package com.urovo.wgmf.db.dao.dao

import android.database.Cursor
import com.urovo.wugumofang.system.BaseAppManager

/**
 * @author LW
 * App响应码信息表
 */
object AppRetcodeDbOperate {
    /**
     * 通过各种状态码来映射到文字提示信息
     */
    @JvmStatic
    fun getInfoByStatusCode(statusCode: String): String {
        var cursor: Cursor? = null
        val sql = "select content from app_retcode where retcode = ?"
        try {
            cursor = BaseAppManager.database().rawQuery(sql, arrayOf(statusCode))
            if (cursor.moveToNext()) {
                return cursor.getString(cursor.getColumnIndex("content"))
            }
        } catch (e: Exception) {
            BaseAppManager.loger().info("根据状态码查找对应提示文字异常:$e")
            e.printStackTrace()
        } finally {
            cursor?.close()
        }
        return ""
    }

    @JvmStatic
    fun insert(model: Map<String, String>): Boolean {
        synchronized(AppRetcodeDbOperate::class.java) {
            BaseAppManager.database().beginTransaction()
            var result = false
            try {
                BaseAppManager.database().execSQL("delete from app_retcode")

                val strSql =
                    "insert into app_retcode(retcode,content) values(?,?)"
                model.forEach {
                    BaseAppManager.database().execSQL(
                        strSql,
                        arrayOf(
                            it.key,
                            it.value
                        )
                    )
                }
                BaseAppManager.database().setTransactionSuccessful()
                result = true
            } catch (e: Exception) {
                e.printStackTrace()
            } finally {
                BaseAppManager.database().endTransaction()
            }
            return result
        }
    }

    /**
     * 删除所有数据
     */
    @JvmStatic
    fun deleteAll(sql: String?): Boolean? {
        var result: Boolean? = false
        var sqlStr = "delete from app_retcode "
        if (sql != null) {
            sqlStr += sql
        }
        try {
            BaseAppManager.database().execSQL(sqlStr)
            result = true
        } catch (e: Exception) {
            result = false
        } finally {
        }
        return result
    }
}