package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Cpbill002Db;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 *
 * @author Administrator
 */
public class Cpbill002DbOperate {

    private static DBTool dbTool;

    public Cpbill002DbOperate(Context context) {
        super();
        dbTool = DBTool.getInstance(context);
    }

    /**
     * 插入数据
     */
    public static Boolean Insert(Cpbill002Db cpbill002) {
        Cursor cursor = null;
        try {
            String sql = "insert into cpbill002(bill,itemID,dhstat,pdstat,sno,xsgrpID,sortNO) values(?,?,?,?,?,?,?)";
            BaseAppManager.database()
                    .execSQL(sql, new String[]{cpbill002.getBill(), cpbill002.getItemID(), cpbill002.getDhstat(), cpbill002.getPdstat(), cpbill002.getSNO() + "", cpbill002.getXsgrpID(), cpbill002.getSortNO() + ""});
            return true;
        } catch (Exception e) {
            BaseAppManager.loger().info("Cpbill002DbOperate.Insert" + e);
            return false;
        } finally {
            // database.close();
            if (cursor != null)
                cursor.close();
        }
    }

    /**
     * 查询方法的基方法，代码的复用，万精油
     *
     * @param sql
     * @return
     */
    public static List<Cpbill002Db> selectBy(String sql) {
        List<Cpbill002Db> list = new ArrayList<>();
        Cursor cursor = null;
        String sqlStr = "select * from cpbill002 ";
        if (sql != null)
            sqlStr += sql;
        try {
            cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
            while (cursor.moveToNext()) {
                Cpbill002Db model = new Cpbill002Db();
                model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
                model.setItemID(cursor.getString(cursor.getColumnIndex("itemID")));
                model.setDhstat(cursor.getString(cursor.getColumnIndex("dhstat")));
                model.setPdstat(cursor.getString(cursor.getColumnIndex("pdstat")));
                model.setSNO(cursor.getInt(cursor.getColumnIndex("sno")));
                model.setXsgrpID(cursor.getString(cursor.getColumnIndex("xsgrpID")));
                model.setSortNO(cursor.getInt(cursor.getColumnIndex("sortNO")));
                if (model.getBill() != null && model.getBill().length() > 0) {
                    list.add(model);
                }
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("Cpbill002DbOperate.selectBy" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 删除所有数据
     */
    public static Boolean deleteAllGoods(String sql) {
        Boolean result = false;
        String sqlStr = "Delete from cpbill002 ";
        if (sql != null) {
            sqlStr += sql;
        }
        try {
            BaseAppManager.database().execSQL(sqlStr);
            result = true;
        } catch (Exception e) {
            BaseAppManager.loger().info("Cpbill002DbOperate.deleteAllGoods" + e);
            result = false;
        } finally {
        }
        return result;
    }

    public static boolean isDecimalById(String itemId) {
        Cursor cursor = null;
        String sql = "select isdecimal from Cpbill002 where itemid=?";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, new String[]{itemId});
            if (cursor.moveToNext()) {
                final String isDecimal = cursor.getString(cursor.getColumnIndex("ISDECIMAL"));
                return "Y".equals(isDecimal);
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("根据产品编码查询是否显示小数位发生异常:" + e);
            e.printStackTrace();
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return false;
    }
}
