package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.bill.DalCommon;
import com.urovo.wgmf.db.dao.entitys.Djbh001Db;
import com.urovo.wgmf.db.dao.entitys.Djbh002Db;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Djbh002DbOperate {

	private static DBTool dbTool;

	public Djbh002DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static void Insert(Djbh002Db djbh002) {
		try {
			String sql = "insert into djbh002(bill,itemID,bhqty,price,totnet,comm,seq_NO,yn_tx) values(?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ djbh002.getBill(), djbh002.getItemID(), djbh002.getBhqty() + "", djbh002.getPrice() + "", djbh002.getTotnet() + "", djbh002.getComm(), djbh002.getSeq_NO() + "", djbh002.getYn_tx() });
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djbh002DbOperate.Insert]" + e);

		}
	}

	public synchronized static void Insert(List<Djbh002Db> list, Djbh001Db djbh001) {
		try {
			BaseAppManager.database().beginTransaction();
			Djbh001DbOperate.Insert(djbh001);
			for (Djbh002Db data : list) {
				Insert(data);
			}
			BaseAppManager.database().setTransactionSuccessful();
		}
		catch (Exception e) {

			BaseAppManager.loger().info("Djbh002DbOperate:Insert=>" + e);
		}
		finally {
			BaseAppManager.database().endTransaction();
		}

	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static synchronized List<Djbh002Db> selectBy(String sql) {
		List<Djbh002Db> list = new ArrayList<Djbh002Db>();
		Cursor cursor = null;
		String sqlStr = "select * from djbh002 ";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Djbh002Db model = new Djbh002Db();
				model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
				model.setItemID(cursor.getString(cursor.getColumnIndex("itemID")));
				model.setBhqty(cursor.getDouble(cursor.getColumnIndex("bhqty")));
				model.setPrice(cursor.getDouble(cursor.getColumnIndex("price")));
				model.setTotnet(cursor.getDouble(cursor.getColumnIndex("totnet")));
				model.setComm(cursor.getString(cursor.getColumnIndex("comm")));
				model.setSeq_NO(cursor.getInt(cursor.getColumnIndex("seq_NO")));
				model.setYn_tx(cursor.getString(cursor.getColumnIndex("yn_tx")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public synchronized static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djbh002 ";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);
			result = false;
		}
		finally {
		}
		return result;
	}

	/**
	 * 保存订货单明细数据到本地数据库
	 * 
	 * @param bill
	 * @param list
	 * @return
	 */
	public static boolean SaveDingHuoDetail(String bill, List<ProductEntity> list) {
		String sql = "insert into DJBH002(BILL,ITEMID,BHQTY,PRICE,TOTNET,COMM,SEQ_NO,YN_TX) values(?,?,?,?,?,?,?,?)";
		try {
			BaseAppManager.database().beginTransaction();
			for (ProductEntity p : list) {
				BaseAppManager.database().execSQL(sql, new Object[]{ bill, p.getItemId(), p.getTQTY(), p.getPrice(), p.getAmount(), p.getOpl_qty(), p.getSeq_No(), 'Y' });
			}
			BaseAppManager.database().setTransactionSuccessful();
		}
		catch (Exception e) {

			BaseAppManager.loger().info("保存订货单明细表发生异常:" + e);
			return false;
		}
		finally {
			BaseAppManager.database().endTransaction();
		}
		return true;
	}

	/**
	 * 根据门店订货单据号获取产品明细
	 * 
	 * @param bill
	 * @return
	 */
	public static List<ProductEntity> GetBillDetail(String bill) {
		Cursor cursor = null;
		List<ProductEntity> list = new ArrayList<ProductEntity>();
		String sql = "select t1.itemid,t1.bhqty,t1.price,t1.totnet,t1.comm,t1.seq_no,t1.yn_tx, " + " t2.itemname,t2.kcuom,t2.dhpack  from djbh002 t1 " + " join item001 t2 on t1.itemid=t2.itemid " + " join djbh001 t3 on t1.bill = t3.bill "
				+ " join store001 t4 on t3.storeid = t4.storeid and t4.cpbill = t2.itemgx " + " where t1.bill='" + bill + "'";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				ProductEntity ent = new ProductEntity();
				ent.setItemId(cursor.isNull(0) ? "" : cursor.getString(0));
				ent.setTQTY(cursor.isNull(1) ? 0.0 : cursor.getDouble(1));
				ent.setPrice(cursor.isNull(2) ? 0.0 : cursor.getDouble(2));
				ent.setAmount(cursor.isNull(3) ? Arith.mul(ent.getTQTY(), ent.getPrice()) : cursor.getDouble(3));
				ent.setOpl_qty(cursor.isNull(4) ? "" : cursor.getString(4));
				ent.setSeq_No(cursor.isNull(5) ? Arith.add(list.size(), 1) : cursor.getDouble(5));
				ent.setYN_TX(cursor.isNull(6) ? "Y" : cursor.getString(6));
				ent.setItemName(cursor.isNull(7) ? "" : cursor.getString(7));
				ent.setKCUom(cursor.isNull(8) ? "" : cursor.getString(8));
				ent.setDHPack(cursor.isNull(9) ? 1.0 : cursor.getDouble(9));
				if(!DalCommon.CanEditAmount(ent.getItemId())) {
					ent.setAmount(Arith.mul(ent.getPrice(), ent.getTQTY())); // 对于不可修改金额产品：金额=单价*数量
				}
				else {
					ent.setAmount(ent.getPrice()); // 对于可修改金额产品：金额=单价
				}
				list.add(ent);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("根据门店订货单号获取产品明细发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}
}
