package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Djbs002Db;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Djbs002DbOperate {

	private static DBTool dbTool;

	public Djbs002DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(Djbs002Db djbs002) {
		Cursor cursor = null;
		try {
			String sql = "insert into djbs002(bill,itemID,pack,unit,sqty,tqty,price,sptmID,comm,seq_NO,yn_tx) values(?,?,?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql,
					new String[]{ djbs002.getBill(), djbs002.getItemID(), djbs002.getPack() + "", djbs002.getUnit() + "", djbs002.getSqty() + "", djbs002.getTqty() + "", djbs002.getPrice() + "", djbs002.getSptmID(), djbs002.getComm(), djbs002.getSeq_NO() + "", djbs002.getYn_tx() });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djbs002DbOperate.Insert]" + e);
			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<Djbs002Db> selectBy(String sql) {
		List<Djbs002Db> list = new ArrayList<Djbs002Db>();
		Cursor cursor = null;
		String sqlStr = "select * from djbs002 ";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Djbs002Db model = new Djbs002Db();
				model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
				model.setItemID(cursor.getString(cursor.getColumnIndex("itemID")));
				model.setPack(cursor.getInt(cursor.getColumnIndex("pack")));
				model.setUnit(cursor.getInt(cursor.getColumnIndex("unit")));
				model.setSqty(cursor.getInt(cursor.getColumnIndex("sqty")));
				model.setTqty(cursor.getInt(cursor.getColumnIndex("tqty")));
				model.setPrice(cursor.getInt(cursor.getColumnIndex("price")));
				model.setSptmID(cursor.getString(cursor.getColumnIndex("sptmID")));
				model.setComm(cursor.getString(cursor.getColumnIndex("comm")));
				model.setSeq_NO(cursor.getInt(cursor.getColumnIndex("seq_NO")));
				model.setYn_tx(cursor.getString(cursor.getColumnIndex("yn_tx")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("[Djbs001DbOperate.selectBy]" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djbs002 ";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djbs001DbOperate.deleteAllGoods]" + e);
			result = false;
		}
		finally {
		}
		return result;
	}
}
