package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.CXItems;
import com.urovo.wgmf.db.dao.entitys.DjcxitemDb;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class DjcxitemDbOperate {

	private static DBTool dbTool;

	public DjcxitemDbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(DjcxitemDb djcxitem) {
		Cursor cursor = null;
		try {
			String sql = "insert into djcxitem(bill,storeID,sdate,edate,cxmode,xsnet,fzNO,itemID,rprice,cprice,cxrprice,cxcprice,xsqty,zsitemID,zsqty,status) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ djcxitem.getBill(), djcxitem.getStoreID(), djcxitem.getSdate(), djcxitem.getEdate(), djcxitem.getCxmode(), djcxitem.getXsnet() + "", djcxitem.getFzNO() + "", djcxitem.getItemID(), djcxitem.getRprice() + "", djcxitem.getCprice() + "",
					djcxitem.getCxrprice() + "", djcxitem.getCxcprice() + "", djcxitem.getXsqty() + "", djcxitem.getZsitemID(), djcxitem.getZsqty() + "", djcxitem.getStatus(), });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[DjcxitemDbOperate.Insert]" + e);
			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<DjcxitemDb> selectBy(String sql) {
		List<DjcxitemDb> list = new ArrayList<DjcxitemDb>();
		Cursor cursor = null;
		String sqlStr = "select * from djcxitem";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				DjcxitemDb model = new DjcxitemDb();
				model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
				model.setStoreID(cursor.getString(cursor.getColumnIndex("storeID")));
				model.setSdate(cursor.getString(cursor.getColumnIndex("sdate")));
				model.setEdate(cursor.getString(cursor.getColumnIndex("edate")));
				model.setCxmode(cursor.getString(cursor.getColumnIndex("cxmode")));
				model.setXsnet(cursor.getInt(cursor.getColumnIndex("xsnet")));
				model.setFzNO(cursor.getInt(cursor.getColumnIndex("fzNO")));
				model.setItemID(cursor.getString(cursor.getColumnIndex("itemID")));
				model.setRprice(cursor.getInt(cursor.getColumnIndex("rprice")));
				model.setCprice(cursor.getInt(cursor.getColumnIndex("cprice")));
				model.setCxrprice(cursor.getInt(cursor.getColumnIndex("cxrprice")));
				model.setCxcprice(cursor.getInt(cursor.getColumnIndex("cxcprice")));
				model.setXsqty(cursor.getInt(cursor.getColumnIndex("xsqty")));
				model.setZsitemID(cursor.getString(cursor.getColumnIndex("zsitemID")));
				model.setZsqty(cursor.getInt(cursor.getColumnIndex("zsqty")));
				model.setStatus(cursor.getString(cursor.getColumnIndex("status")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 得到活动的所有信息
	 * 
	 * @return
	 */
	/*
	 * public List<HuoDongEntity> getHuoDongList(){ List<HuoDongEntity> list =
	 * new ArrayList<HuoDongEntity>(); Cursor cursor = null; String sqlStr =
	 * "select * from djcxitem"; try { cursor =
	 * BaseAppManager.database().rawQuery(sqlStr, new String[] {}); while
	 * (cursor.moveToNext()) { HuoDongEntity huoDongEntity=new HuoDongEntity();
	 * huoDongEntity.setAct_id(cursor.getString(cursor.getColumnIndex("bill")));
	 * huoDongEntity.setAct_name("");
	 * huoDongEntity.setAct_type(cursor.getString(cursor
	 * .getColumnIndex("cxmode"))); } } catch (Exception e) { // handle
	 * exception } finally { if (cursor != null) { cursor.close(); } } return
	 * list; }
	 */

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djcxitem";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);
			result = false;
		}
		finally {
		}
		return result;
	}

	/**
	 * 获取买赠促销产品:买A送B方式 比如买两个A送一个B，那么如果买了5个A，就应该送2个B 比如买三个C送两个D，那么如果买了8个C，就应该送4个D
	 * 
	 * @param saleList
	 * @param storeId
	 * @return
	 */
	public static List<List<ProductEntity>> getMZCXITEM(List<ProductEntity> saleList, String storeId) {
		List<ProductEntity> copySaleList = new ArrayList<ProductEntity>(); // 客户购买的产品集合
		Cursor cursor = null;
		for (ProductEntity p : saleList) {
			ProductEntity ent = new ProductEntity();
			ent.setItemId(p.getItemId());
			ent.setItemName(p.getItemName());
			ent.setItemType(p.getItemType());
			ent.setKCUom(p.getKCUom());
			ent.setPrice(p.getPrice());
			ent.setTQTY(p.getTQTY());
			ent.setAmount(p.getAmount());
			ent.setDHPack(p.getDHPack());

			copySaleList.add(ent);
		}
		List<List<ProductEntity>> zsList = new ArrayList<List<ProductEntity>>(); // 应该赠送给客户的产品集合
		String sqlCommand = "select t1.zsitemid,t2.itemname,t2.itemmode,t2.kcuom,t2.dhpack,t1.zsqty,t1.xsqty" + " from djcxitem t1 join item001 t2 on t2.itemid=t1.zsitemid" + " join store001 t4 on t1.storeid = t4.storeid and t4.cpbill = t2.itemgx" + " where " + " t1.storeid=? and "
				+ " t1.sdate <=? and t1.edate >=? and " + " t1.cxmode='MZCX' and " + " t1.XSQTY<=?" + " and t1.itemid=?";
		try {
			Date curDate = new Date(System.currentTimeMillis());// 获取当前时间
			for (ProductEntity p : copySaleList) {

				cursor = BaseAppManager.database().rawQuery(sqlCommand, new String[]{ storeId, DateUtil.formatDate(curDate), DateUtil.formatDate(curDate), p.getTQTY() + "", p.getItemId() });
				if(cursor != null) {
					while (cursor.moveToNext()) {
						List<ProductEntity> list = new ArrayList<ProductEntity>();
						double baseQty = cursor.isNull(6) ? 1 : cursor.getDouble(6); // 基准数量
						double zsQty = cursor.isNull(5) ? 1 : cursor.getDouble(5); // 赠送数量

						// 先获取基准数量和赠送数量
						// 买A赠B：比如买2个A赠送一个B的情况下，如果买了5个A，那就需要赠送2个B，基准数量就为2，赠送数量就为1

						if(p.getTQTY() >= baseQty) {
							// SystemHelper.CXZSID = SystemHelper.CXZSID +1;

							// 2013-02-01买赠促销时候，数量需要取整，余数不计入赠送
							double N = Arith.div(p.getTQTY(), baseQty);

							ProductEntity zs = new ProductEntity();
							zs.setItemId(cursor.isNull(0) ? "" : cursor.getString(0));
							zs.setItemName(cursor.isNull(1) ? "" : cursor.getString(1));
							zs.setItemMode(cursor.isNull(2) ? "" : cursor.getString(2));
							zs.setKCUom(cursor.isNull(3) ? "" : cursor.getString(3));
							zs.setDHPack(cursor.isNull(4) ? 0 : cursor.getInt(4));
							zs.setTQTY(Arith.mul(N, zsQty));
							zs.setBarcode("t");

							// 赠送的促销产品，单价和金额都为0
							zs.setPrice(0);
							zs.setAmount(0);
							// zs.box_qty = SystemHelper.CXZSID;
							list.add(zs);
							zsList.add(list);
						}
					}
					cursor.close();
					// dr.Close();
				}

			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("根据获取买赠促销产品时发生异常:买单送单-GetMZCXITEM" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return zsList;
	}

	/**
	 * 获取买赠促销产品:买A+B送C方式 比如买两个A加上买两个B 送一个C，那么如果买了5个A加5个B，就应该送2个C
	 * 比如买三个C加三个B送两个D，那么如果买了8个C加8个B，就应该送4个D
	 * 
	 * @param saleList
	 * @param storeId
	 * @return
	 */
	public static List<List<ProductEntity>> getMZCCXITEM(List<ProductEntity> saleList, String storeId) {
		String SQLitems = "";
		String SQLitems1 = "";
		Cursor cursor = null;
		Cursor cursor1 = null;
		List<ProductEntity> copySaleList = new ArrayList<ProductEntity>(); // 客户购买的产品集合
		for (ProductEntity p : saleList) {
			ProductEntity ent = new ProductEntity();
			ent.setItemId(p.getItemId());
			ent.setItemName(p.getItemName());
			ent.setItemType(p.getItemType());
			ent.setKCUom(p.getKCUom());
			ent.setPrice(p.getPrice());
			ent.setTQTY(p.getTQTY());
			ent.setAmount(p.getAmount());
			ent.setDHPack(p.getDHPack());
			SQLitems += " or t1.itemid like '%" + ent.getItemId() + "%'";
			copySaleList.add(ent);
		}
		List<List<ProductEntity>> zsList = new ArrayList<List<ProductEntity>>(); // 应该赠送给客户的产品集合

		// String sqlCommand ="select t1.zsitemid,t1.itemid"
		// +" from djcxitem t1 "
		// +" where "
		// +" t1.storeid=? and"
		// +" t1.sdate <=? and t1.edate >=? and"
		// +" t1.cxmode='MZCCXX'"
		// +" and ( t1.itemid like '%?%'";
		// sqlCommand += SQLitems + ")";

		String sqlCommand1 = "select t1.zsitemid,t1.itemid" + " from djcxitem t1" + " where " + " t1.storeid=? and" + " t1.sdate <=? and t1.edate >=? and" + " t1.cxmode='MZCCXX' ";

		try {
			Date curDate = new Date(System.currentTimeMillis());// 获取当前时间

			for (ProductEntity p : copySaleList) {
				String sqlCommand = "select t1.zsitemid,t1.itemid" + " from djcxitem t1 " + " where " + " t1.storeid=? and" + " t1.sdate <=? and t1.edate >=? and" + " t1.cxmode='MZCCXX'" + " and ( t1.itemid like '%" + p.getItemId() + "%'";
				sqlCommand += SQLitems + ")";
				cursor = BaseAppManager.database().rawQuery(sqlCommand, new String[]{ storeId, DateUtil.formatDate(curDate), DateUtil.formatDate(curDate) });

				if(cursor != null) {
					while (cursor.moveToNext()) {
						String items = cursor.isNull(1) ? "" : cursor.getString(1);
						int currentIndex = 0;
						/*
						 * while (items.length() > currentIndex) { SQLitems1 +=
						 * "and t1.itemid like '%" +
						 * items.substring(currentIndex, items.indexOf(":",
						 * currentIndex)) +"%'"; currentIndex =
						 * items.indexOf(";", currentIndex) + 1; } // SQLitems1
						 * += "and t1.itemid = '" + items+"'";
						 * 
						 * sqlCommand1+=SQLitems1; cursor1 =
						 * BaseAppManager.database().rawQuery(sqlCommand1, new
						 * String[] {storeId, DateUtil.formatDate(curDate),
						 * DateUtil.formatDate(curDate)}); if (cursor1 != null)
						 * { while (cursor1.moveToNext()) {
						 */
						items = cursor.isNull(1) ? "" : cursor.getString(1);
						String ZSitems = cursor.isNull(0) ? "" : cursor.getString(0);
						currentIndex = 0;
						List<CXItems> cxItems1 = new ArrayList<CXItems>();
						List<CXItems> cxItems2 = new ArrayList<CXItems>();
						while (items.length() > currentIndex) {
							CXItems cx = new CXItems();
							cx.setBuyItemID(items.substring(currentIndex, items.indexOf(":", currentIndex)));
							cx.setBuyItemQty(items.substring(items.indexOf(":", currentIndex) + 1, items.indexOf(";", currentIndex)));
							currentIndex = items.indexOf(";", currentIndex) + 1;
							cxItems1.add(cx);
						}

						currentIndex = 0;
						while (ZSitems.length() > currentIndex) {
							CXItems cx = new CXItems();
							cx.setZsItemID(ZSitems.substring(currentIndex, ZSitems.indexOf(":", currentIndex)));
							cx.setZsItemQty(ZSitems.substring(ZSitems.indexOf(":", currentIndex) + 1, ZSitems.indexOf(";", currentIndex)));
							currentIndex = ZSitems.indexOf(";", currentIndex) + 1;
							cxItems2.add(cx);
						}

						int N = 0;
						int M = 0;
						int number = 0;
						for (ProductEntity pe : copySaleList) {
							N = 0;
							if(M == 0 && number >= 1) {
								continue;
							}
							for (CXItems ccx : cxItems1) {
								if(pe.getItemId().equals(ccx.getBuyItemID())) {
									number = number + 1;
									if(Double.parseDouble(ccx.getBuyItemQty()) <= pe.getTQTY()) {
										N = (int) (Arith.div(pe.getTQTY(), Double.parseDouble(ccx.getBuyItemQty())));
									}
									if(N < M) {
										M = N;
									}
								}
							}
							if(N == 0) {
								continue;
							}
							if(M != 0 && N > M) {
								N = M;
							}
							if(M == 0 && N > M && number == 1) {
								M = N;
							}
						}
						N = M;
						if(number < cxItems1.size()) {
							N = 0;
						}
						if(N == 0) {
							continue;
						}
						if(N > 0) {
							List<ProductEntity> list = new ArrayList<ProductEntity>();
							// SystemHelper.CXZSID = SystemHelper.CXZSID + 1;
							for (CXItems ccx : cxItems2) {
								ProductEntity zs = new ProductEntity();
								zs = Item001DbOperate.GetProductByBarcode(ccx.getZsItemID());
								zs.setTQTY(Arith.mul(N, Double.parseDouble(ccx.getZsItemQty())));
								zs.setBarcode("t");

								// 赠送的促销产品，单价和金额都为0
								zs.setPrice(0);
								zs.setAmount(0);
								// zs.box_qty = SystemHelper.CXZSID;
								list.add(zs);
							}
							zsList.add(list);
						}
					}
				}
				// }
				// }
				break;
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("根据获取买赠促销产品时发生异常:多买多赠-GetMZCCXITEM" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
			if(cursor1 != null) {
				cursor1.close();
			}
		}
		return zsList;
	}

	/**
	 * 获取满额促销产品:满多少送某个产品 比如，满400送一个A，那么如果金额为1000，应该送2个A
	 * 
	 * @param list
	 * @param storeId
	 * @return
	 */
	public static List<List<ProductEntity>> getZLCXITEM(List<ProductEntity> list, String storeId) {
		Cursor dr = null;
		double amount = 0;
		for (ProductEntity p : list) {
			amount += p.getAmount();
		}
		double allAmount = amount;

		List<List<ProductEntity>> zsList = new ArrayList<List<ProductEntity>>();
		String sqlCommand = "select t1.zsitemid,t2.itemname,t2.itemmode,t2.kcuom,t2.dhpack,t1.zsqty,t1.xsnet" + " from djcxitem t1 join item001 t2 on t2.itemid=t1.zsitemid" + " join store001 t4 on t1.storeid = t4.storeid and t4.cpbill = t2.itemgx" + " where " + " t1.storeid=? and "
				+ " t1.sdate <=? and t1.edate >=? and " + " t1.cxmode='ZLCX' and " + " t1.XSNET<=?";
		try {
			Date curDate = new Date(System.currentTimeMillis());// 获取当前时间

			dr = BaseAppManager.database().rawQuery(sqlCommand, new String[]{ storeId, DateUtil.formatDate(curDate), DateUtil.formatDate(curDate), amount + "" });
			if(dr != null) {
				/*
				 * while (dr.moveToNext()) { amount = allAmount; //先获取基准金额：
				 * //买300赠B：比如如果买了800，那就需要赠送2个B，基准金额就为300 boolean flag = true;
				 * //是否可以继续赠送：只要第i次赠送后剩下的金额还大于基准金额，就意味着需要继续赠送 while (flag) {
				 * double baseAmount = 400; //基准金额
				 * 
				 * ProductEntity zs = new ProductEntity();
				 * zs.setItemId(dr.isNull(0) ? "" : dr.getString(0));
				 * zs.setItemName(dr.isNull(1) ? "" : dr.getString(1));
				 * zs.setItemMode(dr.isNull(2) ? "": dr.getString(2));
				 * zs.setKCUom(dr.isNull(3) ? "" : dr.getString(3));
				 * zs.setDHPack(dr.isNull(4) ? 0 : dr.getDouble(4));
				 * zs.setTQTY(dr.isNull(5) ? 0 : dr.getDouble(5)); baseAmount =
				 * dr.isNull(6) ? 400 : dr.getDouble(6); //基准金额
				 * zs.setBarcode("t");
				 * 
				 * //赠送产品的单价和金额都为0 zs.setPrice(0); zs.setAmount(0);
				 * 
				 * 
				 * boolean exist = false; for(ProductEntity var:zsList) { if
				 * (var.getItemId().equals(zs.getItemId())) { exist = true;
				 * var.setTQTY((int)var.getTQTY()+(int)zs.getTQTY());
				 * var.setAmount(Arith.add(var.getAmount(), zs.getAmount())); }
				 * } if (!exist) { // SystemHelper.CXZSID = SystemHelper.CXZSID
				 * + 1; // zs.box_qty = SystemHelper.CXZSID; zsList.add(zs);
				 * 
				 * }
				 * 
				 * //赠送一次后，原销售总金额减去相应赠送一次的基准金额 amount = amount - baseAmount;
				 * 
				 * //是否还可以继续赠送 flag = amount >= baseAmount; } }
				 */
				while (dr.moveToNext()) {
					List<ProductEntity> plist = new ArrayList<ProductEntity>();
					double baseAmount = dr.isNull(6) ? 400 : dr.getDouble(6); // 基准金额
					double num = dr.isNull(5) ? 0 : dr.getDouble(5);
					int zsNum = (int) (allAmount / baseAmount);
					ProductEntity zs = new ProductEntity();
					zs.setItemId(dr.isNull(0) ? "" : dr.getString(0));
					zs.setItemName(dr.isNull(1) ? "" : dr.getString(1));
					zs.setItemMode(dr.isNull(2) ? "" : dr.getString(2));
					zs.setKCUom(dr.isNull(3) ? "" : dr.getString(3));
					zs.setDHPack(dr.isNull(4) ? 0 : dr.getDouble(4));
					// zs.setTQTY(dr.isNull(5) ? 0 : dr.getDouble(5));
					zs.setTQTY(num * zsNum);
					// baseAmount = dr.isNull(6) ? 400 : dr.getDouble(6); //基准金额
					zs.setBarcode("t");
					plist.add(zs);
					zsList.add(plist);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("根据获取买赠促销产品时发生异常:满额赠-GetZLCXITEM" + e);
		}
		finally {
			if(dr != null) {
				dr.close();
			}
		}
		return zsList;
	}

	/**
	 * 获取满额促销折扣率:满多少打多少折扣 比如，满400打8折，那么如果金额为1000，也打8折
	 * 
	 * @param list
	 * @param storeId
	 * @return
	 */
	public static List<List<ProductEntity>> getZLZK_BLCXITEM(List<ProductEntity> list, String storeId) {
		double amount = 0;
		Cursor dr = null;
		for (ProductEntity p : list) {
			amount += p.getAmount();
		}

		List<List<ProductEntity>> zsList = new ArrayList<List<ProductEntity>>();

		String sqlCommand = "select t1.zsitemid,t1.itemid" + " from djcxitem t1 " + " where " + " t1.storeid=? and " + " t1.sdate <=? and t1.edate >=? and " + " t1.cxmode='ZLZK_BL' and " + " t1.XSNET<=?";
		try {
			Date curDate = new Date(System.currentTimeMillis());// 获取当前时间
			dr = BaseAppManager.database().rawQuery(sqlCommand, new String[]{ storeId, DateUtil.formatDate(curDate), DateUtil.formatDate(curDate), amount + "" });
			if(dr != null) {
				while (dr.moveToNext()) {
					List<ProductEntity> plist = new ArrayList<ProductEntity>();
					ProductEntity zs = new ProductEntity();
					zs.setItemId("9.8888");
					zs.setTQTY(1);
					zs.setItemName(Item001DbOperate.GetProductName(zs.getItemId()));
					zs.setProductState(dr.isNull(0) ? "" : dr.getString(0));
					zs.setAmount(0);
					zs.setComm(dr.isNull(1) ? "" : dr.getString(1));
					zs.setItemType("ZLZK_BL");
					// SystemHelper.CXZSID = SystemHelper.CXZSID + 1;
					// zs.box_qty = SystemHelper.CXZSID;
					zs.setBarcode("t");
					plist.add(zs);
					zsList.add(plist);
				}
			}
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("根据获取买赠促销产品时发生异常:满额折-GetZLZK_BLCXITEM" + ex);
		}
		finally {
			if(dr != null) {
				dr.close();
			}
		}
		return zsList;
	}

	/**
	 * 获取满额促销金额:满多少减多少金额 比如，满400减50，那么如果金额为1000，应该减200
	 * 
	 * @param list
	 * @param storeId
	 * @return
	 */
	public static List<List<ProductEntity>> getZLZK_JECXITEM(List<ProductEntity> list, String storeId) {
		double amount = 0;
		Cursor dr = null;
		for (ProductEntity p : list) {
			amount = Arith.add(amount, p.getAmount());
		}
		double allAmount = amount;

		List<List<ProductEntity>> zsList = new ArrayList<List<ProductEntity>>();
		String sqlCommand = "select t1.zsitemid,t1.itemid" + " from djcxitem t1" + " where " + " t1.storeid=? and " + " t1.sdate <=? and t1.edate >=? and " + " t1.cxmode='ZLZK_JE' and " + " t1.XSNET<=?";
		try {
			Date curDate = new Date(System.currentTimeMillis());// 获取当前时间
			dr = BaseAppManager.database().rawQuery(sqlCommand, new String[]{ storeId, DateUtil.formatDate(curDate), DateUtil.formatDate(curDate), amount + "" });

			if(dr != null) {
				while (dr.moveToNext()) {
					List<ProductEntity> plist = new ArrayList<ProductEntity>();
					ProductEntity zs = new ProductEntity();
					String ZSJE = dr.isNull(0) ? "" : dr.getString(0);
					zs.setComm(dr.isNull(1) ? "" : dr.getString(1));
					zs.setProductState(Arith.mul((int) Arith.div(allAmount, Double.parseDouble(zs.getComm())), Double.parseDouble(ZSJE)) + "");
					zs.setItemType("ZLZK_JE");
					zs.setItemId("9.8888");
					zs.setTQTY(1);
					zs.setAmount(-Arith.mul((int) Arith.div(allAmount, Double.parseDouble(zs.getComm())), Double.parseDouble(ZSJE)));
					zs.setPrice(-Arith.mul((int) Arith.div(allAmount, Double.parseDouble(zs.getComm())), Double.parseDouble(ZSJE)));
					zs.setBarcode("t");
					zs.setItemName(Item001DbOperate.GetProductName(zs.getItemId()));
					// SystemHelper.CXZSID = SystemHelper.CXZSID + 1;
					// zs.box_qty = SystemHelper.CXZSID;
					plist.add(zs);
					zsList.add(plist);
				}
			}
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("根据获取买赠促销产品时发生异常:满额减-GetZLZK_JECXITEM" + ex);
		}
		finally {
			if(dr != null) {
				dr.close();
			}
		}
		return zsList;
	}

	/**
	 * 获取买折促销产品:买A+B打C折方式. 比如买两个A加上买两个B打8折，那么如果买了5个A加5个B，还打8折
	 * 
	 * @param saleList
	 * @param storeId
	 * @return
	 */
	public static List<List<ProductEntity>> getMZHPZK_BLCXITEM(List<ProductEntity> saleList, String storeId) {
		Cursor dr = null;
		Cursor dr1 = null;
		String SQLitems = "";
		String SQLitems1 = "";
		List<ProductEntity> copySaleList = new ArrayList<ProductEntity>(); // 客户购买的产品集合
		for (ProductEntity p : saleList) {
			ProductEntity ent = new ProductEntity();
			ent.setItemId(p.getItemId());
			ent.setItemName(p.getItemName());
			ent.setItemType(p.getItemType());
			ent.setKCUom(p.getKCUom());
			ent.setPrice(p.getPrice());
			ent.setTQTY(p.getTQTY());
			ent.setAmount(p.getAmount());
			ent.setDHPack(p.getDHPack());
			SQLitems += " or t1.itemid like '%" + ent.getItemId() + "%'";
			copySaleList.add(ent);
		}
		List<List<ProductEntity>> zsList = new ArrayList<List<ProductEntity>>(); // 应该赠送给客户的产品集合
		// String sqlCommand = "select t1.zsitemid,t1.itemid"
		// +" from djcxitem t1"
		// +" where "
		// +" t1.storeid=? and "
		// +" t1.sdate <=? and t1.edate >=? and "
		// +" t1.cxmode='MZHPZK_BL'"
		// +" and ( t1.itemid like '%?%'";
		// sqlCommand += SQLitems + ")";
		try {
			Date curDate = new Date(System.currentTimeMillis());// 获取当前时间
			for (ProductEntity p : copySaleList) {
				String sqlCommand = "select t1.zsitemid,t1.itemid" + " from djcxitem t1" + " where " + " t1.storeid=? and " + " t1.sdate <=? and t1.edate >=? and " + " t1.cxmode='MZHPZK_BL'" + " and ( t1.itemid like '%" + p.getItemId() + "%'";
				sqlCommand += SQLitems + ")";
				dr = BaseAppManager.database().rawQuery(sqlCommand, new String[]{ storeId, DateUtil.formatDate(curDate), DateUtil.formatDate(curDate) });

				if(dr != null) {
					while (dr.moveToNext()) {
						String items = dr.isNull(1) ? "" : dr.getString(1);
						int currentIndex = 0;
						while (items.length() > currentIndex) {
							SQLitems1 += "and t1.itemid like '%" + items.substring(currentIndex, items.indexOf(":", currentIndex)) + "%'";
							currentIndex = items.indexOf(";", currentIndex) + 1;
						}

						dr1 = BaseAppManager.database().rawQuery(sqlCommand, new String[]{ storeId, DateUtil.formatDate(curDate), DateUtil.formatDate(curDate) });
						{
							if(dr1 != null) {
								if(dr1.moveToNext()) {
									items = dr.isNull(1) ? "" : dr.getString(1);
									String ZSitems = dr.isNull(0) ? "" : dr.getString(0);
									currentIndex = 0;
									List<CXItems> cxItems1 = new ArrayList<CXItems>();
									List<CXItems> cxItems2 = new ArrayList<CXItems>();
									while (items.length() > currentIndex) {
										CXItems cx = new CXItems();
										cx.setBuyItemID(items.substring(currentIndex, items.indexOf(":", currentIndex)));
										cx.setBuyItemQty(items.substring(items.indexOf(":", currentIndex) + 1, items.indexOf(";", currentIndex)));
										currentIndex = items.indexOf(";", currentIndex) + 1;
										cxItems1.add(cx);
									}

									int N = 0;
									int M = 0;
									int number = 0;
									for (ProductEntity pe : copySaleList) {
										N = 0;
										if(M == 0 && number >= 1) {
											continue;
										}
										for (CXItems ccx : cxItems1) {
											if(pe.getItemId().equals(ccx.getBuyItemID())) {
												number = number + 1;
												if(Double.parseDouble(ccx.getBuyItemQty()) <= pe.getTQTY()) {
													N = (int) (Arith.div(pe.getTQTY(), Double.parseDouble(ccx.getBuyItemQty())));
												}
												if(N < M) {
													M = N;
												}
											}
										}
										if(N == 0) {
											continue;
										}
										if(M != 0 && N > M) {
											N = M;
										}
										if(M == 0 && N > M && number == 1) {
											M = N;
										}
									}
									N = M;
									if(number < cxItems1.size()) {
										N = 0;
									}
									if(N == 0) {
										continue;
									}
									if(N > 0) {
										List<ProductEntity> plist = new ArrayList<ProductEntity>();
										// SystemHelper.CXZSID =
										// SystemHelper.CXZSID + 1;
										ProductEntity zs = new ProductEntity();
										zs.setProductState(ZSitems);
										zs.setBarcode("t");
										zs.setItemId("9.8888");
										zs.setTQTY(1);
										zs.setAmount(0);
										zs.setItemName(Item001DbOperate.GetProductName(zs.getItemId()));
										// zs.box_qty = SystemHelper.CXZSID;
										zs.setItemType("MZHPZK_BL");
										plist.add(zs);
										zsList.add(plist);

									}
								}
							}
						}
					}
				}
				break;
			}
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("根据获取买赠促销产品时发生异常:组合品折-GetMZHPZK_BLCXITEM" + ex);
		}
		finally {
			if(dr != null) {
				dr.close();
			}
			if(dr1 != null) {
				dr1.close();
			}
		}
		return zsList;
	}

	/**
	 * 获取买减促销产品:买A+B减C元 比如买两个A加上买两个B 减50，那么如果买了5个A加5个B，就应该减100
	 * 比如买三个C加三个B减50，那么如果买了8个C加8个B，就应该减100
	 * 
	 * @param saleList
	 * @param storeId
	 * @return
	 */
	public static List<List<ProductEntity>> getMZHPZK_JECXITEM(List<ProductEntity> saleList, String storeId) {
		Cursor dr = null;
		Cursor dr1 = null;
		String SQLitems = "";
		String SQLitems1 = "";
		List<ProductEntity> copySaleList = new ArrayList<ProductEntity>(); // 客户购买的产品集合
		for (ProductEntity p : saleList) {
			ProductEntity ent = new ProductEntity();
			ent.setItemId(p.getItemId());
			ent.setItemName(p.getItemName());
			ent.setItemType(p.getItemType());
			ent.setKCUom(p.getKCUom());
			ent.setPrice(p.getPrice());
			ent.setTQTY(p.getTQTY());
			ent.setAmount(p.getAmount());
			ent.setDHPack(p.getDHPack());
			SQLitems += " or t1.itemid like '%" + ent.getItemId() + "%'";
			copySaleList.add(ent);
		}
		List<List<ProductEntity>> zsList = new ArrayList<List<ProductEntity>>(); // 应该赠送给客户的产品集合
		// String sqlCommand = "select t1.zsitemid,t1.itemid"
		// +" from djcxitem t1 "
		// +" where "
		// +" t1.storeid=? and"
		// +" t1.sdate <=? and t1.edate >=? and"
		// +" t1.cxmode='MZHPZK_JE'"
		// +" and ( t1.itemid like '%?%'";
		// sqlCommand += SQLitems + ")";
		try {
			Date curDate = new Date(System.currentTimeMillis());// 获取当前时间
			for (ProductEntity p : copySaleList) {
				String sqlCommand = "select t1.zsitemid,t1.itemid" + " from djcxitem t1 " + " where " + " t1.storeid=? and" + " t1.sdate <=? and t1.edate >=? and" + " t1.cxmode='MZHPZK_JE'" + " and ( t1.itemid like '%" + p.getItemId() + "%'";
				sqlCommand += SQLitems + ")";
				dr = BaseAppManager.database().rawQuery(sqlCommand, new String[]{ storeId, DateUtil.formatDate(curDate), DateUtil.formatDate(curDate) });

				if(dr != null) {
					while (dr.moveToNext()) {
						String items = dr.isNull(1) ? "" : dr.getString(1);
						int currentIndex = 0;
						while (items.length() > currentIndex) {
							SQLitems1 += "and t1.itemid like '%" + items.substring(currentIndex, items.indexOf(":", currentIndex)) + "%'";
							currentIndex = items.indexOf(";", currentIndex) + 1;
						}

						dr1 = BaseAppManager.database().rawQuery(sqlCommand, new String[]{ storeId, DateUtil.formatDate(curDate), DateUtil.formatDate(curDate) });
						if(dr1 != null) {
							if(dr1.moveToNext()) {
								items = dr.isNull(1) ? "" : dr.getString(1);
								String ZSitems = dr.isNull(0) ? "" : dr.getString(0);
								currentIndex = 0;
								List<CXItems> cxItems1 = new ArrayList<CXItems>();
								List<CXItems> cxItems2 = new ArrayList<CXItems>();
								while (items.length() > currentIndex) {
									CXItems cx = new CXItems();
									cx.setBuyItemID(items.substring(currentIndex, items.indexOf(":", currentIndex)));
									cx.setBuyItemQty(items.substring(items.indexOf(":", currentIndex) + 1, items.indexOf(";", currentIndex)));
									currentIndex = items.indexOf(";", currentIndex) + 1;
									cxItems1.add(cx);
								}

								int N = 0;
								int M = 0;
								int number = 0;
								for (ProductEntity pe : copySaleList) {
									N = 0;
									if(M == 0 && number >= 1) {
										continue;
									}
									for (CXItems ccx : cxItems1) {
										if(pe.getItemId().equals(ccx.getBuyItemID())) {
											number = number + 1;
											if(Double.parseDouble(ccx.getBuyItemQty()) <= pe.getTQTY()) {
												N = (int) (Arith.div(pe.getTQTY(), Double.parseDouble(ccx.getBuyItemQty())));
											}
											if(N < M) {
												M = N;
											}
										}
									}
									if(N == 0) {
										continue;
									}
									if(M != 0 && N > M) {
										N = M;
									}
									if(M == 0 && N > M && number == 1) {
										M = N;
									}
								}
								N = M;
								if(number < cxItems1.size()) {
									N = 0;
								}
								if(N == 0) {
									continue;
								}
								if(N > 0) {
									List<ProductEntity> plist = new ArrayList<ProductEntity>();
									// SystemHelper.CXZSID = SystemHelper.CXZSID
									// + 1;
									ProductEntity zs = new ProductEntity();
									zs.setProductState(Arith.mul(Double.parseDouble(ZSitems), N) + "");
									// zs.box_qty = SystemHelper.CXZSID;
									zs.setItemId("9.8888");
									zs.setAmount(-Arith.mul(Double.parseDouble(ZSitems), N));
									zs.setPrice(-Arith.mul(Double.parseDouble(ZSitems), N));
									zs.setTQTY(1);
									zs.setBarcode("t");
									zs.setItemName(Item001DbOperate.GetProductName(zs.getItemId()));
									zs.setItemType("MZHPZK_JE");

									plist.add(zs);
									zsList.add(plist);

								}
							}
						}
					}
				}
				break;
			}
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("根据获取买赠促销产品时发生异常:组合品减金额-GetMZHPZK_JECXITEM" + ex);
		}
		finally {
			if(dr != null) {
				dr.close();
			}
			if(dr1 != null) {
				dr1.close();
			}
		}
		return zsList;
	}

	/**
	 * 获取三个活动：以老带新，荔枝干，大礼包
	 * 
	 * @param saleList
	 * @param storeId
	 * @return
	 */
	public static List<List<ProductEntity>> getZLCX_DHM(List<ProductEntity> saleList, String storeId) {
		List<List<ProductEntity>> zsList = new ArrayList<List<ProductEntity>>();
		double sum = 0;
		for (ProductEntity p : saleList) {
			sum = Arith.add(sum, p.getAmount());
		}
		Cursor dr = null;
		Date curDate = new Date(System.currentTimeMillis());// 获取当前时间
		String sqlCommand = "select xsnet" + " from djcxitem " + " where " + " storeid=? and" + " sdate <=? and edate >=? and" + " cxmode='ZLCX_DHM'" + " and " + " xsnet<= " + sum;
		dr = BaseAppManager.database().rawQuery(sqlCommand, new String[]{ storeId, DateUtil.formatDate(curDate), DateUtil.formatDate(curDate) });

		if(dr != null) {
			if(dr.moveToNext()) {
				ProductEntity p = new ProductEntity();
				p.setItemName("输入兑换码验证");
				p.setItemId("9.8888");
				p.setItemType("ZLCX_DHM");
				List<ProductEntity> list = new ArrayList<ProductEntity>();
				list.add(p);
				zsList.add(list);
			}
		}
		return zsList;
	}

	/**
	 * 获取买赠+兑换码:买A+B送C方式 比如买两个A加上买两个B 送一个C，那么如果买了5个A加5个B，就应该送2个C
	 * 比如买三个C加三个B送两个D，那么如果买了8个C加8个B，就应该送4个D
	 * 
	 * @param saleList
	 * @param storeId
	 * @return
	 */
	public static List<List<ProductEntity>> getMZCX_DHM(List<ProductEntity> saleList, String storeId) {
		String SQLitems = "";
		String SQLitems1 = "";
		Cursor cursor = null;
		Cursor cursor1 = null;
		List<ProductEntity> copySaleList = new ArrayList<ProductEntity>(); // 客户购买的产品集合
		for (ProductEntity p : saleList) {
			ProductEntity ent = new ProductEntity();
			ent.setItemId(p.getItemId());
			ent.setItemName(p.getItemName());
			ent.setItemType(p.getItemType());
			ent.setKCUom(p.getKCUom());
			ent.setPrice(p.getPrice());
			ent.setTQTY(p.getTQTY());
			ent.setAmount(p.getAmount());
			ent.setDHPack(p.getDHPack());
			SQLitems += " or t1.itemid like '%" + ent.getItemId() + "%'";
			copySaleList.add(ent);
		}
		List<List<ProductEntity>> zsList = new ArrayList<List<ProductEntity>>(); // 应该赠送给客户的产品集合

		// String sqlCommand ="select t1.zsitemid,t1.itemid"
		// +" from djcxitem t1 "
		// +" where "
		// +" t1.storeid=? and"
		// +" t1.sdate <=? and t1.edate >=? and"
		// +" t1.cxmode='MZCCXX'"
		// +" and ( t1.itemid like '%?%'";
		// sqlCommand += SQLitems + ")";

		String sqlCommand1 = "select t1.zsitemid,t1.itemid" + " from djcxitem t1" + " where " + " t1.storeid=? and" + " t1.sdate <=? and t1.edate >=? and" + " t1.cxmode='MZCX_DHM' ";

		try {
			Date curDate = new Date(System.currentTimeMillis());// 获取当前时间

			for (ProductEntity p : copySaleList) {
				String sqlCommand = "select t1.zsitemid,t1.itemid" + " from djcxitem t1 " + " where " + " t1.storeid=? and" + " t1.sdate <=? and t1.edate >=? and" + " t1.cxmode='MZCX_DHM'" + " and ( t1.itemid like '%" + p.getItemId() + "%'";
				sqlCommand += SQLitems + ")";
				cursor = BaseAppManager.database().rawQuery(sqlCommand, new String[]{ storeId, DateUtil.formatDate(curDate), DateUtil.formatDate(curDate) });

				if(cursor != null) {
					while (cursor.moveToNext()) {
						String items = cursor.isNull(1) ? "" : cursor.getString(1);
						int currentIndex = 0;
						/*
						 * while (items.length() > currentIndex) { SQLitems1 +=
						 * "and t1.itemid like '%" +
						 * items.substring(currentIndex, items.indexOf(":",
						 * currentIndex)) +"%'"; currentIndex =
						 * items.indexOf(";", currentIndex) + 1; } // SQLitems1
						 * += "and t1.itemid = '" + items+"'";
						 * 
						 * sqlCommand1+=SQLitems1; cursor1 =
						 * BaseAppManager.database().rawQuery(sqlCommand1, new
						 * String[] {storeId, DateUtil.formatDate(curDate),
						 * DateUtil.formatDate(curDate)}); if (cursor1 != null)
						 * { while (cursor1.moveToNext()) {
						 */
						items = cursor.isNull(1) ? "" : cursor.getString(1);
						String ZSitems = cursor.isNull(0) ? "" : cursor.getString(0);
						currentIndex = 0;
						List<CXItems> cxItems1 = new ArrayList<CXItems>();
						List<CXItems> cxItems2 = new ArrayList<CXItems>();
						while (items.length() > currentIndex) {
							CXItems cx = new CXItems();
							cx.setBuyItemID(items.substring(currentIndex, items.indexOf(":", currentIndex)));
							cx.setBuyItemQty(items.substring(items.indexOf(":", currentIndex) + 1, items.indexOf(";", currentIndex)));
							currentIndex = items.indexOf(";", currentIndex) + 1;
							cxItems1.add(cx);
						}

						currentIndex = 0;
						while (ZSitems.length() > currentIndex) {
							CXItems cx = new CXItems();
							cx.setZsItemID(ZSitems.substring(currentIndex, ZSitems.indexOf(":", currentIndex)));
							cx.setZsItemQty(ZSitems.substring(ZSitems.indexOf(":", currentIndex) + 1, ZSitems.indexOf(";", currentIndex)));
							currentIndex = ZSitems.indexOf(";", currentIndex) + 1;
							cxItems2.add(cx);
						}

						int N = 0;
						int M = 0;
						int number = 0;
						for (ProductEntity pe : copySaleList) {
							N = 0;
							if(M == 0 && number >= 1) {
								continue;
							}
							for (CXItems ccx : cxItems1) {
								if(pe.getItemId().equals(ccx.getBuyItemID())) {
									number = number + 1;
									if(Double.parseDouble(ccx.getBuyItemQty()) <= pe.getTQTY()) {
										N = (int) (Arith.div(pe.getTQTY(), Double.parseDouble(ccx.getBuyItemQty())));
									}
									if(N < M) {
										M = N;
									}
								}
							}
							if(N == 0) {
								continue;
							}
							if(M != 0 && N > M) {
								N = M;
							}
							if(M == 0 && N > M && number == 1) {
								M = N;
							}
						}
						N = M;
						if(number < cxItems1.size()) {
							N = 0;
						}
						if(N == 0) {
							continue;
						}
						if(N > 0) {
							ProductEntity pe = new ProductEntity();
							pe.setItemName("输入兑换码验证");
							pe.setItemId("9.8888");
							pe.setItemType("ZLCX_DHM");
							List<ProductEntity> list = new ArrayList<ProductEntity>();
							list.add(pe);
							zsList.add(list);
						}
					}
				}
				// }
				// }
				break;
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("根据获取买赠促销产品时发生异常:买赠+兑换码-GetMZCX_DHM" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
			if(cursor1 != null) {
				cursor1.close();
			}
		}
		return zsList;
	}

	/**
	 * 获取全部促销赠品
	 * 
	 * @param saleList
	 * @param storeId
	 * @return
	 */
	public static List<List<ProductEntity>> getAllZengPin(List<ProductEntity> saleList, String storeId) {
		List<List<ProductEntity>> list = new ArrayList<List<ProductEntity>>();
		List<List<ProductEntity>> list1 = getMZCCXITEM(saleList, storeId);
		List<List<ProductEntity>> list2 = getMZCXITEM(saleList, storeId);
		List<List<ProductEntity>> list3 = getMZHPZK_BLCXITEM(saleList, storeId);
		List<List<ProductEntity>> list4 = getMZHPZK_JECXITEM(saleList, storeId);
		List<List<ProductEntity>> list5 = getZLCXITEM(saleList, storeId);
		List<List<ProductEntity>> list6 = getZLZK_BLCXITEM(saleList, storeId);
		List<List<ProductEntity>> list7 = getZLZK_JECXITEM(saleList, storeId);
		List<List<ProductEntity>> list8 = getZLCX_DHM(saleList, storeId);
		List<List<ProductEntity>> list9 = getMZCX_DHM(saleList, storeId);
		if(list1 != null && list1.size() != 0) {
			list.addAll(list1);
		}
		if(list2 != null && list2.size() != 0) {
			list.addAll(list2);
		}
		if(list3 != null && list3.size() != 0) {
			list.addAll(list3);
		}
		if(list4 != null && list4.size() != 0) {
			list.addAll(list4);
		}
		if(list5 != null && list5.size() != 0) {
			list.addAll(list5);
		}
		if(list6 != null && list6.size() != 0) {
			list.addAll(list6);
		}
		if(list7 != null && list7.size() != 0) {
			list.addAll(list7);
		}
		if(list8 != null && list8.size() != 0) {
			list.addAll(list8);
		}
		if(list9 != null && list9.size() != 0) {
			list.addAll(list9);
		}
		return list;
	}

	/**
	 * 获取是否有促销赠品
	 * 
	 * @param saleList
	 * @param storeId
	 * @return
	 */
	public static boolean haveZengPin(List<ProductEntity> saleList, String storeId) {
		List<List<ProductEntity>> list1 = getMZCCXITEM(saleList, storeId);
		if(list1 != null && list1.size() != 0) {
			return true;
		}
		List<List<ProductEntity>> list2 = getMZCXITEM(saleList, storeId);
		if(list2 != null && list2.size() != 0) {
			return true;
		}
		List<List<ProductEntity>> list3 = getMZHPZK_BLCXITEM(saleList, storeId);
		if(list3 != null && list3.size() != 0) {
			return true;
		}
		List<List<ProductEntity>> list4 = getMZHPZK_JECXITEM(saleList, storeId);
		if(list4 != null && list4.size() != 0) {
			return true;
		}
		List<List<ProductEntity>> list5 = getZLCXITEM(saleList, storeId);
		if(list5 != null && list5.size() != 0) {
			return true;
		}
		List<List<ProductEntity>> list6 = getZLZK_BLCXITEM(saleList, storeId);
		if(list6 != null && list6.size() != 0) {
			return true;
		}
		List<List<ProductEntity>> list7 = getZLZK_JECXITEM(saleList, storeId);
		if(list7 != null && list7.size() != 0) {
			return true;
		}
		List<List<ProductEntity>> list8 = getZLCX_DHM(saleList, storeId);
		if(list8 != null && list8.size() != 0) {
			return true;
		}
		List<List<ProductEntity>> list9 = getMZCX_DHM(saleList, storeId);
		if(list9 != null && list9.size() != 0) {
			return true;
		}
		return false;
	}
	/*    
    *//**
	 * 获取促销活动信息
	 * 
	 * @param storeId
	 *            门店编号
	 * @return
	 */
	/*
	 * public static List<HuoDongDetailEntity> getCuXiaoDetail(String storeId){
	 * String sql = "select sdate,edate,cxname,cxmode from djcxitem " +" where "
	 * +" storeid=? and" +" sdate <=? and edate >=? "; Cursor cursor=null;
	 * List<HuoDongDetailEntity> hdlist=new ArrayList<HuoDongDetailEntity>();
	 * try { Date curDate=new Date(System.currentTimeMillis());//获取当前时间 cursor =
	 * BaseAppManager.database().rawQuery(sql, new String[] { storeId,
	 * DateUtil.formatDate(curDate), DateUtil.formatDate(curDate) }); if (cursor
	 * != null) { while(cursor.moveToNext()) { HuoDongDetailEntity hddEntity=new
	 * HuoDongDetailEntity(); String sdate =cursor.isNull(0)? "" :
	 * cursor.getString(0); String edate =cursor.isNull(1)? "" :
	 * cursor.getString(1); String cxname =cursor.isNull(2)? "" :
	 * cursor.getString(2); String cxmode =cursor.isNull(3)? "" :
	 * cursor.getString(3); if(!"".equals(sdate)){ String[]
	 * sdates=sdate.split("-"); sdate=sdates[0]+"年"+sdates[1]+"月"+sdates[2]+"日";
	 * } if(!"".equals(edate)){ String[] edates=edate.split("-");
	 * edate=edates[0]+"年"+edates[1]+"月"+edates[2]+"日"; }
	 * hddEntity.setStartTime(sdate); hddEntity.setEndTime(edate);
	 * hddEntity.setContent(cxname); String title="";
	 * if("MZCX".equals(cxmode)||"MZCCXX".equals(cxmode)){ title="买赠"; }else
	 * if("MZHPZK_BL".equals(cxmode)){ title="买减"; }else
	 * if("MZHPZK_JE".equals(cxmode)){ title="买折"; }else
	 * if("ZLZK_BL".equals(cxmode)){ title="满减"; }else
	 * if("ZLZK_JE".equals(cxmode)){ title="满折"; }else
	 * if("ZLCX".equals(cxmode)){ title="满赠"; } hddEntity.setTitle(title);
	 * hdlist.add(hddEntity); } }
	 * 
	 * } catch (Exception e) { BaseAppManager.loger().info("查询促销活动信息出错"+e);
	 * }finally{ if(cursor!=null){ cursor.close(); } } return hdlist; }
	 */

}