package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.DiaoBoChuHuoEntity;
import com.urovo.wgmf.db.dao.entitys.Djdb001Db;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Djdb001DbOperate {

	private static DBTool dbTool;

	public Djdb001DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(Djdb001Db djdb001) {
		Cursor cursor = null;
		try {
			String sql = "insert into djdb001(bill,storeID,stwhsID,tstoreID,oper_lr,lr_name,wdate,status,shstatus,dbnum,comm) values(?,?,?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql,
					new String[]{ djdb001.getBill(), djdb001.getStoreID(), djdb001.getStwhsID(), djdb001.getTstoreID(), djdb001.getOper_lr(), djdb001.getLr_name(), djdb001.getWdate(), djdb001.getStatus(), djdb001.getShstatus(), djdb001.getDbnum() + "", djdb001.getComm(), });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djdb001DbOperate.Insert]" + e);
			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<Djdb001Db> selectBy(String sql) {
		List<Djdb001Db> list = new ArrayList<Djdb001Db>();
		Cursor cursor = null;
		String sqlStr = "select * from djdb001 ";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Djdb001Db model = new Djdb001Db();
				model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
				model.setStoreID(cursor.getString(cursor.getColumnIndex("storeID")));
				model.setStwhsID(cursor.getString(cursor.getColumnIndex("stwhsID")));
				model.setTstoreID(cursor.getString(cursor.getColumnIndex("tstoreID")));
				model.setOper_lr(cursor.getString(cursor.getColumnIndex("oper_lr")));
				model.setLr_name(cursor.getString(cursor.getColumnIndex("lr_name")));
				model.setWdate(cursor.getString(cursor.getColumnIndex("wdate")));
				model.setStatus(cursor.getString(cursor.getColumnIndex("status")));
				model.setShstatus(cursor.getString(cursor.getColumnIndex("shstatus")));
				model.setDbnum(cursor.getInt(cursor.getColumnIndex("dbnum")));
				model.setComm(cursor.getString(cursor.getColumnIndex("comm")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djdb001DbOperate.selectBy]" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djdb001 ";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djdb001DbOperate.deleteAllGoods]" + e);
			result = false;
		}
		finally {
		}
		return result;
	}

	public static int GetUnUploadCount() {
		int total = 0;
		Cursor cursor = null;
		String sql = "select count(bill) from djdb001 where IsUp=0";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			if(cursor.moveToNext()) {
				total = cursor.getInt(0);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("获取未上传调拨单据总数发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return total;
	}

	/**
	 * 获取未上传的调拨出货主表
	 * 
	 * @return
	 */
	public static List<DiaoBoChuHuoEntity> GetUnUpload() {
		Cursor cursor = null;
		List<DiaoBoChuHuoEntity> list = new ArrayList<DiaoBoChuHuoEntity>();
		Date date = new Date();
		String sql = "select bill,storeid,stwhsid,tstoreid,oper_lr,lr_name,wdate,status,shstatus,dbnum,comm from djdb001 " + " where IsUp=0 limit 20";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				DiaoBoChuHuoEntity ent = new DiaoBoChuHuoEntity();
				ent.setBill(cursor.isNull(0) ? "" : cursor.getString(0));
				ent.setStoreId(cursor.isNull(1) ? "" : cursor.getString(1));
				ent.setTStoreId(cursor.isNull(3) ? "" : cursor.getString(3));
				ent.setOper_Lr(cursor.isNull(4) ? "" : cursor.getString(4));
				ent.setLr_Name(cursor.isNull(5) ? "" : cursor.getString(5));
				ent.setWDate(cursor.isNull(6) ? DateUtil.getDate(date) : cursor.getString(6));
				ent.setDBNum(cursor.isNull(9) ? 0 : cursor.getDouble(9));
				ent.setComm(cursor.isNull(10) ? "" : cursor.getString(10));
				list.add(ent);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("获取未上传门店调拨出货单主表发生异常" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 获取未上传的调拨出货主表
	 * 
	 * @return
	 */
	public static List<DiaoBoChuHuoEntity> GetAllUnUpload() {
		Cursor cursor = null;
		List<DiaoBoChuHuoEntity> list = new ArrayList<DiaoBoChuHuoEntity>();
		Date date = new Date();
		String sql = "select bill,storeid,stwhsid,tstoreid,oper_lr,lr_name,wdate,status,shstatus,dbnum,comm from djdb001 " + " where IsUp=0 ";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				DiaoBoChuHuoEntity ent = new DiaoBoChuHuoEntity();
				ent.setBill(cursor.isNull(0) ? "" : cursor.getString(0));
				ent.setStoreId(cursor.isNull(1) ? "" : cursor.getString(1));
				ent.setTStoreId(cursor.isNull(3) ? "" : cursor.getString(3));
				ent.setOper_Lr(cursor.isNull(4) ? "" : cursor.getString(4));
				ent.setLr_Name(cursor.isNull(5) ? "" : cursor.getString(5));
				ent.setWDate(cursor.isNull(6) ? DateUtil.getDate(date) : cursor.getString(6));
				ent.setDBNum(cursor.isNull(9) ? 0 : cursor.getDouble(9));
				ent.setComm(cursor.isNull(10) ? "" : cursor.getString(10));
				list.add(ent);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("获取未上传门店调拨出货单主表发生异常" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 更新上传信息
	 * 
	 * @param bill
	 */
	public static void UpdateBillState(String bill) {

		String sqlCommand = "update djdb001 set IsUp=1 where bill=?";
		try {
			BaseAppManager.database().execSQL(sqlCommand, new String[]{ bill });
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("更新调拨出货单据" + bill + "上传状态发生异常:" + ex);
		}
	}

	/**
	 * 保存调拨出库单主表到本地数据库
	 * 
	 * @param bll
	 * @return
	 */
	public static boolean SaveDiaoBoChuKu(DiaoBoChuHuoEntity bll) {
		String sql = "insert into DJDB001(BILL,STOREID,STWHSID,TSTOREID,OPER_LR,LR_NAME,WDATE,STATUS,SHSTATUS,DBNUM,COMM,IsUp) " + "values(?,?,?,?,?,?,?,?,?,?,?,?)";
		try {
			BaseAppManager.database().execSQL(sql, new Object[]{ bll.getBill(), bll.getStoreId(), bll.getSTWHSID(), bll.getTStoreId(), bll.getOper_Lr(), bll.getLr_Name(), bll.getWDate(), bll.getStatus(), bll.getSHSTATUS(), bll.getDBNum(), bll.getComm(), 0 });
		}
		catch (Exception e) {

			BaseAppManager.loger().info("保存调拨出库单主表到本地数据库发生异常:" + e);
			return false;
		}
		return true;
	}

}