package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Djdbsh001Db;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Djdbsh001DbOperate {

	private static DBTool dbTool;

	public Djdbsh001DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(Djdbsh001Db djdbsh001) {
		Cursor cursor = null;
		try {
			String sql = "insert into djdbsh001(bill,db_bill,storeID,stwhsID,fstoreID,fstwhsID,oper_lr,lr_name,wdate,status,comm,isup) values(?,?,?,?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ djdbsh001.getBill(), djdbsh001.getDb_bill(), djdbsh001.getStoreID(), djdbsh001.getStwhsID(), djdbsh001.getFstoreID(), djdbsh001.getFstwhsID(), djdbsh001.getOper_lr(), djdbsh001.getLr_name(), djdbsh001.getWdate(), djdbsh001.getStatus(),
					djdbsh001.getComm(), djdbsh001.getIsup() + "" });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djdb002DbOperate.Inserts]" + e);
			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<Djdbsh001Db> selectBy(String sql) {
		List<Djdbsh001Db> list = new ArrayList<Djdbsh001Db>();
		Cursor cursor = null;
		String sqlStr = "select * from djdbsh001 ";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Djdbsh001Db model = new Djdbsh001Db();
				model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
				model.setDb_bill(cursor.getString(cursor.getColumnIndex("db_bill")));
				model.setStoreID(cursor.getString(cursor.getColumnIndex("storeID")));
				model.setStwhsID(cursor.getString(cursor.getColumnIndex("stwhsID")));
				model.setFstoreID(cursor.getString(cursor.getColumnIndex("fstoreID")));
				model.setFstwhsID(cursor.getString(cursor.getColumnIndex("fstwhsID")));
				model.setOper_lr(cursor.getString(cursor.getColumnIndex("oper_lr")));
				model.setLr_name(cursor.getString(cursor.getColumnIndex("lr_name")));
				model.setWdate(cursor.getString(cursor.getColumnIndex("wdate")));
				model.setStatus(cursor.getString(cursor.getColumnIndex("status")));
				model.setComm(cursor.getString(cursor.getColumnIndex("comm")));
				model.setIsup(cursor.getInt(cursor.getColumnIndex("isup")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djdb002DbOperate.selectBy]" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djdbsh001 ";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djdb002DbOperate.deleteAllGoods]" + e);
			result = false;
		}
		finally {
		}
		return result;
	}
}