package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;
import android.text.TextUtils;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Djpd001Db;
import com.urovo.wgmf.db.dao.entitys.PanDianEntity;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Djpd001DbOperate {

	private static DBTool dbTool;

	public Djpd001DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(Djpd001Db djpd001) {
		Cursor cursor = null;
		try {
			String sql = "insert into djpd001(bill,storeID,stwhsID,yngc,pddesc,pddate,status,oper_lr,lr_name,remark,url,wdate,isup) values(?,?,?,?,?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ djpd001.getBill(), djpd001.getStoreID(), djpd001.getStwhsID(), djpd001.getYngc(), djpd001.getPddesc(), djpd001.getPddate(), djpd001.getStatus(), djpd001.getOper_lr(), djpd001.getLr_name(),djpd001.getRemark(),djpd001.getUrl(), djpd001.getWdate(), djpd001.getIsup() + "" });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djpd001DbOperate.Insert]" + e);
			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<Djpd001Db> selectBy(String sql) {
		List<Djpd001Db> list = new ArrayList<Djpd001Db>();
		Cursor cursor = null;
		String sqlStr = "select * from djpd001 ";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Djpd001Db model = new Djpd001Db();
				model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
				model.setStoreID(cursor.getString(cursor.getColumnIndex("storeID")));
				model.setStwhsID(cursor.getString(cursor.getColumnIndex("stwhsID")));
				model.setYngc(cursor.getString(cursor.getColumnIndex("yngc")));
				model.setPddesc(cursor.getString(cursor.getColumnIndex("pddesc")));
				model.setPddate(cursor.getString(cursor.getColumnIndex("pddate")));
				model.setStatus(cursor.getString(cursor.getColumnIndex("status")));
				model.setOper_lr(cursor.getString(cursor.getColumnIndex("oper_lr")));
				model.setLr_name(cursor.getString(cursor.getColumnIndex("lr_name")));
				model.setRemark(cursor.getString(cursor.getColumnIndex("remark")));
				model.setUrl(cursor.getString(cursor.getColumnIndex("url")));
				model.setWdate(cursor.getString(cursor.getColumnIndex("wdate")));
				model.setIsup(cursor.getInt(cursor.getColumnIndex("isup")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djpd001DbOperate.selectBy]" + e);

		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djpd001 ";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djpd001DbOperate.deleteAllGoods]" + e);

			result = false;
		}
		finally {
		}
		return result;
	}

	public static int GetUnUploadCount() {
		int total = 0;
		Cursor cursor = null;
		String sql = "select count(bill) from djpd001 where IsUp=0";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			if(cursor.moveToNext()) {
				total = cursor.getInt(0);
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("获取未上传盘点单据总数发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return total;
	}

	/**
	 * 更新上传信息
	 * 
	 * @param bill
	 */
	public static void UpdateBillState(String bill) {

		String sqlCommand = "update djpd001 set IsUp=1 where bill=?";
		try {
			BaseAppManager.database().execSQL(sqlCommand, new String[]{ bill });
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("更新盘点据" + bill + "上传状态发生异常:" + ex);
		}

	}

	public static void DeletePanDian(String bill) {
		String sql1 = "delete from djpd001 where bill='" + bill + "'";
		String sql2 = "delete from djpd002 where bill='" + bill + "'";
		BaseAppManager.database().beginTransaction();
		try {
			BaseAppManager.database().execSQL(sql1);
			BaseAppManager.database().execSQL(sql2);
			BaseAppManager.database().setTransactionSuccessful();
		}
		catch (Exception e) {

			BaseAppManager.loger().info("DeletePanDian(" + bill + ")发生异常:" + e);
		}
		finally {
			BaseAppManager.database().endTransaction();
		}
	}

	/**
	 * 保存盘点单主表到本地数据库
	 * 
	 * @param bll
	 * @return
	 */
	public static boolean SavePanDian(PanDianEntity bll) {
		String sql = "insert into DJPD001(BILL,STOREID,STWHSID,YNGC,PDDESC,PDDATE,OPER_LR,LR_NAME,REMARK,URL,WDATE,STATUS,IsUp) " + "  values(?,?,?,?,?,?,?,?,?,?,?,?,?)";
		try {
			BaseAppManager.database().execSQL(sql, new Object[]{ bll.getBill(), bll.getStoreId(), bll.getSTWHSID(), bll.getYNGC(), bll.getPDDESC(), bll.getPDDate(), bll.getOper_Lr(), bll.getLr_Name(),bll.getRemark(),bll.getUrl(), bll.getWDate(), bll.getStatus(), 0 });
		}
		catch (Exception e) {

			BaseAppManager.loger().info("保存盘点单主表发生异常:" + e);
			return false;
		}
		return true;
	}

	/**
	 * 获取未上传的盘点单据主表
	 * 
	 * @return
	 */
	public static List<PanDianEntity> GetUnUpload() {
		Cursor cursor = null;
		List<PanDianEntity> list = new ArrayList<PanDianEntity>();
		Date date = new Date();
		String sql = "select bill,storeid,stwhsid,yngc,pddesc,pddate,status,oper_lr,lr_name,remark,url,wdate from djpd001 where IsUp=0 limit 20";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				PanDianEntity ent = new PanDianEntity();
				ent.setBill(cursor.isNull(0) ? "" : cursor.getString(0));
				ent.setStoreId(cursor.isNull(1) ? "" : cursor.getString(1));
				ent.setPDDESC(cursor.isNull(4) ? "" : cursor.getString(4));
				ent.setPDDate(cursor.isNull(5) ? DateUtil.getDate(date) : cursor.getString(5));
				String oper_lr = cursor.isNull(7) ? SystemHelper.LoginUserId : cursor.getString(7);
				ent.Oper_Lr = TextUtils.isEmpty(oper_lr) ? SystemHelper.LoginUserId : oper_lr;
				String lr_name = cursor.isNull(8) ? SystemHelper.LoginUserName : cursor.getString(8);
				ent.setLr_Name(TextUtils.isEmpty(lr_name) ? SystemHelper.LoginUserName : lr_name);
				ent.setRemark(cursor.isNull(9) ?"" : cursor.getString(9));
				ent.setUrl(cursor.isNull(10) ? "" : cursor.getString(10));
				ent.setWDate(cursor.isNull(11) ? DateUtil.getDate(date) : cursor.getString(11));
				list.add(ent);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("获取未上传盘点单主表发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 获取未上传的盘点单据主表
	 * 
	 * @return
	 */
	public static List<PanDianEntity> GetAllUnUpload() {
		Cursor cursor = null;
		List<PanDianEntity> list = new ArrayList<PanDianEntity>();
		Date date = new Date();
		String sql = "select bill,storeid,stwhsid,yngc,pddesc,pddate,status,oper_lr,lr_name,remark,url,wdate from djpd001 where IsUp=0 ";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				PanDianEntity ent = new PanDianEntity();
				ent.setBill(cursor.isNull(0) ? "" : cursor.getString(0));
				ent.setRemark(cursor.isNull(9) ? "" : cursor.getString(9));
				ent.setUrl(cursor.isNull(10) ? "" : cursor.getString(10));
				ent.setStoreId(cursor.isNull(1) ? "" : cursor.getString(1));
				ent.setPDDESC(cursor.isNull(4) ? "" : cursor.getString(4));
				ent.setPDDate(cursor.isNull(5) ? DateUtil.getDate(date) : cursor.getString(5));
				String oper_lr = cursor.isNull(7) ? SystemHelper.LoginUserId : cursor.getString(7);
				ent.Oper_Lr = TextUtils.isEmpty(oper_lr) ? SystemHelper.LoginUserId : oper_lr;
				String lr_name = cursor.isNull(8) ? SystemHelper.LoginUserName : cursor.getString(8);
				ent.setLr_Name(TextUtils.isEmpty(lr_name) ? SystemHelper.LoginUserName : lr_name);
				ent.setWDate(cursor.isNull(11) ? DateUtil.getDate(date) : cursor.getString(11));
				list.add(ent);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("获取未上传盘点单主表发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

}