package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Item005Db;
import com.urovo.wgmf.db.dao.entitys.LPItem;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Item005DbOperate {

	private static DBTool dbTool;

	public Item005DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(Item005Db item005) {
		Cursor cursor = null;
		try {
			String sql = "insert into item005(storeID,itemID,rprice,gcID,kcqty,tjbill,udate,nrprice) values(?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ item005.getStoreID(), item005.getItemID(), item005.getRprice() + "", item005.getGcID(), item005.getKcqty() + "", item005.getTjbill(), item005.getUdate(), item005.getNrprice() + "", });
			return true;
		}
		catch (Exception e) {

			BaseAppManager.loger().info("[Item005DbOperate.Insert]" + e);
			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<Item005Db> selectBy(String sql) {
		List<Item005Db> list = new ArrayList<Item005Db>();
		Cursor cursor = null;
		String sqlStr = "select * from item005";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Item005Db model = new Item005Db();
				model.setStoreID(cursor.getString(cursor.getColumnIndex("storeID")));
				model.setItemID(cursor.getString(cursor.getColumnIndex("itemID")));
				model.setRprice(cursor.getInt(cursor.getColumnIndex("rprice")));
				model.setGcID(cursor.getString(cursor.getColumnIndex("gcID")));
				model.setKcqty(cursor.getInt(cursor.getColumnIndex("kcqty")));
				model.setTjbill(cursor.getString(cursor.getColumnIndex("tjbill")));
				model.setUdate(cursor.getString(cursor.getColumnIndex("udate")));
				model.setNrprice(cursor.getInt(cursor.getColumnIndex("nrprice")));
				if(model.getItemID() != null && model.getItemID().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info(e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from item005";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {

			result = false;
			BaseAppManager.loger().info(e);
		}
		finally {
		}
		return result;
	}

	/**
	 * 获取产品p的调价
	 */
	public static void GetTiaoJia(ProductEntity p, String storeid, double count) {
		GetItem005rprice(p, storeid);
		Cursor cursor = null;
		String sql = "select nrprice,rprice from item005 where storeid=? and itemid=? and udate <=?";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, new String[]{ storeid, p.getItemId(), DateUtil.getDateTime(new Date()) });
			if(cursor.moveToNext()) {
				double newprice = cursor.getDouble(cursor.getColumnIndex("NRPRICE"));
				if(newprice != 0) {
					// 执行新价格
					p.setPrice(newprice);
					p.setTQTY(count);
					p.setAmount(p.getPrice() * count);
				}
				else {
					p.setPrice(cursor.getDouble(cursor.getColumnIndex("RPRICE")));
					p.setTQTY(count);
					p.setAmount(p.getPrice() * count);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("查询产品调价信息发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
	}

	/**
	 * 获取item005的rprice
	 * 
	 * @param p
	 * @param storeid
	 */
	public static void GetItem005rprice(ProductEntity p, String storeid) {
		Cursor cursor = null;
		String sql = "select rprice from item005 where storeid=? and itemid=?";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, new String[]{ storeid, p.getItemId() });
			if(cursor.moveToNext()) {
				p.setPrice(cursor.getDouble(0));
				p.setTQTY(1);
				p.setAmount(p.getPrice() * 1);
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("获取item005的rprice发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
	}

	/**
	 * 获取礼品p的调价
	 * 
	 * @param p
	 * @param storeid
	 */
	public static void GetTiaoJia(LPItem p, String storeid) {
		GetItem005rprice(p, storeid);

		Cursor dr = null;
		String sql = "select nrprice,rprice from item005 where storeid='{0}' and itemid='{1}'" + "and udate <='{2}'";

		try {
			dr = BaseAppManager.database().rawQuery(sql, new String[]{ storeid, p.getItemId(), DateUtil.format(new Date(), "yyyy-MM-dd 00:00:00") });
			if(dr != null) {
				if(dr.moveToNext()) {
					double newprice = dr.isNull(0) ? 0 : dr.getDouble(0);
					if(newprice != 0) {
						// 执行新价格
						p.setPrice(newprice);
					}
					else {
						// 执行新价格
						p.setPrice(dr.isNull(1) ? 0 : dr.getDouble(1));
					}
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("查询产品调价信息发生异常:" + e);
		}
		finally {
			if(dr != null) {
				dr.close();
			}
		}
	}

	/**
	 * 获取礼品的item005的rprice
	 * 
	 * @param p
	 * @param storeid
	 */
	public static void GetItem005rprice(LPItem p, String storeid) {
		Cursor dr = null;
		String sql = "select rprice from item005 where storeid='{0}' and itemid='{1}'";

		try {
			dr = BaseAppManager.database().rawQuery(sql, new String[]{ storeid, p.getItemId() });
			if(dr != null) {
				if(dr.moveToNext()) {
					p.setPrice(dr.isNull(0) ? 0 : dr.getDouble(0));
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("获取item005的rprice发生异常:" + e);
		}
		finally {
			if(dr != null) {
				dr.close();
			}
		}
	}
}
