package com.urovo.wgmf.db.dao.dao

import android.database.Cursor
import com.urovo.wugumofang.system.BaseAppManager

/**
 * @author Sasuke on 2018/8/9.
 * 打印机响应码信息表
 */
object PrinterRetcodeDbOperate {
    /**
     * 通过各种状态码来映射到文字提示信息
     */
    @JvmStatic
    fun getInfoByStatusCode(statusCode: String): String {
        var cursor: Cursor? = null
        val sql = "select content from printer_retcode where retcode = ?"
        try {
            cursor = BaseAppManager.database().rawQuery(sql, arrayOf(statusCode))
            if (cursor.moveToNext()) {
                return cursor.getString(cursor.getColumnIndex("content"))
            }
        } catch (e: Exception) {
            BaseAppManager.loger().info("根据状态码查找对应提示文字异常:$e")
            e.printStackTrace()
        } finally {
            cursor?.close()
        }
        return ""
    }

    /**
     * 删除所有数据
     */
    @JvmStatic
    fun deleteAll(sql: String?): Boolean? {
        var result: Boolean? = false
        var sqlStr = "Delete from printer_retcode "
        if (sql != null) {
            sqlStr += sql
        }
        try {
            BaseAppManager.database().execSQL(sqlStr)
            result = true
        } catch (e: Exception) {
            BaseAppManager.loger().info("PrinterRetcodeDbOperate.deleteAll $e")

            result = false
        } finally {
        }
        return result
    }

}