package com.urovo.wgmf.db.dao.dao;

import android.database.Cursor;

import com.urovo.wgmf.db.dao.entitys.SrghDb;
import com.urovo.wugumofang.system.BaseAppManager;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

public class SrghDbOperate {
	public static Boolean deleteBy(String sql) {

		Boolean result = false;
		try {
			String strSql = "delete from SRGH";
			if(sql != null) {
				strSql += sql;
			}
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		return result;
	}

	public static Boolean Insert(SrghDb model) {
		Boolean result = false;
		try {
			String strSql = "insert into SRGH(NAME,SEX,MOBILE,BIRTHDAY,CALLEDTIME,MSGEDTIME,INVALID)" + "values(?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(strSql, new String[]{ model.mName, model.mSex, model.mMobile, model.mBirthday, model.mCalledTime, model.mMsgedTime, model.mInvalid });
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[SrghDbOperate.Insert]" + e);

		}
		return result;
	}

	public static List<SrghDb> selectBy(String sql) {
		List<SrghDb> list = new ArrayList<SrghDb>();
		Cursor cursor = null;
		try {
			String strSql = "select * from SRGH";
			if(sql != null) {
				strSql += sql;
			}
			strSql += " order by BIRTHDAY asc";
			cursor = BaseAppManager.database().rawQuery(strSql, new String[]{});
			while (cursor.moveToNext()) {
				SrghDb cell = new SrghDb();
				cell.mName = cursor.getString(cursor.getColumnIndex("NAME"));
				cell.mSex = cursor.getString(cursor.getColumnIndex("SEX"));
				cell.mMobile = cursor.getString(cursor.getColumnIndex("MOBILE"));
				cell.mBirthday = cursor.getString(cursor.getColumnIndex("BIRTHDAY"));
				cell.mCalledTime = cursor.getString(cursor.getColumnIndex("CALLEDTIME"));
				cell.mMsgedTime = cursor.getString(cursor.getColumnIndex("MSGEDTIME"));
				cell.mInvalid = cursor.getString(cursor.getColumnIndex("INVALID"));
				list.add(cell);
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		finally {
			if(null != cursor)
				cursor.close();
		}
		return list;
	}

	public static boolean updateOrInsert(SrghDb model) {
		Boolean result = false;
		if(null == model.mMobile)
			return false;
		Cursor cursor = null;
		try {
			String strSqlQuery = "select * from SRGH where MOBILE='" + model.mMobile + "'";
			cursor = BaseAppManager.database().rawQuery(strSqlQuery, new String[]{});
			if(cursor.moveToNext()) {
				model.mCalledTime = cursor.getString(cursor.getColumnIndex("CALLEDTIME"));
				model.mMsgedTime = cursor.getString(cursor.getColumnIndex("MSGEDTIME"));
			}
			String strSql = "insert or replace into SRGH(NAME,SEX,MOBILE,BIRTHDAY,CALLEDTIME,MSGEDTIME,INVALID)" + "values(?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(strSql, new String[]{ model.mName, model.mSex, model.mMobile, model.mBirthday, model.mCalledTime, model.mMsgedTime, null });
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[SrghDbOperate.updateOrInsert]" + e);
		}
		finally {
			if(null != cursor)
				cursor.close();
		}
		return result;
	}

	public static boolean setCallOrMsgDate(String name, String mobile) {
		Boolean result = false;
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		String date = sdf.format(new java.util.Date());
		try {
			String strSql = "update SRGH set " + name + "='" + date + "' where MOBILE = '" + mobile + "'";
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[SrghDbOperate.setCallOrMsgDate]" + e);

		}
		return result;
	}

	public static boolean enableInvalid() {
		Boolean result = false;
		try {
			String strSql = "update SRGH set INVALID = 'yes'";
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[SrghDbOperate.enableInvalid]" + e);

		}
		return result;
	}

	public static boolean clearInvalid() {
		Boolean result = false;
		try {
			String strSql = "delete from SRGH where INVALID = 'yes'";
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[SrghDbOperate.clearInvalid]" + e);

		}
		return result;
	}
}
