package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;
import android.text.TextUtils;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wgmf.db.dao.entitys.Store001Db;
import com.urovo.wgmf.db.dao.entitys.StoreOrderProduct;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 门店档案表的基本操作
 * 
 * @author Administrator
 * 
 */
public class Store001DbOprate {
	public static DBTool dbTool;

	public Store001DbOprate(Context context) {
		
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入方法
	 */
	public static Boolean Insert(Store001Db storeModel) {
		Boolean result = false;
		//外层已有catch
	//	try {
			String sql = "insert into STORE001(StoreID,Storename,DeptcsID,Yymode,GcID," + "Status,Cpbill,zgName,zgNo) values(?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(
					sql,
					new String[]{ storeModel.getStoreID(), storeModel.getStorename(), storeModel.getDeptcsID(), storeModel.getYymode(), storeModel.getGcID(),
							storeModel.getStatus(),storeModel.getCpbill(),storeModel.getZgName(),storeModel.getZgNo() });
			result = true;
		//}
		/*catch (Exception e) {
			BaseAppManager.loger().info("[Store001DbOprate.Insert]" + e);

		}*/
		return result;
	}

	/**
	 * 删除方法
	 */
	public static Boolean deleteBy(String sql) {
		Boolean result = false;
		try {
			String strSql = "Delete from STORE001";
			if(sql != null) {
				strSql += sql;
			}
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		return result;
	}

	/**
	 * 查询方法
	 */
	public static List<Store001Db> selectBy(String sql) {
		List<Store001Db> list = new ArrayList<Store001Db>();
		Cursor cursor = null;
		try {
			String strSql = "Select * from STORE001";
			if(sql != null) {
				strSql += sql;
			}
			cursor = BaseAppManager.database().rawQuery(strSql, new String[]{});
			while (cursor.moveToNext()) {
				Store001Db model = new Store001Db();
				model.setStoreID(cursor.getString(cursor.getColumnIndex("StoreID")));
				model.setStorename(cursor.getString(cursor.getColumnIndex("Storename")));
				model.setDeptcsID(cursor.getString(cursor.getColumnIndex("DeptcsID")));
				model.setYymode(cursor.getString(cursor.getColumnIndex("Yymode")));
				model.setGcID(cursor.getString(cursor.getColumnIndex("GcID")));
				model.setStatus(cursor.getString(cursor.getColumnIndex("Status")));
				model.setCpbill(cursor.getString(cursor.getColumnIndex("Cpbill")));
				model.setZgName(cursor.getString(cursor.getColumnIndex("zgName")));
				model.setZgNo(cursor.getString(cursor.getColumnIndex("zgNo")));
				if(model.getStoreID() != null && model.getStoreID().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		finally {
			if(cursor != null)
				cursor.close();
		}
		return list;
	}

	/**
	 * 获取所有门店
	 */
	public static List<ShopEntity> GetShopChoice() {
		Cursor cursor = null;
		List<ShopEntity> list = new ArrayList<ShopEntity>();
		try {
			String sql = "select storeid,storename from store001";

			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				ShopEntity ent = new ShopEntity();
				String storeid = cursor.getString(cursor.getColumnIndex("STOREID"));
				ent.setShopId(storeid == null ? "" : storeid);
				String storename = cursor.getString(cursor.getColumnIndex("STORENAME"));
				ent.setShopName(storename == null ? "" : storename);
				list.add(ent);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("获取所有门店GetShopChoice发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}

		return list;
	}

	/**
	 * 根据门店id获取门店名称
	 * 
	 * @param storeId
	 * @return
	 */
	public static String GetStoreName(String storeId) {
		String name = "";
		Cursor cursor = null;
		String sql = "select storename from store001 where storeid=?";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, new String[]{ storeId });
			if(cursor.moveToNext()) {
				name = cursor.getString(0) == null ? "" : cursor.getString(0);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("根据门店id" + storeId + "获取门店名称异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return name;
	}

	/**
	 * 获取该门店下的主管id
	 *
	 * @param storeId
	 * @return
	 */
	public static String getZgNo(String storeId) {
		String zgNo = "";
		Cursor cursor = null;
		String sql = "select zgNo from store001 where storeid=?";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, new String[]{ storeId });
			if(cursor.moveToNext()) {
				zgNo = cursor.getString(0) == null ? "" : cursor.getString(0);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("根据门店id" + storeId + "获取门店名称异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return zgNo;
	}

	/**
	 * 获取该门店下的主管名字
	 *
	 * @param storeId
	 * @return
	 */
	public static String getZgName(String storeId) {
		String zgName = "";
		Cursor cursor = null;
		String sql = "select zgName from store001 where storeId=?";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, new String[]{ storeId });
			if(cursor.moveToNext()) {
				zgName = cursor.getString(0) == null ? "" : cursor.getString(0);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("根据主管id" + storeId + "获取门店名称异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return zgName;
	}



	/**
	 * 
	 * @Title: GetMenDianIDbyName
	 * @Description: 通过门店名称获取门店ID
	 * @param @param string
	 * @param @return 参数说明
	 * @return String 返回类型
	 * @throws
	 */
	public static String GetMenDianIDbyName(String storename) {
		String storeId = null;
		String sql = "select storeid from store001 where storename=?";
		Cursor cursor = null;
		try {
			cursor = BaseAppManager.database().rawQuery(sql, new String[]{ storename });
			if(cursor.moveToNext()) {
				storeId = StringUtils.isEmpty(cursor.getString(0)) ? cursor.getString(0) : "未知";
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("根据门店名称获取id发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return storeId;
	}

	/**
	 * 门店模式下根据门店编号获取门店所属组织机构编码
	 */
	public static String GetDeptcsidByStoreId(String storeId) {
		Cursor cursor = null;
		String deptcsid = "";
		String sql = "select deptcsid from store001 where storeid=?";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, new String[]{ storeId });
			if(cursor.moveToNext()) {
				deptcsid = cursor.getString(0) == null ? "" : cursor.getString(0);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("根据门店编码获取所属组织机构编码:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return deptcsid;
	}

	/**
	 * 查询产品信息
	 * 
	 *  storeId
	 *            门店编号
	 *  selectType查找类别
	 *            ：1模糊查询，2精确查询
	 *  itemId查找的商品编号
	 *  type查找的业务类别type
	 *            =1 ：订货状态，status:Y 可订货 N 不可订货。 2：盘点状态：Y 需盘点 N 不需盘点。3：销售分组号
	 *            XSGRPID= '999' 的不显示status为null。4：其他分组号 QTGRPID =
	 *            '999'的不显示。5：试吃状态 Y 可试吃 N 不可试吃。6：冲加状态 Y 可冲加 N 不可冲加
	 *  status
	 * @return
	 */
	public static synchronized List<StoreOrderProduct> getStoreProduct(String storeId, int selectType, String itemId, int type, String status) {
		String billSql = " select CPBILL from  STORE001 where STOREID='" + storeId + "' ";
		String itemStr = " select ITEMID from CPBILL002 where BILL=(" + billSql + ") ";
		if(status != null) {
			switch (type) {
			case 1:
				itemStr += " and DHSTAT='" + status + "' ";
				break;
			case 2:
				itemStr += " and  PDSTAT='" + status + "' ";
				break;
			case 3:
				itemStr += " and  XSGRPID<>'999' ";
				break;
			case 4:
				itemStr += " and  QTGRPID<>'999' ";
				break;
			case 5:
				itemStr += " and  SCSTAT='" + status + "' ";
				break;
			case 6:
				itemStr += " and  CJSTAT='" + status + "' ";
				break;
			}
		}
		if(itemId != null && !itemId.equals("")) {
			if(selectType == 1)
				itemStr += " and  ITEMID like '" + itemId + "%' ";
			else
				if(selectType == 2) {
					itemStr += " and  ITEMID = '" + itemId + "' ";
				}
		}
		String productSql = "select it1.ITEMID as ITEMID,ITEMNAME,KCUOM,DHPACK,NORMRPRICE,RPRICE,UDATE,NRPRICE" + " from ( select * from ITEM001 where ITEMID in (" + itemStr + ")) as it1" + " left join (select * from ITEM005 where STOREID='" + storeId + "') as it5 on it1.ITEMID=it5.ITEMID ";
		// Log.e("aa", productSql);
		Cursor cursor = null;
		List<StoreOrderProduct> list = new ArrayList<StoreOrderProduct>();
		StoreOrderProduct data = null;
		try {
			cursor = BaseAppManager.database().rawQuery(productSql, new String[]{});
			while (cursor.moveToNext()) {
				data = new StoreOrderProduct();
				data.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
				data.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
				data.setUnit(cursor.getString(cursor.getColumnIndex("KCUOM")));
				data.setDpPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
				data.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
				double RPRICE = cursor.getDouble(cursor.getColumnIndex("RPRICE"));// 门店价
				if(RPRICE != 0.0) {
					data.setPrice(RPRICE);
				}
				String UDATE = cursor.getString(cursor.getColumnIndex("UDATE"));
				if(UDATE != null && DateUtil.getDateTime(new Date()).compareTo(UDATE) > 0) {
					double NRPRICE = cursor.getDouble(cursor.getColumnIndex("NRPRICE"));
					data.setPrice(NRPRICE);
				}
				// 排除重复的
				boolean exist = false;
				for (StoreOrderProduct ent : list) {
					if(data.getItemId().equals(ent.getItemId())) {
						exist = true;
						break;
					}
				}
				if(!exist) {
					list.add(data);
				}
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info(e);
		}
		finally {
			if(cursor != null)
				cursor.close();
		}
		return list;
	}

	/**
	 * 查询产品信息
	 * 
	 * @param storeId
	 *            门店编号
	 *            ：1模糊查询，2精确查询
	 *            =1 ：订货状态，status:Y 可订货 N 不可订货。 2：盘点状态：Y 需盘点 N 不需盘点。3：销售分组号
	 *            XSGRPID= '999' 的不显示status为null。4：其他分组号 QTGRPID =
	 *            '999'的不显示。5：试吃状态 Y 可试吃 N 不可试吃。6：冲加状态 Y 可冲加 N 不可冲加
	 * @param status
	 * @return
	 */
	public static synchronized List<ProductEntity> getProduct(String storeId, int selectType, String itemId, int type, String status) {
		String billSql;
		if(TextUtils.isEmpty(storeId)) {
			billSql = " select CPBILL from  STORE001 ";
		}
		else {
			billSql = " select CPBILL from  STORE001 where STOREID='" + storeId + "' ";
		}
		String itemStr = " select ITEMID from CPBILL002 where BILL=(" + billSql + ") ";
		if(status != null) {
			switch (type) {
			case 1:
				itemStr += " and DHSTAT='" + status + "' ";
				break;
			case 2:
				itemStr += " and  PDSTAT='" + status + "' ";
				break;
			case 3:
				itemStr += " and  XSGRPID<>'999' ";
				break;
			case 4:
				itemStr += " and  QTGRPID<>'999' ";
				break;
			case 5:
				itemStr += " and  SCSTAT='" + status + "' ";
				break;
			case 6:
				itemStr += " and  CJSTAT='" + status + "' ";
				break;
			}
		}
		if(itemId != null && !itemId.equals("")) {
			if(selectType == 1)
				itemStr += " and  ITEMID like '" + itemId + "%' ";
			else
				if(selectType == 2) {
					itemStr += " and  ITEMID = '" + itemId + "' ";
				}
		}
		String productSql;
		if(TextUtils.isEmpty(storeId)) {
			productSql = "select it1.ITEMID as ITEMID,ITEMNAME,ITEMMODE,ITEMTYPE,QTYINTEGER,KCUOM,DHPACK,NORMRPRICE,RPRICE,UDATE,NRPRICE" + " from ( select * from ITEM001 where ITEMID in (" + itemStr + ")) as it1" + " left join (select * from ITEM005 " + ") as it5 on it1.ITEMID=it5.ITEMID ";
		}
		else {
			productSql = "select it1.ITEMID as ITEMID,ITEMNAME,ITEMMODE,ITEMTYPE,QTYINTEGER,KCUOM,DHPACK,NORMRPRICE,RPRICE,UDATE,NRPRICE" + " from ( select * from ITEM001 where ITEMID in (" + itemStr + ")) as it1" + " left join (select * from ITEM005 where STOREID='" + storeId
					+ "') as it5 on it1.ITEMID=it5.ITEMID ";
		}
		// Log.e("aa", productSql);
		Cursor cursor = null;
		List<ProductEntity> list = new ArrayList<ProductEntity>();
		ProductEntity p = null;
		try {
			cursor = BaseAppManager.database().rawQuery(productSql, new String[]{});
			while (cursor.moveToNext()) {
				p = new ProductEntity();
				p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
				p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
				p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
				p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
				p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
				p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
				p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
				p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
				p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
				double RPRICE = cursor.getDouble(cursor.getColumnIndex("RPRICE"));// 门店价
				if(RPRICE != 0.0) {
					p.setPrice(RPRICE);
				}
				String UDATE = cursor.getString(cursor.getColumnIndex("UDATE"));
				if(UDATE != null && DateUtil.getDateTime(new Date()).compareTo(UDATE) > 0) {
					double NRPRICE = cursor.getDouble(cursor.getColumnIndex("NRPRICE"));
					p.setPrice(NRPRICE);
				}
				// p.setSortNo(cursor.getDouble(cursor.getColumnIndex("SORTNO")));
				p.setTQTY(1);
				p.setAmount(p.getPrice());
				boolean exist = false;
				for (ProductEntity ent : list) {
					if(p.getItemId().equals(ent.getItemId())) {
						exist = true;
						break;
					}
				}
				if(!exist) {
					list.add(p);
				}
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info(e);
		}
		finally {
			if(cursor != null)
				cursor.close();
		}
		return list;
	}

	/**
	 * 根据门店id获取工厂id，工厂id在订货时候要用到
	 * 
	 * @param storeid
	 * @return
	 */
	public static String GetGCID(String storeid) {
		String gcid = "99";
		String sql = "select gcid from store001 where storeid='" + storeid + "'";
		Cursor cursor = null;
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			if(cursor.moveToNext()) {
				gcid = cursor.isNull(0) ? "99" : cursor.getString(0);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("根据门店id获取工厂id异常" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return gcid;
	}
}
