package com.urovo.wgmf.db.dao.dao;

import android.app.Activity;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;

import com.google.gson.Gson;
import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.BasicDataRes;
import com.urovo.wgmf.db.dao.entitys.Table_toposDb;
import com.urovo.wgmf.db.dao.entitys.Table_toposItem;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.List;

public class Table_toposDbOperate {
    public static DBTool dbTool;
    /*	public final static int DOWNLOAD_BASIC_DATA_ALL = 1;
        public final static int DOWNLOAD_BASIC_DATA_FAST = 2;*/
    public static boolean isDownAll = false;//是按时间戳来下载还是直接下载全部
    private static WeakReference<Activity> activityRef;

    public Table_toposDbOperate(Context context) {
        super();
        dbTool = DBTool.getInstance(context);
//        new BasicDataDownloader(activityRef.get()).
    }

    /**
     * 插入方法
     */
    public static boolean Insert(Table_toposDb tableModel) {
        boolean result = false;
        //外层事务处理时会写catch
        //try {
        String sql = "replace into table_topos(TABLENAME,VERSIONTIME,COMM)" + "values(?,?,?)";
        BaseAppManager.database().execSQL(sql, new String[]{tableModel.getTableName(), tableModel.getVersionTime(), tableModel.getComm()});
        result = true;
        //}
        /*catch (Exception e) {
			BaseAppManager.loger().info("[Table_toposDbOperate.Insert]" + e);

		}*/
        return result;
    }

    /**
     * 查询方法
     */
    public static List<Table_toposDb> selectBy(String sql) {
        List<Table_toposDb> list = new ArrayList<Table_toposDb>();
        Cursor cursor = null;
        try {
            String strSql = "select * from table_topos";
            if (sql != null) {
                strSql += sql;
            }
            cursor = BaseAppManager.database().rawQuery(strSql, new String[]{});
            while (cursor.moveToNext()) {
                Table_toposDb tableModel = new Table_toposDb();
                tableModel.setComm(cursor.getString(cursor.getColumnIndex("COMM")));
                tableModel.setVersionTime(cursor.getString(cursor.getColumnIndex("VERSIONTIME")));
                tableModel.setTableName(cursor.getString(cursor.getColumnIndex("TABLENAME")));
                if (tableModel.getTableName() != null && tableModel.getTableName().length() > 0) {
                    list.add(tableModel);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info(e);

        } finally {
            if (cursor != null)
                cursor.close();
        }
        return list;
    }

    /**
     * 把查询出来的结果转换成JSON，并发给后台
     */
    public static String transToJson(List<Table_toposDb> list) {
        List<Table_toposItem> toList = new ArrayList<>();
        if (list != null && list.size() > 0) {//把从本地select出来的list转换成可发给后台的json数组
            for (Table_toposDb db : list) {
                Table_toposItem item = new Table_toposItem();
                item.setTableName(db.getTableName());
                item.setVersionTime(db.getVersionTime());
                toList.add(item);
            }
        }
        return new Gson().toJson(toList);
    }

    /**
     * 处理下载基础资料的返回结果
     */
    public static boolean dealBasicDataResult(BasicDataRes res) {
        synchronized (Table_toposDbOperate.class) {
            if (res == null) {
                return false;
            }
            BaseAppManager.database().beginTransaction();
            boolean writeSuccess = false;//是否写入成功
            try {
                //写入基础数据
                if (res.getInsertSql() != null) {
                    for (String sql : res.getInsertSql()) {
                        BaseAppManager.database().execSQL(sql);//循环执行insert
                    }
                }
                //写入时间戳
                if (res.getTimeStamps() != null) {
                    //Table_toposDbOperate.deleteBy(null);
                    for (Table_toposItem item : res.getTimeStamps()) {
                        Table_toposDb db = new Table_toposDb();
                        db.setTableName(item.getTableName());
                        db.setVersionTime(item.getVersionTime());
                        Table_toposDbOperate.Insert(db);
                    }
                }
                BaseAppManager.database().setTransactionSuccessful();
                writeSuccess = true;
//                markBrand();//做品牌标记
            } catch (SQLException e) {
                e.printStackTrace();
                BaseAppManager.loger().info("TabMenuActivity_displayResult()_downloadBasicData_db_write_exception");
            } finally {
                BaseAppManager.database().endTransaction();
            }
            return writeSuccess;
        }
    }

    /**
     * 记录品牌标记
     */
    public static void markBrand() {//这个做标记记得在登陆里面也做一下，作为默认标记，然后基础资料下载完成之后，会通过eventBus再做一次刷新的。
        SystemHelper.WgmfBrand = "五谷磨房";
        SystemHelper.XdyBrand = Item001DbOperate.querySubBrand();
        SystemHelper.MemGoodsBrand = Item001DbOperate.queryMemGoodsBrand();//会员商品品牌名

//        EventBus.getDefault().post(new ActionFreshBtnBean());//这个挪到每个调用markBrand()的地方,因为启动APP时需要做标记初始化却不需要跑EventBus通知

//        PreferHelper.getInstance().setString(AppConstants.PreKeys.BRAND_MARK,brands);
        //如果产品表里没有找到子品牌，就直接赋值为NULL_BRAND给子品牌字段
//        AppConstants.BRAND.XIANDAOYAN = Item001DbOperate.querySubBrand();//TextUtils.isEmpty(subBrand)?AppConstants.BRAND.NULL_BRAND : subBrand;
    }


    /**
     * 下载基础资料请求
     *
     * @param downAll        是否全量下载
     * @param isShowProgress 是否显示下载转圈圈
     * @param isShowDialog   如果下载失败，是否“强制”弹窗
     */

//    public static void downloadBasicData(final Activity activity, final boolean downAll, final boolean isShowProgress, final boolean isShowDialog) {
//        activityRef = new WeakReference<Activity>(activity);
//        synchronized (Table_toposDbOperate.class) {
//            isDownAll = downAll;
//            final HashMap<String, String> params = new HashMap<>();
//            if (!downAll) {//如果是按时间戳来下载
//                BaseAppManager.loger().info("报文:开始读取时间戳");
//                String json = Table_toposDbOperate.transToJson(Table_toposDbOperate.selectBy(null));
//                params.put("", json);//json为时间戳
//            } else {//如果是下载全部
//                params.put("", new Gson().toJson(new ArrayList<>()));
//            }
//            BaseAppManager.loger().info("报文:开始请求基础资料");
//            if (isShowProgress && getActivity(activityRef) != null) {
//                ViewUtil.showProgress(getActivity(activityRef), "请稍等", "正在下载基础资料...");
//            }
//            OkHttpDominator.postAsynByType(NetParam.YINXIAOBU_SERVER + ApiUrls.APPMANAGE.BASE_DATA_DOWN + SystemHelper.LoginOrganId,
//                    OkHttpDominator.JSON,
//                    params,
//                    new OkHttpDominator.ResultCallback<BasicDataRes>() {
//                        @Override
//                        public void onError(Request request, Exception e) {
//                            ViewUtil.dismissProgress();
//                            if (isShowDialog || Item001DbOperate.GetAll().size() == 0) {//只有当要求显示重试弹窗&&Item001的表为空才弹出 重试弹窗
//                                showDownDerrorDialog(downAll, isShowProgress, isShowDialog);
//                            }
//                        }
//
//                        @Override
//                        public void onResponse(final BasicDataRes res) {
//                            ViewUtil.dismissProgress();
//                            if (!res.msgCode.equals("0")) {//失败
//                                MyToast.show(GlobalApp.context, res.msgInfo, Toast.LENGTH_SHORT);
//                                return;
//                            }
//                            //建个新线程来写入基础资料到本地数据库
//                            new Thread(new Runnable() {
//                                @Override
//                                public void run() {
//                                    boolean writeBasicResult = Table_toposDbOperate.dealBasicDataResult(res);
//                                    if ((!writeBasicResult && isShowDialog) || Item001DbOperate.GetAll().size() == 0) {//如果写入失败
//                                        showDownDerrorDialog(downAll, isShowProgress, isShowDialog);
//                                    }
//                                    //如果写入成功&&显示过等待圆圈圈，那就给个成功提示呗
//                                    if (writeBasicResult && isShowProgress && getActivity(activityRef) != null) {
//                                        getActivity(activityRef).runOnUiThread(new Runnable() {
//                                            @Override
//                                            public void run() {
//                                                MyToast.show(GlobalApp.context, "基础资料下载成功！", Toast.LENGTH_SHORT);
//                                            }
//                                        });
//                                    }
//                                    BaseAppManager.loger().info("报文:基础资料处理完成");
//                                }
//                            }).start();
//                        }
//                    });
//        }
//    }

    /**
     * 基础资料下载失败
     */
//    private static void showDownDerrorDialog(final boolean downAll, final boolean isShowProgress, final boolean isShowDialog) {
//        if (getActivity(activityRef) == null) {
//            return;
//        }
//        getActivity(activityRef).runOnUiThread(new Runnable() {
//            @Override
//            public void run() {
//                new AlertDialog.Builder(getActivity(activityRef)).setMessage("基础资料下载失败！")
//                        .setCancelable(false)
//                        .setPositiveButton("退出", new DialogInterface.OnClickListener() {
//                            @Override
//                            public void onClick(DialogInterface dialogInterface, int i) {
//                                System.exit(0);
//                            }
//                        }).setNegativeButton("重新下载", new DialogInterface.OnClickListener() {
//                    @Override
//                    public void onClick(DialogInterface dialogInterface, int i) {
//                        new Handler().post(new Runnable() {
//                            @Override
//                            public void run() {
//                                if (getActivity(activityRef) != null) {
//                                    Table_toposDbOperate.downloadBasicData(getActivity(activityRef), downAll, isShowProgress, isShowDialog);
//                                }
//                            }
//                        });
//                    }
//                }).create().show();
//            }
//        });
//    }


//    private static Activity getActivity(WeakReference<Activity> activityRef) {
//        if (activityRef != null && activityRef.get() != null) {
//            return activityRef.get();
//        } else {
//            return null;
//        }
//    }

    /**
     * 删除方法
     */
    public static boolean deleteBy(String sql) {
        boolean result = false;
        try {
            String strSql = "delete from table_topos";
            if (sql != null) {
                strSql += sql;
            }
            BaseAppManager.database().execSQL(strSql);
            result = true;
        } catch (Exception e) {

            BaseAppManager.loger().info(e);
        }
        return result;
    }

//    public static void ImportData(List<TableToPOSEntity> list) {
//        String sqlUpdate = "update table_topos set VERSIONTIME=?,COMM=? where TABLENAME=?";
//        String sqlInsert = "insert into table_topos(TABLENAME,VERSIONTIME,COMM) values(?,?,?)";
//
//        try {
//            for (TableToPOSEntity ent : list) {
//                if (!ExistTableName(ent.tableName)) {
//                    BaseAppManager.database().execSQL(sqlInsert, new Object[]{ent.tableName, ent.versionTime, ent.comm});
//                } else {
//                    BaseAppManager.database().execSQL(sqlUpdate, new Object[]{ent.versionTime, ent.comm, ent.tableName});
//                }
//
//            }
//        } catch (Exception ex) {
//            BaseAppManager.loger().info("下载table_topos表数据写入终端数据库发生异常:+ex");
//        }
//    }

    public static boolean ExistTableName(String tableName) {
        boolean flag = false;
        Cursor cursor = null;
        String sql = "select TABLENAME from table_topos where TABLENAME='" + tableName + "'";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            if (cursor.moveToNext()) {
                flag = true;
            }
        } catch (Exception ex) {
            BaseAppManager.loger().info("获取表名是否存在于table_topos:" + ex);
            return flag;
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return flag;
    }


    /**
     * 好像并没有用到
     * 获取PDA上需要重新去后台下载的基础表名(服务器时间戳大于PDA时间戳)
     *
     * @return
     */
    public static List<String> GetUpdateTables() {
        List<String> tables = new ArrayList<String>();
        Cursor cursor = null;
        try {
            String sql = "select table_name from table_topos where mod_timestamp > currentTimeSTAMP or currentTimeSTAMP is null";
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                String name = StringUtils.isEmpty(cursor.getString(0)) ? cursor.getString(0) : "";
                if ("CPBILL002".equals(name.trim().toUpperCase()) || "CZYDA001".equals(name.trim().toUpperCase()) || "DEPTCSDA".equals(name.trim().toUpperCase()) || "ITEM001".equals(name.trim().toUpperCase()) || "ITEM005".equals(name.trim().toUpperCase())
                        || "STORE001".equals(name.trim().toUpperCase()) || "STORECS_GRP002".equals(name.trim().toUpperCase()) || "T_DHLPITEM".equals(name.trim().toUpperCase()) || "CPBARBILL001".equals(name.trim().toUpperCase()) || "CPBARBILL002".equals(name.trim().toUpperCase())
                        || "CPBARSHOP".equals(name.trim().toUpperCase()) || "DJCXITEM".equals(name.trim().toUpperCase()) || "XBZPF".equals(name.trim().toUpperCase())) {
                    if (!"CZYDA001".equals(name.trim().toUpperCase())) {
                        if ("DEPTCSDA".equals(name.trim().toUpperCase())) {
                            // 督导模式下才可以更新机构表
                            if (SystemHelper.IsAdmin) {
                                tables.add(name);
                            }
                        } else {
                            if ("CPBARBILL001".equals(name.trim().toUpperCase()) || "CPBARBILL002".equals(name.trim().toUpperCase()) || "CPBARSHOP".equals(name.trim().toUpperCase())) {
                                // 门店模式：商超条码三个表只要有一个表更新就需要去下载商超条码
                                if (!SystemHelper.IsAdmin) {
                                    if (!tables.contains("CPBARCODE"))
                                        tables.add("CPBARCODE");
                                }
                            } else {
                                tables.add(name);
                            }
                        }
                    }
                }
            }
        } catch (Exception ex) {
            BaseAppManager.loger().info(ex);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return tables;
    }

    /**
     * 好像并没有用到
     * 获取PDA上需要重新去后台下载的基础表名(服务器时间戳大于PDA时间戳)
     *
     * @param autoDownload
     * @return
     */
    public static List<String> GetUpdateTables(boolean autoDownload) {
        List<String> tables = new ArrayList<String>();
        Cursor cursor = null;
        try {
            String sql = "select table_name from table_topos where mod_timestamp > currentTimeSTAMP or currentTimeSTAMP is null";
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                String name = StringUtils.isEmpty(cursor.getString(0)) ? cursor.getString(0) : "";
                if ("CPBILL002".equals(name.trim().toUpperCase()) || "CZYDA001".equals(name.trim().toUpperCase()) || "DEPTCSDA".equals(name.trim().toUpperCase()) || "ITEM001".equals(name.trim().toUpperCase()) || "ITEM005".equals(name.trim().toUpperCase())
                        || "STORE001".equals(name.trim().toUpperCase()) || "STORECS_GRP002".equals(name.trim().toUpperCase()) || "T_DHLPITEM".equals(name.trim().toUpperCase()) || "CPBARBILL001".equals(name.trim().toUpperCase()) || "CPBARBILL002".equals(name.trim().toUpperCase())
                        || "CPBARSHOP".equals(name.trim().toUpperCase()) || "DJCXITEM".equals(name.trim().toUpperCase()) || "XBZPF".equals(name.trim().toUpperCase())) {
                    if ("CPBARBILL001".equals(name.trim().toUpperCase()) || "CPBARBILL002".equals(name.trim().toUpperCase()) || "CPBARSHOP".equals(name.trim().toUpperCase())) {
                        // 门店模式：商超条码三个表只要有一个表更新就需要去下载商超条码
                        if (!SystemHelper.IsAdmin) {
                            if (!tables.contains("CPBARCODE"))
                                tables.add("CPBARCODE");
                        }
                    } else {
                        tables.add(name);
                    }
                }
            }
        } catch (Exception ex) {
            BaseAppManager.loger().info(ex);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return tables;
    }
}