package com.urovo.wgmf.db.dao.dao;

import android.database.Cursor;

import com.urovo.wgmf.db.dao.entitys.XkqtghDb;
import com.urovo.wugumofang.system.BaseAppManager;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

public class XkqtghDbOperate {

	public static Boolean deleteBy(String sql) {

		Boolean result = false;
		try {
			String strSql = "delete from XKQTGH";
			if(sql != null) {
				strSql += sql;
			}
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		return result;
	}

	public static Boolean Insert(XkqtghDb model) {
		Boolean result = false;
		try {
			String strSql = "insert into XKQTGH(NAME,MOBILE,SEX,AGE,BUYREASON,SALEDATE,PRODUCTNAMES,CALLEDTIME,MSGEDTIME,INVALID)" + "values(?,?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(strSql, new String[]{ model.mName, model.mMobile, model.mSex, model.mAgeGroup, model.mBuyReason, model.mSaledate, model.mProducts, model.mCalledTime, model.mMsgedTime, model.mInvalid });
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[XkqtghDbOperate.Insert]" + e);

		}
		return result;
	}

	public static List<XkqtghDb> selectBy(String sql) {
		List<XkqtghDb> list = new ArrayList<XkqtghDb>();
		Cursor cursor = null;
		try {
			String strSql = "select * from XKQTGH";
			if(sql != null) {
				strSql += sql;
			}
			strSql += " order by SALEDATE asc";
			cursor = BaseAppManager.database().rawQuery(strSql, new String[]{});
			while (cursor.moveToNext()) {
				XkqtghDb cell = new XkqtghDb();
				cell.mName = cursor.getString(cursor.getColumnIndex("NAME"));
				cell.mMobile = cursor.getString(cursor.getColumnIndex("MOBILE"));
				cell.mSex = cursor.getString(cursor.getColumnIndex("SEX"));
				cell.mAgeGroup = cursor.getString(cursor.getColumnIndex("AGE"));
				cell.mBuyReason = cursor.getString(cursor.getColumnIndex("BUYREASON"));
				cell.mSaledate = cursor.getString(cursor.getColumnIndex("SALEDATE"));
				cell.mProducts = cursor.getString(cursor.getColumnIndex("PRODUCTNAMES"));
				cell.mCalledTime = cursor.getString(cursor.getColumnIndex("CALLEDTIME"));
				cell.mMsgedTime = cursor.getString(cursor.getColumnIndex("MSGEDTIME"));
				cell.mInvalid = cursor.getString(cursor.getColumnIndex("INVALID"));
				list.add(cell);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info(e);
		}
		finally {
			if(null != cursor)
				cursor.close();
		}
		return list;
	}

	public static boolean updateOrInsert(XkqtghDb model) {
		Boolean result = false;
		if(null == model.mMobile)
			return false;
		Cursor cursor = null;
		try {
			String strSqlQuery = "select * from XKQTGH where MOBILE='" + model.mMobile + "'";
			cursor = BaseAppManager.database().rawQuery(strSqlQuery, new String[]{});
			if(cursor.moveToNext()) {
				model.mCalledTime = cursor.getString(cursor.getColumnIndex("CALLEDTIME"));
				model.mMsgedTime = cursor.getString(cursor.getColumnIndex("MSGEDTIME"));
			}
			String strSql = "insert or replace into XKQTGH(NAME,MOBILE,SEX,AGE,BUYREASON,SALEDATE,PRODUCTNAMES,CALLEDTIME,MSGEDTIME,INVALID)" + "values(?,?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(strSql, new String[]{ model.mName, model.mMobile, model.mSex, model.mAgeGroup, model.mBuyReason, model.mSaledate, model.mProducts, model.mCalledTime, model.mMsgedTime, null });
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[XkqtghDbOperate.updateOrInsert]" + e);
		}
		finally {
			if(null != cursor)
				cursor.close();
		}
		return result;
	}

	public static boolean setCallOrMsgDate(String name, String mobile) {
		Boolean result = false;
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		String date = sdf.format(new java.util.Date());
		try {
			String strSql = "update XKQTGH set " + name + "='" + date + "' where MOBILE = '" + mobile + "'";
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[XkqtghDbOperate.setCallOrMsgDate]" + e);

		}
		return result;
	}

	public static boolean enableInvalid() {
		Boolean result = false;
		try {
			String strSql = "update XKQTGH set INVALID = 'yes'";
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[XkqtghDbOperate.enableInvalid]" + e);

		}
		return result;
	}

	public static boolean clearInvalid() {
		Boolean result = false;
		try {
			String strSql = "delete from XKQTGH where INVALID = 'yes'";
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[XkqtghDbOperate.clearInvalid]" + e);

		}
		return result;
	}
}
