package com.urovo.wgmf.db.dao.entitys

import com.urovo.wugumofang.response.Base3Response
import java.io.Serializable

/**
 * Created by Sasuke on 2019-04-02
 */
data class CanCheckRes3(var resultInfo: List<ResultInfo>) : Base3Response() {
    data class ResultInfo(
        var createDate: String?,//盘点创建日期
        var diffAmount: Double?,//盘点差异金额
        var pdAmount: Double?,//盘点总金额
        var pdBillCode: String?,//盘点单号
        var brandName: String?,//盘点品牌
        var brandId: Int?,//品牌类型id
        var pdDate: String?,//盘点日期
        var pdKouFen: String?,//盘点扣分
        var pdQty: Double?,//盘点总数量
        var pdState: String?,//盘点单状态 ('草稿', '待审核','生效') ,
        var shDate: String?,// 盘点审核日期
        var storeName: String?, //门店名称
        var storeNo: String?, //门店编号
        var pdUserName: String?, // 盘点人员
        var saleAmount: Double?, //本月销售总金额
        val modifyNum: Int?,   //本月可修改次数
        var detailList: List<DetailList>
    ) : Serializable {
        data class DetailList(
            var proName: String?,//产品名字
            var proCode: String?, //产品编码
            var proPrice: Double?,//产品价格
            var isPanDian: Boolean = false,
            var pdQty: Double?,//盘点数量
            var pdAmount: Double?,//盘点金额
            var isDecimal: Boolean = false,//手动添加产品是否支持小数位(默认支持2位)
            var proIsDecimal: String = "是", //实盘数量是否支持小数位(默认支持2位)
            var stockQty: Double?,//库存数量
            var diffQty: Double?, //盘点差异数量
            var diffAmount: Double?,//盘点差异金额
            var productType: Int?,  //产品分类(1定型包装,2小包装)
            var brandId: Int?,//品牌类型id
            var proId: Int?,//产品ID  这个ID不是产品编码的id，具体我也不知道这是什么id，如171。。。。反正不是2.40010这样的
            var locationId: Int?,//库位ID
            var pdAlterNum: Double? = null,//修改盘点后数量
            var pdBillCode: String?,//盘点单号
            var pdId: Int?,//盘点Id
            var proUnit: String?,//产品单位
            var proUnitId: Int?,//产品单位Id
            var storeId: Int?,//门店id
            var type: String?,//类型 :UPDATE =0 或 INSERT =1
            var pdUserNo: String?,//盘点人员工号
            var pdStatus: String?
        ) : Serializable {//盘点单状态 ('草稿', '待审核','生效') ,
        }
    }
}