package com.urovo.wgmf.db.dao.entitys

/**
 * 积分兑换
 * lpitemname 礼品名称
 * lpuom 礼品单位
 * lpusejf 兑换礼品所需积分
 * dates 兑换开始时间
 * datee 兑换结束时间
 * itemid 对应pos的产品编码
 * ehd_kg 对应pos的单位换算率
 * inv 库存
 */
data class JiFenDuiHuanEntity(
    var datee: String,
    var dates: String,
    var ehd_kg: Double,
    var inv: Double,
    var itemid: String,
    var lpitemid: String,
    var lpitemname: String,
    var lpuom: String,
    var lpusejf: Double,
    var showInv: Boolean
) {

    fun toLPItem(): LPItem {
        return LPItem().also {
            it.setDHDateE(this.datee)
            it.setDHDateS(this.dates)
            it.setEHD_KG(this.ehd_kg)
            it.setInv(this.inv)
            it.setItemId(this.itemid)
            it.setLPItemId(this.lpitemid)
            it.setLPItemName(this.lpitemname)
            it.setLPUom(this.lpuom)
            it.setUseJF(this.lpusejf)
            it.setShowInv(this.showInv)

        }
    }
}