package com.urovo.wgmf.db.dao.entitys;

import android.text.TextUtils;

import com.urovo.wgmf.db.dao.dao.Cpbill002DbOperate;
import com.urovo.wgmf.db.dao.dao.Item001DbOperate;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.view.indexBar.IndexBar.bean.BaseIndexPinyinBean;

import java.io.Serializable;
import java.util.Date;

/**
 * 产品实体类
 *
 * @author Administrator
 */
public class ProductEntity extends BaseIndexPinyinBean implements Serializable, Cloneable {
    private static final long serialVersionUID = 1L;
    /**
     * 产品编码
     */
    private String ItemId = "";
    /**
     * 产品条码
     */
    private String Barcode = "";
    /**
     * 产品角色：P-普通产品（输入数量：罐装、盒装单位） C-大类码（散装类，输入金额）
     */
    private String ItemMode = "P";
    /**
     * 产品类型：1 - 原材料 2 - 产成品 3 - 半成品 4 - 包装料 5 - 营耗品 6-直销品
     */
    private String ItemType = "";
    /**
     * 产品名称
     */
    private String ItemName = "";
    /**
     * YN_TX
     */
    private String YN_TX = "Y";
    /**
     * 销售分组号
     */
    private double SortNo = 0;
    /**
     * 插入序列号
     */
    private double Seq_No = 0;
    /**
     * 产品数量
     */
    private double TQTY = 0;
    // / 散数：固定为0
    public double SQTY = 0;
    // / 箱数：等于TQTY
    public double PACK;

    private double DHPack = 0; // 产品包装规格

    private String QtyInteger = ""; // 是否计件
    private double Price = 0; // 售价
    private String KCUom = ""; // 库存单位
    private double Unit = 1; // 箱装数
    private String Comm = ""; // 备注
    private double Discount = 1; // 折扣率(0-1):不打折的商品，折扣率为1；9折商品，折扣率为0.9；8折商品，折扣率为0.8；免费商品，折扣率为0
    /**
     * 金额
     */
    private double Amount = 0;
    private String EffectDate = DateUtil.getDateTime(new Date()); // 生效日期
    private String SaleEmpId = ""; // 促销\销售员编号(单据制单人)
    private String SaleEmpName = ""; // 促销\销售员名称(单据制单人名称)
    private String BeginDate = DateUtil.getDateTime(new Date()); // 开始时间
    private String EndDate = DateUtil.getDateTime(new Date()); // 结束时间
    private String StoreId = ""; // 门店
    private String OrderDate = DateUtil.getDate(new Date()); // 单据日期
    private String OrderBillId1 = ""; // 单号1（收货时候需要两个单号，收货单号，调拨单号）
    private String OrderBillId2 = ""; // 单号2（收货时候需要两个单号，收货单号，调拨单号）
    private String ProductState = ""; // 产品状态
    private String Promotion = ""; // 促销方式
    private String CustomerPhone = ""; // 客户电话
    private String ManagerPhone = ""; // 主管电话
    private double SaleAmount = 0; // 净销售金额
    private String VipId = ""; // 会员号
    private double QtyPercent = 0; // 数量占比（统计查询会用到）
    private double SaleAmountPercent = 0; // 净销售额占比（统计查询会用到）
    private String TStoreId = ""; // 调入门店（调拨时候会用到）
    private String opl_qty = "0"; // 订货建议数量（订货是需要用到）
    private double max_opl_qty = 0;// 订货最大数量（订货是需要用到）
    private double sy_opl_qty = 0;// 剩余订货最大数量（订货是需要用到）
    private double box_qty = 0; // 订货商品箱装数（订货是需要用到）

    private String LastMonth_qty = ""; // 上月用量数
    private String Stock_Qty = ""; // 库存数量//库存+在途
    private String currQty = ""; // 账面库存

    private String proArea = "";//产地
    private String proSupplier = "";//供应商
    private String brand = "";//品牌（五谷磨房 或 鲜稻研）
    private boolean isDecimal = true;//数据是否支持小数（一般是2位）
    private String classid = "";//Classid，用于下单界面对产品表的分类
    private int classidorder;//标签classid的优先级（数字越低优先级越高，越排在前面）
    private int brandId;//品牌id 如：（8五谷磨房 13鲜稻研 15食补集）
    //是否是特殊BOM产品，y:是
    public String BOMSPEC;

    public String getBOMSPEC() {
        return BOMSPEC;
    }

    public void setBOMSPEC(String BOMSPEC) {
        this.BOMSPEC = BOMSPEC;
    }

    public int getBrandId() {
        return brandId;
    }

    public void setBrandId(int brandId) {
        this.brandId = brandId;
    }

    public int getClassidorder() {
        return classidorder;
    }

    public void setClassidorder(int classidorder) {
        this.classidorder = classidorder;
    }

    public String getClassid() {
        return classid;
    }

    public void setClassid(String classid) {
        this.classid = classid;
    }

    public boolean isDecimal() {
        if(isDecimal) {//因为isDecimal默认就是true，所以为了避免因为未赋值而采用的默认值，所以需要再进行一次数据库查询来保险。
            isDecimal = Cpbill002DbOperate.isDecimalById(ItemId);
        }
        return  isDecimal;
    }

    public void setDecimal(boolean decimal) {
        isDecimal = decimal;
    }

    public String getBrand() {
        //小心有时候活动传来的产品信息不带品牌，做个防空！
        if(brand == null){
            brand = Item001DbOperate.getBrandById(ItemId);
        }
        return brand;
    }

    public void setBrand(String brand) {
        this.brand = brand;
    }

    @Override
    public String getTarget() {
        return ItemName;
    }

    public String getProArea() {
        return proArea;
    }

    public void setProArea(String proArea) {
        this.proArea = proArea;
    }

    public String getProSupplier() {
        return proSupplier;
    }

    public void setProSupplier(String proSupplier) {
        this.proSupplier = proSupplier;
    }

    public String getCurrQty() {
        return currQty;
    }

    public void setCurrQty(String currQty) {
        this.currQty = currQty;
    }

    public boolean isEnable = false;
    public boolean isBack = false;
    public boolean isPanDian = false;
    public boolean isShow = true;
    public boolean isChecked = false;
    public boolean isInvalid = false;
    public double orgTQTY = 0; // 产品数量
    public int minCount = 0;// 最小数量，为活动时产品数量的最小值
    public double cyl = 0.0;// 本地计算库存率


    /**
     * 特价，目前只用于数据库存储用
     */
    private double specialPrice;

    @Override
    public String toString() {
        return "ProductEntity [ItemId=" + ItemId + ", Barcode=" + Barcode + ", ItemMode=" + ItemMode
                + ", ItemType=" + ItemType + ", ItemName=" + ItemName + ", YN_TX=" + YN_TX + ", SortNo="
                + SortNo + ", Seq_No=" + Seq_No + ", TQTY=" + TQTY + ", SQTY=" + SQTY + ", PACK=" + PACK
                + ", DHPack=" + DHPack + ", QtyInteger=" + QtyInteger + ", Price=" + Price + ", KCUom="
                + KCUom + ", Unit=" + Unit + ", Comm=" + Comm + ", Discount=" + Discount + ", Amount="
                + Amount + ", EffectDate=" + EffectDate + ", SaleEmpId=" + SaleEmpId + ", SaleEmpName="
                + SaleEmpName + ", BeginDate=" + BeginDate + ", EndDate=" + EndDate + ", StoreId=" + StoreId
                + ", OrderDate=" + OrderDate + ", OrderBillId1=" + OrderBillId1 + ", OrderBillId2="
                + OrderBillId2 + ", ProductState=" + ProductState + ", Promotion=" + Promotion
                + ", CustomerPhone=" + CustomerPhone + ", ManagerPhone=" + ManagerPhone + ", SaleAmount="
                + SaleAmount + ", VipId=" + VipId + ", QtyPercent=" + QtyPercent + ", SaleAmountPercent="
                + SaleAmountPercent + ", TStoreId=" + TStoreId + ", opl_qty=" + opl_qty + ", max_opl_qty="
                + max_opl_qty + ", sy_opl_qty=" + sy_opl_qty + ", box_qty=" + box_qty + ", LastMonth_qty="
                + LastMonth_qty + ", Stock_Qty=" + Stock_Qty + ", isEnable=" + isEnable + ", isBack="
                + isBack + ", isPanDian=" + isPanDian + ", isShow=" + isShow + ", isChecked=" + isChecked
                + ", isInvalid=" + isInvalid + ", orgTQTY=" + orgTQTY + ", minCount=" + minCount + ", cyl="
                + cyl + "]";
    }

    @Override
    public ProductEntity clone() {

        ProductEntity o = null;
        try {
            o = (ProductEntity) super.clone();
        } catch (CloneNotSupportedException e) {

        }
        return o;
    }

    public double getSy_opl_qty() {
        return sy_opl_qty;
    }

    public void setSy_opl_qty(double sy_opl_qty) {
        this.sy_opl_qty = sy_opl_qty;
    }

    public double getMax_opl_qty() {
        return max_opl_qty;
    }

    public void setMax_opl_qty(double max_opl_qty) {
        this.max_opl_qty = max_opl_qty;
    }

    public double getBox_qty() {
        return box_qty;
    }

    public void setBox_qty(double box_qty) {
        this.box_qty = box_qty;
    }

    public String getOpl_qty() {
        return opl_qty;
    }

    public void setOpl_qty(String opl_qty) {
        this.opl_qty = opl_qty;
    }

    public String getItemId() {
        return ItemId;
    }

    public void setItemId(String itemId) {
        ItemId = itemId;
    }

    public String getBarcode() {
        return Barcode;
    }

    public void setBarcode(String barcode) {
        Barcode = barcode;
    }

    public String getItemMode() {
        return ItemMode;
    }

    public void setItemMode(String itemMode) {
        ItemMode = itemMode;
    }

    public String getItemType() {
        return ItemType;
    }

    public void setItemType(String itemType) {
        ItemType = itemType;
    }

    public String getItemName() {
        return ItemName;
    }

    public void setItemName(String itemName) {
        ItemName = itemName;
    }

    public String getYN_TX() {
        return YN_TX;
    }

    public void setYN_TX(String yN_TX) {
        YN_TX = yN_TX;
    }

    public double getSortNo() {
        return SortNo;
    }

    public void setSortNo(double sortNo) {
        SortNo = sortNo;
    }

    public double getSeq_No() {
        return Seq_No;
    }

    public void setSeq_No(double seq_No) {
        Seq_No = seq_No;
    }

    public double getTQTY() {
        return TQTY;
    }

    public void setTQTY(double tQTY) {
        TQTY = tQTY;
    }

    public double getSQTY() {
        return SQTY;
    }

    public void setSQTY(double sQTY) {
        SQTY = sQTY;
    }

    public double getPACK() {
        return PACK;
    }

    public void setPACK(double pACK) {
        PACK = pACK;
    }

    public double getDHPack() {
        return DHPack;
    }

    public void setDHPack(double dHPack) {
        DHPack = dHPack;
    }

    public String getQtyInteger() {
        return QtyInteger;
    }

    public void setQtyInteger(String qtyInteger) {
        QtyInteger = qtyInteger;
    }

    public double getPrice() {
        return Price;
    }

    public void setPrice(double price) {
        Price = price;
    }

    public String getKCUom() {
        return KCUom;
    }

    public void setKCUom(String kCUom) {
        KCUom = kCUom;
    }

    public double getUnit() {
        return Unit;
    }

    public void setUnit(double unit) {
        Unit = unit;
    }

    public String getComm() {
        return Comm;
    }

    public void setComm(String comm) {
        Comm = comm;
    }

    public double getDiscount() {
        return Discount;
    }

    public void setDiscount(double discount) {
        Discount = discount;
    }

    public double getAmount() {
        return Amount;
    }

    public void setAmount(double amount) {
        Amount = amount;
    }

    public String getEffectDate() {
        return EffectDate;
    }

    public void setEffectDate(String effectDate) {
        EffectDate = effectDate;
    }

    public String getSaleEmpId() {
        return SaleEmpId;
    }

    public void setSaleEmpId(String saleEmpId) {
        SaleEmpId = saleEmpId;
    }

    public String getSaleEmpName() {
        return SaleEmpName;
    }

    public void setSaleEmpName(String saleEmpName) {
        SaleEmpName = saleEmpName;
    }

    public String getBeginDate() {
        return BeginDate;
    }

    public void setBeginDate(String beginDate) {
        BeginDate = beginDate;
    }

    public String getEndDate() {
        return EndDate;
    }

    public void setEndDate(String endDate) {
        EndDate = endDate;
    }

    public String getStoreId() {
        return StoreId;
    }

    public void setStoreId(String storeId) {
        StoreId = storeId;
    }

    public String getOrderDate() {
        return OrderDate;
    }

    public void setOrderDate(String orderDate) {
        OrderDate = orderDate;
    }

    public String getOrderBillId1() {
        return OrderBillId1;
    }

    public void setOrderBillId1(String orderBillId1) {
        OrderBillId1 = orderBillId1;
    }

    public String getOrderBillId2() {
        return OrderBillId2;
    }

    public void setOrderBillId2(String orderBillId2) {
        OrderBillId2 = orderBillId2;
    }

    public String getProductState() {
        return ProductState;
    }

    public void setProductState(String productState) {
        ProductState = productState;
    }

    public String getPromotion() {
        return Promotion;
    }

    public void setPromotion(String promotion) {
        Promotion = promotion;
    }

    public String getCustomerPhone() {
        return CustomerPhone;
    }

    public void setCustomerPhone(String customerPhone) {
        CustomerPhone = customerPhone;
    }

    public String getManagerPhone() {
        return ManagerPhone;
    }

    public void setManagerPhone(String managerPhone) {
        ManagerPhone = managerPhone;
    }

    public double getSaleAmount() {
        return SaleAmount;
    }

    public void setSaleAmount(double saleAmount) {
        SaleAmount = saleAmount;
    }

    public String getVipId() {
        return VipId;
    }

    public void setVipId(String vipId) {
        VipId = vipId;
    }

    public double getQtyPercent() {
        return QtyPercent;
    }

    public void setQtyPercent(double qtyPercent) {
        QtyPercent = qtyPercent;
    }

    public double getSaleAmountPercent() {
        return SaleAmountPercent;
    }

    public void setSaleAmountPercent(double saleAmountPercent) {
        SaleAmountPercent = saleAmountPercent;
    }

    public String getTStoreId() {
        return TStoreId;
    }

    public void setTStoreId(String tStoreId) {
        TStoreId = tStoreId;
    }

    public String getLastMonth_qty() {
        return LastMonth_qty;
    }

    public void setLastMonth_qty(String lastMonth_qty) {
        LastMonth_qty = lastMonth_qty;
    }

    public String getStock_Qty() {
        if (TextUtils.isEmpty(Stock_Qty)){
            Stock_Qty = "0";
        }
        return Stock_Qty;
    }

    /**输入的【会员商品数量】是否超过了库存*/
    public boolean isOverMemStock(Double inputQty){
        return  SystemHelper.MemGoodsBrand.equals(brand)
                && inputQty > Double.parseDouble(getStock_Qty());
    }

    public void setStock_Qty(String stock_Qty) {
        Stock_Qty = stock_Qty;
    }

    public double getCyl() {
        return cyl;
    }

    public void setCyl(double cyl) {
        this.cyl = cyl;
    }

    public double getSpecialPrice() {
        return specialPrice;
    }

    public void setSpecialPrice(double specialPrice) {
        this.specialPrice = specialPrice;
    }


    @Override
    public int hashCode() {

        return ItemId.hashCode();
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof ProductEntity) {
            ProductEntity pc = (ProductEntity) obj;
            return ItemId.equals(pc.getItemId());
        } else if (obj instanceof QueryEntity) {
            QueryEntity pc = (QueryEntity) obj;
            return ItemId.equals(pc.ItemId);
        } else if (obj instanceof StockGoodsDetailEntity.DetailList) {
            StockGoodsDetailEntity.DetailList pc = (StockGoodsDetailEntity.DetailList) obj;
            return ItemId.equals(pc.getProductNo());
        } else {
            return super.equals(obj);
        }
    }
}
