package com.urovo.wugumofang.base;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;

import com.urovo.wugumofang.libutils.R;

import java.util.List;

/**
 * @author xiep on 2016/7/20 16:28
 */
public abstract class BaseCommonAdapter<T> extends BaseAdapter {
    private Context mContext;
    private List<T> mDatas;
    private final int mItemLayoutId;

    public BaseCommonAdapter(Context context, List<T> mDatas) {
        this.mContext = context;
        this.mDatas = mDatas;
        this.mItemLayoutId = R.layout.public_list_item;
    }

    @Override
    public int getCount() {
        return !mDatas.isEmpty()? mDatas.size() : 0;
    }

    @Override
    public T getItem(int position) {
        return mDatas.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder = getViewHolder(position, convertView, parent);
        convert(viewHolder, getItem(position));
        return viewHolder.getConvertView();

    }

    public abstract void convert(ViewHolder helper, T item);

    private ViewHolder getViewHolder(int position, View convertView, ViewGroup parent) {
        return ViewHolder.get(mContext, convertView, parent, mItemLayoutId, position);
    }
}