package com.urovo.wugumofang.base;

import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.umeng.analytics.MobclickAgent;
import com.urovo.wugumofang.libutils.R;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.PdaMsgConfig;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DialogHelper;
import com.urovo.wugumofang.ui.DialogHelper.DialogResult;
import com.urovo.wugumofang.ui.ViewUtil;
import com.zsy.libcore.ui.act.SYActManager;

import cn.jpush.android.api.JPushInterface;

public class BaseOldActivity extends Activity implements DialogResult, AdapterResult {
    private static final String TAG = BaseOldActivity.class.getName();
    protected RelativeLayout titile_bg;
    protected ImageButton back;
    protected TextView titleTextView;
    protected ImageButton settinButton;
    protected Button submit;
    protected Boolean backFlag = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        SYActManager.getInstance().addActivity(this);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
//        if (mHttpUtils == null) {
//            mHttpUtils = new HttpUtils();
//            //请求头大概这么加
//            if (!NetParam.getNetHeaders().isEmpty()) {
//                for (String key : NetParam.getNetHeaders().keySet()) {
//                    mHttpUtils.getHttpClient().getParams().setParameter(key, NetParam.getNetHeaders().get(key));
//                }
//            }
//        }
    }

    public void displayResult(String tag, BaseResponse response) {
        try {
            if (null != response) {
                if (!response.sysCode.equals("0")) {
                    // showMsg(response.sysContent);
                    showMsg("网络异常");
                    response = null;
                    // } else if (!response.msgCode.equals("0")) {
                    // showMsg(response.msgContent);
                    // response= null;
                    // return;
                }
            }
            SystemHelper.NewInterface = true;
        } catch (Exception e) {
            Log.d(TAG, "访问的是老接口-" + e.toString());
            SystemHelper.NewInterface = false;
        }
    }

    public void initTitle() {
        getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title);
        titile_bg = (RelativeLayout) findViewById(R.id.relativeLayout1);
        back = (ImageButton) findViewById(R.id.back);
        titleTextView = (TextView) findViewById(R.id.text_title);
        submit = (Button) findViewById(R.id.confirm);
        back.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (backFlag) {
                    DialogHelper.showBackDialog(BaseOldActivity.this);
                } else {
                    back();
                }
            }
        });
        settinButton = (ImageButton) findViewById(R.id.settinButton);
    }

    public void focus(View view) {
        view.setFocusable(true);
        view.setFocusableInTouchMode(true);
        view.requestFocus();
    }

    protected String getName() {
        return "none";
    }

    private String getPageName() {
        if (null != titleTextView) {
            String temp = titleTextView.getText().toString();
            if (temp.startsWith("产品销售查询")) {
                temp = "产品销售查询";
            }
            return temp;
        } else
            return getName();
    }

    @Override
    protected void onResume() {
        super.onResume();
        initPdaConfig();
        MobclickAgent.onPageStart(getPageName());
        MobclickAgent.onResume(this);
        JPushInterface.onResume(this);//用于统计的API
        JPushInterface.requestPermission(this);//安卓6.0以上申请权限
    }

    @Override
    protected void onPause() {
        super.onPause();
        MobclickAgent.onPageEnd(getPageName());
        MobclickAgent.onPause(this);
        JPushInterface.onPause(this);
    }

    @Override
    protected void onDestroy() {
        SYActManager.getInstance().finishActivity(this);
        ViewUtil.dismissProgress();
        super.onDestroy();
    }

    private void initPdaConfig() {
        SystemHelper.LoginOrganId = PdaMsgConfig.getLoginOrgID(BaseOldActivity.this);
        SystemHelper.IsAdmin = PdaMsgConfig.getIsAdmin(BaseOldActivity.this);
        SystemHelper.LoginOrganName = PdaMsgConfig.getLoginOrganName(BaseOldActivity.this);
        SystemHelper.LoginUserId = PdaMsgConfig.getLogUserId(BaseOldActivity.this);
        SystemHelper.LoginUserName = PdaMsgConfig.getLoginUserName(BaseOldActivity.this);
    }

    protected void back() {
        this.finish();
    }

    /**
     * Toast提示
     */
    public void showMsg(String msg) {
//        MyToast.show(BaseOldActivity.this, msg, Toast.LENGTH_LONG);
        Toast.makeText(BaseOldActivity.this, msg, Toast.LENGTH_LONG).show();
    }

    @Override
    public void onDialogResult(int tag) {
    }

    @Override
    public void doResult(int position) {

    }

    public void netError() {

    }

    // @Override
    // public boolean onKeyDown(int keyCode, KeyEvent event) {
    //
    // if(keyCode == KeyEvent.KEYCODE_BACK){
    // return true;
    // }
    // return super.onKeyDown(keyCode, event);
    // }

    public void displayNoNet(String tag) {
    }
}
