package com.urovo.wugumofang.constants;

/**
 * 接口Url地址
 * Created by samy on 16/9/6.
 */
public interface ApiUrls {

    /**
     * http://test.wgmf.com/crmserver
     * crmserver子目录下
     * 原来crmserver现在分成四大子模块；
     * app-manage
     * app-saler
     * app
     * mkt-back 营销管家接口
     */
    interface CRMSERVER {
        /**
         * EnvPort
         */
        String EnvPort = "crmserver/";
    }

    /**
     * AI识别
     */
    interface IDRECOGNIZE {
        String EnvPort = "idRecognize/";

        /**
         * 查询顾问的已上传照片
         */
        String QUERY_FACE = EnvPort + "employee/queryUploadFace4Attendance";

        /**
         * 检查上传的图片是否有面部特征
         */
        String CHECK_FACE = EnvPort + "employee/checkFace";

        /**
         * 上传脸图
         */
        String UPLOAD_FACE = EnvPort + "employee/uploadFace4Attendance";
    }

    /**
     * 微信相关
     */
    interface WeiXin {
        String EnvPort = "wechat-shop-back/";
        /**
         * 请求会员商品转发的列表
         */
        String MEMBER_GOODS_LIST = EnvPort + "product/getQRCodeUrl";
        /**
         * 会员商城订单列表
         */
        String MEMBER_STORE_ORDER_LIST = EnvPort + "order/getByPhone";
        /**
         * 查看会员商城订单物流信息
         */
        String LOGISTICS_QUERY_URL = "http://m.kuaidi100.com/index_all.html?";
        /**
         * 获取专属二维码图片URL
         */
        String QUERY_QRCODE_IMAGE_URL = "wechat-service/wechatQrCodeApi/limitStrQRCode";

    }

    /**
     * 企业微信
     */
    interface WeiXinEnterprise {
        String EnvPort = "wechat-enterprise-service/";

        /**
         * 获取营养顾问企业微信二维码
         */
        String GET_USER_QR_CODE = EnvPort + "userContact/contactWay";
        /**
         * get /workerStaff/isAddQyGroupChat 是否添加企业微信门店群
         */
        String IS_ADD_QY_GROUP_CHAT = EnvPort + "workerStaff/isAddQyGroupChat";

    }

    /**
     * 微信公众号
     */
    interface WeiXinQrcode {
        String EnvPort = "app/";

        /**
         * post /checkQrcodeShops 查询试点门店
         */
        String CHECK_QRCODE_SHOPS = EnvPort + "checkQrcodeShops";

    }

    /**
     * 管理模块
     */
    interface APPMANAGE {
        String EnvPort = "app-manage/";

        //下载基础资料
        String BASE_DATA_DOWN = EnvPort + "information/downloadBasicDataCompress?phoneSys=ios&storeNo=";

        /**
         * 上传Beta版意见反馈
         */
        String BETA_FEED_BACK = EnvPort + "appGrayWhitelist/switchWhitelistByUserNo";

        /**
         * 验证门店
         */
        String CHECK_STORE = EnvPort + "information/checkStore";

        /**
         * 在线验证账户
         */
        String LOGIN_ONLINE = EnvPort + "information/loginOnLine";

        /**
         * 标签打印
         */
        String XDY_LABEL = EnvPort + "information/getXDYLabel";

        /**
         * 用户权限下载（跟基础资料下载类似
         */
        String DOWNLOAD_PRIVILEGE = EnvPort + "appPrivilege/downloadPrivilege";
    }

    /**
     * 销售模块
     */
    interface APPSALER {
        String ENV_PORT = "app-saler/";
        /**
         * 获取用户头像
         */
        String USER_GETHEADPIC = ENV_PORT + "user/getheadpic";
        /**
         * 头像上传
         */
        String USER_UPLOAD = ENV_PORT + "user/upload";
        /**
         * 流程查询
         */
        String OA_WORKFLOW_GET_WORK_FLOW_INFO = ENV_PORT + "OAworkflow/getWorkFlowInfo";
        /**
         * 上报反馈评价提交（评星级）
         */
        String OA_WORKFLOW_SUBMIT_PJ = ENV_PORT + "OAworkflow/submitPj";
        /**
         * 质量问题反馈流程提交
         */
        String OA_FB_WORKFLOW = ENV_PORT + "OAworkflow/createQualityFBWorkFlow";
        /**
         * 到货误差流程提交
         */
        String AOG_ERR_WORKFLOW = ENV_PORT + "OAworkflow/CreateAOGErrWorkFlow";
        /**
         * 柜子质量问题流程提交
         */
        String CABINET_WORKFLOW = ENV_PORT + "OAworkflow/createCabinetWorkFlow";
        /**
         * 我要走流程投诉
         */
        String COMPLAINT_WORKFLOW = ENV_PORT + "OAworkflow/createComplaintWorkFlow";
        /**
         * 文章按关键字搜索
         */
        String LEARN_FIND = ENV_PORT + "learn/find";
        /**
         * 下单成功营养顾问主动推券
         */
        String SEND_TICKET = ENV_PORT + "message/sendTicket";

        /**
         * 上报反馈 - 意见与建议
         */
        String SUGGESTION_WORKFLOW = ENV_PORT + "OAworkflow/createFeedbackWorkFlow";

        /**
         * 会员商品埋点
         */
        String VIP_BURY_POINT = ENV_PORT + "message/vipBuryPoint";

        /**
         * 获取销售动态未读数
         */
        String NEW_SALE_COUNT = ENV_PORT + "message/getNewSaleNum";

        /**
         * 获取销售动态详情
         */
        String NEW_SALE_GET_DETAIL = ENV_PORT + "message/getNewSaleDetail";

        /**
         * 考勤上传
         */
        String SIGN_IN_OR_OUT_MSG = ENV_PORT + "information/signInOrOut";

        /**
         * 流动顾问销售完成情况
         */
        String FLOW_SALES_PERSON_COMPLETION = ENV_PORT + "/salarydetail/getFlowSale";

        /**
         * 更多功能/首页菜单页面(首页菜单也是共用这个接口)
         */
        String MORE_PAGES = ENV_PORT + "/user/getPerMenuInfo";

        /**
         * 首页更新编辑菜单页面接口
         */
        String HOME_DRAG_MENU_PAGES = ENV_PORT + "/user/updatePerMenuInfo";

        /**
         * 查询考勤记录
         */
        String QUERY_WORK_ATTENDANCE = ENV_PORT + "information/queryWorkAttendance";

        /**
         * 年假查询
         */
        String QUERY_VACTIONDETAIL = ENV_PORT + "vactiondetail/querybyempno";

        /**
         * 可调休小时数
         */
        String QUERY_BREAK_HOURS = ENV_PORT + "user/queryStaffBreakHours";

        /**
         * 请假查询 && 调休查询 （请假查询 ridType =1，leaveType不填；调休查询 leaveType  = 8，ridType 不填）
         */
        String QUERY_ABESNCE = ENV_PORT + "user/queryLeaveInfo";

        /**
         * 查询营养顾问上级信息
         */
        String QUERY_STAFF_MANAGERS = ENV_PORT + "user/queryStaffManagers";

        /**
         * 年终奖查询
         */
        String QUERY_YEAR_BONUS = ENV_PORT + "user/queryYearBonus";

        /**
         * 请假申请
         */
        String ASK_FOR_LEAVE = ENV_PORT + "askForLeave";

        /**
         * 常见问题阅读数量累加
         */
        String ADD_PROBLEM_READ_COUNT = ENV_PORT + "FrequentlyProblem/addReadCount";

        /**
         * 查询常见问题
         */
        String GET_PROBLEM_DATA = ENV_PORT + "FrequentlyProblem/getData";

        /**
         * 搜索常见问题
         */
        String SEARCH_PROBLEM_DATA = ENV_PORT + "FrequentlyProblem/serchData";

        /**
         * 临/过期货报损申请
         */
        String OVERDUE_WORKFLOW = ENV_PORT + "OAworkflow/createOverDueWorkFlow";

        /**
         * 查询地理位置是否正确
         */
        String SIGN_IN_OR_OUT_LOCATION_CHECK = ENV_PORT + "information/signInOrOut";
        /**
         * 获取门店距离
         */
        String SHOP_DISTANCE = ENV_PORT + "machineRepair/shopDistance";
        /**
         * 营养顾问 - 根据门店号查询机修人员信息
         */
        String QUERY_MR_OPERATOR = ENV_PORT + "machineRepair/queryMrOperatorByStoreNo";

        /**
         * 营养顾问 - 提交修机单
         */
        String CREAT_MACHINE_REPAIR = ENV_PORT + "machineRepair/creatMrApplication";

        /**
         * 营养顾问 - 查询机修记录
         */
        String QUERY_MR_HISTORY = ENV_PORT + "machineRepair/queryMrApplicationByApplicantNo";

        /**
         * 营养顾问 - 查询机修单详情
         */
        String QUERY_MR_DETAIL = ENV_PORT + "machineRepair/queryMrApplicationDetailById";

        /**
         * 营养顾问 - 提交机修评价
         */
        String SUBMIT_MR_RATING = ENV_PORT + "machineRepair/ratingMrApplicationById";

        /**
         * 机修人员 - 查询未处理工单
         */
        String QUERY_UNDEAL_REPAIR = ENV_PORT + "machineRepair/queryMrApplicationByOperatorNo";

        /**
         * 机修人员 - 查询工单详情
         */
        String QUERY_REPAIR_DETAIL = ENV_PORT + "machineRepair/queryMrApplicationDetailById4Operator";

        /**
         * 机修人员 - 提交工单处理
         */
        String SUBMIT_REPAIR_DEAL = ENV_PORT + "machineRepair/handleMrApplicationById4Operator";

        /**
         * 临期查询
         */
        String QUERY_SHOP_STOCK_LQ = ENV_PORT + "user/getAppShopStockLq";

        /**
         * 养生文库文章分享埋点
         */
        String MESSAGE_ARTICLE_BURYPOINT = ENV_PORT + "message/articleBuryPoint";

        /**
         * 所选日期可调休的时长
         */
        String BREAK_HOURS_TODAY = ENV_PORT + "user/getBreakHoursChooseDay";

        /**
         * 查询机修单申请人的电话号码
         */
        String QUERY_STAFF_PHONE_MR = ENV_PORT + "machineRepair/queryApplicantPhone";


        /**
         * 根据机修工号查询所服务的门店
         */
        String QUERY_ENGINEER_STORES_INFO = ENV_PORT + "machineRepair/queryStoreServed";

        /**
         * 查询门店亮灯故障
         */
        String QUERY_ENGINEER_LIGHT_PROBLEM = ENV_PORT + "machineRepair/queryLogoLampReport";

        /**
         * 上报反馈 - 亮灯情况上报
         */
        String QBACK_LIGHT = ENV_PORT + "machineRepair/submitLogoLampReport";

        /**
         * 机修人员 - 查询巡店检查项目
         */
        String QUERY_PATROL_ITEMS = ENV_PORT + "machineRepair/queryPatrolItem";
        /**
         * post /machineRepair/queryPatrolSchedule 查询巡店计划表
         */
        String QQUERY_PATROL_SCHEDULE = ENV_PORT + "machineRepair/queryPatrolSchedule";

        /**
         * 机修人员 - 提交巡店检查
         */
        String SUBMIT_PATROL_ITEMS = ENV_PORT + "machineRepair/submitPatrol";
        /**
         * 提交灯箱维修状态
         */
        String SUBMIT_SUBMIT_LOGO_LAMP_REPAIR = ENV_PORT + "machineRepair/submitLogoLampRepair";

        /**
         * 顾问入职培训计划的展示
         */
        String CAREER_TRAINING_STAFF = ENV_PORT + "salerTraining/getTrainingPlan";

        /**
         * 提交评估数据
         */
        String SUBMIT_EVALUATE_DATA = ENV_PORT + "salerTraining/submitAssess";

        /**
         * 查询差旅预算
         */
        String QUERY_TRIP_BUDGET = ENV_PORT + "machineRepairTrip/queryTripBudget";

        /**
         * 查询出差记录
         */
        String QUERY_TRIP_RECORD = ENV_PORT + "machineRepairTrip/queryMrTripRecordByUserNo";

        /**
         * 查询是否可添加出差记录
         */
        String CHECK_CAN_INSERT_TRIP_RECORD = ENV_PORT + "machineRepairTrip/canInsertTripRecord";

        /***
         * 查询巡店记录
         */
        String QUERY_PATROL_REPORT = ENV_PORT + "machineRepair/queryPatrolReport";

        /**
         * 查询对应tid的出差明细
         */
        String QUERY_TRIP_RECORD_DETAIL = ENV_PORT + "machineRepairTrip/queryMrTripDetailByTid";

        /**
         * 新建机修出差记录
         */
        String CREATE_NEW_TRIP_RECORD = ENV_PORT + "machineRepairTrip/creatMrTripRecord";

        /**
         * 更新机修出差记录
         */
        String UPDATE_TRIP_RECORD = ENV_PORT + "machineRepairTrip/changeMrTripRecord";

        /***
         * 活动二维码链接获取
         */
        String GET_ACT_QRCODE_URL = ENV_PORT + "user/getActQrcodeUrl";

        /***
         * 到货误差
         */
        String GET_ARRIVE_ERROR_PHOTO_TEXT = ENV_PORT + "OAworkflow/getAOGEgInfo";
        /***
         * 上传个人微信二维码url
         */
        String UPDATE_PERSONAL_WECHAT_URL = ENV_PORT + "user/updatePersonalWechatUrl";
        /***
         * get /user/getTicketUrl 优惠券查询链接
         */
        String GET_TICKET_URL = ENV_PORT + "user/getTicketUrl";
        /***
         * post /information/signFlag 打卡弹窗执行 true：弹窗，false不弹
         */
        String SIGN_FLAG = ENV_PORT + "information/signFlag";
        /***
         * post /information/collect/signForSaleData 打卡确认当天促销的产品
         */
        String SIGN_FORSALE_DATA = ENV_PORT + "information/collect/signForSaleData";

        /**
         * GET /collect/voucherCardData 权益卡数据
         */
        String VOUCHER_CARD_DATA = ENV_PORT + "collect/voucherCardData";

        /**
         * POST /collect/popupWindows 弹窗数据收集
         */
        String POPUP_WINDOWS_DATA_COLLECTION = ENV_PORT + "collect/popupWindows";

        /**
         * post /exhibit/queryMissionByStoreNo 查询门店陈列任务
         */
        String QUERY_MISSION_BY_STORENO = ENV_PORT + "/exhibit/queryMissionByStoreNo";

        /**
         * post /exhibit/addSubmition 新增提报数据
         */
        String ADD_SUBMITION = ENV_PORT + "/exhibit/addSubmition";

        /**
         * post /exhibit/updateSubmition 修改提报数据
         */
        String UPDATE_SUBMITION = ENV_PORT + "exhibit/updateSubmition";

        /**
         * POST /exhibit/queryMissionByStaffId 查询货架陈列上报任务
         */
        String QUERY_MISSION_BY_STAFFID = ENV_PORT + "exhibit/queryMissionByStaffId";

        /**
         * POST /exhibit/queryMissionDetail  查询货架陈列上报任务明细
         */
        String QUERY_MISSION_DETAIL = ENV_PORT + "exhibit/queryMissionDetail";

        /**
         * POST /exhibit/submitMissionDetail 提交货架陈列上报任务数据
         */
        String SUBMIT_MISSION_DETAIL = ENV_PORT + "exhibit/submitMissionDetail";

        /**
         * GET /OAworkflow/hasUnreadData  查询是否有未读的已处理意见与建议流程,返回true就弹窗
         */
        String HAS_UN_READ_DATA = ENV_PORT + "OAworkflow/hasUnreadData";

        /**
         * POST /OAworkflow/updateUnreadData  标记未读的已处理意见与建议流程数据为已读
         */
        String UPDATE_UN_READ_DATA = ENV_PORT + "OAworkflow/updateUnreadData";

        /**
         * GET /homePage/popWindowShow 首页弹窗查询
         */
        String POP_WINDOW_SHOW = ENV_PORT + "homePage/popWindowShow";

        /**
         * GET /leaveTypeList  请假类型接口
         */
        String LEAVE_TYPE_LIST = ENV_PORT + "leaveTypeList";
        /**
         * POST /askForLeaveOption  申请请假类型列表
         */
        String ASK_FOR_LEAVE_OPTION = ENV_PORT + "askForLeaveOption";
    }

    /**
     * 会员模块
     */
    interface APP {
        String EnvPort = "app/";
        /**
         * 首页报表数据(门店关键数据)
         */
        String HOMEPAGE_1_DATA = EnvPort + "information/getMainPage1Data";

        /**
         * 首页报表数据(个人薪资预估或者联营门店数据
         */
        String HOMEPAGE_2_DATA = EnvPort + "information/getMainPage2Data";

        /**
         * 获取会员基本信息
         */
        String GET_CUSTOMER_INFO = EnvPort + "information/getCustomerInfo";
//        /**
//         * 前端显示控制更多页面
//         */
//        String GET_ICONS_DATA = EnvPort + "frontDisplay/getIconsData";
        /**
         * 排班设置接口
         */
        String POST_SHOW_SCHEDULE = EnvPort + "frontDisplay/showSchedule";

        /**
         * 获取会员日数据
         */
        String GET_MEMBER_DAY_DATA = EnvPort + "datastatistics/getMemberDayData";
        /**
         * 获取积分用户名单数据
         */
        String GET_OVER_POINT_CUSTOMER_LIST = EnvPort + "customer/getOverPointCustomerList";
        /**
         * 获取会员关怀人数
         */
        String GET_CUSTOMER_CARE_COUNT = EnvPort + "customer/getCustomerCareCount";
        /**
         * 获取会员关怀列表
         */
        String GET_CARE_CUSTOMER_LIST = EnvPort + "customer/getCareCustomerList";

        /**
         * 下单接口(提交销售),最半不像接口,地址的会员部这边，参数格式是信息部的
         */
        //String USER_POINTEX = EnvPort +  MINISTRY.EnvPort + "/user/pointex";
        String USER_POITEX = EnvPort + "user/pointex";
        /**
         * 门店订货周期变更提醒
         */
        String QUERY_ORDER_GOODS_TIP = EnvPort + "apply/queryOrderGoodsTip";
        /**
         * 查询近一周内是否有发货差异
         */
        String QUERY_ORDER_GOODS_DIFF_BY_WEEK = EnvPort + "apply/queryOrderGoodsDiffByWeek";
        /**
         * 查看门店是否可以订货
         */
        String IS_CAN_ORDERING = EnvPort + "apply/isCanOrdering";
        /**
         * 获取订货列表
         */
        String GET_ORDER_LIST = EnvPort + "apply/getOrderList";
        /**
         * 订货提交
         */
        String ORDER_SUBMIT = EnvPort + "apply/orderSubmit";
        /**
         * 获取订货公共物料列表
         */
        String GET_ORDER_COMMON_LIST = EnvPort + "apply/getOrderCommonList";

        /**
         * 分页查询会员积分兑换历史数据
         */
        String GET_CUS_EXCH_HISTORY = EnvPort + "user/getCusExchHistory";

        /**
         * 兑换撤销
         */
        String POINT_EXCHANGE_CANCEL = EnvPort + "user/pointexchangecancel";

        /**
         * 后台控制是否显示欢迎界面（新功能介绍）
         */
        String WELCOME_IS_SHOW = EnvPort + "frontDisplay/welcome";

        /**
         * 首页广告弹窗
         */
        String NATIONAL_AD_IS_SHOW = EnvPort + "frontDisplay/adPage";

        /**
         * 更多页面的盘点提示广告弹窗
         */
        String MORE_INDEX_ACT_AD_IS_SHOW = EnvPort + "storeTransferCheck/isShowStoreTransferTips";

        /**
         * 获取门店产品出入库汇总
         */
        String GET_STORE_PRODUCT_IN_OUT = EnvPort + "getStoreProductInOut";

        /**
         * 获取门店产品出入库明细
         */
        String GET_STORE_PRODUCT_IN_OUT_DETAIL = EnvPort + "getStoreProductInOutDetail";

        /**
         * 新版盘点，获取本期盘点数据+验证是否可盘点（二合一接口）
         */
        String CURRENT_TRANSFER_CHECK = EnvPort + "storeTransferCheck/getCurrentTransferCheck";

        /**
         * 门店盘点判断
         */
        String TRANSFER_CHECK = EnvPort + "storeTransferCheck/transferCheck";

        /**
         * 查询盘点数据
         */
        String QUERY_TRANSFER_CHECK = EnvPort + "storeTransferCheck/getTransferCheck";

        /**
         * 提交门店盘点数据
         */
        String SUBMIT_TRANSFER_CHECK = EnvPort + "storeTransferCheck/saveTransferCheck";

        /**
         * 订货查询 新接口
         */
        String ORDER_GOODS_DETAIL = EnvPort + "apply/getOrderGoodsDetail";

        /**
         * 门店订货与发货差异列表
         */
        String ORDER_GOODS_Diff = EnvPort + "apply/queryOrderGoodsDiff";

        /**
         * 配送收货查询 新接口
         */
        String QUERY_DISPATCH_DETAIL = EnvPort + "storeDispatch/getDispatchDetail";

        /**
         * 配送收货 新接口
         */
        String GET_CAN_RECEIVED_DISPATCHBILL = EnvPort + "storeDispatch/getCanReceivedDispatchBill";

        /**
         * 配送收货单 提交
         */
        String SAVE_DISPATCHBILL = EnvPort + "storeDispatch/saveDispatchBill";

        /**
         * 新版 退货接口 获取销售记录
         */
        String SALE_RECORD = EnvPort + "storeGoodReturn/getSalesRecord";

        /**
         * 新客微会员（扫码加粉明细页面）数据接口
         */
        String SWEEP_CODE_DETAIL = EnvPort + "datastatistics/getNewWeMemberData";

        /**
         * 销售业绩----产品月销量查询数据接口
         */
        String MONTH_SALE_PRODUCT_DETAIL = EnvPort + "datastatistics/getMonthSaleProductDetail";

        /**
         * 销售业绩----月销量查询数据接口
         */
        String MONTH_CONSUMPTION = EnvPort + "datastatistics/getMonthConsumption";

        /**
         * 显示 职业宣言
         */
        String DECLARATION_PAGE = EnvPort + "frontDisplay/declarationPage";

        /**
         * 退货 获取各子列表的详情
         */
        String GOODRETURN_GET_DETAIL = EnvPort + "storeGoodReturn/getSalesRecordDetail";

        /**
         * 首页轮播图的接口
         */
//        String STORE_TASK_INFO = EnvPort + "information/getStoreTaskInfo";
        String STORE_TASK_INFO = EnvPort + "datastatistics/getHomePageData";


        /**
         * 首页广告位接口
         */
        String HOME_AD = EnvPort + "frontDisplay/showAdList";

        /**
         * 获取试吃数据
         */
        String EAT_MANAGER_QUERY = EnvPort + "storeForetaste/getForetasteData";

        /**
         * 提交试吃数据
         */
        String EAT_MANAGER_SAVE = EnvPort + "storeForetaste/saveForetasteData";

        /**
         * 兑换撤销，查询是否已盘点
         */
        String IS_STORE_TRANSFER_CHECKED = EnvPort + "storeTransferCheck/isStoreTransferChecked";

        /**
         * 调拨查询
         */
        String ALLOT_GOODS_QUIRE = EnvPort + "storeAllot/getStoreAllot";

        /**
         * 获取门店调拨信息(新)
         */
        String STORE_ALLOT_NEW = EnvPort + "storeAllot/getStoreAllotNew";

        /**
         * 调拨单弹窗
         */
        String NOTIFICATION_STORE_ALLOT = EnvPort + "storeAllot/notificationStoreAllot";
        /**
         * 门店订货与发货差异弹窗
         */
        String NOTIFICATION_ORDER_GOOD_DIFF = EnvPort + "apply/notificationOrderGoodDiff";
        /**
         * 修改调拨收货
         */
        String UPDATE_STORE_ALLOT = EnvPort + "storeAllot/updateStoreAllot";

        /**
         * 门店确认收货
         */
        String CONFIRM_STORE_ALLOT = EnvPort + "storeAllot/confirmStoreAllot";

        /**
         * 门店确认发货
         */
        String CHECK_STORE_ALLOT = EnvPort + "storeAllot/checkStoreAllot";

        /**
         * 报损查询
         */
        String STORE_LOSS_QUERY = EnvPort + "storeLoss/getLossData";

        /**
         * 门店赠送查询
         */
        String STORE_PRESENT_QUERY = EnvPort + "storePresent/getPresentData";

        /**
         * 销售补录 查询该日期门店是否已日审
         */
        String IS_STORE_DAY_CHECKED = EnvPort + "storeDayCheck/isStoreDayChecked";

        /**
         * 发送积分兑换验证码
         */
        String POINT_EXCHANGE_SEND_SMS = EnvPort + "user/pointExchangeSendSMS";

        /**
         * 远程校验验证码是否正确
         */
        String CHECK_POINT_EXCHANGE_SMS_ONLINE = EnvPort + "user/pointExchangeVerifySMS";

        /**
         * 录单异常提醒
         */
        String CHECK_ORDER_EXCP = EnvPort + "frontDisplay/orderExcp";

        /**
         * 上传积分兑换数据
         */
        String UPLOAD_JIFEN_DUIHUAN = EnvPort + "user/pointexchange";

        /**
         * 获取会员积分历史（就是积分兑换那个页面的详情列表 ，还带下拉刷新 上拉加载的那个。。。）
         */
        String QUERY_CUST_PTS_DETAIL = EnvPort + "custpts/detail";

        /**
         * 获取登陆界面的背景图
         */
        String QUERY_LOGIN_IMAGE_URL = EnvPort + "frontDisplay/loginImage";

        /**
         * 库存查询主档
         */
        String STOCK_SEARCH = EnvPort + "storeRepertory/getStoreRepertoryTopic";

        /**
         * 库存查询  结果列表
         */
        String STOCK_GOODS_DETAIL = EnvPort + "storeRepertory/getStoreRepertoryDetail";

        /**
         * 会员营销 -- 本月门店会员数据和本月门店会员商品
         */
//        String MEMBER_DATA_STORE = "https://www.easy-mock.com/mock/59c3593fe0dc663341b2e7da/app-manage/member";
        String MEMBER_DATA_STORE = EnvPort + "datastatistics/getMemberData";
        /**
         * 是否显示加微及入群人数提报 页面
         */
//        String MEMBER_SHOW_WE_CHAT = EnvPort + "frontDisplay/showAddFriOnWechat";

        /**
         * 购买明细
         */
        String CUS_SALE_DETAIL = EnvPort + "customer/getCusSaleDetail";

        /**
         * 显示免责声明
         */
        String SHOW_DECLARATION = EnvPort + "frontDisplay/showDeclaration";

        /**
         * 同意免责声明
         */
        String AGREE_DECLARATION = EnvPort + "frontDisplay/agreeDeclaration";

//        /**
//         * 是否显示门店利润查询【弃用】
//         */
//        String IS_SHOW_SHOP_PROFIT = EnvPort + "frontDisplay/showShopProfit";

        /**
         * 是否显示门店利润查询 && 联营门店利润查询
         */
        String IS_SHOW_SHOP_DATA = EnvPort + "frontDisplay/showShopData";
        /**
         * Ra90名单回访
         */
        String GET_RA90_DATA = EnvPort + "datastatistics/getRa90Data";
        /**
         * Ra90名单回访详情列表
         */
        String GET_RA90_DATA_LIST = EnvPort + "datastatistics/getRa90DataList";

        /**
         * 判断会员商城是否允许使用
         */
        String IS_SHOW_MEMBERGOODS = EnvPort + "frontDisplay/showMemberGoods";

        /**
         * 会员日预约名单
         */
        String GET_BOOK_MEMBER_DAY_LIST = EnvPort + "sale/getBookMemberDayList";

        /**
         * 适合Ta的会员商品推荐
         */
        String RECOM_PRO_CUSTOMER = EnvPort + "tagLibrary/recommendProductforCustomer";

        /**
         * 产品销售查询
         */
        String SALE_PRODUCT_DETAIL = EnvPort + "datastatistics/getSaleProductDetail";

        /**
         * 扫码加粉获得顾客信息
         */
        String WEIXIN_SAOMA_JIAFEN = EnvPort + "customer/getQrcode";

        /**
         * 超级营养师查询
         */
        String SUPER_DIETITIAN_QUERY = EnvPort + "nutritionist/queryCertInfo";

        /**
         * 超级营养师 上传
         */
        String SUPER_DIETITIAN_UPLOAD = EnvPort + "nutritionist/uploadCertInfo";

        /**
         * 更多页面合同条款弹窗
         */
        String MORE_INDEX_CONTRACT_DIALOG = EnvPort + "frontDisplay/showMorePage";

        /**
         * 合同条款已读
         */
        String MORE_INDEX_CONTRACT_READ = EnvPort + "frontDisplay/verifyContract";

        /**
         * 上报反馈 - 多点陈列
         */
        String QBACK_CHINRETSU = EnvPort + "storeShowSpot/saveStoreShowSpot";

        /**
         * 根据产品id获取实时库存
         */
        String QUERY_PRO_STOCK = EnvPort + "wxOrder/getProductStocks";

        /**
         * 根据产品id获取产品详情
         */
        String QUERY_PRO_DETAIL = EnvPort + "wxOrder/getProductDetailInfo";

        /**
         * 在线提交会员商品订单
         */
        String SUBMIT_MEM_GOODS_ORDER = EnvPort + "wxOrder/saveOrder";

        /**
         * 查询会员商品未完成订单数
         */
        String QUERY_MEM_ORDER_COUNT = EnvPort + "wxOrder/getOrderNumWithOrdering";

        /**
         * 查询会员商品未完成订单详情
         */
        String QUERY_MEM_ORDER_DETAILS = EnvPort + "wxOrder/getOrdersWithOrdering";

        /**
         * 删除会员商品订单
         */
        String CANCEL_MEM_ORDER = EnvPort + "wxOrder/cancelOrder";

        /**
         * 获取用户收件地址信息
         */
        String QUERY_RECEIVER_ADDRESS = EnvPort + "wxOrder/getCusAddressList";

        /**
         * 提交新的收货地址
         */
        String SUBMIT_NEW_RECEIVER_ADDRESS = EnvPort + "wxOrder/confirmAddress";

        /**
         * 提交会员商品订单
         */
        String SUBMIT_MEM_ORDER = EnvPort + "wxOrder/submitWxMallOrder";

        /**
         * 门店柜型上报查询
         */
        String QUERY_SHISAN_REPORT = EnvPort + "storeFixedAssets/getFixedAssetsInfo";
        /**
         * 固定资产提交数据
         */
        String SUBMIT_SHISAN_REPORT = EnvPort + "storeFixedAssets/save";
        /**
         * post /customer/getCareTaskList 查询自定义回访任务
         */
        String GET_CARE_TASK_LIST = EnvPort + "customer/getCareTaskList";
        /**
         * get /customer/getCareTaskDetail 查询自定义回访任务的明细
         */
        String GET_CARE_TASK_DETAIL = EnvPort + "customer/getCareTaskDetail";

        /**
         * 查询门店是否允许到家业务
         */
        String CAN_HAVE_2_HOME_BIZ = EnvPort + "bizEntry/canHave2HomeBiz";
        /***
         * 获取商城产品数据（海报信息）
         */
        String QUERY_POSTER_INFO = EnvPort + "getProductInfo";

        /**
         * 提交自定义回访任务反馈
         */
        String GUANHUAI_FEED_BACK = EnvPort + "customer/feedbackCareTaskDetail";

        /***
         * 获取朋友圈素材库
         */
        String FRIEND_CIRCLE_MATERIAL = EnvPort + "friendCircleMaterial/queryMaterial";

        /***
         *  朋友圈素材 - 更新状态为已发布
         */
        String FRIENDS_CIRCLE_MATERIAL_PUBLISH_STATE = EnvPort + "friendCircleMaterial/updateMaterialReleased";
        /***
         *  朋友圈素材 - 更新状态为已发布
         */
        String GET_SALER_INFO_LIST = EnvPort + "zmd/getSalerInfoList";

        /**
         * 判断是否新客单，并发对应消费的首购礼
         */
        String QUERY_FIRST_SHOP_GIFT = EnvPort + "newConsGift";

        /**
         * 权益卡查询信息
         */
        String VOUCHER_CARD_INFO = EnvPort + "CostomerSubject/voucherCardInfo";

        /**
         * 免费送直接兑换记录查询
         */
        String GET_ACTIVITY_EXCHAGE_DETAIL = EnvPort + "customer/getActivityExchageDetail";

        /**
         * 配送单号产品
         */
        String GET_DISPATCH_PRODUCT = EnvPort + "storeDispatch/getDispatchProduct";

        /**
         * 非波次单货品
         */
        String GET_NOT_DISPATCH_PRODUCT = EnvPort + "storeDispatch/getNotDispatchProduct";

        /**
         * 上传小票
         */
        String UPLOAD_CERTIFICATE = EnvPort + "uploadCertificate";
    }

    /**
     * 活动
     * http://test.wgmf.com/promotion
     * promotion子目录下
     */
    interface PROMOTION {
        /**
         * EnvPort
         */
        String EnvPort = "promotion/";

        /**
         * 查询线下的全场活动
         */
        String OFFLINE_COMMON_ACTIVITY = EnvPort + "offline/commonActivity";
        /**
         * 查询线下的专享活动
         */
        String OFFLINE_VIP_ACTIVITY = EnvPort + "offline/vipActivity";
        /**
         * 查询会员剩余积分
         */
        String CUS_REMAINS_POINTS = EnvPort + "cus/remainsPoints";
        /**
         * 验证兑换码
         */
        String CHECK_CODE = EnvPort + "checkCode";
        /**
         * 验证规则并返回结果集(立享优惠)
         */
        String VALID_RULE_RESULT = EnvPort + "valid/ruleResult";

        /**
         * 核销，根据活动id返回该门店下的id详情
         */
        String QUERY_ACTION_BY_ACTIVITY_ID = EnvPort + "offline/getActAbortShop";
    }


    /**
     * 信息部老接口;非常特殊（兼容模式)
     */
    interface MINISTRY {
        /**
         * EnvPort
         */
        String EnvPort = "AccessPoint.do";

        /**
         * ActionType
         * 三种:(固定)
         */
        interface ActionType {
            /**
             * 基础数据下载
             */
            String BASEDATA_DOWNLOAD = "BASEDATA_DOWNLOAD";
            /**
             * 上传
             */
            String UPLOAD = "UPLOAD";
            /**
             * 后台查询
             */
            String QUERY_DATA = "QueryData";
        }

        /**
         * 方法类型
         */
        interface MethodType {
            /**
             * 下载门店销量审核数据
             */
            String RequestDown_StoreRXS001 = "RequestDown_StoreRXS001";
            /**
             * 销售上传
             */
            String UPLOAD_XIAOSHOU = "UPLOAD_XIAOSHOU";
            /**
             * 查询订货
             */
            String REQUEST_QUERY__DING_HUO = "RequestQuery_DingHuo";
        }
    }

    /**
     * 签到签退
     */
    interface SignInOut {

        /**
         * 拍照指引
         */
        interface PhotoGuide {
            String PHOTOGUIDEURL = "https://qy.weixin.qq.com/cgi-bin/show?agentuin=1056027793&msgid=4535604834612058277&offset=0";
        }
    }

    /**
     * 消息中心那些乱七八糟的
     */
    interface MSG_SERVICE {
        String EnvPort = "msg-service/";

        /**
         * ELearning更新已读
         */
        String UPDATE_ELEARNING_COUNT = EnvPort + "elearning/updateElearningMsgStatus";

        /**
         * ELearing获取未读
         */
        String GET_ELEARNING_COUNT = EnvPort + "elearning/getUnreadElearningMsgCount";

        /**
         * ELearning卡片点进去后的里面列表详情内容
         */
        String GET_ELEARNING_DETAIL = EnvPort + "elearning/getElearningMsgTypeList";

        /**
         * ELearning外面的卡片内容
         */
        String GET_ELEARNING_CARD = EnvPort + "elearning/getElearningMsgType";

        /**
         * 订货提醒
         */
        String GET_ORDER_SHOP_MSG = EnvPort + "shopmessage/getorderShopMsg";

        /**
         * 盘点提醒
         */
        String GET_STOCK_TAKING_SHOP_MSG = EnvPort + "shopmessage/getstocktakingShopMsg";

        /**
         * 考勤提醒
         */
        String GET_WORK_MSG = EnvPort + "shopmessage/getworkMsg";

        /**
         * 养生文库 or 学习中心
         */
        String GET_DOC_MSG = EnvPort + "shopmessage/getDocMsg";
        /**
         * 获取个人考试档案详情信息
         */
        String GET_EXAM_ARCHIVE_INFO = "examdetail/exam/archive/detail/getInfoByStaffId";

        /**
         * 在线订单
         */
        String ONLINE_ORDER_MSG = EnvPort + "shopmessage/getCommissionMsg";

        /**
         * 系统消息 && 今日任务 未读数
         */
        String SYS_MSG_COUNT = EnvPort + "shopmessage/getUnreadMsgCount";

        /**
         * 上传系统消息 && 今日任务 已读
         */
        String SYS_MSG_COUNT_UPDATE = EnvPort + "shopmessage/updateShopMsg";

        /**
         * 获取系统消息详情
         */
        String SYS_GET_MESSAGE = EnvPort + "shopmessage/getSystemMessage";

        /**
         * 获取今日任务消息详情
         */
        String TODAYTASK_GET_MESSAGE = EnvPort + "shopmessage/getMissionMsg";

        /**
         * 获取千店万群消息
         */
        String GET_TENTHOUSAND_GROUP_MSG = EnvPort + "shopmessage/getTenthousandgroupMsg";

    }

    /**
     * 营销管家模块(涉及排班信息)
     * ps:http://test.wgmf.com/mkt-back/swagger-ui.html#/
     */
    interface YXGJ {
        String EnvPort = "mkt-back";
        /**
         * 营养顾问排班未确认查询
         */
        String SHIFT_QUERY = EnvPort + "/nutritionConsultant/findNutConSchedulingConfirm";
        /**
         * 营养顾问确认排班
         */
        String SHIFT_CONFIRM = EnvPort + "/nutritionConsultant/confirmScheduling";
        /**
         * 导师查询新顾问-生意管家
         */
        String GET_CAREER_EVALUATE_LIST = EnvPort + "/newWorkerTrain/queryTrainEvaluatedUser";
        /**
         * 查询新顾问周一评价信息-生意管家
         */
        String GET_QUERY_WEEK_ONE_TRAIN_INFO = EnvPort + "/newWorkerTrain/queryWeekOneTrainInfo";
        /**
         * 导师评估——生意管家
         */
        String GET_SAVE_NEW_WORKER_TRAIN_INFO_BEAN = EnvPort + "/newWorkerTrain/saveNewWorkerTrainInfoBean";
        /**
         * 查询顾问评估
         */
        String GET_QUERY_WORKER_TRAIN_INFO = EnvPort + "/newWorkerTrain/querySWorkerTrainInfo";
        /**
         * 顾问查询自己的培训结果-生意管家
         */
        String GET_QUERY_TRAIN_RESULT = EnvPort + "/newWorkerTrain/queryTrainResult";
        /**
         * get /terminalDisCorrective/findTerminalDisShop 查询终端陈列整改门店
         */
        String FIND_TERMINAL_DISSHOP = EnvPort + "/terminalDisCorrective/findTerminalDisShop";

    }

    /**
     * 特权查询
     */
    interface SYGJ_EWX {
        String EnvPort = "sygj-ewx";
        /**
         * get /salerCare/customerPrivilege 特权查询
         */
        String CUSTOMER_PRIVILEGE = EnvPort + "/salerCare/customerPrivilege";
    }

    interface SYGJ {
        String EnvPort = "sygj";
        /**
         * 权益卡线下购买二维码
         */
        String VOUCHERCARD_OFFLINE_PURCHASE_QRCODE = EnvPort + "/voucherCard/offline/purchase/qrcode";
        /**
         * 权益卡失效延期
         */
        String VOUCHERCARD_FAILURE_POSTPONE = EnvPort + "/voucherCard/failure/postpone";
        /**
         * 发送权益卡二维码短信到手机
         */
        String VOUCHERCARD_SEND_MESSAGE = EnvPort + "/voucherCard/send/message";
        /**
         * 旧手机号获取会员信息
         */
        String MERGE_MEMBER_INFO_OLD_MOBILE = EnvPort + "/merge/member/info/oldMobile/query";
        /**
         * 新手机号获取会员信息
         */
        String MERGE_MEMBER_INFO_NEW_MOBILE = EnvPort + "/merge/member/info/newMobile/query";
        /**
         * 合并会员信息
         */
        String MERGE_MEMBER_INFO_EXECUTE = EnvPort + "/merge/member/info/execute";
        /**
         * 权益卡兑换码或商城订单编号查询购买者信息
         */
        String VOUCHERCARD_USER_INFO = EnvPort + "/voucherCard/userInfo";
        /**
         * 物流专员信息请求对象
         */
        String LOGISTICS_SPECIALIST_LIST = EnvPort + "/app/logistics/specialist/info/list";

    }

    interface CommonApi {
        String EnvPort = "common-api";

        /**
         * 动态参数配置详情
         */
        String DYNAMIC_PARAMETER_INFO = EnvPort + "/dynamic/parameter/info";

    }

    interface CrmApi {
        String EnvPort = "crm-api";
        /**
         * 新增标签信息详情
         */
        String LABEL_DETAIL_SAVE = EnvPort + "/labelDetail/save";

        /**
         * 获取标签列表
         */
        String LABEL_LIST = EnvPort + "/basic/label/option/list";
    }

    interface OrderApi {
        String EnvPort = "order-api";
        /**
         * 根据优惠券码获取用户及券信息
         */
        String QUERY_CUSTOMER_COUPON_BY_EXCHANGE_CODE = EnvPort + "/basic/coupon/queryCustomerCouponByExchangeCode";

    }

    /**
     * 伪造数据接口测试，可以根据自己的地址更改ENV_PORT
     */
    interface EasyMockTest {
//        String ENV_PORT = "https://www.easy-mock.com/mock/59c3593fe0dc663341b2e7da/app-manage";
        /**
         * 测试流动顾问销售完成情况(头部信息)
         */
//        String FLOW_SALES_PERSON_COMPLETION_HEAD = ENV_PORT + "/user/head";
        /**
         * 测试流动顾问销售完成情况(list列表)
         */
//        String FLOW_SALES_PERSON_COMPLETION_LIST = ENV_PORT + "/user/list";
    }
}
