package com.urovo.wugumofang.data;

import android.os.Environment;

import java.io.File;

/**
 * 文件工具类 by Sasuke
 */
public final class FileUtil {
    /**
     * 检测SD卡是否存在
     */
    public static boolean checkSDcard() {
        return Environment.MEDIA_MOUNTED.equals(Environment.getExternalStorageState());
    }

    /**
     * 清空指定目录Dir下的所有文件。
     * @param dir
     */
    public static void deleteAll(File dir) {
        if (!dir.exists()) {
            return;
        } else {
            if (dir.isFile()) {
                dir.delete();
                deleteAll(getDir(dir));//删了本文件之后，还要再把同一个文件夹里的其它文件也带着删一下，前面有防空，不用怕。
                return;
            }
            if (dir.isDirectory()) {
                File[] childFiles = dir.listFiles();
                for (File f : childFiles) {
                    deleteAll(f);
                }
            }
        }
    }

    /**
     * 获取对应文件所在文件夹
     * @return
     */
    public static File getDir(File file){
        return new File(file.getPath().substring(0, file.getPath().lastIndexOf(File.separator)));
    }

}