package com.urovo.wugumofang.net;

import android.content.Context;
import android.os.Build;
import android.webkit.CookieManager;
import android.webkit.CookieSyncManager;

import com.urovo.wugumofang.system.SystemHelper;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.HashMap;

/**
 * Created by Sasuke on 2017/5/23.
 * 通用WebView设置cookie（要加新请求头字段就直接在这里面加就行了）
 */
@SuppressWarnings("deprecation")
public class CookieDominator {
    /**
     * WebView共用的coockie设置。
     */
    public static void setCommonCookie(Context context,String url,String staffId) {
        try {
            CookieManager cookieManager = CookieManager.getInstance();
            if (Build.VERSION.SDK_INT < Build.VERSION_CODES.LOLLIPOP) {
                CookieSyncManager.createInstance(context);
//                cookieManager.removeSessionCookie();// 移除所有过期 cookie
                cookieManager.setAcceptCookie(true);
                cookieManager.setCookie(url, "staffId=" + URLEncoder.encode(staffId, "utf-8"));
                CookieSyncManager.getInstance().sync();
            } else {
//                CookieManager.getInstance().removeSessionCookies(null);// 移除所有过期 cookie
                cookieManager.setAcceptCookie(true);
                cookieManager.setCookie(url, "staffId=" + URLEncoder.encode(staffId, "utf-8"));
                cookieManager.flush();
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
    }

    /**
     * 自定义需要添加到Cookie的值
     */
    public static void setCookie(Context context,String url, HashMap<String, String> params) {
        try {
            CookieManager cookieManager = CookieManager.getInstance();
            if (Build.VERSION.SDK_INT < Build.VERSION_CODES.LOLLIPOP) {
                CookieSyncManager.createInstance(context);
//                cookieManager.removeSessionCookie();// 移除所有过期 cookie
                cookieManager.setAcceptCookie(true);
                for (String key : params.keySet()) {
                    cookieManager.setCookie(url, key + "=" + URLEncoder.encode(params.get(key), "utf-8"));
                }
                CookieSyncManager.getInstance().sync();
            } else {
//                CookieManager.getInstance().removeSessionCookies(null);// 移除所有过期 cookie
                cookieManager.setAcceptCookie(true);
                for (String key : params.keySet()) {
                    cookieManager.setCookie(url, key + "=" + URLEncoder.encode(params.get(key), "utf-8"));
                }
                cookieManager.flush();
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
    }

    /**
     * 把获取到的url的含 {} 字段的给替换掉。
     * @return
     */
    public static String transURL(String urlTemp){
        if(urlTemp.contains("{shopId}")){
            urlTemp = urlTemp.replace("{shopId}", SystemHelper.LoginOrganId);
        }
        if(urlTemp.contains("{staffId}")){
            urlTemp = urlTemp.replace("{staffId}", SystemHelper.LoginUserId);
        }
        if(urlTemp.contains("{name}")){
            urlTemp = urlTemp.replace("{name}", SystemHelper.LoginUserName);
        }
        return urlTemp;
    }
}