package com.urovo.wugumofang.receiver;

import android.accessibilityservice.AccessibilityService;
import android.app.Notification;
import android.app.NotificationManager;
import android.content.Intent;
import android.os.Build;
import androidx.core.app.NotificationCompat;
import android.view.accessibility.AccessibilityEvent;

import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.libutils.R;
import com.urovo.wugumofang.system.BaseAppManager;
import com.zsy.libcore.common.android.log.SYLoger;

import org.greenrobot.eventbus.EventBus;

/**
 * @author chenji
 * 参考链接：http://blog.csdn.net/AndrExpert/article/details/75045678
 */
public class TrackerService extends AccessibilityService {
    //    public static final String TAG = "TrackerService";
//    public static final String COMMAND = "COMMAND";
//    public static final String COMMAND_OPEN = "COMMAND_OPEN";
//    public static final String COMMAND_CLOSE = "COMMAND_CLOSE";
//    TrackerWindowManager mTrackerWindowManager;
    public static final int NOTICE_ID = 100;

    @Override
    public void onCreate() {
        super.onCreate();
        //如果API大于18，需要弹出一个可见通知
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN_MR2) {
            NotificationCompat.Builder builder = new NotificationCompat.Builder(this, AppConstants.NOTI_CHANNEL_ID.HIGH);
            builder.setSmallIcon(R.drawable.ic_launcher);
            builder.setContentTitle("生意管家");
            builder.setContentText("后台服务正在运行中...");
            startForeground(NOTICE_ID, builder.build());
            // 如果觉得常驻通知栏体验不好
            // 可以通过启动CancelNoticeService，将通知移除，oom_adj值不变
//            Intent intent = new Intent(this, CancelNoticeService.class);
//            startService(intent);
        } else {
            startForeground(NOTICE_ID, new Notification());
        }
    }

//    private void initTrackerWindowManager(){
//        if(mTrackerWindowManager == null)
//            mTrackerWindowManager = new TrackerWindowManager(this);
//    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
//        Log.d(TAG, "onStartCommand");
//        initTrackerWindowManager();
//        String command = intent.getStringExtra(COMMAND);
//        if(command != null) {
//            if (command.equals(COMMAND_OPEN))
//                mTrackerWindowManager.addView();
//            else if (command.equals(COMMAND_CLOSE))
//                mTrackerWindowManager.removeView();
//        }
//        return super.onStartCommand(intent, flags, startId);

        // 如果Service被终止  当资源允许情况下，重启service
        return START_STICKY;
    }

    @Override
    public void onInterrupt() {
    }

    @Override
    public void onAccessibilityEvent(AccessibilityEvent event) {
        SYLoger.print("topAct: " + event.getClassName().toString());
        if (event.getEventType() == AccessibilityEvent.TYPE_WINDOW_STATE_CHANGED) {
            EventBus.getDefault().post(new ActivityChangedEvent(
                    event.getPackageName().toString(),
                    event.getClassName().toString()
            ));
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        // 如果Service被杀死，干掉通知
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN_MR2) {
            NotificationManager mManager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
            mManager.cancel(NOTICE_ID);
        }
        // 重启自己
        Intent intent = new Intent(BaseAppManager.appContext(), TrackerService.class);
        startService(intent);
    }

    public static class ActivityChangedEvent {
        private final String mPackageName;
        private final String mClassName;

        public ActivityChangedEvent(String packageName, String className) {
            mPackageName = packageName;
            mClassName = className;
        }

        public String getPackageName() {
            return mPackageName;
        }

        public String getClassName() {
            return mClassName;
        }
    }
}
