package com.urovo.wugumofang.system;

import android.content.Context;
import android.text.TextUtils;

import com.urovo.wugumofang.data.PrefTool;

public class PdaMsgConfig {
    private static String LoginOrganId = null; // 登陆门店\机构号码
    private static String LoginOrganName = null; // 登陆门店名字
    private static boolean IsAdmin = false;// 是否是督导模式
    private static String CheckStoreId = null;// 待验证的门店编号
    private static String gprsServerAddress = null;// GPRS服务地址
    private static String wlanServerAddress = null;// WLAN服务地
    private static String loginUser = null;// 登入人
    private static String LoginUserName = null;// 登入人姓名
    private static String downloadTiem = null;// 下载时间
    private static String uploadTiem = null;// 上传时间
    private static String cleanTime = null;// 清理时间
    private static String password = null;// 密码
    private static boolean ispda; // 是否POS机
    private static boolean isTerminal;// 是否为终端机，需要绑定管理员密码

    // private static String logCompany;// 登入公司
    // private static String LogCompanyCH;//登入站点中文
    // private static String key;// 登入秘钥
    // private static String pdaNumber;//pda编号
    // private static String verString;//版本号
    // private static int maxSignCount;//最大扫描限制
    // private static int signCount;//扫描限制

    /**
     * 获取登入门店ID
     *
     * @param context
     * @return
     */
    public static String getLoginOrgID(Context context) {

        if ("".equals(LoginOrganId) || null == LoginOrganId)
            LoginOrganId = PrefTool.getStringPerferences(context, Prefs.PRE_LOGINORGANId, "");
        return LoginOrganId;
    }

    /**
     * 保存登门店ID
     *
     * @param loginUser
     * @param context
     */
    public static void setLoginOrgID(String loginUser, Context context) {
        PdaMsgConfig.LoginOrganId = loginUser;
        PrefTool.setStringsave(context, Prefs.PRE_LOGINORGANId, loginUser);
    }

    /**
     * 获取登入门店名字
     *
     * @param context
     * @return
     */
    public static String getLoginOrganName(Context context) {

        if ("".equals(LoginOrganName) || null == LoginOrganName)
            LoginOrganName = PrefTool.getStringPerferences(context, Prefs.PRE_LOGINORGANNAME, "");
        return LoginOrganName;
    }

    /**
     * 保存登门店名字
     *
     * @param name
     * @param context
     */
    public static void setLoginOrganName(String name, Context context) {
        PdaMsgConfig.LoginOrganName = name;
        PrefTool.setStringsave(context, Prefs.PRE_LOGINORGANNAME, LoginOrganName);
    }

    /**
     * 获取是否是督导模式：为true表示是督导模式，否则为固定门店模式
     *
     * @param context
     * @return
     */
    public static boolean getIsAdmin(Context context) {
        IsAdmin = PrefTool.getBooleanPreferences(context, Prefs.PRE_ISADMIN, false);
        return IsAdmin;
    }

    /**
     * 保存是否是督导模式：为true表示是督导模式，否则为固定门店模式
     *
     * @param IsAdmin
     * @param context
     */
    public static void setIsAdmin(boolean IsAdmin, Context context) {
        PdaMsgConfig.IsAdmin = IsAdmin;
        PrefTool.setBooleanSave(context, Prefs.PRE_ISADMIN, IsAdmin);
    }

    /**
     * 获取待验证的门店编号
     *
     * @param context
     * @return
     */
    public static String getCheckStoreId(Context context) {

        if ("".equals(CheckStoreId) || null == CheckStoreId)
            CheckStoreId = PrefTool.getStringPerferences(context, Prefs.PRE_CHECKSTOREId, "");
        return CheckStoreId;
    }

    /**
     * 保存待验证的门店编号
     *
     * @param CheckStoreId
     * @param context
     */
    public static void setCheckStoreId(String CheckStoreId, Context context) {
        PdaMsgConfig.CheckStoreId = CheckStoreId;
        PrefTool.setStringsave(context, Prefs.PRE_CHECKSTOREId, CheckStoreId);
    }

    /**
     * 获取GPRS服务地址
     */
    public static String getgprsServerAddress(Context context) {

        if ("".equals(gprsServerAddress) || null == gprsServerAddress)
            gprsServerAddress = PrefTool.getStringPerferences(context, Prefs.PRE_GPRS_SERVER_ADDRESS, "");
        return gprsServerAddress;
    }

    /**
     * 保存GPRS服务地址
     */
    public static void setgprsServerAddress(String gprsServerAddress, Context context) {
        PdaMsgConfig.gprsServerAddress = gprsServerAddress;
        PrefTool.setStringsave(context, Prefs.PRE_GPRS_SERVER_ADDRESS, gprsServerAddress);
    }

    /**
     * 获取GPRS服务地址
     */
    public static String getwlanServerAddress(Context context) {

        if ("".equals(wlanServerAddress) || null == wlanServerAddress)
            wlanServerAddress = PrefTool.getStringPerferences(context, Prefs.PRE_WLAN_SERVER_ADDRESS, "");
        return wlanServerAddress;
    }

    /**
     * 保存GPRS服务地址
     */
    public static void setwlanServerAddress(String wlanServerAddress, Context context) {
        PdaMsgConfig.wlanServerAddress = wlanServerAddress;
        PrefTool.setStringsave(context, Prefs.PRE_WLAN_SERVER_ADDRESS, wlanServerAddress);
    }

    /**
     * 获取登入用户id
     */
    public static String getLogUserId(Context context) {

        if (TextUtils.isEmpty(PdaMsgConfig.loginUser))
            PdaMsgConfig.loginUser = PrefTool.getStringPerferences(context, Prefs.PRE_LOGING_USER, "");
        return loginUser;
    }

    /**
     * 保存登入用户
     */
    public static void setLogUserId(String logString, Context context) {
        PdaMsgConfig.loginUser = logString;
        PrefTool.setStringsave(context, Prefs.PRE_LOGING_USER, logString);
    }

    /**
     * 获取登入用户姓名
     */
    public static String getLoginUserName(Context context) {

        if (TextUtils.isEmpty(PdaMsgConfig.LoginUserName))
            PdaMsgConfig.LoginUserName = PrefTool.getStringPerferences(context, Prefs.PRE_LOGINUSERNAME, "");
        return LoginUserName;
    }

    /**
     * 保存登入用户姓名
     */
    public static void setLoginUserName(String name, Context context) {
        PdaMsgConfig.LoginUserName = name;
        PrefTool.setStringsave(context, Prefs.PRE_LOGINUSERNAME, name);
    }

    /**
     * 获取登入用户身份
     *
     * @return ...
     */
    public static String getLoginUserRole(Context context) {
        return PrefTool.getStringPerferences(context, Prefs.PRE_LOGINUSERROLE, "");
    }

    /**
     * 保存登入用户身份
     *
     * @param loginUserRole （营养顾问，流动营养顾问，店长，督导，兼职）
     */
    public static void setLoginUserRole(Context context, String loginUserRole) {
        PrefTool.setStringsave(context, Prefs.PRE_LOGINUSERROLE, loginUserRole);
    }

    public static String getDataUpdateTime(Context context) {

        String download = PrefTool.getStringPerferences(context, Prefs.DATA_UPDATE, "");
        return download;
    }

    public static void setDataUpdateTime(String time, Context context) {
        PrefTool.setStringsave(context, Prefs.DATA_UPDATE, time);
    }

    /**
     * 获取下载时间
     */
    public static String getDownloadTime(Context context) {

        if (TextUtils.isEmpty(PdaMsgConfig.downloadTiem))
            PdaMsgConfig.downloadTiem = PrefTool.getStringPerferences(context, Prefs.PRE_DOWAN_TIEM, "");
        return PdaMsgConfig.downloadTiem;
    }

    /**
     * 保存下载时间
     */
    public static void setDownloadTime(String time, Context context) {
        PdaMsgConfig.downloadTiem = time;
        PrefTool.setStringsave(context, Prefs.PRE_DOWAN_TIEM, time);
    }

    /**
     * 获取上传时间
     */
    public static String getUpTime(Context context) {

        if (TextUtils.isEmpty(PdaMsgConfig.uploadTiem))
            PdaMsgConfig.uploadTiem = PrefTool.getStringPerferences(context, Prefs.PRE_UP_TIEM, "");
        return PdaMsgConfig.uploadTiem;
    }

    /**
     * 保存上传时间
     */
    public static void setupTime(String time, Context context) {
        PdaMsgConfig.uploadTiem = time;
        PrefTool.setStringsave(context, Prefs.PRE_UP_TIEM, time);
    }

    /**
     * 获取清理时间
     */
    public static String getCleanTime(Context context) {

        if (TextUtils.isEmpty(PdaMsgConfig.cleanTime))
            PdaMsgConfig.cleanTime = PrefTool.getStringPerferences(context, Prefs.PRE_CLEAN_TIEM, "");
        return PdaMsgConfig.cleanTime;
    }

    /**
     * 保存清理时间
     */
    public static void setCleanTime(String time, Context context) {
        PdaMsgConfig.cleanTime = time;
        PrefTool.setStringsave(context, Prefs.PRE_CLEAN_TIEM, time);
    }

    /**
     * 获取密码
     */
    public static String getPassWord(Context context) {

        if (TextUtils.isEmpty(PdaMsgConfig.password))
            PdaMsgConfig.password = PrefTool.getStringPerferences(context, Prefs.PRE_PASSWORD, "");
        return PdaMsgConfig.password;
    }

    /**
     * 保存密码
     */
    public static void setPassWord(String passWord, Context context) {
        PdaMsgConfig.password = passWord;
        PrefTool.setStringsave(context, Prefs.PRE_PASSWORD, passWord);
    }

    /**
     * 获取机型是否i6200S
     */
    public static boolean isPDA(Context context) {

        PdaMsgConfig.ispda = PrefTool.getBooleanPreferences(context, Prefs.IS_PDA, false);
        return PdaMsgConfig.ispda;
    }

    /**
     * 保存机型
     */
    public static void setIsPDA(boolean tag, Context context) {
        PdaMsgConfig.ispda = tag;
        PrefTool.setBooleanSave(context, Prefs.IS_PDA, tag);
    }

    /**
     * @return 获取是否为终端机
     */
    public static boolean isTerminal(Context context) {
        PdaMsgConfig.isTerminal = PrefTool.getBooleanPreferences(context, Prefs.IS_TERMINAL, false);
        return PdaMsgConfig.isTerminal;
    }

    /**
     * 设置是否为终端机
     */
    public static void setIsTerminal(boolean isTerminal, Context context) {
        PdaMsgConfig.isTerminal = isTerminal;
        PrefTool.setBooleanSave(context, Prefs.IS_TERMINAL, isTerminal);
    }
}
