package com.urovo.wugumofang.system;

import android.app.ActivityManager;
import android.content.Context;
import android.text.TextUtils;

import java.util.List;

/**
 *
 * @author Sasuke
 * @date 2016/11/11
 */

public class RunningUtil {
    /**
     * 用来判断APP是在前台还是后台运行
     */
    public static boolean checkForeground(Context context) {
        //获取ActivityManager
        ActivityManager mAm = (ActivityManager) context.getSystemService(Context.ACTIVITY_SERVICE);

        //获得当前运行的task
        assert mAm != null;
        List<ActivityManager.RunningTaskInfo> taskList = mAm.getRunningTasks(1);
        //找到当前应用的task，并启动task的栈顶activity，达到程序切换到前台
        //栈顶若是登陆、找回密码，都判定为“未登陆”
        //true;//在前台   false;//在后台
        return
                taskList != null && !taskList.isEmpty() && taskList.get(0) != null && taskList.get(0).topActivity != null
                        && !TextUtils.isEmpty(taskList.get(0).topActivity.getPackageName())
                        && taskList.get(0).topActivity.getPackageName().equals(context.getPackageName());
    }
}
