package com.urovo.wugumofang.ui;

import android.content.Context;
import android.view.View;
import android.view.inputmethod.InputMethodManager;

public class InputMethodManagerTool {
    private static InputMethodManagerTool inputMethodManagerTool;
    private static InputMethodManager inputMethodManager;

    public InputMethodManagerTool(Context context) {
        if (inputMethodManager == null) {
            inputMethodManager = (InputMethodManager) context.getSystemService(Context.INPUT_METHOD_SERVICE);
        }
    }

    public static InputMethodManagerTool getInstance(Context context) {
        if (inputMethodManagerTool == null) {
            inputMethodManagerTool = new InputMethodManagerTool(context);
        }
        return inputMethodManagerTool;
    }

    /**
     * 获取输入法打开状态
     *
     * @return
     */
    public boolean getInputMethodState() {
        return inputMethodManager.isActive();
    }

    /**
     * 调用显示系统默认的输入法方法一
     */
    public void getInputMethod(View view) {
        inputMethodManager.showSoftInput(view, InputMethodManager.SHOW_FORCED);
    }

    /**
     * 这个方法可以实现输入法在窗口上切换显示，如果输入法在窗口上已经显示，则隐藏，如果隐藏，则显示输入法到窗口上)
     */
    public void hideOrShowInputMethod() {
        inputMethodManager.toggleSoftInput(0, InputMethodManager.HIDE_NOT_ALWAYS);
        // inputMethodManager.getInputMethodList();
    }

    /**
     * 调用屏蔽系统默认的输入法
     */
    public void hideInputMethod(View view) {
        inputMethodManager.hideSoftInputFromWindow(view.getWindowToken(), 0);

    }
}
