package com.urovo.wugumofang.utils

import android.app.Activity
import android.app.AlertDialog
import android.content.*
import android.net.Uri
import android.os.Build
import android.os.Environment
import android.provider.MediaStore
import android.provider.Settings
import androidx.core.content.FileProvider
import com.hjq.permissions.OnPermission
import com.hjq.permissions.XXPermissions
import java.io.File


/**
 * @author Sasuke on 2019-04-12 0012.
 * 去你妈的谷歌适配！！！
 *
 * 以后新版安卓需要适配的新特性的东西就都封装在这里吧。。。
 *
 * 坑好多
 */
class FuckGoogleAdaptUtil {

    companion object {
        @JvmStatic
        fun grantPermissions(activity: Activity) {
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
                if (Build.VERSION.SDK_INT > 32) {
                    requestPresenter(activity, PermissionsCheckerUtil.NEWPERMISSIONS)
                } else {
                    requestPresenter(activity, PermissionsCheckerUtil.PERMISSIONS)
                }
            }
        }

        /**
         * 获取权限
         */
        fun requestPresenter(activity: Activity, permissions: Array<String>) {
            XXPermissions.with(activity)
                .constantRequest() //可设置被拒绝后继续申请，直到用户授权或者永久拒绝
                //.permission(Permission.SYSTEM_ALERT_WINDOW, Permission.REQUEST_INSTALL_PACKAGES) //支持请求6.0悬浮窗权限8.0请求安装权限
                //                    .permission(Permission.Group.STORAGE, Permission.Group.CALENDAR) //不指定权限则自动获取清单中的危险权限
                .permission(permissions)
                .request(object : OnPermission {
                    override fun hasPermission(granted: List<String>, isAll: Boolean) {}

                    override fun noPermission(denied: List<String>, quick: Boolean) {
                        if (quick) {
                            AlertDialog.Builder(activity).setTitle("提示")
                                .setMessage("为保证生意管家的正常运行，请打开相应权限")
                                .setPositiveButton("去打开") { dialog, which ->
                                    XXPermissions.gotoPermissionSettings(
                                        activity
                                    )
                                }
                                .show()
                        }
                    }
                })
        }


        /**
         * Android 7 适配Uri
         */
        @JvmStatic
        fun android7AdaptUri(context: Context, auth: String, file: File): Uri {
            if (Build.VERSION.SDK_INT < Build.VERSION_CODES.N) {
                return Uri.fromFile(file)
            } else {
                return FileProvider.getUriForFile(context, auth, file)
            }
        }

        /**
         * Android 10 适配Uri
         */
        @JvmStatic
        fun android10AdaptUri(context: Context, filePath: String): Uri? {
            //设置保存参数到ContentValues中
            val contentValues = ContentValues()
            //设置文件名
            //contentValues.put(
            //    MediaStore.Images.Media.DISPLAY_NAME,
            //    System.currentTimeMillis().toString() + ""
            //)
            //android Q中不再使用DATA字段，而用RELATIVE_PATH代替
            //RELATIVE_PATH是相对路径不是绝对路径;照片存储的地方为：内部存储/Pictures/preventpro
            contentValues.put(MediaStore.Images.Media.DATA, filePath)
            //设置文件类型
            contentValues.put(MediaStore.Images.Media.MIME_TYPE, "image/JPEG")
            //执行insert操作，向系统文件夹中添加文件
            //EXTERNAL_CONTENT_URI代表外部存储器，该值不变
            return context.contentResolver.insert(
                MediaStore.Images.Media.EXTERNAL_CONTENT_URI,
                contentValues
            )
        }

        @JvmStatic
        fun android10AdaptUri(context: Context): Uri? {
            val status = Environment.getExternalStorageState()
            // 判断是否有SD卡,优先使用SD卡存储,当没有SD卡时使用手机存储
            return if (status == Environment.MEDIA_MOUNTED) {
                context.contentResolver.insert(
                    MediaStore.Images.Media.EXTERNAL_CONTENT_URI,
                    ContentValues()
                )
            } else {
                context.contentResolver.insert(
                    MediaStore.Images.Media.INTERNAL_CONTENT_URI,
                    ContentValues()
                )
            }
        }

        //。。。我就直接让7.0以下的都不用这个WRITE_SETTINGS权限得了。。。
        @JvmStatic
        fun android6WriteSettings(context: Context) {
            try {
                context.startActivity(Intent(Settings.ACTION_MANAGE_WRITE_SETTINGS).apply {
                    setData(Uri.parse("package:" + context.getPackageName()))
                })
            } catch (e: ActivityNotFoundException) {

            }
        }

        /**
         * 安卓6.0上要单独申请Uri权限，要不然相机要自杀。
         */
//    fun grantFuckUriPermission(context: Context,intent: Intent,uri: Uri,writable: Boolean){
//        var flag = Intent.FLAG_GRANT_READ_URI_PERMISSION
//        if (writable){
//            flag = Intent.FLAG_GRANT_READ_URI_PERMISSION and Intent.FLAG_GRANT_WRITE_URI_PERMISSION
//        }
//        intent.addFlags(flag)
//        context.getPackageManager().queryIntentActivities(intent,PackageManager.MATCH_DEFAULT_ONLY).forEach {
//            context.grantUriPermission(it.activityInfo.packageName,uri,flag)
//        }
//    }


        /**
         * 把Uri路径转成真实路径（谷歌你他妈烦不烦！
         */
        @JvmStatic
        fun getRealFilePath(context: Context, uri: Uri): String {
            val scheme = uri.getScheme()
            var data = ""
            if (scheme == null) {
                data = uri.getPath() ?: ""
            } else if (ContentResolver.SCHEME_FILE.equals(scheme)) {
                data = uri.getPath() ?: ""
            } else if (ContentResolver.SCHEME_CONTENT.equals(scheme)) {
                val cursor = context.getContentResolver()
                    .query(uri, arrayOf(MediaStore.Images.ImageColumns.DATA), null, null, null);
                if (null != cursor) {
                    if (cursor.moveToFirst()) {
                        val index = cursor.getColumnIndex(MediaStore.Images.ImageColumns.DATA)
                        if (index > -1) {
                            data = cursor.getString(index)
                        }
                    }
                    cursor.close()
                }
            }
            return data
        }
    }
}