package com.urovo.wugumofang.utils

import android.content.Context
import android.text.TextUtils
import android.widget.Toast
import com.urovo.wugumofang.constants.Files
import com.urovo.wugumofang.data.GZIPUtils
import com.urovo.wugumofang.data.JsonDominator
import com.zsy.libext.widgets.clipboard.ClipboardUtil
import java.io.File

/**
 * @author Sasuke on 2019/4/11.
 * 把最新崩溃日志拷贝到剪切板，供问题反馈
 */
object LogReaderUtil {
    fun copyLog2Clipboard(context: Context){
        val logFile = File(Files.logfile)
        val log = JsonDominator.readTextFromFile(logFile){
            it.getName().endsWith(".log");//如果为true，就过滤掉。
        }

        if (!TextUtils.isEmpty(log)) {
            ClipboardUtil.copyText(context, GZIPUtils.zip(log))// 复制到系统的剪切板
            Toast.makeText(context,"LOG复制成功！",Toast.LENGTH_LONG).show()
        }else{
            Toast.makeText(context,"LOG为空，复制失败",Toast.LENGTH_LONG).show()
        }
    }
}