package com.urovo.wugumofang.view.webview;

import android.content.Context;
import android.os.Bundle;
import android.webkit.WebViewClient;


import com.urovo.wugumofang.net.CookieDominator;

import java.util.HashMap;

/**
 * Created by Sasuke on 2017/5/23.
 * 带添加Cookie的WebView（组件化工具）
 */

public class BaseCookieWebFra extends BaseWebFra {
    /**
     * 启动一个带单个cookie的webView
     *
     * @param context      ...
     * @param url          H5页面链接
     * @param staffId      单个cookie 值
     * @param title        webView标题
     * @param isShowBottom ...
     */
    public static void launch(Context context,
                              String url,
                              String staffId,
                              String title,
                              Boolean isShowBottom) {
        CookieDominator.setCommonCookie(context, url, staffId);//添加单个cookie
        BaseWebFra.launch(context, url, title, isShowBottom);
    }

    /**
     * 启动一个带多个cookie的webView
     */
    public static void launch(Context context,
                              String url,
                              HashMap<String, String> params,
                              String title, Boolean isShowBottom) {
        CookieDominator.setCookie(context, url, params);//添加多个cookie
        BaseWebFra.launch(context, url, title, isShowBottom);
    }

    public static void launch(Context context,
                              String url,
                              String staffId,
                              String title,
                              Boolean isShowBottom,
                              WebViewClient newWebViewClient) {
        CookieDominator.setCommonCookie(context, url, staffId);//添加单个cookie
        BaseWebFra.launch(context, url, title, isShowBottom, newWebViewClient);
    }

    public static void launch(Context context,
                              String url,
                              HashMap<String, String> params,
                              String title,
                              Boolean isShowBottom,
                              WebViewClient newWebViewClient) {
        CookieDominator.setCookie(context, url, params);//添加多个cookie
        BaseWebFra.launch(context, url, title, isShowBottom, newWebViewClient);
    }

    @SuppressWarnings("all")
    public static Bundle webContainerBundle(Context context,
                                            String url,
                                            String staffId,
                                            String title,
                                            Boolean isShowBottom) {
        CookieDominator.setCommonCookie(context, url, staffId);//添加单个cookie
        return BaseWebFra.webContainerBundle(url, title, isShowBottom);
    }

    public static Bundle webContainerBundleShare(Context context,
                                            String url,
                                            String staffId,
                                            String title,
                                            Boolean isShowShareBtn) {//新增了”是否显示顶栏分享按钮“
        CookieDominator.setCommonCookie(context, url, staffId);//添加单个cookie
        return BaseWebFra.webContainerBundleShare(url, title, isShowShareBtn);
    }

    public static Bundle webContainerBundle(Context context,
                                            String url,
                                            HashMap<String, String> params,
                                            String title,
                                            Boolean isShowBottom) {
        CookieDominator.setCookie(context, url, params);//添加多个cookie
        return BaseWebFra.webContainerBundle(url, title, isShowBottom);
    }
}
