package com.urovo.wugumofang.view.webview;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.webkit.DownloadListener;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;

import com.urovo.wugumofang.utils.JSJumpUtil;
import com.zsy.libcore.common.other.NetUtil;
import com.zsy.libcore.ui.fra.FragmentArgs;
import com.zsy.libext.R;
import com.zsy.libext.ui.fra.BaseFra;
import com.zsy.libext.widgets.tips.ToastMsg;
import com.zsy.libext.widgets.webview.CustomWebView;
import com.zsy.libext.widgets.webview.WebViewUtil;

/**
 * 单个H5界面
 *
 * @author samy
 * @date 16/4/20
 */
public class BaseWebFra extends BaseFra {
    //    因在library不能用butterknife;还没有找到原因；
    //        @Bind(R.id.web_view_cwv)
    CustomWebView webViewCwv;
    //    @Bind(R.id.web_view_pb)
    ProgressBar webViewPb;
    //    @Bind(R.id.web_view_parent_rl)
    RelativeLayout webViewParentRl;
    //    @Bind(R.id.nav_bar_back_ibtn)
    ImageButton navBarBackIbtn;
    //    @Bind(R.id.nav_bar_forword_ibtn)
    ImageButton navBarForwordIbtn;
    //    @Bind(R.id.nav_bar_reload_ibtn)
    ImageButton navBarReloadIbtn;
    //    @Bind(R.id.nav_bar_close_ibtn)
    ImageButton navBarCloseIbtn;
    //    @Bind(R.id.nav_bar_bottom_rl)
    RelativeLayout navBarBottomRl;
    //    @Bind(R.id.nav_bar_load_pb)
    ProgressBar navBarLoadPb;
    //    @Bind(R.id.nav_bar_root_ll)
    LinearLayout navBarRootLl;

    private String webDefaultUrl = "http://www.baidu.com/";
    private String webUrl;
    private String webTitle;
    private boolean isShowBottom;
    //    后续安需求做成可以配置的
    private static WebViewClient newwebViewClient;
    private CustomWebViewClient customWebViewClient;
    private String currentWebUrl;

    public static void launch(Context context, String url, String title, Boolean isShowBottom) {
        FragmentArgs args = new FragmentArgs();
        args.add("url", url);
        args.add("title", title);
        args.add("isShowBottom", isShowBottom);
        FraContainerAct.launch(context, BaseWebFra.class, args, false);
    }

    public static void launch(Context context, String url, String title, Boolean isShowBottom,
                              WebViewClient newwebViewClient) {
        FragmentArgs args = new FragmentArgs();
        args.add("url", url);
        args.add("title", title);
        args.add("isShowBottom", isShowBottom);
        BaseWebFra.newwebViewClient = newwebViewClient;
        FraContainerAct.launch(context, BaseWebFra.class, args, false);
    }

    /**
     * 局部复杂调用;Activity传递数据到Fragment
     */
    public static Bundle webContainerBundle(String url, String title, Boolean isShowBottom) {
        Bundle bundle = new Bundle();
        bundle.putString("url", url);
        bundle.putString("title", title);
        bundle.putBoolean("isShowBottom", isShowBottom);
        return bundle;
    }

    /**
     * 局部复杂调用;Activity传递数据到Fragment
     */
    public static Bundle webContainerBundleShare(String url, String title,Boolean isShowShareBtn) {
        Bundle bundle = new Bundle();
        bundle.putString("url", url);
        bundle.putString("title", title);
        bundle.putBoolean("isShowBottom", true);//其实是不显示底栏（后面逻辑反了），在显示顶栏分享按钮的情况下，就让它默认不显示底栏算了
        bundle.putBoolean("isShowShareBtn",isShowShareBtn);
        return bundle;
    }

    @Override
    protected void getBundleExtras(Bundle extras) {
        super.getBundleExtras(extras);
        webUrl = extras.getString("url");
        webTitle = extras.getString("title");
        isShowBottom = extras.getBoolean("isShowBottom");
    }

    @SuppressLint("JavascriptInterface")
    @Override
    protected void initWidgetsAndEvents(View rootView) {
        //    因在library不能用butterknife;
        webViewCwv = (CustomWebView) rootView.findViewById(R.id.web_view_cwv);
        webViewPb = (ProgressBar) rootView.findViewById(R.id.web_view_pb);
        webViewParentRl = (RelativeLayout) rootView.findViewById(R.id.web_view_parent_rl);
        navBarBackIbtn = (ImageButton) rootView.findViewById(R.id.nav_bar_back_ibtn);
        navBarForwordIbtn = (ImageButton) rootView.findViewById(R.id.nav_bar_forword_ibtn);
        navBarReloadIbtn = (ImageButton) rootView.findViewById(R.id.nav_bar_reload_ibtn);
        navBarCloseIbtn = (ImageButton) rootView.findViewById(R.id.nav_bar_close_ibtn);
        navBarBottomRl = (RelativeLayout) rootView.findViewById(R.id.nav_bar_bottom_rl);
        navBarLoadPb = (ProgressBar) rootView.findViewById(R.id.nav_bar_load_pb);
        navBarRootLl = (LinearLayout) rootView.findViewById(R.id.nav_bar_root_ll);

        navBarBackIbtn.setOnClickListener(this);
        navBarForwordIbtn.setOnClickListener(this);
        navBarReloadIbtn.setOnClickListener(this);
        navBarCloseIbtn.setOnClickListener(this);

        //用于JS跳转原生的设置。
        webViewCwv.addJavascriptInterface(new JSJumpUtil(),"JSJump");

        if (TextUtils.isEmpty(webUrl)) {
            webUrl = webDefaultUrl;
        }
        if (isShowBottom) {//あれ？？？？怎么这逻辑是反的？？算了先这样吧
            navBarRootLl.setVisibility(View.GONE);
        }
        baseAct.commonToolbar.setTitle(webTitle);
        webViewCwv.loadUrl(webUrl);
        //默认不能点击
        navBarForwordIbtn.setEnabled(false);
        webViewCwv.setCanTouchZoom(false);

        WebViewUtil.hideBuiltInZoomControls(webViewCwv);

        //清除缓存
        webViewCwv.getSettings().setCacheMode(WebSettings.LOAD_NO_CACHE);

        //加了一条注释
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {//自动化测试H5内容需要
            WebView.setWebContentsDebuggingEnabled(true);
        }

        // 下载
        webViewCwv.setDownloadListener(new DownloadListener() {
            @Override
            public void onDownloadStart(String url, String userAgent, String contentDisposition,
                                        String mimetype, long contentLength) {
                Uri uri = Uri.parse(url);
                Intent intent = new Intent(Intent.ACTION_VIEW, uri);
                startActivity(intent);
            }
        });
        //如果有传自定义的新webViewClient进来 ，就用新的，否则就用预设的customWebViewClient
        if (newwebViewClient != null) {
            webViewCwv.setWebViewClient(newwebViewClient);
        } else {
            customWebViewClient = new CustomWebViewClient(BaseWebFra.this);
            webViewCwv.setWebViewClient(customWebViewClient);
        }
        webViewCwv.setWebChromeClient(new WebChromeClient() {
            @Override
            public void onReceivedTitle(WebView view, String mTitle) {
                super.onReceivedTitle(view, mTitle);
                if (TextUtils.isEmpty(webTitle)) {
                    if (getActivity() instanceof WebContainerAct) {
                        ((WebContainerAct) getActivity()).updateWebTitle(mTitle);
                    } else {
                        //如果没有传递title就用窃取的title
                        baseAct.commonToolbar.setTitle(mTitle);
                    }
                }
            }

            @Override
            public void onProgressChanged(WebView view, int newProgress) {
                webViewPb.setProgress(newProgress);
                if (newProgress == 100) {
                    webViewPb.setVisibility(View.GONE);
                }
                // 进度条
                super.onProgressChanged(view, newProgress);
                navBarLoadPb.setProgress(newProgress);
            }
        });

        //webViewCwv.setOnKeyListener(new View.OnKeyListener() {
        //  @Override public boolean onKey(View v, int keyCode, KeyEvent event) {
        //    if (event.getAction() == KeyEvent.ACTION_DOWN) {
        //      WebView webView = (WebView) v;
        //      switch (keyCode) {
        //        case KeyEvent.KEYCODE_BACK:
        //          if (webView.canGoBack()) {
        //            webView.goBack();
        //            return true;
        //          }else {
        //            getActivity().finish();
        //          }
        //          break;
        //      }
        //    }
        //    return false;
        //  }
        //});
    }

    @Override
    protected View getLoadingTargetView() {
        return null;
    }

    @Override
    protected int getContentViewLayoutID() {
        return R.layout.fra_base_web_view;
    }

    //@Override public void initPresenter() {
    //
    //}

    /**
     * 显示进度
     */
    private void showLoadingProgress() {
        if (webViewPb.getVisibility() == View.GONE) {
            webViewPb.setVisibility(View.VISIBLE);
        }
    }

    /**
     * 隐藏进度
     */
    private void hideLoadingProgress() {
        if (webViewPb.getVisibility() == View.VISIBLE) {
            webViewPb.setVisibility(View.GONE);
        }
    }

    private void updataUI(WebView view) {
        navBarBackIbtn.setEnabled(view.canGoBack());
        navBarForwordIbtn.setEnabled(view.canGoForward());
    }

    public void onReceivedError() {
        // showLoading();
        // loading_tip_tv.setText(R.string.loading_errors_hint);
        hideLoadingProgress();
    }

    /**
     * 关闭按钮
     */
    public void onCloseClick() {
        webViewCwv.stopLoading();
        if (webViewCwv.canGoBack()) {
            webViewCwv.goBack();
        }
    }

    /**
     * 刷新按钮
     */
    public void onReloadUrlClick() {
        webViewPb.setVisibility(View.VISIBLE);
        webViewPb.setProgress(0);
        if (NetUtil.isNetworkAvailable(getActivity())) {
            webViewCwv.reload();
            // if (loadingParentView.getVisibility() == View.VISIBLE) {
            // loading_tip_tv.setText(R.string.loading_progress_hint);
            // }
        } else {
            ToastMsg.showToastMsg(getActivity(), "当前网络不可用");
        }
    }

    /**
     * @description：后退按钮
     * @author samy
     * @date 2014年8月14日 下午2:19:07
     */
    public void onBackwordUrlClick() {
        webViewCwv.stopLoading();
        if (webViewCwv.canGoBack()) {
            webViewCwv.goBack();
        }
    }

    /**
     * 前进按钮
     */
    public void onForwordUrlClick() {
        webViewCwv.stopLoading();
        if (webViewCwv.canGoForward()) {
            webViewCwv.goForward();
        }
    }

    //    library中不能用switch;
    @Override
    public void widgetsClick(View v) {
        super.widgetsClick(v);
        if (v.getId() == R.id.nav_bar_back_ibtn) {
            onBackwordUrlClick();
        } else if (v.getId() == R.id.nav_bar_forword_ibtn) {
            onForwordUrlClick();
        } else if (v.getId() == R.id.nav_bar_reload_ibtn) {
            onReloadUrlClick();
        } else if (v.getId() == R.id.nav_bar_close_ibtn) {
            onCloseClick();
        }
        //        switch (v.getId()) {
        //            case R.id.nav_bar_back_ibtn:
        //                onBackwordUrlClick();
        //                break;
        //            case R.id.nav_bar_forword_ibtn:
        //                onForwordUrlClick();
        //                break;
        //            case R.id.nav_bar_reload_ibtn:
        //                onReloadUrlClick();
        //                break;
        //            case R.id.nav_bar_close_ibtn:
        //                onCloseClick();
        //                break;
        //        }
    }

    //    @OnClick({R.id.nav_bar_back_ibtn, R.id.nav_bar_forword_ibtn, R.id.nav_bar_reload_ibtn, R.id.nav_bar_close_ibtn})
    //    public void onClick(View view) {
    //        switch (view.getId()) {
    //            case R.id.nav_bar_back_ibtn:
    //                onBackwordUrlClick();
    //                break;
    //            case R.id.nav_bar_forword_ibtn:
    //                onForwordUrlClick();
    //                break;
    //            case R.id.nav_bar_reload_ibtn:
    //                onReloadUrlClick();
    //                break;
    //            case R.id.nav_bar_close_ibtn:
    //                onCloseClick();
    //                break;
    //        }
    //    }

    public void onPageStarted(WebView view, String url) {
        updataUI(view);
        showLoadingProgress();
    }

    public void onPageFinished(WebView view, String url) {
        updataUI(view);
        hideLoadingProgress();
    }

    public void shouldOverrideUrlLoading(WebView view, String url) {
        updataUI(view);
    }

    public WebView getWebView() {
        return webViewCwv;
    }

    public String getWebUrl() {
        return customWebViewClient.getCurrentWebUrl();
    }

    @Override
    public void setPresenter(Object o) {

    }


    /**
     * @Override public void onBackPressed()
     * {
     * if(webView.canGoBack()){
     * webView.goBack();
     * }else{
     * new AlertDialog.Builder(this)
     * .setIcon(android.R.drawable.ic_dialog_alert)
     * .setTitle("Exit!")
     * .setMessage("Are you sure you want to close?")
     * .setPositiveButton("Yes", new DialogInterface.OnClickListener()
     * {
     * @Override public void onClick(DialogInterface dialog, int which) {
     * finish();
     * }
     *
     * })
     * .setNegativeButton("No", null)
     * .show();
     * }
     * }
     */
}


