package com.zsy.libcore.event;


import org.greenrobot.eventbus.EventBus;

/**
 * 统一管理发送 EventBus控制
 *
 * @author: samy(hongfeiliuxing@gmail.com)
 * @datetime: 2015-09-03 12:57
 */
public class EventManager {
    private static EventManager mInstance = null;

    public synchronized static EventManager getInstance() {
        if (mInstance == null) {
            mInstance = new EventManager();
        }
        return mInstance;
    }

    /**
     * 登录结果事件
     */
    public void postLoginResultEvent(LoginResultEvent mEvent) {
        EventBus.getDefault().post(mEvent);
    }

    /**
     * 消息中心里的各标签更新未读数
     */
    public void postMsgCenterCount(MsgCount msgCount){
        EventBus.getDefault().post(msgCount);
    }
}
