package com.zsy.libcore.ui.ada;

import android.text.TextUtils;
import android.widget.Filter;
import java.util.ArrayList;
import java.util.List;

/**
 * @author samy
 * @description：自定义的（筛选、搜索）过滤器
 * @date 2015-3-24 下午4:39:44
 */
public class BaseAdaFilter<E> extends Filter {
	protected List<E> mDataSet = null;
	protected List<E> mDataSetUp = null;
	private BaseAda<E> baseAda;

	public BaseAdaFilter(BaseAda<E> baseAda) {
		super();
		this.baseAda = baseAda;
	}

	@Override
	protected FilterResults performFiltering(CharSequence prefix) {
		FilterResults results = new FilterResults();
		List<E> groups = null;
		if (TextUtils.isEmpty(prefix)) {
			groups = mDataSetUp;
			results.values = groups;
			results.count = groups.size();
		}
		else {
			final List<E> oldGroups = mDataSetUp;
			final int count = oldGroups.size();
			final List<E> newGroups = new ArrayList<E>();
			for (int i = 0; i < count; i++) {
				if (oldGroups.get(i).toString().toLowerCase().contains(prefix.toString().toLowerCase())) {
					newGroups.add(oldGroups.get(i));
				}
			}
			results.values = newGroups;
			results.count = newGroups.size();
		}
		return results;
	}

	@Override
	protected void publishResults(CharSequence constraint, FilterResults results) {
		// baseAda.setGroup( (ArrayList<T>) results.values);
		baseAda.mDataSet = (ArrayList<E>) results.values;
		if (results.count > 0) {
			baseAda.notifyDataSetChanged();
		}
		else {
			baseAda.notifyDataSetInvalidated();
		}
	}
}