package com.zsy.libcore.ui.ada.quickadapter;

import android.view.View;
import android.view.ViewGroup;
import java.util.ArrayList;
import java.util.List;

/**
 * 最常规的Adapter 不需要实现ISelectable(选中状态，多类型item)
 * 可用于业务类型 为String Object
 */
public abstract class ObjQuickAdapter<T> extends BaseQuickAdapter<T, BaseAdapterHelper> {
	// private SelectHelper<T> mSelectHelper;

	/**
	 * Same as QuickAdapter#QuickAdapter(Context,int) but with some
	 * initialization data.
	 *
	 * @param layoutResId The layout resource id of each item.
	 * @param data A new list is created out of this one to avoid mutable list
	 */
	public ObjQuickAdapter(int layoutResId, List<T> data) {
		this(layoutResId, data, ISelectable.SELECT_MODE_SINGLE);
	}

	public ObjQuickAdapter(int layoutResId, List<T> data, int selectMode) {
		super(layoutResId, data);
	}

	public ObjQuickAdapter(ArrayList<T> data, MultiItemTypeSupport<T> multiItemSupport) {
		super(data, multiItemSupport);
	}

	@Override
	protected BaseAdapterHelper getAdapterHelper(int position, View convertView, ViewGroup parent) {
		if (mMultiItemSupport != null) {
			return BaseAdapterHelper.get(convertView, parent, mMultiItemSupport.getLayoutId(position, data.get(position)), position);
		}
		else {
			return BaseAdapterHelper.get(convertView, parent, layoutResId, position);
		}
	}
}
