package com.zsy.libcore.view;

import android.view.View;

/**
 * 覆盖物(一般用在加载网络数据时用到)
 *
 * @author samy(hongfeiliuxing @ gmail.com)
 *  2015-09-12 18:23
 */
public interface BaseView<P> extends BaseAppCompatView<P> {
    /**
     * 加载中
     */
    void showLoading(String msg);

    /**
     * 关闭加载
     */
    void hideLoading();

    /**
     * 空数据情况
     */
    void showEmpty(String msg, View.OnClickListener onClickListener);

    /**
     * 空数据情况，点击事件和设置图片
     */
    void showEmpty(String msg, View.OnClickListener onClickListener, int imageId);

    /**
     * 错误
     */
    void showError(String msg, View.OnClickListener onClickListener);

    /**
     * 网络问题
     */
    void showNetError(View.OnClickListener onClickListener);
}
