package com.zsy.libext.model.perfer;

import com.zsy.libcore.LibCoreApp;
import com.zsy.libext.LibExtApp;

import android.content.SharedPreferences;

/**
 * LibPrefer
 *
 * @author samy
 * @date 2014年9月17日 下午6:30:24
 */
public class LibExtPrefer {
//	public static final String NAME = BuildConfig.APPLICATION_ID + LibExtPrefer.class.getSimpleName();
	public static final String NAME = LibCoreApp.PACKAGE_NAME + LibExtPrefer.class.getSimpleName();
	private static SharedPreferences sp;
	private static SharedPreferences.Editor editor;
	private static LibExtPrefer mInstance;
	/** 主题 */
	public static final String CURRENT_THEME_KEY = "CURRENT_THEME_KEY";

	/** 语言 */
	public static final String CURRENT_LANGUAGE_KEY = "CURRENT_LANGUAGE_KEY";

	/** 语言对应的国家 */
	public static final String CURRENT_LANGUAGE_COUNTRY_KEY = "CURRENT_LANGUAGE_COUNTRY_KEY";

	/** 沉浸式 */
	public static final String USE_TRANSLUCENT_KEY = "USE_TRANSLUCENT_KEY";
	/** 是否是第一次启动 */
	public static final String IS_FIRST_LAUNCH_KEY = "IS_FIRST_LAUNCH_KEY";

	private LibExtPrefer() {
		sp = LibExtApp.getInstance().getSharedPreferences(NAME, 0);
		editor = sp.edit();
	}

	// 增加了双重判断
	public static LibExtPrefer getInstance() {
		if (null == mInstance) {
			synchronized (LibExtPrefer.class) {
				if (null == mInstance) {
					mInstance = new LibExtPrefer();
				}
			}
		}
		return mInstance;
	}

	/**
	 * 储存值
	 */
	public void setString(String key, String value) {
		editor.putString(key, value).commit();
	}

	public void setInt(String key, int value) {
		editor.putInt(key, value).commit();
	}

	public void setLong(String key, long value) {
		editor.putLong(key, value).commit();
	}

	public void setBoolean(String key, boolean value) {
		editor.putBoolean(key, value).commit();
	}

	/**
	 * 获取值
	 */
	public String getString(String key) {
		return sp.getString(key, "");
	}

	public int getInt(String key) {
		return sp.getInt(key, -1);
	}

	public long getLong(String key) {
		return sp.getLong(key, 1);
	}

	public boolean getBoolean(String key, boolean defaultValue) {
		return sp.getBoolean(key, defaultValue);
	}

	/**
	 * @description：移除特定的
	 * @date 2014年11月5日 下午4:30:08
	 */
	public void remove(String name) {
		editor.remove(name).commit();
	}
}
