package com.zsy.libext.ui.act;

import com.zsy.libext.ui.act.swipeback.SwipeBackActivityBase;
import com.zsy.libext.ui.act.swipeback.SwipeBackActivityHelper;
import com.zsy.libext.ui.act.swipeback.SwipeBackLayout;
import com.zsy.libext.ui.act.swipeback.Utils;

import android.os.Bundle;
import android.view.View;

/**
 * 带滑动销毁的基类,这个后期处理跟左右切换页面相关
 *
 * @author: samy(hongfeiliuxing@gmail.com)
 * @datetime: 2015-09-03 22:30
 */
public abstract class BaseSwipeBackAct extends BaseAct implements SwipeBackActivityBase {
	private SwipeBackActivityHelper mHelper;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		mHelper = new SwipeBackActivityHelper(this);
		mHelper.onActivityCreate();
	}

	@Override
	public View findViewById(int id) {
		View v = super.findViewById(id);
		if (v == null && mHelper != null) return mHelper.findViewById(id);
		return v;
	}

	@Override
	public SwipeBackLayout getSwipeBackLayout() {
		return mHelper.getSwipeBackLayout();
	}

	@Override
	public void setSwipeBackEnable(boolean enable) {
		getSwipeBackLayout().setEnableGesture(enable);
	}

	@Override
	public void scrollToFinishActivity() {
		Utils.convertActivityToTranslucent(this);
		getSwipeBackLayout().scrollToFinishActivity();
	}
}
