package com.zsy.libext.ui.fra;

import android.view.View;

import com.zsy.libcore.view.BaseListView;
import com.zsy.libext.R;
import com.zsy.libext.widgets.LoadMoreListView;

import java.util.ArrayList;
import java.util.List;

import androidx.swiperefreshlayout.widget.SwipeRefreshLayout;

/**
 * @author: samy(hongfeiliuxing@gmail.com)
 * @datetime: 2015-09-12 17:52
 */
public abstract class BaseListFra<E,P> extends BaseFra<P> implements BaseListView<E,P>,LoadMoreListView.OnLoadMoreListener, SwipeRefreshLayout.OnRefreshListener {
	final protected List<E> mDataSet = new ArrayList<E>();
	protected SwipeRefreshLayout mSwipeRefreshLayout;
	// @InjectView(R.id.common_swipe_refresh_list_view)
	protected LoadMoreListView mLoadMoreListView;

	@Override
	protected void initWidgetsAndEvents(View rootView) {
		mSwipeRefreshLayout = (SwipeRefreshLayout) rootView.findViewById(R.id.common_swipe_refresh_layout);
		mLoadMoreListView = (LoadMoreListView) rootView.findViewById(R.id.common_swipe_refresh_list_view);
		mSwipeRefreshLayout.setOnRefreshListener(this);
		mLoadMoreListView.setOnLoadMoreListener(this);
	}

	@Override
	protected View getLoadingTargetView() {
		return mSwipeRefreshLayout;
	}

	@Override
	protected int getContentViewLayoutID() {
		return R.layout.fra_base_swiperefresh;
	}
}
