package com.zsy.libext.widgets.dialog.effectsdialog;


import com.zsy.libext.widgets.dialog.effectsdialog.effects.BaseEffects;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.FadeIn;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.FlipH;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.FlipV;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.NewsPaper;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.SideFall;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.SlideLeft;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.SlideRight;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.SlideTop;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.SlideBottom;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.Fall;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.RotateBottom;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.RotateLeft;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.Slit;
import com.zsy.libext.widgets.dialog.effectsdialog.effects.Shake;


public enum Effectstype {

  Fadein(FadeIn.class),
  Slideleft(SlideLeft.class),
  Slidetop(SlideTop.class),
  SlideBottom(SlideBottom.class),
  Slideright(SlideRight.class),
  Fall(Fall.class),
  Newspager(NewsPaper.class),
  Fliph(FlipH.class),
  Flipv(FlipV.class),
  RotateBottom(RotateBottom.class),
  RotateLeft(RotateLeft.class),
  Slit(Slit.class),
  Shake(Shake.class),
  Sidefill(SideFall.class);
  private Class<? extends BaseEffects> effectsClazz;

  private Effectstype(Class<? extends BaseEffects> mclass) {
    effectsClazz = mclass;
  }

  public BaseEffects getAnimator() {
    BaseEffects bEffects = null;
    try {
      bEffects = effectsClazz.newInstance();
    } catch (ClassCastException e) {
      throw new Error("Can not init animatorClazz instance");
    } catch (InstantiationException e) {
      //  Auto-generated catch block
      throw new Error("Can not init animatorClazz instance");
    } catch (IllegalAccessException e) {
      //  Auto-generated catch block
      throw new Error("Can not init animatorClazz instance");
    }
    return bEffects;
  }
}
