package com.zsy.libext.widgets.loading.impl;

import com.zsy.libext.R;
import com.zsy.libext.widgets.loading.IVaryViewHelper;

import android.text.TextUtils;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

public class VaryViewHelperController {

	private IVaryViewHelper helper;

	public VaryViewHelperController(View view) {
		this(new VaryViewHelper(view));
	}

	public VaryViewHelperController(IVaryViewHelper helper) {
		super();
		this.helper = helper;
	}

	public void showError(String errorMsg,boolean isNetType, View.OnClickListener onClickListener) {
		View layout = helper.inflate(R.layout.common_message);
		TextView textView = (TextView) layout.findViewById(R.id.message_info);
		ImageView imageView = (ImageView) layout.findViewById(R.id.message_icon);

		if (isNetType){
			textView.setText(helper.getContext().getResources().getString(R.string.common_no_network_msg));
			imageView.setImageResource(R.drawable.ic_exception);

		}else {
			textView.setText(TextUtils.isEmpty(errorMsg)?helper.getContext().getResources().getString(R.string.common_error_msg):errorMsg);
			imageView.setImageResource(R.drawable.ic_error);
		}

		if (null != onClickListener) {
			layout.setOnClickListener(onClickListener);
		}

		helper.showLayout(layout);
	}

	public void showEmpty(String emptyMsg,int imgSrc, View.OnClickListener onClickListener) {
		View layout = helper.inflate(R.layout.common_message);
		TextView textView = (TextView) layout.findViewById(R.id.message_info);
		ImageView imageView = (ImageView) layout.findViewById(R.id.message_icon);
		if (!TextUtils.isEmpty(emptyMsg)) {
			textView.setText(emptyMsg);
		}
		else {
			textView.setText(helper.getContext().getResources().getString(R.string.common_empty_msg));
		}

		if (imgSrc==-1) {
			imageView.setImageResource(imgSrc);
		}
		else {
			imageView.setImageResource(R.drawable.ic_exception);
		}

		if (null != onClickListener) {
			layout.setOnClickListener(onClickListener);
		}
		helper.showLayout(layout);
	}

	public void showLoading(String msg) {
		View layout = helper.inflate(R.layout.common_loading);
		if (!TextUtils.isEmpty(msg)) {
			TextView textView = (TextView) layout.findViewById(R.id.loading_msg);
			textView.setText(msg);
		}
		helper.showLayout(layout);
	}

	public void restore() {
		helper.restoreView();
	}
}
