package com.zsy.libext.widgets.loading.impl;

import com.zsy.libext.widgets.loading.IVaryViewHelper;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.widget.FrameLayout;

/**
 * 覆盖页可以加载头部处理
 */
public class VaryViewHelperX implements IVaryViewHelper {

	private IVaryViewHelper helper;
	private View view;

	public VaryViewHelperX(View view) {
		super();
		this.view = view;
		ViewGroup group = (ViewGroup) view.getParent();
		LayoutParams layoutParams = view.getLayoutParams();
		FrameLayout frameLayout = new FrameLayout(view.getContext());
		group.removeView(view);
		group.addView(frameLayout, layoutParams);

		LayoutParams params = new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT);
		View floatView = new View(view.getContext());
		frameLayout.addView(view, params);
		frameLayout.addView(floatView, params);
		helper = new VaryViewHelper(floatView);
	}

	@Override
	public View getCurrentLayout() {
		return helper.getCurrentLayout();
	}

	@Override
	public void restoreView() {
		helper.restoreView();
	}

	@Override
	public void showLayout(View view) {
		helper.showLayout(view);
	}

	@Override
	public View inflate(int layoutId) {
		return helper.inflate(layoutId);
	}

	@Override
	public Context getContext() {
		return helper.getContext();
	}

	@Override
	public View getView() {
		return view;
	}
}
