package com.zsy.libext.widgets.webview;

import android.annotation.TargetApi;
import android.content.Context;
import android.content.res.Configuration;
import android.os.Build;
import android.util.AttributeSet;
import android.webkit.WebView;

/**
 * @author Sasuke on 2019/5/13.
 *
 * 注：此类与 LollipopFixedWebView 不带2版的联动。
 *
 * 在升级到androidX (也可能是因为升级到SDK 28的原因)，之后，在安卓5.0的机子上，会发生所有WebView闪退的现象。
 * 解决方案参考：https://stackoverflow.com/questions/41025200/android-view-inflateexception-error-inflating-class-android-webkit-webview
 *
 * 但是按上面链接的解决方案来做的话，5.0的机子上是好了，不过非5.0的机子上又出现了闪退。。。。所以自己改了一下，兼容尽可能多的机型。
 * 用的时候直接在WebView需要用的XML里，使用这个类就行了。
 *
 * 【这个就是直接从LollipopFixedWebView拷过来加了个2的，这里作为最底层库，都不读我那个base_lib了。。。。还要逼我强行复制一个过来。】
 */
public class LollipopFixedWebView2 extends WebView {
    public LollipopFixedWebView2(Context context) {
        super(getFixedContext(context));
    }

    public LollipopFixedWebView2(Context context, AttributeSet attrs) {
        super(getFixedContext(context), attrs);
    }

    public LollipopFixedWebView2(Context context, AttributeSet attrs, int defStyleAttr) {
        super(getFixedContext(context), attrs, defStyleAttr);
    }

    @TargetApi(Build.VERSION_CODES.LOLLIPOP)
    public LollipopFixedWebView2(Context context, AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(getFixedContext(context), attrs, defStyleAttr, defStyleRes);
    }

    public LollipopFixedWebView2(Context context, AttributeSet attrs, int defStyleAttr, boolean privateBrowsing) {
        super(getFixedContext(context), attrs, defStyleAttr, privateBrowsing);
    }

    public static Context getFixedContext(Context context) {
        if (Build.VERSION.SDK_INT == Build.VERSION_CODES.LOLLIPOP) {
            return context.createConfigurationContext(new Configuration());
        } else if (Build.VERSION.SDK_INT == Build.VERSION_CODES.LOLLIPOP_MR1) {
            return context.createConfigurationContext(new Configuration());
        } else {
            return context;
        }
    }
}