package com.urovo.wugumofang.membermodule.ada;


import android.content.Context;
import android.graphics.Color;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;

import com.chad.library.adapter.base.BaseMultiItemQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.urovo.wugumofang.membermodule.R;
import com.urovo.wugumofang.membermodule.ent.MultipleItem;
import com.urovo.wugumofang.ui.DensityUtil;
import com.urovo.wugumofang.utils.CommonTools;

import java.util.List;

/**
 * @author chenji
 */
public class MultipleItemQuickAdapter extends BaseMultiItemQuickAdapter<MultipleItem, BaseViewHolder> {
    private Context mContext;

    /**
     * 头部 会员数据和会员商品id
     */
    private int[] memHeadTextViewId = {
            R.id.mem_date_title,
            R.id.new_members_name,
            R.id.we_chat_member_name,
            R.id.new_guest_member_name,
            R.id.new_members,
            R.id.we_chat_member,
            R.id.new_guest_member
    };

//    /**
//     * 中部 会员菜单图片drawableId
//     */
//    public int[] memBodyDrawableId = {
//            R.mipmap.member_btn_vip_form,
//            R.mipmap.member_btn_new_sxp,
//            R.mipmap.member_btn_old_remind,
//            R.mipmap.member_btn_integral_exchange,
//            R.mipmap.member_btn_develop_new,
//            R.mipmap.member_btn_order_center
//    };
//    /**
//     * 尾部 图片drawableId
//     */
//    public int[] memFootDrawableId = {
//            R.mipmap.member_ic_join,
//            R.mipmap.member_ic_valid_weixin,
//            R.mipmap.member_ic_new,
//            R.mipmap.member_ic_90d_re_purchase,
//            R.mipmap.member_ic_90d_not_re_purchase,
//            R.mipmap.member_ic_vip_day,
//            R.mipmap.member_ic_vshop,
//            R.mipmap.member_ic_change_list,
//            R.mipmap.member_ic_vip_sell_proportion,
//            R.mipmap.member_ic_integral
//    };

    /**
     * 添加type类型和布局
     */
    public MultipleItemQuickAdapter(Context context, List<MultipleItem> data) {
        super(data);
        mContext = context;
        //头部type和布局 --会员数据
        addItemType(MultipleItem.TEXT_0, R.layout.member_item_head);
        //头部type和布局 --会员商品
        addItemType(MultipleItem.TEXT_1, R.layout.member_item_head);
        //中部type和布局
        addItemType(MultipleItem.IMG_TEXT, R.layout.member_item_body);
        //尾部type和布局
        addItemType(MultipleItem.IMG_TEXT_IMG, R.layout.member_item_foot);
        //分隔线类型和布局
        addItemType(MultipleItem.HORIZONTAL_LINE, R.layout.member_item_hori_line);
        //head 头部加高补白色,故用白色水平线填充
        addItemType(MultipleItem.HEAD_HORIZONTAL_LINE, R.layout.member_item_hori_line);
        //body 中间会员构成部分缺少额外的白色部分,故用白色水平线填充
        addItemType(MultipleItem.BODY_HORIZONTAL_LINE, R.layout.member_item_hori_line);
        //body 子元素总数为奇数时填补空白
        addItemType(MultipleItem.IMG_TEXT_EMPTY, R.layout.member_item_body);
        //尾部--tips
        addItemType(MultipleItem.TEXT_FOOT_TIPS, R.layout.member_item_tips);
    }

    @Override
    protected void convert(BaseViewHolder helper, final MultipleItem item) {
        switch (helper.getItemViewType()) {
            //头部数据填充 --会员数据
            case MultipleItem.TEXT_0:
                String[] memHeadDateArray = mContext.getResources().getStringArray(R.array.member_ship_data_store);

                //更多按钮的隐藏
                helper.getView(R.id.member_more).setVisibility(View.GONE);
                helper.setGone(R.id.new_guest_member_name, false);
                helper.setGone(R.id.new_guest_member, false);
                // 头部会员数据
                if (item.getStringArray() != null) {
                    //在线
                    for (int j = 0; j < item.getStringArray().length; j++) {
                        helper.setText(memHeadTextViewId[j], item.getStringArray()[j]);
                    }
                } else {
                    //离线
                    for (int i = 0; i < memHeadTextViewId.length; i++) {
                        helper.setText(memHeadTextViewId[i], memHeadDateArray[i]);
                    }
                }
                break;

            //头部数据填充 --会员商品
            case MultipleItem.TEXT_1:
                String[] memHeadGoodsArray = mContext.getResources().getStringArray(R.array.member_ship_goods_store);

                //头部会员商城的名字
                //本月门店会员商城数据更多按钮
                helper.setVisible(R.id.member_more, false);
                helper.addOnClickListener(R.id.member_more);

                if (item.getStringArray() != null) {
                    //在线
                    for (int j = 0; j < item.getStringArray().length; j++) {
                        helper.setText(memHeadTextViewId[j], item.getStringArray()[j]);
                    }
                } else {
                    //离线
                    for (int i = 0; i < memHeadTextViewId.length; i++) {
                        helper.setText(memHeadTextViewId[i], memHeadGoodsArray[i]);
                    }
                }
                break;

            //中部数据填充
            case MultipleItem.IMG_TEXT:
                CommonTools.INSTANCE.setImgAndText(mContext,
                        (Button) helper.getView(R.id.btn_sales_local),
                        CommonTools.ShowArrowDirection.top,
                        item.getId(),
                        item.getName());
                //子菜单的点击事件绑定
                helper.addOnClickListener(R.id.btn_sales_local);
                break;

            //尾部数据填充
            case MultipleItem.IMG_TEXT_IMG:
                helper.setImageDrawable(R.id.member_item_iv, mContext.getResources().getDrawable(item.getId()));
                helper.setText(R.id.member_name_tv, item.getName());
                //子菜单的点击事件绑定
                helper.addOnClickListener(R.id.member_foot_data);
                break;

            //中部线条
            case MultipleItem.BODY_HORIZONTAL_LINE:
                //线条设置颜色为白色
                helper.setBackgroundColor(R.id.item_horizontal_lines, Color.WHITE);
                //高度设置为18dp
                ViewGroup.LayoutParams params = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, DensityUtil.dip2px(mContext, 18));
                helper.getView(R.id.item_horizontal_lines).setLayoutParams(params);
                break;

            //头部线条
            case MultipleItem.HEAD_HORIZONTAL_LINE:
                //线条设置颜色为白色
                helper.setBackgroundColor(R.id.item_horizontal_lines, Color.WHITE);
                //高度设置为10dp
                ViewGroup.LayoutParams headParams = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, DensityUtil.dip2px(mContext, 10));
                helper.getView(R.id.item_horizontal_lines).setLayoutParams(headParams);
                break;

            //中部item子元素为奇数不能铺满一行的情况下,需要用空白item填补
            case MultipleItem.IMG_TEXT_EMPTY:
                helper.setGone(R.id.btn_sales_local, false);
                break;
            default:
                break;
        }
    }
}