package com.urovo.wugumofang.membermodule.ent;

import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.membermodule.R;
import com.urovo.wugumofang.system.SystemHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * 会员界面数据管理器
 *
 * @author chenji last on 2018/4/9 15:48
 */

public class MemberManager {
    private static final String LINK_TYPE_NATIVE = "native";
    private static final String LINK_TYPE_URL = "url";
    private static List<MemberItem> mBodyList = new ArrayList<>();
    private static List<MemberItem> mFootList = new ArrayList<>();

    public static List<MemberItem> initBodyData() {
        mBodyList.clear();
        mBodyList.add(new MemberItem(
                R.mipmap.member_btn_vip_form,
                "会员构成",
                LINK_TYPE_NATIVE,
                RouterParams.Member.MEMBER_LIST,
                AppConstants.Member.MEMBER_LIST
        ));

        mBodyList.add(new MemberItem(
                R.mipmap.member_btn_new_sxp,
                "新客三响炮",
                LINK_TYPE_NATIVE,
                RouterParams.Member.SAN_XIANG_PAO,
                AppConstants.Member.SAN_XIANG_PAO
        ));

        mBodyList.add(new MemberItem(
                R.mipmap.member_btn_old_remind,
                "老客唤醒",
                LINK_TYPE_NATIVE,
                RouterParams.Member.OLD_GUEST_AWAKENS,
                AppConstants.Member.OLD_GUEST_AWAKENS
        ));
        mBodyList.add(new MemberItem(
                R.mipmap.member_btn_integral_exchange,
                "积分兑换",
                LINK_TYPE_NATIVE,
                RouterParams.Member.INTEGRAL_CONVERTIBLE,
                AppConstants.Member.INTEGRAL_CONVERTIBLE
        ));
        mBodyList.add(new MemberItem(
                R.mipmap.member_btn_develop_new,
                "发展新会员",
                LINK_TYPE_NATIVE,
                RouterParams.Member.DEVELOP_NEW_MEMBER,
                AppConstants.Member.DEVELOP_NEW_MEMBER
        ));
        mBodyList.add(new MemberItem(
                R.mipmap.member_btn_order_center,
                "会员日预约",
                LINK_TYPE_NATIVE,
                RouterParams.Member.MEMBER_DAY_SUBSCRIBE,
                AppConstants.Member.MEMBER_DAY_SUBSCRIBE
        ));
        mBodyList.add(new MemberItem(
                R.mipmap.member_btn_customer_care,
                "客户关怀",
                LINK_TYPE_NATIVE,
                RouterParams.Member.CUSTOMER_CARE_LIST,
                AppConstants.Member.CUSTOMER_CARE_LIST
        ));
        mBodyList.add(new MemberItem(
                R.mipmap.btn_friend_circle_material,
                "朋友圈素材",
                LINK_TYPE_NATIVE,
                RouterParams.Member.WX_FRIENDS_RES,
                AppConstants.Member.WX_FRIENDS_RES
        ));
        mBodyList.add(new MemberItem(
                R.mipmap.btn_privilege_enquiry,
                "特权查询",
                LINK_TYPE_NATIVE,
                RouterParams.Member.CUSTOMER_PRIVILEGE,
                AppConstants.Member.CUSTOMER_PRIVILEGE
        ));
        mBodyList.add(new MemberItem(
                R.mipmap.btn_equity_card_query,
                "权益卡查询",
                LINK_TYPE_NATIVE,
                RouterParams.Member.VOUCHER_CARD_QUERY,
                AppConstants.Member.VOUCHER_CARD_QUERY
        ));
        return mBodyList;
    }

    public static List<MemberItem> initFootData() {
        mFootList.clear();
        mFootList.add(new MemberItem(
                R.mipmap.member_ic_join,
                "加微入群人数提报",
                LINK_TYPE_URL,
                String.format(NetParam.MEMBER_WECHAT_GROUP,
                        SystemHelper.LoginOrganName, SystemHelper.LoginUserId,
                        SystemHelper.LoginOrganId, SystemHelper.LoginUserName),
                AppConstants.Member.MEMBER_WECHAT_GROUP
        ));

        mFootList.add(new MemberItem(
                R.mipmap.member_ic_valid_weixin,
                "新客进塘数据",
                LINK_TYPE_NATIVE,
                RouterParams.Member.NEW_GUEST_MEMBER_DATA,
                AppConstants.Member.NEW_GUEST_MEMBER_DATA
        ));

        mFootList.add(new MemberItem(
                R.mipmap.member_ic_new,
                "新客数据",
                LINK_TYPE_URL,
                String.format(NetParam.NEW_CUSTOMER_DATA,
                        SystemHelper.LoginOrganName,
                        SystemHelper.LoginOrganId),
                AppConstants.Member.NEW_CUSTOMER_DATA
        ));

        mFootList.add(new MemberItem(
                R.mipmap.member_ic_90d_re_purchase,
                "新客90天复购率",
                LINK_TYPE_NATIVE,
                RouterParams.Member.NEW_GUEST_REPURCHASE_RATE,
                AppConstants.Member.NEW_GUEST_REPURCHASE_RATE
        ));

        mFootList.add(new MemberItem(
                R.mipmap.member_ic_90d_not_re_purchase,
                "顾客90天未回头名单",
                LINK_TYPE_NATIVE,
                RouterParams.ORIGIN.RA_90_NO_RETURN_LIST,
                AppConstants.Member.RA_90_NO_RETURN_LIST
        ));

        mFootList.add(new MemberItem(
                R.mipmap.member_ic_vip_day,
                "会员日数据",
                LINK_TYPE_NATIVE,
                RouterParams.Member.VIP_DAY_DATA,
                AppConstants.Member.VIP_DAY_DATA
        ));
        mFootList.add(new MemberItem(
                R.mipmap.ic_member_equity_card,
                "权益卡数据",
                LINK_TYPE_NATIVE,
                RouterParams.Member.VOUCHER_CARD_DATA,
                AppConstants.Member.VOUCHER_CARD_DATA
        ));

        mFootList.add(new MemberItem(
                R.mipmap.member_ic_vshop,
                "会员商城销售查询",
                LINK_TYPE_URL,
                String.format(NetParam.MEMBER_SALE, SystemHelper.LoginOrganName,
                        SystemHelper.LoginUserId, SystemHelper.LoginUserName,
                        SystemHelper.LoginOrganId),
                AppConstants.Member.MEMBER_SALE
        ));

        mFootList.add(new MemberItem(
                R.mipmap.member_ic_change_list,
                "会员商城体验装兑换名单",
                LINK_TYPE_URL,
                String.format(NetParam.MEMBER_GIFT, SystemHelper.LoginOrganName,
                        SystemHelper.LoginUserId, SystemHelper.LoginUserName,
                        SystemHelper.LoginOrganId),
                AppConstants.Member.MEMBER_GIFT
        ));

        mFootList.add(new MemberItem(
                R.mipmap.member_ic_vip_sell_proportion,
                "会员销售占比查询",
                LINK_TYPE_NATIVE,
                RouterParams.Member.QUERY_MEMBER_SALES_COMPARED,
                AppConstants.Member.QUERY_MEMBER_SALES_COMPARED
        ));

        mFootList.add(new MemberItem(
                R.mipmap.member_ic_integral,
                "积分兑换流水查询",
                LINK_TYPE_NATIVE,
                RouterParams.Member.QUERY_CREDIT_STATEMENT,
                AppConstants.Member.QUERY_CREDIT_STATEMENT
        ));

        mFootList.add(new MemberItem(
                R.mipmap.member_ic_customer_evaluation,
                "顾客评价查询",
                LINK_TYPE_URL,
                String.format(NetParam.MEMBER_CUSTOMER_EVALUATION,
                        SystemHelper.LoginUserId, SystemHelper.LoginUserName),
                AppConstants.Member.CUSTOMER_EVALUATION_QUERY
        ));
        return mFootList;
    }
}
