package com.urovo.wugumofang.membermodule.net;

import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.membermodule.ent.MembershipStoreData;
import com.urovo.wugumofang.net.CommonController;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.urovo.wugumofang.response.CommonEntity;
import com.zsy.libcore.common.android.log.SYLoger;

import java.util.Map;

import okhttp3.Request;

/**
 * 会员营销页面接口
 *
 * @author chenji last on 2018/1/2 19:51
 */

public class MemberNet {
    private IMemberNet mIMemberNet;

    /**
     * retrofit的配置
     */
    public MemberNet() {
        mIMemberNet = RetrofitHelper.createApi(IMemberNet.class);
    }

    /**
     * 本店会员数据 和 本月门店会员商店
     *
     * @param presenter ...
     */
    public void start2request(final CommonController.BasePre<MembershipStoreData> presenter, Map<String, String> params) {
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.MEMBER_DATA_STORE, params, new OkHttpDominator.ResultCallback<MembershipStoreData>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        presenter.onFailure("会员营销页面异常：" + e);
                        SYLoger.print("会员营销页面异常:" + e);
                    }

                    @Override
                    public void onResponse(MembershipStoreData response) {
                        if (null != response) {
                            presenter.onResponseSuccess(new CommonEntity<>(response));
                        }
                    }
                }
        );
    }

    public void onShowAddFriOnWeChatTask(final CommonController.BasePre<Boolean> presenter, Map<String, String> params) {
//        final Call<RequestResult> call = mIMemberNet.isShowAddFriOnWeChat(params);
//        call.enqueue(new ResultBaseCallback<RequestResult>() {
//            @Override
//            public void onResponse(Call<RequestResult> call, Response<RequestResult> response) {
//                if (response.isSuccessful()) {
//                    final RequestResult responseBody = response.body();
//                    if (responseBody.msgCode != 0) {
//                        presenter.onFailure(response.body().msgInfo + ", " + response.body().resultInfo);
//                    } else {//正常情况下
//                        presenter.onResponseSuccess(new CommonEntity<>(true));
//                    }
//                } else {
//                    this.onFailure(call, new Throwable(response.errorBody().toString()));
//                }
//            }
//
//            @Override
//            public void onFailure(Call<RequestResult> call, Throwable t) {
//                if (presenter != null) {
//                    presenter.onFailure("网络异常或者接口数据解析失败：" + t);
//                }
//            }
//        });
    }
}
