package com.urovo.wugumofang.membermodule.pre;

import com.urovo.wugumofang.response.CommonEntity;
import com.urovo.wugumofang.membermodule.ent.MembershipStoreData;
import com.urovo.wugumofang.net.CommonController;
import com.urovo.wugumofang.membermodule.net.MemberNet;

import java.util.List;
import java.util.Map;

/**
 * 会员营销门店会员数据和会员商品的pre
 *
 * @author chenji
 */
public class MemberPre implements CommonController.BasePre<MembershipStoreData> {
    private CommonController.BaseView<MembershipStoreData> mMemberView;
    private MemberNet mMemberNet;

    public MemberPre(CommonController.BaseView<MembershipStoreData> stockSearchView) {
        this.mMemberView = stockSearchView;
        this.mMemberNet = new MemberNet();
    }

    @Override
    public void onStart2requestData(Map<String, String> params) {
        mMemberNet.start2request(this, params);
    }

    @Override
    public void onResponseSuccess(CommonEntity<MembershipStoreData> resultInfo) {
        mMemberView.onResponseSuccess(resultInfo);
    }

    @Override
    public void onFailure(String failInfo) {
        mMemberView.onFailure(failInfo);
    }
}
