package com.urovo.wugumofang.basewebview.ui;

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.KeyEvent
import android.widget.FrameLayout
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.basewebview.R
import com.urovo.wugumofang.basewebview.ui.HtmlFragment.OnChangeTitleListener

/**
 * 加载H5 Activity
 * @author LW
 */
class HtmlActivity : BaseActivity(), OnChangeTitleListener {
    private var mIsShowClose = false

    override fun addRootLayoutId(): Int = R.layout.activity_webview_content

    companion object {

        fun start(context: Context, branchUrl: String?) {
            val intent = Intent(context, HtmlActivity::class.java)
            intent.putExtra("branchUrl", branchUrl)
            context.startActivity(intent)
        }
    }

    override fun initViewNew() {
        initTitle()
        if (findViewById<FrameLayout>(R.id.activity_webview_content_frg) != null) {
            val htmlFragment = HtmlFragment()
            val htmlBundle = Bundle()
            htmlBundle.putString("mainUrl", intent.getStringExtra("mainUrl"))
            htmlBundle.putString("customHtml", intent.getStringExtra("customHtml"))
            htmlBundle.putString("orientation", intent.getStringExtra("orientation"))
            htmlBundle.putString("branchUrl", intent.getStringExtra("branchUrl"))
            htmlBundle.putString("branchTitle", intent.getStringExtra("branchTitle"))
            htmlFragment.arguments = htmlBundle
            supportFragmentManager.beginTransaction()
                .add(R.id.activity_webview_content_frg, htmlFragment).commit()
        }
    }

    override fun initDataNew() {
        mIsShowClose = intent.getBooleanExtra("isShowClose", false)
    }

    override fun changeTitle(title: String?) {
        titleTextView.text = title
    }

    override fun back() {
        val fragment = supportFragmentManager
            .findFragmentById(R.id.activity_webview_content_frg) as HtmlFragment?
        fragment?.back()
    }

    override fun close() {
        finish()
    }

    override fun onKeyDown(keyCode: Int, event: KeyEvent): Boolean {
        if (event.action == KeyEvent.ACTION_DOWN) {
            if (keyCode == KeyEvent.KEYCODE_BACK) {
                if (mIsShowClose) {
                    back()
                } else {
                    close()
                }
                return true
            }
        }
        return super.onKeyDown(keyCode, event)
    }

}