package com.urovo.wugumofang.printermodule;

import android.database.Cursor;
import android.text.TextUtils;

import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.XBZPFEntity;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Sasuke on 2017/9/7.
 * 好烦啊，直接从Item001里把这个抽出来，给打印自己用吧。。。。
 */

public class PrinterDbOperate {
    /**
     * 获取所有可盘点产品信息
     */
    public static PrinterUtil.PrinterRule GetCanPanDianProductsForNewPrint(String itemId, PrinterUtil.PrinterRule printerRule) {
        Cursor cursor = null;
        String sql = "select t1.itemid,t1.INGREDIENT,t1.SAVECONDITION,t2.BarType,t2.Barcode,t1.proarea,t1.prosupplier "
                + " from item001 t1,cpbarbill002 t2 where t1.itemId = t2.itemId "
                + " and t1.itemid = '" + itemId + "'";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                printerRule.mType = cursor.getString(cursor.getColumnIndex("BarType"));
                printerRule.mCode = cursor.getString(cursor.getColumnIndex("Barcode"));
                printerRule.mIngredient = cursor.getString(cursor.getColumnIndex("INGREDIENT"));
                printerRule.mSaveCondition = cursor.getString(cursor.getColumnIndex("SAVECONDITION"));
                printerRule.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                printerRule.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取所有可盘产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return printerRule;
    }

    /**
     * 根据门店获取十方产品
     */
    public static List<ProductEntity> GetShiFangItems(String storeId) {
        List<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql;
        if (!TextUtils.isEmpty(storeId)) {
            sql = "select distinct t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, t1.bomspec," + " t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t3.sortno " + " from item001 t1,xbzpf t2,cpbill002 t3 " + " where t3.XSGRPID !='999' and t3.bill in" + " (select cpbill from store001 where storeid='"
                    + storeId + "')" + " and t1.itemid=t2.itemid and t1.itemid=t3.itemid" + " order by t3.sortno";
        } else {
            sql = "select distinct t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom,t1.bomspec, " + " t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t3.sortno" + " from item001 t1,xbzpf t2 join cpbill002 t3 on t2.itemid=t3.itemid" + " where t1.itemid=t2.itemid " + " order by t3.sortno";
        }

        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setSortNo(cursor.getDouble(cursor.getColumnIndex("SORTNO")));
                p.setBOMSPEC(cursor.getString(cursor.getColumnIndex("BOMSPEC")));
                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取所有十方信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 根据十方组合编码获得成分信息
     */
    public static List<XBZPFEntity> GetShiFangDetail(String ItemId) {
        List<XBZPFEntity> list = new ArrayList<XBZPFEntity>();
        Cursor cursor = null;
        String sql = null;
        if (!TextUtils.isEmpty(ItemId)) {
            sql = "select t1.*,t2.itemname,t3.itemname as THENAME " + " from xbzpf t1,item001 t2 left join item001 t3 on t1.itemid=t3.itemid" + " where t1.itemid='" + ItemId + "'" + " and t1.xbzid=t2.itemid";
        }
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                XBZPFEntity p = new XBZPFEntity();
                p.setITEMNAME(cursor.getString(cursor.getColumnIndex("THENAME")));
                p.setITEMID(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setXBZID(cursor.getString(cursor.getColumnIndex("XBZID")));
                p.setWEIGHT(cursor.getDouble(cursor.getColumnIndex("WEIGHT")));
                p.setBZQTY(cursor.getDouble(cursor.getColumnIndex("BZQTY")));
                p.setSJQTY(cursor.getDouble(cursor.getColumnIndex("SJQTY")));
                p.setBZPRICE(cursor.getDouble(cursor.getColumnIndex("BZPRICE")));
                p.setSJPRICE(cursor.getDouble(cursor.getColumnIndex("SJPRICE")));
                p.setXBZNAME(cursor.getString(cursor.getColumnIndex("ITEMNAME")));

                boolean exist = false;
                for (XBZPFEntity ent : list) {
                    if (p.getXBZID().equals(ent.getXBZID())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取十方详情发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 根据产品ID 查询列表一行中一种产品的信息。
     *
     * @param itemId 产品ID
     * @return ...
     */
    public static PrinterUtil.PrinterRule getPrinterRuleByCpbarbill002(String itemId) {
        PrinterUtil.PrinterRule pr = new PrinterUtil.PrinterRule();

        String sqlCommand = "select Barcode,BarCodePaper,PrintRule from Cpbarbill002 where ItemId='" + itemId + "'";
        Cursor dr;
        try {
            dr = BaseAppManager.database().rawQuery(sqlCommand, null);
            if (dr != null) {
                while (dr.moveToNext()) {
                    pr.mCode = dr.isNull(0) ? "" : dr.getString(0);
                    pr.mBarCodePaper = dr.isNull(1) ? "" : dr.getString(1);
                    pr.mPrintRule = dr.isNull(2) ? "" : dr.getString(2);
                }
                dr.close();
            }
        } catch (Exception ex) {
            BaseAppManager.loger().info("根据门店Id获取商超条码明细发生异常:" + ex);
        }
        return pr;
    }

    /**
     * 根据产品获取BOM信息:BOMSPEC y-是 明细和数量规则不变，总金额取该产品的金额:NORMRPRICE；
     */
    public static ProductEntity GetBomInfo(String itemid) {
        ProductEntity p = new ProductEntity();
        Cursor cursor = null;
        String sql = "select distinct t1.itemid, t1.bomspec,t1.normrprice from item001 t1 where ItemId='" + itemid + "'";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setBOMSPEC(cursor.getString(cursor.getColumnIndex("BOMSPEC")));
                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("根据产品获取BOM信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return p;
    }
}
