package com.urovo.wugumofang.printermodule;

import com.urovo.wugumofang.constants.AppConstants;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by chenji on 2017/8/21.
 * 打印条码类型工厂类
 */

public class PrinterFactory {//factory
    private static final Map<String, CodePrinter> mCpMap = new HashMap<>();

    static {
        mCpMap.put(AppConstants.Printer.mItemCode, new ItemCodePrinter());
        mCpMap.put(AppConstants.Printer.mCombineCode, new CombineCodePrinter());
    }

    public static CodePrinter getInstance(String key) {
        return mCpMap.get(key);
    }
}
