package com.urovo.activity.MemberList.view;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.activity.MemberList.model.MemberListCountEntity;
import com.urovo.activity.MemberList.model.MemberListEntity;
import com.urovo.activity.MemberList.model.MemberListResponse;
import com.urovo.activity.MemberList.presenter.MemberListContract;
import com.urovo.activity.MemberList.presenter.MemberListPresenter;
import com.urovo.activity.slidemenu.BlankFrag;
import com.urovo.activity.slidemenu.NoDataFrag;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.SetFocusUtil;
import com.zsy.libcore.common.android.log.SYLoger;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;

/**
 * 会员名单Activity（就是在”我的会员“里的那个按钮。
 * Created by Sasuke on 2016/5/18.
 */
@Route(path = RouterParams.Member.MEMBER_LIST)
public class MemberListAct extends BaseActivity implements View.OnFocusChangeListener, View.OnClickListener {
    SimpleDateFormat sdfShow;//格式为"yyyy年MM月dd日"的显示格式
    MemberListFra listFra;//显示积分到期表的Frag
    NoDataFrag noDataFrag;//无新客信息时显示的带提示的Fragment
    BlankFrag blankFrag;
    MemberListContract.Presenter mPresenter;
    WebView webView;
    private TextView mTextViewStore;
    private TextView mTextViewDate;
    private MemberListCountEntity mEntity;
    private Button mZuanguBtn;//10天内过期标签按钮
    private Button mZhunZuanguBtn;//30天内过期标签按钮
    // private Button mFortyFiveDayBtn;//四十五天待回头按钮
    private int mType;
    private Date mDate;
    private List<MemberListEntity> mList = new ArrayList<>();//获取客户列表数据时网络传回的数据实体列表

    @SuppressLint("SetJavaScriptEnabled")
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_member_list);

        titleTextView = (TextView) findViewById(R.id.text_title);
        titleTextView.setText("会员构成");
        ImageButton goback = (ImageButton) findViewById(R.id.goback);
        goback.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        mType = 1;//三响炮中，1表示5天，2是15天，3是45天;
        findViews();//获取上方标签按钮组件
        setListeners();

        noDataFrag = new NoDataFrag();//显示“暂无数据”
        blankFrag = new BlankFrag();
        listFra = new MemberListFra();//有新客信息时显示此Frag

        //必须传入this，即此BaseActivity，因为Presenter里面调Task时会回调BaseActivity里的displayResult方法
        mPresenter = new MemberListPresenter(this, listFra);
        mPresenter.start();

        //mPresenter.requestCount(mDate,mList);
        mPresenter.requestUserData(mDate, 1);

        webView = (WebView) findViewById(R.id.webView);
        assert webView != null;
        WebSettings settings = webView.getSettings();
        settings.setSupportZoom(false);          //支持缩放
        settings.setBuiltInZoomControls(false);  //启用内置缩放装置
        settings.setJavaScriptEnabled(true);    //启用JS脚本
        settings.setSavePassword(false);//webview不要保存密码，官方未来会不支持保存密码
        webView.removeJavascriptInterface("searchBoxJavaBridge_");
        webView.removeJavascriptInterface("accessibility");
        webView.removeJavascriptInterface("accessibilityTraversal");
//        webView.loadUrl("file:///android_asset/h5/html/app_special/membership_form_pie_chart.html");
//        webView.loadUrl(NetParam.MEMBERSHIP_FORM_PIE_CHART);
    }

    /**
     * 获取上方标签按钮组件
     */
    public void findViews() {
        //日期选择器的默认显示
        mDate = new Date();
        Calendar c = Calendar.getInstance();
        Long yesterdayTime = c.getTimeInMillis() - (24 * 60 * 60 * 1000);//取昨天为固定截止日期

        sdfShow = new SimpleDateFormat("yyyy年MM月dd日");
        String yesterday = sdfShow.format(yesterdayTime);//把昨天Long转换成字符串
        try {
            mDate = sdfShow.parse(yesterday);
        } catch (ParseException e) {
            e.printStackTrace();
        }

        mTextViewDate = (TextView) findViewById(R.id.date_text);
        mTextViewDate.setText("截止" + yesterday);

        mTextViewStore = (TextView) findViewById(R.id.store_text);
        mTextViewStore.setText(SystemHelper.LoginOrganName);
        //可以点击切换日期的区域
        mZuanguBtn = (Button) findViewById(R.id.zuangu_member);
        SetFocusUtil.focus(mZuanguBtn);//首先一来就把焦点设在第一个“5天”标签上
        mZuanguBtn.setTextColor(getResources().getColor(R.color.title_yellow_bg));//再来一波字体染色

        mZhunZuanguBtn = (Button) findViewById(R.id.zhun_zuangu_member);
        //mFortyFiveDayBtn = (Button) findViewById(R.id.forty_five_day_btn);
    }

    /**
     * 给标签按钮挂监听器（包括点击监听、焦点改变监听
     */
    public void setListeners() {
        mZuanguBtn.setOnClickListener(this);
        mZhunZuanguBtn.setOnClickListener(this);
        //mFortyFiveDayBtn.setOnClickListener(this);
        mZuanguBtn.setOnFocusChangeListener(this);
        mZhunZuanguBtn.setOnFocusChangeListener(this);
        //mFortyFiveDayBtn.setOnFocusChangeListener(this);
    }


    /**
     * 监听上端标签的点击
     *
     * @param v 标签按钮
     */
    @Override
    public void onClick(View v) {
        int id = v.getId();
        switch (id) {
            case R.id.zuangu_member:
                SetFocusUtil.focus(mZuanguBtn);
                break;
            case R.id.zhun_zuangu_member:
                SetFocusUtil.focus(mZhunZuanguBtn);
                break;
           /* case R.id.forty_five_day_btn:
                SetFocusUtil.focus(mFortyFiveDayBtn);
                break;*/
            //case R.id.date_layout://改日期的那个点击区域
                /*Calendar c = Calendar.getInstance();
                new DatePickerDialog(MemberListAct.this,
                        new DatePickerDialog.OnDateSetListener() {
                            @Override
                            public void onDateSet(DatePicker view, int year,
                                                  int monthOfYear, int dayOfMonth) {
                                if (mDate.getYear() != (year - 1900)
                                        || mDate.getMonth() != monthOfYear
                                        || mDate.getDate() != dayOfMonth) {
                                    mDate.setYear(year - 1900);
                                    mDate.setMonth(monthOfYear);
                                    mDate.setDate(dayOfMonth);

                                    mTextViewDate.setText(sdfShow.format(mDate));
                                    getFragmentManager().beginTransaction().replace(R.id.member_list_fra_container,blankFrag).commit();
                                    mPresenter.requestCount(mDate,mList);
                                }
                            }
                        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c
                        .get(Calendar.DAY_OF_MONTH)).show();*/
            //break;
            default:
                break;
        }
    }

    /**
     * 监听标签的焦点变化
     *
     * @param v
     * @param hasFocus
     */
    @Override
    public void onFocusChange(View v, boolean hasFocus) {
        if (hasFocus) {
            ((Button) v).setTextColor(getResources().getColor(R.color.title_yellow_bg));
            int id = v.getId();
            switch (id) {
                case R.id.zuangu_member:
                    mType = 1;
                    break;
                case R.id.zhun_zuangu_member:
                    mType = 2;
                    break;
            }
            getSupportFragmentManager().beginTransaction().replace(R.id.member_list_fra_container, blankFrag).commit();
            //mPresenter.requestCount(mDate,mList);
            mPresenter.requestUserData(mDate, 1);
        } else {
            ((Button) v).setTextColor(getResources().getColor(R.color.text_menu_color));
        }
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        /*f ("query".equals(tag) && null != response) {
            MemberListCountResponse res = (MemberListCountResponse) response;
            if (null != res.getList() && res.getList().size() > 0) {
                mEntity = res.getList().get(0);
                //把人数显示在标签上
                mZuanguBtn.setText("钻谷会员" + "(" + mEntity.firstCareCustomerNum + ")");
                mZhunZuanguBtn.setText("准钻谷会员" + "(" + mEntity.secondCareCustomerNum + ")");
                //mFortyFiveDayBtn.setText("45天待回头" + "(" + mEntity.thirdCareCustomerNum + ")");
                mPresenter.requestUserData(mDate,1);//获取完了三项的各个数量后，马上去获取具体的客户数据
            }
        }else*/
        if ("queryData".equals(tag) && null != response) {//下载客户列表数据
            MemberListResponse res = (MemberListResponse) response;

            if (null != res.returnBean) {
                initWebPie(res.returnBean.level1Sum, res.returnBean.level2Sum, res.returnBean.level3Sum, res.returnBean.level4Sum);
            } else {
                initWebPie("", "", "", "");
            }

            if (null != res.getList(1) && res.getList(1).size() > 0) {
                mZuanguBtn.setText(String.format(Locale.CHINA,"钻谷会员(%d)", res.getList(1).size()));
            } else {
                mZuanguBtn.setText("钻谷会员(0)");
            }
            if (null != res.getList(2) && res.getList(2).size() > 0) {
                mZhunZuanguBtn.setText(String.format(Locale.CHINA,"金谷会员(%d)", res.getList(2).size()));
            } else {
                mZhunZuanguBtn.setText("金谷会员(0)");
            }
            Bundle bundle = new Bundle();
            bundle.putSerializable("mList", res);
            bundle.putInt("mType", mType);
            listFra.setArguments(bundle);
            getSupportFragmentManager().beginTransaction().replace(R.id.member_list_fra_container, listFra).commit();
        } else {//暂无数据
            mZuanguBtn.setText("钻谷会员(0)");
            mZhunZuanguBtn.setText("金谷会员(0)");
            getSupportFragmentManager().beginTransaction().replace(R.id.member_list_fra_container, noDataFrag).commit();
        }
    }

    private void initWebPie(String level1Sum, String level2Sum, String level3Sum, String level4Sum) {
        if (NetHelper.IsHaveInternet(this)) {
//            String tempUrl = String.format(NetParam.MEMBERSHIP_FORM_PIE_CHART, level1Sum, level2Sum, level3Sum, level4Sum);
            //不知道测试环境咋地了。。。。这个H5又挂了。。。那我直接从正式环境把这个html保存下来直接加载得了
            String tempUrl = String.format("file:///android_asset/h5/html/app_special/membership_form_pie_chart.html?level1Sum=%s&level2Sum=%s&level3Sum=%s&level4Sum=%s",level1Sum,level2Sum,level3Sum,level4Sum);
            webView.loadUrl(tempUrl);
//      webView.loadUrl("http://test.wgmf.com//crmserver-front/html/app_special/membership_form_pie_chart.html?level1Sum=%s&level2Sum=%s&level3Sum=%s&level4Sum=%s");
            SYLoger.print("cj initWebPie 测试环境加载完成。。。。");
        } else {
            SYLoger.print("cj initWebPie 没有联网。。。。");
            webView.loadUrl("file:///android_asset/h5/html/app_special/membership_form_pie_chart.html");
        }
    }

    @Override
    protected void onDestroy() {
        if (webView != null) {
//            ViewGroup parent = (ViewGroup) webView.getParent();
//            if (parent != null) {
//                parent.removeView(webView);
//            }
            webView.removeAllViews();
            webView.destroy();
        }
        super.onDestroy();
    }
}
