package com.urovo.activity.MemberList.view;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ListView;

import com.urovo.activity.MemberList.model.MemberListEntity;
import com.urovo.activity.MemberList.model.MemberListResponse;
import com.urovo.activity.MemberList.presenter.MemberListContract;
import com.urovo.activity.MemberList.ui.MemberListAdapter;
import com.urovo.activity.MemberProfile.view.MemberProfileAct;
import com.urovo.wugumofang.R;

import java.util.List;

import androidx.fragment.app.Fragment;

/**
 * @author Sasuke
 * @date 2016/5/18
 */
public class MemberListFra extends Fragment implements MemberListContract.View {

    private List<MemberListEntity> mList;
    private ListView mLv;
    private MemberListAdapter myAdapter;
    private MemberListContract.Presenter mPresenter;
    private int mType;
    MemberListResponse res;

    @Override
    public void setPresenter(MemberListContract.Presenter presenter) {
        this.mPresenter = presenter;
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        final Bundle bundle = getArguments();
        res = (MemberListResponse) bundle.get("mList");
        mType = (int) bundle.get("mType");
        mList = res.getList(mType);

        View view = inflater.inflate(R.layout.jifen_daoqi_list, container, false);
        mLv = (ListView) view.findViewById(R.id.jifen_list);
        view.findViewById(R.id.tips_datetime_tv).setVisibility(View.GONE);
        if (mList != null) {
            mLv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                    Intent intent = new Intent(getActivity(), MemberProfileAct.class);
                    intent.putExtra("phone", ((MemberListEntity) mList.get(position)).customerMobile);
                    intent.putExtra("mType", bundle.getInt("mType", 1));//告诉它这条新客记录是从哪个标签来的
                    intent.putExtra("entity", mList.get(position));//只用传对应会员的Entity就行了
                    intent.putExtra("careType", "3");//关怀类型 默认1新客三响炮 2积分到期提醒 3砖石会员
                    intent.putExtra("position", position);
                    startActivityForResult(intent, 1);
                }
            });
            myAdapter = new MemberListAdapter(getActivity(), mList);
            mLv.setAdapter(myAdapter);
        }
        return view;
    }

    /**
     * 把手机号码转换成带分隔线的字符串
     *
     * @param customerMobile 原手机号字符串
     * @return 转换后生成的手机号
     */
    private String transMobile(String customerMobile) {
        char c;
        StringBuffer sb = new StringBuffer(customerMobile);
        sb.replace(3, 7, "****");
        return sb.toString();
    }

    /**
     * 主要用于关闭新客详情Activity后，对本页面的列表状态标识进行刷新
     *
     * @param requestCode ...
     * @param resultCode  ...
     * @param data        ...
     */
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        int position = data.getIntExtra("position", -1);
        if (position != -1 && resultCode == 1) {//如果回访信息上传成功
            MemberListEntity cell = (MemberListEntity) data.getSerializableExtra("entity");
            mList.set(position, cell);//把该position上的元素给覆盖掉
            myAdapter.notifyDataSetChanged();
        }

    }
}
