package com.urovo.activity.MemberProfile.presenter;

import android.text.TextUtils;

import com.urovo.activity.MemberProfile.model.GuanHuaiData;
import com.urovo.wgmf.AsyncTask.BaseAppSalerServerTask;
import com.urovo.wgmf.AsyncTask.BaseAppServerTask;
import com.urovo.wgmf.db.dao.entitys.HuiYuanXiangXiZiLiaoEntity;
import com.urovo.wgmf.entity.response.CanKaoHuaShuResponse;
import com.urovo.wgmf.entity.response.HuiYuanXiangXiZiLiaoResponse;
import com.urovo.wgmf.entity.response.HuiYuanYouHuiQuanResponse;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.Files;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.system.SystemHelper;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

import okhttp3.Request;

/**
 *
 * @author Sasuke
 * @date 2016/5/13
 */
public class MemberProfilePresenter implements MemberProfileContract.Presenter {
    MemberProfileContract.View mView;

    public MemberProfilePresenter(MemberProfileContract.View view) {
        this.mView = view;
        this.mView.setPresenter(this);
    }

    @Override
    public void start() {
        mView.setReceiver();
        mView.init();
    }

    @Override
    public void getCanKaoHuaShu(int type) {
        Map<String, String> p = new HashMap<>();
        p.put("userId", SystemHelper.LoginUserId);
        p.put("storeId", SystemHelper.LoginOrganId);
        p.put("type", "" + type);
        new BaseAppSalerServerTask("words", CanKaoHuaShuResponse.class,
                (BaseActivity) mView, "正在获取参考话术...", true,
                "/information/getReferenceTalk", p).execute("");
    }


    @Override
    public void request(GuanHuaiData guanHuaiData) {
        if (TextUtils.isEmpty(guanHuaiData.getPhone())) {
            return;
        }
        //查询会员详细资料
        Map<String, String> p = new HashMap<>();
        p.put("userId", SystemHelper.LoginUserId);
        p.put("storeId", SystemHelper.LoginOrganId);
        p.put("customerMobile", guanHuaiData.getPhone());

        new BaseAppServerTask("query", HuiYuanXiangXiZiLiaoResponse.class,
                (BaseActivity) mView, "正在会员详细资料...", true, "/information/getCustomerDetalInfo",
                p).execute("");
        //查询会员拥有的优惠券
        Map<String, String> p2 = new HashMap<>();
        p2.put("storeid", SystemHelper.LoginOrganId);
        p2.put("phone", guanHuaiData.getPhone());
        new BaseAppServerTask("queryYouhui", HuiYuanYouHuiQuanResponse.class,
                (BaseActivity) mView, "正在查询优惠券...", false, NetParam.YOUHUIQUAN, p2).execute("");
    }

    /**
     * @param guanHuaiData 刚进会员详情的时候，获取到的会员详细数据
     * @param weixin       是否微信
     * @param msg          是否短信
     * @param call         是否打电话
     * @param share        是否分享了文章
     * @param confirmCare  是否为手动关怀,只有为非1才可以操作;
     * @param careType     关怀类型 默认1新客三响炮 2积分到期提醒 3砖石会员
     * @param type         积分到期提醒类型，是10天还是30天到期
     * @param taskId
     */
    @Override
    public void upload(GuanHuaiData guanHuaiData,
                       boolean weixin, boolean msg, boolean call, boolean share, boolean confirmCare, String careType, int type, String taskId) {
        if (TextUtils.isEmpty(guanHuaiData.getCell().getCustomerMobile())) {
            return;
        }
        //SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Map<String, String> p = new HashMap<>();
        p.put("careType", careType);//关怀类型 默认1新客三响炮 2积分到期提醒 3砖石会员
        p.put("type", type + "");//积分到期提醒名单关怀需要提供 1十天 2三十天
        p.put("userId", SystemHelper.LoginUserId);
        p.put("storeId", SystemHelper.LoginOrganId);
        p.put("customerMobile", guanHuaiData.getCell().getCustomerMobile());
//        p.put("statisticsDate", transDateString(guanHuaiData.getCell().getStatisticsDate()));
        if (weixin) {
            p.put("wechatCare", "1");
            p.put("wechatCareTime", getCareNowTime());
        }
        if (msg) {
            p.put("smsCare", "1");
            p.put("smsCareTime", getCareNowTime());
        }
        if (call) {
            p.put("phoneCare", "1");
            p.put("phoneCareTime", getCareNowTime());
        }
        if (share) {
            p.put("shareCare", "1");
            p.put("shareTime", getCareNowTime());
            p.put("shareOpno", SystemHelper.LoginUserId);
        }
        if (confirmCare) {
            p.put("confirmCare", "1");
        }
        p.put("taskId", taskId);
        String tag = confirmCare?"upload_confirmCare" : "upload";

        new BaseAppServerTask( tag, BaseOldResponse.class, (BaseActivity) mView,
                "正在提交关怀数据...", false, "/customer/updateCareCustomerInfo", p)
                .execute("");
    }

    /**
     * 把响应实体entity里的日期转换成带横杠的日期，如2016-03-29，这样才能成功上传数据
     *
     * @return ...
     */
    private String transDateString(String entityDateString) {
        if (!TextUtils.isEmpty(entityDateString)) {
            StringBuilder sb = new StringBuilder(entityDateString);
            sb.insert(4, "-");
            sb.insert(7, "-");
            return sb.toString();
        }
        return entityDateString;
    }

    /**
     * 获取当前进行回访时的时间
     *
     * @return ...
     */
    private String getCareNowTime() {
//        String careNowTime;//进行回访的现在时间
        Date now = new Date();
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss", Locale.CHINA);
        return dateFormat.format(now);
    }

    /**
     * 把手机号插入横杠分隔线，如185-****-****
     *
     * @param customerMobile ...
     * @return ...
     */
    @SuppressWarnings("unused")
    private String trans(String customerMobile) {
        StringBuilder sb = new StringBuilder(customerMobile);
        sb.insert(3, "-");
        sb.insert(8, "-");
        return sb.toString();
    }

    /**
     * 获取头像
     *
     * @param headUrl ...
     */
    @Override
    public void getHeadPicFromNet(String headUrl, HuiYuanXiangXiZiLiaoEntity mEntity) {
//        HttpUtils http = new HttpUtils();
//        http.download(headUrl, Files.photoPath + mEntity.customerMobile + ".jpg",
//                new RequestCallBack<File>() {
//                    @Override
//                    public void onFailure(HttpException arg0, String arg1) {
//                        ((BaseActivity)mView).showMsg("下载头像出错");
//                        GlobalApp.loger.info("下载头像出错" + arg1);
//                        //	image.setImageResource(R.drawable.head);
//                    }
//
//                    @Override
//                    public void onSuccess(ResponseInfo<File> arg0) {
//                        GlobalApp.loger.info("下载头像成功" + arg0.result);
//                        mView.showCirclePic();
//                    }
//                });
        OkHttpDominator.downloadAsyn(headUrl, Files.photoPath + mEntity.customerMobile + ".jpg",
                new OkHttpDominator.ResultCallback<String>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ((BaseActivity) mView).showMsg("下载头像出错");
                    }

                    @Override
                    public void onResponse(String response) {
                        mView.showCirclePic();
                    }
                });
    }
}
