package com.urovo.activity.addsellactivity.ui

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import androidx.recyclerview.widget.RecyclerView
import com.squareup.picasso.Picasso
import com.urovo.wugumofang.R

/**
 * @author Sasuke on 2019-7-15 0015.
 */
class ProShowAdapter(val context: Context,val imgUrls: List<String>?): RecyclerView.Adapter<ProShowAdapter.ViewHolder>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(LayoutInflater.from(context).inflate(R.layout.pro_show_list_item, parent, false))
    }

    override fun getItemCount(): Int {
        return imgUrls?.size ?: 0
    }

    override fun onBindViewHolder(holder: ViewHolder, pos: Int) {
        holder?.let {
//            val scrWidth = DensityUtil.getScreenW(context)
            Picasso.with(context).load(imgUrls?.get(pos))
                    .into(it.proImg)
        }
    }

    class ViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        var proImg: ImageView

        init {
            proImg = view.findViewById(R.id.proImg) as ImageView
        }
    }
}