package com.urovo.activity.addsellactivity.ui

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.*
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.sell.ShiFangDetailActivity
import com.urovo.wgmf.db.dao.entitys.ProductEntity
import com.urovo.wugumofang.R
import com.urovo.wugumofang.constants.AppConstants.Printer.maxCount
import com.urovo.wugumofang.data.Arith
import com.urovo.wugumofang.utils.MyToast
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2018/1/4.
 * 十方Adapter  （代码有点乱，不要怪我，我也是直接拷祖传代码改的）
 *
 */
class ShiFangAda(val context: Context,val proList: List<ProductEntity>,val notifyMain: () -> Unit): RecyclerView.Adapter<ViewHolder2>(){
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder2 {
        return ViewHolder2(LayoutInflater.from(context).inflate(R.layout.listview_shifang_item2, null))
    }

    override fun onBindViewHolder(holder: ViewHolder2, pos: Int) {
        holder.apply {
            et_x2count.setSelectAllOnFocus(true)
            et_x2count.setOnClickListener { v ->
                (v as EditText).apply {
                    setText(v.text.toString())
                    selectAll()
                }
            }
            tv_shi_name.text = proList[pos].getItemName()
            tv_shi_num.text = proList[pos].getItemId()


            rl_checkbox.setOnClickListener {
                when(cb_shi.isChecked){
                    true -> if (proList[pos].minCount > 0) MyToast.show("该产品为活动产品，不可以取消") else proList[pos].isChecked = false
                    false -> {
                        proList[pos].isChecked = true
                        proList[pos].tqty = 1.0
                    }
                }
                notifyDataSetChanged()
                notifyMain.invoke()//相当于祖传代码的setChanged(),更新主界面底栏总价
            }

            ibtn_x2jian.setOnClickListener {
                var i = et_x2count.text.toString().toInt()
                i--
                et_x2count.setText(i.toString())
            }

            ibtn_x2jia.setOnClickListener {
                var i = et_x2count.text.toString().toInt()
                i++
                et_x2count.setText(i.toString())
            }

            et_x2count.setTag(pos)
            et_x2count.addTextChangedListener(object: TextWatcher{
                override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                }

                override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                }

                override fun afterTextChanged(p0: Editable?) {
                    if (!proList[pos].isChecked) return
                    val ptn = et_x2count.getTag() as Int

                    val str = et_x2count.getText().toString()

                    var count = 1
                    var minCount = proList[pos].minCount
                    if (minCount == 0) {
                        minCount = 1
                    }
                    if (!TextUtils.isEmpty(str)) {
                        count = Integer.parseInt(str)

                        if (count < minCount) {
                            count = minCount
                            et_x2count.setText(count.toString())
                            ibtn_x2jian.setEnabled(false)
                            ibtn_x2jia.setEnabled(true)
                        } else if (count == minCount) {
                            ibtn_x2jian.setEnabled(false)
                            ibtn_x2jia.setEnabled(true)
                        } else if (count > maxCount) {
                            count = maxCount
                            et_x2count.setText(count.toString())
                            ibtn_x2jia.setEnabled(false)
                            ibtn_x2jian.setEnabled(true)
                        } else if (count == maxCount) {
                            ibtn_x2jia.setEnabled(false)
                            ibtn_x2jian.setEnabled(true)
                        } else {
                            ibtn_x2jian.setEnabled(true)
                            ibtn_x2jia.setEnabled(true)
                        }
                    } else {
                        count = minCount
                        et_x2count.setText(minCount.toString())
                    }
                    val p = proList[ptn]
                    if (count.toDouble() != p.tqty) {
                        p.tqty = count.toDouble()
                        p.amount = Arith.mul(count.toDouble(), p.getPrice())
                        notifyMain.invoke()//相当于祖传代码的setChanged(),更新主界面底栏总价
                    }
                }
            })

            btn_detail.setOnClickListener {
                val intent = Intent(context, ShiFangDetailActivity::class.java).apply { putExtra("zuhebianma", tv_shi_num.getText().toString()) }
                (context as Activity).startActivity(intent)
            }

            et_x2count.setText(proList[pos].tqty.toInt().toString())
            cb_shi.setChecked(proList[pos].isChecked)
            ll_btns2.setVisibility(
                    if (proList[pos].isChecked) View.VISIBLE else View.INVISIBLE)
            btn_detail.setVisibility(
                    if (proList[pos].isChecked) View.INVISIBLE else View.VISIBLE)

        }
    }
    override fun getItemCount(): Int {
        return proList.size
    }
}

class ViewHolder2(view: View): RecyclerView.ViewHolder(view) {
    var tv_shi_name: TextView
    var tv_shi_num: TextView
    var rl_checkbox: RelativeLayout
    var cb_shi: CheckBox
    var btn_detail: Button

    var ll_btns2: LinearLayout
    var ibtn_x2jian: ImageButton
    var et_x2count: EditText
    var ibtn_x2jia: ImageButton

    init {
        tv_shi_name = view.find<TextView>(R.id.tv_shi_name)
        tv_shi_num = view.find<TextView>(R.id.tv_shi_num)
        rl_checkbox = view.find<RelativeLayout>(R.id.rl_checkbox)
        cb_shi = view.find<CheckBox>(R.id.cb_shi)
        btn_detail = view.find<Button>(R.id.btn_detail)

        ll_btns2 = view.find<LinearLayout>(R.id.ll_btns2)
        ibtn_x2jia = view.find<ImageButton>(R.id.ibtn_x2jia)
        ibtn_x2jian = view.find<ImageButton>(R.id.ibtn_x2jian)
        et_x2count = view.find<EditText>(R.id.et_x2count)
    }



}