package com.urovo.activity.addsellactivity.ui

import android.app.AlertDialog
import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.*
import androidx.appcompat.app.AppCompatActivity
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.addsellactivity.view.AddSellProShowAct
import com.urovo.wgmf.db.dao.entitys.ProductEntity
import com.urovo.wugumofang.R
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.data.Arith
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.utils.MyToast
import com.urovo.wugumofang.view.NumberKeyboard

/**
 * @author Sasuke on 2018/1/4.
 */
class WgmfAda(val context: Context, val proList: List<ProductEntity>, val isMemGoods: Boolean, val notifyMain: () -> Unit) : RecyclerView.Adapter<ViewHolder1>() {
    val keyboard: NumberKeyboard by lazy {
        NumberKeyboard.newInstance(null)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder1 {
        return ViewHolder1(LayoutInflater.from(context).inflate(R.layout.listview_pro_item_xdy, parent, false))
    }

    override fun onBindViewHolder(holder: ViewHolder1, pos: Int) {
        val view: View
        holder.apply {
            stockTv.visibility = if (isMemGoods) View.VISIBLE else View.GONE//只有会员商品才需要显示库存。
            stockTv.text = "库存:${proList[pos].stock_Qty}"
            ll_btns2.visibility = View.GONE
            tv_kg.visibility = View.GONE
            et_xcount.setSelectAllOnFocus(true)
            et_xcount.setOnClickListener {
                et_xcount.apply {
                    setText(et_xcount.getText().toString())
//                    selectAll()
                }
            }
            tv_after_name.setText(proList[pos].itemName)
            tv_after_danwei.setText("(${proList[pos].kcUom})")
            tv_after_bianma.setText("${proList[pos].price}元/${proList[pos].kcUom}")
            tv_item_id.setText(proList[pos].itemId)

            et_xcount.tag = pos

            rl_count_item_click.setOnClickListener {
                when (cb_pro.isChecked) {
                    true -> if (proList[pos].minCount > 0) MyToast.show("该产品为活动产品，不可以取消") else proList[pos].isChecked = false
                    false -> {
                        proList[pos].apply {
                            isChecked = true
                            tqty = if (isMemGoods) 0.0 else 1.0//会员商品可能会有库存为0的情况，那它就可以数量为0
                            amount = Arith.mul(price, tqty)
                        }
                    }
                }
                notifyDataSetChanged()
                notifyMain.invoke()//相当于祖传代码的setChanged(),更新主界面底栏总价
            }

            ibtn_xjian.setOnClickListener {
                var i = et_xcount.getText().toString().toInt()
                i--
                et_xcount.setText(i.toString())
                val ptn = et_xcount.getTag() as Int
                afterChangeWork(ptn, holder, i.toString())
            }

            ibtn_xjia.setOnClickListener {
                var i = et_xcount.getText().toString().toInt()
                i++
                holder.et_xcount.setText(i.toString())
                val ptn = et_xcount.getTag() as Int
                afterChangeWork(ptn, holder, i.toString())
            }

            et_xcount.setOnClickListener { v ->
                keyboard.show(v as TextView, (context as AppCompatActivity).supportFragmentManager) {
                    val ptn = et_xcount.getTag() as Int
                    afterChangeWork(ptn, holder, it)
                }.selectAll()
            }

//            et_xcount.addTextChangedListener(object : TextWatcher {
//                override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
//                }
//
//                override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
//                }
//
//                override fun afterTextChanged(p0: Editable?) {
//                    if (!proList[pos].isChecked) return
//                    val ptn = et_xcount.getTag() as Int
//                    val str = et_xcount.getText().toString()
//
//                    var count = 1
//                    var minCount = proList[ptn].minCount
//                    if (minCount == 0) {
//                        minCount = 1
//                    }
//                    if (str.isNotEmpty()) {
//                        count = str.toInt()
//
//                        if (count < minCount) {
//                            count = minCount
//                            holder.et_xcount.setText(count.toString())
//                            holder.ibtn_xjian.setEnabled(false)
//                            holder.ibtn_xjia.setEnabled(true)
//                        } else if (count == minCount) {
//                            holder.ibtn_xjian.setEnabled(false)
//                            holder.ibtn_xjia.setEnabled(true)
//                        } else if (count > maxCount) {
//                            count = maxCount
//                            holder.et_xcount.setText(count.toString())
//                            holder.ibtn_xjia.setEnabled(false)
//                            holder.ibtn_xjian.setEnabled(true)
//                        } else if (count == maxCount) {
//                            holder.ibtn_xjia.setEnabled(false)
//                            holder.ibtn_xjian.setEnabled(true)
//                        } else {
//                            holder.ibtn_xjian.setEnabled(true)
//                            holder.ibtn_xjia.setEnabled(true)
//                        }
//                    } else {
//                        count = minCount
//                        holder.et_xcount.setText(minCount.toString())
//                    }
//
//
//                    val p = proList[ptn]
//
//                    if (count.toDouble() != p.tqty) {
//                        p.tqty = count.toDouble()
//                        p.amount = Arith.mul(count.toDouble(), p.getPrice())
//                        notifyMain.invoke()
//                    }
//                }
//            })
            et_xcount.setText(proList[pos].tqty.toInt().toString())
            cb_pro.isChecked = proList[pos].isChecked
            ll_btns.visibility = if (proList[pos].isChecked) View.VISIBLE else View.GONE
            //跳转商品详情页
            if (proList[pos].brand == SystemHelper.MemGoodsBrand) {
                proInfoLayout.setOnClickListener {
                    context.startActivity(Intent(context, AddSellProShowAct::class.java).apply {
                        putExtra("PRO_ID", proList[pos].itemId)
                        putExtra("PRO_NAME", proList[pos].itemName)
                    })
                }
            }
        }
    }

    fun afterChangeWork(ptn: Int, holder: ViewHolder1, str: String?) {
        if (proList[ptn].isChecked) {
            val str: String = str ?: "0"
            //先把库存拿出来，并排除空的情况
            val stockQty = proList[ptn].stock_Qty.toInt()

            var count = 1
            var minCount = proList[ptn].minCount
            if (minCount == 0) {
                minCount = if (isMemGoods) 0 else 1//会员商品可能会有库存为0的情况，那它就可以数量为0
            }
            if (str.isNotEmpty()) {
                try {
                    count = str.toInt()
                } catch (e: NumberFormatException) {
                    e.printStackTrace()
                    count = 0
                }

                if (count < minCount) {
                    count = minCount
                    holder.et_xcount.setText(count.toString())
                    holder.ibtn_xjian.setEnabled(false)
                    holder.ibtn_xjia.setEnabled(true)
                } else if (count == minCount) {
                    holder.ibtn_xjian.setEnabled(false)
                    holder.ibtn_xjia.setEnabled(true)
                } else if (count > AppConstants.Printer.maxCount) {
                    count = AppConstants.Printer.maxCount
                    holder.et_xcount.setText(count.toString())
                    holder.ibtn_xjia.setEnabled(false)
                    holder.ibtn_xjian.setEnabled(true)
                    //录入数量不允许超过最大值99999
                    AlertDialog.Builder(context)
                            .setMessage("录入数量不允许超过最大值99999")
                            .setPositiveButton("我知道了", null)
                            .show()
                } else if (count == AppConstants.Printer.maxCount) {
                    holder.ibtn_xjia.setEnabled(false)
                    holder.ibtn_xjian.setEnabled(true)
                } else if (proList[ptn].isOverMemStock(count.toDouble())) {//如果输入的数量大于库存
                    count = stockQty
                    holder.et_xcount.setText(count.toString())
                    holder.ibtn_xjia.setEnabled(false)
                    holder.ibtn_xjian.setEnabled(true)
                    //会员商品录入数量不允许超过库存数量
                    AlertDialog.Builder(context)
                            .setMessage("录入数量不允许超过库存数量")
                            .setPositiveButton("我知道了", null)
                            .show()
                } else {
                    holder.ibtn_xjian.setEnabled(true)
                    holder.ibtn_xjia.setEnabled(true)
                }
            } else {
                count = minCount
                holder.et_xcount.setText(minCount.toString())
            }

            val p = proList[ptn]

            if (count.toDouble() != p.tqty) {
                p.tqty = count.toDouble()
                p.amount = Arith.mul(count.toDouble(), p.getPrice())
                notifyMain.invoke()
            }

        }
    }

    override fun getItemCount(): Int {
        return proList.size
    }

}

class ViewHolder1(view: View) : RecyclerView.ViewHolder(view) {
    var cb_pro: CheckBox
    //
    var ll_btns: LinearLayout
    var ll_btns2: LinearLayout

    var rl_count_item_click: RelativeLayout
    var tv_after_name: TextView
    var tv_after_bianma: TextView
    var tv_after_danwei: TextView
    var tv_item_id: TextView//产品编码
    var tv_kg: TextView//重量

    var ibtn_xjian: ImageButton
    var et_xcount: TextView
    var et_xcount2: TextView
    var ibtn_xjia: ImageView
    var stockTv: TextView
    var proInfoLayout: LinearLayout

    init {
        cb_pro = view.findViewById(R.id.cb_pro) as CheckBox
        rl_count_item_click = view.findViewById(R.id.rl_count_item_click) as RelativeLayout
        tv_after_name = view.findViewById(R.id.tv_after_name) as TextView
        tv_after_danwei = view.findViewById(R.id.tv_after_danwei) as TextView
        tv_after_bianma = view.findViewById(R.id.tv_after_bianma) as TextView
        tv_kg = view.findViewById(R.id.tv_kg) as TextView
        tv_item_id = view.findViewById(R.id.tv_item_id) as TextView
        ll_btns = view.findViewById(R.id.ll_btns) as LinearLayout
        ll_btns2 = view.findViewById(R.id.ll_btns2) as LinearLayout
        ibtn_xjian = view.findViewById(R.id.ibtn_xjian) as ImageButton
        et_xcount = view.findViewById(R.id.et_xcount) as TextView
        et_xcount2 = view.findViewById(R.id.et_xcount2) as TextView
        ibtn_xjia = view.findViewById(R.id.ibtn_xjia) as ImageView
        stockTv = view.findViewById(R.id.stockTv) as TextView
        proInfoLayout = view.findViewById(R.id.proInfoLayout) as LinearLayout
    }
}