package com.urovo.activity.addsellactivity.ui

import android.app.AlertDialog
import android.content.Context
import android.text.Editable
import android.text.TextWatcher
import android.view.View
import android.view.ViewGroup
import android.widget.*
import androidx.recyclerview.widget.RecyclerView
import com.urovo.wgmf.adapter.MyBaseAdapter
import com.urovo.wgmf.db.dao.entitys.ProductEntity
import com.urovo.wugumofang.R
import com.urovo.wugumofang.constants.AppConstants.Printer.maxCount
import com.urovo.wugumofang.data.Arith
import com.urovo.wugumofang.data.MoneyUtils
import com.urovo.wugumofang.system.SystemHelper
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2018/1/7.
 *
 * 以前这个是专门给五谷磨房产品显示已选专用的。。。现在两个品牌要求混录了，所以这一个adapter给大家一起共用
 */
class WgmfSelectAda(context: Context, val proList: List<ProductEntity>, val notifyMain: () -> Unit) : MyBaseAdapter<ProductEntity, ListView>(proList, context) {
    override fun getView(position: Int, convertView: View?, parent: ViewGroup): View {
        val view: View
        val holder: WgmfSelectVH
        if (convertView == null) {
            view = View.inflate(context, R.layout.listview_product_item3, null)
            holder = WgmfSelectVH(view)
            view.tag = holder
        } else {
            view = convertView
            holder = view.tag as WgmfSelectVH
        }

        holder.apply {
            ll_btns.visibility = if (lists[position].isDecimal) View.GONE else View.VISIBLE
            brandTv.run {
                //右上方显示品牌名称小气泡
                visibility = if (lists[position].brand == SystemHelper.XdyBrand) View.VISIBLE else View.INVISIBLE
                text = lists[position].brand
            }


            et_xcount.setSelectAllOnFocus(true)
            et_xcount.setOnClickListener {
                et_xcount.setText(et_xcount.text.toString())
                et_xcount.selectAll()
            }
            tv_after_name.setText(lists.get(position).getItemName())
            tv_after_danwei.text = "(" + lists.get(position).getKCUom() + ")"
            tv_after_bianma.text = "￥" + lists.get(position).getAmount()


            ibtn_xjian.setOnClickListener {
                var i = Integer.parseInt(et_xcount.text.toString())
                i--
                et_xcount.setText(i.toString() + "")
            }
            ibtn_xjia.setOnClickListener {
                var i = Integer.parseInt(et_xcount.text.toString())
                i++
                et_xcount.setText(i.toString() + "")
            }

            et_xcount.tag = position
            et_xcount.addTextChangedListener(object : TextWatcher {

                override fun onTextChanged(s: CharSequence, start: Int, before: Int, count: Int) {

                }

                override fun beforeTextChanged(s: CharSequence, start: Int, count: Int, after: Int) {

                }

                override fun afterTextChanged(s: Editable) {
                    val ptn = et_xcount.tag as Int
                    if (lists[ptn].isDecimal) return

                    //先把库存拿出来，并排除空的情况
                    val stockQty = proList[ptn].stock_Qty.toInt()

                    val str = et_xcount.text.toString()

                    var count = 1
                    var minCount = lists[ptn].minCount
                    if (minCount == 0) {
                        minCount = 1
                    }
                    if (str.isNotEmpty()) {
                        count = str.toInt()

                        if (count < minCount) {
                            count = minCount
                            holder.et_xcount.setText(count.toString())
                            holder.ibtn_xjian.setEnabled(false)
                            holder.ibtn_xjia.setEnabled(true)
                        } else if (count == minCount) {
                            holder.ibtn_xjian.setEnabled(false)
                            holder.ibtn_xjia.setEnabled(true)
                        } else if (count > maxCount) {
                            count = maxCount
                            holder.et_xcount.setText(count.toString())
                            holder.ibtn_xjia.setEnabled(false)
                            holder.ibtn_xjian.setEnabled(true)
                        } else if (count == maxCount) {
                            holder.ibtn_xjia.setEnabled(false)
                            holder.ibtn_xjian.setEnabled(true)
                        } else if (proList[ptn].isOverMemStock(count.toDouble())) {//如果输入的数量大于库存
                            count = stockQty
                            holder.et_xcount.setText(count.toString())
                            holder.ibtn_xjia.setEnabled(false)
                            holder.ibtn_xjian.setEnabled(true)
                            //会员商品录入数量不允许超过库存数量
                            AlertDialog.Builder(context)
                                    .setMessage("录入数量不允许超过库存数量")
                                    .setPositiveButton("我知道了", null)
                                    .show()
                        } else {
                            holder.ibtn_xjian.setEnabled(true)
                            holder.ibtn_xjia.setEnabled(true)
                        }
                    } else {
                        count = minCount
                        holder.et_xcount.setText(minCount.toString())
                    }

                    val p = lists.get(ptn)
                    if (count.toDouble() != p.getTQTY()) {
                        p.setTQTY(count.toDouble())
                        p.setAmount(Arith.mul(count.toDouble(), p.getPrice()))
                        if (count == 0) {
                            p.isChecked = false
                        }
                        tv_after_bianma.text = "￥" + MoneyUtils.twolastDF(p.getAmount())
                        notifyMain.invoke()
                    }
                }
            })
            et_xcount.setText(lists.get(position).run {
                if (this.isDecimal) getTQTY().toString()
                else MoneyUtils.nolastDF(tqty)
            })
        }
        return view
    }
}

class WgmfSelectVH(view: View) : RecyclerView.ViewHolder(view) {
    //
    var tv_after_name: TextView
    var tv_after_bianma: TextView
    var tv_after_danwei: TextView

    var ibtn_xjian: ImageButton
    var et_xcount: EditText
    var ibtn_xjia: ImageButton
    var ll_btns: LinearLayout
    var brandTv: TextView

    init {
        tv_after_name = view.find(R.id.tv_after_name)
        tv_after_danwei = view.find(R.id.tv_after_danwei)
        tv_after_bianma = view.find(R.id.tv_after_bianma)
        ibtn_xjian = view.find(R.id.ibtn_xjian)
        et_xcount = view.find(R.id.et_xcount)
        ibtn_xjia = view.find(R.id.ibtn_xjia)
        ll_btns = view.find(R.id.ll_btns)
        brandTv = view.find(R.id.brandTv)
    }
}