package com.urovo.activity.appraise;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.R;

/**
 * Created by Sasuke on 2016/3/24.
 */
public class AppraiseAct extends BaseActivity {
    ListView mainLv;
    String[] listItems = new String[]{"评价详情", "评价数据查询"/*,"","打赏数据查询"*/};
    TextView title;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.appraise_act_main);
        initTitle();
        title = (TextView) findViewById(R.id.text_title);
        assert title != null;
        title.setText("评价");
        ImageButton goback = (ImageButton) findViewById(R.id.back);
        assert goback != null;
        goback.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        getView();
        setListener();
        mainLv.setAdapter(new MyAdapter());
    }

    private void getView() {
        mainLv = (ListView) findViewById(R.id.appraise_lv);
    }

    private void setListener() {
        mainLv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Intent intent = new Intent(AppraiseAct.this, AppraiseWebAct.class);
                switch (position) {
                    case 0://评价详情
                        intent.putExtra("type", "detail");
                        intent.putExtra("URL", NetParam.APPRAISE_DETAIL);
                        break;
                    case 1://评价数据查询
                        intent.putExtra("type", "dataSearch");
                        intent.putExtra("URL", NetParam.APPRAISE_DATA_SEARCH);
                        break;
//                    case 3://打赏数据查询
//                        intent.putExtra("type", "daShang");
//                        intent.putExtra("URL", "https://torrents.ohys.net");
//                        break;
                }
                startActivity(intent);
            }
        });
    }

    class MyAdapter extends BaseAdapter {
        @Override
        public int getCount() {
            return listItems.length;
        }

        @Override
        public Object getItem(int position) {
            return null;
        }

        @Override
        public long getItemId(int position) {
            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            if (listItems[position].equals("")) {
                return View.inflate(AppraiseAct.this, R.layout.listview_item_data2, null);
            } else {
                LayoutInflater inflater = LayoutInflater.from(AppraiseAct.this);
                View view = inflater.inflate(R.layout.appraise_lv_item, parent,false);
                TextView itemText = (TextView) view.findViewById(R.id.item_text);
                itemText.setText(listItems[position]);
                return view;
            }
        }

    }


}
