package com.urovo.activity.attendancemanagement.attendancemanager;

import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.urovo.activity.attendancemanagement.attendancemanager.act.AttenHistoryAct;
import com.urovo.activity.attendancemanagement.attendancemanager.act.ShiftQueryAndConfirmAct;
import com.urovo.activity.attendancemanagement.attendancemanager.ada.AttendanceManagerAda;
import com.urovo.activity.attendancemanagement.attendancemanager.ent.FunItem;
import com.urovo.activity.attendancemanagement.attendancemanager.pre.ShiftSettingPre;
import com.urovo.wgmf.db.dao.dao.PrivilegeDbOperate;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.CommonController;
import com.urovo.wugumofang.response.CommonEntity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.system.ToActivity;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.ui.ada.helper.DividerItemDecoration;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 考勤管理  主菜单
 *
 * @author Administrator 考勤查询 签到签退
 */
public class AttendanceManagerMenu extends BaseActivity implements CommonController.BaseView<Boolean> {
    /**
     * 考勤管理列表item的权限
     */
    private String[] mFunctionPrivilege = {
            AppConstants.More.URL_CREW_ARRANGMENT_CHECK,
            AppConstants.More.NATIVE_ATTEN_HISTORY_ACT,
            AppConstants.More.NATIVE_SHIFT_QUERY_AND_CONFIRM_ACT
    };
    /**
     * 存储有权限的列表item
     */
    private List<FunItem> mFunctionList = new ArrayList<>();
    private Unbinder mBind;
    @BindView(R.id.attendance_manager_menu_rv)
    RecyclerView mAttendanceManagerListRv;
    //    @BindView(R.id.empty_view_container)
//    View mEmptyView;
    private ShiftSettingPre mShiftPre;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.menu_attendance_manager);
        mBind = ButterKnife.bind(this);
        initTitle();
        //是否显示排班设置
        mShiftPre = new ShiftSettingPre(this);
        init();
    }

    private void isShowShiftSetting(boolean isShowShiftSetting) {
        for (int i = 0; i < mFunctionList.size(); i++) {
            SYLoger.print("isShowShiftSetting-name-" + mFunctionList.get(i));
            if (mFunctionName[0].equals(mFunctionList.get(i)) && !isShowShiftSetting) {
                mFunctionList.remove(mFunctionList.get(i));
                i--;
            }
        }
        if (mFunctionList.isEmpty()) {
//            noPower();
            setEmptyLayout();
        }
        mAdapter.notifyDataSetChanged();
    }

    /**
     * 是否显示排班设置
     */
    private void shiftSettingTask() {
        Map<String, String> params = new HashMap<>(1);
        params.put("staffId", SystemHelper.LoginUserId);
        mShiftPre.onStart2requestData(params);
    }

    private FunItem[] mFunctionName = {
            new FunItem("排班设置", 0),
            new FunItem("考勤记录查询", 1),
            new FunItem("排班查询及确认", 2)
    };

    private AttendanceManagerAda mAdapter;

    private void init() {
        titleTextView.setText("考勤管理");
        SYLoger.print(" 权限： " + PrivilegeDbOperate.checkUserPrivilege(AppConstants.More.ATTENDANCE_MANAGER_MENU));
        //!true:无权限
//        if (!PrivilegeDbOperate.Companion.checkUserPrivilege(AppConstants.More.ATTENDANCE_MANAGER_MENU)) {
//            noPower();
//        } else {
//            mEmptyView.setVisibility(View.GONE);
        mFunctionList.clear();
        for (int i = 0; i < mFunctionName.length; i++) {
            if (PrivilegeDbOperate.checkUserPrivilege(mFunctionPrivilege[i])) {
                mFunctionList.add(mFunctionName[i]);
            }
        }
//            if (mFunctionList.isEmpty()) {
////                noPower();
//                setEmptyLayout();
//            }
        mAdapter = new AttendanceManagerAda(mFunctionList);
        mAttendanceManagerListRv.setHasFixedSize(true);
        LinearLayoutManager layoutManager = new LinearLayoutManager(this, RecyclerView.VERTICAL, false);
        mAttendanceManagerListRv.setLayoutManager(layoutManager);
        //禁止滑动
//            mAttendanceManagerListRv.setNestedScrollingEnabled(false);
        //分割线 (在布局添加了)
        mAttendanceManagerListRv.addItemDecoration(new DividerItemDecoration(this, DividerItemDecoration.VERTICAL_LIST, 1, ContextCompat.getColor(this, R.color.pop_query_devider)));
        mAttendanceManagerListRv.setAdapter(mAdapter);
        mAdapter.setOnItemChildClickListener(new BaseQuickAdapter.OnItemChildClickListener() {
            @Override
            public void onItemChildClick(BaseQuickAdapter baseQuickAdapter, View view, int position) {
                String itemText = ((TextView) view.findViewById(R.id.ItemText)).getText().toString();

//                    FunItem funItem = (FunItem) baseQuickAdapter.getData().get(position);
                click(itemText);
            }
        });
        shiftSettingTask();
//        }
    }

//    /**
//     * 暂无权限
//     */
//    private void noPower() {
//        mEmptyView.setVisibility(View.VISIBLE);
//        ((TextView) mEmptyView.findViewById(R.id.empty_view)).setText("暂无使用权限!");
//    }

    /**
     * 设置空布局
     */
    private void setEmptyLayout() {
        View notDataView = getLayoutInflater().inflate(R.layout.layout_empty_view, (ViewGroup) mAttendanceManagerListRv.getParent(), false);
        TextView emptyViewTv = (TextView) notDataView.findViewById(R.id.empty_view);
        emptyViewTv.setText("暂无使用权限!");
        mAdapter.setEmptyView(notDataView);
    }

    public void click(String itemName) {
        //排班设置
        if (itemName.equals(mFunctionName[0].funName)) {
            BaseCookiesWebFra.launch(AttendanceManagerMenu.this, String.format(NetParam.SHIFT_SETTING, SystemHelper.LoginOrganId, SystemHelper.LoginUserId), "", true);
        //考勤记录查询
        } else if (itemName.equals(mFunctionName[1].funName)) {
            ToActivity.toActivity(this, AttenHistoryAct.class);
        //排班查询及确认 ShiftQueryAndConfirmAct
        } else if (itemName.equals(mFunctionName[2].funName)) {
            ToActivity.toActivity(this, ShiftQueryAndConfirmAct.class);
        }
    }

    private Boolean isShowShiftSetting;

    @Override
    public void onResponseSuccess(CommonEntity<Boolean> resultInfo) {
        isShowShiftSetting = resultInfo.entity;
        isShowShiftSetting(isShowShiftSetting);
        SYLoger.print("isShowShiftSetting--" + isShowShiftSetting);
    }

    @Override
    public void onFailure(String failInfo) {
        isShowShiftSetting = false;
        MyToast.show(failInfo);
        isShowShiftSetting(isShowShiftSetting);
    }

    @Override
    protected void onDestroy() {
        if (mBind != null) {
            mBind.unbind();
        }
        super.onDestroy();
    }
}
