package com.urovo.activity.attendancemanagement.attendancemanager.act;

import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.google.gson.Gson;
import com.urovo.activity.attendancemanagement.attendancemanager.ada.ShiftQueryAdapter;
import com.urovo.activity.attendancemanagement.attendancemanager.ent.MultipleItem;
import com.urovo.activity.attendancemanagement.attendancemanager.ent.ShiftConfirmRequestEntity;
import com.urovo.activity.attendancemanagement.attendancemanager.ent.ShiftQueryEntity;
import com.urovo.activity.attendancemanagement.attendancemanager.pre.ShiftQueryAndConfirmPre;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.net.CommonController;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.response.CommonEntity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.CommonTools;
import com.urovo.wugumofang.utils.MyToast;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libext.utils.DateTimeUtils;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;


/**
 * 排班查询及确认
 *
 * @author chenji last on 2018/1/11 11:09
 */
public class ShiftQueryAndConfirmAct extends BaseActivity implements CommonController.ShiftBaseView<ShiftQueryEntity.ResultBean>, View.OnClickListener {
    @BindView(R.id.rv_list)
    RecyclerView mShiftRv;
    @BindView(R.id.last_month)
    LinearLayout mLastMonthBtn;
    @BindView(R.id.tv_last_month)
    TextView mLastMonthText;
    @BindView(R.id.next_month)
    LinearLayout mNextMonthBtn;
    @BindView(R.id.tv_next_month)
    TextView mNextMonthText;
    @BindView(R.id.tv_current_date)
    TextView mCurrentDateText;
    //    @BindView(R.id.cb_shift_confirm)
//    CheckBox mCheckBox;
//    @BindView(R.id.btn_shift_commit)
//    Button mCommitBtn;
    Unbinder unbinder;
    /**
     * 页面构成所有的控件的集合
     */
    private List<MultipleItem> mTotalList = new ArrayList<>();
    private ShiftQueryAdapter shiftItemAdapter;
    /**
     * 加载更多监听器监听时用来记录加载了几部分
     */
    private int mNextRequestPage;
    /**
     * 初始化recycleview一次加载显示最多几个部分(查询出来的列表信息和底部确认的按钮提示信息)
     */
    private final int ITEM_NUM = 2;

    /**
     * Item的子元素一行铺满的总列数(ps:一行最多能摆放几个子元素)
     */
    private final int ROW_ITEM_NUM = 1;
    boolean isRefresh = true;
    private ShiftQueryAndConfirmPre mShiftPre;
    private View notDataView;
    /**
     * 月份选择的变量-->-1:上个月 0:当前月 1:下个月
     */
    private int mMonthSelect = AppConstants.ShiftQueryAndConfirm.CURRENT_MONTH;

    private List<String> schedulingTimeList = new ArrayList<>();
    private String schedulingTime = "";
    private List<ShiftConfirmRequestEntity> shiftConfirmEntityList = new ArrayList<>();
    private long tempTimeStamp;
    //    String sureFlag = "1";
    private boolean isUnconfirmed;
    private MultipleItem confirmItem;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_shift_query_confirm);
        unbinder = ButterKnife.bind(this);
        initTitle();
        mShiftPre = new ShiftQueryAndConfirmPre(ShiftQueryAndConfirmAct.this);
        init();
        refresh(mMonthSelect);
    }

    private void refresh(int date) {
        //这里的作用是防止下拉刷新的时候还可以上拉加载
//        shiftItemAdapter.setEnableLoadMore(false);
//        isRefresh = true;
        if (NetHelper.IsHaveInternet(this)) {
            //网络请求 刷新当前选择的月份列表
            start2ShiftQueryTask(date);
        } else {
            showMsg("网络连接超时，请检查您的网络状态，稍后重试！");
        }
    }

    /**
     * 排班确认网络请求
     */
    private void start2ShiftConfirmTask(String json) {
        if (NetHelper.IsHaveInternet(this)) {
            Map<String, String> params = new HashMap<>(1);
            params.put("nutConSchedulingDayList", json);
            mShiftPre.onStart2ConfirmData(params);
        } else {
            showMsg("网络连接超时，请检查您的网络状态，稍后重试！");
        }
    }

    /**
     * 排班查询网络请求
     *
     * @param date 选择查询的月份
     */
    private void start2ShiftQueryTask(int date) {
        ViewUtil.showProgress(this, "正在玩命加载...", "请稍等...");
        //设置中间的日期显示
        mCurrentDateText.setText(DateTimeUtils.getMonth4Year("yyyy年MM月", date));

        Map<String, String> params = new HashMap<>(3);
        params.put("startTime", DateTimeUtils.getFirstDay4Month(date));
        params.put("endTime", DateTimeUtils.getFinalDay4Month(date));
        params.put("staffId", SystemHelper.LoginUserId);
//        params.put("staffId", "75602947");
        mShiftPre.onStart2requestData(params);
    }

    private void init() {
        mLastMonthBtn.setOnClickListener(this);
        mNextMonthBtn.setOnClickListener(this);
        setArrowStare(mLastMonthText, true, mNextMonthText, true);
//        mSwipeRefreshLayout.setColorSchemeColors(Color.rgb(47, 223, 189));
        mTotalList = getTotalList(ITEM_NUM, new ShiftQueryEntity.ResultBean());
        shiftItemAdapter = new ShiftQueryAdapter(mTotalList);
//        shiftItemAdapter.setOnLoadMoreListener(new BaseQuickAdapter.RequestLoadMoreListener() {
//            @Override
//            public void onLoadMoreRequested() {
//                loadMore();
//            }
//        }, mShiftRv);
//        shiftItemAdapter.setOnConfirmedListener(new ShiftQueryAdapter.OnConfirmedListener() {
//            @Override
//            public void setConfirmedText(TextView view) {
//                //将最近更新的日期按照要求的格式转化
//                view.setText(DateTimeUtils.getTimeStamp("yyyy年MM月dd日", String.valueOf(tempTimeStamp)));
//            }
//        });
        shiftItemAdapter.openLoadAnimation(BaseQuickAdapter.SLIDEIN_BOTTOM);
        final GridLayoutManager manager = new GridLayoutManager(this, ROW_ITEM_NUM);
        mShiftRv.setLayoutManager(manager);
        shiftItemAdapter.setSpanSizeLookup(new BaseQuickAdapter.SpanSizeLookup() {
            @Override
            public int getSpanSize(GridLayoutManager gridLayoutManager, int position) {
                return mTotalList.get(position).getSpanSize();
            }
        });
//        shiftItemAdapter.setLoadMoreView(new CustomLoadMoreView());
        mShiftRv.setAdapter(shiftItemAdapter);
        shiftItemAdapter.setOnItemChildClickListener(new BaseQuickAdapter.OnItemChildClickListener() {
            @Override
            public void onItemChildClick(BaseQuickAdapter baseQuickAdapter, View view, int position) {
                switch (view.getId()) {
                    case R.id.btn_shift_commit:
                        if (CommonTools.INSTANCE.isOneClick()) {
                            boolean isChecked = PreferHelper.getInstance().getBoolean(AppConstants.ShiftQueryAndConfirm.ISCHECKED, false);
                            if (isChecked) {
                                final String json = new Gson().toJson(shiftConfirmEntityList);
                                SYLoger.print("shiftConfirmEntityList-->" + shiftConfirmEntityList);
                                start2ShiftConfirmTask(json);
                            }
                        }
                        break;
                    default:
                        break;
                }
            }
        });
    }

    @Override
    public void onClick(View v) {
        final int id = v.getId();
        switch (id) {
            // 上个月
            case R.id.last_month:
                mMonthSelect -= 1;
                if (mMonthSelect == AppConstants.ShiftQueryAndConfirm.LAST_MONTH) {
                    setArrowStare(mLastMonthText, false, mNextMonthText, true);
                    mLastMonthBtn.setEnabled(false);
                    mNextMonthBtn.setEnabled(true);
                }
                if (mMonthSelect == AppConstants.ShiftQueryAndConfirm.CURRENT_MONTH) {
                    setArrowStare(mLastMonthText, true, mNextMonthText, true);
                    mLastMonthBtn.setEnabled(true);
                    mNextMonthBtn.setEnabled(true);
                }
                refresh(mMonthSelect);
                SYLoger.print("mMonthSelect--" + mMonthSelect);
                break;
            // 下个月
            case R.id.next_month:
                mMonthSelect += 1;
                if (mMonthSelect == AppConstants.ShiftQueryAndConfirm.NEXT_MONTH) {
                    setArrowStare(mLastMonthText, true, mNextMonthText, false);
                    mLastMonthBtn.setEnabled(true);
                    mNextMonthBtn.setEnabled(false);
                }
                if (mMonthSelect == AppConstants.ShiftQueryAndConfirm.CURRENT_MONTH) {
                    setArrowStare(mLastMonthText, true, mNextMonthText, true);
                    mLastMonthBtn.setEnabled(true);
                    mNextMonthBtn.setEnabled(true);
                }
                refresh(mMonthSelect);
                SYLoger.print("mMonthSelect--" + mMonthSelect);
                break;
            default:
                break;
        }
    }

    /**
     * 箭头显示的状态
     *
     * @param lastMonthText  上个月的tv
     * @param leftArrowFlag  左箭头的状态 ,true:深色,false:浅色
     * @param nextMonthText  下个月的tv
     * @param rightArrowFlag 右箭头的状态 ,true:深色,false:浅色
     */
    private void setArrowStare(TextView lastMonthText, boolean leftArrowFlag, TextView nextMonthText, boolean rightArrowFlag) {
        CommonTools.INSTANCE.setShowArrow(
                ShiftQueryAndConfirmAct.this,
                lastMonthText, CommonTools.ShowArrowDirection.left,
                leftArrowFlag,
                //true:显示
                R.drawable.go_left_press,
                R.drawable.go_left
        );
        CommonTools.INSTANCE.setShowArrow(
                ShiftQueryAndConfirmAct.this,
                nextMonthText, CommonTools.ShowArrowDirection.left,
                rightArrowFlag,
                //true:显示
                R.drawable.go_press,
                R.drawable.go_right
        );
    }

    private List<MultipleItem> getTotalList(int len, ShiftQueryEntity.ResultBean resultInfo) {
        //某月排班总信息列表
        final List<ShiftQueryEntity.ResultBean.NutConSchedulingDayListBean> dayList
                = resultInfo.getNutConSchedulingDayList();
        if (dayList != null) {
            //清空上次的缓存数据
            clear(mTotalList);
            shiftConfirmEntityList.clear();
            switch (len) {
                case 1:

                    break;
                case 2:
                    //遍历某月所有排班信息
                    StringBuilder builder = new StringBuilder();
                    for (int i = 0; i < dayList.size(); i++) {
                        ShiftConfirmRequestEntity confirmEntity = new ShiftConfirmRequestEntity();
                        //每天排班的更新时间，取最近的一次作为确认时间显示到用户确认后看到的时间信息
                        String nutConUpdateTime = dayList.get(i).getNutConUpdateTime();
                        try {
                            long timestamp = DateTimeUtils.getTimestamp(nutConUpdateTime);
                            //遍历当月所有天取到的排班更新时间，取最大的值
                            tempTimeStamp = (tempTimeStamp < timestamp) ? timestamp : tempTimeStamp;
                        } catch (ParseException e) {
                            MyToast.show("排班更新时间解析失败！");
                            e.printStackTrace();
                        }
                        //如果获取到确认标记为"1",就把ISUNCONFIRMED标记为true,在adapter中去显示未确认的按钮信息,确认完后ISUNCONFIRMED改成false
                        String sureFlag = dayList.get(i).getSureflag();
                        SYLoger.print("sureFlag-->" + sureFlag);
                        builder.append(sureFlag);
                        //排班日期列表的ID
                        int schedulingId = dayList.get(i).getId();
                        //排班日期(ex:11月01日)
                        String schedulingDay = dayList.get(i).getSchedulingDay();

                        //排班日期列表的ID+排班日期 存到排班确认对象模型中
                        confirmEntity.setId(schedulingId);
                        confirmEntity.setSchedulingDay(schedulingDay);
                        shiftConfirmEntityList.add(confirmEntity);

                        //上班的地点(店名)
                        String shopName = dayList.get(i).getShop().getShopName();
                        // 例休还是正常排班标识
//                        final String caseHughFlag = dayList.get(i).getCaseHughFlag();
                        //排班时间列表(ex:07:00--10:00;11:00--12:00;14:00--16:00;19:00--21:00;)
//                        final List<ShiftQueryEntity.ResultBean.NutConSchedulingDayListBean.NutConSchedulingTimeBean> nutConSchedulingTime = dayList.get(i).getNutConSchedulingTime();
//                        schedulingTime = "1".equals(caseHughFlag) ? "例休" : makeSchedulingTimeFormat(nutConSchedulingTime);
                        //后台传的排班标识 直接显示
                        String caseHughFlagChinese = dayList.get(i).getCaseHughFlagChinese();
                        //把日期格式转化成要求的**月**日
                        String[] split = schedulingDay.split("-");
                        schedulingDay = split[1] + "月" + split[2] + "日";
                        SYLoger.print("schedulingDay--" + schedulingDay);
                        mTotalList.add(new MultipleItem(MultipleItem.TEXT, MultipleItem.TEXT_SPAN_SIZE, schedulingDay, shopName, caseHughFlagChinese));
                    }
                    SYLoger.print("sureFlag1-->" + builder.toString().contains(AppConstants.ShiftQueryAndConfirm.UNCONFIRMED));
                    //排班确认标志
                    isUnconfirmed = builder.toString().contains(AppConstants.ShiftQueryAndConfirm.UNCONFIRMED);
                    confirmItem = new MultipleItem(MultipleItem.TEXT_BUTTON, MultipleItem.TEXT_BUTTON_SPAN_SIZE, isUnconfirmed, String.valueOf(tempTimeStamp));
                    mTotalList.add(confirmItem);
                    break;
                default:
                    break;
            }
        }
        return mTotalList;
    }

    /**
     * 排班时间列表信息的样式设置
     * ps:从排班集合中取出起始和结束时间,组合好并存到集合中,后面展示所有的排班时间信息到TextView中
     *
     * @param nutConSchedulingTime 排班时间列表
     */
    private String makeSchedulingTimeFormat(List<ShiftQueryEntity.ResultBean.NutConSchedulingDayListBean.NutConSchedulingTimeBean> nutConSchedulingTime) {
        schedulingTime = "";
        schedulingTimeList.clear();
        for (int j = 0; j < nutConSchedulingTime.size(); j++) {
            //排班开始时间
            final String schedulingStartTime = nutConSchedulingTime.get(j).getSchedulingStartTime();
            //排班结束时间
            final String schedulingEndTime = nutConSchedulingTime.get(j).getSchedulingEndTime();

//         ===============================   定制每个时间段呈现的样式   ============================
            //最后一个元素的排版
            if (j == nutConSchedulingTime.size() - 1) {
                schedulingTimeList.add(schedulingStartTime + "--" + schedulingEndTime + "\t");
            }
            //序号为偶数的元素的排版
            else if (j % 2 == 0) {
                schedulingTimeList.add(schedulingStartTime + "--" + schedulingEndTime + "; \t");
            }
            //序号为奇数的元素的排版
            else {
                schedulingTimeList.add(schedulingStartTime + "--" + schedulingEndTime + "; \t\n");
            }
        }

        //==========================拼接组装已经设置好样式的定制的时间段=============================
        for (String sc : schedulingTimeList) {
            schedulingTime = String.format("%s%s", schedulingTime, sc);
        }
        return schedulingTime;
    }

    /**
     * 清空集合
     */
    private void clear(List mTotalList) {
        if (mTotalList != null && !mTotalList.isEmpty()) {
            mTotalList.clear();
        }
    }

    @Override
    public void onDestroy() {
        if (unbinder != null) {
            unbinder.unbind();
        }
        super.onDestroy();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText("我的排班");
    }

    /**
     * 排班查询成功回调
     *
     * @param resultInfo ...
     */
    @Override
    public void onResponseSuccess(CommonEntity<ShiftQueryEntity.ResultBean> resultInfo) {
        ViewUtil.dismissProgress();
        final ShiftQueryEntity.ResultBean entity = resultInfo.entity;
        if (entity == null) {
            setEmptyLayout();
        } else if (entity.getNutConSchedulingDayList() == null) {
            setEmptyLayout();
        } else if (entity.getNutConSchedulingDayList().isEmpty()) {
            setEmptyLayout();
        } else {
            mTotalList = getTotalList(ITEM_NUM, entity);
        }
        shiftItemAdapter.notifyDataSetChanged();
    }

    /**
     * 设置空布局
     */
    private void setEmptyLayout() {
        mTotalList.clear();
        notDataView = getLayoutInflater().inflate(R.layout.layout_empty_view, (ViewGroup) mShiftRv.getParent(), false);
        TextView emptyViewTv = (TextView) notDataView.findViewById(R.id.empty_view);
        emptyViewTv.setText("暂无数据");
        shiftItemAdapter.setEmptyView(notDataView);
    }

    /**
     * 排班查询和确认失败通用一个回调
     *
     * @param failInfo ...
     */
    @Override
    public void onFailure(String failInfo) {
        ViewUtil.dismissProgress();
        MyToast.show(failInfo);
    }

    /**
     * 排班确认成功
     *
     * @param resultInfo ...
     */
    @Override
    public void onConfirmResponseSuccess(String resultInfo) {
        MyToast.show(resultInfo);
        //提交成功后,必须设置成false,排班确认信息才会显示出来(具体逻辑在ShiftQueryAdapter)
        isUnconfirmed = false;
        updateConfirmInfo();
    }

    private void updateConfirmInfo() {
        mTotalList.remove(confirmItem);
        mTotalList.add(new MultipleItem(MultipleItem.TEXT_BUTTON, MultipleItem.TEXT_BUTTON_SPAN_SIZE, isUnconfirmed, String.valueOf(tempTimeStamp)));
//        shiftItemAdapter.notifyItemChanged(1);
        shiftItemAdapter.notifyDataSetChanged();
    }
}
