package com.urovo.activity.attendancemanagement.attendancemanager.ada

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.attendancemanagement.attendancemanager.ent.AttenHistoryRes
import com.urovo.wugumofang.R
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2018/1/16.
 */
class AttenHisAdapter(val context: Context,val dataList: List<AttenHistoryRes.ReturnBean>): RecyclerView.Adapter<AttenHisHolder>(){
    private lateinit var header: View
    private lateinit var mParent: RecyclerView

    override fun onAttachedToRecyclerView(recyclerView: RecyclerView) {
        super.onAttachedToRecyclerView(recyclerView)
        mParent = recyclerView
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): AttenHisHolder {
        return AttenHisHolder(LayoutInflater.from(context).inflate(R.layout.atten_his_list_item,parent,false))
    }

    override fun onBindViewHolder(holder: AttenHisHolder, pos: Int) {
        holder.container.removeAllViews()
        when(true){
            //设置头
            getPos(pos) <= -1 -> holder.apply {
                childTitle.visibility = View.GONE
                //you must call removeview() on the child's parent first
                container.addView(header.apply { parent?.let { (it as ViewGroup).removeView(header) } })
            }
            //设置具体数据
            else -> holder.apply {
                childTitle.visibility = View.VISIBLE
                dataList[getPos(pos)].apply { childTitle.text = "${this.dataTime}  ${this.dayOfWeek}"
                    //如果详情为空，就显示“无考勤记录”
                    if(recordList.isEmpty() ){
                        val view: View = LayoutInflater.from(context).inflate(R.layout.atten_his_detail_item,mParent,false)
                        view.find<TextView>(R.id.wukaoqinjilu).visibility = View.VISIBLE
                        container.addView(view)
                    }
                    //如果详情不为空，就一个个插进container里面去
                    this.recordList.forEachIndexed { index, recordList ->
                        val view: View = LayoutInflater.from(context).inflate(R.layout.atten_his_detail_item,mParent,false)
                        view.find<TextView>(R.id.wukaoqinjilu).visibility = View.GONE
                        view.find<TextView>(R.id.qiandaoTitle).text = "签到${index + 1}："
                        view.find<TextView>(R.id.qiandaoTime).text = "${recordList.signIn}"
                        view.find<TextView>(R.id.qiantuiTitle).text = "签退${index + 1}："
                        view.find<TextView>(R.id.qiantuiTime).text = "${recordList.signOut}"
                        container.addView(view)
                    }
                }

            }
        }
    }

    override fun getItemCount(): Int {
        return dataList.size + 1//包含了headerView
    }

    fun getPos(pos: Int): Int{
        return pos - 1
    }

    fun addHeaderView(view: View){
        this.header = view
    }
}

class AttenHisHolder(view: View): RecyclerView.ViewHolder(view){
    var childTitle: TextView
    var container: LinearLayout
    init {
        childTitle = view.find(R.id.childTitle)
        container = view.find(R.id.childContainer)
    }
}