package com.urovo.activity.attendancemanagement.attendancemanager.ada;


import android.graphics.Color;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;

import com.chad.library.adapter.base.BaseMultiItemQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.urovo.activity.attendancemanagement.attendancemanager.ent.MultipleItem;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.PreferHelper;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libext.utils.DateTimeUtils;

import java.util.List;

/**
 * @author chenji
 */
public class ShiftQueryAdapter extends BaseMultiItemQuickAdapter<MultipleItem, BaseViewHolder> {
    /**
     * 添加type类型和布局
     */
    public ShiftQueryAdapter(List<MultipleItem> data) {
        super(data);
//      排班查询列表信息
        addItemType(MultipleItem.TEXT, R.layout.shift_query_item);
//       排班确认按钮
        addItemType(MultipleItem.TEXT_BUTTON, R.layout.shift_confirm_item);
    }

    @Override
    protected void convert(BaseViewHolder helper, final MultipleItem item) {
        switch (helper.getItemViewType()) {
            case MultipleItem.TEXT:
                final String[] shiftInfo = item.getStringArray();
                //排班日期(ex:11月01日)
                final String schedulingDay = shiftInfo[0];
                helper.setText(R.id.shift_query_date, schedulingDay);

                //上班的地点(店名)
                final String shopName = shiftInfo[1];
                helper.setText(R.id.shift_shop_name, shopName);

                //ps-->old:排班时间列表(ex:07:00--10:00;11:00--12:00;14:00--16:00;19:00--21:00;) 作废
                //ps-->new:例休还是正常排班标识中文 解释： 早班 、中班 、晚班 、直落班 、做一休一（工作）、做一休一（休息）、高峰班 、例休 、月会培训
                final String caseHughFlagChinese = shiftInfo[2];
                helper.setText(R.id.shift_time, caseHughFlagChinese);
                break;
//
            case MultipleItem.TEXT_BUTTON:
                final boolean isUnconfirmed = item.isBoolean();
                SYLoger.print("isUnconfirmed--" + isUnconfirmed);
                helper.setVisible(R.id.ll_shift_container, isUnconfirmed);
                helper.setVisible(R.id.tv_shift_confirm, !isUnconfirmed);
                //用户已确认排班信息-->点击提交按钮返回成功后，隐藏提交按钮信息，切换到确认提示语信息。
                if (!isUnconfirmed) {
                    String confirmedDate = DateTimeUtils.getTimeStamp("yyyy年MM月dd日", item.getContent());
                    helper.setText(R.id.tv_shift_confirm, "以上排班信息已于" + confirmedDate + "确认，\n无需再次确认！");
//                    mOnConfirmedListener.setConfirmedText((TextView) helper.getView(R.id.tv_shift_confirm));
                } else {
                    // isUnconfirmed为true 时,可以看到未确认信息
                    helper.addOnClickListener(R.id.btn_shift_commit);

                    final CheckBox checkBox = helper.getView(R.id.cb_shift_confirm);
                    final Button commitBtn = helper.getView(R.id.btn_shift_commit);
                    checkBox.setChecked(false);
                    commitStatus(commitBtn, checkBox.isChecked());
                    checkBox.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            commitStatus(commitBtn, checkBox.isChecked());
                            PreferHelper.getInstance().setBoolean(AppConstants.ShiftQueryAndConfirm.ISCHECKED, checkBox.isChecked());
                        }
                    });
                }
                break;
            default:
                break;
        }
    }

    /**
     * 确认的状态
     *
     * @param flag ...
     */
    private void commitStatus(Button commitBtn, boolean flag) {
        commitBtn.setBackgroundResource(flag ? R.drawable.orange_user_background : R.drawable.gray_userl_background);
        commitBtn.setTextColor(flag ? Color.WHITE : Color.BLACK);
    }

//    private OnConfirmedListener mOnConfirmedListener;
//
//    public void setOnConfirmedListener(OnConfirmedListener onConfirmedListener) {
//        mOnConfirmedListener = onConfirmedListener;
//    }
//
//    public interface OnConfirmedListener {
//        void setConfirmedText(TextView view);
//    }
}
