package com.urovo.activity.attendancemanagement.attendancemanager.ent;

import com.chad.library.adapter.base.entity.MultiItemEntity;

import java.util.List;

/**
 * @author chenji
 */
public class MultipleItem<T> implements MultiItemEntity {
    /**
     * 不用布局的type类型
     */
    public static final int
            TEXT = 0,
            TEXT_BUTTON = 1;
    /**
     * 一行中item占用的总列数,如果等于最先设定的上限列数,则说明该item是铺满一行的
     */
    public static final int
            TEXT_SPAN_SIZE = 1,
            TEXT_BUTTON_SPAN_SIZE = 1;

    private int itemType;
    private int spanSize;
    private String content;
    private List<T> list;
    private String[] str;
    private T t;
    private int position;

    public boolean isBoolean() {
        return b;
    }

    public void setBoolean(boolean b) {
        this.b = b;
    }

    private boolean b;

    public MultipleItem(int itemType, int spanSize, String content) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.b = b;
        this.content = content;
    }

    public MultipleItem(int itemType, int spanSize, Boolean b, String content) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.b = b;
        this.content = content;
    }

    public MultipleItem(int itemType, int spanSize, T t) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.t = t;
    }

    public MultipleItem(int itemType, int spanSize, Boolean b) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.b = b;
    }

    public MultipleItem(int itemType, int spanSize, int position) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.position = position;
    }

    public MultipleItem(int itemType, int spanSize, T t, int position) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.t = t;
        this.position = position;
    }

    public MultipleItem(int itemType, int spanSize, String... str) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.str = str;
    }

    public MultipleItem(int itemType, int spanSize, List<T> list) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.list = list;
    }

    public MultipleItem(int itemType, int spanSize) {
        this.itemType = itemType;
        this.spanSize = spanSize;
    }

    public int getSpanSize() {
        return spanSize;
    }

    public void setSpanSize(int spanSize) {
        this.spanSize = spanSize;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public List<T> getList() {
        return list;
    }

    public void setList(List<T> list) {
        this.list = list;
    }

    public String[] getStringArray() {
        return str;
    }

    public void setStringArray(String[] str) {
        this.str = str;
    }

    public T getT() {
        return t;
    }

    public void setT(T t) {
        this.t = t;
    }

    public int getPosition() {
        return position;
    }

    public void setPosition(int position) {
        this.position = position;
    }

    @Override
    public int getItemType() {
        return itemType;
    }
}
