package com.urovo.activity.attendancemanagement.vacation;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.Spinner;
import android.widget.TextView;

import com.google.gson.Gson;
import com.urovo.wgmf.entity.response.BreakHoursRes;
import com.urovo.wgmf.entity.response.LeaveTypeRes;
import com.urovo.wgmf.entity.response.NianJiaResponse;
import com.urovo.wgmf.entity.response.StaffManagerRes;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.ConstantParams;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.DataMonthUtils;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.JsonDominator;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.response.BaseSimpleResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.AnimeUtil;
import com.urovo.wugumofang.ui.PhotoPickDominator;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.view.TextSwitcherDominator;
import com.zsy.libext.utils.DateTimeUtils;

import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;
import okhttp3.Request;

/**
 * @author Sasuke
 * @date 2016/4/13
 * 请假申请
 */
public class AskAbsenceAct extends BaseActivity implements View.OnClickListener {
    /**
     * 最多传1张图片
     */
    @SuppressWarnings("all")
    private final int MAX_PHOTO_NUM = 3;

    public static final int INTENT_QINGJIA = 0;//intent 请假

    public static final int INTENT_TIAOXIU = 1;//intent 调休

    /**
     * 申请人
     */
    @BindView(R.id.user_name)
    TextView userName;
    /**
     * 请假类型
     */
    @BindView(R.id.type)
    LinearLayout type;
    /**
     * 请假类型
     */
    @BindView(R.id.last_nianjia_ll)
    LinearLayout lastNianjiaLl;
    /**
     * 开始时间
     */
    @BindView(R.id.start)
    LinearLayout start;
    /**
     * 结束时间
     */
    @BindView(R.id.end)
    LinearLayout end;
    /**
     * 提交申请按钮
     */
    @BindView(R.id.qingjia_submit)
    Button submit;

    /**
     * 请假类型
     */
    @BindView(R.id.qingjia_type)
    Spinner qingjiaType;
    /**
     * 请假开始时间
     */
    @BindView(R.id.start_time)
    TextView startTime;
    /**
     * 请假结束时间
     */
    @BindView(R.id.end_time)
    TextView endTime;
    /**
     * 请假天数（不可以改！）
     */
    @BindView(R.id.days_amount)
    TextView daysAmount;
    Double lastNianjia = 0.0;
    /**
     * 剩余请假
     */
    @BindView(R.id.lastTiaoxiu)
    TextView lastTiaoxiu;
    /**
     * 所选日期当天可请调休
     */
    @BindView(R.id.todayCanTiaoxiu)
    TextView todayCanTiaoXiu;
    /**
     * 请假原因
     */
    @BindView(R.id.reason_input)
    EditText reasonInput;
    /**
     * 上传图片
     */
    @BindView(R.id.llUploadPhoto)
    LinearLayout uploadPhoto;
    /**
     * 底下一行显示已选图片的区域
     */
    @BindView(R.id.photoGroup)
    LinearLayout photoGroup;
    /**
     * 添加图片按钮
     */
    @BindView(R.id.cameraAdd)
    ImageView cameraAdd;

    /**
     * 我的上级Tv
     */
    @BindView(R.id.staffManagerTv)
    TextView staffManagerTv;
    /**
     * 我的上级Spinner
     */
    @BindView(R.id.staffManagerSpinner)
    Spinner staffManagerSpinner;

    /**
     * 请假申请 布局
     */
    @BindView(R.id.qingjiaLayout)
    LinearLayout qingjiaLayout;
    /**
     * 调休申请 布局
     */
    @BindView(R.id.tiaoxiuLayout)
    LinearLayout tiaoxiuLayout;

    @BindView(R.id.scrollView)
    ScrollView scrollView;

    /**
     * 底部说明文字
     */
    @BindView(R.id.bottomText)
    TextView bottomText;

    /**
     * 调休开始日期
     */
    @BindView(R.id.startDateTiaoXiu)
    TextView startDateTiaoXiu;

    /**
     * 调休开始时间
     */
    @BindView(R.id.startTimeTiaoXiu)
    TextView startTimeTiaoXiu;

    /**
     * 调休结束日期
     */
    @BindView(R.id.endDateTiaoXiu)
    TextView endDateTiaoXiu;

    /**
     * 调休结束时间
     */
    @BindView(R.id.endTimeTiaoXiu)
    TextSwitcherDominator endTimeTiaoXiu;

    /**
     * 小时加按钮
     */
    @BindView(R.id.hourPlus)
    ImageButton hourPlusBtn;

    /**
     * 小时减按钮
     */
    @BindView(R.id.hourMinus)
    ImageButton hourMinusBtn;

    /**
     * 小时数
     */
    @BindView(R.id.hourNum)
    TextView hourNum;

    /**
     * 登陆门店
     */
    @BindView(R.id.shopNameLayout)
    LinearLayout shopNameLayout;

    /**
     * 登陆门店TextView
     */
    @BindView(R.id.shop_name)
    TextView shopNameTv;


    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
    SimpleDateFormat timeFormat = new SimpleDateFormat("HH:mm", Locale.CHINA);
    /**
     * 今天的日期
     */
    String todayDate;

    private List<LeaveTypeRes.ResultInfo> mLeaveTypeList = new ArrayList<>();

    private final static int START_TIME = 0;
    private final static int END_TIME = 1;
    /**
     * 添加照片的工具
     */
    private PhotoPickDominator picker;
    private Unbinder unbinder;

    private String id;

    private int askType = INTENT_QINGJIA;//是请假还是调休，默认请假

    //上级
    private List<StaffManagerRes.ResultInfo> managerCaches;


    /**
     * 获取ID，用来传给后台作为唯一标识。
     *
     * @return
     */
    private String getId() {
        if (TextUtils.isEmpty(id)) {
            id = SystemHelper.LoginUserId + new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
        }
        return id;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ll_ask_absence);
        unbinder = ButterKnife.bind(this);
        initTitle();
        init();
        setListener();
    }

    private void init() {
        scrollView.setFocusableInTouchMode(true);
        scrollView.requestFocus();//解决起始位置不是ScrollView的顶部的问题。

        askType = getIntent().getIntExtra("type", INTENT_QINGJIA);
        getId();//一进来就先初始化一下id单号
        picker = new PhotoPickDominator(this);
        shopNameLayout.setVisibility(askType == INTENT_QINGJIA ? View.GONE : View.VISIBLE);
        shopNameTv.setText(SystemHelper.LoginOrganName);
        titleTextView.setText(askType == INTENT_QINGJIA ? "请假申请" : "调休申请");
        qingjiaLayout.setVisibility(askType == INTENT_QINGJIA ? View.VISIBLE : View.GONE);
        tiaoxiuLayout.setVisibility(askType == INTENT_TIAOXIU ? View.VISIBLE : View.GONE);
        bottomText.setText("说明：\n" +
                "1、调休类型的最小单位为4小时，当天最多可调休8小时！\n" +
                "2、请根据门店当天实际的上班时长进行调休小时申请，否则将会浪费调休时长或造成考勤异常！");
        bottomText.setVisibility(askType == INTENT_QINGJIA ? View.GONE : View.VISIBLE);//只有调休才显示

        userName.setText(SystemHelper.LoginUserName);
        Date now = new Date();
        todayDate = dateFormat.format(now);
        //startTime.setText(todayDate);
        //endTime.setText(todayDate);

        queryVactiondetail();//查询剩余年假
        if (askType == INTENT_TIAOXIU) {
            queryBreakHours();  //查询可调休数
        }
        queryStaffManager();//查询上级
        //queryLeaveTypeList(todayDate, todayDate); //请假类型
    }

    /**
     * 刷新调休结束日期时间
     */
    public void notifyTiaoxiuEndTime(int hour) {
        try {
            String startDate = startDateTiaoXiu.getText().toString();
            String startTime = startTimeTiaoXiu.getText().toString();
            if (TextUtils.isEmpty(startDate) || TextUtils.isEmpty(startTime))
                return;//没有修改完整的时候，不需要刷新结束日期时间
            Date startDateTime = new SimpleDateFormat("yyyy-MM-dd HH:mm").parse(startDate + " " + startTime);//DateUtil.parseDate(startDate + " " + startTime,"yyyy-MM-dd HH:mm");
            //防止先选择更晚的日期，再选择更早的时刻，再返回来选择今天的日期，那就相当于把时刻的限制给绕过了（常规时间校验也放在这里）
            if ((startDate + " " + startTime).compareTo(new SimpleDateFormat("yyyy-MM-dd HH:mm").format(new Date())) < 0) {
                showMsg("不能早于当前时间：" + new SimpleDateFormat("yyyy-MM-dd HH:mm").format(new Date()));
                startDateTiaoXiu.setText(todayDate);
                startTimeTiaoXiu.setText(timeFormat.format(new Date()));
                startDateTime = new Date();
            }

            Date endDateTime = DateUtil.getDayAfterHours(startDateTime, hour);
            endDateTiaoXiu.setText(dateFormat.format(endDateTime));
            endTimeTiaoXiu.setText(timeFormat.format(endDateTime));
        } catch (ParseException e) {
            e.printStackTrace();
        }
    }

    /**
     * 查询可调休数
     */
    private void queryBreakHours() {
        ViewUtil.showProgress(this, "请稍等", "正在查询剩余调休...");
        Map<String, String> params = new HashMap<>(2);
        params.put("staffId", SystemHelper.LoginUserId);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.QUERY_BREAK_HOURS, params,
                new OkHttpDominator.ResultCallback<BreakHoursRes>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        if (isFinishing()) return;
                        ViewUtil.dismissProgress();
                        new AlertDialog.Builder(AskAbsenceAct.this).setMessage("获取剩余调休时长失败！")
                                .setCancelable(true)
                                .setPositiveButton("重试", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        queryBreakHours();
                                    }
                                }).show();
                    }

                    @Override
                    public void onResponse(BreakHoursRes res) {
                        if (isFinishing()) return;
                        ViewUtil.dismissProgress();
                        if (res == null) {
                            return;
                        }
                        if (res.msgCode == 0) {
                            lastTiaoxiu.setText(res.getResultInfo() + "小时");
                        }
                    }
                });
    }


    /**
     * 查询当天可申请调休数
     */
    private void queryBreakHoursToday(String startDay) {
        if (startDay.equals("--")) return;
        ViewUtil.showProgress(this, "请稍等", "正在查询当天可请调休...");
        Map<String, String> params = new HashMap<>(2);
        params.put("staffId", SystemHelper.LoginUserId);
        params.put("shopId", SystemHelper.LoginOrganId);
        params.put("startDay", startDay);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.BREAK_HOURS_TODAY, params,
                new OkHttpDominator.ResultCallback<BreakHoursRes>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        if (isFinishing()) return;
                        ViewUtil.dismissProgress();
                        new AlertDialog.Builder(AskAbsenceAct.this).setMessage("获取剩余当日可调休时长失败！")
                                .setCancelable(true)
                                .setPositiveButton("重试", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        queryBreakHoursToday(startDateTiaoXiu.getText().toString().replace("小时", ""));
                                    }
                                }).show();
                    }

                    @Override
                    public void onResponse(BreakHoursRes res) {
                        if (isFinishing()) return;
                        ViewUtil.dismissProgress();
                        if (res == null) {
                            todayCanTiaoXiu.setText("--小时");
                            return;
                        }
                        if (res.msgCode == 0) {
                            todayCanTiaoXiu.setText(res.getResultInfo() + "小时");
                        }
                    }
                });
    }

    /**
     * 查询请假类型接口
     */
    private void queryLeaveTypeList(String startTime, String endTime) {
        Map<String, String> params = new HashMap<>(1);
        params.put("staffId", SystemHelper.LoginUserId);
        params.put("startTime", startTime);
        params.put("endTime", endTime);
        OkHttpDominator.getAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.ASK_FOR_LEAVE_OPTION, params,
                new OkHttpDominator.ResultCallback<LeaveTypeRes>() {
                    @Override
                    public void onError(Request request, Exception e) {

                    }

                    @SuppressLint("SetTextI18n")
                    @Override
                    public void onResponse(LeaveTypeRes res) {
                        if (isFinishing()) return;
                        if (res == null || res.getResultInfo() == null) {
                            showMsg("选择时间段内没有可请假的类型，请找文员在工资平台配置");
                            return;
                        }
                        if (res.msgCode == 0) {
                            mLeaveTypeList = res.getResultInfo();
                            //刷新请假数据
                            refreshAskForLeaveAdapter();
                        }
                    }
                });
    }


    /**
     * 查询还剩多少天年假
     */
    private void queryVactiondetail() {
        Map<String, String> params = new HashMap<>(2);
        params.put("empno", SystemHelper.LoginUserId);
        params.put("year", Calendar.getInstance().get(Calendar.YEAR) + "");
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.QUERY_VACTIONDETAIL, params,
                new OkHttpDominator.ResultCallback<NianJiaResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {

                    }

                    @SuppressLint("SetTextI18n")
                    @Override
                    public void onResponse(NianJiaResponse res) {
                        if (isFinishing()) return;
                        if (res == null || res.getResultInfo() == null) {
                            return;
                        }
                        if (res.msgCode == 0) {
//                            lastNianjia.setText(res.getResultInfo().getLastVacationDays() + "天" + res.getResultInfo().getVacationRemark());
                            lastNianjia = res.getResultInfo().getLastVacationDays();
                        }
                    }
                });
    }

    /**
     * 初始化请假适配器
     */
    private void refreshAskForLeaveAdapter() {
        if (mLeaveTypeList.size() <= 0) {
            showMsg("选择时间段内没有可请假的类型，请找文员在工资平台配置");
        }
        String[] array = new String[mLeaveTypeList.size()];
        for (int i = 0; i < mLeaveTypeList.size(); i++) {
            array[i] = mLeaveTypeList.get(i).getName();
        }
        qingjiaType.setAdapter(new ArrayAdapter(this,
                R.layout.gray_spinner_dropdown_item, array));
        refreshVisibility(qingjiaType.getSelectedItemPosition());

        qingjiaType.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                refreshVisibility(position);
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
    }

    /**
     * 查询上级信息
     */
    private void queryStaffManager() {
        staffManagerTv.setVisibility(View.VISIBLE);
        staffManagerTv.setTextColor(Color.RED);
        staffManagerTv.setText("正在获取上级信息...");

        Map<String, String> params2 = new HashMap<>(1);
        params2.put("staffId", SystemHelper.LoginUserId);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.QUERY_STAFF_MANAGERS, params2,
                new OkHttpDominator.ResultCallback<StaffManagerRes>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        if (isFinishing()) return;
                        staffManagerTv.setVisibility(View.VISIBLE);
                        staffManagerTv.setTextColor(Color.RED);
                        staffManagerTv.setText("网络异常，点我刷新！");
                    }

                    @Override
                    public void onResponse(StaffManagerRes res) {
                        if (isFinishing()) return;
                        StaffManagerRes resMock = JsonDominator.loadFromSD("StaffManagerRes", StaffManagerRes.class);
                        if (resMock != null) {
                            res = resMock;
                        }
                        if (res == null || res.getResultInfo() == null) {
                            staffManagerTv.setVisibility(View.VISIBLE);
                            staffManagerTv.setTextColor(Color.RED);
                            staffManagerTv.setText("上级信息为空，点我刷新！");
                            return;
                        }
                        if (res.msgCode == 0) {
                            managerCaches = res.getResultInfo();//缓存起来，后面上传的时候要用。

                            staffManagerTv.setVisibility(res.getResultInfo().size() > 1 ? View.GONE : View.VISIBLE);
                            staffManagerTv.setTextColor(Color.parseColor("#84838B"));
                            staffManagerSpinner.setVisibility(res.getResultInfo().size() <= 1 ? View.GONE : View.VISIBLE);

                            staffManagerTv.setText(res.getNames().get(0));
                            staffManagerSpinner.setAdapter(new ArrayAdapter(AskAbsenceAct.this,
                                    R.layout.gray_spinner_dropdown_item,
                                    res.getNames()));
                        }
                    }
                });
    }

    /**
     * 针对不同的请假类型，有些组件可能不需要显示，
     * 例如：
     * 如果不是疫情停工，就不需要显示上传照片了
     * 如果不是年假，那也不需要显示剩余年假天数了
     *
     * @param selectedPos ...
     */
    private void refreshVisibility(int selectedPos) {
        //如果是 年假 ，或者整个大类型为 调休，都显示剩余
        String type = mLeaveTypeList.get(selectedPos).getType();
        uploadPhoto.setVisibility(View.GONE);
    }

    private void setListener() {
        //现在改为不可点击。。。所以把监听器关掉吧
        type.setOnClickListener(this);
        start.setOnClickListener(this);
        end.setOnClickListener(this);
        submit.setOnClickListener(this);
        cameraAdd.setOnClickListener(this);
        staffManagerTv.setOnClickListener(this);
        hourPlusBtn.setOnClickListener(this);
        hourMinusBtn.setOnClickListener(this);
        startDateTiaoXiu.setOnClickListener(this);
        startTimeTiaoXiu.setOnClickListener(this);
        reasonInput.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                if (s.length() > 100) {
                    s = s.toString().substring(0, 100);
                    reasonInput.setText(s);
                    reasonInput.setSelection(100);
                    showMsg("最多允许输入100个字！");
                }
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
    }

    @Override
    public void onClick(View v) {
        int id = v.getId();
        switch (id) {
            //请假开始时间
            case R.id.start:
                //true表示“是开始时间”，false表示“不是开始时间”
                setTime(START_TIME);
                break;
            //请假结束时间
            case R.id.end:
                setTime(END_TIME);
                break;
            //请假申请提交
            case R.id.qingjia_submit:
                //说明根本就没选嘛，选了的话字体会变成黑色的
               /* if(qingjiaType.getCurrentTextColor() != Color.BLACK){
                    showMsg("请选择请假类型！");
                    break;
                }*/
                //上级校验
                if (managerCaches == null || managerCaches.size() == 0) {
                    showMsg("上级为空，无法提交");
                    return;
                }
                //开始上传
                if (askType == INTENT_QINGJIA) {
                    submitQingjia();
                } else if (askType == INTENT_TIAOXIU) {
                    submitTiaoxiu();
                }
                break;
            //添加照片
            case R.id.cameraAdd:
                //低于最大允许数量时才能添加照片
                if (picker.packPhotoPaths(photoGroup).size() < MAX_PHOTO_NUM) {
                    picker.showDialog();
                }
                break;
            case R.id.staffManagerTv:
                queryStaffManager();//点击重新请求上级信息。
                break;
            case R.id.hourPlus://小时加按钮
                String canTiaoXiu = todayCanTiaoXiu.getText().toString().replace("小时", "");
                if (lastTiaoxiu.getText().toString().startsWith("-") || canTiaoXiu.startsWith("-"))
                    break;
                int newHour = Integer.parseInt(hourNum.getText().toString()) + 4;

                if (newHour > 8) {
                    AnimeUtil.vibrate(bottomText);
                    break;
                }
                if (newHour <= Double.parseDouble(canTiaoXiu)) {
                    hourNum.setText(newHour + "");
                    notifyTiaoxiuEndTime(newHour);
                }
                break;
            case R.id.hourMinus://小时减按钮
                if (lastTiaoxiu.getText().toString().startsWith("--")) break;
                int newHour2 = Integer.parseInt(hourNum.getText().toString()) - 4;
                if (newHour2 >= 4) {
                    hourNum.setText(newHour2 + "");
                    notifyTiaoxiuEndTime(newHour2);
                }
                break;
            case R.id.startDateTiaoXiu://调休起始日期
                DateUtil.pickDialog(this, startDateTiaoXiu, "yyyy-MM-dd",
                        new Date(), null, new DateUtil.SelectCallBack() {
                            @Override
                            public void onSelected() {//选完后跟着刷新截止时间
                                notifyTiaoxiuEndTime(Integer.parseInt(hourNum.getText().toString()));
                                queryBreakHoursToday(startDateTiaoXiu.getText().toString().replace("小时", ""));
                            }
                        }).show();
                break;
            case R.id.startTimeTiaoXiu://调休起始时刻
                //如果起始日期是今天，则startLimit起始时间限制要限制当前时间；如果起始日期不是今天，那就无所谓了，传个null
//                Date startLimit = startDateTiaoXiu.getText().toString().equals(new SimpleDateFormat("yyyy-MM-dd").format(new Date()))? new Date() : null;
                DateTimeUtils.pickDialog(this, startTimeTiaoXiu, "HH:mm", null, null,
                        null, new DateTimeUtils.SelectedCallBack() {
                            @Override
                            public void onSelected() {//选完时间后的回调，刷新截止时间
                                notifyTiaoxiuEndTime(Integer.parseInt(hourNum.getText().toString()));
                            }
                        }).show();
                break;
            default:
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        String photoPath = picker.onPhotoPathResult(this, requestCode, resultCode, data);
        //如果没有选择图片，返回回来的路径是“”
        if (TextUtils.isEmpty(photoPath)) {
            return;
        }
        picker.addPhoto2GroupByCamBtnSize(photoPath, cameraAdd, photoGroup);
//        //根据存的照片数，来控制添加图片按钮的显隐。
//        cameraAdd.setVisibility(picker.packPhotoPaths(photoGroup).size() >= MAX_PHOTO_NUM? View.GONE : View.VISIBLE);
    }

    /**
     * 上传调休数据
     */
    public void submitTiaoxiu() {
        if (TextUtils.isEmpty(startDateTiaoXiu.getText().toString()) ||
                TextUtils.isEmpty(startTimeTiaoXiu.getText().toString())) {
            showMsg("所选开始日期有误");
            return;
        }

        if (todayCanTiaoXiu.getText().toString().startsWith("-")) {
            showMsg("所选日期当天可请调休有误");
            AnimeUtil.vibrate(todayCanTiaoXiu);
            return;
        }

        if (Integer.parseInt(todayCanTiaoXiu.getText().toString().split("小时")[0]) == 0) {
            showMsg("所选日期当天可调休为0小时，不能申请调休");
            AnimeUtil.vibrate(todayCanTiaoXiu);
            return;
        }

        //请填写请假原因
        if (TextUtils.isEmpty(reasonInput.getText().toString())) {
            showMsg("请填写请假原因");
            return;
        }
        uploadJson(null, ConstantParams.CONSTANT_PARAMS_8);
    }


    /**
     * 上传请假数据
     * <p>
     * interface /userinformation/askForLeave
     */
    public void submitQingjia() {
        //校验开始时间与结束时间
        Long compareResult = DataMonthUtils.compareDate(startTime.getText().toString(),
                endTime.getText().toString(), dateFormat);
        if (compareResult != null) {
            if (compareResult > 0) {
                showMsg("开始时间必须小于结束时间！");
                return;
            }
        } else {
            showMsg("数据处理失败，请重试");
            return;
        }

        String leaveType = mLeaveTypeList.get(qingjiaType.getSelectedItemPosition()).getType();
        //年假校验
        if (ConstantParams.CONSTANT_PARAMS_2.equals(leaveType)) {
            if (lastNianjia == 0 || lastNianjia < Double.parseDouble(daysAmount.getText().toString().split("天")[0])
                /*lastNianjia.getText().toString().startsWith("--")
                    || Double.parseDouble(lastNianjia.getText().toString().split("天")[0]) < Double.parseDouble(daysAmount.getText().toString().split("天")[0])*/) {
                showMsg("剩余年假不足，请修改后重新提交！");
                return;
            }
            if (startTime.getText().toString().compareTo(dateFormat.format(new Date())) < 0) {
                showMsg("年假必须提前申请，不可事后补");
                return;
            }
        }

        //请填写请假原因
        final String reason = reasonInput.getText().toString();
        if (TextUtils.isEmpty(reason)) {
            showMsg("请填写请假原因");
            return;
        }

        //疫情停工校验
//        if (ConstantParams.CONSTANT_PARAMS_31.equals(leaveType)) {
//            ArrayList<String> photoPaths = picker.packPhotoPaths(photoGroup);
//            //如果没有照片
//            if (photoPaths.size() == 0) {
//                showMsg("需上传社区或卖场疫情停工相关证明图片！");
//            } else {//如果有照片，那就先上传照片，再上传信息。
//                ViewUtil.showProgress(this, "请稍等", "正在上传图片...");
//                QiNiuDominator.uploadImages(photoPaths, new QiNiuDominator.CompleteQiniu() {
//                    @Override
//                    public void uploadInfo(List<String> qiniuUrl) {
//                        uploadJson(qiniuUrl, leaveType);
//                    }
//                });
//            }
//        } else {//如果不是疫情停工，那就不需要上传图片了
        uploadJson(null, leaveType);
//        }
    }


    /**
     * 非强制上传
     *
     * @param qiniuUrl  七牛图片地址
     * @param leaveType 请假类型
     */
    private void uploadJson(List<String> qiniuUrl, String leaveType) {
        uploadJsonForce(qiniuUrl, leaveType, false);
    }

    /**
     * 带有是否强制上传标记的上传
     */
    private void uploadJsonForce(final List<String> qiniuUrl, final String leaveType, boolean isForce) {
        HashMap<String, String> params = new HashMap<>();
        params.put("id", getId());
        params.put("staffId", SystemHelper.LoginUserId);
        params.put("staffName", SystemHelper.LoginUserName);
        params.put("storeId", SystemHelper.LoginOrganId);
        params.put("managerStaffId", getStaffManagerId());//上级工号
        params.put("leaveDateType", askType == INTENT_QINGJIA ? "0" : "1");//请假的计数类型，0:按天数请假，1：按小时数请假（其实请假就是天数，调休就是小时）
        params.put("leaveReason", reasonInput.getText().toString());
        if (askType == INTENT_QINGJIA) {//请假
            params.put("leaveType", leaveType);
            params.put("startTime", startTime.getText().toString());
            params.put("endTime", endTime.getText().toString());
            params.put("leaveDateNum", daysAmount.getText().toString().split("天")[0]);
        } else if (askType == INTENT_TIAOXIU) {//调休
            params.put("leaveType", leaveType);//如果是调休，就直接是8
            params.put("startTime", startDateTiaoXiu.getText().toString() + " " + startTimeTiaoXiu.getText().toString() + ":00");
            params.put("endTime", endDateTiaoXiu.getText().toString() + " " + endTimeTiaoXiu.getText().toString() + ":00");
            params.put("leaveDateNum", hourNum.getText().toString().split("小时")[0]);
        }

        params.put("attachUrl", new Gson().toJson(qiniuUrl));
        if (isForce) {//如果是强制上传，就添加新参数传1
            params.put("coverSwith", "1");
        }

        ViewUtil.showProgress(this, "请稍等", "正在上传请假信息...");
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.ASK_FOR_LEAVE, params,
                new OkHttpDominator.ResultCallback<BaseSimpleResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        showMsg(e.toString());
                    }

                    @Override
                    public void onResponse(BaseSimpleResponse res) {
                        ViewUtil.dismissProgress();
                        if (res != null) {
                            if (res.msgCode < 0) {//后台返回异常，如 单号重复，参数错误 等。
                                new AlertDialog.Builder(AskAbsenceAct.this)
                                        .setTitle("提示")
                                        .setMessage(res.msgInfo)
                                        .setPositiveButton("确定", null)
                                        .create().show();
                                return;
                            }
                            switch (res.msgCode) {
                                case 0://执行成功。
//                                    showMsg(res.msgInfo);
                                    showMsg("提交成功");
                                    finish();
                                    break;
                                case 1://提示信息，确认就继续强制提交，取消就不做操作
                                    new AlertDialog.Builder(AskAbsenceAct.this)
                                            .setTitle("提示")
                                            .setMessage(res.msgInfo)
                                            .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                                                @Override
                                                public void onClick(DialogInterface dialog, int which) {
                                                    //强制覆盖提交，传true
                                                    uploadJsonForce(qiniuUrl, leaveType, true);
                                                }
                                            })
                                            .setNegativeButton("取消", null)
                                            .create().show();
                                    break;
                                case 2://只有警告弹窗和确认按钮，确认后不做多余操作。
                                    new AlertDialog.Builder(AskAbsenceAct.this)
                                            .setTitle("警告")
                                            .setMessage(res.msgInfo)
                                            .setPositiveButton("确定", null)
                                            .create().show();
                                    break;

                            }

                        }
                    }
                });
    }


    /**
     * 读取上级工号
     *
     * @return
     */
    private String getStaffManagerId() {
        int pos = staffManagerSpinner.getSelectedItemPosition();
        return managerCaches.get(pos).getStaffId();
    }

    /**
     * 时间日期选取器
     *
     * @param timeType 告诉它选的是否是起始时间
     */
    @SuppressWarnings("all")
    private void setTime(final int timeType) {
        Calendar c0 = Calendar.getInstance();
        //创建对话框
        DatePickerDialog pickerDialog = new DatePickerDialog(this, new DatePickerDialog.OnDateSetListener() {
            @SuppressLint("SetTextI18n")
            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
//                Date date = new Date();
//                date.setYear(year - 1900);
//                date.setMonth(monthOfYear);
                Calendar c = Calendar.getInstance();
                c.set(Calendar.YEAR, year);
                c.set(Calendar.MONTH, monthOfYear);
                c.set(Calendar.DAY_OF_MONTH, dayOfMonth);
//                date.setDate(dayOfMonth);
                String pickedDate = dateFormat.format(c.getTime());
                switch (timeType) {
                    //起始时间
                    case START_TIME:
                        startTime.setText(pickedDate);
                        break;
                    //截止时间
                    case END_TIME:
                        endTime.setText(pickedDate);
                        break;
                    default:
                }

                if (startTime != null && !TextUtils.isEmpty(startTime.getText())
                        && endTime != null && !TextUtils.isEmpty(endTime.getText())) {
                    String startTimeStr = startTime.getText().toString();
                    String endTimeStr = endTime.getText().toString();

                    queryLeaveTypeList(startTimeStr, endTimeStr); //请假类型

                    long days = DataMonthUtils.getCompareDate(startTimeStr, endTimeStr);
                    if (days >= 0) {
                        DecimalFormat df = new DecimalFormat("#");
                        daysAmount.setText(df.format(Math.ceil(days) + 1) + "天");
                    } else {
                        daysAmount.setText("开始时间不能大于结束时间！");
                    }
                }
            }
        }, c0.get(Calendar.YEAR), c0.get(Calendar.MONTH), c0.get(Calendar.DAY_OF_MONTH));
        //年假必须提前申请，不可事后补；
        if (mLeaveTypeList.size() > 0 && ConstantParams.CONSTANT_PARAMS_2.equals(mLeaveTypeList.get(qingjiaType.getSelectedItemPosition()).getType())) {
            //必须要减一点，否则小米手机会报错：IllegalArgumentException Fromdate does not precede toDate
            pickerDialog.getDatePicker().setMinDate(new Date().getTime() - 10000);
        }
        pickerDialog.show();
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if ("submit".equals(tag)) {
            if (null != response && "0".equals(response.ret)) {
                showMsg("申请成功！");
//                if(timer != null){
//                    timer.cancel();
//                }
                finish();
            } else {
                showMsg("数据上传失败，请重新提交申请！");
            }
        }
    }

    /**
     * 将请假类型转换成整型代号
     *
     * @return ...
     */
    private String transTypeToInt(String qingjiaType) {
        if (askType == INTENT_TIAOXIU || qingjiaType == null) {//如果是调休，就直接是8
            return "8";
        }
        if ("病假".equals(qingjiaType)) {
            return "1";
        } else if ("年假".equals(qingjiaType)) {
            return "2";
        } else if ("事假".equals(qingjiaType)) {
            return "3";
        } else if ("婚假".equals(qingjiaType)) {
            return "4";
        } else if ("产假".equals(qingjiaType)) {
            return "5";
        } else if ("丧假".equals(qingjiaType)) {
            return "6";
        } else if ("护理假".equals(qingjiaType)) {
            return "7";
        } else if ("调休".equals(qingjiaType)) {
            return "8";
        } else if ("哺乳假".equals(qingjiaType)) {
            return "9";
        } else if ("休假".equals(qingjiaType)) {
            return "31";
        } else {
            return "-1";
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        ViewUtil.dismissProgress();
        if (picker != null) {
            picker.deletePicCache();//清除在SD卡上的照片缓存
        }
        if (unbinder != null) {
            unbinder.unbind();
        }
    }
}
