package com.urovo.activity.careertraining.ui;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.RadioButton;
import android.widget.TextView;

import com.urovo.activity.careertraining.model.WorkerTrainInfo;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;

import java.util.List;

public class CareerEvaluateAdapter extends BaseAdapter {
    private List<WorkerTrainInfo> list;
    private BaseActivity context;

    public CareerEvaluateAdapter(List<WorkerTrainInfo> workerTrainInfoList, BaseActivity context) {
        this.list = workerTrainInfoList;
        this.context = context;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {
        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if(convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.career_info_item, null);
            viewHolder = new ViewHolder();
            viewHolder.name = (TextView) convertView.findViewById(R.id.detail_name);
            viewHolder.count = (TextView) convertView.findViewById(R.id.detail_count);
            viewHolder.isokYes = (RadioButton) convertView.findViewById(R.id.tourshop_item_isok_yes);
            viewHolder.isokNo = (RadioButton) convertView.findViewById(R.id.tourshop_item_isok_no);
            convertView.setTag(viewHolder);
        }
        else {
            viewHolder = (ViewHolder) convertView.getTag();
        }

       final WorkerTrainInfo data = list.get(position);
        viewHolder.name.setText(data.getTime());
        viewHolder.count.setText(data.getContent());

        viewHolder.isokYes.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (viewHolder.isokYes.isChecked()) {
                    data.setWeekOneContentIsNot("1");
                } else {
                    data.setWeekOneContentIsNot("2");
                }
                radioButtonShow(viewHolder, data);
            }
        });
        viewHolder.isokNo.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (viewHolder.isokNo.isChecked()) {
                    data.setWeekOneContentIsNot("2");
                } else {
                    data.setWeekOneContentIsNot("1");
                }
                radioButtonShow(viewHolder, data);
            }
        });

        radioButtonShow(viewHolder, data);
        return convertView;
    }


   public List<WorkerTrainInfo>  getData(){
        return list;
    }
    class ViewHolder {
        TextView name;
        TextView count;
        RadioButton isokYes;
        RadioButton isokNo;
    }

    private void radioButtonShow(ViewHolder holder, WorkerTrainInfo data) {
        if (null != data.getWeekOneContentIsNot()) {
            if ("1".equals(data.getWeekOneContentIsNot())) {
                holder.isokYes.setChecked(true);
            } else if ("2".equals(data.getWeekOneContentIsNot())){
                holder.isokNo.setChecked(true);
            }else{
                holder.isokNo.setChecked(false);
                holder.isokYes.setChecked(false);
            }
        }
    }
}
