package com.urovo.activity.careertraining.view;

import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.urovo.activity.careertraining.model.WorkerTrainInfo;
import com.urovo.activity.careertraining.model.WorkerTrainInfoList;
import com.urovo.activity.careertraining.model.WorkerTrainInfoResultData;
import com.urovo.activity.careertraining.ui.CareerEvaluateAdapter;
import com.urovo.wugumofang.constants.ConstantParams;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseSimpleResponse;
import com.urovo.wugumofang.ui.ViewUtil;
import com.wgmf.trade.widgets.ListViewForScrollView;

import java.util.HashMap;
import java.util.List;

import okhttp3.Request;

public class CareerEvaluateAct extends BaseActivity{
    public String staffId = "staffId";
    public String staffName = "staffName";
    public String mentroEvaluationFlag = "mentroEvaluationFlag";
    private TextView name;
    private TextView staffEntryTime;
    private TextView week;
    private EditText reportExplainEdt;
    private LinearLayout reportExplainLl;
    private ListViewForScrollView careerLv;
    private List<WorkerTrainInfo> workerTrainInfoList;
    private CareerEvaluateAdapter adapter;
    private Button submit;
    private boolean isUp = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.career_evaluate_activity);
        initTitle();
        init();
        getData();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText("入职评估");
        staffId = getIntent().getStringExtra("staffId");
        staffName = getIntent().getStringExtra("staffName");
        mentroEvaluationFlag = getIntent().getStringExtra("mentroEvaluationFlag");
    }

    private void init() {
        name = (TextView) findViewById(R.id.staff_name);
        name.setText(staffName);
        staffEntryTime = (TextView) findViewById(R.id.staff_entry_time);
        week = (TextView) findViewById(R.id.week);
        reportExplainLl = (LinearLayout) findViewById(R.id.report_explain_ll);
        reportExplainEdt = (EditText) findViewById(R.id.report_explain_edt);
        careerLv = (ListViewForScrollView) findViewById(R.id.career_listview);
        submit = (Button) findViewById(R.id.submit);
        //导师评估标识：1已评估，0未评估 ,
        if("0".equals(mentroEvaluationFlag)){
            submit.setVisibility(View.VISIBLE);
        }
        submit.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                submit();
            }
        });
        if (workerTrainInfoList != null) {
            adapter = new CareerEvaluateAdapter(workerTrainInfoList, CareerEvaluateAct.this);
            careerLv.setAdapter(adapter);
        }
    }

    private void getData() {
//        String id = SystemHelper.LoginUserId;
//        String id = "35105505";
        if (!TextUtils.isEmpty(staffId)) {
            HashMap<String, String> param = new HashMap<>();
            param.put("staffId",staffId);
            ViewUtil.showProgress(CareerEvaluateAct.this, "", "请稍等.....");
            OkHttpDominator.getAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.YXGJ.GET_QUERY_WEEK_ONE_TRAIN_INFO, param,
                    new OkHttpDominator.ResultCallback<String>() {
                        @Override
                        public void onError(Request request, Exception e) {
                            ViewUtil.dismissProgress();
                            showMsg("获取评估"+ getString(R.string.request_data_fail));
                        }

                        @Override
                        public void onResponse(String json) {
                            ViewUtil.dismissProgress();
                            if(json == null || TextUtils.isEmpty(json)){
                                showMsg("没有返回数据");
                                return;
                            }
                            WorkerTrainInfoResultData mWorkerTrainInfoResultData = new Gson().fromJson(json, WorkerTrainInfoResultData.class);
                            if(null!=mWorkerTrainInfoResultData && ConstantParams.CONSTANT_PARAMS_0.equals(mWorkerTrainInfoResultData.sysCode)){
                                setContentData(mWorkerTrainInfoResultData);
                            }else{
                                showMsg("没有返回数据");
                            }
                        }
                    });
        }
    }

    private void setContentData(WorkerTrainInfoResultData mWorkerTrainInfoResultData) {
        WorkerTrainInfoList mWorkerTrainInfoLists = mWorkerTrainInfoResultData.getResult();
        if(null!=mWorkerTrainInfoLists) {
            if (null!=mWorkerTrainInfoLists.getWorkerTrainInfoList()&&!mWorkerTrainInfoLists.getWorkerTrainInfoList().isEmpty()) {
                week.setText(mWorkerTrainInfoLists.getWeek());
                staffEntryTime.setText(!TextUtils.isEmpty(mWorkerTrainInfoLists.getEntryTime()) ? "入职时间：" + mWorkerTrainInfoLists.getEntryTime() : "--");
                reportExplainEdt.setText(mWorkerTrainInfoLists.getItemContent());
                workerTrainInfoList = mWorkerTrainInfoLists.getWorkerTrainInfoList();
                adapter = new CareerEvaluateAdapter(workerTrainInfoList, CareerEvaluateAct.this);
                careerLv.setAdapter(adapter);
            } else {
                submit.setVisibility(View.GONE);
                reportExplainLl.setVisibility(View.GONE);
                reportExplainEdt.setVisibility(View.GONE);
            }
        }else {
            submit.setVisibility(View.GONE);
            reportExplainLl.setVisibility(View.GONE);
            reportExplainEdt.setVisibility(View.GONE);
        }
    }

    protected void submit() {
        if(TextUtils.isEmpty(reportExplainEdt.getText().toString())){
            showMsg("请填写综合评价内容");
            return;
        }

        if (null != adapter) {
            List<WorkerTrainInfo> data = adapter.getData();
            for(int i = 0 ;i<data.size();i++) {
                if ("0".equals(data.get(i).getWeekOneContentIsNot())) {
                    showMsg("还有选项未勾选，请检查");
                    return;
                }
            }
            WorkerTrainInfoList mWorkerTrainInfoLists=new WorkerTrainInfoList();
            mWorkerTrainInfoLists.setStaffId(staffId);
            mWorkerTrainInfoLists.setItemContent(reportExplainEdt.getText().toString());
            mWorkerTrainInfoLists.setWorkerTrainInfoList(data);
            HashMap<String, String> param = new HashMap<>();
            param.put("newWorkerTrainInfoBean",new Gson().toJson(mWorkerTrainInfoLists));
            Log.d("", "submit: " + new Gson().toJson(mWorkerTrainInfoLists));
            ViewUtil.showProgress(this, "请稍等", "正在上传数据...");

        OkHttpDominator.postAsynByType(NetParam.YINXIAOBU_SERVER + ApiUrls.YXGJ.GET_SAVE_NEW_WORKER_TRAIN_INFO_BEAN,
                OkHttpDominator.JSON,
                param,
                new OkHttpDominator.ResultCallback<BaseSimpleResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        showMsg("网络连接超时，请检查您的网络状态，稍后重试！");
                    }

                    @Override
                    public void onResponse(BaseSimpleResponse res) {
                        ViewUtil.dismissProgress();
                        if (res == null) {
                            showMsg("后台返回为空");
                            return;
                        }
                        if (!TextUtils.isEmpty(res.msgInfo)) {
                            showMsg(res.msgInfo);
                        }
                        if (res.msgCode == 0) {//上传成功
                            isUp = true;
                            submit.setBackgroundColor(CareerEvaluateAct.this.getResources().getColor(R.color.deep_line));
                            CareerEvaluateAct.this.finish();
                        }
                    }
                });
        }
    }
}
