package com.urovo.activity.careertraining.view

import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import com.urovo.activity.careertraining.net.CareerEntryListRes
import com.urovo.activity.careertraining.ui.CareerEntryListAdapter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.view.LoadWaitDominator
import kotlinx.android.synthetic.main.career_evaluate_list_act.*
import okhttp3.Request

/**
 * @author Sasuke on 2019-10-18 0018.
 */
class CareerEvaluateListAct : BaseActivity() {
    var loadWait: LoadWaitDominator? = null
    var isFirst = true

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.career_evaluate_list_act)
        initTitle()
        init()
        query()
    }

    fun init() {
        titleTextView.text = "入职评估列表"
        loadWait = LoadWaitDominator(this, listContainer)
        dataRv.layoutManager = LinearLayoutManager(this)
    }

    fun query() {
        loadWait?.show(LoadWaitDominator.LOADING)
        OkHttpDominator.getAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.YXGJ.GET_CAREER_EVALUATE_LIST,
                mapOf("trainStaffId" to SystemHelper.LoginUserId), object : OkHttpDominator.ResultCallback<CareerEntryListRes>() {
            override fun onError(request: Request?, e: Exception?) {
                loadWait?.show(LoadWaitDominator.NET_ERROR)
            }

            override fun onResponse(res: CareerEntryListRes?) {
                res?.let {
                    if (res.msgCode != 0){
                        loadWait?.show(res.msgInfo)
                        return
                    }
                    if (null==res.resultList||res.resultList.isEmpty()){
                        loadWait?.show(LoadWaitDominator.NO_DATA)
                        return
                    }
                    dataRv.adapter = CareerEntryListAdapter(this@CareerEvaluateListAct,res.resultList.sortedBy { if (it.mentroEvaluationFlag.equals("1")) 1 else -1 })
                    loadWait?.dismissAll()
                }
            }
        })

    }

    override fun onResume() {
        super.onResume()
        if (isFirst) {
            isFirst = false
            return
        }
        query()
    }
}