package com.urovo.activity.checkGoodsTabAct.presenter

import com.urovo.activity.checkGoodsTabAct.model.QueryCheckEntity
import com.urovo.wgmf.adapter.PanDianDiffAdapter
import com.urovo.wgmf.db.dao.entitys.CanCheckRes3
import com.urovo.wugumofang.base.BasePresenter
import com.urovo.wugumofang.base.mvp.AbsView

/**
 * @author LW on 2022/8/18.
 */
interface CheckGoodsQueryContract {

    interface IView : AbsView {

        fun refreshTransferCheckToView(response: List<QueryCheckEntity>)

        fun showDataType(type: Int)

        fun showTitleText(title: String)

        fun showPopWindow()

    }

    interface IPresenter : BasePresenter {

        /**
         * POST /storeTransferCheck/getTransferCheck
         * 查询盘点数据
         */
        fun requestTransferCheck(year: Int, month: Int)

    }
}

interface CheckGoodsSubmitListContract {

    interface IView : AbsView {

        fun currentTransferCheckToView(resultInfo: List<CanCheckRes3.ResultInfo>?)

        fun transferCheckStatus(status:Boolean,msg: String?)
    }


    interface IPresenter : BasePresenter {
        /**
         * POST storeTransferCheck/getCurrentTransferCheck
         */
        fun requestCurrentTransferCheck()

        /**
         * POST /storeTransferCheck/transferCheck
         */
        fun requestTransferCheck()
    }

}


interface CheckGoodsSubmitContract {

    interface IView : AbsView {

        fun resetDataToView()

        fun showAlertDialog(zeroCount: Boolean, info: String, callback: () -> Boolean)

        fun savePanDianDataToDbAndSubmit(callback: () -> Boolean)

        fun showPanDianDiffDialog(diffList: List<PanDianDiffAdapter.Diff>)

    }


    interface IPresenter : BasePresenter {

        fun submit()

        fun checkListCorrectAndSubmit(): Boolean

        fun saveAndSubmit()
    }

}