package com.urovo.activity.checkGoodsTabAct.view

import android.app.AlertDialog
import android.content.DialogInterface
import android.content.Intent
import android.os.Handler
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.*
import androidx.recyclerview.widget.LinearLayoutManager
import com.urovo.activity.addsellactivity.ui.AutoRadioGroup
import com.urovo.activity.checkGoodsTabAct.presenter.CheckGoodsSubmitContract
import com.urovo.activity.checkGoodsTabAct.presenter.CheckGoodsSubmitPresenter
import com.urovo.activity.checkGoodsTabAct.view.adapter.CheckSubmitAdapter2
import com.urovo.wgmf.adapter.PanDianDiffAdapter
import com.urovo.wgmf.db.dao.entitys.CanCheckRes3
import com.urovo.wgmf.tool.netUtil.QiNiuDominator
import com.urovo.wugumofang.view.dialog.PublicTipDialog
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.base.BasePresenter
import com.urovo.wugumofang.constants.ConstantParams
import com.urovo.wugumofang.data.Arith
import com.urovo.wugumofang.data.StringUtils
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.DensityUtil
import com.urovo.wugumofang.ui.PhotoPickDominator
import com.urovo.wugumofang.ui.SpacesItemDecoration
import com.urovo.wugumofang.utils.SoftKeyBoardUtil
import com.urovo.wugumofang.utils.isNotNullOrSize
import com.urovo.wugumofang.view.LoadWaitDominator
import kotlinx.android.synthetic.main.include_check_goods_submit_confirm.*
import kotlinx.android.synthetic.main.include_check_goods_submit_product_list.*
import org.jetbrains.anko.find
import java.text.MessageFormat
import java.util.*

/**
 * @author LW on 2022-08-18
 * 盘点提交
 */
class CheckGoodsSubmitActivity : BaseActivity(), CheckGoodsSubmitContract.IView {

    override fun addRootLayoutId(): Int = R.layout.check_goods_submit_activity

    override fun rootViewGroup(): ViewGroup = check_goods_submit_product_container_rl

    private var mCheckGoodsSubmitPresenter: CheckGoodsSubmitPresenter? = null

    private var mCheckGoodsAdapter: CheckSubmitAdapter2? = null

    private var mPhotoPick: PhotoPickDominator? = null

    private var mType = 0//0:无需上传盘点表，1：需上传盘点表

    //以下是弹窗编辑器的各组件
    //private var mTvGoodsName: TextView? = null
    //private var mTvGoodsDhPack: TextView? = null
    //private var mEtPdcount: EditTextDecimal? = null
    //private var mTvNext: TextView? = null
    //private var mTvCancel: TextView? = null

    //private var mIsPopShow = false

    companion object {
        const val INTENT_RESULTLIST = "INTENT_RESULTLIST"

        /**照片的最大数量*/
        private const val PHOTO_MAX_NUM = 5

        private const val WGMF_BRAND_ID = 8
    }

    override fun initViewNew() {
        initTitle()
        titleTextView.text = getString(R.string.check_goods_submit_title)

        mCheckGoodsSubmitPresenter?.mResultInfo =
            intent.getSerializableExtra(INTENT_RESULTLIST) as CanCheckRes3.ResultInfo

        check_goods_submit_product_store_ll.text =
            MessageFormat.format("盘点门店:{0}", SystemHelper.LoginOrganName)

        check_goods_submit_confirm_title_tv.text = "提交盘点表";
        check_goods_submit_confirm_back_ib.setOnClickListener {
            check_goods_submit_product_list_ll.visibility = View.VISIBLE
            check_goods_submit_confirm_ll.visibility = View.GONE
        }
        check_goods_submit_confirm_camera_add_ib.setOnClickListener {
            showCamera()
        }
        check_goods_submit_confirm_other_check_rb.setOnCheckedChangeListener { btn, isChecked ->
            if (isChecked) {
                check_goods_submit_confirm_other_check_info_et.isEnabled = true
                check_goods_submit_confirm_other_check_info_et.isFocusable = true
                check_goods_submit_confirm_other_check_info_et.isClickable = true
                check_goods_submit_confirm_other_check_info_et.visibility = View.VISIBLE
            } else {
                check_goods_submit_confirm_other_check_info_et.isEnabled = false
                check_goods_submit_confirm_other_check_info_et.isFocusable = false
                check_goods_submit_confirm_other_check_info_et.isClickable = false
                check_goods_submit_confirm_other_check_info_et.visibility = View.GONE
            }
        }
        if (check_goods_submit_confirm_other_check_rb.isChecked) {
            check_goods_submit_confirm_other_check_info_et.isEnabled = true
            check_goods_submit_confirm_other_check_info_et.isFocusable = true
            check_goods_submit_confirm_other_check_info_et.isClickable = true
            check_goods_submit_confirm_other_check_info_et.visibility = View.VISIBLE
        }
        //弹窗组件初始化
        //mTvGoodsName = find(R.id.goods_name)
        //mTvGoodsDhPack = find(R.id.goods_dhpack)
        //mEtPdcount = find(R.id.edit_pdcount)
        //mTvNext = find(R.id.tv_next)
        //mTvCancel = find(R.id.tv_cancel)

        check_goods_submit_product_submit_btn.setOnClickListener {
            mCheckGoodsSubmitPresenter?.checkListCorrectAndSubmit()
        }
        check_goods_submit_confirm_submit_btn.setOnClickListener {
            showTipDialog("正在提交盘点数据...")
            if (mType == 0) {
                if (check_goods_submit_confirm_new_check_rb.isChecked) {
                    mCheckGoodsSubmitPresenter?.mRemarkText = "新店"
                } else if (check_goods_submit_confirm_delete_check_rb.isChecked) {
                    mCheckGoodsSubmitPresenter?.mRemarkText = "撤店"
                } else if (check_goods_submit_confirm_pause_check_rb.isChecked) {
                    mCheckGoodsSubmitPresenter?.mRemarkText = "暂停营业"
                } else if (check_goods_submit_confirm_other_check_rb.isChecked) {
                    mCheckGoodsSubmitPresenter?.mRemarkText =
                        check_goods_submit_confirm_other_check_info_et.text.toString()
                } else {
                    mCheckGoodsSubmitPresenter?.mRemarkText = ""
                }
                mCheckGoodsSubmitPresenter?.saveAndSubmit()
            } else {
                //盘点图片增加最少需上传2张的限制
                val mySize = mCheckGoodsSubmitPresenter?.mBackInput?.photoList?.size ?: 0
                if (mySize < 2) {
                    dismissDialog()
                    showToast("请至少上传2张盘点表图片！")
                } else {
                    QiNiuDominator.uploadImages(
                        mCheckGoodsSubmitPresenter?.mBackInput?.photoList,
                        { qiniuUrl ->
                            //照片七牛url组装
                            var packUrls = ""
                            qiniuUrl.forEach { packUrls += "${it}," }
                            if (packUrls.isNotEmpty()) packUrls =
                                packUrls.substring(0, packUrls.length - 1)
                            mCheckGoodsSubmitPresenter?.mUrlImage = packUrls
                            mCheckGoodsSubmitPresenter?.saveAndSubmit()
                        },
                        { str ->
                            showToast(str)
                        }, false
                    )
                }

            }
        }
        check_goods_submit_product_total_ll.visibility = View.GONE
        SoftKeyBoardUtil.setOnSoftKeyBoardListener(
            this,
            object : SoftKeyBoardUtil.OnSoftKeyBoardChangeListener {
                override fun keyBoardShow(height: Int) {
                    // 将底部控件上移键盘的高度
                    check_goods_submit_product_total_ll.visibility = View.GONE
                }

                override fun keyBoardHide(height: Int) {
                    // 将底部控件上移键盘的高度
                    Handler().postDelayed({
                        check_goods_submit_product_total_ll.visibility = View.VISIBLE
                    }, 100)
                }
            })

        initRecyclerView()
        refreshDataToView()

        if (mCheckGoodsSubmitPresenter?.includeSpecialProduct() == true) {
            showSpecialProductTipDialog()
        }
    }

    override fun addPresenter(): BasePresenter {
        mCheckGoodsSubmitPresenter = CheckGoodsSubmitPresenter(this)
        return mCheckGoodsSubmitPresenter!!
    }

    fun showSpecialProductTipDialog() {
        val builder = PublicTipDialog.Companion.Builder(mContext)
        builder.setMessage(R.string.check_submit_special_product_code_tip)
        builder.setTitle(R.string.hint)
        builder.setNegativeButton(listener = DialogInterface.OnClickListener { dialog, which -> dialog.dismiss() })
        if (!this.isFinishing) {
            builder.create().show()
        }
    }

    override fun showAlertDialog(zeroCount: Boolean, info: String, save2DB: () -> Boolean) {
        val builder = AlertDialog.Builder(this)
        builder.setTitle("重要提示").setMessage(info).setNegativeButton("确定") { dialog, which ->
            if (SystemHelper.LoginOrganName.contains("办事处")) {//当门店名称含有“办事处”字样时，无需提交盘点表，也不用说明原因，直接提交盘点数据
                if (save2DB.invoke()) {//组装数据&&保存到数据库成功，那就网络提交
                    showTipDialog("正在提交盘点数据...")
                    mCheckGoodsSubmitPresenter?.submit()
                }
            } else {
                check_goods_submit_product_list_ll.visibility = View.GONE
                check_goods_submit_confirm_ll.visibility = View.VISIBLE
                if (zeroCount) {//当门店的盘点库存录入的产品数量全部为“0”，无需提交盘点表图片，但需说明原因
                    // 备注
                    check_goods_submit_confirm_reason_rl.visibility = View.VISIBLE
                    check_goods_submit_confirm_photo_group_hsv.visibility = View.GONE
                    mType = 0
                } else {
                    // 图片
                    check_goods_submit_confirm_reason_rl.visibility = View.GONE
                    check_goods_submit_confirm_photo_group_hsv.visibility = View.VISIBLE
                    mType = 1
                }
            }
        }.setPositiveButton("取消", null).create().show()
    }

    override fun savePanDianDataToDbAndSubmit(callback: () -> Boolean) {
        if (callback.invoke()) {//组装数据&&保存到数据库成功，那就网络提交
            showTipDialog("正在提交盘点数据...")
            mCheckGoodsSubmitPresenter?.submit()
        }
    }

    /**
     * 复位界面
     */
    override fun resetDataToView() {
        if (isFinishing) return
        check_goods_submit_product_total_ll.visibility = View.GONE

        check_goods_submit_product_total_count_tv.text = StringUtils.formatDouble(0.0, "0.00")
        check_goods_submit_product_total_price_tv.text = StringUtils.formatDouble(0.0, "0.00")
    }

    /**
     * 弹出盘点差异弹窗
     */
    override fun showPanDianDiffDialog(diffList: List<PanDianDiffAdapter.Diff>) {
        val diffAdapter = PanDianDiffAdapter(this, diffList)
        val view = LayoutInflater.from(this).inflate(R.layout.list_pandian_diff, null)
        (view.findViewById(R.id.diff_all_num) as TextView).text =
            MessageFormat.format("{0}", mCheckGoodsSubmitPresenter?.mAllDiffNum)//显示差异总数量的绝对值之和

        val allAmountStr =
            String.format(Locale.CHINA, "%.2f", mCheckGoodsSubmitPresenter?.mAllDiffAmount)
        (view.findViewById(R.id.diff_all_amount) as TextView).text = allAmountStr//显示差异总价

        if (diffList.isEmpty()) {//如果比较之后并没有什么差异
            (view.findViewById(R.id.no_diff_icon) as ImageView).visibility =
                View.VISIBLE//并没有差异嘛，显示一个绿勾
        } else {
            (view.findViewById(R.id.no_diff_icon) as ImageView).visibility = View.GONE
        }
        (view.findViewById(R.id.diff_list) as ListView).adapter = diffAdapter
        AlertDialog.Builder(this).setTitle("差异信息确认")
            .setView(view)
            .setCancelable(false)
            .setPositiveButton("确认") { dialog, which -> finish() }.create().show()
    }

    private fun initRecyclerView() {
        mCheckGoodsAdapter =
            CheckSubmitAdapter2(mutableListOf()) {
                refreshPriceShow()
            }
        check_goods_submit_product_recycler_view?.apply {
            layoutManager = LinearLayoutManager(mContext)
            adapter = mCheckGoodsAdapter
            addItemDecoration(SpacesItemDecoration(20, adapter!!.itemCount, true))
        }
    }

    private fun refreshDataToView() {
        val resultInfo = mCheckGoodsSubmitPresenter?.mResultInfo
        val detailList = resultInfo?.detailList ?: listOf()
        val antiCheck =
            resultInfo?.pdState == "草稿" && resultInfo.modifyNum == ConstantParams.CONSTANT_STARTS_0
        check_goods_submit_product_label_hsl.visibility = View.GONE
        if (detailList.isNotNullOrSize()) {
            dismissAllState()
            val productTypeMap = mutableMapOf<Int, String>()
            detailList.forEach {
                val productType = it.productType
                if (!productTypeMap.keys.contains(productType)) {
                    if (productType == ConstantParams.CONSTANT_STARTS_1) {
                        productTypeMap.put(ConstantParams.CONSTANT_STARTS_1, "定型包装")
                    } else if (productType == ConstantParams.CONSTANT_STARTS_2) {
                        productTypeMap.put(ConstantParams.CONSTANT_STARTS_2, "小包装")
                    }
                }
                if (antiCheck) {  //反审核状态，默认已经盘点
                    it.isPanDian = true
                    it.pdAlterNum = it.pdQty
                } else {
                    if (mCheckGoodsAdapter?.matchConditionsNotEdit(it) == true) {
                        it.isPanDian = true
                        it.pdAlterNum = 0.0
                    } else {
                        it.pdAlterNum = null
                    }
                }
            }

            val checkGoodsSubmitProductLabelLl =
                find<LinearLayout>(R.id.check_goods_submit_product_label_ll)
            val labelRadioGroup = AutoRadioGroup(checkGoodsSubmitProductLabelLl)
            if (WGMF_BRAND_ID == mCheckGoodsSubmitPresenter?.mResultInfo?.brandId) {
                //产品分类(定型包装、小型包装、其他、全部)
                if (productTypeMap.isNotEmpty()) {
                    productTypeMap.forEach {
                        labelRadioGroup.addView(
                            view = layoutInflater.inflate(
                                R.layout.add_sell_radio_button,
                                null
                            ) as RadioButton, text = it.value
                        ) { pos ->
                            refreshRvByLabel(detailList, it.key)
                        }
                    }

                    labelRadioGroup.addView(
                        view = layoutInflater.inflate(
                            R.layout.add_sell_radio_button,
                            null
                        ) as RadioButton, text = "其他"
                    ) { pos ->
                        refreshRvByLabel(detailList, 0)
                    }
                    check_goods_submit_product_label_hsl.visibility = View.VISIBLE
                }
            }

            //加一个“全部”标签（无论什么品牌都要加）
            val radioButton =
                layoutInflater.inflate(R.layout.add_sell_radio_button, null) as RadioButton
            labelRadioGroup.addView(view = radioButton, text = "全部") {
                refreshRvByLabel(detailList, -1)
            }

            labelRadioGroup.setChildChecked(0)

            refreshPriceShow()

            check_goods_submit_product_total_ll.visibility = View.VISIBLE//底栏

            //ll_dismiss.setOnClickListener { it.visibility = View.GONE }
            //列表点击监听
            //check_goods_submit_product_recycler_view.setOnItemClickListener { adapterView, view, pos, id ->
            //showCheckGoodsDialog(pos)
            //  }
        } else {
            showState(LoadWaitDominator.NO_DATA)
        }
    }

    /**
     * 根据上面的标签分类来过滤显示对应的列表
     */
    private fun refreshRvByLabel(detailList: List<CanCheckRes3.ResultInfo.DetailList>, type: Int) {
        mCheckGoodsAdapter?.notifyProByLabel(
            detailList,
            type
        )
    }


    /**
     * 刷新价格&&数量显示
     */
    private fun refreshPriceShow() {
        var count = 0.0
        var countPrice = 0.0
        val detailList = mCheckGoodsSubmitPresenter?.mResultInfo?.detailList ?: listOf()
        detailList.forEach {
            if (it.pdAlterNum != null) {
                count = Arith.add(count, it.pdAlterNum!!)
                countPrice = Arith.add(countPrice, Arith.mul(it.pdAlterNum!!, it.proPrice ?: 0.0))
            }
        }

        check_goods_submit_product_total_count_tv.text = StringUtils.formatDouble(count, "0.00")
        check_goods_submit_product_total_price_tv.text =
            StringUtils.formatDouble(countPrice, "0.00")
    }


    /**
     * 弹出盘点编辑小弹窗

    private fun showCheckGoodsDialog(position: Int) {
    val ent = mCheckGoodsAdapter?.list?.get(position)
    ll_dismiss.visibility = View.VISIBLE

    val name = ent?.proName + " " + ent?.proCode
    mTvGoodsName?.text = name
    mTvGoodsDhPack?.text = MessageFormat.format("单位:{0}", ent?.proUnit)

    mTvCancel?.setOnClickListener {
    //点取消不需要刷新数量和显示
    ll_dismiss.visibility = View.GONE
    val imm = getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
    imm.hideSoftInputFromWindow(mEtPdcount?.getWindowToken(), 0)
    }
    mTvNext?.setOnClickListener {
    val count = mEtPdcount?.text.toString().trim { it <= ' ' }
    mCheckGoodsSubmitPresenter?.writeEnt(count, ent)//把新数据写入到ent里，并更新isPanDian为true标记
    listview_checkgoods.smoothScrollToPosition(position)
    //刷新底栏价格&&数量显示
    refreshCount(mCheckGoodsSubmitPresenter?.resultInfo?.detailList ?: listOf())
    mCheckGoodsAdapter?.notifyDataSetChanged()
    //如果到了当前列表的最后一项
    if ((position + 1 >= (mCheckGoodsAdapter?.list?.size ?: 0))) {
    ll_dismiss.visibility = View.GONE
    val imm = getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
    imm.hideSoftInputFromWindow(mEtPdcount?.getWindowToken(), 0)
    showToast("没有下一个产品了")
    } else {
    showCheckGoodsDialog(position + 1)
    }
    }

    mIsPopShow = true
    //如果不支持两位小数,就设置自定义editText小数位为0
    mEtPdcount?.setDecimal(if (ent?.isDecimal ?: true) 2 else 0)
    mEtPdcount?.setText(
    StringUtils.formatDouble(
    ent?.pdQty
    ?: 0.00, mCheckGoodsAdapter?.getProQtyFormatByDecimal(ent)
    )
    )//弹窗的输入框
    mEtPdcount?.setSelectAllOnFocus(true)
    mEtPdcount?.selectAll()
    }

    override fun onKeyDown(keyCode: Int, event: KeyEvent?): Boolean {
    if (keyCode == KeyEvent.KEYCODE_BACK) {
    if (mIsPopShow) {
    mIsPopShow = false
    ll_dismiss.visibility = View.GONE
    mCheckGoodsAdapter?.notifyDataSetChanged()
    return true
    } else {
    return super.onKeyDown(keyCode, event)
    }
    }
    return super.onKeyDown(keyCode, event)
    }
     */

    /**
     * 相册选择和拍照
     */
    private fun showCamera() {
        if (mPhotoPick == null) {
            mPhotoPick =
                PhotoPickDominator(this, mCheckGoodsSubmitPresenter?.mBackInput?.getPhotoList())
        }
        if (mCheckGoodsSubmitPresenter?.mBackInput?.getPhotoList()?.size ?: 0 < PHOTO_MAX_NUM) {
            mPhotoPick?.showDialog()
        } else {
            showToast("最多只能上传" + PHOTO_MAX_NUM + "张图片!")
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        val photoPath = mPhotoPick?.onPhotoPathResult(this, requestCode, resultCode, data)
        mPhotoPick?.addPhoto2Group(
            photoPath,
            DensityUtil.dip2px(this, 60f),
            DensityUtil.dip2px(this, 60f),
            check_goods_submit_confirm_camera_container_ll
        )
    }
}
