package com.urovo.activity.checkGoodsTabAct.view.adapter

import androidx.core.content.ContextCompat
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseExpandableListAdapter
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.checkGoodsTabAct.model.QueryCheckEntity
import com.urovo.activity.wxfriendsres.ui.WxFriendsResImgGridAdapter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.data.MoneyUtils
import com.urovo.wugumofang.system.BaseAppManager
import java.util.*

class CheckQueryListAdapter(list: List<QueryCheckEntity>, private val context: BaseActivity) : BaseExpandableListAdapter() {
    //	private List<Group> group;
    //	private List<List<QueryEntity>> child;
    private val list = ArrayList<QueryCheckEntity>()

    init {
        this.list.clear()
        this.list.addAll(list)
        //		group = new ArrayList<Group>();
        //		child = new ArrayList<List<QueryEntity>>();
        //		if(list != null && list.size() > 0) {
        //			group.add(new Group(list.get(0).WDate, list.get(0).Bill, list.get(0).saleAmount,0, 0));
        //			// group.add(new Group(list.get(0).WDate,0,0));
        //			for (QueryEntity a : list) {
        //				if(!group.contains(new Group(a.WDate, a.Bill, a.saleAmount,0, 0))) {
        //					group.add(new Group(a.WDate, a.Bill, a.saleAmount,0, 0));
        //				}
        //			}
        //			for (Group g : group) {
        //				ArrayList<QueryEntity> childItem = new ArrayList<QueryEntity>();
        //				double amount = 0.00;
        //				double count = 0.00;
        //				for (QueryEntity a : list) {
        //					if(a.Bill.equals(g.bill)) {
        //						childItem.add(a);
        //						amount = Arith.add(amount, Double.parseDouble(a.Amount));
        //						count = Arith.add(count, Double.parseDouble(a.TQTY));
        //					}
        //				}
        //				g.amount = amount;
        //				g.count = count;
        //				child.add(childItem);
        //			}
        //		}
    }

    override fun getGroupCount(): Int {

        //		return group == null ? 0 : group.size();
        return list?.size ?: 0
    }

    override fun getChildrenCount(groupPosition: Int): Int {

        //		return child == null ? 0 : child.get(groupPosition).size();
        return if (list[groupPosition].detailList == null) 0 else list[groupPosition].detailList.size
    }

    override fun getGroup(groupPosition: Int): QueryCheckEntity {

        //		return group.get(groupPosition);
        return list[groupPosition]
    }

    override fun getChild(groupPosition: Int, childPosition: Int): QueryCheckEntity.DetailList {

        //		return child.get(groupPosition).get(childPosition);
        return list[groupPosition].detailList[childPosition]
    }

    override fun getGroupId(groupPosition: Int): Long {

        return groupPosition.toLong()
    }

    override fun getChildId(groupPosition: Int, childPosition: Int): Long {

        return childPosition.toLong()
    }

    override fun hasStableIds(): Boolean {

        return false
    }

    override fun getGroupView(groupPosition: Int, isExpanded: Boolean, convertView: View?, parent: ViewGroup): View {
        var convertView = convertView
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.listview_date_item_checkgood, null)
        }
        val bill = convertView!!.findViewById<View>(R.id.bill) as TextView
        val agent = convertView.findViewById<View>(R.id.agent) as TextView
        val totalAmount = convertView.findViewById<View>(R.id.totalAmount) as TextView
        val totalNum = convertView.findViewById<View>(R.id.totalNum) as TextView
        val yinkui = convertView.findViewById<View>(R.id.yinkui) as TextView
        val koufen = convertView.findViewById<View>(R.id.koufen) as TextView
        val saleAmount = convertView.findViewById<View>(R.id.saleAmount) as TextView
        val groupBrand = convertView.findViewById<View>(R.id.groupBrand) as TextView
        val arrowRight = convertView.findViewById<View>(R.id.arrowRight) as ImageView
        val showImage = convertView.findViewById<View>(R.id.showImage) as TextView
        val imagesRv = convertView.findViewById<View>(R.id.imagesRv) as RecyclerView

        arrowRight.setImageResource(if (isExpanded) R.drawable.btn_arrow_up else R.drawable.btn_arrow_down)
        bill.text = "单号：" + getGroup(groupPosition).pdBillCode!!
        groupBrand.text = "品牌：" + getGroup(groupPosition).brandName!!
        totalAmount.text = "实盘总金额：" + MoneyUtils.twolastDF(getGroup(groupPosition).pdAmount)
        agent.text = "制单人：" + getGroup(groupPosition).pdUserName!!
        yinkui.text = "本期盈亏金额：" + getGroup(groupPosition).diffAmount
        totalNum.text = "总数量：" + MoneyUtils.dynamicLastDF(getGroup(groupPosition).pdQty)
        saleAmount.text = "门店销售额：" + MoneyUtils.twolastDF(getGroup(groupPosition).saleAmount)

        if (getGroup(groupPosition).diffAmount >= 0) {
            koufen.text = "扣分：0"
        } else {
            koufen.text = "扣分：" + getGroup(groupPosition).pdKouFen
        }
        //查看图片 点击
        showImage.setOnClickListener {
            getGroup(groupPosition).checked = !getGroup(groupPosition).checked
            imagesRv.visibility = if (getGroup(groupPosition).checked) View.VISIBLE else View.GONE
        }
        //配图 之 列表
        imagesRv.adapter = WxFriendsResImgGridAdapter(context, getGroup(groupPosition).imgList)
        imagesRv.layoutManager = object : GridLayoutManager(context, 4) {
            override fun canScrollVertically(): Boolean {//不允许上下滑动
                return false
            }
        }
        return convertView
    }

    override fun getChildView(groupPosition: Int, childPosition: Int, isLastChild: Boolean, convertView: View?, parent: ViewGroup): View {
        var convertView = convertView
        val viewHolder: ViewHolder
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.second_check_goods_query_item, null)
            viewHolder = ViewHolder()
            viewHolder.name = convertView!!.findViewById<View>(R.id.goods_name) as TextView
            viewHolder.num = convertView.findViewById<View>(R.id.goods_num) as TextView
            viewHolder.price = convertView.findViewById<View>(R.id.goods_price) as TextView
            viewHolder.count = convertView.findViewById<View>(R.id.goods_count) as TextView
            viewHolder.amount = convertView.findViewById<View>(R.id.goods_amount) as TextView
            viewHolder.kucun = convertView.findViewById<View>(R.id.kucun) as TextView
            viewHolder.chayi = convertView.findViewById<View>(R.id.chayi) as TextView
            viewHolder.chayijine = convertView.findViewById<View>(R.id.chayijine) as TextView
            convertView.tag = viewHolder
        } else {
            viewHolder = convertView.tag as ViewHolder
        }
        val (proName, proCode, proPrice, pdQty, pdAmount, stockQty, diffQty, diffAmount) = getChild(groupPosition, childPosition)
        viewHolder.name!!.text = proName
        viewHolder.num!!.text = proCode
        viewHolder.price!!.text = "零售价：$proPrice"
        viewHolder.count!!.text = "实盘数量：$pdQty"
        viewHolder.amount!!.text = "实盘金额：$pdAmount"
        viewHolder.kucun!!.text = "账面库存：$stockQty"
        val n = 0.0
        try {
            //			double c = ent.getStockQty();
            //			double t = ent.getPdQty();
            //			double p = ent.getProPrice();
            //			n = Arith.sub(t, c);
            //			double e = Arith.mul(n, p);
            viewHolder.chayi!!.text = "差异数量：$diffQty"
            viewHolder.chayijine!!.text = "差异金额：$diffAmount"
        } catch (e: Exception) {
            viewHolder.chayi!!.text = "差异数量：--"
            viewHolder.chayijine!!.text = "差异金额：--"
            BaseAppManager.loger().info(e)
        }

        if (diffQty != 0.0) {
            val color = ContextCompat.getColor(context, R.color.red_text_color)
            viewHolder.price!!.setTextColor(color)
            viewHolder.count!!.setTextColor(color)
            viewHolder.amount!!.setTextColor(color)
            viewHolder.kucun!!.setTextColor(color)
            viewHolder.chayi!!.setTextColor(color)
            viewHolder.chayijine!!.setTextColor(color)
        } else {
            val color = ContextCompat.getColor(context, R.color.text_color_gray)
            viewHolder.price!!.setTextColor(color)
            viewHolder.count!!.setTextColor(color)
            viewHolder.amount!!.setTextColor(color)
            viewHolder.kucun!!.setTextColor(color)
            viewHolder.chayi!!.setTextColor(color)
            viewHolder.chayijine!!.setTextColor(color)
        }
        return convertView
    }

    override fun isChildSelectable(groupPosition: Int, childPosition: Int): Boolean {

        return false
    }

    internal inner class ViewHolder {
        var name: TextView? = null
        var num: TextView? = null
        var price: TextView? = null
        var count: TextView? = null
        var amount: TextView? = null
        var kucun: TextView? = null
        var chayi: TextView? = null
        var chayijine: TextView? = null

    }
}
