package com.urovo.activity.checkGoodsTabAct.view.adapter

import android.view.View
import android.widget.LinearLayout
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.urovo.wgmf.db.dao.entitys.CanCheckRes3
import com.urovo.wugumofang.R
import com.urovo.wugumofang.constants.ConstantParams
import com.urovo.wugumofang.data.StringUtils
import com.urovo.wugumofang.utils.convertDefaultValue
import com.urovo.wugumofang.utils.notNullAndEmpty

/**
 * 盘点提交列表
 * @author LW
 */
class CheckSubmitListAdapter(
    data: MutableList<CanCheckRes3.ResultInfo>?
) :
    BaseQuickAdapter<CanCheckRes3.ResultInfo, BaseViewHolder>(
        R.layout.item_check_submit_list,
        data
    ) {

    override fun convert(helper: BaseViewHolder?, item: CanCheckRes3.ResultInfo?) {
        helper?.apply {
            item?.let {
                setText(
                    R.id.check_submit_bill_code_tv, StringUtils.formatString(
                        mContext.getString(R.string.check_submit_bill_code),
                        it.pdBillCode.convertDefaultValue()
                    )
                )

                setText(
                    R.id.check_submit_brand_name_tv, StringUtils.formatString(
                        mContext.getString(R.string.check_submit_brand_name),
                        it.brandName.convertDefaultValue()
                    )
                )

                setText(
                    R.id.check_submit_state_tv, StringUtils.formatString(
                        mContext.getString(R.string.check_submit_state),
                        it.pdState.convertDefaultValue()
                    )
                )

                val canGoPandian =
                    it.pdState == mContext.getString(R.string.check_submit_draft) || it.pdState == mContext.getString(
                        R.string.check_submit_not_counted
                    )
                getView<LinearLayout>(R.id.check_submit_go_check_ll).visibility =
                    if (canGoPandian) View.VISIBLE else View.INVISIBLE

                if (it.pdState == "草稿" && it.modifyNum == ConstantParams.CONSTANT_STARTS_0) {
                    setText(R.id.check_submit_go_check_tv, R.string.check_submit_go_update)
                } else {
                    setText(R.id.check_submit_go_check_tv, R.string.check_submit_go_check)
                }

                if (it.pdState == mContext.getString(
                        R.string.check_submit_take_effect
                    )
                ) {
                    getView<LinearLayout>(R.id.check_submit_take_effect_info_ll).visibility =
                        View.VISIBLE

                    setText(
                        R.id.check_submit_current_profit_loss_amount_tv, StringUtils.formatString(
                            mContext.getString(R.string.check_submit_current_profit_loss_amount),
                            it.diffAmount
                        )
                    )

                    setText(
                        R.id.check_submit_deduction_points_inventory_tv, StringUtils.formatString(
                            mContext.getString(R.string.check_submit_deduction_points_inventory),
                            it.pdKouFen.convertDefaultValue()
                        )
                    )

                    if (it.modifyNum.toString().notNullAndEmpty()) {
                        setText(
                            R.id.check_submit_modify_num_tv, StringUtils.formatString(
                                mContext.getString(R.string.check_submit_modify_num),
                                it.modifyNum.toString()
                            )
                        )
                        setGone(R.id.check_submit_modify_num_tv, true)
                    } else {
                        setGone(R.id.check_submit_modify_num_tv, false)
                    }

                } else {
                    getView<LinearLayout>(R.id.check_submit_take_effect_info_ll).visibility =
                        View.GONE
                }
            }
        }
    }

}