package com.urovo.activity.combineResult.view;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.GridView;
import android.widget.ImageButton;
import android.widget.TextView;

import com.urovo.activity.combineResult.net.CombineRes;
import com.urovo.activity.combineResult.presenter.CombineContract;
import com.urovo.activity.combineResult.presenter.CombineResultPresenter;
import com.urovo.activity.combineResult.ui.ProductGridAdapter;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.response.BaseResponse;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 搭配详情
 * Created by Sasuke on 2016/9/14.
 */
public class CombineResultAct extends BaseActivity implements CombineContract.View{
    CombineResultPresenter mPresenter;
    @BindView(R.id.product_grid) GridView productGrid;
    @BindView(R.id.combine_score) TextView score;
    @BindView(R.id.combine_review) TextView review;
    @BindView(R.id.combine_advice) TextView advice;
    @BindView(R.id.text_title) TextView textTitle;
    Unbinder unbinder;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ll_combine_result_act);
        unbinder =ButterKnife.bind(this);
        mPresenter = new CombineResultPresenter(this);
        mPresenter.start();
    }

    @Override
    public void init() {
        textTitle.setText("搭配详情");
        ((ImageButton)findViewById(R.id.back)).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });

        Intent intent = getIntent();
        mPresenter.getData().setSelectList(
                (List<ProductEntity>)intent.getSerializableExtra("selectedList"));

        if(mPresenter.getData().getSelectList() != null &&
                mPresenter.getData().getSelectList().size() != 0){
            productGrid.setAdapter(new ProductGridAdapter(this,mPresenter.getData().getSelectList()));
            mPresenter.queryCombineResult();//网络请求获取搭配评分
        }else{
            showMsg("您还没有选择产品");
        }

    }

    @Override
    public void setPresenter(CombineContract.Presenter presenter) {
        this.mPresenter = (CombineResultPresenter)presenter;
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        if(response == null){
            showMsg("没有获取到数据");
            return;
        }
        if(tag.equals("getCombineResult")){
            CombineRes res = (CombineRes)response;
            score.setText(res.getInfo().getScore()+"分");
            review.setText(res.getInfo().getComment());
            advice.setText(res.getInfo().getSuggest());
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }
}
