package com.urovo.activity.common;

import java.util.ArrayList;
import java.util.List;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wgmf.db.dao.entitys.MyMarkStoreEntity.ManagerShops;
import com.urovo.wgmf.db.dao.entitys.MyMarkStoreEntity.OfficeShops;
import com.urovo.wugumofang.R;

/**
 * 办事处门店选择
 * 
 * @author Administrator
 * 
 */
public class OfficeStoreSelectorActivity extends BaseActivity {
	public static final String STORE_TAG = "store";
	public static final int RESULTCODE = 302;
	private List<ShopEntity> mListStore;
	private ArrayList<OfficeShops> officeShops;
	private ArrayList<ManagerShops> managerShops;
	private List<String> mListStoreName = new ArrayList<String>();
	private ListView mListView;
	private MyAdapter myAdapter;
	private String mIntentStore;
	private String myShop, myShopName, myShopId;
	private String productname1, productname2;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.store_list);
		initTitle();
		init();
	}

	@Override
	public void initTitle() {
		super.initTitle();
		titleTextView.setText("请选择标杆门店");
	}

	@SuppressWarnings("unchecked")
	private void init() {
		Intent intent = getIntent();
		officeShops = (ArrayList<OfficeShops>) intent.getSerializableExtra("officeShops");
		managerShops = (ArrayList<ManagerShops>) intent.getSerializableExtra("managerShops");
		myShopName = (String) intent.getSerializableExtra("myShopName");
		myShopId = (String) intent.getSerializableExtra("myShopId");
		myShop = (String) intent.getSerializableExtra("myShop");
		mIntentStore = intent.getStringExtra(STORE_TAG);
		mListStore = new ArrayList<ShopEntity>();

		// 排序
		if(null != officeShops && officeShops.size() > 0) {
			for (int j = 0; j < managerShops.size(); j++) {
				productname1 = managerShops.get(j).shop_name;
				for (int i = 0; i < officeShops.size(); i++) {
					OfficeShops entity = officeShops.get(i);
					productname2 = entity.shop_name;
					if(productname1.equals(productname2) && (!myShopName.equals(productname1))) {
						ShopEntity cell = new ShopEntity();
						cell.setShopName(entity.shop_name);
						cell.setShopId(entity.shop_id);
						mListStore.add(cell);
					}
				}
			}
			for (int j = 0; j < managerShops.size(); j++) {
				for (int i = 0; i < officeShops.size(); i++) {
					productname1 = managerShops.get(j).shop_name;
					OfficeShops entity = officeShops.get(i);
					productname2 = entity.shop_name;
					if((productname1.equals(productname2))) {
						officeShops.remove(i);
					}
				}
			}
			if(null != officeShops && officeShops.size() > 0) {
				for (int k = 0; k < officeShops.size(); k++) {
					OfficeShops entity = officeShops.get(k);
					ShopEntity cell = new ShopEntity();
					cell.setShopName(entity.shop_name);
					cell.setShopId(entity.shop_id);
					mListStore.add(cell);
				}
			}
		}
		for (ShopEntity shopEntity : mListStore) {
			mListStoreName.add(shopEntity.getShopName());
		}

		mListView = (ListView) findViewById(R.id.listview);
		myAdapter = new MyAdapter();
		mListView.setAdapter(myAdapter);
		mListView.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				ShopEntity se = mListStore.get(position);
				Intent intent = new Intent();
				intent.putExtra(STORE_TAG, se);
				intent.putExtra("myShop", myShop);
				intent.putExtra("myShopIdBack", myShopId);
				intent.putExtra("myShopNameBack", myShopName);
				setResult(RESULTCODE, intent);
				OfficeStoreSelectorActivity.this.finish();
			}
		});

	}

	class MyAdapter extends BaseAdapter {

		@Override
		public int getCount() {
			return mListStoreName.size();
		}

		@Override
		public Object getItem(int position) {
			return position;
		}

		@Override
		public long getItemId(int position) {
			return position;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			if(null == convertView) {
				convertView = OfficeStoreSelectorActivity.this.getLayoutInflater().inflate(R.layout.store_list_item, null);
			}
			TextView textViewStore = (TextView) convertView.findViewById(R.id.store_item_text);
			ImageView imageViewChecked = (ImageView) convertView.findViewById(R.id.store_item_checked);
			String name = mListStoreName.get(position);
			textViewStore.setText(name);
			if(null != name && name.equals(mIntentStore)) {
				imageViewChecked.setVisibility(View.VISIBLE);
			}
			else {
				imageViewChecked.setVisibility(View.INVISIBLE);
			}
			return convertView;
		}
	}
}
