package com.urovo.activity.common;

import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.adapter.GoodsChoseAdapter;
import com.urovo.wgmf.db.dao.bill.TmsProductService;
import com.urovo.wugumofang.R;

/**
 * 门店订货查询
 * 
 * @author Administrator
 * 
 */
public class OrderGoodsChoseActivity extends BaseActivity {
	public static final int activityResultCode = 21;// 选择成功后返回的code
	public static final String activityResultData = "activityResultData";// 选择成功后返回的code
	public static final int type_Oder = 1;// 订货状态
	public static final int type_Check = 2;// 盘点状态
	public static final int type_Sale = 3;// 销售状态
	public static final int type_OtherGroup = 4;// 其他组别
	public static final int type_TryEat = 5;// 试吃状态
	public static final int type_Add = 6;// 冲加状态
	public static final String Search_type = "Search_type";// 需查询的类别
	public static final String Search_status = "Search_status";// 需查询的状态
	private TextView texttitle;
	private EditText goodsaddquire;
	private ListView listview;
	private GoodsChoseAdapter adapter;
	private int type = type_Oder;// 查询状态默认为订货
	private String typeStatus = "Y";// 状态默认可以
	private String storeid;

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.staff_menu_chose);
		initTitle();
		init();
		setListener();
	}

	private void init() {

		Intent intent = getIntent();
		storeid = intent.getStringExtra("storeid");
		type = intent.getIntExtra(Search_type, type_Oder);// 取传过来的查询种类
		typeStatus = intent.getStringExtra(Search_status) == null ? "Y" : intent.getStringExtra(Search_status);
		texttitle = (TextView) findViewById(R.id.text_title);
		texttitle.setText("选择产品");
		goodsaddquire = (EditText) findViewById(R.id.goodsaddquire);
		listview = (ListView) findViewById(R.id.listview_adds);
		adapter = new GoodsChoseAdapter(this);
		listview.setAdapter(adapter);

		search();
	}

	private void setListener() {
		listview.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				Intent intent = new Intent();
				intent.putExtra(activityResultData, adapter.getItem(position));
				setResult(activityResultCode, intent);
				OrderGoodsChoseActivity.this.finish();
			}
		});

	}

	public void searchGoods(View view) {
		search();
	}

	private void search() {
		String goodsNo = goodsaddquire.getText().toString().trim();
		// adapter.setList(TmsProductService.getStoreProduct(
		// SystemHelper.LoginOrganId, 1, goodsNo, type, typeStatus));
		adapter.setList(TmsProductService.getStoreProduct(storeid, 1, goodsNo, type, typeStatus));
	}

	@Override
	public boolean dispatchKeyEvent(KeyEvent event) {

		if(event.getKeyCode() == KeyEvent.KEYCODE_ENTER && event.getAction() == KeyEvent.ACTION_DOWN) {
			if(goodsaddquire.isFocused()) {
				search();
			}
		}
		else
			if(event.getAction() == KeyEvent.ACTION_UP) {

			}
		return super.dispatchKeyEvent(event);
	}
}
