package com.urovo.activity.common;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.adapter.GoodsChoseSingleAdapter;
import com.urovo.wgmf.db.dao.dao.Item001DbOperate;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.manager.ThreadManager;
import com.urovo.wugumofang.ui.ViewUtil;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * 门店订货查询(选择单个)
 *
 * @author Administrator
 */
public class OrderGoodsChoseSingleActivity extends BaseActivity {
    public static final int activityResultCode = 20;// 选择成功后返回的code
    public static final String activityResultData = "activityResultData";// 选择成功后返回的code
    public static final int type_Oder = 1;// 订货状态
    public static final int type_Check = 2;// 盘点状态
    public static final int type_Sale = 3;// 销售状态
    public static final int type_quality = 4;//上报反馈
    public static final int type_goodsInOutStock = 5;//产品出入库
    public static final String Search_type = "Search_type";// 需查询的类别
    public static final String IS_FILTER = "IS_FILTER";
    private TextView texttitle;
    private EditText goodsaddquire;
    private ListView listview;
    private Button submit;
    private GoodsChoseSingleAdapter adapter;
    private int type = type_Oder;// 查询状态默认为订货
    private boolean isFilter = false;
    private String storeid;
    private List<ProductEntity> list;
    private List<ProductEntity> listShow = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.goods_chose_new);
        initTitle();
        init();
        setListener();
    }

    private void init() {

        Intent intent = getIntent();
        storeid = intent.getStringExtra("storeid");
        type = intent.getIntExtra(Search_type, type_Oder);// 取传过来的查询种类
        isFilter = intent.getBooleanExtra(IS_FILTER, false); //过滤数据
        texttitle = (TextView) findViewById(R.id.text_title);
        submit = (Button) findViewById(R.id.submit);
        texttitle.setText("选择产品");
        goodsaddquire = (EditText) findViewById(R.id.goodsaddquire);

        listview = (ListView) findViewById(R.id.listview_adds);
        adapter = new GoodsChoseSingleAdapter(this, listShow);
        listview.setAdapter(adapter);

        search();
    }

    private void setListener() {
        goodsaddquire.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {

                String keyWord = goodsaddquire.getText().toString().trim();
                if (TextUtils.isEmpty(keyWord)) {
                    listShow.clear();
                    listShow.addAll(list);
                } else {
                    listShow.clear();
                    for (ProductEntity p : list) {
                        if (p.getItemId().contains(keyWord) || p.getItemName().contains(keyWord)) {
                            listShow.add(p);
                        }
                    }
                }
                adapter.setKeyWord(keyWord);//用于设置局部文字高亮。
                adapter.notifyDataSetChanged();
            }
        });
        listview.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                Intent intent = new Intent();
                intent.putExtra(activityResultData, (Serializable) listShow.get(position));
                setResult(activityResultCode, intent);
                OrderGoodsChoseSingleActivity.this.finish();

            }
        });
    }

    private void search() {
        ViewUtil.showProgress(OrderGoodsChoseSingleActivity.this, "", "请稍等.....");
        ThreadManager.getThreadPool().execute(() -> {
            switch (type) {
                case type_Oder:
                    list = Item001DbOperate.GetCanDingHuoProducts(storeid);
                    for (ProductEntity p : list) {
                        p.setTQTY(p.getDHPack());
                        p.setAmount(Arith.mul(p.getTQTY(), p.getPrice()));
                    }
                    break;
                case type_Sale:
                    list = Item001DbOperate.GetCanXiaoShouProducts(storeid);
                    break;
                case type_quality:
                    ArrayList<ProductEntity> productList = Item001DbOperate.GetCanGuWenBrandProducts();
                    list = new ArrayList<>();
                    //list= Item001DbOperate.GetAll();

                    for (ProductEntity p : productList) {
                        if (isFilter && "2.70225".equals(p.getItemId())) {
                            continue;
                        }
                        p.setTQTY(p.getDHPack());
                        p.setAmount(Arith.mul(p.getTQTY(), p.getPrice()));
                        list.add(p);
                    }
                    break;
                case type_goodsInOutStock:
                    list = Item001DbOperate.GetAll();
                    for (ProductEntity p : list) {
                        p.setTQTY(p.getDHPack());
                        p.setAmount(Arith.mul(p.getTQTY(), p.getPrice()));
                    }
                    break;
                default:
                    break;
            }
            Collections.sort(list, (left, right) -> {
                if (left.getItemId().startsWith("2.4") && !right.getItemId().startsWith("2.4")) {
                    return -1;
                } else if (!left.getItemId().startsWith("2.4") && right.getItemId().startsWith("2.4")) {
                    return 1;
                } else {
                    return left.getItemId().compareTo(right.getItemId());
                }
            });

            listShow.addAll(list);
            runOnUiThread(() -> {
                ViewUtil.dismissProgress();
                adapter.notifyDataSetChanged();
            });
        });
    }
}