package com.urovo.activity.common;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.bill.DalCommon;
import com.urovo.wugumofang.R;

/**
 * 省份城市选择
 * 
 * @author Administrator
 * 
 */
public class ProvinceCitySelectorActivity extends BaseActivity {

	public static final int RESULTCODE_CITY = 102;
	private TextView title;
	private ListView listview;
	private List<String> list;
	private boolean isCity = false;
	private String province;
	private ProvinceCityAdapter adapter;

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.store_list);
		init();
		initTitle();
	}

	private void init() {
		title = (TextView) findViewById(R.id.text_title);
		title.setText("请选择省份");
		list = new ArrayList<String>(Arrays.asList(DalCommon.GetProvince()));
		listview = (ListView) findViewById(R.id.listview);
		adapter = new ProvinceCityAdapter();
		listview.setAdapter(adapter);
		listview.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				String info = list.get(position);
				if(isCity) {
					Intent intent = new Intent();
					intent.putExtra("province", province);
					intent.putExtra("city", info);
					setResult(RESULTCODE_CITY, intent);
					ProvinceCitySelectorActivity.this.finish();
				}
				else {
					province = info;
					list.clear();
					list.addAll(new ArrayList<String>(Arrays.asList(DalCommon.GetAreaByProvince(province))));
					adapter.notifyDataSetChanged();
					title.setText("请选择城市");
					isCity = true;

				}

			}
		});
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {

		if(keyCode == KeyEvent.KEYCODE_BACK) {
			back();
			return true;
		}
		return super.onKeyDown(keyCode, event);
	}

	@Override
	protected void back() {

		if(isCity) {
			isCity = false;
			list.clear();
			list.addAll(new ArrayList<String>(Arrays.asList(DalCommon.GetProvince())));
			adapter.notifyDataSetChanged();
		}
		else {
			this.finish();
		}
	}

	class ProvinceCityAdapter extends BaseAdapter {

		@Override
		public int getCount() {

			return list.size();
		}

		@Override
		public Object getItem(int position) {

			return position;
		}

		@Override
		public long getItemId(int position) {

			return position;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {

			if(null == convertView) {
				convertView = ProvinceCitySelectorActivity.this.getLayoutInflater().inflate(R.layout.city_list_item, null);
			}
			TextView textView = (TextView) convertView.findViewById(R.id.city_item_text);
			ImageView imageView = (ImageView) convertView.findViewById(R.id.is_city_item);
			String name = list.get(position);
			textView.setText(name);
			if(!isCity) {
				imageView.setVisibility(View.VISIBLE);
			}
			else {
				imageView.setVisibility(View.GONE);
			}
			return convertView;
		}

	}
}
