package com.urovo.activity.common;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wgmf.AsyncTask.BaseAppServerTask;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wgmf.db.dao.dao.Store001DbOprate;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.entity.response.PullAllStoreResponse;
import com.urovo.wgmf.db.dao.entitys.PullAllStoreEntity;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 门店选择
 *
 * @author Administrator
 */
public class StoreSelectorActivity extends BaseActivity {
    public static final String STORE_TAG = "store";
    public static final String INTENT_FROM_ACTIVITY = "thisActivity";
    public static final int RESULTCODE = 100;
    private ListView mListView;
    private List<ShopEntity> mListStore;
    private List<String> mListStoreName;
    private List<PullAllStoreEntity> mPullAllStoreList;
    private String mIntentStore;
    private boolean mBanShiChu;
    private boolean mNoAll;
    private String mIntentFromActivity;//跳转来的源Activity

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.store_list);
        initTitle();
        init();
    }

    @Override
    public void initTitle() {

        super.initTitle();
        titleTextView.setText("请选择门店");

    }

    private void pullAllStore(String organid, String userid) {
        Map<String, String> p = new HashMap<String, String>();
        p.put("userId", userid);
        p.put("organizationCode", organid);
        new BaseAppServerTask("pullAllStore", PullAllStoreResponse.class, this, "正在查询本办事处所有门店...", true, "/information/getOfficeStoreByOrganization", p).execute("");
    }

    private void init() {
        Intent intent = getIntent();
        mIntentStore = intent.getStringExtra(STORE_TAG);
        mBanShiChu = intent.getBooleanExtra("banshichu", false);
        mIntentFromActivity = intent.getStringExtra(StoreSelectorActivity.INTENT_FROM_ACTIVITY);
        if (mIntentFromActivity == null) {
            mIntentFromActivity = "";
        }
        mNoAll = intent.getBooleanExtra("noall", false);
        if (mBanShiChu) {

            pullAllStore(SystemHelper.LoginOrganId, SystemHelper.LoginUserId);
        } else {
            mListStore = Store001DbOprate.GetShopChoice();
            mListStoreName = new ArrayList<String>();
            //去掉“选择门店”时的“全部”项（月销量查询 和 会员销售占比查询 和 积分兑换流水查询 不显示）
            if (SystemHelper.IsAdmin
                    && !mIntentFromActivity.equals("QuerySales")
                    && !mIntentFromActivity.equals("QueryMemberSalesCompared")
                    && !mIntentFromActivity.equals("QueryCreditStatement")) {
                ShopEntity entity = new ShopEntity();
                entity.setShopId(SystemHelper.LoginOrganId);
                entity.setShopName("全部");
                mListStore.add(0, entity);
            }
            for (ShopEntity shopEntity : mListStore) {
                mListStoreName.add(shopEntity.getShopName());
            }
            mListView = (ListView) findViewById(R.id.listview);
            mListView.setAdapter(new MyAdapter());
            mListView.setOnItemClickListener(new OnItemClickListener() {

                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                    ShopEntity se = mListStore.get(position);
                    Intent intent = new Intent();
                    intent.putExtra(STORE_TAG, se);
                    setResult(RESULTCODE, intent);
                    StoreSelectorActivity.this.finish();
                }
            });
        }

    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);

        if ("pullAllStore".equals(tag)) {
            PullAllStoreResponse res = (PullAllStoreResponse) response;
            mPullAllStoreList = res.getList();
            if (null != mPullAllStoreList && !mPullAllStoreList.isEmpty()) {
                Collections.sort(mPullAllStoreList, new Comparator<PullAllStoreEntity>() {
                    @Override
                    public int compare(PullAllStoreEntity lhs, PullAllStoreEntity rhs) {

                        return rhs.special.compareTo(lhs.special);
                    }
                });
                mListStoreName = new ArrayList<String>();
                for (PullAllStoreEntity entity : mPullAllStoreList) {
                    mListStoreName.add(entity.name);
                }
                mListView = (ListView) findViewById(R.id.listview);
                mListView.setAdapter(new MyAdapter());
                mListView.setOnItemClickListener(new OnItemClickListener() {

                    @Override
                    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                        ShopEntity se = new ShopEntity();
                        PullAllStoreEntity cell = mPullAllStoreList.get(position);
                        se.setShopName(cell.name);
                        se.setShopId(cell.code);
                        Intent intent = new Intent();
                        intent.putExtra(STORE_TAG, se);
                        setResult(RESULTCODE, intent);
                        StoreSelectorActivity.this.finish();
                    }
                });
            }
        }
    }

    class MyAdapter extends BaseAdapter {

        @Override
        public int getCount() {

            return mListStoreName.size();
        }

        @Override
        public Object getItem(int position) {

            return position;
        }

        @Override
        public long getItemId(int position) {

            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {

            if (null == convertView) {
                convertView = StoreSelectorActivity.this.getLayoutInflater().inflate(R.layout.store_list_item, null);
            }
            TextView textViewStore = (TextView) convertView.findViewById(R.id.store_item_text);
            ImageView imageViewChecked = (ImageView) convertView.findViewById(R.id.store_item_checked);
            String name = mListStoreName.get(position);
            textViewStore.setText(name);
            if (null != name && name.equals(mIntentStore)) {
                imageViewChecked.setVisibility(View.VISIBLE);
            } else {
                imageViewChecked.setVisibility(View.INVISIBLE);
            }
            return convertView;
        }

    }
}
