package com.urovo.activity.customercare.presenter

import com.urovo.activity.customercare.net.CustomerCareDetailRes
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.system.SystemHelper
import okhttp3.Request

/**
 *  *  @author XP on 2019/8/23.
 */
class CustomerCareDetailPre(val mView: CustomerCareDetailCon.view) : CustomerCareDetailCon.pre {
    var resSave: CustomerCareDetailRes? = null

    init {
        mView.setPresenter(this)
    }


    override fun start() {
        mView.init()
    }

    /**
     * 查询数据 ，类型：已回访，未回访
     */
    fun queryData(labelType: Int, taskId: String) {
        mView.showLoading()
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.GET_CARE_TASK_DETAIL,
                mapOf("taskId" to taskId, "shopId" to SystemHelper.LoginOrganId),
                object : OkHttpDominator.ResultCallback<CustomerCareDetailRes>() {
                    override fun onError(request: Request?, e: Exception?) {
                        mView.showNetError()
                        e?.printStackTrace()
                    }

                    override fun onResponse(res: CustomerCareDetailRes?) {
                        if (res == null || res.msgCode != 0) {
                            mView.showNoData()
                            return
                        }
                        mView.run {
                            resSave = res.apply {

                                resultInfo.apply {
                                    if ((labelType == 0 && pandingCareList?.size == 0) || (labelType == 1 && careList?.size == 0)) {
                                        mView.showNoData()
                                        return
                                    }
                                    //根据购买时间逆序排序
                                    careList = careList?.sortedByDescending { it.lastBuyDate }
                                    pandingCareList = pandingCareList?.sortedByDescending { it.lastBuyDate }
                                }
                            }
                            dismissLoadWait()
                            showData(labelType)
                        }
                    }
                })
    }
}