package com.urovo.activity.customercare.ui

import android.content.Context
import android.content.Intent
import android.graphics.Color
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.MemberList.model.MemberListEntity
import com.urovo.activity.MemberProfile.view.MemberProfileAct
import com.urovo.activity.customercare.net.CustomerCareDetailRes
import com.urovo.wugumofang.R
import org.jetbrains.anko.find

/**
 *  @author XP on 2019/8/23.
 */
class CustomerCareDetailAdapter(val context: Context, var dataList: List<CustomerCareDetailRes.ResultInfo.DetailItem>?,val taskId: String,var hasCared: Boolean) : RecyclerView.Adapter<Ra90Holder>() {

    override fun onBindViewHolder(holder: Ra90Holder, pos: Int) {
        holder.apply {
            dataList?.get(pos)?.let {
                val item = it
                phoneTv.apply { text = if (item.mobile != null) item.mobile.toString() else "--";setTextColor(Color.BLACK) }
                levelTv.apply { text = if (item.grade != null) item.grade.toString() else "--"; setTextColor(Color.BLACK) }
                lastBuyTime.apply { text = if (item.lastBuyDate != null) item.lastBuyDate.toString() else "--"; setTextColor(Color.BLACK) }

                rightArrow.visibility = View.VISIBLE
                itemRoot.setOnClickListener {
                    val entity = MemberListEntity().apply {
                        buyDate = item.lastBuyDate
                        customerMobile = item.mobile
                        smsCare = item.grade
                        type = "1"//默认传1获取全部数据
                        feedback = item.feedback
                        hasCommunication = if (hasCared) "1" else "0"
                    }
                    context.startActivity(Intent(context, MemberProfileAct::class.java).apply {
                        putExtra("phone", item.mobile)
                        putExtra("entity", entity)//只用传对应会员的Entity就行了
                        putExtra("careType", "4")// "关怀类型 默认1新客三响炮 2积分到期提醒 3钻石会员4,自定义任务关怀"
                        putExtra("position", pos)
                        putExtra("taskId",taskId)
                    })
                }
            }
        }
    }

    override fun getItemCount(): Int {
        return dataList?.size ?: 0
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): Ra90Holder {
        return Ra90Holder(LayoutInflater.from(context).inflate(R.layout.ll_ra90_detail_item, parent, false))
    }
}

class Ra90Holder(view: View) : RecyclerView.ViewHolder(view) {
    var itemRoot: ViewGroup
    var phoneTv: TextView
    var levelTv: TextView
    var lastBuyTime: TextView
    var rightArrow: ImageView

    init {
        itemRoot = view.find<ViewGroup>(R.id.itemRoot)
        phoneTv = view.find<TextView>(R.id.phoneTv)
        levelTv = view.find<TextView>(R.id.levelTv)
        lastBuyTime = view.find<TextView>(R.id.lastBuyTime)
        rightArrow = view.find<ImageView>(R.id.rightArrow)
    }
}