package com.urovo.activity.customerlabel.presenter

import com.urovo.activity.customerlabel.model.CustomerLabelEntity
import com.urovo.activity.customerlabel.model.CustomerLabelSubmitEntity
import com.urovo.wugumofang.base.BasePresenter
import com.urovo.wugumofang.base.mvp.AbsView


interface CustomerLabelContract {

    interface IView : AbsView {
        /**
         * 标签列表
         */
        fun labelListData(data: List<CustomerLabelEntity>?) {}

        /**
         * 保存顾客标签状态
         */
        fun saveLabelDetailStatus(status: Boolean) {}
    }

    interface IPresenter : BasePresenter {
        /**
         * post /crm-api/basic/label/option/list 标签列表
         */
        fun requestLabelList(mobile: String?)

        /**
         * post /exhibit/addSubmition 新增标签数据
         */
        fun requestSaveLabelDetail(customerLabelSubmitList: List<CustomerLabelSubmitEntity>)
    }
}

