package com.urovo.activity.customerlabel.service

import com.urovo.activity.customerlabel.model.*
import com.urovo.wugumofang.net.RetrofitHelper
import com.zsy.libcore.model.bean.RequestResult
import retrofit2.Call

/**
 * 顾客标签仓库
 * @author LW
 */
class CustomerLabelRepository {

    private val mApiService by lazy {
        RetrofitHelper.createNewApi(ApiService::class.java)
    }

    /**
     * 获取标签列表
     * @param mobile String 手机号
     */
    fun requestLabelList(mobile: String?): Call<RequestResult<List<CustomerLabelEntity>>> {
        return mApiService.labelList(CustomerLabelReqEntity(mobile))
    }

    /**
     * 新增标签数据
     */
    fun requestSaveLabelDetail(
        list: List<CustomerLabelSubmitEntity>?
    ): Call<RequestResult<Any>> {
        return mApiService.saveLabelDetail(list)
    }
}