package com.urovo.activity.customerprivilege.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.activity.customerprivilege.model.Acts;
import com.urovo.wugumofang.R;

import java.util.List;

public class CustomerPrivilegeAdapter extends BaseAdapter {
    private List<Acts> list;
    private Context context;

    public CustomerPrivilegeAdapter(List<Acts> acts, Context context) {
        this.list = acts;
        this.context = context;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {
        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.customer_privilege_info_item, null);
            viewHolder = new ViewHolder();
            viewHolder.name = convertView.findViewById(R.id.name);
            viewHolder.status = convertView.findViewById(R.id.status);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }

        final Acts data = list.get(position);
        viewHolder.name.setText(data.getName());
        viewHolder.status.setText(data.getCodeStatus() == 1 ? "已核销" : "未核销");//是否兑换（0.未兑换1.已兑换） ,
        return convertView;
    }

    class ViewHolder {
        TextView name;
        TextView status;
    }
}
