package com.urovo.activity.data;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.BaseAdapter;
import android.widget.BaseExpandableListAdapter;
import android.widget.Button;
import android.widget.ExpandableListView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.activity.common.StoreSelectorActivity;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wgmf.db.dao.dao.Store001DbOprate;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.DataMonthUtils;
import com.urovo.wugumofang.R;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;

public abstract class DataBaseActivity extends BaseActivity implements OnClickListener, StoreDateSelectorPop.StoreDateSelectorPopListener, StoreDateSelectorPop.FolioTypeSetter {
    protected BaseAdapter mMyAdapter;
    protected BaseExpandableListAdapter mExpandableListAdapter;
    protected ListView mListView;
    protected ExpandableListView mExListView;
    protected boolean mIsAdmin;
    protected StoreDateSelectorPop mStoreDateSelectorPop;
    protected String mSql;
    protected LinearLayout mLinearLayoutEdit, mLinearLayoutEditTwo;
    protected Button item_foot, btnEdit, btnEditCancel, btnEditConfirm;
    protected LinearLayout mLinearLayoutMore;
    protected LinearLayout mLinearLayoutDateStore;//显示日期和门店的LL
    protected TextView mTextViewDate;
    protected TextView mTextViewStore;
    protected TextView mTextViewStore0;//用于三响炮的新布局，使用该组件时要把上面那个mTextViewStore给屏蔽掉
    protected ImageView mImageMore;
    protected String mStoreId;
    protected String mOrganizationCode;
    protected String mStoreName;
    protected String mUserID;
    protected String mDateMonth;
    protected String mDateFrom;
    protected String mDateTo;
    protected TextView mWeiVipCont;
    protected TextView mWeiVipNumber;
    protected TextView mWeiVipCore;
    protected TextView mState;
    protected TextView mWeiVipTitile;
    protected TextView listTopTitle;

    protected LinearLayout mWeiVipEmpty;
    protected View mWeiVipView;
    protected LinearLayout item_container;
    protected LinearLayout mWeiVipContent;

    protected int mFolioType = 1;//客单数查询的类型。1、按月查询  2、按天查询（默认按月）
    private LinearLayout mLinearLayoutParent;

    protected abstract boolean isExpandableList();

    protected abstract String getTitleText();

    protected abstract int getPopupWindowMode();

    protected abstract BaseAdapter newBaseAdapter();

    protected abstract BaseExpandableListAdapter newExpandableAdapter();

    protected abstract void requestConnectTask();

    protected abstract void search(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo);

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.query_data);
        mIsAdmin = SystemHelper.IsAdmin;
        if (mIsAdmin) {
            List<ShopEntity> mListStore = Store001DbOprate.GetShopChoice();
           /* if (this instanceof QueryCredit) {
                mStoreId = SystemHelper.LoginOrganId;
                mStoreName = "全部";
                mOrganizationCode = SystemHelper.LoginOrganId;
                mUserID = SystemHelper.LoginUserId;
            } else*/
//            if (/*this instanceof QuerySales || this instanceof QueryMyWeiVIPAct|| */ this instanceof QueryGuestFolio || this instanceof QueryProductSales || this instanceof QueryThreeMonthMember /*|| this instanceof QueryMemberSalesCompared*/) {
            if (/*this instanceof QuerySales || this instanceof QueryMyWeiVIPAct|| *//* this instanceof QueryGuestFolio || */this instanceof QueryThreeMonthMember /*|| this instanceof QueryMemberSalesCompared*/) {
                mStoreId = "1";
                mStoreName = "全部";
                mOrganizationCode = SystemHelper.LoginOrganId;
                mUserID = SystemHelper.LoginUserId;
            } else if (null != mListStore && mListStore.size() > 0) {
                mStoreId = mListStore.get(0).getShopId();
                mStoreName = mListStore.get(0).getShopName();
                mUserID = SystemHelper.LoginUserId;
                mOrganizationCode = SystemHelper.LoginOrganId;
            }
        } else {
            mUserID = SystemHelper.LoginUserId;
            mStoreId = SystemHelper.LoginOrganId;
            mStoreName = SystemHelper.LoginOrganName;
            mOrganizationCode = null;
        }
        initTitle();
        initHeader();
        initView();
        initContent();
    }

    @Override
    public void initTitle() {

        super.initTitle();
        titleTextView.setText(getTitleText());

    }

    @SuppressWarnings("all")
    private void initHeader() {
        mTextViewDate = (TextView) findViewById(R.id.textView1);
        mTextViewStore = (TextView) findViewById(R.id.textView2);
        mTextViewStore0 = (TextView) findViewById(R.id.textView0);//三响炮专用
        mTextViewStore.setSelected(true);

        mTextViewStore.setText(mStoreName);
        mTextViewStore0.setText(mStoreName);
        mTextViewStore0.setVisibility(View.GONE);

        mImageMore = (ImageView) findViewById(R.id.imageView1);
        mLinearLayoutMore = (LinearLayout) findViewById(R.id.linearLayout1);
        mLinearLayoutDateStore = (LinearLayout) findViewById(R.id.date_store_ll);

        if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_MONTH) {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM", Locale.CHINA);
            mDateMonth = sdf.format(new Date());
            mTextViewDate.setText(mDateMonth);
        } else if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_LAST_MONTH) {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM", Locale.CHINA);
            Date nowDate = new Date();
            Calendar c = Calendar.getInstance();
            c.set(Calendar.YEAR, nowDate.getYear() + 1900);
            c.set(Calendar.MONTH, nowDate.getMonth() - 1);
            mDateMonth = sdf.format(c.getTime());
            mTextViewDate.setText(mDateMonth);
        } else if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_FROMTO) {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
            Date nowDate = new Date();
            mDateTo = sdf.format(nowDate);
            nowDate.setDate(1);
            mDateFrom = sdf.format(nowDate);
            mTextViewDate.setText(mDateFrom + "至" + mDateTo);
        } else if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_INFO) {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
            Date nowDate = new Date();
            nowDate.setDate(1);
            Calendar c = Calendar.getInstance();
            c.set(Calendar.YEAR, nowDate.getYear() + 1900);
            c.set(Calendar.MONTH, nowDate.getMonth());
            c.set(Calendar.DATE, nowDate.getDate());
            c.add(Calendar.MONTH, -3);
            nowDate = new Date(nowDate.getTime() - 24 * 60 * 60 * 1000);
            mDateTo = sdf.format(nowDate);
            mDateFrom = sdf.format(c.getTime());
            mTextViewDate.setText(mDateFrom + "至" + mDateTo);
        } else if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_SANXIANGPAO_DATA) {//三响炮专用
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
            SimpleDateFormat sdf2 = new SimpleDateFormat("yyyy年MM月dd", Locale.CHINA);
            Date nowDate = new Date();//默认日期为当前日期至当前日期
            Calendar c = Calendar.getInstance();
//            Calendar.getInstance().set(Calendar.YEAR, c.get(Calendar.YEAR));
            nowDate.setYear(c.get(Calendar.YEAR) - 1900);
            mDateTo = sdf.format(nowDate);
            mDateFrom = sdf.format(nowDate);
            mTextViewDate.setText(sdf2.format(nowDate) + "   至   " + sdf2.format(nowDate));
            mTextViewStore.setVisibility(View.GONE);
            mTextViewStore0.setVisibility(View.VISIBLE);
            mTextViewStore0.setSelected(true);

            mLinearLayoutMore.setLayoutParams(
                    new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT,
                            ViewGroup.LayoutParams.WRAP_CONTENT));
        } else if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_FROMTO_USER) {//新客有效微会员专用 (popuwindow)
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM", Locale.CHINA);
            mDateMonth = sdf.format(new Date());
            DateUtil.parseDate(mDateMonth);
            mTextViewDate.setSingleLine();
//            mTextViewDate.setTextSize(DensityUtil.sp2px(this,10));
            mTextViewDate.setText(String.format("%s月\t,", mDateMonth.replace("-", "年")));
        } else if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_GUEST_FOLIO) {//客单数查询专用
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
            Date nowDate = new Date();
            mDateTo = "";//默认按月查
            mDateMonth = sdf.format(nowDate).substring(0, 7);
            mDateFrom = sdf.format(nowDate);
            mTextViewDate.setText(new SimpleDateFormat("yyyy-MM", Locale.CHINA).format(nowDate));
        } else {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
            Date nowDate = new Date();
            mDateTo = sdf.format(nowDate);
            mDateFrom = sdf.format(nowDate);
            mTextViewDate.setText(mDateFrom + "至" + mDateTo);
        }

        //如果显示了两个日期，就用上下布局，否则用水平布局
        if (!mTextViewDate.getText().toString().contains("至")
                && (getPopupWindowMode() != StoreDateSelectorPop.STORE_DATE_GUEST_FOLIO)) {//排除客单数查询的情况
            mLinearLayoutDateStore.setOrientation(LinearLayout.HORIZONTAL);//水平
            mLinearLayoutDateStore.setGravity(Gravity.LEFT | Gravity.CENTER_VERTICAL);
        }

        mLinearLayoutMore.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {

                showPopWindowDateStore();
            }
        });
    }

    @SuppressWarnings("all")
    private void initView() {
        mListView = (ListView) findViewById(R.id.listView1);
        View headerView = this.getLayoutInflater().inflate(R.layout.myweivip_headview, null);
        mListView.addHeaderView(headerView);
        View footView = this.getLayoutInflater().inflate(R.layout.mark_store_footview, null);
        mListView.addFooterView(footView);
        item_container = (LinearLayout) headerView.findViewById(R.id.item_container);//新客微会员面板
        item_container.setVisibility(View.GONE);
        mWeiVipCont = (TextView) findViewById(R.id.weivipcont);
        mWeiVipNumber = (TextView) findViewById(R.id.weivipnumber);
        mWeiVipCore = (TextView) findViewById(R.id.weivipscore);
        findViewById(R.id.btn_sweep_code_detail).setOnClickListener(this);//查看扫码加粉明细按钮
        mState = (TextView) findViewById(R.id.state);
        mWeiVipTitile = (TextView) findViewById(R.id.weiviptitle);
        listTopTitle = (TextView) findViewById(R.id.listTopTitle);
        mWeiVipView = findViewById(R.id.weivipview);
        mLinearLayoutParent = (LinearLayout) findViewById(R.id.linearLayoutParent);
        mWeiVipEmpty = (LinearLayout) findViewById(R.id.weivipempty);
        mWeiVipContent = (LinearLayout) findViewById(R.id.weivipcontent);
        // 添加固定在底部的按钮
        mLinearLayoutEdit = (LinearLayout) findViewById(R.id.ll_edit);
        mLinearLayoutEditTwo = (LinearLayout) findViewById(R.id.ll_edit_twobtn);
        btnEdit = (Button) findViewById(R.id.btn_edit);
        btnEditCancel = (Button) findViewById(R.id.btn_edit_cancel);
        btnEditConfirm = (Button) findViewById(R.id.btn_edit_confirm);
        // 列表尾部弃用
        item_foot = (Button) findViewById(R.id.btn_mark_store_footview);
        assert item_foot != null;
        item_foot.setVisibility(View.GONE);
    }

    private void initContent() {
        if (isExpandableList()) {
            mLinearLayoutParent.removeView(mListView);
            mExListView = new ExpandableListView(this);
            mListView = mExListView;
            mLinearLayoutParent.addView(mExListView, AbsListView.LayoutParams.MATCH_PARENT, AbsListView.LayoutParams.MATCH_PARENT);
            mExpandableListAdapter = newExpandableAdapter();
            mExListView.setAdapter(mExpandableListAdapter);
            mExListView.setGroupIndicator(null);
        } else {
            mMyAdapter = newBaseAdapter();
            mListView.setAdapter(mMyAdapter);
        }
        showEmpty();
    }

    protected void showPopWindowDateStore() {
        if (null == mStoreDateSelectorPop) {
            mStoreDateSelectorPop = new StoreDateSelectorPop(this, this, mIsAdmin, getPopupWindowMode());
            mStoreDateSelectorPop.setStore(mStoreName);
            mStoreDateSelectorPop.setStroreId(mStoreId);
            mStoreDateSelectorPop.setDateFrom(mDateFrom);
            mStoreDateSelectorPop.setMixBegin(mDateFrom);
            mStoreDateSelectorPop.setDateTo(mDateTo);
            mStoreDateSelectorPop.setMixEnd(mDateTo);
            mStoreDateSelectorPop.setDateMonth(mDateMonth);
        }
        if (!mStoreDateSelectorPop.isShowing()) {
            mStoreDateSelectorPop.show(titile_bg);
        }
    }

    @SuppressWarnings("unused")
    private void closePopWindowDateStore() {
        if (mStoreDateSelectorPop.isShowing()) {
            mStoreDateSelectorPop.dismiss();
        }
    }

    @SuppressWarnings("all")
    protected void showEmpty() {
        View v = LayoutInflater.from(this).inflate(R.layout.listview_empty, null);
        v.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        // v.setVisibility(View.GONE);
        if (null != mListView.getTag()) {
            View old = (View) mListView.getTag();
            ((ViewGroup) mListView.getParent()).removeView(old);
        }
        ((ViewGroup) mListView.getParent()).addView(v);
        mListView.setTag(v);
        mListView.setEmptyView(v);
        if (null != mMyAdapter)
            mMyAdapter.notifyDataSetChanged();
        if (null != mExpandableListAdapter)
            mExpandableListAdapter.notifyDataSetChanged();
    }

    @SuppressWarnings("all")
    private void showNetError() {
        View v = LayoutInflater.from(this).inflate(R.layout.listview_empty_error, null);
        v.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        // v.setVisibility(View.GONE);
        Button btn = (Button) v.findViewById(R.id.buttonDownload);
        btn.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {

                requestConnectTask();
            }
        });
        if (null != mListView.getTag()) {
            View old = (View) mListView.getTag();
            ((ViewGroup) mListView.getParent()).removeView(old);
        }
        ((ViewGroup) mListView.getParent()).addView(v);
        mListView.setTag(v);
        mListView.setEmptyView(v);
        if (null != mMyAdapter)
            mMyAdapter.notifyDataSetChanged();
        if (null != mExpandableListAdapter)
            mExpandableListAdapter.notifyDataSetChanged();
    }

    @Override
    public void netError() {

        showNetError();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);
        switch (resultCode) {
            case StoreSelectorActivity.RESULTCODE:
                ShopEntity shopEntity = (ShopEntity) data.getSerializableExtra(StoreSelectorActivity.STORE_TAG);
                if (shopEntity != null) {
                    mStoreDateSelectorPop.setStore(shopEntity.getShopName());
                    mStoreDateSelectorPop.setStroreId(shopEntity.getShopId());
                }
                break;

            default:
                break;
        }
    }

    @Override
    public void onChooseStore() {

        Intent intent = new Intent(this, StoreSelectorActivity.class);
        intent.putExtra(StoreSelectorActivity.INTENT_FROM_ACTIVITY, this.getClass().getSimpleName());
        intent.putExtra(StoreSelectorActivity.STORE_TAG, mStoreDateSelectorPop.getStore());
        startActivityForResult(intent, StoreSelectorActivity.RESULTCODE);
    }

    @Override
    public void onChooseDate(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {

        if (!mIsAdmin) {
            onStartSearch(id, store, user, dateYearMonth, dateFrom, dateTo);
        }
    }

    @Override
    public void onStartSearch(String id, String store, String userid, String dateYearMonth, String dateFrom, String dateTo) {

        if (!TextUtils.isEmpty(dateFrom) && !TextUtils.isEmpty(dateTo)) {
            if (DateUtil.parseDate(dateFrom).getTime() - DateUtil.parseDate(dateTo).getTime() > 0) {
                showMsg("开始时间不能大于结束时间！");
                return;
            }
            if (Math.abs(
                    DateUtil.diffDate(
                            DateUtil.parseDate(dateFrom), DateUtil.parseDate(dateTo))) > 31) {
                showMsg("时间段不能超过31天！");
                return;
            }
        }

        mTextViewStore.setText(store);
        mStoreDateSelectorPop.dismiss();

        if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_MONTH || getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_LAST_MONTH  //这个是督导模式的QueryMyWeiQeiVIP
                || getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_FROMTO_USER) {//这个是营养顾问模式下的 新客微会员
            mTextViewDate.setText(String.format("%s月\t,", dateYearMonth.replace("-", "年")));
        } else if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_SANXIANGPAO_DATA) {//如果是三响炮数据查询
            SimpleDateFormat sf = new SimpleDateFormat("yyyy年MM月dd日", Locale.CHINA);
            mTextViewDate.setText(sf.format(DateUtil.parseDate(dateFrom)) + "  至  " + sf.format(DateUtil.parseDate(dateTo)));
        } else if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_GUEST_FOLIO) {//客单数查询
            mTextViewDate.setText(String.format("%s%s", dateFrom, TextUtils.isEmpty(dateTo) ? "" : "至" + dateTo));//dateTo为空则不显示“至”
        } else {
            mTextViewDate.setText(dateFrom + "至" + dateTo);
        }

        //如果只是以月份来查询
        if (TextUtils.isEmpty(dateFrom) || TextUtils.isEmpty(dateTo)) {
            String mDateYearMonth = dateYearMonth + "-01";
            try {
                dateFrom = DataMonthUtils.getMinMonthDate(mDateYearMonth);
                dateTo = DataMonthUtils.getMaxMonthDate(mDateYearMonth);
            } catch (ParseException e1) {
                e1.printStackTrace();
            }
        }
        search(id, store, userid, dateYearMonth, dateFrom, dateTo);
    }

    @Override
    public int getFolioType() {
        return mFolioType;
    }

    /**
     * 用来把客单数查询的查询方式type传回DatabaseActivity
     */
    @Override
    public void setFolioType(int type) {
        mFolioType = type;
    }

    @Override
    public void onDismiss() {

    }

    @Override
    public void onClick(View v) {

    }
}
