package com.urovo.activity.data;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.BaseAdapter;
import android.widget.BaseExpandableListAdapter;
import android.widget.Button;
import android.widget.ExpandableListView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.activity.common.StoreSelectorActivity;
import com.urovo.wgmf.db.dao.dao.Store001DbOprate;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

import static com.urovo.wugumofang.data.DateUtil.getCurrentMonth;
import static com.urovo.wugumofang.data.DateUtil.getCurrentYear;
import static com.urovo.wugumofang.data.DateUtil.getMonth;
import static com.urovo.wugumofang.data.DateUtil.getYear;
import static com.urovo.wugumofang.data.DateUtil.parseDate;

public abstract class GoodsInOutStockBaseAct extends BaseActivity implements StoreDateSelectorPop.StoreDateSelectorPopListener {
    protected BaseAdapter mMyAdapter;
    protected BaseExpandableListAdapter mExpandableListAdapter;
    protected ListView mListView;
    protected ExpandableListView mExListView;
    protected boolean mIsAdmin;
    protected StoreDateSelectorPop mStoreDateSelectorPop;
    protected String mSql;
    protected LinearLayout mLinearLayoutEdit, mLinearLayoutEditTwo;
    protected Button item_foot, btnEdit, btnEditCancel, btnEditConfirm;
    protected LinearLayout mLinearLayoutMore;
    protected LinearLayout mLinearLayoutDateStore;//显示日期和门店的LL
    protected TextView mTextViewDate;
    protected TextView mTextViewStore;
    protected String mStoreId;
    protected String mStoreName;
    protected String mUserID;
    protected String mDateMonth;
    protected String mDateFrom;
    protected String mDateTo;
    protected String mDate;
    protected LinearLayout mWeiVipEmpty;
    protected LinearLayout mWeiVipContent;
    private LinearLayout mLinearLayoutParent;

    protected abstract boolean isExpandableList();

    protected abstract String getTitleText();

    protected abstract int getPopupWindowMode();

    protected abstract BaseAdapter newBaseAdapter();

    protected abstract BaseExpandableListAdapter newExpandableAdapter();

    protected abstract void requestConnectTask();

    protected abstract void search(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo);

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.query_data);
        mIsAdmin = SystemHelper.IsAdmin;
        if (mIsAdmin) {
            List<ShopEntity> mListStore = Store001DbOprate.GetShopChoice();
            if (null != mListStore && mListStore.size() > 0) {
                mStoreId = mListStore.get(0).getShopId();
                mStoreName = mListStore.get(0).getShopName();
//                mUserID = SystemHelper.LoginUserId;
//                mOrganizationCode = SystemHelper.LoginOrganId;
            }
        } else {
//            mUserID = SystemHelper.LoginUserId;
            mStoreId = SystemHelper.LoginOrganId;
            mStoreName = SystemHelper.LoginOrganName;
//            mOrganizationCode = null;
        }
        initTitle();
        initHeader();
        initView();
        initContent();
    }

    @Override
    public void initTitle() {

        super.initTitle();
        titleTextView.setText(getTitleText());

    }

    private void initHeader() {
        mTextViewDate = (TextView) findViewById(R.id.textView1);
        mTextViewStore = (TextView) findViewById(R.id.textView2);
        mTextViewStore.setSelected(true);

        mTextViewStore.setText(mStoreName);
        mLinearLayoutMore = (LinearLayout) findViewById(R.id.linearLayout1);
        mLinearLayoutDateStore = (LinearLayout) findViewById(R.id.date_store_ll);

        if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_GOODS_INOUT_STOCK) { // 初始化的时候显示的
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM");
            Date nowDate = new Date();
            mDate = sdf.format(nowDate);
//            mTextViewDate.setText(mDate);
            setQueryMonthDate(mDate);
        }

        //如果显示了两个日期，就用上下布局，否则用水平布局
        if (!mTextViewDate.getText().toString().contains("至")
                && (getPopupWindowMode() != StoreDateSelectorPop.STORE_DATE_GUEST_FOLIO)) {//排除客单数查询的情况
            mLinearLayoutDateStore.setOrientation(LinearLayout.HORIZONTAL);//水平
            mLinearLayoutDateStore.setGravity(Gravity.LEFT | Gravity.CENTER_VERTICAL);
        }

        mLinearLayoutMore.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {

                showPopWindowDateStore();
            }
        });
    }

    /**
     * 日期转换格式
     *
     * @param date ...
     */
    @SuppressLint("SetTextI18n")
    public void setQueryMonthDate(String date) {
        try {
            String[] ss = date.split("-");
            mDateMonth = date;
            mTextViewDate.setText(ss[0] + "年" + ss[1] + "月，");
        } catch (Exception e) {
            BaseAppManager.loger().error(e);
            mTextViewDate.setText("error");
        }
    }

    @SuppressWarnings("all")
    private void initView() {
        mListView = (ListView) findViewById(R.id.listView1);
        View footView = this.getLayoutInflater().inflate(R.layout.mark_store_footview, null);
        mListView.addFooterView(footView);
        mLinearLayoutParent = (LinearLayout) findViewById(R.id.linearLayoutParent);
        mWeiVipEmpty = (LinearLayout) findViewById(R.id.weivipempty);
        mWeiVipContent = (LinearLayout) findViewById(R.id.weivipcontent);
        // 添加固定在底部的按钮
        mLinearLayoutEdit = (LinearLayout) findViewById(R.id.ll_edit);
        mLinearLayoutEditTwo = (LinearLayout) findViewById(R.id.ll_edit_twobtn);
        btnEdit = (Button) findViewById(R.id.btn_edit);
        btnEditCancel = (Button) findViewById(R.id.btn_edit_cancel);
        btnEditConfirm = (Button) findViewById(R.id.btn_edit_confirm);
        // 列表尾部弃用
        item_foot = (Button) findViewById(R.id.btn_mark_store_footview);
        item_foot.setVisibility(View.GONE);
    }

    private void initContent() {
        if (isExpandableList()) {
            mLinearLayoutParent.removeView(mListView);
            mExListView = new ExpandableListView(this);
            mListView = mExListView;
            mLinearLayoutParent.addView(mExListView, AbsListView.LayoutParams.MATCH_PARENT, AbsListView.LayoutParams.MATCH_PARENT);
            mExpandableListAdapter = newExpandableAdapter();
            mExListView.setAdapter(mExpandableListAdapter);
            mExListView.setGroupIndicator(null);
        } else {
            mMyAdapter = newBaseAdapter();
            mListView.setAdapter(mMyAdapter);
        }
    }

    protected void showPopWindowDateStore() {
        if (null == mStoreDateSelectorPop) {
            mStoreDateSelectorPop = new StoreDateSelectorPop(this, this, mIsAdmin, getPopupWindowMode());
            mStoreDateSelectorPop.setStore(mStoreName);
            mStoreDateSelectorPop.setStroreId(mStoreId);
            mStoreDateSelectorPop.setQueryMonth(mDate);
            mStoreDateSelectorPop.setDateMonth(mDateMonth);
        }
        if (!mStoreDateSelectorPop.isShowing()) {
            mStoreDateSelectorPop.show(titile_bg, false);
        }
    }

    @SuppressWarnings("unused")
    private void closePopWindowDateStore() {
        if (mStoreDateSelectorPop.isShowing()) {
            mStoreDateSelectorPop.dismiss();
        }
    }

    @SuppressWarnings("all")
    protected void showEmpty() {
        View v = LayoutInflater.from(this).inflate(R.layout.listview_empty, null);
        v.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        if (null != mListView.getTag()) {
            View old = (View) mListView.getTag();
            ((ViewGroup) mListView.getParent()).removeView(old);
        }
        ((ViewGroup) mListView.getParent()).addView(v);
        mListView.setTag(v);
        mListView.setEmptyView(v);
        if (null != mMyAdapter)
            mMyAdapter.notifyDataSetChanged();
        if (null != mExpandableListAdapter)
            mExpandableListAdapter.notifyDataSetChanged();
    }

    @SuppressWarnings("all")
    private void showNetError() {
        View v = LayoutInflater.from(this).inflate(R.layout.listview_empty_error, null);
        v.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        Button btn = (Button) v.findViewById(R.id.buttonDownload);
        btn.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {

                requestConnectTask();
            }
        });
        if (null != mListView.getTag()) {
            View old = (View) mListView.getTag();
            ((ViewGroup) mListView.getParent()).removeView(old);
        }
        ((ViewGroup) mListView.getParent()).addView(v);
        mListView.setTag(v);
        mListView.setEmptyView(v);
        if (null != mMyAdapter)
            mMyAdapter.notifyDataSetChanged();
        if (null != mExpandableListAdapter)
            mExpandableListAdapter.notifyDataSetChanged();
    }

    @Override
    public void netError() {
        showNetError();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);
        switch (resultCode) {
            case StoreSelectorActivity.RESULTCODE:
                ShopEntity shopEntity = (ShopEntity) data.getSerializableExtra(StoreSelectorActivity.STORE_TAG);
                if (shopEntity != null) {
                    mStoreDateSelectorPop.setStore(shopEntity.getShopName());
                    mStoreDateSelectorPop.setStroreId(shopEntity.getShopId());
                }
                break;

            default:
                break;
        }
    }

    @Override
    public void onChooseStore() {
        Intent intent = new Intent(this, StoreSelectorActivity.class);
        intent.putExtra(StoreSelectorActivity.INTENT_FROM_ACTIVITY, this.getClass().getSimpleName());
        intent.putExtra(StoreSelectorActivity.STORE_TAG, mStoreDateSelectorPop.getStore());
        startActivityForResult(intent, StoreSelectorActivity.RESULTCODE);
    }

    @Override
    public void onChooseDate(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {

        if (!mIsAdmin) {
            onStartSearch(id, store, user, dateYearMonth, dateFrom, dateTo);
        }
    }

    @Override
    public void onStartSearch(String id, String store, String userid, String dateYearMonth, String dateFrom, String dateTo) {
        if (!TextUtils.isEmpty(dateFrom)
                && (getYear(parseDate(dateFrom)) - getCurrentYear() > 0
                || (getYear(parseDate(dateFrom)) - getCurrentYear() == 0
                && getMonth(parseDate(dateFrom)) - getCurrentMonth() > 0))) {
            showMsg("日期不能超过当前月份！");//应该由后台返回数据
            return;
        }
        if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_GOODS_INOUT_STOCK) {
            setQueryMonthDate(dateFrom);//查询后回调显示日期（**年**月）
        }
        mTextViewStore.setText(store);
        mStoreDateSelectorPop.dismiss();
        search(id, store, userid, dateYearMonth, dateFrom, dateTo);
    }

    @Override
    public void onDismiss() {

    }
}
