package com.urovo.activity.data;

import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.TextView;

import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.activity.common.StoreSelectorActivity;
import com.urovo.wgmf.db.dao.entitys.ActionFreshBtnBean;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.SystemHelper;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;
import org.greenrobot.eventbus.ThreadMode;

import java.util.Date;
import java.util.LinkedHashMap;
import java.util.Locale;
import java.util.Map;

import androidx.annotation.DrawableRes;
import androidx.annotation.IdRes;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentTransaction;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

import static com.urovo.wugumofang.R.id.next_month;

public abstract class NewDataBaseActivity extends BaseActivity implements OnClickListener, StoreDateSelectorPop.StoreDateSelectorPopListener {
    protected boolean mIsAdmin;
    protected StoreDateSelectorPop mStoreDateSelectorPop;
    protected String mStoreId;
    protected String mOrganizationCode;
    protected String mStoreName;
    protected String mUserID;
    protected String mDateMonth;
    protected String mDateFrom;
    protected String mDateTo;
    protected String tempCurrentDate;// 当前月份增减的临时变量
    protected Map<Class<? extends Fragment>, Fragment> pageMap;

    @BindView(R.id.query_product_sales_container)
    protected FrameLayout mFrameLayout;
    @BindView(R.id.query_product_sales)
    protected LinearLayout mQueryProductSales;
    @BindView(R.id.textViewStore)
    protected TextView mTextViewStore;//门店名
    @BindView(R.id.last_month)
    protected LinearLayout mLastMonthBtn;//前一月按钮
    @BindView(next_month)
    protected LinearLayout mNextMonthBtn;//后一月按钮
    @BindView(R.id.tv_next_month)
    protected TextView mTvNextMonth;//后一月
    @BindView(R.id.calendar_date)
    protected LinearLayout mCurrentDateBtn;//当前选择的月份按钮
    @BindView(R.id.tv_current_date)
    protected TextView mCurrentDate;//当前选择的月份
    @BindView(R.id.query_product_sales_store)
    protected Button mSalesStoreBtn;
    @BindView(R.id.query_product_sales_VIP_mall)
    protected Button mSalesVIPMallBtn;
    @BindView(R.id.query_data_line)
    protected LinearLayout mQueryDataLineArea;
    @BindView(R.id.brand_pro)
    protected LinearLayout mBrandPro;
    @BindView(R.id.all_pro)
    protected RadioButton mAllPro;
    @BindView(R.id.wgmf_pro)
    protected RadioButton mWgmfPro;
    @BindView(R.id.flow_pro)
    protected RadioButton mFlowPro;
    @BindView(R.id.xdy_pro)
    protected RadioButton mXdyPro;
    @BindView(R.id.horizontal_line)
    protected View mHorizontalLine;
    private String specifiedDateFormat = "yyyy-MM";

    private int resulf;

    protected abstract String getTitleText();

    protected abstract int getPopupWindowMode();

    protected abstract void lastMonth();

    protected abstract void calendarDate();

    protected abstract void nextMonth();

    Unbinder unbinder;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.query_data2);
        unbinder = ButterKnife.bind(this);
        if (!EventBus.getDefault().isRegistered(this)) {
            EventBus.getDefault().register(this);
        }
//        mIsAdmin = SystemHelper.IsAdmin;
//        if (mIsAdmin) {
//            List<ShopEntity> mListStore = Store001DbOprate.GetShopChoice();
//            if (this instanceof MonthSaleProductAct || this instanceof MonthSaleAct) {
//                mStoreId = "1";
//                mStoreName = "全部";
//                mOrganizationCode = SystemHelper.LoginOrganId;
//                mUserID = SystemHelper.LoginUserId;
//            } else if (null != mListStore && mListStore.size() > 0) {
//                mStoreId = mListStore.get(0).getShopId();
//                mStoreName = mListStore.get(0).getShopName();
//                mUserID = SystemHelper.LoginUserId;
//                mOrganizationCode = SystemHelper.LoginOrganId;
//            }
//        } else {
        mUserID = SystemHelper.LoginUserId;
        mStoreId = SystemHelper.LoginOrganId;
        mStoreName = SystemHelper.LoginOrganName;
        mOrganizationCode = null;
//        }
        initTitle();
        initHeader();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText(getTitleText());
    }

    private void initHeader() {
        mTextViewStore.setSelected(true);
        mTextViewStore.setText(mStoreName);
        mAllPro.setText("全部");
        setTextView(mWgmfPro, "磨粉产品");
//        setTextView(mXdyPro, SystemHelper.XdyBrand);
        setTextView(mXdyPro, AppConstants.BRAND.BULK_PRO);
        setTextView(mFlowPro, "流量产品");

        if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_MONTH) {
            tempCurrentDate = mDateMonth = DateUtil.getSpecifiedMonth(new Date(), 0, specifiedDateFormat, Locale.CANADA);
            mCurrentDate.setText(tempCurrentDate);
        }

        mLastMonthBtn.setOnClickListener(this);
        mNextMonthBtn.setOnClickListener(this);
        mCurrentDateBtn.setOnClickListener(this);
        mSalesStoreBtn.setOnClickListener(this);
        mSalesVIPMallBtn.setOnClickListener(this);
        mAllPro.setOnClickListener(this);
        mWgmfPro.setOnClickListener(this);
        mFlowPro.setOnClickListener(this);
        mXdyPro.setOnClickListener(this);
    }

    /**
     * 设置textView显示隐藏和内容
     * @param view textView
     * @param brand 内容
     */
    private void setTextView(TextView view, String brand) {
        if (TextUtils.isEmpty(brand)) {
            view.setVisibility(View.GONE);
        } else {
            view.setVisibility(View.VISIBLE);
            view.setText(brand);
        }
    }

    @SuppressWarnings("unused")
    @Subscribe(threadMode = ThreadMode.MAIN)
    public void onShowEvent(ActionFreshBtnBean btnBean) {
        //第一次启动加载基础资料时候比较慢，需要刷新下。
        setTextView(mWgmfPro, "磨粉产品");
//        setTextView(mXdyPro, SystemHelper.XdyBrand);
        setTextView(mXdyPro, AppConstants.BRAND.BULK_PRO);
        setTextView(mFlowPro, "流量产品");
    }

    /**
     * 展示poppuwindow
     */
    protected void showPopWindowDateStore() {
        if (null == mStoreDateSelectorPop) {
            mStoreDateSelectorPop = new StoreDateSelectorPop(this, this, mIsAdmin, getPopupWindowMode());
            mStoreDateSelectorPop.setStore(mStoreName);
            mStoreDateSelectorPop.setStroreId(mStoreId);
            mStoreDateSelectorPop.setDateFrom(mDateFrom);
            mStoreDateSelectorPop.setMixBegin(mDateFrom);
            mStoreDateSelectorPop.setDateTo(mDateTo);
            mStoreDateSelectorPop.setMixEnd(mDateTo);
            mStoreDateSelectorPop.setDateMonth(mDateMonth);
        }
        if (!mStoreDateSelectorPop.isShowing()) {
            mStoreDateSelectorPop.show(titile_bg);
        }
    }

    @SuppressWarnings("unused")
    private void closePopWindowDateStore() {
        if (mStoreDateSelectorPop.isShowing()) {
            mStoreDateSelectorPop.dismiss();
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);
        switch (resultCode) {
            case StoreSelectorActivity.RESULTCODE:
                ShopEntity shopEntity = (ShopEntity) data.getSerializableExtra(StoreSelectorActivity.STORE_TAG);
                if (shopEntity != null) {
                    mStoreDateSelectorPop.setStore(shopEntity.getShopName());
                    mStoreDateSelectorPop.setStroreId(shopEntity.getShopId());
                }
                break;

            default:
                break;
        }
    }

    @Override
    public void onClick(View v) {
        final int id = v.getId();
        switch (id) {
            // 月份减一
            case R.id.last_month:
                tempCurrentDate = DateUtil.getSpecifiedMonth(tempCurrentDate, -1, specifiedDateFormat);
                mCurrentDate.setText(tempCurrentDate);
                //一直都是小于当前月,颜色变化设置
                setCurrentMonthColor(false);
                //act页面回调，请求在act做
                lastMonth();
                break;
            case R.id.calendar_date:
                showPopWindowDateStore();
                break;
            // 月份加一
            case R.id.next_month:
                String nextMonth = DateUtil.getSpecifiedMonth(tempCurrentDate, 1, specifiedDateFormat);
                //日期期限判断
                timeLimit(nextMonth);
                //resulf ==1,超过当前月都不去请求
                if (resulf != 1) {
                    //act页面回调，请求在act做
                    nextMonth();
                }
                break;
            default:
                break;
        }
    }

    /**
     * 颜色状态选择器
     *
     * @param btn ...
     */
    @SuppressWarnings("deprecation")
    protected void onChooseColors(Button... btn) {
        btn[0].setTextColor(getResources().getColor(R.color.title_yellow_bg));
        btn[0].setBackgroundResource(R.drawable.btn_label_focused);
        btn[1].setTextColor(getResources().getColor(R.color.text_saomiao_gray));
        btn[1].setBackgroundResource(R.drawable.btn_label_not_pressed);
    }

    /**
     * 期限不超过当前月
     *
     * @param nextMonth ...
     */
    private void timeLimit(String nextMonth) {
        resulf = DateUtil.compareDate(nextMonth, mDateMonth);
        if (resulf == 1) {//超过当前月
            showMsg("查询时间截止到本月");
        } else {
            setCurrentMonthColor(resulf == 0);//resulf==0:等于当前月;resulf==-1:小于当前月
            tempCurrentDate = nextMonth;
            mCurrentDate.setText(tempCurrentDate);
        }
    }

    /**
     * 是否要改变月份颜色状态
     *
     * @param isMonth ...
     */
    @SuppressWarnings("deprecation")
    private void setCurrentMonthColor(boolean isMonth) {
        setShowArrow(mTvNextMonth, R.drawable.go, R.drawable.go_press, true);
        mTvNextMonth.setTextColor(isMonth ? Color.parseColor("#55636263") : Color.BLACK);
    }

    /**
     * TextView 设置图片
     *
     * @param textView         需要设置图片的textview
     * @param firstDrawableId  第一幅图片
     * @param secondDrawableId 第二幅图片
     * @param arrawFlag        true:替换为第一幅图片,false:替换为第二幅图片
     */
    @SuppressWarnings("deprecation")
    protected void setShowArrow(TextView textView,
                                @DrawableRes int firstDrawableId,
                                @DrawableRes int secondDrawableId,
                                boolean arrawFlag) {
        Drawable arrowDrawable = getResources().getDrawable(arrawFlag ? firstDrawableId : secondDrawableId);
        arrowDrawable.setBounds(0, 0, arrowDrawable.getMinimumWidth(), arrowDrawable.getMinimumHeight());
        textView.setCompoundDrawables(null, null, arrowDrawable, null);//图片显示在右边
    }

    protected void setHiddenArrow(TextView textView) {
        textView.setCompoundDrawables(null, null, null, null);//图片隐藏
    }

    @Override
    public void onChooseStore() {
        Intent intent = new Intent(this, StoreSelectorActivity.class);
        intent.putExtra(StoreSelectorActivity.INTENT_FROM_ACTIVITY, this.getClass().getSimpleName());
        intent.putExtra(StoreSelectorActivity.STORE_TAG, mStoreDateSelectorPop.getStore());
        startActivityForResult(intent, StoreSelectorActivity.RESULTCODE);
    }

    @Override
    public void onChooseDate(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {
        if (!mIsAdmin) {
            onStartSearch(id, store, user, dateYearMonth, dateFrom, dateTo);
        }
    }

    @Override
    public void onStartSearch(String id, String store, String userid, String dateYearMonth, String dateFrom, String dateTo) {
        mTextViewStore.setText(store);
        mStoreDateSelectorPop.dismiss();

        if (getPopupWindowMode() == StoreDateSelectorPop.STORE_DATE_MONTH) {
            timeLimit(dateYearMonth);
            mCurrentDate.setText(dateYearMonth);
            tempCurrentDate = dateYearMonth;
            calendarDate();//当前日历选择日期后才请求数据，//act页面回调，请求在act做
        }
    }

    @Override
    public void onDismiss() {

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        unbinder.unbind();
        EventBus.getDefault().unregister(this);
    }

    public Fragment showFragment(@IdRes int content_id, Class<? extends Fragment> cls) {
        return showFragment(content_id, cls, null, false);
    }

    @SuppressWarnings("unused")
    public Fragment showFragment(@IdRes int content_id, Class<? extends Fragment> cls, boolean allowBack) {
        return showFragment(content_id, cls, null, allowBack);
    }

    @SuppressWarnings("all")
    public Fragment showFragment(int content_id, Class<? extends Fragment> cls, Bundle bundle, boolean allowBack) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN_MR1) {
            if (isDestroyed()) {
                return null;
            }
        }
        if (pageMap == null) {
            pageMap = new LinkedHashMap<>();
        }

//          做了缓存
//        Fragment page = pageMap.get(cls);
//        if (page == null || bundle != null) {
//            try {
//                page = cls.newInstance();
//                pageMap.put(cls, page);
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//        }

//        if (page == null) {
//            return;
//        }

//        没有缓存，每次都新建一个对象。
        Fragment page = null;
        try {
            page = cls.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }

        if (page != null && bundle != null) {
            page.setArguments(bundle);
        }

//        开启事务
        FragmentTransaction transaction = getSupportFragmentManager().beginTransaction();
        if (allowBack && pageMap.size() > 0) {
            transaction.addToBackStack(cls.getSimpleName());
        }
        transaction.replace(content_id, page).commitAllowingStateLoss();
        return page;
    }
}
