package com.urovo.activity.data;

import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.BaseAdapter;
import android.widget.BaseExpandableListAdapter;

import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.activity.tabMenu.view.TabMenuActivity;
import com.urovo.wgmf.adapter.SaleBackAdapter;
import com.urovo.wgmf.db.dao.dao.Djxs001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djxs002DbOperate;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.XiaoShouEntity;
import com.urovo.wugumofang.data.Arith;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

/**
 * 本机销售记录
 */
public class QuerySalesDetailNative extends DataBaseActivity {
    private List<XiaoShouEntity> mList = new ArrayList<XiaoShouEntity>();
    private boolean gotoHomeTab;

    @Override
    protected BaseExpandableListAdapter newExpandableAdapter() {
        return new SaleBackAdapter(mList, this, true, true);
    }

    @Override
    protected boolean isExpandableList() {
        return true;
    }

    @Override
    protected String getTitleText() {
        return "本机销售记录";
    }

    @Override
    protected int getPopupWindowMode() {
        return StoreDateSelectorPop.STORE_DATE_MIX_USER;
    }

    @Override
    protected BaseAdapter newBaseAdapter() {
        return null;
    }

    @Override
    protected void search(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {
        if (null == dateFrom || null == dateTo) {
            return;
        }
        mList.clear();
        List<XiaoShouEntity> list = Djxs001DbOperate.GetNativeData(user, dateFrom, dateTo);
        if (null != list) {
            Collections.sort(list, new Comparator<XiaoShouEntity>() {
                @Override
                public int compare(XiaoShouEntity lhs, XiaoShouEntity rhs) {

                    return (rhs.getSaleDate() + rhs.getSaleTime()).compareTo(lhs.getSaleDate() + lhs.getSaleTime());
                }
            });
            for (int i = 0; i < list.size(); i++) {
                String bill = list.get(i).getBill();
                if (null != bill) {
                    list.get(i).setProductDetails(Djxs002DbOperate.QueryXiaoShouDetail(bill, false).toArray(new ProductEntity[1]));
                }
            }
            Iterator<XiaoShouEntity> itr = list.iterator();
            while (itr.hasNext()) {
                XiaoShouEntity element = itr.next();
                //多加了一个null == element.getProductDetails()[0]的条件，好像有时候异常单这个会为空，然后会避开这里的remove，然后就会被后面读取给读崩
                if (null == element.getProductDetails() || 0 == element.getProductDetails().length || null == element.getProductDetails()[0]) {
                    itr.remove();
                    continue;
                }
            }
            double countAmount = 0;
            int size = list.size();
            for (int i = 0; i < size; i++) {
                ProductEntity[] productDetails = list.get(i).getProductDetails();
                for (ProductEntity p : productDetails) {
                    countAmount = Arith.add(countAmount, p.getAmount());
                }
            }
            // titleTextView.setText(getTitleText() + "(" + size + "单,￥" +
            // countAmount + ")");
            mList.addAll(list);
        }
        mExpandableListAdapter = newExpandableAdapter();
        mExListView.setAdapter(mExpandableListAdapter);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        search(mStoreId, null, null, null, mDateFrom, mDateTo);

        Intent intent = getIntent();
        gotoHomeTab = intent.getBooleanExtra("gotoHomeTab", false);
        if (gotoHomeTab) {
            back.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    gotoHomeTab(TabMenuActivity.class);
                }
            });
        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        super.onKeyDown(keyCode, event);
        if (gotoHomeTab && event.getAction() == 0) {
            switch (keyCode) {
                case KeyEvent.KEYCODE_BACK:
                    gotoHomeTab(TabMenuActivity.class);
                    return true;
                default:
                    break;
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {

        super.displayResult(tag, response);
    }

    @Override
    protected void requestConnectTask() {

    }


}
