package com.urovo.activity.data;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.BaseExpandableListAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.activity.common.StoreSelectorActivity;
import com.urovo.wgmf.AsyncTask.QuerySanGeYueWeiHuiTouTask;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.entity.response.SanGeYueWeiHuiTouResponse;
import com.urovo.wgmf.entity.response.SanGeYueWeiHuiTouResponse.SanGeYueWeiHuiTouReturnList;
import com.urovo.wugumofang.R;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class QueryThreeMonthMember extends DataBaseActivity {
    private List<BaseModel> mBaseModel = new ArrayList<BaseModel>();
    private Map<String, String> params = new HashMap<String, String>();

    @Override
    protected BaseExpandableListAdapter newExpandableAdapter() {
        return null;
    }

    @Override
    protected boolean isExpandableList() {
        return false;
    }

    @Override
    protected String getTitleText() {

        return "三个月会员消费查询";
    }

    @Override
    protected int getPopupWindowMode() {

        return StoreDateSelectorPop.STORE_DATE_INFO;
    }

    @Override
    protected BaseAdapter newBaseAdapter() {

        return new MyAdapter(mBaseModel, this);
    }

    @Override
    protected void requestConnectTask() {

        new QuerySanGeYueWeiHuiTouTask(this, "正在查询...", true, params).execute("");
    }

    @Override
    protected void search(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {

        SimpleDateFormat sdt = new SimpleDateFormat("yyyy-MM");
        Date d = new Date();
        String mCurrentTime = sdt.format(d);
        showMsg("为您查询三个月会员消费数据，截止时间为昨天后端使用缓存!");
        if (mIsAdmin) {
            params.put("organizationCode", SystemHelper.LoginOrganId);

        } else {
            params.put("organizationCode", null);
        }
        params.put("mDateMonth", mCurrentTime);
        params.put("storeId", id);
        params.put("userId", user);
        params.put("startTimeStr", dateFrom);
        params.put("endTimeStr", dateTo);
        params.put("type", "1");// 1获取前三个月(默认) 2按时间获取
        requestConnectTask();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        // search(mStoreId, null, null, null, null, null);
        search(mStoreId, null, SystemHelper.LoginUserId, mDateMonth, mDateFrom, mDateTo);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);
        switch (resultCode) {
            case StoreSelectorActivity.RESULTCODE:
                mStoreDateSelectorPop.dismiss();
                mTextViewStore.setText(mStoreDateSelectorPop.getStore());
                if ("全部".equals(mStoreDateSelectorPop.getStore())) {
                    search("1", null, SystemHelper.LoginUserId, mDateMonth, mDateFrom, mDateTo);
                } else {
                    search(mStoreDateSelectorPop.getStoreId(), null, SystemHelper.LoginUserId, mDateMonth, mDateFrom, mDateTo);
                }
                break;

            default:
                break;
        }
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {

        super.displayResult(tag, response);
        if (null != response) {
            SanGeYueWeiHuiTouResponse res = (SanGeYueWeiHuiTouResponse) response;
            List<SanGeYueWeiHuiTouReturnList> entity = res.returnBean.returnList;
            mBaseModel.clear();
            if (null != entity) {
                for (int i = 0; i < entity.size(); i++) {
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费总人数";
                        cell.mData = entity.get(i).totalMember;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费总金额";
                        cell.mData = entity.get(i).totalAmount;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费一次人数占比";
                        cell.mData = entity.get(i).oneTimesMemberRate;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费一次金额占比";
                        cell.mData = entity.get(i).oneTimesAmountRate;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费两次人数占比";
                        cell.mData = entity.get(i).twoTimesMemberRate;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费两次金额占比";
                        cell.mData = entity.get(i).twoTimesAmountRate;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费三次人数占比";
                        cell.mData = entity.get(i).threeTimesMemberRate;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费三次金额占比";
                        cell.mData = entity.get(i).threeTimesAmountRate;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费四次人数占比";
                        cell.mData = entity.get(i).fourTimesMemberRate;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费四次金额占比";
                        cell.mData = entity.get(i).fourTimesAmountRate;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费五次人数占比";
                        cell.mData = entity.get(i).fiveTimesMemberRate;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费五次金额占比";
                        cell.mData = entity.get(i).fiveTimesAmountRate;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费五次以上人数占比";
                        cell.mData = entity.get(i).overFiveTimesMemberRate;
                        mBaseModel.add(cell);
                    }
                    {
                        BaseModel cell = new BaseModel();
                        cell.mName = "消费五次以上金额占比";
                        cell.mData = entity.get(i).overFiveTimesAmountRate;
                        mBaseModel.add(cell);
                    }
                }
            }
            mMyAdapter.notifyDataSetInvalidated();
        }
    }

    private class BaseModel {
        String mName;
        String mData;
    }

    private class MyAdapter extends MyBaseAdapter<BaseModel, ListView> {
        public MyAdapter(List<BaseModel> lists, Context context) {
            super(lists, context);
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {

            if (null == convertView) {
                convertView = getLayoutInflater().inflate(R.layout.listview_item_chaxun_kedan, null);
            }
            TextView name = (TextView) convertView.findViewById(R.id.textView1);
            TextView data = (TextView) convertView.findViewById(R.id.textView2);

            BaseModel cell = mBaseModel.get(position);
            name.setText(cell.mName);
            data.setText(cell.mData);
            return convertView;
        }

    }
}
