package com.urovo.activity.data;

import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.BaseExpandableListAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.wgmf.AsyncTask.VipDayDataTask;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.entity.response.VipDayDataResponse;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 会员日数据
 *
 * @author ...
 */
@Route(path = RouterParams.Member.VIP_DAY_DATA)
public class VipDayDataAct extends DataBaseActivity {
    private List<BaseModel> mBaseModel = new ArrayList<>();
    private Map<String, String> params = new HashMap<String, String>();
    public static final String TAG = VipDayDataAct.class.getSimpleName();

    @Override
    protected BaseExpandableListAdapter newExpandableAdapter() {
        return null;
    }

    @Override
    protected boolean isExpandableList() {
        return false;
    }

    @Override
    protected String getTitleText() {
        return "会员日数据";
    }

    @Override
    protected int getPopupWindowMode() {
        //return StoreDateSelectorPop.STORE_DATE_LAST_MONTH;
        //2017年会员日调整为每个月的第一个周五；
        return StoreDateSelectorPop.STORE_DATE_FROMTO_USER;
    }

    @Override
    protected BaseAdapter newBaseAdapter() {
        return new MyAdapter(mBaseModel, this);
    }

    @Override
    protected void requestConnectTask() {
        new VipDayDataTask(this, "正在查询...", true, params).execute("");
    }

    @Override
    protected void search(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {
        params.put("storeid", id);
        params.put("ym", dateYearMonth);
        requestConnectTask();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //mStoreDateSelectorPop.setDateMonth();
        search(mStoreId, null, mUserID, mDateMonth, mDateFrom, mDateTo);
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if (null != response) {
            VipDayDataResponse res = (VipDayDataResponse) response;
            VipDayDataResponse.ResultInfoBean resultInfoBean = res.resultInfo;
            mBaseModel.clear();
            if (resultInfoBean == null) {
                showMsg(res.msgInfo);
                mMyAdapter.notifyDataSetInvalidated();
                return;
            }
            for (int i = 0; i < 1; i++) {
                {
                    BaseModel cell = new BaseModel();
                    cell.mName = "会员日销售量";
                    cell.mData = resultInfoBean.amount + "元";
                    mBaseModel.add(cell);
                }
                {
                    BaseModel cell = new BaseModel();
                    cell.mName = "销售额同比";
                    cell.mData = resultInfoBean.amountTB;
                    mBaseModel.add(cell);
                }
                {
                    BaseModel cell = new BaseModel();
                    cell.mName = "老会员销售占比";
                    cell.mData = resultInfoBean.oldMemberRate;
                    mBaseModel.add(cell);
                }
            }
        }
        mMyAdapter.notifyDataSetInvalidated();
    }


    class BaseModel {
        String mName;
        String mData;
    }

    class MyAdapter extends MyBaseAdapter<BaseModel, ListView> {
        public MyAdapter(List<BaseModel> lists, Context context) {
            super(lists, context);
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {

            if (null == convertView) {
                convertView = getLayoutInflater().inflate(R.layout.listview_item_chaxun_kedan, null);
            }
            TextView name = (TextView) convertView.findViewById(R.id.textView1);
            TextView data = (TextView) convertView.findViewById(R.id.textView2);

            BaseModel cell = mBaseModel.get(position);
            name.setText(cell.mName);
            data.setText(cell.mData);
            return convertView;
        }
    }
}

