package com.urovo.activity.data.querymyweivip.model;

import java.io.Serializable;
import java.util.List;

/**
 * User: lemonade(823307073@qq.com)
 * Date: 2017/05/14
 * Time: 17:48
 * 新客微会员列表（昨天/今天数据共享的实体类）里面的对象最好都做序列化，如果涉及到保存到本地文件的时候。
 */
public class SweepCodeDetailListEntity implements Serializable {
    /**
     * isNewList : [{"mobile":"13561511612","adscription":"李文静","reason":null,"isNew":1},{"mobile":"13671022102","adscription":"马奔","reason":null,"isNew":1}]
     * isNotNewList : [{"mobile":"13699799762","adscription":"赵宁","reason":"不是新客","isNew":0},{"mobile":"13671022102","adscription":"马奔","reason":"缺销售","isNew":0},{"mobile":"13561511612","adscription":"李文静","reason":"缺销售","isNew":0}]
     * isNewCount : 2
     * isNotNewCount : 3
     */

    public int isNewCount;
    public int isNotNewCount;
    public List<IsNewListEntity> isNewList;
    public List<IsNotNewListEntity> isNotNewList;

    /**
     * 符合新客微会员
     */
    public static class IsNewListEntity implements Serializable {
        /**
         * mobile : 13561511612String
         * adscription : 李文静
         * reason : null
         * isNew : 1
         */

        public String mobile;
        public String adscription;
        public String reason;
        public int isNew;
    }

    /**
     * 不符合新客微会员
     */
    public static class IsNotNewListEntity implements Serializable{
        /**
         * mobile : 13699799762
         * adscription : 赵宁
         * reason : 不是新客
         * isNew : 0
         */

        public String mobile;
        public String adscription;
        public String reason;
        public int isNew;
    }
}
