package com.urovo.activity.data.querymyweivip.presenter;

import com.urovo.wgmf.CommonController;
import com.wgmf.trade.model.bean.CommonEntity;
import com.urovo.wgmf.net.CommonNet;
import com.urovo.wugumofang.data.DateUtil;

import java.util.Date;
import java.util.Locale;
import java.util.Map;

/**
 * presenter 层 处理view层的操作逻辑和数据回显，以及获取model 层 数据（本地和网络）
 */
public class SweepCodeDetailPre implements CommonController.Presenter {
    private CommonController.View mView;//view 对象（View 层）
    private CommonNet mCommonNet;// model 对象(网络层)

    public SweepCodeDetailPre(CommonController.View view) {
        this.mView = view;
        this.mCommonNet = new CommonNet();
    }

    /**
     * 这里初始化所有view 需要操作的逻辑方法，具体实现另外在p 中新增方法调用
     */
    @Override
    public void start() {
        mView.requestData(0);// 请求数据，开始~gogogogo
        mView.initStoresDateInfo(0);// 初始化今天的门店和日期信息,0代表是今天的日期，1代表是昨天的日期，以此类推。。。
        mView.initTitleTab();
        mView.initViewPager();
        mView.initTabLayout();//必须在initViewPager初始化，否在adapter报空
    }

    /**
     * model 层回调的数据 回传给p层,最后再回传给view 层显示
     *
     * @param resultInfo 请求成功的数据
     */
    @Override
    public void onResponseSuccess(CommonEntity resultInfo) {
        mView.onResponseSuccess(resultInfo);
    }

    /**
     * @param failInfo 请求失败的数据
     */
    @Override
    public void onFailure(String failInfo) {
        mView.onFailure(failInfo);
    }

    /**
     * 开始请求数据，入口，~少年，要开始拿数据了~
     *
     * @param mParams 。。。
     */
    @Override
    public void start2requestData(Map<String, String> mParams) {
        mCommonNet.start2requestData(this, mParams);
    }

/*-------------------------------------以下是P层处理View 层的逻辑需要的方法---------------------------------------*/

    /**
     * 按照日期格式来显示日期 如：yyyy-MM-dd ，yyyy年MM月dd日
     *
     * @param day        0：今天；1：昨天
     * @param dateFormat 时间格式
     * @return 转换后的日期 如：2017-05-24
     */
    public String sweepCodeDetailDate(int day, String dateFormat) {
        return DateUtil.getSpecifiedDay(
                new Date(),
                day,
                dateFormat,
                Locale.CHINA // 在国内显示
        );
    }
}
