package com.urovo.activity.data.querymyweivip.view.activity;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.activity.common.DatePickerYearMonthDialog;
import com.urovo.activity.data.querymyweivip.model.WeiVIPDataEntity;
import com.urovo.activity.data.querymyweivip.model.WeiVIPDataResponse;
import com.urovo.wgmf.AsyncTask.QueryMyWeiVIPTask;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DialogHelper;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

/**
 * @author Sasuke
 * @date 2016/5/20
 * 会员营销——新客进塘数据
 */
@Route(path = RouterParams.Member.NEW_GUEST_MEMBER_DATA)
public class QueryMyWeiVIP extends BaseActivity implements View.OnClickListener, DialogHelper.DialogResult {
    private List<BaseModel> mBaseModel = new ArrayList<BaseModel>();
    private Map<String, String> params = new HashMap<String, String>();
    private TextView name;
    private TextView data;
    protected LinearLayout mWeiVipEmpty;
    protected LinearLayout itemContainer;
    protected LinearLayout mWeiVipContent;
    protected TextView mWeiVipCont;
    protected TextView mWeiVipNumber;
    protected TextView mWeiVipCore;
    protected TextView mState;
    protected TextView mWeiVipTitile;
    protected TextView listTopTitle;
    protected BaseAdapter mMyAdapter;
    protected ListView mListView;
    private TextView mTextViewDate;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_vip_list);
        mListView = (ListView) findViewById(R.id.listView1);
        View headerView = this.getLayoutInflater().inflate(R.layout.myweivip_headview, null);
        mListView.addHeaderView(headerView);
        View emptyView = this.getLayoutInflater().inflate(R.layout.listview_empty, null);
        mListView.setEmptyView(emptyView);
        itemContainer = (LinearLayout) headerView.findViewById(R.id.item_container);//新客微会员面板
        mState = (TextView) findViewById(R.id.state);
        mWeiVipTitile = (TextView) findViewById(R.id.weiviptitle);
        mWeiVipCont = (TextView) findViewById(R.id.weivipcont);
        mWeiVipNumber = (TextView) findViewById(R.id.weivipnumber);
        mWeiVipCore = (TextView) findViewById(R.id.weivipscore);
        TextView nameText = (TextView) findViewById(R.id.name_text);
        mTextViewDate = (TextView) findViewById(R.id.date_text);
        mTextViewDate = (TextView) findViewById(R.id.date_text);
        nameText.setText("," + SystemHelper.LoginUserName);
        mTextViewDate.setText(DateUtil.getDateMonth(new Date()));

        //查看扫码加粉明细按钮
        findViewById(R.id.btn_sweep_code_detail).setOnClickListener(this);
        //日期选择器的默认显示
        findViewById(R.id.date_text_ll).setOnClickListener(this);

        titleTextView = (TextView) findViewById(R.id.text_title);
        titleTextView.setText("新客进塘数据");
        ImageButton goback = (ImageButton) findViewById(R.id.goback);
        goback.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        String mDateMonth = mTextViewDate.getText().toString().trim();
        search(SystemHelper.LoginOrganId, SystemHelper.LoginUserId, mDateMonth);
    }


    protected BaseAdapter newBaseAdapter() {
        return new MyAdapter(mBaseModel, this);
    }

    protected void search(String shopId, String user, String dateYearMonth) {
        params.put("shopId", shopId);
        params.put("staffId", user);
        params.put("ym", dateYearMonth);
        new QueryMyWeiVIPTask(this, WeiVIPDataResponse.class, "正在查询...", true, params).execute("");
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if (!((BaseOldResponse) response).msgCode.equals("0")) {
            showMsg(response.msgContent);
            return;
        } else {
            WeiVIPDataResponse dataResponse = (WeiVIPDataResponse) response;
            WeiVIPDataEntity entity = dataResponse.resultInfo;
            mBaseModel.clear();
            if (null != entity) {//有数据才显示
                itemContainer.setVisibility(View.VISIBLE);//新客微会员面板
                BaseModel cell = new BaseModel();
                mBaseModel.add(cell);
                mWeiVipCont.setText(entity.getInPondNum());// 磨粉新客数
                mWeiVipNumber.setText(entity.getMemberNewNum());// 新客进塘数
                mWeiVipCore.setText(entity.getInPondRate());// 新客进塘率
                mState.setText(entity.getState());// 说明
            }
        }
        mMyAdapter = newBaseAdapter();
        mListView.setAdapter(mMyAdapter);
        mMyAdapter.notifyDataSetInvalidated();
    }

    @Override
    public void onClick(View v) {
        int id = v.getId();
        switch (id) {
            case R.id.btn_sweep_code_detail://点击查看扫码加粉明细
                startActivity(new Intent(QueryMyWeiVIP.this, SweepCodeDetailAct.class));
                break;
            case R.id.date_text_ll:
                new DatePickerYearMonthDialog(this, new DatePickerYearMonthDialog.OnDateSetListener() {
                    @Override
                    public void onDateSet(int year, int monthOfYear) {
                        String mDateMonth = year + "-" + String.format(Locale.CHINA, "%02d", monthOfYear + 1);//这里月份要发送出去的，格式上要2位数
                        mTextViewDate.setText(mDateMonth);
                        search(SystemHelper.LoginOrganId, SystemHelper.LoginUserId, mDateMonth);
                    }
                }).show();
                break;
            default:
                break;
        }
    }

    private class BaseModel {
        String mName;
        String mData;
    }

    private class MyAdapter extends MyBaseAdapter<BaseModel, ListView> {
        public MyAdapter(List<BaseModel> lists, Context context) {
            super(lists, context);
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            // 当传入数据的getcount为0 ，不会调用getView  tips: https://jingyan.baidu.com/article/2f9b480d85bb9641cb6cc2b4.html
            if (null == convertView) {
                convertView = getLayoutInflater().inflate(R.layout.listview_item_chaxun_weivip, null);
            }
            mWeiVipEmpty = (LinearLayout) convertView.findViewById(R.id.weivipempty);
            mWeiVipContent = (LinearLayout) convertView.findViewById(R.id.weivipcontent);
            name = (TextView) convertView.findViewById(R.id.textView2);
            data = (TextView) convertView.findViewById(R.id.textView4);
            mWeiVipEmpty.setVisibility(View.GONE);//新客微会员面板
            mWeiVipContent.setVisibility(View.GONE);

            BaseModel cell = mBaseModel.get(position);
            name.setText(cell.mName);
            data.setText(cell.mData);
            return convertView;
        }
    }
}