package com.urovo.activity.data.querymyweivip.view.adapter;

import android.graphics.Color;
import android.os.Bundle;

import com.google.android.material.tabs.TabLayout;
import com.lsjwzh.widget.recyclerviewpager.FragmentStatePagerAdapter;
import com.lsjwzh.widget.recyclerviewpager.TabLayoutSupport;
import com.urovo.activity.data.querymyweivip.model.SweepCodeDetailListEntity;
import com.urovo.activity.data.querymyweivip.view.fragment.SweepCodeDetailFra;
import com.urovo.wugumofang.data.ObjectSaveUtil;
import com.wgmf.trade.GlobalApp;

import java.util.LinkedHashMap;
import java.util.List;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;

/**
 * Created by chenji on 2017/5/19.
 * 微会员--recycleviewViewPager 的适配器
 */

public class SweepCodeDetailViewPagerAda extends FragmentStatePagerAdapter implements TabLayoutSupport.ViewPagerTabLayoutAdapter {
    private LinkedHashMap<Integer, Fragment> mFragmentCache = new LinkedHashMap<>();
    private TabLayout mTabLayout;
    private List<SweepCodeDetailListEntity.IsNewListEntity> mConformity;//符合
    private List<SweepCodeDetailListEntity.IsNotNewListEntity> mInconformity;//不符合

    public SweepCodeDetailViewPagerAda(FragmentManager fm, TabLayout tabLayout,
                                       List<SweepCodeDetailListEntity.IsNewListEntity> conformity,
                                       List<SweepCodeDetailListEntity.IsNotNewListEntity> inconformity) {
        super(fm);
        this.mTabLayout = tabLayout;
        this.mConformity = conformity;
        this.mInconformity = inconformity;
//        SYLoger.print("conformity: " + conformity.size() + ", inconformity: " + inconformity.size());
    }

    @Override
    public Fragment getItem(int position, Fragment.SavedState savedState) {
        Fragment f = mFragmentCache.containsKey(position) ? mFragmentCache.get(position) :
                new SweepCodeDetailFra();
//            Log.e("test", "getItem:" + position + " from cache" + mFragmentCache.containsKey(position));
        if (savedState == null || f.getArguments() == null) {
            Bundle bundle = new Bundle();
            bundle.putInt("index", position);
            f.setArguments(bundle);
//                Log.e("test", "setArguments:" + position);
        } else if (!mFragmentCache.containsKey(position)) {
            f.setInitialSavedState(savedState);
//                Log.e("test", "setInitialSavedState:" + position);
        }
        mFragmentCache.put(position, f);
        return f;
    }

    @Override
    public void onDestroyItem(int position, Fragment fragment) {
        while (mFragmentCache.size() > 5) {//缓存的数目
            Object[] keys = mFragmentCache.keySet().toArray();
            mFragmentCache.remove(keys[0]);//移除第一个fragment
        }
    }

    @Override
    public String getPageTitle(int position) {//tablayout的tab 的内容
        SweepCodeDetailListEntity mResultInfo = (SweepCodeDetailListEntity) ObjectSaveUtil.readObject(GlobalApp.getInstance());
        if (mResultInfo != null) {
            mConformity = mResultInfo.isNewList;//符合
            mInconformity = mResultInfo.isNotNewList;//不符合
        }
        switch (position) {
            case 0:
                if (mConformity != null) {
                    return "符合新客进塘（" + mConformity.size() + "）";
                }
            case 1:
                if (mInconformity != null) {
                    mTabLayout.setTabTextColors(Color.BLACK, Color.parseColor("#ffb919"));
                    return "不符合新客进塘（" + mInconformity.size() + "）";
                }
        }
        return "";
    }

    @Override
    public int getItemCount() {
        return 2;
    }// tablayout的tab 的数目
}
