package com.urovo.activity.data.queryproductsales.adapter;

import android.graphics.Color;
import android.view.View;

import com.chad.library.adapter.base.BaseMultiItemQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.chad.library.adapter.base.entity.MultiItemEntity;
import com.urovo.activity.data.queryproductsales.model.Level0Item;
import com.urovo.activity.data.queryproductsales.model.Level1Item;
import com.urovo.wugumofang.R;
import com.zsy.libcore.common.android.log.SYLoger;

import java.util.List;

/**
 * @author chenji
 * @date 2018/3/10
 */
public class ExpandableItemAdapter extends BaseMultiItemQuickAdapter<MultiItemEntity, BaseViewHolder> {
    public static final int TYPE_LEVEL_0 = 0;
    public static final int TYPE_LEVEL_1 = 1;

    /**
     * Same as QuickAdapter#QuickAdapter(Context,int) but with
     * some initialization data.
     *
     * @param data A new list is created out of this one to avoid mutable list
     */
    public ExpandableItemAdapter(List<MultiItemEntity> data) {
        super(data);
        addItemType(TYPE_LEVEL_0, R.layout.msp_item_expandable_lv0);
        addItemType(TYPE_LEVEL_1, R.layout.msp_item_expandable_lv1);
    }

    @Override
    protected void convert(final BaseViewHolder holder, final MultiItemEntity item) {
        switch (holder.getItemViewType()) {
            case TYPE_LEVEL_0:
                final Level0Item lv0 = (Level0Item) item;
                holder.setText(R.id.tv_pro_name, lv0.productSeriesName)
                        .setText(R.id.tv_pro_amount_rate, lv0.amountRate)
                        .setImageResource(R.id.iv_arrow, lv0.isExpanded() ? R.drawable.btn_arrow_up : R.drawable.btn_arrow_down);
                holder.itemView.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        int pos = holder.getAdapterPosition();
                        SYLoger.print("Level 0 item pos: " + pos);
                        if (lv0.isExpanded()) {
                            collapse(pos);
                        } else {
                            expand(pos);
                        }
                    }
                });
                break;

            case TYPE_LEVEL_1:
                //去掉默认的白色
                holder.getView(R.id.pro_detail_info_container).setBackgroundColor(Color.TRANSPARENT);
                final Level1Item lv1 = (Level1Item) item;
                holder.setText(R.id.month_product_name, lv1.productName)
                        .setText(R.id.month_product_id, lv1.productId)
                        .setText(R.id.month_product_amounts, lv1.amount)
                        .setText(R.id.month_product_number, lv1.productNum)
                        .setText(R.id.month_product_sales_amount_rate, lv1.amountRate);
                break;
            default:
                break;
        }
    }
}
