package com.urovo.activity.data.queryproductsales.model;

import java.io.Serializable;
import java.util.List;

/**
 * @author chenji
 * @date 2017/6/23
 * 销售业绩----产品月销量查询
 */
public class MonthSaleProductEntity implements Serializable {
    /**
     * 门店--全部产品
     */
    public List<SaleAllProductsEntity> saleAllProducts;
    /**
     * 门店--五谷磨房产品
     */
    public List<SaleWGProductsEntity> saleWGProducts;
    /**
     * 门店--流量产品
     */

    public List<FlowWGProductsEntity> flowWGProducts;
    /**
     * 门店--鲜稻研产品
     */
    public List<SaleXDYProductsEntity> saleXDYProducts;
    /**
     * 会员商城
     */
    public List<VipSaleProductsEntity> onlineVipSaleProducts;

    public static class SaleAllProductsEntity implements Serializable {
        /**
         * productId : 40
         * productName : 八珍系列
         * amount : 28280
         * list : [{"consDetId":null,"productId":"2.40010","productNo":null,"productName":"益元八珍","unitName":"罐","productNum":"123","amount":"20664","unitPrice":null,"amountRate":"17.72%"},{"consDetId":null,"productId":"2.40142","productNo":null,"productName":"植物益生元八珍","unitName":"盒","productNum":"32","amount":"7616","unitPrice":null,"amountRate":"6.53%"}]
         * amountRate : 24.25%
         * brandId : 8
         */
        public String productId;
        public String productName;
        public String amount;
        public String amountRate;
        public int brandId;
        public List<ListEntity> list;

        public static class ListEntity {
            /**
             * consDetId : null
             * productId : 2.40010
             * productNo : null
             * productName : 益元八珍
             * unitName : 罐
             * productNum : 123
             * amount : 20664
             * unitPrice : null
             * amountRate : 17.72%
             */
            public Object consDetId;
            public String productId;
            public Object productNo;
            public String productName;
            public String unitName;
            public String productNum;
            public String amount;
            public Object unitPrice;
            public String amountRate;

            @Override
            public String toString() {
                return "ListEntity{" +
                        "consDetId=" + consDetId +
                        ", productId='" + productId + '\'' +
                        ", productNo=" + productNo +
                        ", productName='" + productName + '\'' +
                        ", unitName='" + unitName + '\'' +
                        ", productNum='" + productNum + '\'' +
                        ", amount='" + amount + '\'' +
                        ", unitPrice=" + unitPrice +
                        ", amountRate='" + amountRate + '\'' +
                        '}';
            }
        }

        @Override
        public String toString() {
            return "SaleAllProductsEntity{" +
                    "productId='" + productId + '\'' +
                    ", productName='" + productName + '\'' +
                    ", amount='" + amount + '\'' +
                    ", amountRate='" + amountRate + '\'' +
                    ", brandId=" + brandId +
                    ", list=" + list +
                    '}';
        }
    }

    public static class SaleWGProductsEntity implements Serializable {
        /**
         * productId : 40
         * productName : 八珍系列
         * amount : 28280
         * list : [{"consDetId":null,"productId":"2.40010","productNo":null,"productName":"益元八珍","unitName":"罐","productNum":"123","amount":"20664","unitPrice":null,"amountRate":"17.72%"},{"consDetId":null,"productId":"2.40142","productNo":null,"productName":"植物益生元八珍","unitName":"盒","productNum":"32","amount":"7616","unitPrice":null,"amountRate":"6.53%"}]
         * amountRate : 24.25%
         * brandId : 8
         */
        public String productId;
        public String productName;
        public String amount;
        public String amountRate;
        public int brandId;
        public List<ListEntity> list;

        public static class ListEntity {
            /**
             * consDetId : null
             * productId : 2.40010
             * productNo : null
             * productName : 益元八珍
             * unitName : 罐
             * productNum : 123
             * amount : 20664
             * unitPrice : null
             * amountRate : 17.72%
             */
            public Object consDetId;
            public String productId;
            public Object productNo;
            public String productName;
            public String unitName;
            public String productNum;
            public String amount;
            public Object unitPrice;
            public String amountRate;

            @Override
            public String toString() {
                return "ListEntityX{" +
                        "consDetId=" + consDetId +
                        ", productId='" + productId + '\'' +
                        ", productNo=" + productNo +
                        ", productName='" + productName + '\'' +
                        ", unitName='" + unitName + '\'' +
                        ", productNum='" + productNum + '\'' +
                        ", amount='" + amount + '\'' +
                        ", unitPrice=" + unitPrice +
                        ", amountRate='" + amountRate + '\'' +
                        '}';
            }
        }

        @Override
        public String toString() {
            return "SaleWGProductsEntity{" +
                    "productId='" + productId + '\'' +
                    ", productName='" + productName + '\'' +
                    ", amount='" + amount + '\'' +
                    ", amountRate='" + amountRate + '\'' +
                    ", brandId=" + brandId +
                    ", list=" + list +
                    '}';
        }
    }

    public static class SaleXDYProductsEntity implements Serializable {
        /**
         * productId : 227
         * productName : 米类
         * amount : 13424
         * list : [{"consDetId":null,"productId":"2.20069","productNo":null,"productName":"阳原黄小米","unitName":"袋","productNum":"74.2082142858","amount":"2493","unitPrice":null,"amountRate":"2.14%"},{"consDetId":null,"productId":"2.20088","productNo":null,"productName":"兴仁红薏仁","unitName":"袋","productNum":"25.1577292574","amount":"2304.2","unitPrice":null,"amountRate":"1.98%"},{"consDetId":null,"productId":"2.20083","productNo":null,"productName":"朝阳白小米","unitName":"袋","productNum":"34.2908724833","amount":"2043.7","unitPrice":null,"amountRate":"1.75%"},{"consDetId":null,"productId":"2.20067","productNo":null,"productName":"黑龙江五常黑糯米","unitName":"袋","productNum":"44.2147297297","amount":"1308.6","unitPrice":null,"amountRate":"1.12%"},{"consDetId":null,"productId":"2.20070","productNo":null,"productName":"内蒙赤峰黑小米","unitName":"袋","productNum":"29.1680952383","amount":"979.7","unitPrice":null,"amountRate":"0.84%"},{"consDetId":null,"productId":"2.20065","productNo":null,"productName":"黑龙江五常白糯米","unitName":"袋","productNum":"28.7797101447","amount":"794.1","unitPrice":null,"amountRate":"0.68%"},{"consDetId":null,"productId":"2.20082","productNo":null,"productName":"朝阳绿小米","unitName":"袋","productNum":"12.7588590602","amount":"760.6","unitPrice":null,"amountRate":"0.65%"},{"consDetId":null,"productId":"2.20085","productNo":null,"productName":"兴仁小薏仁","unitName":"袋","productNum":"10.7782840235","amount":"728","unitPrice":null,"amountRate":"0.62%"},{"consDetId":null,"productId":"2.20071","productNo":null,"productName":"黑龙江五常黑米","unitName":"袋","productNum":"15.8486170213","amount":"595.1","unitPrice":null,"amountRate":"0.51%"},{"consDetId":null,"productId":"2.20081","productNo":null,"productName":"墨江紫米","unitName":"袋","productNum":"9.6654362417","amount":"575.6","unitPrice":null,"amountRate":"0.49%"},{"consDetId":null,"productId":"2.20068","productNo":null,"productName":"原阳月牙红米","unitName":"袋","productNum":"11.5122972974","amount":"341","unitPrice":null,"amountRate":"0.29%"},{"consDetId":null,"productId":"2.20074","productNo":null,"productName":"高原青稞","unitName":"袋","productNum":"6.4544680851","amount":"242.7","unitPrice":null,"amountRate":"0.21%"},{"consDetId":null,"productId":"2.20062","productNo":null,"productName":"建平大黄米","unitName":"袋","productNum":"7.83875","amount":"200.9","unitPrice":null,"amountRate":"0.17%"},{"consDetId":null,"productId":"2.20059","productNo":null,"productName":"黑龙江密山糙米","unitName":"袋","productNum":"2.8975510204","amount":"56.8","unitPrice":null,"amountRate":"0.05%"}]
         * amountRate : 11.51%
         * brandId : 13
         */
        public String productId;
        public String productName;
        public String amount;
        public String amountRate;
        public int brandId;
        public List<ListEntity> list;

        public static class ListEntity {
            /**
             * consDetId : null
             * productId : 2.20069
             * productNo : null
             * productName : 阳原黄小米
             * unitName : 袋
             * productNum : 74.2082142858
             * amount : 2493
             * unitPrice : null
             * amountRate : 2.14%
             */
            public Object consDetId;
            public String productId;
            public Object productNo;
            public String productName;
            public String unitName;
            public String productNum;
            public String amount;
            public Object unitPrice;
            public String amountRate;

            @Override
            public String toString() {
                return "ListEntityXX{" +
                        "consDetId=" + consDetId +
                        ", productId='" + productId + '\'' +
                        ", productNo=" + productNo +
                        ", productName='" + productName + '\'' +
                        ", unitName='" + unitName + '\'' +
                        ", productNum='" + productNum + '\'' +
                        ", amount='" + amount + '\'' +
                        ", unitPrice=" + unitPrice +
                        ", amountRate='" + amountRate + '\'' +
                        '}';
            }
        }
    }


    public static class FlowWGProductsEntity implements Serializable {
        /**
         * productId : 227
         * productName : 米类
         * amount : 13424
         * list : [{"consDetId":null,"productId":"2.20069","productNo":null,"productName":"阳原黄小米","unitName":"袋","productNum":"74.2082142858","amount":"2493","unitPrice":null,"amountRate":"2.14%"},{"consDetId":null,"productId":"2.20088","productNo":null,"productName":"兴仁红薏仁","unitName":"袋","productNum":"25.1577292574","amount":"2304.2","unitPrice":null,"amountRate":"1.98%"},{"consDetId":null,"productId":"2.20083","productNo":null,"productName":"朝阳白小米","unitName":"袋","productNum":"34.2908724833","amount":"2043.7","unitPrice":null,"amountRate":"1.75%"},{"consDetId":null,"productId":"2.20067","productNo":null,"productName":"黑龙江五常黑糯米","unitName":"袋","productNum":"44.2147297297","amount":"1308.6","unitPrice":null,"amountRate":"1.12%"},{"consDetId":null,"productId":"2.20070","productNo":null,"productName":"内蒙赤峰黑小米","unitName":"袋","productNum":"29.1680952383","amount":"979.7","unitPrice":null,"amountRate":"0.84%"},{"consDetId":null,"productId":"2.20065","productNo":null,"productName":"黑龙江五常白糯米","unitName":"袋","productNum":"28.7797101447","amount":"794.1","unitPrice":null,"amountRate":"0.68%"},{"consDetId":null,"productId":"2.20082","productNo":null,"productName":"朝阳绿小米","unitName":"袋","productNum":"12.7588590602","amount":"760.6","unitPrice":null,"amountRate":"0.65%"},{"consDetId":null,"productId":"2.20085","productNo":null,"productName":"兴仁小薏仁","unitName":"袋","productNum":"10.7782840235","amount":"728","unitPrice":null,"amountRate":"0.62%"},{"consDetId":null,"productId":"2.20071","productNo":null,"productName":"黑龙江五常黑米","unitName":"袋","productNum":"15.8486170213","amount":"595.1","unitPrice":null,"amountRate":"0.51%"},{"consDetId":null,"productId":"2.20081","productNo":null,"productName":"墨江紫米","unitName":"袋","productNum":"9.6654362417","amount":"575.6","unitPrice":null,"amountRate":"0.49%"},{"consDetId":null,"productId":"2.20068","productNo":null,"productName":"原阳月牙红米","unitName":"袋","productNum":"11.5122972974","amount":"341","unitPrice":null,"amountRate":"0.29%"},{"consDetId":null,"productId":"2.20074","productNo":null,"productName":"高原青稞","unitName":"袋","productNum":"6.4544680851","amount":"242.7","unitPrice":null,"amountRate":"0.21%"},{"consDetId":null,"productId":"2.20062","productNo":null,"productName":"建平大黄米","unitName":"袋","productNum":"7.83875","amount":"200.9","unitPrice":null,"amountRate":"0.17%"},{"consDetId":null,"productId":"2.20059","productNo":null,"productName":"黑龙江密山糙米","unitName":"袋","productNum":"2.8975510204","amount":"56.8","unitPrice":null,"amountRate":"0.05%"}]
         * amountRate : 11.51%
         * brandId : 13
         */
        public String productId;
        public String productName;
        public String amount;
        public String amountRate;
        public int brandId;
        public List<ListEntity> list;

        public static class ListEntity {
            /**
             * consDetId : null
             * productId : 2.20069
             * productNo : null
             * productName : 阳原黄小米
             * unitName : 袋
             * productNum : 74.2082142858
             * amount : 2493
             * unitPrice : null
             * amountRate : 2.14%
             */
            public Object consDetId;
            public String productId;
            public Object productNo;
            public String productName;
            public String unitName;
            public String productNum;
            public String amount;
            public Object unitPrice;
            public String amountRate;

            @Override
            public String toString() {
                return "ListEntityXX{" +
                        "consDetId=" + consDetId +
                        ", productId='" + productId + '\'' +
                        ", productNo=" + productNo +
                        ", productName='" + productName + '\'' +
                        ", unitName='" + unitName + '\'' +
                        ", productNum='" + productNum + '\'' +
                        ", amount='" + amount + '\'' +
                        ", unitPrice=" + unitPrice +
                        ", amountRate='" + amountRate + '\'' +
                        '}';
            }
        }

        @Override
        public String toString() {
            return "SaleXDYProductsEntity{" +
                    "productId='" + productId + '\'' +
                    ", productName='" + productName + '\'' +
                    ", amount='" + amount + '\'' +
                    ", amountRate='" + amountRate + '\'' +
                    ", brandId=" + brandId +
                    ", list=" + list +
                    '}';
        }
    }

    public static class VipSaleProductsEntity implements Serializable {
        /**
         * productName : 核桃芝麻黑豆粉560g
         * amount : 5990.03
         * productNum : 98
         * amountRate : 0.52%
         */
        public String productName;
        public String amount;
        public String productNum;
        public String amountRate;

        @Override
        public String toString() {
            return "VipSaleProductsEntity{" +
                    "productName='" + productName + '\'' +
                    ", amount='" + amount + '\'' +
                    ", productNum='" + productNum + '\'' +
                    ", amountRate='" + amountRate + '\'' +
                    '}';
        }
    }

    @Override
    public String toString() {
        return "MonthSaleProductEntity{" +
                "saleAllProducts=" + saleAllProducts +
                ", saleWGProducts=" + saleWGProducts +
                ", flowWGProducts=" + flowWGProducts +
                ", saleXDYProducts=" + saleXDYProducts +
                ", onlineVipSaleProducts=" + onlineVipSaleProducts +
                '}';
    }
//    //门店
//    public List<SaleProductsEntity> saleProducts;
//    //会员商城
//    public List<VipSaleProductsEntity> vipSaleProducts;
//
//    public static class SaleProductsEntity implements Serializable {
//        /**
//         * productId : 40
//         * productName : 八珍系列
//         * amount : 26194
//         * list : [{"consDetId":null,"productId":"2.40142","productNo":null,"productName":"植物益生元八珍","unitName":"盒","productNum":"43","amount":"10234","unitPrice":null,"amountRate":"20.29%"},{"consDetId":null,"productId":"2.40010","productNo":null,"productName":"益元八珍","unitName":"罐","productNum":"95","amount":"15960","unitPrice":null,"amountRate":"31.64%"}]
//         * amountRate : 51.93%
//         */
//
//        public String productId;
//        public String productName;
//        public String amount;
//        public String amountRate;
//        public List<ListEntity> list;
//
//        public static class ListEntity {
//            /**
//             * consDetId : null
//             * productId : 2.40142
//             * productNo : null
//             * productName : 植物益生元八珍
//             * unitName : 盒
//             * productNum : 43
//             * amount : 10234
//             * unitPrice : null
//             * amountRate : 20.29%
//             */
//
//            public Object consDetId;
//            public String productId;
//            public Object productNo;
//            public String productName;
//            public String unitName;
//            public String productNum;
//            public String amount;
//            public Object unitPrice;
//            public String amountRate;
//
//            @Override
//            public String toString() {
//                return "ListEntity{" +
//                        "consDetId=" + consDetId +
//                        ", productId='" + productId + '\'' +
//                        ", productNo=" + productNo +
//                        ", productName='" + productName + '\'' +
//                        ", unitName='" + unitName + '\'' +
//                        ", productNum='" + productNum + '\'' +
//                        ", amount='" + amount + '\'' +
//                        ", unitPrice=" + unitPrice +
//                        ", amountRate='" + amountRate + '\'' +
//                        '}';
//            }
//        }
//
//        @Override
//        public String toString() {
//            return "SaleProductsEntity{" +
//                    "productId='" + productId + '\'' +
//                    ", productName='" + productName + '\'' +
//                    ", amount='" + amount + '\'' +
//                    ", amountRate='" + amountRate + '\'' +
//                    ", list=" + list +
//                    '}';
//        }
//    }
//
//    public static class VipSaleProductsEntity implements Serializable {
//        /**
//         * productName : 核桃芝麻黑豆粉560g
//         * amount : 5990.03
//         * productNum : 98
//         * amountRate : 0.52%
//         */
//
//        public String productName;
//        public String amount;
//        public String productNum;
//        public String amountRate;
//
//        @Override
//        public String toString() {
//            return "VipSaleProductsEntity{" +
//                    "productName='" + productName + '\'' +
//                    ", amount='" + amount + '\'' +
//                    ", productNum='" + productNum + '\'' +
//                    ", amountRate='" + amountRate + '\'' +
//                    '}';
//        }
//    }
//
//    @Override
//    public String toString() {
//        return "MonthSaleProductEntity{" +
//                "saleProducts=" + saleProducts +
//                ", vipSaleProducts=" + vipSaleProducts +
//                '}';
//    }
}
