package com.urovo.activity.data.queryproductsales.presenter;

import com.urovo.wgmf.CommonController;
import com.urovo.wgmf.net.CommonNet;
import com.wgmf.trade.model.bean.CommonEntity;

import java.util.Map;

/**
 * presenter 层 处理view层的操作逻辑和数据回显，以及获取model 层 数据（本地和网络）
 *
 * @author chenji
 */
public class MonthSaleProductPre implements CommonController.Pre {
    /**
     * view 对象（View 层）
     */
    private CommonController.MonthSaleProductView mView;
    /**
     * model 对象(网络层)
     */
    private CommonNet mCommonNet;
    private int mDefaultIndex;
    private int mIndex;
    private String mBrand;
    private String mDefaultBrand;

    public MonthSaleProductPre(CommonController.MonthSaleProductView view, int index, String defaultBrand) {
        this.mView = view;
        this.mCommonNet = new CommonNet();
        this.mDefaultIndex = index;
        this.mDefaultBrand = defaultBrand;
    }

    /**
     * 请求入口
     */
    @Override
    public void start() {
        mView.requestData(mDefaultIndex, mDefaultBrand);
    }

    /**
     * model 层回调的数据 回传给p层,最后再回传给view 层显示
     *
     * @param resultInfo 请求成功的数据
     */
    @Override
    public void onResponseSuccess(CommonEntity resultInfo) {
        mView.onResponseSuccess(resultInfo, mIndex, mBrand);
    }

    /**
     * @param failInfo 请求失败的数据
     */
    @Override
    public void onFailure(String failInfo) {
        mView.onFailure(failInfo);
    }

    /**
     * 开始请求数据，入口，~少年，要开始拿数据了~
     *
     * @param params 。。。
     */
    @Override
    public void start2requestData(Map<String, String> params, int index, String brand) {
        this.mIndex = index;
        this.mBrand = brand;
        mCommonNet.start2requestMonthSaleProductData(this, params);
    }
}
