package com.urovo.activity.data.querysales.presenter;

import com.urovo.wgmf.CommonController;
import com.wgmf.trade.model.bean.CommonEntity;
import com.urovo.wgmf.net.CommonNet;

import java.util.Map;

/**
 * presenter 层 处理view层的操作逻辑和数据回显，以及获取model 层 数据（本地和网络）
 */
public class MonthSalePre implements CommonController.Presenter {
    private CommonController.MonthSaleView mView;//view 对象（View 层）
    private CommonNet mCommonNet;// model 对象(网络层)

    public MonthSalePre(CommonController.MonthSaleView view) {
        this.mView = view;
        this.mCommonNet = new CommonNet();
    }

    /**
     * 请求入口
     */
    @Override
    public void start() {
//        mView.requestData(Constant.STORE);//默认选择门店
        mView.requestData();
    }

    /**
     * model 层回调的数据 回传给p层,最后再回传给view 层显示
     *
     * @param resultInfo 请求成功的数据
     */
    @Override
    public void onResponseSuccess(CommonEntity resultInfo) {
        mView.onResponseSuccess(resultInfo);
    }

    /**
     * @param failInfo 请求失败的数据
     */
    @Override
    public void onFailure(String failInfo) {
        mView.onFailure(failInfo);
    }

    /**
     * 开始请求数据，入口，~少年，要开始拿数据了~
     *
     * @param params 。。。
     */
    @Override
    public void start2requestData(Map<String, String> params) {
        mCommonNet.start2requestMonthSaleData(this, params);
    }
}
