package com.urovo.activity.data.querysales.view;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;

import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.activity.data.NewDataBaseActivity;
import com.urovo.activity.data.queryproductsales.view.MonthSaleProductAct;
import com.urovo.activity.data.querysales.model.MonthSaleEntity;
import com.urovo.activity.data.querysales.presenter.MonthSalePre;
import com.urovo.wgmf.CommonController;
import com.urovo.wugumofang.view.MarqueeTextView;
import com.wgmf.trade.model.bean.CommonEntity;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.constants.AppConstants;

import java.text.MessageFormat;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by chenji on 2017/6/23.
 * 销售业绩----月销量查询
 */

public class MonthSaleAct extends NewDataBaseActivity implements CommonController.MonthSaleView {
    private TextView offlineSalesMore;
    private TextView onlineSalesMore;
    private MonthSalePre mMonthSalePre;
    private Map<String, String> mParams = new HashMap<>();
    private MarqueeTextView
            completeSales,//完成销量
            monthTask,//月任务
            finishingRate,//完成率
            comparedWithSales,//同比
            sequential,//环比
            completePercentage,//应完成百分比
            totalCompleteSales,//总计完成销量
            membershipSales,//会员商品销量
            otherGoodsSales,//其他商品销量
            FinancialPaySales,//财务工资销量
            PayPoorSales;//工资销量差

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mMonthSalePre = new MonthSalePre(this);
        mMonthSalePre.start();
        View view = LayoutInflater.from(this).inflate(R.layout.act_query_sales, mFrameLayout, true);
        initView(view);
    }

    private void initView(View view) {
//      月销量页面需要
        mQueryProductSales.setVisibility(View.GONE);//去掉选择按钮
        mQueryDataLineArea.setVisibility(View.VISIBLE);// 线条区域
        view.findViewById(R.id.act_query_line).setVisibility(View.VISIBLE);//第一第二部分区域线条
        view.findViewById(R.id.act_query_second).setVisibility(View.VISIBLE);//显示第二部分区域
        view.findViewById(R.id.act_query_second_value).setVisibility(View.VISIBLE);

//       线下销售
        View actQueryOfflineSales = view.findViewById(R.id.act_query_offline_sales);
        offlineSalesMore = (TextView) actQueryOfflineSales.findViewById(R.id.store_sale_more);
        offlineSalesMore.setOnClickListener(this);//更多
        completeSales = (MarqueeTextView) actQueryOfflineSales.findViewById(R.id.complete_sales);//完成销量
        monthTask = (MarqueeTextView) actQueryOfflineSales.findViewById(R.id.month_task);//月任务
        finishingRate = (MarqueeTextView) actQueryOfflineSales.findViewById(R.id.finishing_rate);//完成率
        comparedWithSales = (MarqueeTextView) actQueryOfflineSales.findViewById(R.id.compared_with_sales);//同比
        sequential = (MarqueeTextView) actQueryOfflineSales.findViewById(R.id.sequential);//环比
        completePercentage = (MarqueeTextView) actQueryOfflineSales.findViewById(R.id.complete_percentage);//应完成百分比

//        线上销售
        View actQueryOnlineSales = view.findViewById(R.id.act_query_online_sales);
        ((TextView) actQueryOnlineSales.findViewById(R.id.store_sale_title)).setText("个人会员商品");//线上销售标题
        onlineSalesMore = (TextView) actQueryOnlineSales.findViewById(R.id.store_sale_more);
        onlineSalesMore.setOnClickListener(this);//更多
        ((TextView) actQueryOnlineSales.findViewById(R.id.complete_sales_name)).setText("销售额");//销售额标题
        ((TextView) actQueryOnlineSales.findViewById(R.id.month_task_name)).setText("销售单数");//销售单数标题
        ((TextView) actQueryOnlineSales.findViewById(R.id.finishing_rate_name)).setText("下单客户数");//下单客户数标题
        totalCompleteSales = (MarqueeTextView) actQueryOnlineSales.findViewById(R.id.complete_sales);//销售额
        membershipSales = (MarqueeTextView) actQueryOnlineSales.findViewById(R.id.month_task);//销售单数
        otherGoodsSales = (MarqueeTextView) actQueryOnlineSales.findViewById(R.id.finishing_rate);//下单客户数

//        财务销售
        View actQueryFinancialSales = view.findViewById(R.id.act_query_financial_sales);
        ((TextView) actQueryFinancialSales.findViewById(R.id.store_sale_title)).setText("财务销量");//财务销量标题
        actQueryFinancialSales.findViewById(R.id.store_sale_more).setVisibility(View.GONE);//更多按钮去掉
        ((TextView) actQueryFinancialSales.findViewById(R.id.complete_sales_name)).setText("财务工资销量");//财务工资销量标题
        ((TextView) actQueryFinancialSales.findViewById(R.id.month_task_name)).setText("工资销量差");//工资销量差标题
        actQueryFinancialSales.findViewById(R.id.finishing_rate_name).setVisibility(View.GONE);
        actQueryFinancialSales.findViewById(R.id.finishing_rate).setVisibility(View.GONE);
        FinancialPaySales = (MarqueeTextView) actQueryFinancialSales.findViewById(R.id.complete_sales);//财务工资销量
        PayPoorSales = (MarqueeTextView) actQueryFinancialSales.findViewById(R.id.month_task);//工资销量差
    }

    @Override
    protected String getTitleText() {
        return "月销量查询";
    }

    @Override
    protected int getPopupWindowMode() {
        return StoreDateSelectorPop.STORE_DATE_MONTH;
    }

    @Override
    protected void lastMonth() {
        requestData();
    }

    @Override
    protected void calendarDate() {
        requestData();
    }

    @Override
    protected void nextMonth() {
        requestData();
    }

    @Override
    public void onResponseSuccess(CommonEntity resultInfo) {
        ViewUtil.dismissProgress();
        if (resultInfo != null) {
            MonthSaleEntity monthSaleEntity = resultInfo.monthSaleEntity;
            loadData2UI(monthSaleEntity,
                    completeSales,//完成销量
                    monthTask,//月任务
                    finishingRate,//完成率
                    comparedWithSales,//同比
                    sequential,//环比
                    completePercentage,//应完成百分比
                    totalCompleteSales,//销售额
                    membershipSales,//销售单数
                    otherGoodsSales,//下单客户数
                    FinancialPaySales,//财务工资销量
                    PayPoorSales //工资销量差
            );
        }
    }

    @Override
    public void onFailure(String failInfo) {
        ViewUtil.dismissProgress();
        BaseAppManager.loger().error(failInfo);
        MyToast.show(failInfo);
    }

    @Override
    public void requestData() {
        if (NetHelper.IsHaveInternet(this)) {
            ViewUtil.showProgress(this, "正在玩命加载...", "请稍等...");
            mParams.put("ym", tempCurrentDate);//当前的日期
            mParams.put("shopId", SystemHelper.LoginOrganId);// 登录的门店ID
            mParams.put("staffId", SystemHelper.LoginUserId);// 登录的门店ID
            mMonthSalePre.start2requestData(mParams);
        } else {
            showMsg("网络连接超时，请检查您的网络状态，稍后重试！");
        }
    }

    /**
     * 设置箭头显示与否
     *
     * @param cell ...
     * @param data ...
     */
    private void setShowArrow(MarqueeTextView cell, double data) {
        if (data > 0) {
            setShowArrow(cell, R.drawable.ic_icon_red_ascent, R.drawable.ic_icon_green_descent, true);//上升
        } else if (data < 0) {
            setShowArrow(cell, R.drawable.ic_icon_red_ascent, R.drawable.ic_icon_green_descent, false);//下降
        } else {
            setHiddenArrow(cell);//隐藏箭头
        }
    }

    /**
     * 加载数据到UI
     *
     * @param entity ...
     * @param cell   ...
     */
    private void loadData2UI(MonthSaleEntity entity, MarqueeTextView... cell) {
        if (entity != null) {
//      ========================线下销售=========================
            cell[0].setText(entity.storeAmount);//完成销量
            cell[1].setText(entity.taskAmount);//月任务
            cell[2].setText(entity.finishRate);//完成率
            cell[3].setText(getMessageFormat(entity.compareToLastYear));//同比
            setShowArrow(cell[3], getDoubleData(entity.compareToLastYear));//是否显示箭头
            cell[4].setText(getMessageFormat(entity.compareToLastMonth));//环比
            setShowArrow(cell[4], getDoubleData(entity.compareToLastMonth));//是否显示箭头
            cell[5].setText(entity.shouldFinishRate);//应完成百分比
//      =========================线上销售===========================
            cell[6].setText(entity.vipSaleAmount);//销售额
            cell[7].setText(entity.vipSaleConsCount);//销售单数
            cell[8].setText(entity.vipSaleCusNum);//下单客户数
//      =========================财务销售=============================
            cell[9].setText(entity.financeSalaryAmount);//财务工资销量
            cell[10].setText(entity.shortSalaryAmount);//工资销量差
        } else {//处理实体类为null情况
            for (int i = 0; i < cell.length; i++) {
                cell[i].setText("--");
                if (i == 3 || i == 4) {
                    setShowArrow(cell[i], 0);//隐藏箭头
                }
            }
        }
    }

    /**
     * 预防后台传“--”
     *
     * @param str ...
     * @return ...
     */
    private double getDoubleData(String str) {
        if (!str.equals("--")) {
            return Double.parseDouble(str);
        }
        return 0;//后台返回数据为“--”，设置为0，隐藏箭头
    }

    /**
     * 预防后台传“--”
     *
     * @param str ...
     * @return ...
     */
    private String getMessageFormat(String str) {
        if (getDoubleData(str) != 0) {
            return MessageFormat.format("{0}%", Math.abs(getDoubleData(str)));
        } else {
            return str;
        }
    }

    @Override
    public void onClick(View v) {
        super.onClick(v);
//      =====================跳转到门店===================
        if (v == offlineSalesMore) {
            Intent intent = new Intent(MonthSaleAct.this, MonthSaleProductAct.class);
            //跳转到门店
            intent.putExtra("index", AppConstants.SalesPerformance.STORE);
            //默认门店--全部产品
            intent.putExtra("brand", AppConstants.BRAND.ALL_PRO);
            //当前选择的日期，需要同步MonthSaleProductAct的时间
            intent.putExtra("currentDate", tempCurrentDate);
            startActivity(intent);
        }
//      =====================跳转到会员商城==================
        else if (v == onlineSalesMore) {
            Intent intent = new Intent(MonthSaleAct.this, MonthSaleProductAct.class);
            //跳转到会员商城
            intent.putExtra("index", AppConstants.SalesPerformance.MENBER_MALL_STORE);
            intent.putExtra("brand", AppConstants.BRAND.VIP_PRO);
            //当前选择的日期
            intent.putExtra("currentDate", tempCurrentDate);
            startActivity(intent);
        }
    }
}
