package com.urovo.activity.display.service

import com.urovo.activity.display.model.DisplayReportDetailEntity
import com.urovo.activity.display.model.DisplayReportEntity
import com.urovo.activity.display.model.DisplayReportSubmitEntity
import com.urovo.activity.display.model.InspectorDisplayEntity
import com.urovo.wgmf.more.ent.MoreOnlineBean
import com.urovo.wugumofang.constants.ApiUrls
import com.zsy.libcore.model.bean.RequestResult
import retrofit2.Call
import retrofit2.http.*

/**
 * 陈列上报接口
 * @author LW
 */
interface ApiService {
    /**
     * get /terminalDisCorrective/findTerminalDisShop 查询终端陈列整改门店
     */
    @GET(ApiUrls.YXGJ.FIND_TERMINAL_DISSHOP)
    fun findTerminalDisShop(@Field("orgId") orgId: String?): Call<MoreOnlineBean>

    /**
     * post /exhibit/queryMissionByStoreNo 查询门店陈列任务
     */
    @POST(ApiUrls.APPSALER.QUERY_MISSION_BY_STORENO)
    fun queryMissionByStoreNo(@Query("storeNo") storeNo: String?): Call<RequestResult<InspectorDisplayEntity>>

    /**
     * post /exhibit/addSubmition 新增提报数据
     */
    @POST(ApiUrls.APPSALER.ADD_SUBMITION)
    fun addSubmition(@QueryMap map: Map<String, String?>): Call<RequestResult<String>>

    /**
     * post /exhibit/updateSubmition 修改提报数据
     */
    @POST(ApiUrls.APPSALER.UPDATE_SUBMITION)
    fun updateSubmition(@QueryMap map: Map<String, String?>): Call<RequestResult<String>>

    /**
     * POST /exhibit/queryMissionByStaffId 查询货架陈列上报任务
     */
    @POST(ApiUrls.APPSALER.QUERY_MISSION_BY_STAFFID)
    fun queryMissionByStaffId(@Query("staffId") staffId: String?): Call<RequestResult<List<DisplayReportEntity>>>

    /**
     * POST /exhibit/queryMissionDetail 查询货架陈列上报任务明细
     */
    @POST(ApiUrls.APPSALER.QUERY_MISSION_DETAIL)
    fun queryMissionDetail(
        @Query("taskId") taskId: String?,
        @Query("shopId") shopId: String?
    ): Call<RequestResult<DisplayReportDetailEntity>>

    /**
     * POST /exhibit/submitMissionDetail 提交货架陈列上报任务数据
     */
    @Headers("Content-Type: application/json", "Accept: application/json") //提交Json格式
    @POST(ApiUrls.APPSALER.SUBMIT_MISSION_DETAIL)
    fun submitMissionDetail(@Body entity: DisplayReportSubmitEntity?): Call<RequestResult<Any>>
}