package com.urovo.activity.display.view.adapter

import android.view.Gravity
import android.widget.TextView
import androidx.core.content.ContextCompat
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.urovo.activity.display.model.BaseSelectorEntity
import com.urovo.wugumofang.R

/**
 * 编辑督察陈列检查适配器
 * @author LW
 */
class InspectorDisplayEditAdapter(
    entity: List<BaseSelectorEntity>
) : BaseQuickAdapter<BaseSelectorEntity, BaseViewHolder>(
    R.layout.public_list_item,
    entity
) {

    override fun convert(helper: BaseViewHolder?, item: BaseSelectorEntity?) {
        item?.let {
                helper?.getView<TextView>(R.id.public_list_item_title)?.apply {
                    setGravity(Gravity.CENTER)
                    text=it.selectorName
                    setPadding(0, 0, 0, 0)
                    setTextColor(
                        ContextCompat.getColor(
                            context,
                            R.color.black
                        )
                    )
                    setBackgroundResource(R.color.region_bg)
                }
            }
    }
}