package com.urovo.activity.eatmanager;

import android.app.DatePickerDialog;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.TextView;

import androidx.viewpager.widget.ViewPager;

import com.urovo.activity.common.StoreSelectorActivity;
import com.urovo.activity.eatmanager.pre.EatManagerCon;
import com.urovo.activity.eatmanager.pre.EatManagerPre;
import com.urovo.wgmf.AsyncTask.uploadcases.ShichiUploadCase;
import com.urovo.wgmf.adapter.EatInAdapter;
import com.urovo.wgmf.adapter.EatQueryAdapter;
import com.urovo.wgmf.adapter.MyPagerAdapter;
import com.urovo.wgmf.db.dao.dao.Djsc001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djsc002DbOperate;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.ShiChiEntity;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wgmf.entity.response.ShiChiQueryResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivityTap;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.manager.ThreadManager;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.InputMethodManagerTool;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.MyToast;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import kotlin.Unit;
import kotlin.jvm.functions.Function1;

public class EatManager2 extends BaseActivityTap implements EatManagerCon.view{

    private ViewPager pager;
    private View pagerItem1;
    private View pagerItem2;
    private ArrayList<View> pagerList = new ArrayList<View>();

    private RadioGroup RadioGroup;
    private RadioButton tableft;
    private RadioButton tabright;

    private EditText eatnum;
    private TextView eatnum2;
    private Button eatsave;
    private ListView eatinlistview;
    private TextView storeIn;
    private String storeidIn;
    private List<HashMap<String, String>> scList;
    private EatInAdapter eatInAdapter;
    private double count = 0;

    private TextView datefrom;
    private TextView dateto;
    private TextView eatcount;
    private ListView eatquirelistview;
    private String beginTime, endTime;
    private LinearLayout storeSelector;
    private TextView store;
    private String storeid;
    private EatQueryAdapter eatQueryAdapter;
    private TextView noDataText;
    private LinearLayout noNetLayout;
    EatManagerPre pre;
    View loading;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.eatmanager_tap);
        pre = new EatManagerPre(this);
        initTitle();
        initPager();
        initPagerChild();
        initPagerChild2();
        init();
    }

    @Override
    public void setPresenter(Object presenter) {
        this.pre = (EatManagerPre)presenter;
    }

    private void init() {
        tableft = (RadioButton) findViewById(R.id.tap_button_left);
        tabright = (RadioButton) findViewById(R.id.tap_button_right);
        tableft.setText("试吃录入");
        tabright.setText("试吃查询");
        tableft.setTextColor(getResources().getColor(R.color.title_yellow_bg));
        RadioGroup = (RadioGroup) findViewById(R.id.tap_radio);
        RadioGroup.setOnCheckedChangeListener(new OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                switch (checkedId) {
                    case R.id.tap_button_left:
                        pager.setCurrentItem(0);
                        tableft.setTextColor(getResources().getColor(R.color.title_yellow_bg));
                        tabright.setTextColor(getResources().getColor(R.color.white));
                        break;
                    case R.id.tap_button_right:
                        pager.setCurrentItem(1);
                        tableft.setTextColor(getResources().getColor(R.color.white));
                        tabright.setTextColor(getResources().getColor(R.color.title_yellow_bg));
                        if (beginTime.equals(endTime)) {
                            query();
                        }
                        break;
                }
            }
        });
    }

    private void initPager() {
        pager = (ViewPager) findViewById(R.id.viewpager_tab);
        pagerItem1 = LayoutInflater.from(this).inflate(R.layout.eatmanager_in, null);
        pagerItem2 = LayoutInflater.from(this).inflate(R.layout.eatmanager_quire, null);
        loading = pagerItem2.findViewById(R.id.loading_list);
        // pagerItem3 =
        // LayoutInflater.from(this).inflate(R.layout.normal_quire_resault,
        // null);
        pagerList.add(pagerItem1);
        pagerList.add(pagerItem2);
        // pagerList.add(pagerItem3);
        pager.setAdapter(new MyPagerAdapter(this, pagerList));
        pager.setOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageSelected(int arg0) {

                switch (arg0) {
                    case 0:
                        tableft.setChecked(true);
                        tableft.setTextColor(getResources().getColor(R.color.title_yellow_bg));
                        tabright.setTextColor(getResources().getColor(R.color.white));
                        break;
                    case 1:
                        tabright.setChecked(true);
                        tableft.setTextColor(getResources().getColor(R.color.white));
                        tabright.setTextColor(getResources().getColor(R.color.title_yellow_bg));
                        InputMethodManagerTool.getInstance(EatManager2.this).hideInputMethod(eatnum);
                        break;
                    default:
                        break;
                }
            }

            @Override
            public void onPageScrollStateChanged(int arg0) {

            }

            @Override
            public void onPageScrolled(int arg0, float arg1, int arg2) {

            }
        });
    }

    private void initPagerChild() {
        if (SystemHelper.IsAdmin) {
            LinearLayout storeSelectorIn = (LinearLayout) pagerItem1.findViewById(R.id.storeSelector);
            storeSelectorIn.setVisibility(View.VISIBLE);
            storeIn = (TextView) pagerItem1.findViewById(R.id.sotre_selector);
            TextView storetitle = (TextView) pagerItem1.findViewById(R.id.storetitle);
            storetitle.setText("录入门店");
        } else {
            View storequireIn = pagerItem1.findViewById(R.id.store_item);
            storequireIn.setVisibility(View.GONE);
            View lineIn = pagerItem1.findViewById(R.id.store_line);
            lineIn.setVisibility(View.GONE);
            storeidIn = SystemHelper.LoginOrganId;
        }
        eatnum = (EditText) pagerItem1.findViewById(R.id.eat_num);
        eatnum2 = (TextView) pagerItem1.findViewById(R.id.eat_num2);
        eatsave = (Button) pagerItem1.findViewById(R.id.eat_save);
        eatinlistview = (ListView) pagerItem1.findViewById(R.id.eat_in_listview);
        if (!SystemHelper.IsAdmin) {
            loadTodayShichi();
            // 界面加载，延时弹出键盘
//            Timer timer = new Timer();
//            timer.schedule(new TimerTask() {
//                public void run() {
//                    // InputMethodManager inputManager =
//                    // (InputMethodManager)eatnum.getContext().getSystemService(Context.INPUT_METHOD_SERVICE);
//                    // inputManager.showSoftInput(eatnum, 0);
//                    InputMethodManagerTool.getInstance(EatManager2.this).getInputMethod(eatnum);
//                }
//            }, 558);

        }

    }

    private void initPagerChild2() {
        if (SystemHelper.IsAdmin) {
            storeSelector = (LinearLayout) pagerItem2.findViewById(R.id.storeSelector);
            storeSelector.setVisibility(View.VISIBLE);
            store = (TextView) pagerItem2.findViewById(R.id.sotre_selector);
        } else {
            View storequire = pagerItem2.findViewById(R.id.store_item);
            storequire.setVisibility(View.GONE);
            View line = pagerItem2.findViewById(R.id.store_line);
            line.setVisibility(View.GONE);
            storeid = SystemHelper.LoginOrganId;
        }
        String date = DateUtil.getDate(new Date());
        beginTime = date;
        endTime = date;
        datefrom = (TextView) pagerItem2.findViewById(R.id.date_from);
        dateto = (TextView) pagerItem2.findViewById(R.id.date_to);
        datefrom.setText(beginTime);
        dateto.setText(endTime);
        eatcount = (TextView) pagerItem2.findViewById(R.id.eat_count);
        eatquirelistview = (ListView) pagerItem2.findViewById(R.id.eat_quire_listview);
        noDataText = (TextView) pagerItem2.findViewById(R.id.no_data_text);
        noNetLayout = (LinearLayout) pagerItem2.findViewById(R.id.no_net_layout);
    }

    public void eatSave(View view) {
        saveShiChi();
        // new UploadShiChiTask(this, "正在上传试吃数据", true).execute("");
    }

	/*
     * public void datePicker(View view){ View contentView =
	 * LayoutInflater.from(this).inflate( R.layout.ordergoods_quire, null); new
	 * SelectDatePop(this, new onDateSelectedListener() {
	 * 
	 * @Override public void onDateSelect(String startDay, String endDay) {
	 * 
	 * datefrom.setText(startDay); beginTime = startDay; dateto.setText(endDay);
	 * endTime = endDay; query(); } }).showWindow(contentView); }
	 */

    public void orderDatePickFrom(View view) {
        Calendar c = Calendar.getInstance();
        new DatePickerDialog(this, new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                datefrom.setText(String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth));
                beginTime = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
                query();
            }
        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show();
    }

    public void orderDatePickTo(View view) {
        Calendar c = Calendar.getInstance();
        new DatePickerDialog(this, new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                dateto.setText(String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth));
                endTime = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
                query();
            }
        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show();
    }

    private void query() {
        if(loading != null){
            loading.setVisibility(View.VISIBLE);
        }
        pre.queryEat(SystemHelper.LoginOrganId,beginTime,endTime);
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {

        super.displayResult(tag, response);
//        if (QueryShiChiTask.TAG.equals(tag)) {
//            ShiChiQueryResponse res = (ShiChiQueryResponse) response;
//            List<ShiChiQueryResponse.ResultInfoBean> list = res.getResultInfo();
//            if (list == null || list.size() == 0) {
//                showDataType(1);
//                showMsg("无试吃数据");
//            } else {
//                showDataType(0);
//            }
//            eatQueryAdapter = new EatQueryAdapter(list, EatManager.this);
//            eatquirelistview.setAdapter(eatQueryAdapter);
//            double count = 0;
//            for (int i = 0; i < list.size(); i++) {
//                double co = list.get(i).getTasteQty();
//                count = Arith.add(count, co);
//            }
//            eatcount.setText(count + "");
//        }
    }

    public void storeSelector(View view) {
        Intent intent = new Intent(EatManager2.this, StoreSelectorActivity.class);
        if (pager.getCurrentItem() == 1) {
            intent.putExtra("store", "ALL");
            startActivityForResult(intent, 200);
        } else {
            startActivityForResult(intent, 200);
        }

    }

    @Override
    public void setAdapter(List<ShiChiQueryResponse.ResultInfoBean> list) {
        eatQueryAdapter = new EatQueryAdapter(list, EatManager2.this);
        eatquirelistview.setAdapter(eatQueryAdapter);
    }

    @Override
    public void refreshEatCount(double count) {
        eatcount.setText(count+ "");
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);
        switch (resultCode) {
            case StoreSelectorActivity.RESULTCODE:
                ShopEntity shopEntity = (ShopEntity) data.getSerializableExtra("store");
                if (shopEntity != null) {
                    if (pager.getCurrentItem() == 1) {
                        store.setText(shopEntity.getShopName());
                        storeid = shopEntity.getShopId();
                        query();
                    } else {
                        storeIn.setText(shopEntity.getShopName());
                        storeidIn = shopEntity.getShopId();
                        loadTodayShichi();
                    }
                }
                break;
            default:
                break;
        }
    }

    private void loadTodayShichi() {
        count = 0;
        Date today = new Date();
        String todayStr = DateUtil.format(today, "yyMMdd");
        scList = Djsc002DbOperate.findTodayShiChi(storeidIn + todayStr);
        eatInAdapter = new EatInAdapter(scList, EatManager2.this);
        eatinlistview.setAdapter(eatInAdapter);
        for (HashMap<String, String> map : scList) {
            String itemCount = map.get("count");
            count += Double.parseDouble(itemCount);
        }
        eatnum2.setText(StringUtils.formatDouble(count, "0.##"));
    }

    protected void saveShiChi() {

        if (TextUtils.isEmpty(storeidIn)) {
            showMsg("请先选择门店!");
            return;
        }
        String countString = eatnum.getText().toString().trim();
        if (TextUtils.isEmpty(countString)) {
            showMsg("请先输入数量!");
            return;
        }
        if (countString.length() > 3) {
            showMsg("请先输入3位数以内的数量!");
            return;
        }
        double newCount = Double.parseDouble(countString);
        ProductEntity p = new ProductEntity();
        p.setTQTY(newCount);
        p.setItemId("5.00009");
        ArrayList<ProductEntity> pList = new ArrayList<ProductEntity>();
        pList.add(p);
        ShiChiEntity ent = new ShiChiEntity();
        Date date = new Date();
        ent.setStoreId(storeidIn);
        ent.setBill(storeidIn + DateUtil.format(date, "yyMMddHHmmss"));
        ent.setOper_Lr(SystemHelper.LoginUserId);
        ent.setLr_Name(SystemHelper.LoginUserName);
        ent.setWDate(DateUtil.getDateByFormat(date, "yyyy-MM-dd HH:mm:ss"));
        Djsc001DbOperate.SaveShiChi(ent);
        Djsc002DbOperate.SaveShiChiDetail(ent.getBill(), pList);
        refresh(newCount, date);
        eatnum.setText("");

//        List<String> tags = new ArrayList<String>();
//        tags.add(UploadParam.SHICHI);
//        new UploadBusinessDataTask(this, "数据上传中", true, tags).execute("");

        ViewUtil.showProgress(this,"请稍等","数据上传中");
        new ShichiUploadCase(new Function1<String, Unit>() {
            @Override
            public Unit invoke(String resultStr) {
                ViewUtil.dismissProgress();
                if (!TextUtils.isEmpty(resultStr)){
                    MyToast.show(resultStr);
                }
                return null;
            }
        }).dowork();
//        ThreadManager.getThreadPool().execute(new Runnable() {
//            @Override
//            public void run() {
//
//            }
//        });
    }

    private void refresh(double newCount, Date date) {
        count += newCount;
        HashMap<String, String> map = new HashMap<String, String>();
        map.put("time", DateUtil.format(date, "HH:mm"));
        map.put("count", StringUtils.formatDouble(newCount, "0.##"));
        scList.add(map);
        eatInAdapter.notifyDataSetChanged();
        eatinlistview.smoothScrollToPosition(scList.size() - 1);
        eatnum2.setText(StringUtils.formatDouble(count, "0.##"));
    }

    public void showDataType(int type) {
        loading.setVisibility(View.GONE);
        switch (type) {
            case 0:
                noDataText.setVisibility(View.INVISIBLE);
                noNetLayout.setVisibility(View.INVISIBLE);
                break;
            case 1:
                noDataText.setVisibility(View.VISIBLE);
                noNetLayout.setVisibility(View.INVISIBLE);
                break;
            case 2:
                noNetLayout.setVisibility(View.VISIBLE);
                break;
            default:
                break;
        }
    }

    public void againLoadData(View v) {

        query();
    }

    @Override
    public void displayNoNet(String tag) {

        super.displayNoNet(tag);
//        if (QueryShiChiTask.TAG.equals(tag)) {
//            showDataType(2);
//        }
    }

    @Override
    protected void onDestroy() {
//        InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
//        if(imm.isActive()){
//            imm.toggleSoftInput(0, InputMethodManager.HIDE_NOT_ALWAYS);
//        }
        super.onDestroy();
//        if(eatnum != null){
//            InputMethodManagerTool.getInstance(this).hideInputMethod(eatnum);
//        }

    }


}
