package com.urovo.activity.goodsReturn.net;

import com.urovo.wugumofang.response.Base3Response;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Sasuke
 * @date 2017/4/28
 * 退货新接口的 销售记录response
 */

public class GoodsReturnRecordRes extends Base3Response implements Serializable {

    private List<Result> resultInfo;

    public List<Result> getResult() {
        return resultInfo;
    }

    public static class Result implements Serializable {
        /**
         * storeNo : 0110076
         * salePosId : 4
         * saleDate : 2017-3-24 0:00:00
         * saleBill : 011007679109204170324125452
         * storeShift : Z
         * salePhone : 13130993898
         * saleUserNo : 79109204
         * saleCount : 11
         * saleAmount : 1277.2
         * saleActualAmount : 1277.2
         * 以下这个字段已经不是在同一个接口里面啦,分了两个接口做的了...
         * detailList : [{"proName":"北杏仁","proCode":"2.20039","proQty":6,"proPrice":12.8,"proAmount":76.8},{"proName":"胚芽五谷","proCode":"2.40115","proQty":2,"proPrice":39.8,"proAmount":79.6},{"proName":"提子燕麦片(560g)","proCode":"2.40143","proQty":1,"proPrice":57.6,"proAmount":57.6},{"proName":"山药","proCode":"2.20042","proQty":2,"proPrice":12.8,"proAmount":25.6},{"proName":"葛根","proCode":"2.20046","proQty":2,"proPrice":12.8,"proAmount":25.6},{"proName":"枸杞","proCode":"2.20047","proQty":8,"proPrice":6.8,"proAmount":54.4},{"proName":"核桃仁(70g)","proCode":"2.20051","proQty":16,"proPrice":18.8,"proAmount":300.8},{"proName":"益元八珍","proCode":"2.40010","proQty":1,"proPrice":168,"proAmount":168},{"proName":"茯苓","proCode":"2.20038","proQty":2,"proPrice":12.8,"proAmount":25.6},{"proName":"南瓜子","proCode":"2.20044","proQty":20,"proPrice":18.8,"proAmount":376},{"proName":"黑芝麻(250g)","proCode":"2.20053","proQty":4,"proPrice":21.8,"proAmount":87.2}]
         */

        private String storeNo;//门店号
        private String salePosId;//销售POSID
        private String saleDate;//销售日期
        private String saleBill;//销售单号
        private String storeShift;//门店班次
        private String salePhone;//客户手机号
        private String saleUserNo;//营养顾问工号
        private int saleCount;//销售单产品数
        private double saleAmount;//销售金额
        private double saleActualAmount;//实收金额 ,
        private int returnStatus;//退货情况，0：未退货，1：部分退货，2：全部退货
        private int orderType;//订单类别,0正常下单，1补录，2微商城，3到家业务 ,
        private List<DetailListBean> detailList = new ArrayList<>();//销售单明细

        public int getOrderType() {
            return orderType;
        }

        public int getReturnStatus() {
            return returnStatus;
        }

        public boolean isShowLabel() {
            return isShowLabel;
        }

        public void setShowLabel(boolean showLabel) {
            isShowLabel = showLabel;
        }

        /**
         * 手动添加是否显示散货的标志(当前是增加新品牌鲜稻研产品需要)
         */
        private boolean isShowLabel;
        //以下非后台返回，是自己加的标记（其实就是老代码里的）
        public int checkCount = 0;//check了多少个
        private double BillNo = 0; // 单据序号
        private String promid = "";// 活动ID（啥啥啥？我的天这都是啥？
        // 退货老代码里连个赋值的操作都没有，传的全是默认值！不知道有什么意义）
        private String exchangecode = "";// 验证码

        public String getExchangecode() {
            return exchangecode;
        }

        public void setExchangecode(String exchangecode) {
            this.exchangecode = exchangecode;
        }

        public String getPromid() {
            return promid;
        }

        public void setPromid(String promid) {
            this.promid = promid;
        }

        public double getBillNo() {
            return BillNo;
        }

        public void setBillNo(double billNo) {
            BillNo = billNo;
        }

        public String getStoreNo() {
            return storeNo;
        }

        public void setStoreNo(String storeNo) {
            this.storeNo = storeNo;
        }

        public String getSalePosId() {
            return salePosId;
        }

        public void setSalePosId(String salePosId) {
            this.salePosId = salePosId;
        }

        public String getSaleDate() {
            return saleDate;
        }

        public void setSaleDate(String saleDate) {
            this.saleDate = saleDate;
        }

        public String getSaleBill() {
            return saleBill;
        }

        public void setSaleBill(String saleBill) {
            this.saleBill = saleBill;
        }

        public String getStoreShift() {
            return storeShift;
        }

        public void setStoreShift(String storeShift) {
            this.storeShift = storeShift;
        }

        public String getSalePhone() {
            return salePhone;
        }

        public void setSalePhone(String salePhone) {
            this.salePhone = salePhone;
        }

        public String getSaleUserNo() {
            return saleUserNo;
        }

        public void setSaleUserNo(String saleUserNo) {
            this.saleUserNo = saleUserNo;
        }

        public int getSaleCount() {
            return saleCount;
        }

        public void setSaleCount(int saleCount) {
            this.saleCount = saleCount;
        }

        public double getSaleAmount() {
            return saleAmount;
        }

        public void setSaleAmount(double saleAmount) {
            this.saleAmount = saleAmount;
        }

        public double getSaleActualAmount() {
            return saleActualAmount;
        }

        public void setSaleActualAmount(double saleActualAmount) {
            this.saleActualAmount = saleActualAmount;
        }

        public List<DetailListBean> getDetailList() {
            return detailList;
        }

        public void setDetailList(List<DetailListBean> detailList) {
            this.detailList = detailList;
        }

        public static class DetailListBean implements Serializable {
            /**
             * proName : 北杏仁
             * proCode : 2.20039
             * proQty : 6
             * proPrice : 12.8
             * proAmount : 76.8
             */
            private String proName;// 产品名字
            private String proCode;//产品编码
            private double proQty;//产品数量(五谷磨房)/产品称斤重量（鲜稻研）
            private double proPrice;//产品单价
            private double proAmount;//产品总价格

            /**
             * 手动加入产品品牌，用于判断是否显示数量或者重量加减号按钮
             */
            public String brand;

            //            public double orgQty;
            public String KCUom;//包装单位、、罐、包、、等等
            public boolean isBack = false;//要退货的标记
            public double bakQty = 0;//拷贝的一份老数量（用于后面调节数量时、作最大值）
            public double bakAmount = 0;//拷贝的一份老总价格
            public double currentQty = 0;//proQty是此单本来一共买了多少，而currentQty是减去已经退过的，还剩多少可以退的。。。就是上面那个orgQty。。
            public boolean isEnable = false;//有点迷糊了，不要问我这是干什么的，不要改！

            public String getProName() {
                return proName;
            }

            public void setProName(String proName) {
                this.proName = proName;
            }

            public String getProCode() {
                return proCode;
            }

            public void setProCode(String proCode) {
                this.proCode = proCode;
            }

            public double getProQty() {
                return proQty;
            }

            public void setProQty(double proQty) {
                this.proQty = proQty;
            }

            public double getProPrice() {
                return proPrice;
            }

            public void setProPrice(double proPrice) {
                this.proPrice = proPrice;
            }

            public double getProAmount() {
                return proAmount;
            }

            public void setProAmount(double proAmount) {
                this.proAmount = proAmount;
            }
        }
    }
}
