package com.urovo.activity.goodsReturn.view;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ExpandableListView;
import android.widget.ExpandableListView.OnChildClickListener;
import android.widget.ExpandableListView.OnGroupExpandListener;
import android.widget.TextView;

import com.urovo.activity.goodsReturn.net.GoodsReturnRecordDetail;
import com.urovo.activity.goodsReturn.net.GoodsReturnRecordRes;
import com.urovo.activity.goodsReturn.ui.GoodsReturnAda;
import com.urovo.wgmf.AsyncTask.BaseAppServerTask;
import com.urovo.wgmf.AsyncTask.UploadTuiHuoTask;
import com.urovo.wgmf.db.dao.dao.Cpbill002DbOperate;
import com.urovo.wgmf.db.dao.dao.Djxs001DbOperate;
import com.urovo.wgmf.db.dao.dao.Item001DbOperate;
import com.urovo.wgmf.db.dao.entitys.HuiYuanJiChuXinXiEntity;
import com.urovo.wgmf.db.dao.entitys.HuiYuanTag;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.XiaoShouEntity;
import com.urovo.wgmf.entity.response.HuiYuanJiChuXinXiResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.JsonDominator;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DialogHelper;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import okhttp3.Request;


/**
 * 产品退货详情页面
 *
 * @author Administrator
 */
public class storeManagerCancelDetail extends BaseActivity {
    private TextView textInfo;
    private ExpandableListView listView;
    private List<GoodsReturnRecordRes.Result> list;
    private Button submit;
    private GoodsReturnRecordRes.Result ent;
    private String[] info;
    private GoodsReturnAda saleBackAdapter;
    private int lastItem = -1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.store_manager_cancel_confirm);
        initTitle();
        init();
    }

    @SuppressWarnings("unchecked")
    private void init() {
        titleTextView.setText("产品退货");
        textInfo = (TextView) findViewById(R.id.sale_back_info);
        submit = (Button) findViewById(R.id.sale_back_submit);
        listView = (ExpandableListView) findViewById(R.id.sale_back_list);
        Intent intent = getIntent();
        info = intent.getStringArrayExtra("INFO");//门店名、退货日期与销售日期
        String jine = intent.getStringExtra("JINE");
        String phone = intent.getStringExtra("PHONE");
        textInfo.setText(String.format("退:%s 销:%s %s", info[1], info[2], info[0]));
        list = (List<GoodsReturnRecordRes.Result>) intent.getSerializableExtra("LIST");
//		if(list != null && list.size() > 0) {
//			Iterator<GoodsReturnRecordRes.Result> iterator2 = list.iterator();
//			while (iterator2.hasNext()) {
//				if(iterator2.next().getDetailList().size() == 0) {
//					iterator2.remove();
//				}
//			}
//		}
//		else {
//			showMsg("无销售单!");
//			return;
//		}
        if (list != null && list.size() > 0) {
            if (TextUtils.isEmpty(phone) && TextUtils.isEmpty(jine)) {
                initListView();
            } else {
                Iterator<GoodsReturnRecordRes.Result> iterator = list.iterator();
                double jin = 0;
                try {
                    jin = Double.valueOf(jine);
                } catch (NumberFormatException e) {
                    jine = "";
                }
                while (iterator.hasNext()) {
                    GoodsReturnRecordRes.Result cell = iterator.next();
                    String str = cell.getSalePhone();
                    double dou = cell.getSaleAmount();
                    if ((!TextUtils.isEmpty(phone) && !phone.equals(str)) || (!TextUtils.isEmpty(jine) && dou != jin)) {
                        iterator.remove();
                    }
                }
                if (list.size() == 0) {
                    showMsg("无该会员的销售单!");
                } else {
                    initListView();
                }
            }

        } else {
            showMsg("无可退货的销售单!");
        }

    }

    private void initListView() {
        saleBackAdapter = new GoodsReturnAda(this, list);
        listView.setAdapter(saleBackAdapter);
        listView.setGroupIndicator(null);
        listView.setOnGroupExpandListener(new OnGroupExpandListener() {

            @Override
            public void onGroupExpand(int groupPosition) {
                submit.setVisibility(View.GONE);
                if (lastItem >= 0 && lastItem != groupPosition) {
                    listView.collapseGroup(lastItem);
                }
                lastItem = groupPosition;
                //查询客户信息、积分
                checkVIP(list.get(groupPosition));
                //如果详情列表为空，就查询订单详情
                if (list.get(groupPosition).getDetailList().size() == 0) {
                    queryDetail(list.get(groupPosition).getSaleBill(), groupPosition);
                }
            }
        });
        listView.setOnChildClickListener(new OnChildClickListener() {
            @Override
            public boolean onChildClick(ExpandableListView parent, View v, int groupPosition, int childPosition, long id) {
                if (id == R.id.loading_layout) {
                    //加载小圆圈的界面不需要点击响应
                    return true;
                }
                GoodsReturnRecordRes.Result.DetailListBean bean = list.get(groupPosition).getDetailList().get(childPosition);
                //这个好像是表示“已经退了的”吧？所以就不能操作了？
                if (!bean.isEnable) {
                    return false;
                }
                CheckBox check = (CheckBox) v.findViewById(R.id.sale_back_check);
                //如果为true，说明点击之前是true，那么点击之后就是false了，就是说，不退这个产品！！！
                if (check.isChecked()) {
                    bean.isBack = false;
                    list.get(groupPosition).checkCount--;
                } else {//退的就是你！
                    bean.isBack = true;
                    list.get(groupPosition).checkCount++;
                }
                List<GoodsReturnRecordRes.Result.DetailListBean> array = list.get(groupPosition).getDetailList();
                boolean hasSaleGift = false;
                //遍历一遍，看看里面有没有礼品。
                for (GoodsReturnRecordRes.Result.DetailListBean item : array) {
                    //总价为0的是礼品
                    if (0 == item.getProAmount() || "9.8888".equals(item.getProCode())) {
                        hasSaleGift = true;
                        break;
                    }
                }
                //isBack表示要退！！
                boolean back = bean.isBack;
                if (hasSaleGift) {
                    list.get(groupPosition).checkCount = 0;
                    for (GoodsReturnRecordRes.Result.DetailListBean item : array) {
                        if (0 <= item.getProQty()) {
                            item.isBack = back;
                            if (back) {
                                list.get(groupPosition).checkCount++;
                            }
                        }
                    }
                    if (back) {
                        showMsg("该单包含赠品，只能整单退货！");
                    }
                }else if (back){//没有赠品的情况下 ，并且是要退的情况下
                    if (!Cpbill002DbOperate.isDecimalById(bean.getProCode())){//如果不支持小数位，说明是定型包装产品，支持部分退
                        showMsg("定型包装产品，支持部分退货！");
                    }else{//如果支持小数位，说明是散装，不支持部分退货
                        showMsg("散装产品，只能单品全部退货！");
                    }
                }
                showSubmit(list.get(groupPosition).checkCount > 0);
                saleBackAdapter.notifyDataSetChanged();
                return false;
            }
        });
    }

    /**
     * 后台获取会员信息
     *
     * @param ent ...
     */

    private void checkVIP(GoodsReturnRecordRes.Result ent) {
        this.ent = ent;
        if (ent != null) {
            if (TextUtils.isEmpty(ent.getSalePhone())) {
                showSubmit(list.get(lastItem).checkCount > 0);
            } else {
                Map<String, String> p = new HashMap<>(2);
                p.put("userId", SystemHelper.LoginUserId);
                p.put("customerMobile", ent.getSalePhone());
                new BaseAppServerTask("query_huiyuan", HuiYuanJiChuXinXiResponse.class, this, "正在查询会员基础信息...", false, "/information/getCustomerInfo", p).execute("");
            }
        }
    }

    /**
     * 展开子列表的时候，请求订单详情
     *
     * @param billNo 该订单的单号
     */
    private void queryDetail(String billNo, final int groupPos) {
        if (!TextUtils.isEmpty(billNo)) {
            HashMap<String, String> param = new HashMap<>(1);
            param.put("billNo", billNo);
            OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.GOODRETURN_GET_DETAIL,
                    param,
                    new OkHttpDominator.ResultCallback<GoodsReturnRecordDetail>() {
                        @Override
                        public void onError(Request request, Exception e) {
                            showMsg("网络异常，获取详情失败");
                            listView.collapseGroup(lastItem);//获取失败了，就把这一子列表收缩起来。
                        }

                        @Override
                        public void onResponse(GoodsReturnRecordDetail res) {
                            if (res == null || res.resultInfo == null || res.resultInfo.size() == 0) {
                                showMsg("返回详情列表为空");
                                listView.collapseGroup(lastItem);//获取失败了，就把这一子列表收缩起来。
                                return;
                            }
                            addDetail2List(res.resultInfo, groupPos);
                        }
                    });
        }
    }

    /**
     * 把返回的子列表添加到大列表里。
     */
    private void addDetail2List(List<GoodsReturnRecordRes.Result.DetailListBean> detailList, int groupPos) {
        for (GoodsReturnRecordRes.Result.DetailListBean detailItem : detailList) {
            detailItem.bakQty = detailItem.getProQty();//备份初始数量作为最大值，供后面手动调节时使用
            detailItem.bakAmount = detailItem.getProAmount();//备份初始总价作为最大值，供后面手动调节时使用
            detailItem.KCUom = Item001DbOperate.getKCUomById(detailItem.getProCode());//List里填入包装单位（从db里查）。
            detailItem.isEnable = detailItem.getProQty() > 0 && detailItem.getProAmount() > 0;
            detailItem.currentQty = detailItem.getProQty();//先同步初始化一下currentQty（可退多少）
            detailItem.brand = Item001DbOperate.getBrandById(detailItem.getProCode());// 从产品表中获取订单中所选的产品是哪个品牌的（五谷磨房/鲜稻研）
            //是否是鲜稻研,是就在group层显示散装标志
//            list.get(groupPos).setShowLabel(!SystemHelper.isWgmf(detailItem.brand));
//            SYLoger.print(detailItem.getProCode() + ", \n" + detailItem.brand + ", \n" + list.get(groupPos).isShowLabel());
            double num = detailItem.getProQty();
            //以下初始化currentQty，这个字段表示当前可退多少（相当于用之前已买的 减去 已退的）
            if (num > 0 && detailItem.getProAmount()!= 0) {//数量为正数时，表示这个是普通销售单，而不是已退的
                for (GoodsReturnRecordRes.Result.DetailListBean same : detailList) {
                    if (detailItem != same//排除它自己
                            && detailItem.getProCode().equals(same.getProCode())//同一个产品编码
                            && same.getProAmount() != 0) {//总价不为零（为零的好像是赠品）
                        num += same.getProQty();//不用怕，这里currentQty是已经在前面初始化过的，初始时跟proQty是相等的。
                        detailItem.currentQty = num;//这是还可以继续退的数量（原有数量减去已退数量）
                    }
                }
            }
        }

        //展开的子列表按照金额降序
        Collections.sort(detailList, new Comparator<GoodsReturnRecordRes.Result.DetailListBean>() {
            @Override
            public int compare(GoodsReturnRecordRes.Result.DetailListBean lhs, GoodsReturnRecordRes.Result.DetailListBean rhs) {
                if (lhs.getProAmount() > rhs.getProAmount()) {
                    return -1;
                } else if (lhs.getProAmount() == rhs.getProAmount()) {
                    return 0;
                } else {
                    return 1;
                }
            }
        });

        //处理完毕，正式添加进大表
        list.get(groupPos).setDetailList(detailList);
        saleBackAdapter.notifyDataSetChanged();
    }


    @Override
    public void displayResult(String tag, BaseResponse response) {

        super.displayResult(tag, response);
        if ("query_huiyuan".equals(tag)) {
            if (null == response) {
                return;
            }
            HuiYuanJiChuXinXiResponse res = (HuiYuanJiChuXinXiResponse) response;
            //===========test==========
            HuiYuanJiChuXinXiResponse resTemp = JsonDominator.loadFromSD("query_huiyuan", HuiYuanJiChuXinXiResponse.class);
            if (resTemp != null) {
                //......do_anything
                res = resTemp;
            }
            //===========test==========
            HuiYuanJiChuXinXiEntity entity = res.resultInfo;
            if (null != entity) {
//				if((!TextUtils.isEmpty(ent.getPromid())) )
//				{
//					showMsg("该销售单为参加活动类型，允许退货!");
//					showSubmit((this.list.get(lastItem).checkCount > 0) ? true : false);
//				}
//				else 
                if ("1".equals(entity.customerStatus) || "2".equals(entity.customerStatus)) {
                    showMsg("该会员为禁用会员，允许退货!");
                    showSubmit(this.list.get(lastItem).checkCount > 0);
                } else {
                    checkVIPJF(entity);
                }
            } else {
                showMsg("无法获取会员积分，允许退货!");
                showSubmit(this.list.get(lastItem).checkCount > 0);
            }
        }
        // if (DownVipTask.TAG.equals(tag))
        // {
        // VipResponse vip = (VipResponse) response;
        // Vip vipEntity = vip.getVipEntity();
        // if (vipEntity != null)
        // {
        // checkVIPJF(vipEntity);
        // }
        // else
        // {
        // showMsg("会员验证失败!");
        // photoListView.collapseGroup(lastItem);
        // }
        // }
        else if (UploadTuiHuoTask.TAG.equals(tag)) {
            submit.setEnabled(true);
            if (response != null) {
                String info = "";
                if ("0".equals(response.ret)) {
//                    info = "上传成功";
                    showMsg("退货成功!");
                    storeManagerCancelDetail.this.finish();
                } else {
                    info = response.retInfo;
                    DialogHelper.Alert(storeManagerCancelDetail.this, "提示", info, null, null);
                }

            } else {
                DialogHelper.Alert(storeManagerCancelDetail.this, "提示", "上传失败", null, null);
            }
        }
    }

    /**
     * 验证会员积分
     *
     * @param vipEntity
     */
    private void checkVIPJF(HuiYuanJiChuXinXiEntity vipEntity) {
        int yxjf = 0;
        try {
            yxjf = Integer.parseInt(vipEntity.validPoint);
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
            yxjf = 0;
        }
        if (yxjf > 0) {
            String msg = "会员姓名:" + vipEntity.customerName + "\r\n性别:" + ("1".equals(vipEntity.customerSex) ? "男" : "女") + "\r\n有效积分:" + yxjf;
            DialogHelper.Alert(storeManagerCancelDetail.this, "提示", msg, null, new DialogInterface.OnClickListener() {

                @Override
                public void onClick(DialogInterface dialog, int which) {
                    showSubmit(list.get(lastItem).checkCount > 0);
                }
            });
        }
        //else {
        //	showMsg("该会员有效积分不足，不允许退货!");
        //	photoListView.collapseGroup(lastItem);
        //}
    }

    public void submit(View v) {
        final List<GoodsReturnRecordRes.Result.DetailListBean> choice = new ArrayList<>();
        final GoodsReturnRecordRes.Result bill = list.get(lastItem);
        for (GoodsReturnRecordRes.Result.DetailListBean p : bill.getDetailList()) {
            if (p.isBack && (p.getProQty() != 0)) {//TQTY是产品数量
                choice.add(p);
            }
        }

        boolean onlyZenPin = true;
        for (GoodsReturnRecordRes.Result.DetailListBean p : choice) {
            if (0 != p.getProAmount()) {
                onlyZenPin = false;
                break;
            }
        }
        if (onlyZenPin) {
            choice.clear();
        }

        if (choice.size() == 0) {
            DialogHelper.Alert(storeManagerCancelDetail.this, "提示", "您没有选择任何退货产品或者此单无法再退!", null, null);
        } else {
            DialogHelper.Alert2(storeManagerCancelDetail.this, "提示", "是否确认退货!", null, new DialogInterface.OnClickListener() {

                @Override
                public void onClick(DialogInterface dialog, int which) {
                    double amount = 0;
                    double diffPrice = 0;//折扣产品价格（这个命名，其实是延用MemberSalesFra.java里的）
                    for (GoodsReturnRecordRes.Result.DetailListBean p : choice) {
                        p.setProQty(Arith.mul(Math.abs(p.getProQty()), -1));//把数量转为负数
                        //  退货计算
                        if (!Cpbill002DbOperate.isDecimalById(p.getProCode())) {//原来写的是SystemHelper.isWgmf(p.brand)
                            p.setProAmount(Arith.mul(p.getProPrice(), p.getProQty()));
                        } else {
                            p.setProAmount(Arith.mul(Math.abs(p.getProAmount()), -1));
                        }
                        //折扣产品价格
                        if (p.getProCode().equals("9.8888")){
                            diffPrice = Arith.add(diffPrice, p.getProAmount());//diffPrice一般是负数，而且其实一般只有一个，但以防万一，还是做一个累加。
                        }
                        amount = Arith.add(p.getProAmount(), amount);
                    }
                    Date date = new Date();
                    XiaoShouEntity ent = new XiaoShouEntity();
                    ent.setSaleBill(bill.getSaleBill());
                    ent.setBillNo(Djxs001DbOperate.GetTodayXiaoShouNo() + 1);
                    ent.setStoreId(bill.getStoreNo());
                    //退货订单的生成日期设为营养顾问选择的退货日期，而不是当天操作日期（info[1]就是选择的退货日期）
                    ent.setBill(ent.getStoreId() + SystemHelper.LoginUserId +
                            info[1].substring(2).replace("-", "") + DateUtil.format(date, "HHmmss")/* DateUtil.format(date, "yyMMddHHmmss")*/);
                    ent.setMDBC(TextUtils.isEmpty(bill.getStoreShift()) ? SystemHelper.LoginBC : bill.getStoreShift());
                    String saleDateString = info[1] + " " + DateUtil.getTime2(date);//退货以前是退到SaleDate上，而现在要退到退货日期上，所以要把退货日期值传到SaleDate

                    Date date2 = DateUtil.String2Date(saleDateString, "yyyy-MM-dd HH:mm:ss");//退货时间
                    ent.setSaleDate(DateUtil.format(date2, "yyyy-MM-dd HH:mm:ss"));
                    ent.setSaleTime(DateUtil.getTime(date));
                    ent.setSKTNET(amount);//实际金额【老备注：收款金额】diffPrice一般为负数。
                    ent.setSkyId(TextUtils.isEmpty(bill.getSaleUserNo()) ? SystemHelper.LoginUserId : bill.getSaleUserNo());
                    ent.setTLine(choice.size());
                    ent.setTNET(Arith.sub(amount, diffPrice));//销售金额 【老备注：实销金额】,前面把diffPrice加起来了，这里减回去以还原价格
                    ent.setXSTYPE("2"); // 退货
                    ent.setDYBillNo(bill.getBillNo());
                    ent.setDYSaleDate(bill.getSaleDate().split(" ")[0]);//退货对应销售日期(eg.2017-3-24 0:00:00)
                    if (bill.getSaleDate().length() > 10) {
                        ent.setDYSaleTime(bill.getSaleDate().split(" ")[1]);//退货对应销售时间
                    } else {
                        ent.setDYSaleTime("0:00:00");
                    }
                    ent.setCUSTID(bill.getSalePhone());//会员ID
                    List<HuiYuanTag> tag = new ArrayList<HuiYuanTag>();
                    HuiYuanTag t = new HuiYuanTag();
                    t.setAGE("");
                    t.setREASON("");
                    tag.add(t);
                    ent.setTag(tag);
                    ent.setPromid(bill.getPromid());//活动ID
                    ent.setExchangecode(bill.getExchangecode());//验证码
                    ent.setOrdertype(bill.getOrderType());//订单类别,0正常下单，1补录，2微商城，3到家业务 ,

                    ent.setProductDetails(detailListBeans2ProductEntitys(choice).toArray(new ProductEntity[]{}));
                    //现在不需要经过本地数据库了
//                    Djxs001DbOperate.SaveXiaoShouUped(ent);
//                    Djxs002DbOperate.SaveXiaoShouDetail(ent, detailListBeans2ProductEntitys(choice));
                    submit.setEnabled(false);
                    new UploadTuiHuoTask(storeManagerCancelDetail.this, "正在上传退货", true, ent).execute("");
                }
            });
        }
    }

    /**
     * 把DetailListBean转换成ProductEntity，转换后用于存入数据库。。唉。。。
     *
     * @return
     */
    private List<ProductEntity> detailListBeans2ProductEntitys(List<GoodsReturnRecordRes.Result.DetailListBean> beans) {
        List<ProductEntity> entitys = new ArrayList<>();
        for (GoodsReturnRecordRes.Result.DetailListBean bean : beans) {
            ProductEntity entity = new ProductEntity();
            entity.setItemName(bean.getProName());
            entity.setItemId(bean.getProCode());
            entity.setBarcode(bean.getProCode());
            entity.setTQTY(bean.getProQty());
            entity.setPrice(bean.getProPrice());
            entity.setAmount(bean.getProAmount());
            entity.setKCUom(bean.KCUom);
            entitys.add(entity);
        }
        return entitys;
    }

    public void showSubmit(boolean isShow) {
        if (isShow) {
            submit.setVisibility(View.VISIBLE);
        } else {
            submit.setVisibility(View.GONE);
        }
    }
}
