package com.urovo.activity.goodsmanager;

import android.app.DatePickerDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager.LayoutParams;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.urovo.activity.common.StoreSelectorActivity;
import com.urovo.wgmf.adapter.ZengSongQueryAdapter;
import com.urovo.wgmf.db.dao.entitys.QueryEntity;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wgmf.entity.response.ZengSongQueryResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DialogHelper;
import com.urovo.wugumofang.ui.ViewUtil;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import okhttp3.Request;

/**
 * 贈送查询
 *
 * @author Administrator
 */
public class GiftGoodsActivity extends BaseActivity {

    private LinearLayout storeSelector;
    private TextView storequire;
    private TextView texttitle;
    private TextView giftnum;
    private TextView giftdatefrom;
    private TextView giftdateto;
    private TextView store;
    private String storeid;
    private String beginTime, endTime;
    private TextView resaulttext;
    private ListView resaultlist;
    private View showColor;
    private PopupWindow pw;
    private boolean hasQuery = false;
    private TextView noDataText;
    private LinearLayout noNetLayout;
    ZengSongQueryAdapter adapter;
    List<ZengSongQueryResponse.Bean> queryList = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.normal2_quire_resault);
        initTitle();
        init();
    }

    private void init() {
        titleTextView.setText("赠送查询");
        resaulttext = (TextView) findViewById(R.id.result_tv);
        resaultlist = (ListView) findViewById(R.id.listview_quire_resault);
        noDataText = (TextView) findViewById(R.id.no_data_text);
        noNetLayout = (LinearLayout) findViewById(R.id.no_net_layout);
        adapter = new ZengSongQueryAdapter(this,queryList);
        resaultlist.setAdapter(adapter);
    }

    private void showPopWindow() {

        if (pw == null) {
            View v2 = getLayoutInflater().inflate(R.layout.giftgoods_quire, null);
            initWindow(v2);
            pw = new PopupWindow(v2, LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT, false);
            pw.setFocusable(false);
            pw.setBackgroundDrawable(new BitmapDrawable());
            pw.setOutsideTouchable(false);
            showColor.setOnClickListener(new OnClickListener() {

                @Override
                public void onClick(View v) {

                    if (!hasQuery) {
                        return;
                    }
                    if (pw != null && pw.isShowing()) {
                        pw.dismiss();
                    }
                }
            });
        } else {
            showColor.setBackgroundColor(GiftGoodsActivity.this.getResources().getColor(R.color.result_view));
        }
        pw.showAsDropDown(titleTextView);
    }

    private void initWindow(View v) {
        storeid = null;
        if (SystemHelper.IsAdmin) {
            storeSelector = (LinearLayout) v.findViewById(R.id.storeSelector);
            storeSelector.setVisibility(View.VISIBLE);
            store = (TextView) v.findViewById(R.id.sotre_selector);
        } else {
            storequire = (TextView) v.findViewById(R.id.ordergoods_quire);
            storequire.setText("查询门店:" + SystemHelper.LoginOrganName);
            storeid = SystemHelper.LoginOrganId;
        }
        giftnum = (TextView) v.findViewById(R.id.gift_num);
        giftdatefrom = (TextView) v.findViewById(R.id.gift_date_from);
        giftdateto = (TextView) v.findViewById(R.id.gift_date_to);
        String date = DateUtil.getDate(new Date());
        beginTime = date;
        endTime = date;
        giftdatefrom.setText(beginTime);
        giftdateto.setText(endTime);
        showColor = v.findViewById(R.id.out_view);
    }

    public void giftQuire(View view) {
        query();
    }

    private void query() {
        HashMap<String,String> param = new HashMap<>();
        param.put("storeNo",SystemHelper.LoginOrganId);
        param.put("beginYMD",beginTime);
        param.put("endYMD",endTime);
        ViewUtil.showProgress(this,"请稍等","正在查询赠送数据...");
        resaulttext.setText(SystemHelper.LoginOrganName + "," + beginTime + "至" + endTime);
        resaultlist.setVisibility(View.GONE);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.STORE_PRESENT_QUERY, param,
                new OkHttpDominator.ResultCallback<ZengSongQueryResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        showMsg("网络异常，查询失败");
                    }

                    @Override
                    public void onResponse(ZengSongQueryResponse res) {
                        ViewUtil.dismissProgress();
                        if(res == null){
                            showMsg("后台返回null");
                            return;
                        }
                        if(res.msgCode != 0){
                            showMsg(res.msgInfo);
                            return;
                        }
                        resaultlist.setVisibility(View.VISIBLE);
                        if (pw != null && pw.isShowing()) {
                            pw.dismiss();
                        }
                        queryList.clear();
                        queryList.addAll(res.getList());
                        adapter.notifyDataSetChanged();
                    }
                });
//        new QueryZengSongTask(GiftGoodsActivity.this, "正在查询赠送数据...", true, sql).execute("");
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {

//        super.displayResult(tag, response);
//        if (QueryZengSongTask.TAG.equals(tag)) {
//            ZengSongQueryResponse res = (ZengSongQueryResponse) response;
//            List<ZengSongEntity> list = res.getList();
//            String num = giftnum.getText().toString().trim();
//            List<QueryEntity> arrayList = new ArrayList<QueryEntity>();
//            if (list != null && list.size() > 0) {
//                for (ZengSongEntity ent : list) {
//                    ProductEntity[] productDetails = ent.getProductDetails();
//                    for (ProductEntity p : productDetails) {
//                        if (!DalCommon.CanEditAmount(p.getItemId())) {
//                            p.setAmount(Arith.mul(p.getPrice(), p.getTQTY()));
//                        } else {
//                            p.setAmount(p.getPrice());
//                        }
//                        if (!TextUtils.isEmpty(num)) {
//                            if (num.equals(p.getItemId())) {
//                                Item001DbOperate.GetProductDetail(p);
//                                QueryEntity c = new QueryEntity();
//                                c.ItemId = p.getItemId();
//                                c.ItemName = p.getItemName();
//                                c.KCUom = p.getKCUom();
//                                c.TQTY = StringUtils.formatDouble(p.getTQTY(), "0");
//                                c.Price = StringUtils.formatDouble(p.getPrice(), "0.00");
//                                c.Amount = StringUtils.formatDouble(p.getAmount(), "0.00");
//                                c.WDate = ent.getWDate();
//                                c.Bill = ent.getBill();
//                                c.Lr_Name = ent.getLr_Name();
//                                c.CPhone = ent.getCPhone();
//                                arrayList.add(c);
//                            }
//                        } else {
//                            Item001DbOperate.GetProductDetail(p);
//                            QueryEntity c = new QueryEntity();
//                            c.ItemId = p.getItemId();
//                            c.ItemName = p.getItemName();
//                            c.KCUom = p.getKCUom();
//                            c.TQTY = StringUtils.formatDouble(p.getTQTY(), "0");
//                            c.Price = StringUtils.formatDouble(p.getPrice(), "0.00");
//                            c.Amount = StringUtils.formatDouble(p.getAmount(), "0.00");
//                            c.WDate = ent.getWDate();
//                            c.Bill = ent.getBill();
//                            c.Lr_Name = ent.getLr_Name();
//                            c.CPhone = ent.getCPhone();
//                            arrayList.add(c);
//                        }
//                    }
//                }
//            }
//            toSecondView(arrayList);
//        }
    }

    private void toSecondView(List<QueryEntity> newList) {
//        hasQuery = true;
//        if (pw != null && pw.isShowing()) {
//            pw.dismiss();
//        }
//        String storeString;
//        if (SystemHelper.IsAdmin) {
//            storeString = store.getText().toString();
//        } else {
//            storeString = SystemHelper.LoginOrganName;
//        }
//        resaulttext.setText(storeString + "," + beginTime + "至" + endTime);
//        if (newList == null || newList.size() == 0) {
//            showDataType(1);
//            showMsg("无赠送数据");
//        } else {
//            showDataType(0);
//        }
//        ZengSongQueryAdapter adapter = new ZengSongQueryAdapter(newList, GiftGoodsActivity.this);
//        resaultlist.setAdapter(adapter);
    }

	/*
     * public void giftDatePick(View view) { View contentView =
	 * LayoutInflater.from(this).inflate(R.layout.ordergoods_quire, null); new
	 * SelectDatePop(this, new onDateSelectedListener() {
	 * 
	 * @Override public void onDateSelect(String startDay, String endDay) {
	 * 
	 * giftdatefrom.setText(startDay); beginTime = startDay;
	 * giftdateto.setText(endDay); endTime = endDay; }
	 * }).showWindow(contentView); }
	 */

    public void orderDatePickFrom(View view) {
        Calendar c = Calendar.getInstance();
        new DatePickerDialog(this, new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                giftdatefrom.setText(String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth));
                beginTime = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
            }
        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show();
    }

    public void orderDatePickTo(View view) {
        Calendar c = Calendar.getInstance();
        new DatePickerDialog(this, new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                giftdateto.setText(String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth));
                endTime = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
            }
        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show();
    }

    public void storeSelector(View view) {
        Intent intent = new Intent(GiftGoodsActivity.this, StoreSelectorActivity.class);
        intent.putExtra("store", "ALL");
        startActivityForResult(intent, 200);
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);
        switch (resultCode) {
            case StoreSelectorActivity.RESULTCODE:
                ShopEntity shopEntity = (ShopEntity) data.getSerializableExtra("store");
                if (shopEntity != null) {
                    store.setText(shopEntity.getShopName());
                    storeid = shopEntity.getShopId();
                }
                break;
            default:
                break;
        }
    }

    public void giftNumPick(View view) {
        View editView = getLayoutInflater().inflate(R.layout.edittext_diy, null);
        final EditText editText = (EditText) editView.findViewById(R.id.edit);
        DialogHelper.Alert2(this, "请输入产品编号", null, editView, new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {

                giftnum.setText(editText.getText().toString());
            }
        });
    }

    public void reQuire(View view) {
        showPopWindow();
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {

        super.onWindowFocusChanged(hasFocus);
        if (pw == null) {
            showPopWindow();
        }
    }

    private void showDataType(int type) {

        switch (type) {
            case 0:
                noDataText.setVisibility(View.INVISIBLE);
                noNetLayout.setVisibility(View.INVISIBLE);
                break;
            case 1:
                noDataText.setVisibility(View.VISIBLE);
                noNetLayout.setVisibility(View.INVISIBLE);
                break;
            case 2:
                noNetLayout.setVisibility(View.VISIBLE);
                break;
            default:
                break;
        }
    }

    public void againLoadData(View v) {

        query();
    }

    @Override
    public void displayNoNet(String tag) {

        super.displayNoNet(tag);
//        if (QueryZengSongTask.TAG.equals(tag)) {
//            if (pw != null && pw.isShowing()) {
//                pw.dismiss();
//            }
//            showDataType(2);
//            hasQuery = true;
//            String storeString;
//            if (SystemHelper.IsAdmin) {
//                storeString = store.getText().toString();
//            } else {
//                storeString = SystemHelper.LoginOrganName;
//            }
//            resaulttext.setText(storeString + "," + beginTime + "至" + endTime);
//        }
    }
}
