package com.urovo.activity.goodsmanager;

import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;

import com.urovo.activity.checkGoodsTabAct.view.CheckGoodsTabMenu;
import com.urovo.activity.goodsmanager.stocksearch.StockSearchActivity;
import com.urovo.activity.receiveGoodsTabMenu.view.ReceiveGoodsTabMenu;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.ToActivity;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * 货品管理菜单
 *
 * @author Administrator
 * <p>
 * 门店订货/查询 配送收货/查询 存货盘点/查询 调拔查询 库存查询 报损查询 赠送查询
 */
public class GoodsManagerMenu extends BaseActivity {
    private ListView listview;
    private TextView texttitle;

    private String[] mFunctionName = {"门店订货/查询", "配送收货/查询", "存货盘点/查询", "调拨查询", "库存查询", "产品出入库查询", "报损查询", "赠送查询"};
    private ArrayList<HashMap<String, Object>> listArrayList;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.staff_menu);
        init();
        initTitle();
    }

    private void init() {

        texttitle = (TextView) findViewById(R.id.text_title);
        assert texttitle != null;
        texttitle.setText("货品管理");
        listview = (ListView) findViewById(R.id.listview);
        listArrayList = new ArrayList<>();
        for (String aMFunctionName : mFunctionName) {
            HashMap<String, Object> hashMap = new HashMap<>(1);
            hashMap.put("text", aMFunctionName);
            listArrayList.add(hashMap);
        }

        SimpleAdapter simpleAdapter = new SimpleAdapter(this, listArrayList, R.layout.second_menu_item, new String[]{"text"}, new int[]{R.id.ItemText});
        listview.setAdapter(simpleAdapter);
        listview.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                click(position);
            }
        });

    }

    public void click(int position) {
        switch (position) {
            case 0:
                ToActivity.toActivity(this, OrderGoodsTabAct.class);
                break;
            case 1:
                ToActivity.toActivity(this, ReceiveGoodsTabMenu.class);
                break;
            case 2:
                ToActivity.toActivity(this, CheckGoodsTabMenu.class);
                break;
            case 3:
                ToActivity.toActivity(this, TransferQueryActivity.class);
                break;
            case 4:
                ToActivity.toActivity(this, StockSearchActivity.class);
                break;
            case 5:
                ToActivity.toActivity(this, GoodsInOutStockAct.class);
                break;
            case 6:
                ToActivity.toActivity(this, ReimburseGoodsActivity.class);
                break;
            case 7:
                ToActivity.toActivity(this, GiftGoodsActivity.class);
                break;

            default:
                break;
        }

    }

}
