package com.urovo.activity.goodsmanager;

import android.graphics.Rect;
import android.util.DisplayMetrics;
import android.view.View;
import android.view.ViewTreeObserver;

import com.urovo.wugumofang.ui.SetFocusUtil;

/**
 * Created by Sasuke on 2016/4/12.
 * 通过计算高度差判断键盘是否收起，若收起，则把焦点放到rootView根布局上（转移焦点，激发焦点处理事件）
 */
public class OnKeyboardDownListener implements ViewTreeObserver.OnGlobalLayoutListener{
    View rootView;
    public OnKeyboardDownListener(View rootView) {
        this.rootView = rootView;
    }

    @Override
    public void onGlobalLayout() {
        final int softKeyboardHeight = 100;
        Rect r = new Rect();
        rootView.getWindowVisibleDisplayFrame(r);
        DisplayMetrics dm = rootView.getResources().getDisplayMetrics();
        int heightDiff = rootView.getBottom() - r.bottom;
        if(heightDiff <= softKeyboardHeight * dm.density){//如果为true则键盘收起
            SetFocusUtil.focus(rootView);
        };
    }
}
