package com.urovo.activity.goodsmanager

import android.annotation.SuppressLint
import android.app.AlertDialog
import android.content.DialogInterface
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.widget.*
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import androidx.viewpager.widget.ViewPager
import com.urovo.activity.addsellactivity.ui.AutoRadioGroup
import com.urovo.activity.goodsmanager.adapter.OrderGoodsTradeAdapter
import com.urovo.activity.goodsmanager.model.OrderCommonEntity
import com.urovo.wgmf.adapter.MyPagerAdapter
import com.urovo.wgmf.db.dao.entitys.DingHuoOplQtyEntity
import com.urovo.activity.goodsmanager.model.OrderDeliveryDifferenceQueryEntity
import com.urovo.activity.goodsmanager.model.OrderGoodsQueryEntity
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivityTap
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.data.Arith
import com.urovo.wugumofang.data.StringUtils
import com.urovo.wugumofang.net.NetHelper
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.DialogHelper
import com.urovo.wugumofang.ui.ViewUtil
import com.urovo.wugumofang.utils.isNotNullOrSize
import com.urovo.wugumofang.view.DividerUniteItemDecoration
import com.urovo.wugumofang.view.LoadWaitDominator
import com.urovo.wugumofang.view.dialog.PublicContainerDataDialog
import com.urovo.wugumofang.view.indexBar.IndexbarConfig
import com.wgmf.trade.model.bean.OrderSubmitReqBean
import com.wgmf.trade.presenter.OrderGoodPre
import com.wgmf.trade.view.OrderGoodCon
import kotlinx.android.synthetic.main.activity_order_goods_submit.*
import kotlinx.android.synthetic.main.activity_phone_query.*
import java.util.*
import kotlin.collections.ArrayList


/**
 * @author Sasuke on 2019/4/5.
 */
class OrderGoodsSubmitActivity : BaseActivityTap(), OrderGoodCon.View {
    private var mOrderGoodPre: OrderGoodPre? = null
    private var mLoadWaitDominator: LoadWaitDominator? = null

    private var mBrandRadioGroup: AutoRadioGroup? = null
    private var mLabelRadioGroupList: MutableList<AutoRadioGroup> = mutableListOf()
    private var mViewPagerList: MutableList<View> = mutableListOf()

    private var mOrderCommonList: MutableList<OrderCommonEntity> = mutableListOf()

    private var mResultInfoCache: DingHuoOplQtyEntity.ResultInfo? = null

    private var mPublicTabContentContainerLl: LinearLayout? = null
    private var mPublicTabContentTv: TextView? = null

    companion object {
        const val WGMF_BRAND_ID = 8
        const val XDY_BRAND_ID = 15
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_order_goods_submit)
        mOrderGoodPre = OrderGoodPre(this)
        init()
    }

    private fun init() {
        mPublicTabContentContainerLl =
            order_goods_submit_title_view.findViewById(R.id.public_tab_content_container_ll)
        mPublicTabContentTv =
            order_goods_submit_title_view.findViewById(R.id.public_tab_content_tv)
        mPublicTabContentTv?.text =
            getString(R.string.order_goods_submit)
        order_goods_submit_title_view.findViewById<ImageButton>(R.id.public_tab_back_ib)
            .setOnClickListener {
                finish()
            }
        order_goods_submit_title_view.findViewById<TextView>(R.id.public_tab_tip_tv).apply {
            text = getString(R.string.order_goods_submit_shared_materials)
            visibility = View.VISIBLE

            val drawableStart =
                ContextCompat.getDrawable(mContext, R.drawable.tip)
            setCompoundDrawablesWithIntrinsicBounds(drawableStart, null, null, null)
            setOnClickListener {
                showSharedMaterialsDialog()
            }
        }

        mPublicTabContentContainerLl?.let {
            mBrandRadioGroup =
                AutoRadioGroup(it)
        }

        mLoadWaitDominator = LoadWaitDominator(this, order_goods_submit_content_fl)

        mOrderGoodPre?.apply {
            val storeId = SystemHelper.LoginOrganId
            getOrderCommonList(storeId)
            isCanOrdering(storeId, SystemHelper.LoginUserId, false)
        }
        order_goods_submit_btn.setOnClickListener { checkBeforeSubmit() }
    }

    /**
     * 公共物料弹窗
     */
    private fun showSharedMaterialsDialog() {
        val builder = PublicContainerDataDialog.Companion.Builder(mContext)
        builder.setTitle(R.string.hint)
        builder.setMessage(R.string.order_goods_submit_shared_materials_tip)
        builder.isDataEntry(mOrderCommonList.size <= 0)
        builder.setDialogInitContainerDataListener(object :
            PublicContainerDataDialog.OnDialogInitContainerDataListener {
            override fun onContainerData(
                dialog: PublicContainerDataDialog,
                container: FrameLayout
            ) {
                addViewToSharedMaterials(container)
            }
        })
        builder.setNegativeButton(
            R.string.ok_btn_txt,
            DialogInterface.OnClickListener { dialog, which -> dialog.dismiss() })
        if (!this.isFinishing) {
            builder.create().show()
        }
    }

    private fun addViewToSharedMaterials(container: FrameLayout) {
        if (container.childCount > 0) container.removeAllViews()

        container.apply {
            if (mOrderCommonList.isNotNullOrSize()) {
                val groupView = LayoutInflater.from(mContext)
                    .inflate(R.layout.item_shared_materials_group, container, false)
                val groupContainer =
                    groupView.findViewById<LinearLayout>(R.id.shared_materials_group_container_ll)

                mOrderCommonList.forEach { item ->
                    val childView = LayoutInflater.from(mContext)
                        .inflate(R.layout.item_shared_materials_child, groupContainer, false)
                    childView.findViewById<TextView>(R.id.shared_materials_child_num_tv).text =
                        item.syOplQty
                    val childContainer =
                        childView.findViewById<LinearLayout>(R.id.shared_materials_child_container_ll)
                    item.productList?.forEach { product ->
                        val itemView = LayoutInflater.from(mContext)
                            .inflate(R.layout.item_shared_materials_item, childContainer, false)
                        itemView.findViewById<TextView>(R.id.shared_materials_child_code_tv).text =
                            product.proCode
                        itemView.findViewById<TextView>(R.id.shared_materials_child_name_tv).text =
                            product.proName
                        childContainer.addView(itemView)
                    }
                    groupContainer.addView(childView)
                }
                addView(groupView)
            }
        }
    }

    @SuppressLint("InflateParams")
    fun refreshUI(resultInfo: DingHuoOplQtyEntity.ResultInfo?) {
        if (resultInfo == null) {
            showState(LoadWaitDominator.NO_DATA)
        }
        //先存一份
        if (resultInfo?.list == null) return

        resultInfo.list.forEach {
            it.fixedSyOplQty = it.syOplQty
        }
        mResultInfoCache = resultInfo

        //初始化最顶栏
        resultInfo.brandPage?.let {
            if (it.size == 1) {
                //品牌大标签 只有一个品牌的情况
                mPublicTabContentTv?.apply {
                    text = it[0]?.title
                    visibility = View.VISIBLE
                }
                mPublicTabContentContainerLl?.visibility =
                    View.GONE
            } else {
                mPublicTabContentTv?.visibility =
                    View.GONE
                mPublicTabContentContainerLl?.visibility =
                    View.VISIBLE
            }
        }

        //先清一下（其实如果只走一遍好像也无所谓
        mBrandRadioGroup?.removeAllChild()
        mLabelRadioGroupList.forEach { it.removeAllChild() }
        order_goods_submit_view_pager.removeAllViews()
        mViewPagerList.clear()
        //初始化顶部品牌标签+内容页（循环）
        resultInfo.brandPage?.forEach { brandItem ->
            //品牌大标签显示
            val radio: RadioButton = (layoutInflater.inflate(
                R.layout.tap_title_radio_new_btn,
                mPublicTabContentContainerLl,
                false
            ) as RadioButton)
            mBrandRadioGroup?.addViewWithLayoutParams(
                view = radio, text = brandItem.title, paramWith = 0,
                paramheight = RadioGroup.LayoutParams.MATCH_PARENT
            ) { pos -> order_goods_submit_view_pager.currentItem = pos }
            //数据内容页显示
            mViewPagerList.add(LayoutInflater.from(this).inflate(R.layout.ordergoods, null).apply {
                findViewById<TextView>(R.id.tvStore).apply {
                    text = "订货门店: ${SystemHelper.LoginOrganName}"
                }

                // val dataList = mutableListOf<DingHuoOplQtyEntity.DinghuoDetail>().apply { addAll(resultInfo.list.filter { it.brandId == brandItem.type }) }
                //分类标签(只有 五谷磨房 才有小分类)
                val labelGroup = findViewById<LinearLayout>(R.id.labelGroup)
                val labelRadioGroup = AutoRadioGroup(labelGroup)
                if (brandItem.type == WGMF_BRAND_ID) {
                    //加一个“全部”标签（无论什么品牌都要加）
                    val radioButton =
                        layoutInflater.inflate(R.layout.add_sell_radio_button, null) as RadioButton
                    labelRadioGroup.addView(view = radioButton, text = "全部") {
                        refreshItemTitle(null)
                        refreshRvByLabel(brandItem.type, -1)
                    }
                    resultInfo.col.forEach { colItem ->
                        val radioButton = layoutInflater.inflate(
                            R.layout.add_sell_radio_button,
                            null
                        ) as RadioButton
                        labelRadioGroup.addView(view = radioButton, text = colItem.title) { pos ->
                            refreshItemTitle(colItem)
                            refreshRvByLabel(brandItem.type, colItem.type)//各标签的点击监听。
                        }
                    }
                    labelGroup.visibility = View.VISIBLE
                } else {
                    //加一个“全部”标签（无论什么品牌都要加）
                    val radioButton =
                        layoutInflater.inflate(R.layout.add_sell_radio_button, null) as RadioButton
                    labelRadioGroup.addView(view = radioButton, text = "全部") {
                        refreshItemTitle(null)
                        refreshRvByLabel(brandItem.type, 0)
                    }
                    labelGroup.visibility = View.INVISIBLE
                }

                mLabelRadioGroupList.add(labelRadioGroup)

                if (resultInfo.col.isNotEmpty()) {
                    refreshItemTitle(resultInfo.col[0])
                } else {
                    refreshItemTitle(null)
                }
                //列表
                findViewById<RecyclerView>(R.id.proLv).apply {
                    layoutManager = LinearLayoutManager(this@OrderGoodsSubmitActivity)
                    addItemDecoration(
                        DividerUniteItemDecoration(
                            this@OrderGoodsSubmitActivity,
                            DividerUniteItemDecoration.HORIZONTAL_LIST, 12, ContextCompat.getColor(
                                this@OrderGoodsSubmitActivity, R.color.color_common_devider_line_one
                            )
                        )
                    )
                    adapter = OrderGoodsTradeAdapter(
                        this@OrderGoodsSubmitActivity,
                        listOf()
                    ) { refreshPriceShow() }
                }
            })
        }

        order_goods_submit_view_pager.adapter = MyPagerAdapter(this, ArrayList(mViewPagerList))
        order_goods_submit_view_pager.currentItem = 0
        order_goods_submit_view_pager.addOnPageChangeListener(
            object : ViewPager.OnPageChangeListener {
                override fun onPageScrollStateChanged(p0: Int) {}
                override fun onPageScrolled(p0: Int, p1: Float, p2: Int) {}
                override fun onPageSelected(pos: Int) {
                    mBrandRadioGroup?.setChildChecked(pos)
                }
            })
        mBrandRadioGroup?.setChildChecked(0)
        mLabelRadioGroupList.forEach { it.setChildChecked(0) }//要放在最后check，因为前面构造的时候，还没有添加到pager里面，直接check会崩。
        //每个pager都先定位到第一个分类
        //refreshRvByLabel(resultInfo.brandPage[0].type, if (brandItem.type != WGMF_BRAND_ID) -1 else resultInfo?.col[0].type)

        showSharedMaterialsDialog()
    }

    private fun View.refreshItemTitle(label: DingHuoOplQtyEntity.Label?) {
        var titleList = Arrays.asList(*resources.getStringArray(R.array.goods_order_default_title))
        if (label?.type == AppConstants.PackType.ACCESSORIES_SUPPLIERS) {
            titleList = Arrays.asList(*resources.getStringArray(R.array.goods_order_other_title))
        }
        findViewById<TextView>(R.id.tvName).apply {
            text = titleList[0]
        }
        findViewById<TextView>(R.id.tvKucun).apply {
            text = titleList[1]
        }
        findViewById<TextView>(R.id.tvQuantity).apply {
            text = titleList[2]
        }
        findViewById<TextView>(R.id.tvQty).apply {
            text = titleList[3]
        }
        findViewById<TextView>(R.id.tvCyl).apply {
            text = titleList[4]
        }
    }

    /**
     * 根据上面的标签分类来过滤显示对应的列表
     */
    private fun refreshRvByLabel(brand: Int, type: Int) {
        val currentPager =
            mViewPagerList.get(mResultInfoCache?.brandPage?.indexOfFirst { it.type == brand }
                ?: 0)
        val currRv = currentPager.findViewById<RecyclerView>(R.id.proLv)
        val adapter = currRv.adapter as OrderGoodsTradeAdapter
        adapter.notifyProByLabel(mResultInfoCache, brand, type)

        val indexbarConfig = IndexbarConfig(
            this,
            currentPager.findViewById(R.id.product_index_bar),
            currentPager.findViewById(R.id.tvSideBarHint),
            currRv,
            adapter.orderList
        ).configDefault()
        //        indexbarConfig.setCustomComparator(new OrderGoodsComparator());
        indexbarConfig.toggleShowIndexBar(false)//-1表示“全部”标签 type == -1

        refreshPriceShow()
        // listviewChange()
    }

    /**
     * 刷新价格显示
     */
    private fun refreshPriceShow() {
        var invalidCount = 0
        var count = 0.0
        var countPrice = 0.0

        mResultInfoCache?.list?.forEach {
            if (it.isInvalid) invalidCount++
            count = Arith.add(count, it.tqty)
            countPrice = Arith.add(countPrice, it.amount)
        }
        order_goods_submit_total_num_tv.text = StringUtils.formatDouble(count, "0.00")
        order_goods_submit_total_amount_tv.text = StringUtils.formatDouble(countPrice, "0.00")
        if (invalidCount > 0) {
            order_goods_submit_btn.isEnabled = false
            order_goods_submit_btn.text = "您有 ${invalidCount} 条信息输入不合格,请重输！"
        } else {
            if (!order_goods_submit_btn.isEnabled) {
                order_goods_submit_btn.isEnabled = true
                order_goods_submit_btn.text = "提交"
            }
        }
    }

    override fun showOrderGoodsDetail(list: MutableList<OrderGoodsQueryEntity>?) {

    }

    override fun showOrderCommon(list: MutableList<OrderCommonEntity>?) {
        list?.let {
            this.mOrderCommonList = it
            //if (list.isNotNullOrSize()) {
            //    showSharedMaterialsDialog()
            //}
        }
    }

    override fun showOrderGoodsDiff(list: MutableList<OrderDeliveryDifferenceQueryEntity>?) {

    }

    /**
     * 请求是否能订货之后的回调
     */
    override fun showCanOrdering(msgCode: Int, msgInfo: String?, isSubmitOrder: Boolean) {
        if (isSubmitOrder) {
            if (msgCode >= 0) {
                order_goods_submit_btn.isEnabled = false
                ViewUtil.showProgress(this, "请稍等", "正在提交订货数据...")
                mOrderGoodPre?.orderSubmit(packedSubmitData())
            } else {
                // Toast.makeText(LibCoreApp.getInstance(), msgInfo, Toast.LENGTH_SHORT).show()
                DialogHelper.Alert(
                    this@OrderGoodsSubmitActivity,
                    "提示",
                    msgInfo,
                    null
                ) { dialog, which ->
                    dialog.dismiss()
                }
            }
        } else {
            if (msgCode > 0) {
                DialogHelper.Alert3R(this@OrderGoodsSubmitActivity, "提示", msgInfo, null,
                    { dialog, which ->
                        dialog.dismiss()
                        mOrderGoodPre?.getOrderList(
                            SystemHelper.LoginOrganId,
                            SystemHelper.LoginUserId,
                            SystemHelper.LoginUserBrandList
                        )
                    }, { dialog, which ->
                        dialog.dismiss()
                        this@OrderGoodsSubmitActivity.finish()
                    })
            } else if (msgCode < 0) {
                order_goods_submit_btn.isEnabled = false
                mLoadWaitDominator?.show("提示:$msgInfo")
            }
        }
    }

    override fun showOrderList(resultInfo: DingHuoOplQtyEntity.ResultInfo?) {
        if (isFinishing || resultInfo?.brandPage == null || resultInfo.brandPage.isEmpty()) return
        refreshUI(resultInfo)
    }

    /**
     * 提交成功
     */
    override fun submitSuccess(msg: String?) {
        if (isFinishing) return
        Toast.makeText(this, msg, Toast.LENGTH_SHORT).show()
        finish()
    }

    override fun submitFailed(msg: String?) {
        if (isFinishing) return
        showMsg(msg)
        order_goods_submit_btn.isEnabled = true
        order_goods_submit_btn.text = "提交"
    }

    /**
     * 提交前的校验
     */
    fun checkBeforeSubmit() {
        val choiceList = mResultInfoCache?.list?.filter { it.tqty > 0 } ?: listOf()
        val choiceWgmfList =
            mResultInfoCache?.list?.filter { it.tqty > 0 && it.brandId == WGMF_BRAND_ID }
                ?: listOf()
        val choiceXdyList =
            mResultInfoCache?.list?.filter { it.tqty > 0 && it.brandId == XDY_BRAND_ID }
                ?: listOf()
//        val listGroup
//                = mResultInfoCache?.list?.filter { it.tqty > 0 }?.groupBy { if ( it.brandId == WGMF_BRAND_ID) "WGMF" else "XDY" }

        if (!OrderGoodsCheckLiuFang.checkNumLimit(choiceList)) {
            AlertDialog.Builder(this)
                .setMessage("六方订货总量必须是6的整数倍，请调整数量后重新提交！")
                .setPositiveButton("我知道了", null)
                .create().show()
            return
        }
        if (choiceList.isEmpty()) {
            showMsg("您没有选择任何订货产品!")
            return
        }
        //订货周期第一次订货中，五谷磨房产品总价2000+才允许订货，如果不存在该类产品，则默认给个2001当作它通过校验
        if ((mResultInfoCache?.firstOrder ?: false)
            && (choiceWgmfList.sumByDouble { it.amount } < mResultInfoCache?.mainBrandLimit ?: 0.0)
            && (choiceXdyList.sumByDouble { it.amount } < mResultInfoCache?.mainBrandLimit ?: 0.0)
        ) {
            AlertDialog.Builder(this)
                .setMessage("本次订货单个品牌的金额必须达到${mResultInfoCache?.mainBrandLimit}元或以上，请调整后再提交！如有疑问，请咨询销管部。")
                .setPositiveButton("我知道了", null)
                .show()
            return
        }

        //真正提交
        val info = "请确认是否提交整单订货！"
        val builder = AlertDialog.Builder(this)
        builder.setTitle("重要提示").setMessage(info)
            .setNegativeButton("提交", DialogInterface.OnClickListener { dialog, which ->
                if (!NetHelper.IsHaveInternet(this@OrderGoodsSubmitActivity)) {
                    showMsg("当前为离线模式，无法订货！")
                    return@OnClickListener
                }
                order_goods_submit_btn.isEnabled = false
                mOrderGoodPre?.isCanOrdering(
                    SystemHelper.LoginOrganId,
                    SystemHelper.LoginUserId,
                    true
                )
            }).setPositiveButton("取消") { dialog, which -> order_goods_submit_btn.isEnabled = true }
            .create()
            .show()
    }


    /**
     * 组装提交的数据
     */
    private fun packedSubmitData(): OrderSubmitReqBean {
        val date = Date()
        //    orderSubmitReqBean.setBillCode(SystemHelper.LoginOrganId + DateUtil.format(date, "yyMMddHHmmss"));
        /*新订单号规则：门店编号+顾问ID+时间戳到秒+2位随机数，例如：0110074+75598659+170301092423+12；
    顾问ID长度最多为8位，不够的前面补0；*/
        val orderSubmitReqBean = OrderSubmitReqBean().apply {
            billCode = SystemHelper.makeBillCode()
            storeNo = SystemHelper.LoginOrganId
            staffNo = SystemHelper.LoginUserId
            setBrands(SystemHelper.LoginUserBrandList)
            setFirstOrder(mResultInfoCache?.firstOrder ?: false)
        }

        val detailBeans = ArrayList<OrderSubmitReqBean.DetailsBean>()
        mResultInfoCache?.list?.filter { it.tqty > 0 }?.forEach { choice ->
            detailBeans.add(
                OrderSubmitReqBean.DetailsBean().apply {
                    proAmount = choice.getAmount().toString()
                    proBoxQty = choice.getBox_qty().toString()
                    proCode = choice.itemid
                    proDHQty = choice.getTQTY().toString()
                    proId = choice.oe_pro_id
                    proLastMonthQty = choice.lastMonth_qty
                    proMaxQty = choice.max_opl_qty.toString()
                    proName = choice.itemName
                    proOplQty = choice.opl_qty
                    proPrice = choice.itemPrice.toString()
                    proSYQty = choice.sy_opl_qty.toString()
                    proStockQty = choice.stock_Qty
                    proUOM = choice.itemUOM
                    proUOMID = choice.itemUOM_id
                    brandId = choice.brandId
                }
            )
        }

        orderSubmitReqBean.details = detailBeans
        return orderSubmitReqBean
    }

    override fun showIsLoading() {
        mLoadWaitDominator?.show(LoadWaitDominator.LOADING)
    }

    override fun showError(errorMsg: String?) {
        mLoadWaitDominator?.show(errorMsg ?: "netError")
    }

    override fun showState(loadWaitState: Int) {
        mLoadWaitDominator?.show(loadWaitState)
    }

    override fun showDismissAll() {
        mLoadWaitDominator?.dismissAll()
    }
}