package com.wgmf.trade.ui.fra.index

import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.urovo.wugumofang.R


class OrderGoodsAdapter(val items: List<Int>?) :
    BaseQuickAdapter<Int, BaseViewHolder>(R.layout.second_menu_item, items) {

    private var mTip: String = ""

    private var mPos: Int = -1

    override fun convert(viewHolder: BaseViewHolder, item: Int?) {
        item?.let {
            viewHolder.setText(R.id.ItemText, it)
            if (mPos == viewHolder.layoutPosition) {
                viewHolder.setText(R.id.ItemTip, mTip)
                viewHolder.setVisible(R.id.ItemTip, true)
            } else {
                viewHolder.setText(R.id.ItemTip, "")
                viewHolder.setVisible(R.id.ItemTip, false)
            }
        }
        viewHolder.setVisible(R.id.dividerView, false)
    }

    /**
     * 提示信息
     */
    fun setTipToPos(tip: String, pos: Int) {
        this.mTip = tip
        this.mPos = pos
        if (items != null && (pos >= 0 && pos < items.size)) {
            notifyItemChanged(pos)
        }
    }
}