package com.urovo.activity.goodsmanager.model

import java.io.Serializable

/**
 *获取门店调拨信息
 * RetInfo«List«AllotmentNew»» {
msgCode (integer, optional): 状态码,状态码等于0说明成功 ,
msgInfo (string, optional): 状态说明 ,
resultInfo (Array[AllotmentNew], optional): 结果集
}AllotmentNew {
allotDate (string, optional): 调拨时间 ,
allotInStore (string, optional): 调入门店名称 ,
allotOutStore (string, optional): 调出门店名称 ,
allotUserName (string, optional): 调拨用户名 ,
allotmentId (integer, optional): 调拨单ID ,
amount (number, optional): 总金额 ,
dbBillCode (string, optional): dbBillCode ,
isCheck (boolean, optional): 是否确认 ,
dbReason(string,optional) 调拨原因，
isSh (boolean, optional): 是否收货 ,
products (Array[Product], optional): 产品列表 ,
shDate (string, optional): 收货日期 ,
shUserName (string, optional): 收货人
}Product {
proAmount (number, optional): 调入金额 ,
proCode (string, optional): 产品编码 ,
proDate (string, optional): 生产日期 ,
proName (string, optional): 产品名字 ,
proPrice (number, optional): 产品单价 ,
proQty (number, optional): 数量 ,
proUnit (string, optional): 产品单位
}
 */
data class StoreAllotEntity(
    val allotDate: String?,
    val allotInStore: String?,
    val allotOutStore: String?,
    val allotUserName: String?,
    val allotmentId: Int,
    val distance: Double,
    val amount: Double,
    val dbBillCode: String?,
    val isCheck: Boolean,
    val isSh: Int,
    val dbReason:String,
    val products: List<ProductBean>?,
    val shDate: String?,
    val shUserName: String?,
    val allotUserCode:String?
) : Serializable {
    data class ProductBean(
        val proAmount: Double,
        val proCode: String?,
        val proDate: String?,
        val proName: String?,
        val proPrice: Double,
        val proQty: Double,
        var editProQty: Double? = null,
        val proIsDecimal: String? = "是",
        val proUnit: String?
    ) : Serializable
}