package com.urovo.activity.goodsmanager.presenter;

import com.urovo.wgmf.CommonController;
import com.urovo.wgmf.db.dao.entitys.StockSearchEntity;
import com.urovo.wgmf.net.CommonNet;
import com.wgmf.trade.model.bean.CommonEntity;

import java.util.Map;

/**
 * 库存查询的pre
 *
 * @author chenji
 */
public class StockSearchPresenter implements CommonController.StockSearchPre<StockSearchEntity> {
    private CommonController.StockSearchView<StockSearchEntity> mStockSearchView;
    private CommonNet mCommonNet;

    public StockSearchPresenter(CommonController.StockSearchView<StockSearchEntity> stockSearchView, CommonNet commonNet) {
        this.mStockSearchView = stockSearchView;
        this.mCommonNet = commonNet;
    }

    @Override
    public void onStart2requestData(Map<String, String> params) {
        mCommonNet.start2requestStockSearch(this, params);
    }

    @Override
    public void onResponseSuccess(CommonEntity<StockSearchEntity> resultInfo) {
        mStockSearchView.onResponseSuccess(resultInfo);
    }

    @Override
    public void onFailure(String failInfo) {
        mStockSearchView.onFailure(failInfo);
    }
}
