package com.urovo.activity.goodsmanager.presenter

import com.urovo.activity.goodsmanager.model.AllotmentNotificationEntity
import com.urovo.activity.goodsmanager.model.StoreAllotEntity
import com.urovo.activity.goodsmanager.model.StoreAllotUpdateEntity
import com.urovo.wugumofang.base.BasePresenter
import com.urovo.wugumofang.base.mvp.AbsView


interface TransferContract {

    interface IView : AbsView {
        /**
         * 获取门店调拨信息(新)
         */
        fun storeAllotNew(data: List<StoreAllotEntity>?) {}
        /**
         * 调拨单弹窗
         */
        fun notificationStoreAllot(data: AllotmentNotificationEntity?) {}
        /**
         * 修改调拨收货
         */
        fun updateStoreAllotStatus(status: Boolean) {}
        /**
         * 门店确认收货状态
         */
        fun confirmStoreAllotStatus(status: Boolean) {}
        /**
         * 门店确认发货状态
         */
        fun checkStoreAllotStatus(status: Boolean) {}
    }

    interface IPresenter : BasePresenter {
        /**
         *  post /storeAllot/getStoreAllotNew 获取门店调拨信息(新)
         */
        fun requestStoreAllotNew(
            storeNo: String?,
            beginDate: String?,
            endDate: String?,
            status: Int
        )

        /**
         * post /storeAllot/notificationStoreAllot 调拨单弹窗
         */
        fun requestNotificationStoreAllot(
            checkUserNo: String?,
            storeNo: String?
        )

        /**
         * post /storeAllot/updateStoreAllot 修改调拨收货
         */
        fun requestUpdateStoreAllot(dbDetails: List<StoreAllotUpdateEntity>)

        /**
         * post  /storeAllot/confirmStoreAllot 门店确认收货
         */
        fun requestConfirmStoreAllot(dbBillCode: String?, storeNo: String?,userNo: String?,reason:String?,type:Int)

        /**
         * post /storeAllot/checkStoreAllot 门店确认发货
         */
        fun requestCheckStoreAllot(dbBillCode: String?, storeNo: String?)
    }
}

