package com.urovo.activity.goodsmanager.service

import com.urovo.activity.goodsmanager.model.AllotmentNotificationEntity
import com.urovo.activity.goodsmanager.model.StoreAllotEntity
import com.urovo.activity.goodsmanager.model.StoreAllotUpdateEntity
import com.urovo.wugumofang.net.RetrofitHelper
import com.zsy.libcore.model.bean.RequestResult
import retrofit2.Call

/**
 *  调拨
 * @author LW
 */
class TransferRepository {

    private val mApiService by lazy {
        RetrofitHelper.createApi(ApiService::class.java)
    }

    /**
     * post /storeAllot/getStoreAllotNew 获取门店调拨信息(新)
     */
    fun requestStoreAllotNew(
        storeNo: String?,
        beginDate: String?,
        endDate: String?,
        status: Int
    ): Call<RequestResult<List<StoreAllotEntity>>> {
        return mApiService.getStoreAllotNew(storeNo, beginDate, endDate, status)
    }

    /**
     * post /storeAllot/notificationStoreAllot 调拨单弹窗
     */
    fun requestNotificationStoreAllot(
        checkUserNo: String?,
        storeNo: String?
    ): Call<RequestResult<AllotmentNotificationEntity>> {
        return mApiService.notificationStoreAllot(checkUserNo, storeNo)
    }

    /**
     * post /storeAllot/updateStoreAllot 修改调拨收货
     */
    fun requestUpdateStoreAllot(
        dbDetails: List<StoreAllotUpdateEntity>
    ): Call<RequestResult<Any>> {
        return mApiService.updateStoreAllot(dbDetails)
    }

    /**
     *post /storeAllot/confirmStoreAllot 门店确认收货
     */
    fun requestConfirmStoreAllot(
        dbBillCode: String?,
        dbId: String?,
        userNo: String?,
        reason: String?,
        type: Int
    ): Call<RequestResult<Any>> {
        return mApiService.confirmStoreAllot(dbBillCode, dbId, userNo, reason, type)
    }

    /**
     *post /storeAllot/checkStoreAllot 门店确认发货
     */
    fun requestCheckStoreAllot(
        dbBillCode: String?,
        storeNo: String?
    ): Call<RequestResult<Any>> {
        return mApiService.checkStoreAllot(dbBillCode, storeNo)
    }
}