package com.urovo.activity.home;

import android.content.Intent;
import android.os.Bundle;
import android.text.InputType;
import android.text.TextUtils;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;

import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;

public class EditPhoneActivity extends BaseActivity {

    private EditText et_detail;
    private Button btn_cancel;
    private Button btn_sure;
    private ImageButton goback;
    private DatePicker dpPicker;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.edit_text);
        et_detail = (EditText) findViewById(R.id.et_detail);
        btn_cancel = (Button) findViewById(R.id.btn_cancel);
        btn_sure = (Button) findViewById(R.id.btn_sure);
        goback = (ImageButton) findViewById(R.id.goback);
        dpPicker = (DatePicker) findViewById(R.id.dpPicker);
        titleTextView = (TextView) findViewById(R.id.text_title);

        initTitleContent();

        dpPicker.setVisibility(View.GONE);
        et_detail.setVisibility(View.VISIBLE);
        et_detail.setInputType(InputType.TYPE_CLASS_NUMBER);

        Intent intent = getIntent();
        String phone = intent.getStringExtra("phone");
        if (!TextUtils.isEmpty(phone)) {
            et_detail.setText(phone);
        }

        btn_cancel.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                finish();
            }
        });

        btn_sure.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                String phone = et_detail.getText().toString();
                if (!TextUtils.isEmpty(phone)) {
                    // 设置返回的数据
                    Intent data = new Intent();
                    data.putExtra("phone", phone);
                    // 当界面关闭时调用这个方法生效
                    setResult(200, data);
                }
                finish();
            }
        });
    }

    private void initTitleContent() {
        titleTextView.setText("编辑信息");
        btn_cancel.setVisibility(View.VISIBLE);
        btn_sure.setVisibility(View.VISIBLE);
        goback.setVisibility(View.GONE);
    }
}