package com.urovo.activity.home;

import android.app.AlertDialog.Builder;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;

import com.urovo.activity.sell.SelectZuHe;
import com.urovo.wgmf.AsyncTask.QueryYanZhengTask;
import com.urovo.wgmf.AsyncTask.UploadJiFenDuiHuanTask;
import com.urovo.wgmf.AsyncTask.UploadSongJiFenTask;
import com.urovo.wgmf.db.dao.dao.Item001DbOperate;
import com.urovo.wgmf.db.dao.entitys.HuoDongEntity;
import com.urovo.wgmf.db.dao.entitys.HuoDongEntity.ChanPin;
import com.urovo.wgmf.db.dao.entitys.HuoDongEntity.Product;
import com.urovo.wgmf.db.dao.entitys.JiFenDuiHuanUploadEntity;
import com.urovo.wgmf.db.dao.entitys.LPItem;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.utils.NumberUtil;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class FreeGetGift extends BaseActivity {

    private TextView tv_gift;
    private TextView tv_hd_content;
    private Button btn_zengsong;
    private HuoDongEntity huoDongEntity;
    private String huiyuan;
    private String storeId;
    private String guwen;
    private double jifen;
    private List<ProductEntity> gift = new ArrayList<ProductEntity>();
    private Product zpro;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.free_get_gift);

        tv_gift = (TextView) findViewById(R.id.tv_gift);
        tv_hd_content = (TextView) findViewById(R.id.tv_hd_content);
        btn_zengsong = (Button) findViewById(R.id.btn_zengsong);

        TextView titleTextView = (TextView) findViewById(R.id.text_title);
        titleTextView.setText("免费领取");
        ImageButton goback = (ImageButton) findViewById(R.id.goback);
        goback.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                finish();
            }
        });

        Intent intent = getIntent();
        huoDongEntity = (HuoDongEntity) intent.getSerializableExtra("huodong");
        huiyuan = intent.getStringExtra("huiyuan");
        storeId = intent.getStringExtra("storeId");
        guwen = intent.getStringExtra("guwen");
        jifen = intent.getDoubleExtra("jifen", 0);

        zpro = huoDongEntity.getGiftprojson();
        if (zpro != null && zpro.pro != null && zpro.pro.size() > 0) {
            for (ChanPin cp : zpro.pro) {
                ProductEntity pe = new ProductEntity();
                pe.setItemId(cp.getPro_code());
                pe.setTQTY(cp.getPro_num());
                gift.add(pe);
            }
        }
        if (zpro != null && zpro.prozuhe != null && zpro.prozuhe.size() > 0) {
            if (zpro.prozuhe.get(0).getPro_code() != null && zpro.prozuhe.get(0).getPro_code().size() > 0) {
                ProductEntity p = new ProductEntity();
                p.setItemId("0.0002");// 组合品
                p.setTQTY(0);
                p.setItemName("请选择赠品组合;");
                gift.add(p);
            }
        }
        showHuoDong();
        tv_gift.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                Intent intent = new Intent(FreeGetGift.this, SelectZuHe.class);
                intent.putExtra("huodong", (Serializable) huoDongEntity);
                startActivityForResult(intent, 88);
            }
        });
        tv_hd_content.setText("活动内容：" + huoDongEntity.getAct_content());

        btn_zengsong.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                Builder builder = new Builder(FreeGetGift.this);
                builder.setTitle("请输入验证码领取");
                final EditText et = new EditText(FreeGetGift.this);
                et.setTextSize(25);
                et.setBackgroundResource(R.drawable.edit_unselected);
                builder.setView(et);
                builder.setPositiveButton("确定", new DialogInterface.OnClickListener() {

                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        String code = et.getText().toString().trim();
                        dialog.dismiss();
                        if (TextUtils.isEmpty(code)) {
                            showMsg("请输入验证码");
                        } else {
                            huoDongEntity.setCode(code);
                            new QueryYanZhengTask(FreeGetGift.this, "正在验证...", true, huoDongEntity.getAct_id(), code, huiyuan).execute("");
                        }
                    }
                });
                builder.setNegativeButton("取消", null);
                Dialog dialog = builder.create();
                dialog.setCancelable(true);
                dialog.setCanceledOnTouchOutside(true);
                dialog.show();
            }
        });
    }

    private void showHuoDong() {
        StringBuilder sb = new StringBuilder();
        if (gift != null && gift.size() > 0) {
            for (ProductEntity p : gift) {
                if ("0.0002".equals(p.getItemId())) {
                    sb.append(p.getItemName());
                } else {
                    ProductEntity pe = Item001DbOperate.GetProductByBarcode(p.getItemId());
                    sb.append(pe.getItemName() + "X" + p.getTQTY() + ";");
                }
            }
        }
        if (huoDongEntity.getGiftpoint() != 0) {
            sb.append(huoDongEntity.getGiftpoint() + "积分");
        }
        tv_gift.setText(sb.toString());
        sb = null;
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {

        super.displayResult(tag, response);
        if (QueryYanZhengTask.TAG.equals(tag)) {
            if (response != null) {
                if ("0".equals(response.getRet())) {
                    showMsg("验证成功");
                    if (gift != null && gift.size() > 0) {
                        Iterator<ProductEntity> it = gift.iterator();
                        while (it.hasNext()) {
                            ProductEntity pe = (ProductEntity) it.next();
                            if (pe.getTQTY() == 0) {
                                it.remove();
                            }
                        }

                        if (gift != null && gift.size() > 0) {
                            JiFenDuiHuanUploadEntity ent = new JiFenDuiHuanUploadEntity();
                            Date date = new Date();
                            ent.setBill(storeId + DateUtil.format(date, "yyMMddHHmmss")+ NumberUtil.generateRandom(4));
                            ent.setStoreId(storeId);
                            ent.setSkyId(SystemHelper.LoginUserId);
                            ent.setSaleEmpName(SystemHelper.LoginUserName);
                            ent.setDHDate(DateUtil.format(date, "yyyy-MM-dd"));
                            ent.setDHTime(DateUtil.format(date, "HH:mm:ss"));
                            ent.setPromid(huoDongEntity.getAct_id());
                            ent.setExchangecode(huoDongEntity.getCode());
                            ent.setCUSTID(huiyuan);
                            ent.setYXJF(jifen);
                            List<LPItem> lplist = new ArrayList<LPItem>();
                            for (ProductEntity p : gift) {
                                LPItem lp = new LPItem();
                                lp.setItemId(p.getItemId());
                                lp.setLPItemName(p.getItemName());
                                lp.setQuantity(p.getTQTY());
                                if (lplist != null && lplist.size() > 0) {
                                    lp.setTotalUseJF(0);
                                } else {
                                    lp.setTotalUseJF(huoDongEntity.getPoint());
                                }
                                lp.setLPUom(p.getKCUom());
                                lplist.add(lp);
                            }
                            LPItem[] lps = new LPItem[lplist.size()];
                            lplist.toArray(lps);
                            ent.setLPItemDetails(lps);

                            List<JiFenDuiHuanUploadEntity> list = new ArrayList<JiFenDuiHuanUploadEntity>();
                            list.add(ent);
                            new UploadJiFenDuiHuanTask(this, "", true, list).execute("");
                        }
                    } else {
                        if (huoDongEntity.getGiftpoint() != 0) {
                            new UploadSongJiFenTask(this, "正在上传", true, huiyuan, huoDongEntity.getGiftpoint() + "", huoDongEntity.getAct_id(), storeId, guwen, huoDongEntity.getCode()).execute("");
                        }
                    }
                } else {
                    showMsg(response.getRetInfo());
                }
            } else {
                showMsg("验证失败");
            }
        }

        if (UploadJiFenDuiHuanTask.TAG.equals(tag)) {
            if (response != null) {
                if ("0".equals(response.getRet())) {
                    btn_zengsong.setEnabled(false);
                    btn_zengsong.setText("领取成功");
                }
                showMsg(response.getRetInfo());
            } else {
                showMsg("上传失败");
            }
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        switch (resultCode) {
            case 88:
                List<ProductEntity> zuhe = (List<ProductEntity>) data.getSerializableExtra("zuhe");
                if (zuhe != null && zuhe.size() > 0) {
                    gift.clear();
                    gift.addAll(zuhe);
                    ProductEntity p = new ProductEntity();
                    p.setItemId("0.0002");
                    p.setTQTY(0);
                    p.setItemName("");
                    int index = gift.indexOf(p);
                    if (index != -1) {
                        gift.set(index, p);
                    }
                }
                showHuoDong();

                break;
            default:
                break;
        }
    }
}