package com.urovo.activity.home;

import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.text.InputType;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.SpannedString;
import android.text.TextUtils;
import android.text.style.AbsoluteSizeSpan;
import android.text.style.ForegroundColorSpan;
import android.text.style.StyleSpan;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;

public class InputPhoneActivity extends BaseActivity {
    private EditText mEditTextPhone;
    private Button mButtonConfirm;

    private String mTitleName;
    private String mClassName;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.input_phone);
        mTitleName = getIntent().getStringExtra("title");
        mClassName = getIntent().getStringExtra("class");
        initTitle();
        mEditTextPhone = (EditText) findViewById(R.id.editTextInput);
        mButtonConfirm = (Button) findViewById(R.id.buttonConfirm);
        mEditTextPhone.setInputType(InputType.TYPE_CLASS_NUMBER);

        // 新建一个属性对象,设置文字的大小
        SpannableString ss = new SpannableString("请输入手机号");
        AbsoluteSizeSpan ass = new AbsoluteSizeSpan(14, true);
        ForegroundColorSpan f = new ForegroundColorSpan(Color.rgb(189, 189, 189));
        StyleSpan s = new StyleSpan(android.graphics.Typeface.NORMAL);
        // 附加属性到文本
        ss.setSpan(ass, 0, ss.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);// ss.length()
        ss.setSpan(f, 0, ss.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
        ss.setSpan(s, 0, ss.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
        // 设置hint
        mEditTextPhone.setHint(new SpannedString(ss)); // 一定要进行转换,否则属性会消失
        mButtonConfirm.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {

                String phone = mEditTextPhone.getText().toString();
                if (phone.length() < 6 || phone.length() > 13) {
                    showMsg("请输入6~13位纯数字手机号！");
                    return;
                }
                if (!TextUtils.isDigitsOnly(phone)) {
                    showMsg("请输入纯数字的手机号！");
                    return;
                }
                if (phone.startsWith("1") && phone.length() != 11) {
                    showMsg("请输入11位的手机号！");
                    return;
                }
                if (phone.length() == 13 && !phone.startsWith("00852") && !phone.startsWith("00853")) {
                    showMsg("只能输入13位的香港或澳门的号码！");
                    return;
                }
                if (phone.startsWith("00852") && phone.length() != 13) {
                    showMsg("请输入13位的香港号码！");
                    return;
                }
                if (phone.startsWith("00853") && phone.length() != 13) {
                    showMsg("请输入13位的澳门号码！");
                    return;
                }
                if (phone.startsWith("400")) {
                    showMsg("请输入有效的手机号！");
                    return;
                }
                Class<?> cls = null;
                try {
                    cls = Class.forName(mClassName);
                } catch (ClassNotFoundException e) {

                }
                if (null != cls) {
                    Intent intent = new Intent(InputPhoneActivity.this, cls);
                    intent.putExtra("phone", phone);
                    intent.putExtra("huiyuan", phone);
                    intent.putExtra("fromInput", true);
                    startActivity(intent);
                    finish();
                }
            }
        });

    }

    @Override
    public void initTitle() {

        super.initTitle();
        if (TextUtils.isEmpty(mTitleName)) {
            titleTextView.setText("请输入手机号");
        } else {
            titleTextView.setText(mTitleName);
        }
    }

    @Override
    protected void onResume() {

        super.onResume();
    }

    @Override
    protected void onPause() {

        super.onPause();

    }

    @Override
    protected void onDestroy() {

        super.onDestroy();
    }
}