package com.urovo.activity.home;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.activity.tabMenu.home.act.ScanResultAct;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseSimpleResponse;
import com.urovo.wugumofang.system.Prefs;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.system.ToActivity;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.StringUtil;
import com.urovo.wugumofang.view.webview.FraContainerAct;
import com.wgmf.trade.model.bean.MemberInfo;
import com.wgmf.trade.ui.fra.index.MemberHomeFra;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.model.bean.RequestResult;
import com.zsy.libcore.ui.fra.FragmentArgs;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;
import okhttp3.Request;

/**
 * 会员搜索
 *
 * @author ...
 */
public class SearchMemberActivity extends BaseActivity {
    private ArrayAdapter<String> arrAdapter;
    @BindView(R.id.et_search_number)
    EditText etSearchNumber;
    @BindView(R.id.bt_search)
    Button btSearch;
    String[] newArrays;
    @BindView(R.id.lv_search_history)
    ListView lvSearchHistory;
    @BindView(R.id.bt_back)
    ImageButton btBack;
    private Unbinder unbinder;

    @Override
    protected String getName() {
        return "会员搜索";
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_search);
        unbinder = ButterKnife.bind(this);

        // 获取搜索框信息
        btSearch.setOnClickListener(new OnClickListener() {
            // 页面首先跳到扫码加粉页，即新流程鼓励先扫码，再录销售
            @Override
            public void onClick(View v) {
                String text = etSearchNumber.getText().toString().trim();
                if (!StringUtil.isNotNullAndNotEmpty(text)) {
                    text = "4006836080";
                    // 从服务器查询会员信息
                    FragmentArgs fragmentArgs = new FragmentArgs();
                    fragmentArgs.add(AppConstants.ExtraKeys.PHONE_NUM, text);
                    FraContainerAct.launchWithFinish(SearchMemberActivity.this, MemberHomeFra.class, fragmentArgs, false);
                    return;
                }
                SYLoger.print("etSearchNumber-->" + etSearchNumber);
                checkOrderExcp(text);
            }
        });

        btBack.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        String history = PreferHelper.getInstance().getString(Prefs.SEARCH_HISTORY);
        if (!"".equals(history)) {
            // 用逗号分割内容返回数组
            String[] historyArr = history.split(",");
            newArrays = new String[20];
            // 保留前20条数据
            if (historyArr.length > 20) {
                // 实现数组之间的复制
                System.arraycopy(historyArr, 0, newArrays, 0, 20);
            } else {
                newArrays = historyArr;
            }
        } else {
            newArrays = new String[0];
        }

        View v = View.inflate(this, R.layout.history_foot_view, null);
        ((TextView) v).setText(newArrays.length == 0 ? "无历史记录" : "清除历史记录");
        lvSearchHistory.addFooterView(v);
        arrAdapter = new ArrayAdapter<>(this, R.layout.simple_dropdown_item_1line, newArrays);
        // 设置适配器
        lvSearchHistory.setAdapter(arrAdapter);

        v.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                ((TextView) v).setText("无历史记录");
                PreferHelper.getInstance().remove(Prefs.SEARCH_HISTORY);
                showMsg("清除成功");
                newArrays = new String[0];
                arrAdapter =
                        new ArrayAdapter<>(SearchMemberActivity.this, R.layout.simple_dropdown_item_1line,
                                newArrays);
                // 设置适配器
                lvSearchHistory.setAdapter(arrAdapter);
            }
        });

        lvSearchHistory.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                TextView tv = (TextView) view.findViewById(R.id.text1);
                String number = tv.getText().toString();
                checkOrderExcp(number);
            }
        });
        String phoneNum = getIntent().getStringExtra(AppConstants.ExtraKeys.PHONE_NUM);
        if (!TextUtils.isEmpty(phoneNum)) {
            etSearchNumber.setText(phoneNum);
        }
        etSearchNumber.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (newArrays != null) {
                    String str = etSearchNumber.getText().toString().trim();
                    List<String> aList = new ArrayList<>();
                    String[] ne2 = newArrays;
                    for (String newArray : newArrays) {
                        if (newArray.startsWith(str)) {
                            aList.add(newArray);
                        }
                    }
                    String[] results = new String[aList.size()];
                    newArrays = aList.toArray(results);
                    updateListView();
                    newArrays = ne2;
                }
            }
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (unbinder != null) {
            unbinder.unbind();
        }
    }

    private void updateListView() {
        arrAdapter = new ArrayAdapter<>(this, R.layout.simple_dropdown_item_1line, newArrays);
        lvSearchHistory.setAdapter(arrAdapter);

        lvSearchHistory.setOnItemClickListener(new OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                TextView tv = (TextView) view.findViewById(R.id.text1);
                String number = tv.getText().toString();
                etSearchNumber.setText(number);
                checkOrderExcp(number);
            }
        });
    }

    /**
     * 录单异常提醒
     */
    public void checkOrderExcp(final String mobile) {
        HashMap<String, String> params = new HashMap<>(16);
        params.put("mobile", mobile);
        //ViewUtil.showProgress(this, "请稍等", "正在验证手机号...");
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.CHECK_ORDER_EXCP,
                params,
                new OkHttpDominator.ResultCallback<BaseSimpleResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        searchMember(mobile);
                    }

                    @Override
                    public void onResponse(BaseSimpleResponse res) {
                        ViewUtil.dismissProgress();
                        if (res != null && res.msgCode != 0) {
                            new AlertDialog.Builder(SearchMemberActivity.this)
                                    .setTitle("确认真实消费号码")
                                    .setMessage(res.msgInfo)
                                    .setNegativeButton("放弃", new DialogInterface.OnClickListener() {
                                        @Override
                                        public void onClick(DialogInterface dialog, int which) {
                                            finish();
                                        }
                                    })
                                    .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                                        @Override
                                        public void onClick(DialogInterface dialog, int which) {
                                            searchMember(mobile);
                                        }
                                    })
                                    .show();
                            //如果这个手机号并不异常，就照常录单
                        } else {
                            searchMember(mobile);
                        }
                    }
                });
    }

    /**
     * 查询会员基础信息
     */
    public void queryMemberInfo(String userId, String shopId, String member) {
        ViewUtil.showProgress(this, "请稍等", "正在查询会员基础信息...");
        HashMap<String, String> param = new HashMap<>();
        param.put("userId", userId);
        param.put("shopId", shopId);
        param.put("customerMobile", member);
        OkHttpDominator.getAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.GET_CUSTOMER_INFO,
                param, new OkHttpDominator.ResultCallback<RequestResult<MemberInfo>>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        //走老逻辑（企业微信
                        EnterpriseWxCodeAct.launch(SearchMemberActivity.this, member, "", 0);
                    }

                    @Override
                    public void onResponse(RequestResult<MemberInfo> res) {
                        ViewUtil.dismissProgress();
                        if (res.resultInfo == null) {
                            EnterpriseWxCodeAct.launch(SearchMemberActivity.this, member, "", 0);
                            return;
                        }
                        if (res.resultInfo.inGroup == 1) {
                            EnterpriseWxCodeAct.launch(SearchMemberActivity.this, member, "", 0);
                        } else {
                            EnterpriseWxCodeAct.launch(SearchMemberActivity.this, member, res.resultInfo.groupUrl, res.resultInfo.showSwitch);
                        }
                    }
                });
    }

    /**
     * 检查是否是公众号加粉试点门店
     * 如果是试点门店，检查是否关注公众号；
     * 如果关注公众号，检查是否已加门店群；
     * 已加门店群，进入会员主页，
     * 未加门店群，进入门店加群页面，点击下一步跳转会员主页；
     * 未关注公众号，进入关注公众号流程；
     * 关注公众号流程：
     * 首先查询是否需要跳转企业微信扫码加好友页面；
     * 需要则跳转到企业微信扫码加好友流程；
     * 不需要进入本地二维码流程，点击下一步跳转会员主页
     */
    public void checkQrcodeShops(String member, String storeId, String guwenid, String dailuDate, String daiLu, boolean scanCodeAddFlag) {
        //ViewUtil.showProgress(this, "请稍等", "正在查询...");
        HashMap<String, String> param = new HashMap<>();
        param.put("shopId", SystemHelper.LoginOrganId);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.WeiXinQrcode.CHECK_QRCODE_SHOPS,
                param, new OkHttpDominator.ResultCallback<BaseSimpleResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        //网络异常,进入微信公众号加粉异常流程
                        followWXOfficial(member, guwenid, dailuDate, daiLu, scanCodeAddFlag);
                    }

                    @Override
                    public void onResponse(BaseSimpleResponse res) {
                        ViewUtil.dismissProgress();
                        if ("true".equals(res.resultInfo)) {//公众号加粉试点门店
                            followWXOfficial(member, guwenid, dailuDate, daiLu, scanCodeAddFlag);
                            return;
                        }
                        //非公众号加粉试点门店,进入企业微信加粉流程
                        queryMemberInfo(SystemHelper.LoginUserId, SystemHelper.LoginOrganId, member);
                    }
                });
    }

    private void followWXOfficial(String member, String guwenid, String dailuDate, String daiLu, boolean scanCodeAddFlag) {
        Intent intent = new Intent(SearchMemberActivity.this, ErWeiMaEntryActivity.class);
        intent.putExtra("huiyuan", member);
        intent.putExtra("storeId", SystemHelper.LoginOrganId);
        intent.putExtra("guwenid", guwenid);
        intent.putExtra("dailuDate", dailuDate);
        intent.putExtra("DaiLu", daiLu);
        intent.putExtra("scanCodeAddFlag", scanCodeAddFlag);
        startActivity(intent);
    }

    public void searchMember(String text) {
        if (!TextUtils.isDigitsOnly(text)) {
            showMsg("请输入纯数字的会员号！");
            return;
        }
        if (TextUtils.isEmpty(text)) {
            toSearchMember(text, false);
        } else {
            if (text.length() != 11 && text.length() != 8) {
                showMsg("请输入正确的11位手机号或者6/9开头的8位数香港手机号！");
            } else {
                if (text.length() == 8) {
                    if (!text.startsWith("6")
                            && !text.startsWith("9")) {
                        showMsg("请输入正确的8位数香港手机号！");
                        return;
                    }
                }
                if (text.length() == 11) {
                    if (!text.startsWith("13")
                            && !text.startsWith("14")
                            && !text.startsWith("15")
                            && !text.startsWith("16")
                            && !text.startsWith("17")
                            && !text.startsWith("18")
                            && !text.startsWith("19")) {
                        showMsg("请输入正确的11位手机号！");
                        return;
                    }
                }
                String oldText = PreferHelper.getInstance().getString(Prefs.SEARCH_HISTORY);
                String[] historyArr = oldText.split(",");
                StringBuilder builder = new StringBuilder();
                builder.append(text).append(",");
                //前二十条记录
                for (int i = 0; i < 19 && i < historyArr.length; i++) {
                    if (!text.equals(historyArr[i])) {
                        builder.append(historyArr[i]).append(",");
                    }
                }
                PreferHelper.getInstance().setString(Prefs.SEARCH_HISTORY, builder.toString());
                // 从服务器查询会员信息
                toSearchMember(text, true);
            }
        }
    }

    /**
     * 从服务器查询会员信息
     */
    private void toSearchMember(String member, boolean entryErWeiMa) {
        if (this.isFinishing()) return;
        etSearchNumber.clearFocus();
        InputMethodManager imm = (InputMethodManager) SearchMemberActivity.this.getSystemService(
                Context.INPUT_METHOD_SERVICE);
        if (imm != null) {
            imm.hideSoftInputFromWindow(etSearchNumber.getWindowToken(), 0);
        }

        Intent data = getIntent();
        boolean after = data.getBooleanExtra("after", false);
        if (after) {//恒为false
            Intent intent = new Intent();
            intent.putExtra("huiyuan", member);
            setResult(77, intent);
            finish();
        } else {
            Intent getIntent = getIntent();
            String storeId = getIntent.getStringExtra("storeId");
            String guwenid = getIntent.getStringExtra("guwenid");
            String dailuDate = getIntent.getStringExtra("dailuDate");
            String daiLu = getIntent.getStringExtra("DaiLu");//这个应该是恒为null吧。
            boolean scanCodeAddFlag = getIntent.getBooleanExtra("scanCodeAddFlag", false);
//            String filterScanCodeJson = getIntent.getStringExtra("filterScanCodeList");

            SYLoger.print("scanCodeAddFlag-- " + scanCodeAddFlag);
            //是否启动扫码加粉
            if (entryErWeiMa && !"DaiLu".equals(daiLu)) {//这个"DaiLu".equals(daiLu)应该也是恒为false，都没传值过来。
//                EnterpriseWxCodeAct.launch(this,member);
                checkQrcodeShops(member, storeId, guwenid, dailuDate, daiLu, scanCodeAddFlag);

                SYLoger.print("scanCodeAddFlag-- " + scanCodeAddFlag);
                SYLoger.print("memberPhone-- " + member);

                //不要随意加上这个finish()，之所以屏蔽掉，是因为在SaveSuccessActivity界面需要通过跳转到这个界面
                //再通过设置Flag的clear_top来把栈上的FraContainerAct给清掉。。。
                //如果加上finish,那此页面被finish了，后面再跳转回来的时候，clear_top的flag就相当于没意义了
                //栈中的多个FraContainerAct就清不掉了，再按返回键的时候，就会产生需要按多次才能完全退出到首页的问题
//                finish();
            } else {
                //手机号码为空
                if (scanCodeAddFlag) {
                    ToActivity.toActivity(SearchMemberActivity.this, ScanResultAct.class, "scanCodeAddFlag", true, "phone", member);
                } else {
                    FraContainerAct.launchWithFinish(this, MemberHomeFra.class, null, false);
                }
            }
        }
    }
}
