package com.urovo.activity.labelprinter.ada;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.content.Context;
import android.view.View;
import android.widget.DatePicker;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.Nullable;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.google.gson.Gson;
import com.urovo.activity.labelprinter.act.LabelPrinterAct;
import com.urovo.activity.labelprinter.ent.LabelPrinterEnt;
import com.urovo.activity.labelprinter.ent.MultipleItem;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.printermodule.PrinterTool;
import com.urovo.wugumofang.printermodule.PrinterUtil;
import com.urovo.wugumofang.ui.AnimeUtil;
import com.urovo.wugumofang.utils.MyToast;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;

/**
 * @author chenji last on 2018/2/6 16:03
 */

public class LabelPrinterAda extends BaseQuickAdapter<LabelPrinterEnt, BaseViewHolder> {
    private Activity mContext;
    private String activityType;//普通标签打印 或 期限标签打印

    public LabelPrinterAda(Activity context, @Nullable List<LabelPrinterEnt> data, String activityType) {
        super(R.layout.item_label_printer, data);
        mContext = context;
        this.activityType = activityType;
    }

    @Override
    protected void convert(BaseViewHolder helper, final LabelPrinterEnt labelPrinterEnt) {
        //把所有的key保存到本地,需要用的时候再提取,remove掉,既可删除之前保存的所有数据,不会干涉到其他原本存储的数据文件

//        helper.setText(R.id.label_pro_code_tv, labelPrinterEnt.getProCode());
//        helper.setText(R.id.label_pro_name_tv, labelPrinterEnt.getProName());
        helper.setNestView(R.id.rl_item_click);
        final RecyclerView recyclerView = helper.getView(R.id.item_label_printer_list);
        recyclerView.setLayoutManager(new LinearLayoutManager(helper.itemView.getContext(), RecyclerView.VERTICAL, false));
        recyclerView.setHasFixedSize(true);

        mDetailTotalList = getTotalList(labelPrinterEnt);
        NestAda nestAdapter = new NestAda(mContext, mDetailTotalList,activityType);
        nestAdapter.setOnItemChildClickListener(new OnItemChildClickListener() {
            @Override
            public void onItemChildClick(BaseQuickAdapter baseQuickAdapter, View view, int position) {
                switch (view.getId()) {
                    case R.id.label_producers_date:
                        final TextView currentDate = (TextView) view;
                        proDatePicker(mContext, currentDate, labelPrinterEnt.getProCode());
                        break;
                    case R.id.label_producers_deadline_date:
                        final TextView deadDate = (TextView) view;
                        proDeadLinePicker(mContext, deadDate, labelPrinterEnt.getProCode());
                        break;
//                    case R.id.label_decrease:
//                        Toast.makeText(BaseAppManager.appContext(), "减号: " + position, Toast.LENGTH_SHORT).show();
//                        mEtLabelNum.setText(String.format(Locale.CHINA, "%d", --mLabelNum));
//                        break;
//                    case R.id.label_print_num_value:
//                        final TextView mEtLabelNum = (EditText) view;
//                        configEdiText(mEtLabelNum);

//                        Toast.makeText(BaseAppManager.appContext(), "edittext: " + position, Toast.LENGTH_SHORT).show();
//                        break;
//                    case R.id.label_plus:
//                        mEtLabelNum.setText(String.format(Locale.CHINA, "%d", ++mLabelNum));
//                        Toast.makeText(BaseAppManager.appContext(), "加号: " + position, Toast.LENGTH_SHORT).show();
//                        break;
                    case R.id.label_printer_btn://打印按钮
                        getLabelPrinterTotalList(labelPrinterEnt);
                        break;
                    default:
                        break;
                }

            }
        });
        recyclerView.setAdapter(nestAdapter);
    }

    /**得到需要拿去打印的List数据*/
    private void getLabelPrinterTotalList(LabelPrinterEnt labelPrinterEnt) {
        //生产日期 期限日期 打印数量(布局固定配置)
        String etPrintNum = PreferHelper.getInstance().getString(labelPrinterEnt.getProCode() + "_etPrintNum");
        String currentDateSp = PreferHelper.getInstance().getString(labelPrinterEnt.getProCode());
        String deadLineSp = PreferHelper.getInstance().getString(labelPrinterEnt.getProCode() + "_deadLine");
        mLabelPrinterTotalList.clear();

        //=======================打印期限标签=======================
        if (activityType.equals(LabelPrinterAct.DDLINE)){
            mLabelPrinterTotalList.add(new PrinterUtil.MultipleItem("", "销售期限标签"));//因为第一行会有空格，会居中，所以打印一个空白，使从第二行开始正经打印
            LabelPrinterEnt.DetailListBean firstItem = labelPrinterEnt.getDetailList().get(0);//第一行要打印产品名
            mLabelPrinterTotalList.add(new PrinterUtil.MultipleItem(firstItem.getKey() + ":", firstItem.getValue()));
            mLabelPrinterTotalList.add(new PrinterUtil.MultipleItem("开封/加工日期:", currentDateSp));
            mLabelPrinterTotalList.add(new PrinterUtil.MultipleItem("销售期限至:", deadLineSp));
            mLabelPrinterTotalList.add(new PrinterUtil.MultipleItem("打印数量:", etPrintNum));
        //=======================打印常规产品标签=======================
        }else{
            //标题 如:银杏 (2.20045)
            //        mLabelPrinterTotalList.add(new PrinterUtil.MultipleItem(labelPrinterEnt.getProName(), "(" + labelPrinterEnt.getProCode() + ")"));
            mLabelPrinterTotalList.add(new PrinterUtil.MultipleItem(labelPrinterEnt.getLabelType().equals("2")? "散装食品合格证" : "商品信息", ""));
            //如果是特殊标签
            if (labelPrinterEnt.getLabelType().equals("2")){
                mLabelPrinterTotalList.add(new PrinterUtil.MultipleItem("                        ", "称重计量"));
            }
            //生产商 生产地址 保质期 电话号码(布局动态配置)
            for (LabelPrinterEnt.DetailListBean detailListBean : labelPrinterEnt.getDetailList()) {
                mLabelPrinterTotalList.add(new PrinterUtil.MultipleItem(detailListBean.getKey() + ":", detailListBean.getValue()));
            }
            mLabelPrinterTotalList.add(new PrinterUtil.MultipleItem("生产日期:", currentDateSp));
            mLabelPrinterTotalList.add(new PrinterUtil.MultipleItem("打印数量:", etPrintNum));
        }

        //打印开始
        new PrinterTool(mContext, null).printLabel(mLabelPrinterTotalList);
    }

    private List<MultipleItem> mDetailTotalList = new ArrayList<>();

    /**
     * 组装打印的集合
     */
    private List<PrinterUtil.MultipleItem> mLabelPrinterTotalList = new ArrayList<>();

    /**
     * 复杂布局数据组装
     *
     * @param detailList 后台配置的数据集合
     * @return 组装后符合BRVAH框架使用的集合
     */
    private List<MultipleItem> getTotalList(LabelPrinterEnt detailList) {
        if (mDetailTotalList != null) {
            mDetailTotalList.clear();
        }
        if (activityType.equals(LabelPrinterAct.PROD)){
            //后台配置部分--生成商、生成地址、保质期、电话号码...
            for (LabelPrinterEnt.DetailListBean detailListBean : detailList.getDetailList()) {
                mDetailTotalList.add(new MultipleItem(MultipleItem.TEXT_CONTENT, detailListBean.getKey(), detailListBean.getValue()));
            }
        }else{//期限标签情况，只用显示第一项 品名
            LabelPrinterEnt.DetailListBean firstItem = detailList.getDetailList().get(0);
            mDetailTotalList.add(new MultipleItem(MultipleItem.TEXT_CONTENT, firstItem.getKey(), firstItem.getValue()));
        }

        //固定部分--生产日期、打印数量、打印按钮
        mDetailTotalList.add(new MultipleItem(MultipleItem.TEXT_FIXED, detailList.getProCode()));
        return mDetailTotalList;
    }

    private List<String> proCodeList = new ArrayList<>();
    private String tempProCode = "";

    /**选生产or开封日期*/
    private void proDatePicker(Context context, final TextView date, final String proCode) {
        Calendar c = Calendar.getInstance();
        DatePickerDialog datePickerDialog = new DatePickerDialog(context, new DatePickerDialog.OnDateSetListener() {
            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
                String today = DateUtil.getSpecifiedDay(new Date(), 0, "yyyy-MM-dd", Locale.CHINA);
                String selectDate = String.format(Locale.CHINA, "%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
                String todayCompare = today.replace("-", "");
                String selectDateCompare = selectDate.replace("-", "");
                if (Long.parseLong(todayCompare) - Long.parseLong(selectDateCompare) >= 0) {
                    date.setText(selectDate);
                } else {
                    AnimeUtil.vibrate(date);
                    MyToast.show(mContext, "只能选择今天或今天之前的日期!", Toast.LENGTH_SHORT);
                }
                PreferHelper.getInstance().setString(proCode, selectDate);
                if (!tempProCode.equals(proCode)) {
                    proCodeList.add(proCode);
                    tempProCode = proCode;
                }
                String proCodeListJson = new Gson().toJson(proCodeList);
                PreferHelper.getInstance().setString(AppConstants.Printer.LABEL_PRO_CODE, proCodeListJson);
            }
        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH));
        datePickerDialog.getDatePicker().setCalendarViewShown(false);
        datePickerDialog.show();
    }

    /**选期限日期*/
    private void proDeadLinePicker(Context context, final TextView date, final String proCode) {
        Calendar c = Calendar.getInstance();
        DatePickerDialog datePickerDialog = new DatePickerDialog(context, new DatePickerDialog.OnDateSetListener() {
            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
                String today = DateUtil.getSpecifiedDay(new Date(), 0, "yyyy-MM-dd", Locale.CHINA);
                String selectDate = String.format(Locale.CHINA, "%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
                String todayCompare = today.replace("-", "");
                String selectDateCompare = selectDate.replace("-", "");
                if (Long.parseLong(todayCompare) - Long.parseLong(selectDateCompare) <= 0) {
                    date.setText(selectDate);
                } else {
                    AnimeUtil.vibrate(date);
                    MyToast.show(mContext, "只能选择今天或今天之后的日期!", Toast.LENGTH_SHORT);
                }
                PreferHelper.getInstance().setString(proCode+"_deadLine", selectDate);
                if (!tempProCode.equals(proCode+"_deadLine")) {
                    proCodeList.add(proCode+"_deadLine");
                    tempProCode = proCode+"_deadLine";
                }
                String proCodeListJson = new Gson().toJson(proCodeList);
                PreferHelper.getInstance().setString(AppConstants.Printer.LABEL_PRO_CODE, proCodeListJson);
            }
        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH));
        datePickerDialog.getDatePicker().setCalendarViewShown(false);
        datePickerDialog.show();
    }
}
