package com.urovo.activity.labelprinter.ent;

import com.chad.library.adapter.base.entity.MultiItemEntity;

import java.util.List;

/**
 * @author chenji
 */
public class MultipleItem<T> implements MultiItemEntity {
    /**
     * 不用布局的type类型
     */
    public static final int
            TEXT_CONTENT = 0,
            TEXT_FIXED = 1,
            IMG_TEXT_IMG = 3,
            HORIZONTAL_LINE = 4,
            ITEM_HORIZONTAL_LINE = 5,
            BODY_HORIZONTAL_LINE = 6,
            IMG_TEXT_EMPTY = 7,
            TEXT_FOOT_TIPS = 8;
    /**
     * 一行中item占用的总列数,如果等于最先设定的上限列数,则说明该item是铺满一行的
     */
//    public static final int
//            TEXT_SPAN_SIZE = 4,
//            TEXT_IMG_SPAN_SIZE = 4,
//            IMG_TEXT_IMG_SPAN_SIZE = 4,
//            HORIZONTAL_LINE_SPAN_SIZE = 4,
//            IMG_TEXT_SPAN_SIZE = 1;

    private int itemType;
    private int spanSize;
    private String content;
    private List<T> list;
    private String[] contents;
    private T t;
    private int count;
    private int typeId;

//    public String key;
//    public String value;

//    /**
//     * 存打印的信息
//     *
//     * @param key   ...
//     * @param value ...
//     */
//    public MultipleItem(String key, String value) {
//        this.key = key;
//        this.value = value;
//    }

//    @Override
//    public String toString() {
//        return "MultipleItem{" +
//                "key='" + key + '\'' +
//                ", value='" + value + '\'' +
//                '}';
//    }

    /**
     * 用于后台返回数据里面绑定的id
     */

    public MultipleItem(int itemType, String... contents) {
        this.itemType = itemType;
        this.contents = contents;
    }

    public MultipleItem(int itemType, String content) {
        this.itemType = itemType;
        this.content = content;
    }

    public MultipleItem(int itemType, int spanSize, int typeId, T t, String... contents) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.typeId = typeId;
        this.t = t;
        this.contents = contents;
    }

    public MultipleItem(int itemType, int spanSize, int typeId, int count, T t, String... contents) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.typeId = typeId;
        this.count = count;
        this.t = t;
        this.contents = contents;
    }

    public MultipleItem(int itemType, int spanSize, int typeId, int count, T t, String content) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.typeId = typeId;
        this.count = count;
        this.t = t;
        this.content = content;
    }

    public MultipleItem(int itemType, int spanSize, int typeId, String... contents) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.typeId = typeId;
        this.contents = contents;
    }

    public MultipleItem(int itemType, int spanSize, String content) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.content = content;
    }

    public MultipleItem(int itemType, int spanSize, T t) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.t = t;
    }

    public MultipleItem(int itemType, int spanSize, int count) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.count = count;
    }

    public MultipleItem(int itemType, int spanSize, T t, int count) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.t = t;
        this.count = count;
    }

    public MultipleItem(int itemType, int spanSize, List<T> list) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.list = list;
    }

    public MultipleItem(int itemType, int spanSize) {
        this.itemType = itemType;
        this.spanSize = spanSize;
    }

    public int getSpanSize() {
        return spanSize;
    }

    public void setSpanSize(int spanSize) {
        this.spanSize = spanSize;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public List<T> getList() {
        return list;
    }

    public void setList(List<T> list) {
        this.list = list;
    }

    public String[] getStringArray() {
        return contents;
    }

    public void setStringArray(String[] str) {
        this.contents = str;
    }

    public T getT() {
        return t;
    }

    public void setT(T t) {
        this.t = t;
    }

    public int getCount() {
        return count;
    }

    public void setCount(int count) {
        this.count = count;
    }

    public int getTypeId() {
        return typeId;
    }

    public void setTypeId(int typeId) {
        this.typeId = typeId;
    }

    @Override
    public int getItemType() {
        return itemType;
    }
}
