package com.urovo.activity.labelprinter.pre;

import com.urovo.activity.labelprinter.ent.LabelPrinterEnt;
import com.urovo.activity.labelprinter.net.LabelPrinterNet;
import com.urovo.wugumofang.data.JsonDominator;
import com.urovo.wugumofang.net.CommonController;
import com.urovo.wugumofang.response.CommonEntity;

import java.util.List;
import java.util.Map;

/**
 * @author chenji
 * @date 18/1/12
 */
public class LabelPrinterPre implements CommonController.BasePre<List<LabelPrinterEnt>> {
    private CommonController.BaseView<List<LabelPrinterEnt>> mLabelPrinterView;
    private LabelPrinterNet mLabelPrinterNet;

    public LabelPrinterPre(CommonController.BaseView<List<LabelPrinterEnt>> labelPrinterNet) {
        this.mLabelPrinterView = labelPrinterNet;
        this.mLabelPrinterNet = new LabelPrinterNet();
    }

    @Override
    public void onStart2requestData(Map<String, String> params) {
        mLabelPrinterNet.start2request(this, params);
    }

    @Override
    public void onResponseSuccess(CommonEntity<List<LabelPrinterEnt>> resultInfo) {
        LabelPrinterEnt entity0 = JsonDominator.loadFromSD("LabelPrinterEnt", LabelPrinterEnt.class);
        if (entity0 != null) {
            resultInfo.entity.remove(0);
            resultInfo.entity.set(0,entity0);
        }

        mLabelPrinterView.onResponseSuccess(resultInfo);
    }

    @Override
    public void onFailure(String failInfo) {
        mLabelPrinterView.onFailure(failInfo);
    }
}
