package com.urovo.activity.learning;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.melnykov.fab.FloatingActionButton;
import com.urovo.activity.learningsearch.view.LearnSearchAct;
import com.urovo.wgmf.db.dao.entitys.LearningCenter2ndMenuRes;
import com.urovo.wgmf.db.dao.entitys.LearningCenterResultEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.ui.ViewUtil;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;
import org.greenrobot.eventbus.ThreadMode;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;
import okhttp3.Request;

/**
 * Created by Sasuke on 2016/12/19.
 */

public class LearningCenter2ndMenuAct extends BaseActivity implements AdapterView.OnItemClickListener{
    @BindView(R.id.learning_center_list_menu_lv) ListView lv;
    @BindView(R.id.learning_center_search_fab) FloatingActionButton mLearningCenterSearchFab;
   LearningCenterResultEntity.LearningCenterEntityList entityList ;//从一级目录点进来的那一条。
    List<LearningCenter2ndMenuRes.Item> dataList = new ArrayList<>();
    int flag;//1学习中心  非1养生文库
    Unbinder unbinder;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_learning_center_menu);
        unbinder = ButterKnife.bind(this);
        initUI();
        requestTask();
        EventBus.getDefault().register(this);
    }


    protected void initUI(){
        initTitle();
        titleTextView.setText(getIntent().getStringExtra("title"));
        entityList = (LearningCenterResultEntity.LearningCenterEntityList)
                                                getIntent().getSerializableExtra("learningCenterEntityList");
        String flagString = getIntent().getStringExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE);
        flag = TextUtils.isEmpty(flagString)? 1 : Integer.parseInt(flagString);
        lv.setOnItemClickListener(this);
        mLearningCenterSearchFab.attachToListView(lv);
    }

    protected void requestTask(){
        if(entityList != null){
            HashMap<String,String> param = new HashMap<>();
            param.put("stype",entityList.getSelectTypeId());
            param.put("flag",flag == 1?"study" : "yangsheng");
            ViewUtil.showProgress(this, "", "正在获取目录.....");
            OkHttpDominator.getAsyn(NetParam.LEARNINGCENTER_2ND_MENU,
                    param,
                    new OkHttpDominator.ResultCallback<LearningCenter2ndMenuRes>() {
                        @Override
                        public void onError(Request request, Exception e) {
                            ViewUtil.dismissProgress();
                            showMsg(getString(R.string.request_data_fail));
                        }

                        @Override
                        public void onResponse(LearningCenter2ndMenuRes res) {
                            ViewUtil.dismissProgress();
                            dataList.clear();
                            dataList = new ArrayList<>();
                            dataList = res.getResultInfo();
                            EventBus.getDefault().post(dataList);
                        }
                    });
//            RequestParams params = new RequestParams();
//            params.addQueryStringParameter("stype", entityList.getSelectTypeId());//一级类目的主键
//            params.addQueryStringParameter("flag",flag == 1?"study" : "yangsheng");//study:为学习中心文章，yangsheng:为养生文库的文章
//            // 默认查当月
//            mHttpUtils.send(HttpRequest.HttpMethod.GET, NetParam.LEARNINGCENTER_2ND_MENU,
//                    params, mRequestCallBack);
        }
    }


//    private RequestCallBack<String> mRequestCallBack = new RequestCallBack<String>(){
//        @Override
//        public void onStart() {
//            super.onStart();
//            GlobalApp.loger.info("请求报文：" + this.getRequestUrl());
//        }
//
//        @Override
//        public void onFailure(HttpException e, String s) {
//            showMsg(getString(R.string.request_data_fail));
//            GlobalApp.loger.info("失败" + ":" + s);
//        }
//
//        @Override
//        public void onSuccess(ResponseInfo<String> responseInfo) {
//            String json = responseInfo.result;
//            GlobalApp.loger.info("响应报文:" + json);
//            LearningCenter2ndMenuRes res = new Gson().fromJson(json,LearningCenter2ndMenuRes.class);
//            dataList.clear();
//            dataList = new ArrayList<>();
//            dataList = res.getResultInfo();
//            EventBus.getDefault().post(dataList);
//        }
//    };


    @Subscribe(threadMode = ThreadMode.MAIN)
    public void onEventMainThread(List<LearningCenter2ndMenuRes.Item> dataList) {
        lv.setAdapter(new SecondMenuAdapter(dataList));
        ViewUtil.dismissProgress();
    }

    /**
     * 跳转到关键词搜索
     */
    @OnClick(R.id.learning_center_search_fab)
    public void onSearchClick(View v){
        Intent intent = new Intent(this,LearnSearchAct.class);
        intent.putExtra(AppConstants.ExtraKeys.ARTICLE_SEARCH_TYPE, flag);
        intent.putExtra(AppConstants.ExtraKeys.ARTICLE_SEARCH_ALREADY_STORES, getIntent().getSerializableExtra("alreadyStores"));
        intent.setFlags(Intent.FLAG_ACTIVITY_NO_ANIMATION);
        startActivity(intent);
    }

    /**
     * 跳转到关键词搜索
     */
    @OnClick(R.id.learning_center_exam_archive_fab)
    public void onExamArchiveClick(View v){
        Intent intent = new Intent(this, ExamArchiveListActivity.class);
        startActivity(intent);
    }

    @Override
    public void onItemClick(AdapterView<?> adapterView, View view, int position, long l) {
        Intent intent = new Intent(LearningCenter2ndMenuAct.this,LearningCenterListActivity.class);
        intent.putExtra("tag", "content");//标记跳到的界面不是收藏，而是文章列表。
        intent.putExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE,flag + "");
        intent.putExtra("title", dataList.get(position).getName());

        //把收藏列表传过去，后面跳文件的时候，要对比收藏列表，并显示收藏标记。
        intent.putExtra("alreadyStores",getIntent().getSerializableExtra("alreadyStores"));
        intent.putExtra("secondTypeId",dataList.get(position).getSid());
        intent.putExtra("selectType",entityList.getSelectTypeId());
        startActivity(intent);
    }

    protected class SecondMenuAdapter extends BaseAdapter{
        List<LearningCenter2ndMenuRes.Item> dataList ;
        public SecondMenuAdapter(List<LearningCenter2ndMenuRes.Item> dataList){
            this.dataList = dataList;
        }
        @Override
        public int getCount() {
            return dataList.size();
        }

        @Override
        public Object getItem(int i) {
            return null;
        }

        @Override
        public long getItemId(int i) {
            return i;
        }

        @Override
        public View getView(int position, View view, ViewGroup viewGroup) {
            view = LayoutInflater.from( LearningCenter2ndMenuAct.this).inflate(R.layout.learning_center_2nd_menu_item, null);
            TextView tv = (TextView) view.findViewById(R.id.learning_2nd_text);
            String name = dataList.get(position).getName();
            tv.setText(name);
            return view;
        }
    }


    @Override
    protected void onDestroy() {
//        ButterKnife.unbind(this);
        unbinder.unbind();
        EventBus.getDefault().unregister(this);
       super.onDestroy();
    }
}
