package com.urovo.activity.learning;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.AbsListView.OnScrollListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.melnykov.fab.FloatingActionButton;
import com.urovo.activity.learningsearch.view.LearnSearchAct;
import com.urovo.wgmf.AsyncTask.BaseAppSalerServerTask;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wgmf.db.dao.dao.XXWKOperate;
import com.urovo.wgmf.db.dao.entitys.XXWKDb;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.entity.response.LearningCenterPageNoResponse;
import com.urovo.wgmf.entity.response.LearningCenterPageNoResponse.LearningCenterPageNoEntity;
import com.urovo.wgmf.db.dao.entitys.LearningCenterDetailEntityList;
import com.urovo.wgmf.db.dao.entitys.LearningCenterResultEntity;
import com.urovo.wgmf.db.dao.entitys.LearningCenterResultEntity.LearningCenterEntityList;
import com.urovo.wgmf.db.dao.entitys.LearningCenterStoreEntityList;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class LearningCenterListActivity extends BaseActivity implements
        OnItemClickListener, View.OnClickListener {
    private ListView learning_center_list_menu_lv;
    private MyAdapter mMyAdapter;
    private List<String> mList;
    private LearningCenterEntityList list = new LearningCenterResultEntity().new LearningCenterEntityList();
    private LearningCenterDetailEntityList model;
    private List<LearningCenterStoreEntityList> storelist;
    private List<String> alreadyStores;
    private String cotentTag, title;
    private int typeTag;
    private List<XXWKDb> DBlist = XXWKOperate.selectBy(null);
    boolean invalid;// 从数据库中读出已读状态
    private int mPage = 2;//因为第一页已经在刚进来的时候请求得到了，所以从第2页开始请求
    private int secondTypeId = -1;
    private FloatingActionButton mLearningCenterSearchFab, mLearningCenterExamArchiveFab;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_learning_center_menu);
        initTitle();
        initContent();
        if (getIntent().getIntExtra("secondTypeId", -1) != -1) {//如果是通过新的二级目录跳进来的，那就请求网络
            secondTypeId = getIntent().getIntExtra("secondTypeId", -1);
        }

        mPage = 1;//二级目录进来的话，这里并没有通过前面页面的接口请求到，需要从第1页重新请求
        requestNextPageTask(mPage);
    }

    @SuppressWarnings("unchecked")
    private void initContent() {
        learning_center_list_menu_lv = (ListView) findViewById(R.id.learning_center_list_menu_lv);
        mLearningCenterSearchFab = (FloatingActionButton) findViewById(R.id.learning_center_search_fab);
        mLearningCenterSearchFab.attachToListView(learning_center_list_menu_lv);
        mLearningCenterSearchFab.setOnClickListener(this);

        mLearningCenterExamArchiveFab = (FloatingActionButton) findViewById(R.id.learning_center_exam_archive_fab);
        mLearningCenterExamArchiveFab.setOnClickListener(this);

        mMyAdapter = new MyAdapter();
        learning_center_list_menu_lv.setAdapter(mMyAdapter);
        learning_center_list_menu_lv
                .setOnScrollListener(new OnScrollListener() {
                    int firstTemp = 0;//缓存第一个可见元素序列号

                    @Override
                    public void onScrollStateChanged(AbsListView view,
                                                     int scrollState) {
                        if (scrollState == OnScrollListener.SCROLL_STATE_IDLE) {
                            if (view.getLastVisiblePosition() == view
                                    .getCount() - 1) {
                                requestNextPageTask(mPage);
                            }
                        }
                    }

                    @Override
                    public void onScroll(AbsListView arg0, int firstVisibleItem,
                                         int visibleItemCount, int totalItemCount) {
//						Log.i("SasukeLog",firstVisibleItem+"");
                        if (firstTemp < firstVisibleItem) {//数值逐渐变大，说明在往下滚，隐藏FAB。
                            mLearningCenterSearchFab.hide();
                        }
                        if (firstTemp > firstVisibleItem) {//数值逐渐变小，说明在往上、往回滚，显示FAB。
                            mLearningCenterSearchFab.show();
                        }
                        firstTemp = firstVisibleItem;//同步一下序列号
                    }
                });
        learning_center_list_menu_lv.setOnItemClickListener(this);

//        if (null != list) {
//            for (int i = 0; i < list.list.size(); i++) {
//                mList.add(list.list.get(i).title);
//                XXWKDb cell = new XXWKDb();
//                cell.title = list.list.get(i).title;
//                cell.articleId = list.list.get(i).articleId;
//                cell.articleUrl = list.list.get(i).articleUrl;
//                cell.imageUrl = list.list.get(i).imageUrl;
//                cell.createTime = list.list.get(i).createTime;
//                cell.invalid = list.list.get(i).invalid;
//                XXWKOperate.Insert(cell);
//            }
//        }
    }

    private void requestNextPageTask(int page) {
        Map<String, String> params = new HashMap<String, String>();
        String queryUrl = "";
        if (cotentTag.equals("content")) {//如果secondTypeId !=-1说明是从新二级目录跳来的，那intent 也会携带selectType,而list是空的
            params.put("selectType", getIntent().getStringExtra("selectType"));
            params.put("empNo", SystemHelper.LoginUserId);
            queryUrl = "/learn/findLearnsByPage";
        } else if (cotentTag.equals("collect")) {
            params.put("empNo", SystemHelper.LoginUserId);
            queryUrl = "/learn/findStoreByPage";
        }
        if (secondTypeId != -1) {//如果通过新二级目录跳来，则Intent会携带secondTypeId，并且以后请求接口都需要传这个值。
            params.put("secondTypeId", secondTypeId + "");
        }
        params.put("stype", typeTag + "");
        params.put("pageNo", String.valueOf(page));
        new BaseAppSalerServerTask("querybypage",
                LearningCenterPageNoResponse.class, this, "正在加载更多内容...", true,
                queryUrl, params).execute("");
    }

    /**
     * 用于过滤掉日期超过3个月的文章（品嘉说他那边不能过滤）
     */
	/*public void threeMonthFilter(List<LearningCenterPageNoEntity> listentitys){
		Date today = new Date();
		Iterator<LearningCenterPageNoEntity> it = listentitys.iterator();
		while (it.hasNext()){
			LearningCenterPageNoEntity listEntity = it.next();
			if(DateUtil.diffDate(today,DateUtil.String2Date(listEntity.getCreateTime(),"yyyy-MM-dd")) > 90){
				it.remove();//删掉日期超过90天的（三个月）
			}
		}
	}*/
    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if ("querybypage".equals(tag) && null != response) {
            LearningCenterPageNoResponse res = (LearningCenterPageNoResponse) response;
            List<LearningCenterPageNoEntity> entitys = res.resultList;

            for (int i = 0; i < entitys.size(); i++) {
                model = new LearningCenterDetailEntityList();
                // 添加分页加载的新数据
                model.articleId = entitys.get(i).articleId;
                model.articleUrl = entitys.get(i).articleUrl;
                model.createTime = entitys.get(i).createTime;
                model.imageUrl = entitys.get(i).imageUrl;
                model.title = entitys.get(i).title;
                model.originType = entitys.get(i).originType;
                model.isNeedTest = entitys.get(i).isNeedTest;
                model.testLink = entitys.get(i).testLink;
                model.articleEditorExternalLink = entitys.get(i).articleEditorExternalLink;
                list.list.add(model);
                mList.add(model.title);
            }
			/*if (entitys.size() < 10) {
				showMsg("加载完毕,无更多数据");
			}*/
            if (entitys.size() == 0) {
                showMsg("加载完毕,无更多数据");
            } else {
                mPage++;//只有在确定后面还可能有数据的时候才自增页码
            }
        }
        mMyAdapter.notifyDataSetChanged();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        mList = new ArrayList<String>();
        typeTag = TextUtils.isEmpty(getIntent().getStringExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE)) ?
                1 : Integer.parseInt(getIntent().getStringExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE));

        cotentTag = getIntent().getStringExtra("tag");
        storelist = (List<LearningCenterStoreEntityList>) getIntent()
                .getSerializableExtra("learningCenterStoreEntityList");
        alreadyStores = (List<String>) getIntent()
                .getSerializableExtra("alreadyStores");

        if (cotentTag.equals("collect")) {
            if (null != storelist) {
                for (int i = 0; i < storelist.size(); i++) {
                    mList.add(storelist.get(i).title);
                }
            }
        } else if (cotentTag.equals("content")) {
            //list = (LearningCenterEntityList) getIntent().getSerializableExtra(
            //        "learningCenterEntityList");
            //if (list == null) {//如果传过来的是空的（例如从新二级目录传来的）那就先实例化一下，免得给Adapter传个null
            list = new LearningCenterResultEntity().new LearningCenterEntityList();
            //}
        }


        if (cotentTag.equals("collect")) {
            title = "我的收藏";

        } else if (cotentTag.equals("content")) {
            title = getIntent().getStringExtra("title");
        }
        titleTextView.setText(title);
    }

    private class ViewHolder {
        ImageView mImageViewNew;
        TextView mTextViewLabel;
        TextView mTextViewTitle;
        TextView mTextViewContent;
        ImageView mImgState;
        TextView mTextViewDate;
        Button mBtnMore;
    }

    class MyAdapter extends BaseAdapter {
        ViewHolder holder;

        @Override
        public int getCount() {

            return mList.size();
        }

        @Override
        public Object getItem(int position) {

            return mList.get(position);
        }

        @Override
        public long getItemId(int position) {

            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {

            if (null == convertView) {
                convertView = LayoutInflater.from(
                        LearningCenterListActivity.this).inflate(
                        R.layout.listview_item_message, null);
                holder = new ViewHolder();
                holder.mImageViewNew = (ImageView) convertView
                        .findViewById(R.id.imageViewNew);
                holder.mTextViewLabel = (TextView) convertView
                        .findViewById(R.id.textViewLabel);
                holder.mTextViewTitle = (TextView) convertView
                        .findViewById(R.id.textViewTitle);
                holder.mTextViewContent = (TextView) convertView
                        .findViewById(R.id.textViewContent);
                holder.mImgState = (ImageView) convertView
                        .findViewById(R.id.ivActiveState);
                holder.mTextViewDate = (TextView) convertView
                        .findViewById(R.id.textViewDate);
                holder.mBtnMore = (Button) convertView
                        .findViewById(R.id.bt_more);
                convertView.setTag(holder);
            }
            holder = (ViewHolder) convertView.getTag();
            String name = mList.get(position);

            holder.mTextViewContent.setText(name);
            if (cotentTag.equals("content")) {
                try {
                    XXWKDb dblist = DBlist.get(position);
                    if (null != dblist
                            && dblist.articleId
                            .equals(list.list.get(position).articleId)) {
                        invalid = dblist.invalid == null ? false : true;
                    } else {
                        invalid = false;
                    }
                } catch (Exception e) {
                    invalid = false;
                }

//				if (!invalid) {
//					holder.mImageViewNew.setVisibility(View.INVISIBLE);
//				} else {
//					holder.mImageViewNew.setVisibility(View.INVISIBLE);
//				}
                if (list.list.get(position).readStatus == 1) {//如果未读，就显示红点，
                    holder.mImageViewNew.setVisibility(View.VISIBLE);
                } else {
                    holder.mImageViewNew.setVisibility(View.INVISIBLE);
                }

                holder.mTextViewLabel
                        .setText(list.list.get(position).createTime);
            } else {
                holder.mImageViewNew.setVisibility(View.INVISIBLE);
                holder.mTextViewLabel
                        .setText(storelist.get(position).createTime);
            }
            holder.mTextViewLabel.setVisibility(View.VISIBLE);
            holder.mTextViewTitle.setVisibility(View.INVISIBLE);
            return convertView;
        }
    }

    @Override
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.learning_center_search_fab:
                Intent intent = new Intent(LearningCenterListActivity.this, LearnSearchAct.class);
                intent.putExtra(AppConstants.ExtraKeys.ARTICLE_SEARCH_TYPE, typeTag);
                intent.putExtra(AppConstants.ExtraKeys.ARTICLE_SEARCH_ALREADY_STORES, (Serializable) alreadyStores);
                intent.setFlags(Intent.FLAG_ACTIVITY_NO_ANIMATION);
                startActivity(intent);
                break;
            case R.id.learning_center_exam_archive_fab:
                Intent intent3 = new Intent(this, ExamArchiveListActivity.class);
                startActivity(intent3);
                break;
        }
    }

    @Override
    public void onItemClick(AdapterView<?> view, View arg, int position,
                            long arg3) {
        String articleId;
        Intent intent = new Intent();
        intent.setClass(this, LearningCenterDetailActivity.class);
        if (cotentTag.equals("content")) {
            LearningCenterDetailEntityList entity = list.list.get(position);
            intent.putExtra("title", entity.title);
            if ("2".equals(entity.originType)) {
                intent.putExtra("articleUrl", entity.articleEditorExternalLink);
            } else {
                intent.putExtra("articleUrl", entity.articleUrl);
            }
            intent.putExtra("isNeedTest", entity.isNeedTest);
            intent.putExtra("testLink", entity.testLink);
            articleId = list.list.get(position).articleId;
            intent.putExtra("articleId", articleId);
            if (alreadyStores.contains(articleId)) {//如果收藏列表里存在该文章的ID，那么就传一个“已收藏”的标记过去
                intent.putExtra(AppConstants.ExtraKeys.IS_FAVORITED_ARTICLE, true);
            } else {
                intent.putExtra(AppConstants.ExtraKeys.IS_FAVORITED_ARTICLE, false);
            }
            intent.putExtra(AppConstants.ExtraKeys.ARTICLE_READ_TIMES_COUNT, entity.readTimesCount);
        } else {//收藏列表
            intent.putExtra("title", storelist.get(position).title);
            intent.putExtra("articleUrl", storelist.get(position).articleUrl);
            articleId = storelist.get(position).articleId;
            intent.putExtra("articleId", articleId);
            intent.putExtra(AppConstants.ExtraKeys.IS_FAVORITED_ARTICLE, true);
            intent.putExtra(AppConstants.ExtraKeys.ARTICLE_READ_TIMES_COUNT, storelist.get(position).readTimesCount);
        }
        intent.putExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE, typeTag + "");
        intent.putExtra("detailTag", cotentTag);
        //intent.putExtra("learningCenterStoreEntityList",
        //		(Serializable) storelist);
        //以防万一，这边本地也做一个处理。
        arg.findViewById(R.id.imageViewNew).setVisibility(View.INVISIBLE);//去掉小红点
        if (cotentTag.equals("content")) {//只有文章列表才改已读标记，收藏里面不用改
            list.list.get(position).readStatus = 0;//标记为已读
        }
        startActivity(intent);

//		browsingHistory(articleId);  //感觉放到LearningCenterDetailActivity.class里去执行更好。

        this.finish();
    }


}
