package com.urovo.activity.learning;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.melnykov.fab.FloatingActionButton;
import com.urovo.activity.learningsearch.view.LearnSearchAct;
import com.urovo.wgmf.AsyncTask.QueryLearningTask;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.db.dao.entitys.LearningCenterResultEntity;
import com.urovo.wgmf.db.dao.entitys.LearningCenterResultEntity.LearningCenterEntity;
import com.urovo.wgmf.db.dao.entitys.LearningCenterResultEntity.LearningCenterEntityList;
import com.urovo.wgmf.db.dao.entitys.LearningCenterStoreEntityList;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.utils.CommonTools;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/***
 * 学习中心首页                            or               养生文库首页
 *
 * 内部跳转Link：
 * com.urovo.activity.learning.LearningCenterMenuActivity@1   com.urovo.activity.learning.LearningCenterMenuActivity@2
 */
public class LearningCenterMenuActivity extends BaseActivity implements
        OnItemClickListener, OnClickListener {
    private ListView learning_center_list_menu_lv;
    private FloatingActionButton mLearningCenterSearchFab, mLearningCenterExamArchiveFab;
    private int typeTag;//1学习中心  非1 养生文库
    private MyAdapter mMyAdapter;
    private List<String> mList;
    private List<LearningCenterEntityList> mLearningCenterEntityList;
    private List<LearningCenterStoreEntityList> mLearningCenterStoreEntityList;
    private List<String> alreadyStores;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_learning_center_menu);
        init();
        initTitle();
        initContent();
    }

    private void init() {
        typeTag = TextUtils.isEmpty(getIntent().getStringExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE)) ?
                1 : Integer.parseInt(getIntent().getStringExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE));
    }


    @Override
    protected void onResume() {
        super.onResume();
        requestWentiTask();
    }

    private void requestWentiTask() {
        CommonTools.INSTANCE.postDelayed(10000);
        Map<String, String> params = new HashMap<>(2);
        params.put("empNo", SystemHelper.LoginUserId);
        params.put("stype", typeTag + "");
        new QueryLearningTask(this, "正在加载...", true, params).execute("");
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText(typeTag == 1 ? "学习中心" : "养生文库");

        submit.setVisibility(View.VISIBLE);
        submit.setTextSize(14);
        submit.setOnClickListener(this);
    }

    private void initContent() {
        mList = new ArrayList<String>();
        mLearningCenterEntityList = new ArrayList<>();
        mLearningCenterStoreEntityList = new ArrayList<>();
        learning_center_list_menu_lv = (ListView) findViewById(R.id.learning_center_list_menu_lv);
        mLearningCenterSearchFab = (FloatingActionButton) findViewById(R.id.learning_center_search_fab);
        mLearningCenterSearchFab.attachToListView(learning_center_list_menu_lv);

        mLearningCenterExamArchiveFab = (FloatingActionButton) findViewById(R.id.learning_center_exam_archive_fab);

        mMyAdapter = new MyAdapter();
        learning_center_list_menu_lv.setAdapter(mMyAdapter);
        learning_center_list_menu_lv.setOnItemClickListener(this);
        mLearningCenterSearchFab.setOnClickListener(this);
        mLearningCenterExamArchiveFab.setOnClickListener(this);
    }

    private class ViewHolder {
        ImageView mImageViewNew;
        TextView mTextViewLabel;
        TextView mTextViewTitle;
        TextView mTextViewContent;
        ImageView mImgState;
        TextView mTextViewDate;
        Button mBtnMore;
    }

    class MyAdapter extends BaseAdapter {
        ViewHolder holder;

        @Override
        public int getCount() {

            return mList.size();
        }

        @Override
        public Object getItem(int position) {

            return mList.get(position);
        }

        @Override
        public long getItemId(int position) {

            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {

            if (null == convertView) {
                convertView = LayoutInflater.from(
                        LearningCenterMenuActivity.this).inflate(
                        R.layout.listview_item_message, null);
                holder = new ViewHolder();
                holder.mImageViewNew = (ImageView) convertView
                        .findViewById(R.id.imageViewNew);
                holder.mTextViewLabel = (TextView) convertView
                        .findViewById(R.id.textViewLabel);
                holder.mTextViewTitle = (TextView) convertView
                        .findViewById(R.id.textViewTitle);
                holder.mTextViewContent = (TextView) convertView
                        .findViewById(R.id.textViewContent);
                holder.mImgState = (ImageView) convertView
                        .findViewById(R.id.ivActiveState);
                holder.mTextViewDate = (TextView) convertView
                        .findViewById(R.id.textViewDate);
                holder.mBtnMore = (Button) convertView
                        .findViewById(R.id.bt_more);
                holder.mImageViewNew.setVisibility(View.INVISIBLE);
                convertView.setTag(holder);
            }
            holder = (ViewHolder) convertView.getTag();
            String name = mList.get(position);
            holder.mTextViewTitle.setText(name);
            holder.mTextViewContent.setVisibility(View.GONE);
            return convertView;
        }
    }

    /**
     * 用于过滤掉日期超过3个月的文章（品嘉说他那边不能过滤）
     */
	/*public void threeMonthFilter(List<LearningCenterEntityList> listentitys){
		Date today = new Date();
		for(LearningCenterEntityList entity : listentitys){
			Iterator<LearningCenterDetailEntityList> it = entity.list.iterator();
			while (it.hasNext()){
				LearningCenterDetailEntityList listEntity = it.next();
				if(DateUtil.diffDate(today,DateUtil.String2Date(listEntity.getCreateTime(),"yyyy-MM-dd")) > 90){
					it.remove();//删掉日期超过90天的（三个月）
					GlobalApp.loger.info("超过90天的文章日期为："+DateUtil.String2Date(listEntity.getCreateTime(),"yyyy-MM-dd"));
				}
			}
		}
	}*/
    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if (null != response) {
            LearningCenterResultEntity learningCenterEntity = (LearningCenterResultEntity) response;
            LearningCenterEntity resultListentitys = learningCenterEntity.resultInfo;
            List<LearningCenterStoreEntityList> mStoreList = resultListentitys.storeList;
            List<LearningCenterEntityList> listentitys = resultListentitys.list;//一级目录

            alreadyStores = resultListentitys.alreadyStore;
            mList.clear();
            mLearningCenterEntityList.clear();
            for (int j = 0; j < listentitys.size(); j++) {
//				if (!mList.contains(listentitys.get(j).name)) {
                mList.add(listentitys.get(j).name);
                mLearningCenterEntityList.add(listentitys.get(j));
//				}
            }
            submit.setText("我的收藏（" + resultListentitys.storeCount + "）");
            mLearningCenterStoreEntityList.clear();
            for (int k = 0; k < mStoreList.size(); k++) {
                mLearningCenterStoreEntityList.add(mStoreList.get(k));
            }
        }
        mMyAdapter.notifyDataSetChanged();
    }

    @Override
    public void onItemClick(AdapterView<?> view, View arg, int position,
                            long arg3) {
        Intent intent = new Intent();
        intent.putExtra("tag", "content");
        intent.putExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE, typeTag + "");
        intent.putExtra("title", mList.get(position));
        intent.putExtra("learningCenterEntityList",
                (Serializable) mLearningCenterEntityList.get(position));
        intent.putExtra("learningCenterStoreEntityList",
                (Serializable) mLearningCenterStoreEntityList);
        intent.putExtra("alreadyStores",
                (Serializable) alreadyStores);
        intent.putExtra("selectType", mLearningCenterEntityList.get(position).getSelectTypeId());
        if (mLearningCenterEntityList.get(position).getSecondType() == 1) {//如果有二级目录
            intent.setClass(this, LearningCenter2ndMenuAct.class);//二级目录专门界面
        } else {//如果没有二级目录
            intent.setClass(this, LearningCenterListActivity.class);//普通文章列表
        }
        startActivity(intent);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.confirm://我的收藏列表
                Intent intent = new Intent();
                intent.setClass(this, LearningCenterListActivity.class);
                intent.putExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE, typeTag + "");
                intent.putExtra("tag", "collect");
                intent.putExtra("learningCenterStoreEntityList",
                        (Serializable) mLearningCenterStoreEntityList);
                startActivity(intent);
                break;
            case R.id.learning_center_search_fab:
                Intent intent2 = new Intent(this, LearnSearchAct.class);
                intent2.putExtra(AppConstants.ExtraKeys.ARTICLE_SEARCH_TYPE, typeTag);
                intent2.putExtra(AppConstants.ExtraKeys.ARTICLE_SEARCH_ALREADY_STORES, (Serializable) mLearningCenterStoreEntityList);
                intent2.setFlags(Intent.FLAG_ACTIVITY_NO_ANIMATION);
                startActivity(intent2);
                break;
            case R.id.learning_center_exam_archive_fab:
                Intent intent3 = new Intent(this, ExamArchiveListActivity.class);
                startActivity(intent3);
                break;
            default:
                break;
        }
    }
}
