package com.urovo.activity.learningsearch.view;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;

import com.urovo.activity.learning.LearningCenterDetailActivity;
import com.urovo.activity.learningsearch.net.LearnResultRes;
import com.urovo.activity.learningsearch.presenter.LearnSearchContract;
import com.urovo.activity.learningsearch.presenter.LearnSearchPresenter;
import com.urovo.activity.learningsearch.ui.ResultAdapter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnItemClick;
import butterknife.Unbinder;

/**
 * Created by Sasuke on 2017/3/7.
 */

public class LearnResultFra extends Fragment implements LearnSearchContract.view {
    LearnSearchPresenter mPresenter;
    @BindView(R.id.alert_msg)
    TextView alertMsg;
    @BindView(R.id.loading)
    ProgressBar loading;
    @BindView(R.id.search_result_list)
    ListView resultLv;
    ResultAdapter mAdapter;
    Unbinder unbinder;
    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        //以下注释是用来上拉加载下拉刷新的。
        /*View view = super.onCreateView(inflater, container, savedInstanceState);
        setPullLoadEnabled(false);
        setPullRefreshEnabled(false);
        setShowText("没有搜索到");
        //以下写Adapter吧
        setRefreshListener();*/
        View view = inflater.inflate(R.layout.learn_result_fra, container, false);
        unbinder = ButterKnife.bind(this, view);
        mAdapter = new ResultAdapter(getActivity(), mPresenter.getData());
        resultLv.setAdapter(mAdapter);
        return view;
    }

    @Override
    public void initUI() {

    }

    @OnItemClick(R.id.search_result_list)
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        List<LearnResultRes.ResultListBean> list = mPresenter.getData().getSearchList();

        String articleId = list.get(position).getArticleId();
        Intent intent = new Intent(getActivity(),LearningCenterDetailActivity.class);
        intent.putExtra("title", list.get(position).getTitle());
        intent.putExtra("articleUrl", list.get(position).getArticleUrl());
        intent.putExtra("articleId", articleId);
        if (mPresenter.getData().getAlreadyStores().contains(articleId)) {//如果收藏列表里存在该文章的ID，那么就传一个“已收藏”的标记过去
            intent.putExtra(AppConstants.ExtraKeys.IS_FAVORITED_ARTICLE, true);
        } else {
            intent.putExtra(AppConstants.ExtraKeys.IS_FAVORITED_ARTICLE, false);
        }
        intent.putExtra(AppConstants.ExtraKeys.ARTICLE_READ_TIMES_COUNT, list.get(position).getReadTimesCount());
        intent.putExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE, mPresenter.getData().getType() + "");
        intent.putExtra("detailTag", "content");
        //intent.putExtra("learningCenterStoreEntityList",
        //		(Serializable) storelist);
        startActivity(intent);
    }

    @Override
    public void showMsg(String msg) {
        ((BaseActivity) getActivity()).showMsg(msg);
    }

    @Override
    public void setPresenter(LearnSearchContract.presenter presenter) {
        this.mPresenter = (LearnSearchPresenter) presenter;
    }

    @Override
    public void showAlert(String msg) {
        loading.setVisibility(View.GONE);
        resultLv.setVisibility(View.GONE);
        alertMsg.setVisibility(View.VISIBLE);
        alertMsg.setText(msg);
    }

    @Override
    public void showLoading() {
        alertMsg.setVisibility(View.GONE);
        resultLv.setVisibility(View.GONE);
        loading.setVisibility(View.VISIBLE);
    }

    @Override
    public void showResultList() {
        resultLv.setVisibility(View.VISIBLE);
        loading.setVisibility(View.GONE);
        alertMsg.setVisibility(View.GONE);
        mAdapter.notifyDataSetChanged();
    }


    @Override
    public void onDestroyView() {
        super.onDestroyView();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }
}
