package com.urovo.activity.machinerepairact.model

import android.view.View
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.urovo.activity.machinerepairact.net.PatrolItemListRes
import com.urovo.activity.machinerepairact.net.PatrolItemRes
import com.urovo.activity.machinerepairact.repository.MachineCallRepo
import com.urovo.activity.machinerepairact.view.PatrolAct
import com.urovo.wugumofang.utils.MyToast
import kotlinx.coroutines.launch

class PatrolListModel(val repo: MachineCallRepo) : ViewModel() {

    var showProgressText = MutableLiveData<String>()

    var isFinish = MutableLiveData<Boolean>()

    /**项目数据*/
    var itemsData = MutableLiveData<List<PatrolItemListRes.ResultInfo>>()

    /**提交*/
    fun onClickSubmit(view: View) {
        //巡店检查
        PatrolAct.launch(view.context)
    }

    /***
     * 查询项目
     */
    fun queryItems() = viewModelScope.launch {
        try {
            val items = repo.queryPatrolListItems()
            itemsData.value = items
        } catch (e: Exception) {
            MyToast.show(e.message)
        }
    }
}