package com.urovo.activity.machinerepairact.net

import androidx.databinding.ObservableField
import com.urovo.wugumofang.response.Base3Response
import java.io.Serializable

/**
 * Created by Sasuke on 2019-05-06
 * 未处理机修单
 */
data class UndealRepairRes(var resultInfo: ResultPack) : Base3Response(), Serializable {
    data class ResultPack(var badNum: Int,//差评数
                          var goodNum: Int,//好评数
                          var mediumNum: Int,//中评数
                          var showRatingNum: Boolean,//是否显示好中差评数
                          var details: List<ResultInfo> ){
        data class ResultInfo(var mroNo: String?,//机修工单号
                              var mroId: Int,//工单id
                              var status: Int,// 工单状态,0待处理,1待评价,2已评价 ,
                              var applyTime: String?,//申请时间
                              var applyReason: String?,//申请原因
                              var storeNo: String?,//门店号
                              var storeName: String?,//门店名 ,
                              var applicantName: String?,//申请人
                              var applicantPhone: String?,//申请人联系电话
                              var handleWay: String?,//处理方式 ,
                              var isIntime: String?,//是否及时,n表示不及时,y表示及时 ,
                              var rating: Int,
                              var finishTime: String) : Serializable {
            @Transient
            var isChecked: ObservableField<Boolean>? = ObservableField(false)//自建字段，记录选取状态

            //客户评价 未评价0 ,差1,中2,好3 ,
            fun getRatingText(): String {
                return when (rating) {
                    3 -> "好评"
                    2 -> "中评"
                    1 -> "差评"
                    else -> "未评价"
                }
            }
        }
    }

}