package com.urovo.activity.machinerepairact.ui

import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.appcompat.app.AppCompatActivity
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.machinerepairact.net.UndealRepairRes
import com.urovo.activity.machinerepairact.view.EngineerBillDetailAct
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.EngineerBillItemBinding
import com.wgmf.trade.ui.ada.ViewHolderX
import com.wgmf.trade.utils.IntentUtil

/**
 * @author Sasuke on 2019/5/7.
 */

class EngineerBillAdapter(val context: AppCompatActivity, val dataList: List<UndealRepairRes.ResultPack.ResultInfo> = listOf()) : RecyclerView.Adapter<ViewHolderX>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        val binding = DataBindingUtil.inflate<EngineerBillItemBinding>(
                LayoutInflater.from(parent.context),
                R.layout.engineer_bill_item,
                parent,
                false)
        return ViewHolderX(binding.root)
    }

    override fun getItemCount(): Int {
        return dataList.size
    }

    override fun onBindViewHolder(holder: ViewHolderX, position: Int) {
        val binding = DataBindingUtil.getBinding<EngineerBillItemBinding>(holder.view)
        binding?.info = dataList?.get(position)
        binding?.root?.setOnClickListener {
            context.startActivityForResult(
                    Intent(context, EngineerBillDetailAct::class.java).apply {
                        putExtra(EngineerBillDetailAct.INTENT_RES, dataList?.get(position))
                    }, EngineerBillDetailAct.REQUEST_CODE)
        }
        //申请人联系电话，点击拨打电话。
        binding?.applicantPhoneTv?.setOnClickListener {
            var phoneNum = (it as TextView).text.toString().trim()
            if (phoneNum.isEmpty()) return@setOnClickListener
            IntentUtil.callPhone(phoneNum, context)
        }
        //是否及时,n表示不及时,y表示及时
        binding?.isIntime?.visibility = if (dataList?.get(position).isIntime.equals("n")) View.VISIBLE else View.GONE
        binding?.executePendingBindings()//防止数据更新时闪屏
    }
}