package com.urovo.activity.machinerepairact.ui

import android.content.Context
import android.graphics.Color
import android.view.LayoutInflater
import android.view.ViewGroup
import android.widget.TextView
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.machinerepairact.net.EngineerMyStoresRes
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.EngineerMyStoreRvItemBinding
import com.urovo.wugumofang.ui.TextColorDominator
import com.wgmf.trade.ui.ada.ViewHolderX
import com.wgmf.trade.utils.IntentUtil

/**
 * @author Sasuke on 2019-7-31 0031.
 */
class EngineerManageAdapter(val context: Context, val dataList: List<EngineerMyStoresRes.ResultInfo>, var searchWord: String) : RecyclerView.Adapter<ViewHolderX>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        val binding = DataBindingUtil.inflate<EngineerMyStoreRvItemBinding>(
                LayoutInflater.from(context),
                R.layout.engineer_my_store_rv_item,
                parent,
                false)
        return ViewHolderX(binding.root)

    }

    override fun getItemCount(): Int {
        return dataList.size
    }

    override fun onBindViewHolder(holder: ViewHolderX, position: Int) {
        val binding = DataBindingUtil.getBinding<EngineerMyStoreRvItemBinding>(holder.view)
        var item = dataList[position]
        binding?.apply {
            //搜索关键词高亮
            if (searchWord.isNullOrBlank()){
                storeNoTv.text = item.storeNo
                storeNameTv.text = item.storeName
            }else{
                storeNoTv.setText(TextColorDominator.textColorChange(0, Color.YELLOW, item.storeNo, searchWord))
                storeNameTv.setText(TextColorDominator.textColorChange(0, Color.YELLOW, item.storeName, searchWord))
            }

            jyTypeTv.text = item.jyType
            officeTv.text = item.office
            isSaledLastMonthTv.text = if (item.isSaledLastMonth == 1) "是" else "否"
            storeAddrTv.text = item.storeAddr
            managerTv.text = item.getManagerName()
            managerPhoneTv.text = item.getManagerPhone()
            managerPhoneTv.setOnClickListener {
                var phoneNum = (it as TextView).text.toString().trim()
                if (phoneNum.isEmpty()) return@setOnClickListener
                IntentUtil.callPhone(phoneNum,context)
            }
        }
    }
}