package com.urovo.activity.machinerepairact.ui

import android.content.Intent
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.appcompat.app.AppCompatActivity
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.machinerepairact.net.MachinRepairHistoryRes
import com.urovo.activity.machinerepairact.view.MachineRepairDetailAct
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.MachineRepairHistoryItemBinding
import com.wgmf.trade.ui.ada.ViewHolderX

/**
 * @author Sasuke on 2019/5/1.
 */
class HistoryAdapter(val context: AppCompatActivity,val dataList: List<MachinRepairHistoryRes.ResultInfo> = listOf()): RecyclerView.Adapter<ViewHolderX>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        val binding = DataBindingUtil.inflate<MachineRepairHistoryItemBinding>(
                LayoutInflater.from(parent.context),
                R.layout.machine_repair_history_item,
                parent,
                false)
        return ViewHolderX(binding.root)
    }

    override fun getItemCount(): Int {
        return dataList.size
    }

    override fun onBindViewHolder(holder: ViewHolderX, position: Int) {
        val binding = DataBindingUtil.getBinding<MachineRepairHistoryItemBinding>(holder.view)
        binding?.info = dataList[position]
        binding?.root?.setOnClickListener {  context.startActivityForResult(
                Intent(context,MachineRepairDetailAct::class.java).apply {
                    putExtra(MachineRepairDetailAct.INTENT_RES,dataList[position])
        },MachineRepairDetailAct.REQUEST_CODE) }
        binding?.executePendingBindings()//防止数据更新时闪屏
    }
}
