package com.urovo.activity.machinerepairact.ui

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.machinerepairact.net.LightProblemRes
import com.urovo.activity.machinerepairact.view.EngineerMyStoresAct
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.LightProblemRvItem2Binding
import com.urovo.wugumofang.databinding.LightProblemRvItemBinding
import com.wgmf.trade.ui.ada.ViewHolderX

/**
 * @author Sasuke on 2019-8-8 0008.
 */
class LightNoProblemAdapter(val innerContext: Context, val dataList: List<LightProblemRes.ResultInfo.NotSubmitList>?): RecyclerView.Adapter<ViewHolderX>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        val binding = DataBindingUtil.inflate<LightProblemRvItem2Binding>(
                LayoutInflater.from(parent.context),
                R.layout.light_problem_rv_item2,
                parent,
                false)
        return ViewHolderX(binding.root)
    }

    override fun getItemCount(): Int {
        return dataList?.size ?:0
    }

    override fun onBindViewHolder(holder: ViewHolderX, position: Int) {
        val binding = DataBindingUtil.getBinding<LightProblemRvItem2Binding>(holder.view)
        binding?.storeName?.text = dataList?.get(position)?.storeName
        binding?.goStoreDetail?.setOnClickListener {
            //传一个门店名过去，过滤掉查询结果，使只显示这个门店。
            dataList?.get(position)?.storeName?.let { EngineerMyStoresAct.launch(innerContext,it) }
        }
    }
}