package com.urovo.activity.machinerepairact.ui

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.machinerepairact.net.PatrolItemRes
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.PatrolItemsRvAdapterBinding
import com.wgmf.trade.ui.ada.ViewHolderX

/**
 * @author Sasuke on 2019-9-23 0023.
 */
class PatrolItemsAdapter(val context: Context, val items: List<PatrolItemRes.ResultInfo>) : RecyclerView.Adapter<ViewHolderX>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        val view = DataBindingUtil.inflate<PatrolItemsRvAdapterBinding>(
                LayoutInflater.from(context),
                R.layout.patrol_items_rv_adapter,
                parent,
                false).root
        return ViewHolderX(view)
    }

    override fun getItemCount(): Int {
        return items.size
    }

    override fun onBindViewHolder(holder: ViewHolderX, pos: Int) {
        val binding = DataBindingUtil.getBinding<PatrolItemsRvAdapterBinding>(holder.view)
        if (!(items[pos].itemResult in 0..1)) items[pos].itemResult = -1//如果不是0或1，那就赋为-1
        binding?.apply {
            itemPos = pos + 1
            itemDesc = items[pos].itemDesc
            itemResult = items[pos].itemResult
            normalCheck.setOnCheckedChangeListener { compoundButton, isChecked -> if (isChecked) items[pos].itemResult = 0 }
            errorCheck.setOnCheckedChangeListener { compoundButton, isChecked -> if (isChecked) items[pos].itemResult = 1 }
        }
    }
}