package com.urovo.activity.machinerepairact.ui

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseExpandableListAdapter
import android.widget.ImageView
import android.widget.TextView
import androidx.core.content.ContextCompat
import com.urovo.activity.machinerepairact.net.PatrolItemListRes
import com.urovo.wugumofang.R

/**
 * @author Sasuke on 2019-9-23 0023.
 */
class PatrolListItemsAdapter(val context: Context, val list: List<PatrolItemListRes.ResultInfo>) : BaseExpandableListAdapter() {

    override fun getGroupCount(): Int {
        return list?.size ?: 0
    }

    override fun getChildrenCount(groupPosition: Int): Int {
        return if (list[groupPosition].shopList == null) 0 else list[groupPosition].shopList!!.size
    }

    override fun getGroup(groupPosition: Int): PatrolItemListRes.ResultInfo {
        return list[groupPosition]
    }

    override fun getChild(groupPosition: Int, childPosition: Int): PatrolItemListRes.ResultInfo.PatrolShop {
        return list[groupPosition].shopList!![childPosition]
    }

    override fun getGroupId(groupPosition: Int): Long {

        return groupPosition.toLong()
    }

    override fun getChildId(groupPosition: Int, childPosition: Int): Long {

        return childPosition.toLong()
    }

    override fun hasStableIds(): Boolean {

        return false
    }

    override fun getGroupView(groupPosition: Int, isExpanded: Boolean, convertView: View?, parent: ViewGroup): View {
        var convertView = convertView
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.patrol_list_items_group, null)
        }
        val listName = convertView!!.findViewById<View>(R.id.listName) as TextView
        val arrowRight = convertView.findViewById<View>(R.id.arrowRight) as ImageView

        arrowRight.setImageResource(if (isExpanded) R.drawable.btn_arrow_up else R.drawable.btn_arrow_down)
        listName.text = getGroup(groupPosition).listName!!
        return convertView
    }

    override fun getChildView(groupPosition: Int, childPosition: Int, isLastChild: Boolean, convertView: View?, parent: ViewGroup): View {
        var convertView = convertView
        val viewHolder: ViewHolder
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.patrol_list_items_child, null)
            viewHolder = ViewHolder()
            viewHolder.storeName = convertView!!.findViewById<View>(R.id.storeName) as TextView
            viewHolder.patrolStatus = convertView.findViewById<View>(R.id.patrolStatus) as TextView
            convertView.tag = viewHolder
        } else {
            viewHolder = convertView.tag as ViewHolder
        }
        val (patrolStatus, storeLevel, storeName, storeNo) = getChild(groupPosition, childPosition)
        viewHolder.storeName!!.text = storeName

        //patrolStatus 巡店状态,0本月待巡检，1待巡检，2已巡检 ,
        if ("0".equals(patrolStatus)) {
            viewHolder.patrolStatus!!.text = "待巡检(本月)"
            viewHolder.patrolStatus!!.setTextColor(ContextCompat.getColor(context, R.color.red_text_color))
        } else if ("1".equals(patrolStatus)) {
            viewHolder.patrolStatus!!.text = "待巡检"
            viewHolder.patrolStatus!!.setTextColor(ContextCompat.getColor(context, R.color.gplus_color_2))
        } else if ("2".equals(patrolStatus)) {
            viewHolder.patrolStatus!!.text = "已巡检"
        }
        return convertView
    }

    override fun isChildSelectable(groupPosition: Int, childPosition: Int): Boolean {
        return false
    }

    internal inner class ViewHolder {
        var storeName: TextView? = null
        var patrolStatus: TextView? = null
    }
}