package com.urovo.activity.machinetrip.net

import android.view.View
import androidx.databinding.Observable
import androidx.databinding.ObservableField
import com.google.gson.annotations.Expose
import java.io.Serializable

/**
 * Created by Sasuke on 2019-10-25
 */
class TripRecordNewEntity: Serializable {
    @Expose var id: Int? = null
    @Expose var insertTime: String = ""//插入时间
    @Expose var startLocation: String = ""//始发点
    @Expose var timeRange: Int = 0//时间范围
    @Expose var travelDay: String = ""//出差日期,yyyy-MM-dd
    @Expose var userNo: String = ""//机修工号
    @Expose var details: MutableList<Details> = mutableListOf(TripRecordNewEntity.Details())



    class Details: Serializable {
        @Expose var reasonType: Int = 1//出差事由,1工单处理,  2主动巡店,  3 返程,  4中转换乘, 5其他, 6 外区支援 ,
        @Expose var location: String = ""//地点
        @Expose var hotelCost: String = ""//住宿费
        @Expose var trafficCost: String = ""//交通费
        @Expose var cityTrafficCost: String = ""//交通费
        @Expose var workOrderNo: String? = ""//工单处理时为工单号,巡店时为巡店记录id

        /**是否显示原因详情选择框*/
        fun isShowReasonLayout(reasonTypeUI: ObservableField<Int>) = if (reasonTypeUI.get().toString() in "0,1") View.VISIBLE else View.GONE

        /**原因详情的标题文字*/
        fun reasonLayoutTitleText(reasonTypeUI: ObservableField<Int>) = when(reasonTypeUI.get()){
            0 -> "选择工单"
            1 -> "巡店记录"
            else ->""
        }


        //以下字段不用传====================
        var reasonTypeUI = ObservableField(0).apply {//跟reasonType一样，只是因为用到观察者数据绑定，动态刷新界面，所以新增这么个拷贝字段
            addOnPropertyChangedCallback(object: Observable.OnPropertyChangedCallback(){
                override fun onPropertyChanged(sender: Observable?, propertyId: Int) {
                    reasonType = ((sender as ObservableField<Int>?)?.get() ?:0) + 1
                }
            })
        }

        var workOrderNoUI = ObservableField("").apply {
            addOnPropertyChangedCallback(object: Observable.OnPropertyChangedCallback(){
                override fun onPropertyChanged(sender: Observable?, propertyId: Int) {
                    workOrderNo = (sender as ObservableField<String>?)?.get() ?:""
                }
            })
        }


        fun initUiProperties() {//构造后马上执行
            reasonTypeUI.set(reasonType - 1)
            workOrderNoUI.set(workOrderNo)
        }

        //工单处理时为工单号,巡店时为巡店记录id
        var typeList: List<String> = listOf("工单处理", "主动巡店","返程","中转换乘","其他","外区支援")

        var isWorkOrderNoSelecting = false//自建字段，标记是否是点击状态，用于点击选择工单后回调找到该item

        //Spinner改变时执行
        fun syncReasonType(pos: Int?){
            //改变Spinner时，要清空它（只有在与上次不一样的情况下，才清空）
            if (pos != reasonTypeUI.get()!!){
                workOrderNoUI.set("")
            }
            //试验证明，双向数据绑定比 onItemSelected(）监听要慢。。。
            pos?.let { reasonTypeUI.set(pos) }
//            reasonType = reasonTypeUI.get()!! + 1
        }
    }
}