package com.urovo.activity.machinetrip.ui

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.machinetrip.net.TripRecordRes
import com.urovo.activity.machinetrip.view.MachineTripAct
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.EngineerTripRecordItemBinding
import com.wgmf.trade.ui.ada.ViewHolderX

/**
 * @author Sasuke on 2019/10/29.
 */
class MachineRecordAdapter(val context0: Context, val dataList: List<TripRecordRes.ResultInfo>?) : RecyclerView.Adapter<ViewHolderX>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        val binding = DataBindingUtil.inflate<EngineerTripRecordItemBinding>(
                LayoutInflater.from(context0),
                R.layout.engineer_trip_record_item,
                parent,
                false)
        return ViewHolderX(binding.root)
    }

    override fun getItemCount(): Int {
        return dataList?.size ?: 0
    }

    override fun onBindViewHolder(holder: ViewHolderX, pos: Int) {
        val binding = DataBindingUtil.getBinding<EngineerTripRecordItemBinding>(holder.view)
        binding?.record = dataList?.get(pos)
        binding?.locationsRv?.run {
            layoutManager = object : LinearLayoutManager(context0) {
                override fun canScrollVertically(): Boolean {
                    return false
                }
            }
            adapter = MachineRecordChildAdapter(context0, dataList?.get(pos)?.id, dataList?.get(pos)?.locations)
        }
        binding?.itemRl?.setOnClickListener {
            val id = dataList?.get(pos)?.id
            MachineTripAct.launchWithId(context0, id)
        }
    }
}