package com.urovo.activity.machinetrip.ui

import android.content.Context
import android.os.Handler
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.machinetrip.model.MachineTripModel
import com.urovo.activity.machinetrip.net.TripRecordNewEntity
import com.urovo.activity.machinetrip.view.MachineOrderSelectAct
import com.urovo.activity.machinetrip.view.MachineTripAct
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.TripInputItemChildrenBinding
import com.wgmf.trade.ui.ada.ViewHolderX

/**
 * @author Sasuke on 2019-10-25 0025.
 */
class TripInputChildAdapter(val context: Context, val tripModel: MachineTripModel, val dataList: MutableList<TripRecordNewEntity.Details>) : RecyclerView.Adapter<ViewHolderX>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        val binding = DataBindingUtil.inflate<TripInputItemChildrenBinding>(
                LayoutInflater.from(context),
                R.layout.trip_input_item_children,
                parent,
                false)
        return ViewHolderX(binding.root)
    }

    override fun getItemCount(): Int {
        return dataList.size
    }

    override fun onBindViewHolder(holder: ViewHolderX, pos: Int) {
        val binding = DataBindingUtil.getBinding<TripInputItemChildrenBinding>(holder.view)
        val dataItem = dataList[pos]
        binding?.apply {
            entity = dataItem
            model = tripModel
            itemPos = holder.adapterPosition

            //删除元素
            itemDeleteBtn.setOnClickListener {
                dataList.removeAt(holder.adapterPosition)
//                notifyDataSetChanged()
                notifyItemRemoved(holder.adapterPosition)//用这个方法就图一个删除动画
                Handler().postDelayed({notifyDataSetChanged()},500)//因为后面的 第N站会发生变化，所以还是需要全局刷一下
            }

            //点击选择工单或巡店记录
            selectWorkOrderNoTv.setOnClickListener {
                dataItem.isWorkOrderNoSelecting = true
                (context as MachineTripAct).clickTextViewCache = selectWorkOrderNoTv//缓存起来，用于返回之后刷新UI
                MachineOrderSelectAct.launchForResult(context,when(dataItem.reasonType){
                    1 -> MachineOrderSelectAct.TYPE_MACHINE_BILL
                    2 -> MachineOrderSelectAct.TYPE_MACHINE_PATROL
                    else -> ""
                })
            }
            executePendingBindings()//防闪屏
            //停掉Spinner的监听锁
//            typeSpinner.setOnTouchListener { view, motionEvent ->
//                if (motionEvent.action == MotionEvent.ACTION_UP) {
//                    dataItem.spinnerIsLocked = false
//                };false
//            }
            //出差事由Spinner
//            typeSpinner.onItemSelectedListener = object : AdapterView.OnItemSelectedListener{
//                override fun onNothingSelected(parent: AdapterView<*>?) {
//                    dataItem.spinnerIsLocked = true
//                }
//
//                override fun onItemSelected(parent: AdapterView<*>?, view: View?, pos: Int, id: Long) {
//                    if (dataItem.spinnerIsLocked) return
//                    dataItem.reasonType = pos + 1
//                    selectWorkOrderNoTv.text = ""
//                    dataItem.workOrderNo = ""
//                    dataItem.spinnerIsLocked = true//执行完了再锁上
//                }
//            }

        }
    }


}