package com.urovo.activity.machinetrip.ui

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.appcompat.app.AppCompatActivity
import androidx.databinding.DataBindingUtil
import androidx.databinding.ObservableField
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.machinetrip.net.PatrolReportRes
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.EngineerPatrolSelectItemBinding
import com.wgmf.trade.ui.ada.ViewHolderX

/**
 * @author Sasuke on 2019-10-28 0028.
 */
class WorkNoSelectPatrolAdapter(val context: AppCompatActivity, val dataList: List<PatrolReportRes.ResultInfo>?) : RecyclerView.Adapter<ViewHolderX>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        val binding = DataBindingUtil.inflate<EngineerPatrolSelectItemBinding>(
                LayoutInflater.from(parent.context),
                R.layout.engineer_patrol_select_item,
                parent,
                false)
        return ViewHolderX(binding.root)
    }

    override fun getItemCount(): Int {
        return dataList?.size ?: 0
    }

    override fun onBindViewHolder(holder: ViewHolderX, pos: Int) {
        val binding = DataBindingUtil.getBinding<EngineerPatrolSelectItemBinding>(holder.view)
        if (dataList?.get(pos)?.isChecked == null){
            dataList?.get(pos)?.isChecked = ObservableField(false)
        }
        binding?.patrol = dataList?.get(pos)
        binding?.checkBox?.isClickable = false
        //选取
        holder.view.setOnClickListener {
//            datalist?.find { it.ischecked?.get() ?: false }?.ischecked?.set(false)
            dataList?.forEach { it.isChecked?.set(false) }
            dataList?.get(pos)?.isChecked?.set(true)
        }

        //工单
//        binding?.root?.setOnClickListener {  context.startActivityForResult(
//                Intent(context, EngineerBillDetailAct::class.java).apply {
//                    putExtra(EngineerBillDetailAct.INTENT_RES,dataList?.get(position))
//                }, EngineerBillDetailAct.REQUEST_CODE) }
        binding?.executePendingBindings()//防止数据更新时闪屏
    }
}