package com.urovo.activity.memberGoodsShare.model;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

import com.umeng.socialize.media.UMImage;
import com.urovo.wugumofang.ui.BitmapUtil;
import com.urovo.wugumofang.R;

import java.io.Serializable;

/**
 * Created by Sasuke on 2016/12/22.
 * 用于从前一个页面传值过来时的传输介质。（这是一个基类，其它要跳转到MemberGoodsQrCodeAct传值进来的都要继承它！）
 */

public class MemberQrEntity implements Serializable{
    int qrCodeId;//唯一性标识
    String qrUrl;//要用来生成二维码的url
    String imageUrl;//分享用的图片url
    String title;//分享标题
    String content;//分享内容
    byte[] bitmapBytes;//分享用的产品图片（因为要Activity之间传递，所以为了使能序列化，便用字节来存；
                                    //至于为什么要传bitmap，因为如果前面一个页面已经下载好了，那后面那个页面就没必要下载了，直接传过来用是效率最高的。 ）
    public int productTemplateId;//请求海报信息要用

    public UMImage getUMImage(Context context) {
        if (bitmapBytes == null || bitmapBytes.length == 0) {//防止万一没下载成功，就去点击分享。。。。。那就传个默认的图标。
            return new UMImage(context, BitmapFactory.decodeResource(context.getResources(), R.drawable.qr_ticket));
        }
        return new UMImage(context, BitmapUtil.bytes2Bitmap(bitmapBytes));
    }

        public Bitmap getImage() {
        if (bitmapBytes == null || bitmapBytes.length == 0) {
            return null;
        }
        return BitmapUtil.bytes2Bitmap(bitmapBytes);
    }

    public boolean hasImage(){
        return bitmapBytes == null || bitmapBytes.length == 0 ? false : true;
    }

    public void setImage(Bitmap bitmap) {
        this.bitmapBytes = BitmapUtil.bitmap2bytes(bitmap);
    }

    public String getQrUrl() {
        return qrUrl;
    }

    public String getImageUrl() {
        //防止url里有空格，提前把它换成%20
        return imageUrl.replace(" ","%20");
    }

    public int getQrCodeId() {
        return qrCodeId;
    }

    public String getTitle() {
        return title;
    }

    public String getContent() {
        return content;
    }
}
