package com.urovo.activity.memberGoodsShare.view;

import android.app.ProgressDialog;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Paint;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;

import androidx.cardview.widget.CardView;

import com.squareup.picasso.Picasso;
import com.umeng.socialize.Config;
import com.urovo.activity.memberGoodsShare.model.MemberQrEntity;
import com.urovo.activity.memberGoodsShare.net.MemSharePosterRes;
import com.urovo.activity.memberGoodsShare.presenter.MemberGoodsQrContract;
import com.urovo.activity.memberGoodsShare.presenter.MemberGoodsQrPresenter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.ui.ShareDominator;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;
import kotlin.Unit;
import kotlin.jvm.functions.Function0;

/**
 * 会员商品二维码
 * Created by Sasuke on 2016/12/21.
 */

public class MemberGoodsQrCodeAct extends BaseActivity implements MemberGoodsQrContract.view, View.OnClickListener {
    MemberGoodsQrPresenter presenter;
    @BindView(R.id.loading_progress)
    ProgressBar progressBar;
    @BindView(R.id.iv_erweima)
    ImageView erweimaShow;
    @BindView(R.id.bottomShareLayout)//底部 分享到 布局
            LinearLayout bottomShareLayout;
    @BindView(R.id.qrcodeLayout) LinearLayout qrcodeLayout;//二维码模式下的View
    @BindView(R.id.posterCardView) CardView posterCardView;//海报模式下的View

    //海报相关
    @BindView(R.id.posterImg) ImageView posterImg;//海报大图
    @BindView(R.id.proNameTv) TextView proNameTv;//产品名
    @BindView(R.id.specialPriceLabel) TextView specialPriceLabel;//秒杀价标签
    @BindView(R.id.bigPriceTv) TextView bigPriceTv;//大价格
    @BindView(R.id.smallPriceTv) TextView smallPriceTv;//小价格
    @BindView(R.id.qrcodeImg) ImageView qrcodeImg;//右下角小二维码
    @BindView(R.id.posterContentLayout) LinearLayout posterContentLayout;//最后需要图形化的海报布局


    TextView textTitle;
    ImageButton back;
    //    LinearLayout shareFriends;//分享给朋友
//    LinearLayout shareGroup;//分享到朋友圈
    public final static String ENTITY = "ENTITY";
    Unbinder unbinder;

    ShareDominator shareDominator;

    public final static String QR_CODE_TYPE = "QR_CODE_TYPE";//单二维码类型
    public final static String POSTER_TYPE = "POSTER_TYPE";//海报类型

    String activityType = QR_CODE_TYPE;//默认为二维码类型。。。吧

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ll_member_goods_act);
        unbinder = ButterKnife.bind(this);
        presenter = new MemberGoodsQrPresenter(this, this);
        presenter.setEntity((MemberQrEntity) getIntent().getSerializableExtra(ENTITY));//网络请求获取url，用于后面生成对应的二维码
        presenter.start();


        //初始化底栏分享（这个要放到setEntity()后面来做，要不然getDate()里的数据都没初始化，分享个毛）
        initShareBottom();
    }


    /**初始化底部分享按钮*/
    public void initShareBottom() {
        shareDominator = new ShareDominator(this, presenter.getData().getQrUrl(),"1");
        //初始化UI
        if (activityType.equals(QR_CODE_TYPE)){//二维码模式
            shareDominator.inflateBtnLayoutUI(bottomShareLayout,4)
                    .setShareBtns(ShareDominator.ENTERPRISE_WX,
                            ShareDominator.CIRCLE_WX,
                            ShareDominator.FRIENDS_WX,
                            ShareDominator.JUMP_SHARE_POSTER)
                    .isShowHeadLine(true)//显示“分享到”两边的横线
                    .isShowCancelBtn(false);//不显示底下取消按钮
        }else{//海报模式
            shareDominator.setEnable(false);//先禁用分享，等网络请求成功后，再启用分享。
            shareDominator.inflateBtnLayoutUI(bottomShareLayout,4)
                    .setShareBtns(ShareDominator.ENTERPRISE_WX_IMG,
                            ShareDominator.CIRCLE_WX_IMG,
                            ShareDominator.FRIENDS_WX_IMG,
                            ShareDominator.SAVE_LOCAL)
                    .isShowHeadLine(true)//显示“分享到”两边的横线
                    .isShowCancelBtn(false);//不显示底下取消按钮
        }

        //初始化分享内容
        shareDominator.setImage(presenter.getData().getEntity().getUMImage(this),
                "POSTER_" + presenter.getData().getEntity().productTemplateId);
        shareDominator.setWebTitle(presenter.getData().getTitle());
        shareDominator.setContentText(presenter.getData().getContent());
        shareDominator.setImageUrl(presenter.getData().getImageUrl());
        //跳转海报页
        shareDominator.setOnJumpSharePosterCallback(new Function0<Unit>() {
            @Override
            public Unit invoke() {
                Intent intent = new Intent(MemberGoodsQrCodeAct.this,MemberGoodsQrCodeAct.class);
                intent.putExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE, POSTER_TYPE);
                intent.putExtra(ENTITY, presenter.getData().getEntity());
                startActivity(intent);
                return null;
            }
        });

        //以下埋点（点击了就算数，用回调好像有问题。）
        shareDominator.setOnShared(buryPoint -> {
            presenter.buryPoint(buryPoint);
            return null;
        });
    }

    @Override
    public void init() {
        String type = getIntent().getStringExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE);
        activityType = type == null ? QR_CODE_TYPE : POSTER_TYPE;

        textTitle = (TextView) findViewById(R.id.text_title);
//        shareFriends = (LinearLayout) findViewById(R.id.share_to_friends);
//        shareGroup = (LinearLayout) findViewById(R.id.share_to_group);
        back = (ImageButton) findViewById(R.id.back);
        textTitle.setText(activityType.equals(QR_CODE_TYPE)? "会员商品二维码" : "分享海报");
        qrcodeLayout.setVisibility(activityType.equals(QR_CODE_TYPE)? View.VISIBLE : View.GONE);
        posterCardView.setVisibility(activityType.equals(QR_CODE_TYPE)? View.GONE : View.VISIBLE);
//        shareFriends.setOnClickListener(this);
//        shareGroup.setOnClickListener(this);
        if (activityType.equals(POSTER_TYPE)) {//海报模式，要专门请求
            presenter.requestPosterInfo(presenter.getData().getEntity().productTemplateId + "");
        }

         back.setOnClickListener(this);
    }

    /**刷新海报的回调*/
    @Override
    public void refreshPoster(MemSharePosterRes.ResultInfo resultInfo) {
        Picasso.with(this).load(resultInfo.getImgUrl()).into(posterImg);
        shareDominator.saveViewForBitmap(posterContentLayout,"POSTER_" + presenter.getData().getEntity().productTemplateId);
        proNameTv.setText(resultInfo.getProductTemplateName());
        qrcodeImg.setImageBitmap(presenter.getData().getErweima());
        //特价
        String bigPriceText = "￥"+ resultInfo.getMinPrice() + (resultInfo.getMaxPrice() == resultInfo.getMinPrice()? "" : "~" +resultInfo.getMaxPrice());
        bigPriceTv.setText(bigPriceText);
        //原价
        String smallPriceText =  resultInfo.getMinPrice() >= resultInfo.getPrice() ? "" : "￥"+ resultInfo.getPrice();
        smallPriceTv.setText(smallPriceText);
        smallPriceTv.setPaintFlags(smallPriceTv.getPaintFlags() | Paint.STRIKE_THRU_TEXT_FLAG);
        posterCardView.setForeground(null);
        new Handler().postDelayed(new Runnable() {
            @Override
            public void run() {
                //先禁用分享，等网络请求成功后，再启用分享。
                shareDominator.setEnable(true);
            }
        },1_000);//网络请求成功后，加载图片可能还需要一点时间，所以等1秒之后再启用分享的点击
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.back:
                finish();
                break;
//            case R.id.share_to_friends://分享给朋友
//                showDialog();
//                presenter.share2Friends(this, umShareListener);
//                break;
//            case R.id.share_to_group://分享到朋友圈
//                showDialog();
//                presenter.share2Group(this, umShareListener);
//                break;
            default:
                break;
        }
    }


    private void showDialog() {
        ProgressDialog dialog = new ProgressDialog(this);
        dialog.setTitle("启动分享中");
        dialog.setMessage("请稍等.....");
        Config.dialog = dialog;
    }

//    private UMShareListener umShareListener = new UMShareListener() {
//        @Override
//        public void onResult(SHARE_MEDIA platform) {
//            showMsg("分享成功");
//            if (platform.name().equals("WEIXIN")) {//分享给朋友
//                presenter.buryPoint(1);
//            } else if (platform.name().equals("WEIXIN_CIRCLE")) {//分享到朋友圈
//                presenter.buryPoint(0);
//            }
//        }
//
//        @Override
//        public void onError(SHARE_MEDIA platform, Throwable t) {
//            showMsg("分享失败");
//        }
//
//        @Override
//        public void onCancel(SHARE_MEDIA platform) {
//            showMsg("分享取消");
//        }
//    };

    @Override
    public void refreshUI(final Bitmap erweima) {
        if (this == null || this.isFinishing()) {
            return;
        }
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (progressBar != null && erweimaShow != null) {
                    progressBar.setVisibility(View.GONE);
                    erweimaShow.setVisibility(View.VISIBLE);
                    erweimaShow.setImageBitmap(erweima);
                }
            }
        });
    }

    @Override
    protected void onDestroy() {
        unbinder.unbind();
        super.onDestroy();
    }

    @Override
    public void setPresenter(Object presenter) {
        this.presenter = (MemberGoodsQrPresenter) presenter;
    }
}
