package com.urovo.activity.membererweima.presenter;

import android.text.TextUtils;

import com.urovo.activity.membererweima.model.MemGoodsListData;
import com.urovo.activity.membererweima.net.MemGoodsExRes;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseSimpleResponse;
import com.urovo.wugumofang.system.SystemHelper;

import java.util.HashMap;
import java.util.List;

import okhttp3.Request;

import static com.urovo.wugumofang.constants.NetParam.WEIXIN_SERVER;

/**
 * Created by Sasuke on 2017/3/17.
 */

public class MemGoodsListPresenter implements MemGoodsListContract.presenter {
    MemGoodsListContract.view mView;
    MemGoodsListData data;
    public MemGoodsListPresenter(MemGoodsListContract.view mView) {
        this.mView = mView;
        mView.setPresenter(this);
    }

    @Override
    public void start() {
        mView.initUI();
        mView.query();
    }

    public MemGoodsListData getData(){
        if (data == null){
            data = new MemGoodsListData();
        }
        return data;
    }

    /**
     *  搜索产品
     */
    public void searchProduct(String keyword){
        List<MemGoodsExRes.Data.PurchaseData.QrCodeInfo> resultList = getData().searchByKeyWord(keyword);
        mView.showSearchResult(resultList);
    }

    /**获取会员商品*/
    public void queryProducts(){
//        OkHttpDominator.getAsyn(WEIXIN_SERVER+ ApiUrls.Weix);
        OkHttpDominator.getAsyn(WEIXIN_SERVER + ApiUrls.WeiXin.MEMBER_GOODS_LIST
                + "/"+SystemHelper.LoginUserId
                +"/"+SystemHelper.LoginOrganId, null,
                new OkHttpDominator.ResultCallback<MemGoodsExRes>() {
                            @Override
                            public void onError(Request request, Exception e) {
                                e.printStackTrace();
                                mView.showMsg("请求失败"+e.toString());
                                mView.showNetError();
                            }

                            @Override
                            public void onResponse(MemGoodsExRes res) {
                                if(res == null || res.checkDataIsNull()){
                                    mView.showMsg("没有数据");
                                    mView.showNoData();
                                    mView.refreshUI();
                                    return ;
                                }
                                getData().transRes2Data(res.getData());//转换数据并保存
                                mView.refreshUI();
                            }
        });
    }

    /**
     * 判断会员商城允许使用
     */
    public void checkIsAllowUse(){
        mView.showLoading();
        HashMap<String,String> params = new HashMap<>();
        params.put("staffId",SystemHelper.LoginUserId);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.IS_SHOW_MEMBERGOODS,
                params,
                new OkHttpDominator.ResultCallback<BaseSimpleResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        e.printStackTrace();
                        mView.showMsg("请求失败"+e.toString());
                        mView.showNetError();
                    }

                    @Override
                    public void onResponse(BaseSimpleResponse res) {
                        if(res == null){
                            mView.showNetError();
                            return;
                        }
                        if(res.msgCode == 0){//功能允许使用
                            queryProducts();//那就开始请求真正的数据
                        }else{//不允许使用
                            String msg = TextUtils.isEmpty(res.msgInfo)? "上班时间此功能暂停使用，请下班后使用！" : res.msgInfo;
                            mView.showLoadWaitText(msg);
                        }
                    }
                });
    }
}
