package com.urovo.activity.membererweima.ui

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.*
import com.squareup.picasso.Picasso
import com.urovo.activity.memberGoodsShare.view.MemberGoodsQrCodeAct
import com.urovo.activity.membererweima.model.MemGoodsListData
import com.urovo.wugumofang.R
import com.urovo.wugumofang.ui.BitmapUtil
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2018/7/1.
 * 第三方框架的BUG不会改。。。无奈重新写一个。。。
 */
class MemGoodsExAdapter3(val context: Context, var dataList: MutableList<MemGoodsListData.GroupEntity>) : BaseExpandableListAdapter() {
    override fun getGroup(groupPosition: Int): Any {
        return groupPosition
    }

    override fun isChildSelectable(groupPosition: Int, childPosition: Int): Boolean {
        return false
    }

    override fun hasStableIds(): Boolean {
        return false
    }

    override fun getGroupView(groupPosition: Int, isExpanded: Boolean, convertView: View?, parent: ViewGroup?): View {
        var holder: GroupHolder? = null
        var view: View
        if (convertView != null) {
            view = convertView.apply { holder = this.tag as GroupHolder }
        } else {
            view = LayoutInflater.from(context).inflate(R.layout.ll_member_goods_group, parent, false)
            view.tag = GroupHolder().apply {
                titleRadioButton = view.find(R.id.mem_group_title)
                holder = this
            }
        }
        //填充数据
        holder?.titleRadioButton?.apply {
            text = "${dataList[groupPosition].title}（${dataList[groupPosition].count}）"
            dataList[groupPosition].isExpanded = isExpanded//其实这个要不要无所谓。
            isChecked = isExpanded
        }

        return view
    }

    override fun getChildView(groupPosition: Int, childPosition: Int, isLastChild: Boolean, convertView: View?, parent: ViewGroup?): View {
        var holder: ChildHolder? = null
        var view: View
        if (convertView != null) {
            view = convertView.apply { holder = this.tag as ChildHolder }
        } else {
            view = LayoutInflater.from(context).inflate(R.layout.ll_member_goods_child, parent, false)
            view.tag = ChildHolder().apply {
                titleRadioButton = view.find(R.id.childTitle)
                secondContainer = view.find(R.id.secondContainer)
                blankTop = view.find(R.id.blankTop)
                blankBottom = view.find(R.id.blankBottom)
                holder = this
            }
        }
        var child = dataList[groupPosition].children?.get(childPosition)
        //显隐填充物
        setBlankVisibility(holder,childPosition,getChildrenCount(groupPosition))

        //填充数据
        holder?.titleRadioButton?.apply {
            text = "${child?.title}（${child?.count}）"
            isChecked = child?.isExpanded ?: false
            holder?.secondContainer?.visibility = if (isChecked) View.VISIBLE else View.GONE
            setOnClickListener { btn: View? ->
                child?.isExpanded = !(child?.isExpanded ?: false)//取相反，赋自己
                (btn as RadioButton).isChecked = child?.isExpanded ?: false
                holder?.secondContainer?.visibility = if (isChecked) View.VISIBLE else View.GONE
                notifyDataSetChanged()
            }
        }

        //如果复用容器里的旧组件比新数据还多，那就直接清除再重新创建添加；否则就复用容器
        if (holder?.secondContainer?.childCount ?: 0 > child?.datas?.size ?: 0) {
            holder?.secondContainer?.removeAllViews()
        }

        //只有在展开的时候才创建组件。。。相当于懒加载。。。减轻卡顿。
        child?.takeIf { it?.isExpanded }?.datas?.forEachIndexed { index, data ->
            var dataView: View?
            //如果没有该序号旧组件可复用，就新建一个，添加进去。
            if (holder?.secondContainer?.getChildAt(index) == null) {
                dataView = LayoutInflater.from(context).inflate(R.layout.ll_member_goods_list_item, parent, false)
                holder?.secondContainer?.addView(dataView, index)
            } else {//如果有，就直接复用。
                dataView = holder?.secondContainer?.getChildAt(index) as View
            }
            //对子组件初始化
            dataView?.apply {
//                setLayerType(View.LAYER_TYPE_SOFTWARE, null)//要显示虚线，必须要设这个，否则就会显示成实线了
                //分割线的显隐，第0位显示实线，后面的显示虚线
                find<View>(R.id.lineDivider).visibility = if (index == 0) View.VISIBLE else View.GONE
                find<View>(R.id.dashDivider).visibility = if (index != 0) View.VISIBLE else View.GONE

                find<TextView>(R.id.mem_goods_name).text = data?.productTemplateName
                val memImg = find<ImageView>(R.id.mem_goods_img).apply {
                    if (data != null && !data.imageUrl.isNullOrEmpty()) {//防空
                        Picasso.with(context).load(data.imageUrl)/*.resize(120,120)*/.into(this)
                    } else {
                        this.setImageResource(R.drawable.wgmf_logo)
                    }
                }
                //分享按钮
                find<Button>(R.id.mem_goods_share).setOnClickListener {
                    val intent = Intent(context, MemberGoodsQrCodeAct::class.java)
                    intent.putExtra(MemberGoodsQrCodeAct.ENTITY, data.apply {
                        memImg.getDrawable()?.let { data?.image = BitmapUtil.imageView2Bitmap(memImg) }
                    })
                    context.startActivity(intent)
                }
            }
        }
        return view
    }

    override fun getChildrenCount(groupPosition: Int): Int {
        return dataList[groupPosition].children?.size ?: 0
    }

    override fun getChild(groupPosition: Int, childPosition: Int): MemGoodsListData.GroupEntity? {
        return dataList[groupPosition].children?.get(childPosition)
    }

    override fun getGroupId(groupPosition: Int): Long {
        return groupPosition.toLong()
    }

    override fun getChildId(groupPosition: Int, childPosition: Int): Long {
        return childPosition.toLong()
    }

    override fun getGroupCount(): Int {
        return dataList.size
    }


    //以下Holder
    class GroupHolder() {
        lateinit var titleRadioButton: RadioButton
    }

    class ChildHolder {
        lateinit var titleRadioButton: RadioButton
        lateinit var secondContainer: LinearLayout
        //因为首个child和尾个child的空隙会更大些，所以塞个空的填充物View
        lateinit var blankTop: View
        lateinit var blankBottom: View
    }

    //设置首尾空白填充物的显隐
    fun setBlankVisibility(holder: ChildHolder?,index: Int,size: Int){
        holder?.blankTop?.visibility = if (index == 0) View.VISIBLE else View.GONE
        holder?.blankBottom?.visibility = if (index == size - 1) View.VISIBLE else View.GONE
    }
}