package com.urovo.activity.membererweima.view;

import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ExpandableListView;
import android.widget.RelativeLayout;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.activity.membererweima.net.MemGoodsExRes;
import com.urovo.activity.membererweima.presenter.MemGoodsListContract;
import com.urovo.activity.membererweima.presenter.MemGoodsListPresenter;
import com.urovo.activity.membererweima.ui.MemGoodsExAdapter3;
import com.urovo.activity.membererweima.ui.MemGoodsListAdapter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.view.LoadWaitDominator;
import com.urovo.wugumofang.view.baseWebViewAct.WebViewAct;
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra;

import java.util.List;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * @author Sasuke
 * @date 2017/3/17
 * 会员商品分享列表（更多页面里的，是List那个，不是二维码那个！！）
 */
@Route(path = RouterParams.Member.MEMBER_GOODS)
public class MemberGoodsAct extends BaseActivity
        implements MemGoodsListContract.view, View.OnClickListener {
    MemGoodsListPresenter mPre;
    @BindView(R.id.member_goods_list)
    ExpandableListView lv;
//    @BindView(R.id.list_progress)
//    ProgressBar progress;
    @BindView(R.id.searchBar)
    EditText searchBar;
    @BindView(R.id.searchResultLayout)
    RelativeLayout searchLayout;//关键词搜索结果布局
    @BindView(R.id.containerLayout)
    ViewGroup containerLayout;//loadWait容器
    RecyclerView resultLv;//关键词搜索结果列表

    Button saleQueryBtn;//底部销售查询按钮
    Button rankingBtn;//底部排名情况按钮
    Button myClientsBtn;//底部我的客户按钮
    //    MemGoodsListAdapter adapter;
    MemGoodsExAdapter3 adapter;
    Unbinder unbinder;
    LoadWaitDominator loadWait;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ll_member_goods_list_act);
        unbinder = ButterKnife.bind(this);
        initTitle();
        mPre = new MemGoodsListPresenter(this);
        mPre.start();
    }

    @Override
    public void initUI() {
        titleTextView.setText("会员商品转发");
//        lv.setLayoutManager(new LinearLayoutManager(this, OrientationHelper.VERTICAL, false));
        //设置Item增加、移除动画
//        lv.setItemAnimator(new DefaultItemAnimator());
        //添加分割线
//        lv.addItemDecoration(new DividerItemDecoration(this, DividerItemDecoration.VERTICAL_LIST));
//        lv.addItemDecoration(new RecycleViewDivider(this, LinearLayoutManager.VERTICAL));
//        lv.setAdapter(adapter);
        lv = (ExpandableListView) findViewById(R.id.member_goods_list);
//        lv.setLayoutManager(new LinearLayoutManager(this));

        resultLv = (RecyclerView) searchLayout.findViewById(R.id.resultList);
        resultLv.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));

        saleQueryBtn = (Button) findViewById(R.id.saleQueryBtn);
        rankingBtn = (Button) findViewById(R.id.rankingBtn);
        myClientsBtn = (Button) findViewById(R.id.myClientsBtn);

        saleQueryBtn.setOnClickListener(this);
        rankingBtn.setOnClickListener(this);
        myClientsBtn.setOnClickListener(this);
        searchBar.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                String searchText = s.toString();
                if ("".equals(searchText)) {
                    searchLayout.setVisibility(View.GONE);
                } else {
                    searchLayout.setVisibility(View.VISIBLE);
                    mPre.searchProduct(searchText);
                }
            }
        });
        loadWait = new LoadWaitDominator(this,containerLayout);
    }

    /**
     * 显示搜索结果
     *
     * @param resultList ...
     */
    @Override
    public void showSearchResult(List<MemGoodsExRes.Data.PurchaseData.QrCodeInfo> resultList) {
        if (resultList != null) {
            resultLv.setAdapter(new MemGoodsListAdapter(this, resultList));
            resultLv.setVisibility(resultList.size() == 0 ? View.GONE : View.VISIBLE);
        }
    }

    @Override
    public void query() {
        mPre.checkIsAllowUse();
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.saleQueryBtn:
                BaseCookiesWebFra.launch(this, String.format(NetParam.MEMBER_SALE, SystemHelper.LoginOrganName, SystemHelper.LoginUserId, SystemHelper.LoginUserName, SystemHelper.LoginOrganId), "", true);
                break;
            //会员商城排名情况
            case R.id.rankingBtn:
                WebViewAct.launch(this, SystemHelper.LoginUserId,"会员商品销售查询", String.format(NetParam.MEMBER_GOODS_RANK,
                        SystemHelper.LoginOrganName,
                        SystemHelper.LoginUserId,
                        SystemHelper.LoginUserName));
                break;
            //我的客户
            case R.id.myClientsBtn:
                WebViewAct.launch(this,SystemHelper.LoginUserId, "我的客户", String.format(NetParam.MEMBER_GOODS_MY_CLIENTS,
                        SystemHelper.LoginUserId));
            default:
        }
    }

    @Override
    public void refreshUI() {
        if (isFinishing()){
            return;
        }
//        if (progress != null) {
//            progress.setVisibility(View.GONE);
//        }
        if(mPre.getData().getProductList() == null || mPre.getData().getProductList().size() == 0){
            showNoData();
            return;
        }
        dismissLoadWait();

        //把第一个Group的第一个child展开，其它都收缩。
        mPre.getData().getProductList().get(0).getChildren().get(0).setExpanded(true);
        adapter = new MemGoodsExAdapter3(this, mPre.getData().getProductList());
        lv.setAdapter(adapter);
        int size = mPre.getData().getProductList().size();
        if(size > 0){
            lv.expandGroup(0,false);
        }
//        if (size > 0) {
////            adapter.expandAll();
//           //后台没配置好，导致一进去没有数据，所以先展开一段，让别人能看到产品
//            adapter.expandAll(0,false,false);
//        }
    }

    @Override
    public void setPresenter(Object presenter) {
        this.mPre = (MemGoodsListPresenter) presenter;
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (unbinder != null) {
            unbinder.unbind();
        }
    }

    @Override
    public void showNoData() {
        if(loadWait != null){
            loadWait.show(LoadWaitDominator.NO_DATA);
        }
    }

    @Override
    public void showLoadWaitText(String text) {
        if(loadWait != null){
            loadWait.show(text);
        }
    }

    @Override
    public void showNetError() {
        if(loadWait != null){
            loadWait.show(LoadWaitDominator.NET_ERROR);
        }
    }

    @Override
    public void showLoading() {
        if(loadWait != null){
            loadWait.show(LoadWaitDominator.LOADING);
        }
    }

    @Override
    public void dismissLoadWait() {
        if(loadWait != null){
            loadWait.dismissAll();
        }
    }
}
