package com.urovo.activity.membergroup.JiFenDaoQiTiXing.view;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.activity.MemberProfile.view.MemberProfileAct;
import com.urovo.activity.membergroup.JiFenDaoQiTiXing.model.JiFenDaoQiTiXingEntity;
import com.urovo.activity.membergroup.JiFenDaoQiTiXing.model.JiFenDaoQiTiXingResponse;
import com.urovo.activity.membergroup.JiFenDaoQiTiXing.ui.JiFenDaoQiAdapter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.system.SystemHelper;

import java.util.List;

import androidx.fragment.app.Fragment;

/**
 * Created by Sasuke on 2016/5/16.
 * ...
 */
public class JiFenDaoQiFra extends Fragment {
    private List<JiFenDaoQiTiXingEntity> mList;
    private JiFenDaoQiAdapter myAdapter;
    private int mType;

    JiFenDaoQiTiXingResponse res;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        final Bundle bundle = getArguments();
        if (bundle != null) {
            res = (JiFenDaoQiTiXingResponse) bundle.get("mList");
            mType = (int) bundle.get("mType");
            mList = res.getList(mType);
        }

        View view = inflater.inflate(R.layout.jifen_daoqi_list, container, false);
        TextView tipsDatetimeTv = (TextView) view.findViewById(R.id.tips_datetime_tv);
        String tempName = "";

        switch (mType) {
            case 1:
                tempName = SystemHelper.LoginOrganName + ",积分将在10天后到期名单";
                break;
            case 2:
                tempName = SystemHelper.LoginOrganName + ",积分将在9天后到期名单";
                break;
            case 3:
                tempName = SystemHelper.LoginOrganName + ",积分将在8天后到期名单";
                break;
            default:
                break;
        }

        tipsDatetimeTv.setText(tempName);
        ListView mLv = (ListView) view.findViewById(R.id.jifen_list);
        if (mList != null) {
            mLv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                    Intent intent = new Intent(getActivity(), MemberProfileAct.class);
                    intent.putExtra("phone", (mList.get(position)).customerMobile);
                    //intent.putExtra("mType", bundle.getInt("mType", 1));//告诉它这条新客记录是从哪个标签来的，10天过期，还是30天过期;先修改成默认为10;
                    intent.putExtra("mType", 1);//告诉它这条新客记录是从哪个标签来的，10天过期，还是30天过期;先修改成默认为10;
                    intent.putExtra("entity", mList.get(position));//只用传对应会员的Entity就行了
                    intent.putExtra("position", position);
                    intent.putExtra("careType", "2");//关怀类型 默认1新客三响炮 2积分到期提醒 3砖石会员
                    startActivityForResult(intent, 1);
                }

            });
            myAdapter = new JiFenDaoQiAdapter(getActivity(), mList);
            mLv.setAdapter(myAdapter);
        }
        return view;
    }

    /**
     * 把手机号码转换成带分隔线的字符串
     *
     * @param customerMobile 原手机号字符串
     * @return 转换后生成的手机号
     */
    @SuppressWarnings("unused")
    private String transMobile(String customerMobile) {
        char c;
        StringBuilder sb = new StringBuilder(customerMobile);
        sb.replace(3, 7, "****");
        return sb.toString();
    }

    /**
     * 主要用于关闭新客详情Activity后，对本页面的列表状态标识进行刷新
     *
     * @param requestCode ...
     * @param resultCode  ...
     * @param data        ...
     */
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        int position = data.getIntExtra("position", -1);
        if (position != -1 && resultCode == 1) {//如果回访信息上传成功
            JiFenDaoQiTiXingEntity cell = (JiFenDaoQiTiXingEntity) data.getSerializableExtra("entity");
            mList.set(position, cell);//把该position上的元素给覆盖掉
            myAdapter.notifyDataSetChanged();
        }

    }
}
