package com.urovo.activity.membergroup.JiFenDaoQiTiXing.view;

import android.os.Bundle;
import android.view.View;
import android.widget.ImageButton;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.activity.slidemenu.NoDataFrag;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.RouterParams;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentTransaction;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 积分到期提醒
 *
 * @author Sasuke
 * @date 2016/5/16
 */
@Route(path = RouterParams.Member.OLD_GUEST_AWAKENS)
public class JiFenDaoQiTiXingAct extends BaseActivity {
    JiFenDaoqiContainerFra jiFenDaoqiContainerFra;//显示积分到期表的Frag
    NoDataFrag noDataFrag;//无新客信息时显示的带提示的Fragment
    @BindView(R.id.gift_tips_tab_rb)
    RadioButton giftTipsTabRb;
    @BindView(R.id.exchange_invitation_tab_rb)
    RadioButton exchangeInvitationTabRb;
    //BlankFrag blankFrag;

    private RadioGroup group_rg;
    public static final String TAKEOUT = "takeout";
    public static final String INTRODUCE = "introduce";
    Unbinder unbinder;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_jifen_daoqi);
        unbinder = ButterKnife.bind(this);

        titleTextView = findViewById(R.id.text_title);
        titleTextView.setText("老客唤醒");
        ImageButton goback = findViewById(R.id.goback);
        goback.setOnClickListener(v -> finish());

        findViews();
        //初始化;
        jiFenDaoqiContainerFra =
                (JiFenDaoqiContainerFra) getSupportFragmentManager().findFragmentByTag(TAKEOUT);
        noDataFrag = (NoDataFrag) getSupportFragmentManager().findFragmentByTag(INTRODUCE);

        showByIntent();//根据传进来的intent来跳转不同标签
    }

    public void showByIntent() {
        int type = getIntent().getIntExtra(AppConstants.ExtraKeys.JIFENDAOQI_DEFAULT_LABEL, 1);
        switch (type) {
            case 2:
                group_rg.findViewById(R.id.exchange_invitation_tab_rb).performClick();
                break;
        }
    }

    /**
     * 获取上方标签按钮组件
     */
    public void findViews() {
        group_rg = (RadioGroup) findViewById(R.id.group_rg);
        group_rg.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                switch (checkedId) {
                    case R.id.gift_tips_tab_rb:
                        giftTipsTabRb.setTextColor(getResources().getColor(R.color.title_yellow_bg));
                        exchangeInvitationTabRb.setTextColor(getResources().getColor(R.color.text_saomiao_gray));
                        changeFragment(TAKEOUT);
                        break;
                    case R.id.exchange_invitation_tab_rb:
                        exchangeInvitationTabRb.setTextColor(getResources().getColor(R.color.title_yellow_bg));
                        giftTipsTabRb.setTextColor(getResources().getColor(R.color.text_saomiao_gray));
                        changeFragment(INTRODUCE);
                        break;
                }
            }
        });
    }

    protected void changeFragment(String tag) {
        Fragment hideFragment = null;
        Fragment showFragment = null;
        FragmentTransaction transaction = getSupportFragmentManager().beginTransaction();
        if (TAKEOUT.equals(tag)) {
            showFragment = jiFenDaoqiContainerFra;
            hideFragment = noDataFrag;
        } else {
            showFragment = noDataFrag;
            hideFragment = jiFenDaoqiContainerFra;
        }
        transaction.hide(hideFragment);
        transaction.show(showFragment);
        transaction.commit();
    }
}
