package com.urovo.activity.membergroup.JiFenDaoQiTiXing.view;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import com.urovo.activity.membergroup.JiFenDaoQiTiXing.model.JiFenDaoQiTiXingCountEntity;
import com.urovo.activity.membergroup.JiFenDaoQiTiXing.model.JiFenDaoQiTiXingEntity;
import com.urovo.activity.membergroup.JiFenDaoQiTiXing.model.JiFenDaoQiTiXingResponse;
import com.urovo.activity.membergroup.JiFenDaoQiTiXing.presenter.JiFenDaoQiContract;
import com.urovo.activity.membergroup.JiFenDaoQiTiXing.presenter.JiFenDaoQiPresenter;
import com.urovo.activity.slidemenu.BlankFrag;
import com.urovo.activity.slidemenu.NoDataFrag;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.SetFocusUtil;
import com.urovo.wugumofang.utils.CommonTools;

import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import androidx.fragment.app.Fragment;

/**
 * 积分到期提醒
 *
 * @author Sasuke
 * @date 2016/5/16
 */
public class JiFenDaoqiContainerFra extends Fragment implements View.OnFocusChangeListener, View.OnClickListener, JiFenDaoQiContract.View {
    private TextView mTextViewStore;
    private TextView mTextViewDate;
    private JiFenDaoQiTiXingCountEntity mEntity;

    private Button today_btn;
    private Button yesterday_btn;
    private Button before_yesterday_btn;
    private int mType;
    private Date mDate;
    SimpleDateFormat sdfShow;//格式为"yyyy年MM月dd日"的显示格式

    private List<JiFenDaoQiTiXingEntity> mList = new ArrayList<>();//获取客户列表数据时网络传回的数据实体列表
    JiFenDaoQiFra listFra;//显示积分到期表的Frag
    NoDataFrag noDataFrag;//无新客信息时显示的带提示的Fragment
    BlankFrag blankFrag;

    JiFenDaoQiContract.Presenter mPresenter;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fra_jifen_daoqi_container, container, false);
        initWidgetAndEvent(view);
        mPresenter = new JiFenDaoQiPresenter(this);
        mPresenter.getOverPointCustomerList();
        return view;
    }

    private void initWidgetAndEvent(View view) {
        mType = 1;//积分过期提醒中，1是10天，2是30天
        findViews(view);//获取上方标签按钮组件
        setListeners();
    }


    /**
     * 获取上方标签按钮组件
     */
    public void findViews(View view) {
        //日期选择器的默认显示
        mDate = new Date();
        sdfShow = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
        mTextViewDate = (TextView) view.findViewById(R.id.textViewDate);
        mTextViewDate.setText(sdfShow.format(mDate));

        mTextViewStore = (TextView) view.findViewById(R.id.textViewStore);
        mTextViewStore.setText(SystemHelper.LoginOrganName);
        today_btn = (Button) view.findViewById(R.id.today_btn);
        SetFocusUtil.focus(today_btn);
        today_btn.setTextColor(getResources().getColor(R.color.title_yellow_bg));//再来一波字体染色
        yesterday_btn = (Button) view.findViewById(R.id.yesterday_btn);
        before_yesterday_btn = (Button) view.findViewById(R.id.before_yesterday_btn);

        noDataFrag = new NoDataFrag();//显示“暂无数据”
        blankFrag = new BlankFrag();
        //listFra = new JiFenDaoQiFra();//有新客信息时显示此Fra
    }

    /**
     * 给标签按钮挂监听器（包括点击监听、焦点改变监听
     */
    public void setListeners() {
        today_btn.setOnClickListener(this);
        yesterday_btn.setOnClickListener(this);
        before_yesterday_btn.setOnClickListener(this);

        today_btn.setOnFocusChangeListener(this);
        yesterday_btn.setOnFocusChangeListener(this);
        before_yesterday_btn.setOnFocusChangeListener(this);
    }


    /**
     * 监听上端标签的点击
     *
     * @param v 标签按钮
     */
    @Override
    public void onClick(View v) {
        int id = v.getId();
        switch (id) {
            case R.id.today_btn:
                SetFocusUtil.focus(today_btn);
                break;
            case R.id.yesterday_btn:
                SetFocusUtil.focus(yesterday_btn);
                break;
            case R.id.before_yesterday_btn:
                SetFocusUtil.focus(before_yesterday_btn);
                break;
            /*case R.id.linearLayoutDate://改日期的那个点击区域
                Calendar c = Calendar.getInstance();
                new DatePickerDialog(JiFenDaoQiTiXingAct.this,
                        new DatePickerDialog.OnDateSetListener() {
                            @Override
                            public void onDateSet(DatePicker view, int year,
                                                  int monthOfYear, int dayOfMonth) {
                                if (mDate.getYear() != (year - 1900)
                                        || mDate.getMonth() != monthOfYear
                                        || mDate.getDate() != dayOfMonth) {
                                    mDate.setYear(year - 1900);
                                    mDate.setMonth(monthOfYear);
                                    mDate.setDate(dayOfMonth);

                                    Date today = new Date();
                                    //所选日期大于当今日期
                                    if(DateUtil.diffDate(mDate,today) >= 0 && mDate.getDate() != today.getDate()){
                                        showMsg("不支持查今天之后的数据");
                                        return;
                                    }
                                    mTextViewDate.setText(sdfShow.format(mDate));
                                    getFragmentManager().beginTransaction().replace(R.id.jifen_list_fra_container,blankFrag).commit();
                                    //mPresenter.requestCount(mDate,mList);
                                    mPresenter.requestUserData(mDate,1);
                                }
                            }
                        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c
                        .get(Calendar.DAY_OF_MONTH)).show();
                break;*/
            default:
                break;
        }
    }

    /**
     * 监听标签的焦点变化
     *
     * @param v        ...
     * @param hasFocus ...
     */
    @Override
    public void onFocusChange(View v, boolean hasFocus) {
        if (hasFocus) {
            ((Button) v).setTextColor(getResources().getColor(R.color.title_yellow_bg));
            int id = v.getId();
            switch (id) {
                case R.id.today_btn:
                    mType = 1;
                    break;
                case R.id.yesterday_btn:
                    mType = 2;
                    break;
                case R.id.before_yesterday_btn:
                    mType = 3;
                    break;
                default:
                    break;
            }
//           getFragmentManager().beginTransaction().replace(R.id.jifen_list_fra_container, blankFrag).commit();
            CommonTools.INSTANCE.replace(this, R.id.jifen_list_fra_container, blankFrag);
            mPresenter.getOverPointCustomerList();
        } else {
            ((Button) v).setTextColor(getResources().getColor(R.color.text_saomiao_gray));
        }
    }

    public void displayResult(JiFenDaoQiTiXingResponse response) {


     /*   if ("query".equals(tag) && null != response) {
            JiFenDaoQiTiXingCountResponse res = (JiFenDaoQiTiXingCountResponse) response;
            if (null != res.getList() && res.getList().size() > 0) {
                mEntity = res.getList().get(0);
                //把人数显示在标签上
                mTenDayBtn.setText("10天" + "(" + mEntity.firstCareCustomerNum + ")");
                mThirtyDayBtn.setText("30天" + "(" + mEntity.secondCareCustomerNum + ")");
                //mFortyFiveDayBtn.setText("45天待回头(" + mEntity.thirdCareCustomerNum + ")");
                mPresenter.requestUserData(mDate,1);//获取完了三项的各个数量后，马上去获取具体的客户数据
            }
        }else */
        //if("queryData".equals(tag) && null != response){//下载客户列表数据
        if (null != response) {//下载客户列表数据
            JiFenDaoQiTiXingResponse res = response;
            if (null != res.getList(1) && res.getList(1).size() > 0) {
                today_btn.setText(MessageFormat.format("今天({0})", res.getList(1).size()));
            } else {
                today_btn.setText("今天(0)");
            }
            if (null != res.getList(2) && res.getList(2).size() > 0) {
                yesterday_btn.setText(MessageFormat.format("昨天({0})", res.getList(2).size()));
            } else {
                yesterday_btn.setText("昨天(0)");
            }
            if (null != res.getList(3) && res.getList(3).size() > 0) {
                before_yesterday_btn.setText(MessageFormat.format("前天({0})", res.getList(3).size()));
            } else {
                before_yesterday_btn.setText("前天(0)");
            }
            //有新客信息时显示此Fra,放这里也是临时解决问题；
            listFra = new JiFenDaoQiFra();
            Bundle bundle = new Bundle();
            bundle.putSerializable("mList", res);
            bundle.putInt("mType", mType);
            listFra.setArguments(bundle);
            //if (!fragment.isAdded()) {
            CommonTools.INSTANCE.replace(this, R.id.jifen_list_fra_container, listFra);
        } else {//暂无数据
            today_btn.setText("今天(0)");
            yesterday_btn.setText("昨天(0)");
            before_yesterday_btn.setText("前天(0)");
//            getFragmentManager().beginTransaction().replace(R.id.jifen_list_fra_container, noDataFrag).commit();
            CommonTools.INSTANCE.replace(this, R.id.jifen_list_fra_container, noDataFrag);
        }
    }

    @Override
    public void showOverPointCustomerList(JiFenDaoQiTiXingResponse response) {
        displayResult(response);
    }

    @Override
    public void setPresenter(Object presenter) {
    }
}