package com.urovo.activity.messagecenter.model;

import com.urovo.activity.messagecenter.net.SysMsgModel;
import com.urovo.activity.messagecenter.presenter.MsgCenterContract;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Sasuke on 2016/10/8.
 */

public class MsgDetailData implements MsgCenterContract.baseData {
    List<SysMsgModel> dataList = new ArrayList<>();
    int pageNum = 0;//这个是将要发送给接口获取的下一页页码，而不是当前页的
    int msgAmount = 0;//未读消息总数
    int actType;//1、新客三响炮回访  2、积分到期提醒  3、优惠券到期提醒  4、订货提醒  5、盘点提醒  6、考勤提醒  文章更新（7：养生文库 8：学习中心） 9:今日任务 10:会员商城提成 11:千店万群销售动态
    String localType;//（"ELearning"）因为ELearning的子类型不知道会有多少种，所以这里自己在本地设一个额外的类型

    public class DetailItem {
        String time;
        String content;
        String articleTitle;//eg.文章更新（写死）
        int used;//0未读 1已读
    }

    public String getLocalType() {
        return localType;//（"ELearning"）
    }

    public void setLocalType(String localType) {
        this.localType = localType;
    }

    public void setActType(int actType) {
        this.actType = actType;
    }

    public int getActType() {
        return actType;
    }

    public void addNewList(List<SysMsgModel> newList) {
        if (pageNum == 0) {//说明是从第0页开始刷，也就是说，是下拉全局刷新
            dataList.clear();
        }
        if (newList != null) {//一定要防空，这里传空addAll()好像会爆炸
            dataList.addAll(newList);
        }
    }

    @Override
    public int getMsgAmount() {
        return msgAmount;
    }

    public List<SysMsgModel> getDataList() {
        return dataList;
    }

    public int getPageNum() {
        return pageNum;
    }

    /**
     * 下次下拉刷新时，应发送的页码自增
     */
    public void pageNumPlus() {
        pageNum++;
    }

    public void setPageNum(int pageNum) {
        this.pageNum = pageNum;
    }

    @Override
    public void msgAmountMinus() {
        msgAmount--;
    }

    @Override
    public void setMsgAmount(int msgAmount) {
        this.msgAmount = msgAmount;
    }
}

