package com.urovo.activity.messagecenter.model;

import com.urovo.activity.messagecenter.presenter.MsgCenterContract;
import com.urovo.wgmf.MessageActivity;
import com.urovo.wgmf.db.dao.dao.MsgOperate;
import com.urovo.wgmf.db.dao.entitys.MsgDb;
import com.urovo.wugumofang.data.DataMonthUtils;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

/**
 * Created by Sasuke on 2016/8/1.
 * 注：这两个链表才是数据源，那个什么List<Entity>的是网络获取的，不必在这里用
 */
public class NoticeData implements MsgCenterContract.baseData {
    List<Model> models = new ArrayList<>();//从msgDbs映射出来的，可以直接在Adapter里用的
    int msgAmount = 0;

    public List<Model> getDataList() {
        return models;
    }


    public void setDataList(List<Model> models) {
        if (models != null) {
            this.models.clear();
            this.models.addAll(models);
        }
    }

    //在网络获取MsgEntity，并写入db后执行这个，（返回未读数，发广播到标签显示脚标）
    public int loadMsgDbs() {
        int count = 0;
        models.clear();
        List<MsgDb> msgDbs = MsgOperate.selectBy(null);
        if (msgDbs.size() > 0) {
            for (MsgDb db : msgDbs) {
                Model cell = new Model();
                cell.mIsNew = db.mInvalid == null;
                if ("1".equals(db.mType)) {//过滤掉促销活动，请求获取数据他俩是绑在一起的
                    if (cell.mIsNew) {
                        count++;
                    }
                    cell.mLabel = MessageActivity.ZONGBUTONGZHI;
                    cell.mID = db.mNo;
                    cell.mTitle = db.mTitle;
                    cell.mContent = db.mContent;
                    cell.mDate = db.mDate;
                    cell.mObject = db;
                    models.add(cell);

                }
            }
            SortMsgByDate();
        }
        return count;
    }

    private void SortMsgByDate() {
        Collections.sort(models, new Comparator<Model>() {
            @Override
            public int compare(Model lhs, Model rhs) {
                if (lhs.mDate == null || rhs.mDate == null) {
                    return 0;
                }
                if (DataMonthUtils.getCompareDate(lhs.mDate, rhs.mDate) < 0) {
                    return -1;
                } else if (lhs.mDate.equals(rhs.mDate)) {
                    return 0;
                } else {
                    return 1;
                }
            }
        });
    }

    public int getMsgAmount() {
        return msgAmount;
    }

    public void msgAmountMinus() {
        msgAmount--;
    }

    public void setMsgAmount(int msgAmount) {
        this.msgAmount = msgAmount;
    }

    public class Model {
        public boolean mIsNew;
        public boolean mIsOpen;
        public String mType_ID;
        public String mLabel;
        public String mID;
        public String mTitle;
        public String mContent;
        public String mImgState;
        public String mDate;
        public Object mObject;
    }
}
