package com.urovo.activity.messagecenter.model;

import com.urovo.activity.messagecenter.presenter.MsgCenterContract;
import com.urovo.activity.tabMenu.web.NewSaleDetailResponse;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Sasuke
 * @date 2016/8/1
 */
public class SaleNewsData implements MsgCenterContract.baseData {
    private List<NewSaleDetailResponse.SaleMessage> detailList = new ArrayList<>();
    /**
     * 这个是将要发送给接口获取的下一页页码，而不是当前页的
     */
    private int pageNum = 1;
    /**
     * 未读消息总数
     */
    private int msgAmount = 0;

    public void addNewList(List<NewSaleDetailResponse.SaleMessage> newList) {
        //说明是从第1页开始刷，也就是说，是下拉全局刷新
        if (pageNum == 1) {
            detailList.clear();
        }
        //一定要防空，这里传空addAll()好像会爆炸
        if (newList != null) {
            detailList.addAll(newList);
        }
    }

    public void setPageNum(int pageNum) {
        this.pageNum = pageNum;
    }

    public int getPageNum() {
        return pageNum;
    }

    public void pageNumPlus() {
        pageNum++;
    }

    public List<NewSaleDetailResponse.SaleMessage> getDetailList() {
        return detailList;
    }

    @Override
    public int getMsgAmount() {
        return msgAmount;
    }

    @Override
    public void setMsgAmount(int msgAmount) {
        this.msgAmount = msgAmount;
    }

    /**
     * 这个SaleNews是看到即已读，应该不需要实现自减吧
     */
    @Override
    public void msgAmountMinus() {
    }
}
