package com.urovo.activity.messagecenter.net;

import com.google.gson.Gson;
import com.google.gson.JsonArray;
import com.google.gson.reflect.TypeToken;
import com.urovo.activity.messagecenter.util.Date2DayUtil;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * Created by Sasuke on 2016/9/30.
 */

public class ArticleModel extends SysMsgModel {
    String pid;//文章更新要用
    String title;
    long create_time;
    JsonArray content;
    //imageUrl articleUrl是属于content的
    String imageUrl;
    String articleUrl;
    //imageUrl articleUrl是属于content的
    String originType;
    String articleEditorExternalLink;
    String isNeedTest;
    String testLink;

    int area_id;
    int shop_id;
    long _version_;

    class Url{
        String imageUrl;
        String articleUrl;
        String originType;
        String articleEditorExternalLink;
        String isNeedTest;
        String testLink;
    }
    public String getPid() {
        return pid;
    }

    //把获取到的****-**-** **:**:**转换成   昨天 **:**的时间格式
    @Override
    public String getTime(){
        return Date2DayUtil.withLong(create_time);
    }

    public String getTimestamp() {
        return new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date(create_time));
    }

    public void setPid(String pid) {
        this.pid = pid;
    }

    public String getTitle() {
        return title;
    }



    public void setTitle(String title) {
        this.title = title;
    }

    public void setCreate_time(long create_time) {
        this.create_time = create_time;
    }


    public long getCreate_time() {
        return create_time;
    }

    public String getImageUrl() {
        return imageUrl;
    }

    public String getArticleUrl() {
        return articleUrl;
    }

    public int getArea_id() {
        return area_id;
    }

    public void setImageUrl(String imageUrl) {
        this.imageUrl = imageUrl;
    }

    public void setArticleUrl(String articleUrl) {
        this.articleUrl = articleUrl;
    }

    public void setArea_id(int area_id) {
        this.area_id = area_id;
    }

    public void setShop_id(int shop_id) {
        this.shop_id = shop_id;
    }

    public void set_version_(long _version_) {
        this._version_ = _version_;
    }

    public String getOriginType() {
        return originType;
    }

    public void setOriginType(String originType) {
        this.originType = originType;
    }

    public String getArticleEditorExternalLink() {
        return articleEditorExternalLink;
    }

    public void setArticleEditorExternalLink(String articleEditorExternalLink) {
        this.articleEditorExternalLink = articleEditorExternalLink;
    }

    public String getIsNeedTest() {
        return isNeedTest;
    }

    public void setIsNeedTest(String isNeedTest) {
        this.isNeedTest = isNeedTest;
    }

    public String getTestLink() {
        return testLink;
    }

    public void setTestLink(String testLink) {
        this.testLink = testLink;
    }

    //当Json映射到这个类完成后，就执行一下这个，从content把imageUrl和articleUrl解析出来，并存起来
    public void decodeContent(){
        if(content != null){
            List<Url> urlList = new Gson().fromJson(content,new TypeToken<List<Url>>(){}.getType());
            imageUrl = urlList.get(0).imageUrl;
            articleUrl = urlList.get(0).articleUrl;
            originType = urlList.get(0).originType;
            articleEditorExternalLink = urlList.get(0).articleEditorExternalLink;
            isNeedTest = urlList.get(0).isNeedTest;
            testLink = urlList.get(0).testLink;
        }
    }
}
