package com.urovo.activity.messagecenter.presenter;

import android.annotation.SuppressLint;
import android.os.AsyncTask;

import com.urovo.activity.messagecenter.model.NoticeData;
import com.urovo.wgmf.db.dao.dao.MsgOperate;
import com.urovo.wgmf.db.dao.entitys.MsgDb;
import com.urovo.wgmf.db.dao.entitys.MsgEntity;
import com.urovo.wgmf.entity.response.MsgResponse;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.system.SystemHelper;
import com.zsy.libcore.event.EventManager;
import com.zsy.libcore.event.MsgCount;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import okhttp3.Request;

/**
 * Created by Sasuke on 2016/8/12.
 */
public class NoticePresenter implements MsgCenterContract.detailPresenter {
    MsgCenterContract.view mView;
    MsgCenterContract.view mActivity;
    NoticeData data;

    public NoticePresenter(MsgCenterContract.view mActivity, MsgCenterContract.view mView) {
        if (mView != null) {//在外面单独使用这个Presenter时可以传空mView
            this.mView = mView;
            this.mView.setPresenter(this);
        }
        this.mActivity = mActivity;
        this.data = new NoticeData();
    }

    @Override
    public void start() {

    }

    public NoticeData getData() {
        if (data == null) {
            data = new NoticeData();
        }
        return data;
    }

    /**
     * 一进来就加载全部（第1页）or下拉刷新
     */
    @Override
    public void refreshAll() {
        //不扯些没用的，直接调全局刷新接口
        Map<String, String> params = new HashMap<String, String>();
        params.put("startDay", "");
        params.put("endDay", new SimpleDateFormat("yyyy-MM-dd").format(new Date()));
        params.put("storecode", SystemHelper.LoginOrganId);
//        if(BaseActivity.class.isAssignableFrom(context.getClass())){
//            new DownloadMsgTask((BaseActivity)context, "正在查询通知信息...", false,"DownloadMsgTask_Notice", params).execute("");
//        }else{
//            new DownloadMsgTask((TabMenuActivity) context, "正在查询通知信息...", false,"DownloadMsgTask_Notice", params).execute("");
//        }
        OkHttpDominator.postAsyn(NetParam.MSGQUERY, params,
                new OkHttpDominator.ResultCallback<MsgResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {

                    }

                    @SuppressLint("StaticFieldLeak")
                    @Override
                    public void onResponse(MsgResponse res) {
                        List<MsgEntity> msglist = res.getList();
                        if (null != msglist && msglist.size() > 0) {
                            new AsyncTask<List<MsgEntity>, Float, String>() {
                                @Override
                                protected void onPostExecute(String s) {
                                    notifyAdapter();
                                }

                                @Override
                                protected String doInBackground(List<MsgEntity>... params) {
                                    for (int i = 0; i < params[0].size(); i++) {
                                        MsgEntity entity = params[0].get(i);
                                        MsgDb cell = new MsgDb();
                                        cell.mNo = entity.id;// 消息id
                                        cell.mType = entity.type;// 消息类型
                                        cell.mTitle = entity.title;// 消息标题
                                        cell.mContent = entity.content;// 消息内容
                                        cell.mDate = entity.releaseTime;// 消息发布时间
                                        MsgOperate.Insert(cell);
                                        MsgOperate.updateitem(cell);
                                    }
                                    loadMsgDbsData();//再从数据库里映射出来，同时返回有多少未读
                                    return null;
                                }
                            }.execute(msglist);
                        } else {
//                            getData().setMsgAmount(0);
                            EventManager.getInstance().postMsgCenterCount(new MsgCount(NoticePresenter.this.getClass().getName(), 0));//先映射数据库的数据，再顺便把未读数给存到Data里
                            notifyAdapter();
                        }
                    }
                });
    }

    /**
     * 上拉加载（消息通知没这需求）
     */
    @Override
    public void loadMore() {

    }

    /**
     * 已经通过网络把数据加载到本地db，这里把db里的数据映射出来，并返回未读数
     */
    public void loadMsgDbsData() {
//        getData().setMsgAmount(getData().loadMsgDbs());
        EventManager.getInstance().postMsgCenterCount(new MsgCount(NoticePresenter.this.getClass().getSimpleName(), getData().loadMsgDbs()));//先映射数据库的数据，再顺便把未读数给存到Data里
    }

    @Override
    public void notifyAdapter() {
        if (mView != null) {
            mView.notifyAdapter();
        }
    }

}
