package com.urovo.activity.messagecenter.presenter;

import android.os.AsyncTask;

import com.urovo.activity.messagecenter.model.SaleActivityData;
import com.urovo.wgmf.db.dao.dao.MsgOperate;
import com.urovo.wgmf.db.dao.entitys.ActEntity;
import com.urovo.wgmf.db.dao.entitys.MsgDb;
import com.urovo.wgmf.entity.response.MsgResponse;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.DataMonthUtils;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.system.SystemHelper;
import com.zsy.libcore.event.EventManager;
import com.zsy.libcore.event.MsgCount;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import okhttp3.Request;

/**
 * Created by Sasuke on 2016/8/15.
 */
public class SaleActivityPresenter implements MsgCenterContract.detailPresenter{
    MsgCenterContract.view mView;
    MsgCenterContract.view mActivity;
    SaleActivityData data;
    public SaleActivityPresenter(MsgCenterContract.view mActivity, MsgCenterContract.view mView) {
        if(mView != null) {//在外面单独使用这个Presenter时可以传空mView
            this.mView = mView;
            this.mView.setPresenter(this);
        }
        this.mActivity = mActivity;
        this.data = new SaleActivityData();
    }

    public SaleActivityData getData(){
        if(data == null){
            data = new SaleActivityData();
        }
        return data;
    }

    @Override
    public void refreshAll() {
        Map<String, String> params = new HashMap<String, String>();
        params.put("startDay", "");
        params.put("endDay", new SimpleDateFormat("yyyy-MM-dd").format(new Date()));
        params.put("storecode", SystemHelper.LoginOrganId);
//        if(BaseActivity.class.isAssignableFrom(context.getClass())){
//            new DownloadMsgTask((BaseActivity)context, "正在查询通知信息...", false,"DownloadMsgTask_SaleActivity", params).execute("");
//        }else{
//            new DownloadMsgTask((TabMenuActivity)context, "正在查询通知信息...", false,"DownloadMsgTask_SaleActivity", params).execute("");
//        }
        OkHttpDominator.postAsyn(NetParam.MSGQUERY, params,
                new OkHttpDominator.ResultCallback<MsgResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {

                    }

                    @Override
                    public void onResponse(MsgResponse res) {
                        List<ActEntity> actlist = res.getActList();
                        if (null != actlist && actlist.size() > 0) {
                            new AsyncTask<List<ActEntity>,Float,String>(){
                                @Override
                                protected void onPostExecute(String s) {
                                    notifyAdapter();
                                }

                                @Override
                                protected String doInBackground(List<ActEntity>... params) {
                                    for (int i = 0; i < params[0].size(); i++) {
                                        MsgDb cell = new MsgDb();
                                        ActEntity entity = params[0].get(i);
                                        if (DataMonthUtils.getCompareDate(entity.END_TIME,
                                                new SimpleDateFormat("yyyy-MM-dd").format(new Date())) < 30) {
                                            cell.mNo = entity.ACTIVITY_ID;// 活动id
                                            cell.mType = "3";//
                                            cell.mTypeId = entity.TYPE_ID;// 活动类型
                                            cell.mTitle = entity.NAME;// 活动标题
                                            cell.mContent = entity.CONTENT;// 活动内容
                                            cell.mActStartTime = entity.START_TIME;// 活动开始时间
                                            cell.mActEndTime = entity.END_TIME;// 活动结束时间
                                            cell.mDate = entity.UPDATE_TIME.substring(0,16);// 活动当前时间
                                            MsgOperate.Insert(cell);
                                            MsgOperate.updateitem(cell);
                                        }
                                    }
                                    loadMsgDbsData();//再从数据库里映射出来，同时返回有多少未读
                                    return null;
                                }
                            }.execute(actlist);
                        }else{
//                            getData().setMsgAmount(0);
                            EventManager.getInstance().postMsgCenterCount(new MsgCount(SaleActivityPresenter.this.getClass().getName(),0));//先映射数据库的数据，再顺便把未读数给存到Data里
                            notifyAdapter();
                        }
                    }
                });
    }

    public void loadMsgDbsData(){
//        getData().setMsgAmount(getData().loadMsgDbs());
        EventManager.getInstance().postMsgCenterCount(new MsgCount(SaleActivityPresenter.this.getClass().getSimpleName(),getData().loadMsgDbs()));//先映射数据库的数据，再顺便把未读数给存到Data里
    }
    //上拉加载更多，促销活动没这需求，暂时不管
    @Override
    public void loadMore() {

    }

    @Override
    public void notifyAdapter() {
        if(mView != null){
            mView.notifyAdapter();
        }
    }

    @Override
    public void start() {

    }

}
