package com.urovo.activity.messagecenter.ui;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.BaseAdapter;
import android.widget.RadioButton;
import android.widget.TextView;

import com.urovo.activity.messagecenter.model.MsgActData;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.ui.DensityUtil;


/**
 * Created by Sasuke on 2016/7/28.
 */
public class LabelAdapter extends BaseAdapter {
    Context context;
    int itemHeight;//每个子组件的高度
    MsgActData.LabelModel[] labelModels;
    public LabelAdapter(Context context, int itemHeight,MsgActData.LabelModel[] labelModels) {
        this.context = context;
        this.labelModels = labelModels;
        this.itemHeight = itemHeight;
    }

    @Override
    public int getCount() {
        return labelModels.length;
    }

    @Override
    public MsgActData.LabelModel getItem(int position) {
        return labelModels[position];
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        if(convertView == null){
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.msg_label_list_item,null);
            convertView.setLayoutParams(new AbsListView.LayoutParams(AbsListView.LayoutParams.MATCH_PARENT,itemHeight));
            holder.label = ((RadioButton)convertView.findViewById(R.id.system_msg));//标签本体
            holder.msgCount = (TextView)convertView.findViewById(R.id.count_msg);//标签上的小圆点数字脚标
            convertView.setTag(holder);
        }else{
            holder = (ViewHolder)convertView.getTag();
        }

        //设置标签（两种标签都设一下）
        holder.label.setText(labelModels[position].labelName);
        holder.label.setChecked(labelModels[position].isChecked);
        //设置切换的背景
        holder.label.setBackgroundResource(position == labelModels.length - 1 ? R.drawable.ver_label_tail_selector : R.drawable.ver_label_selector);
        // 设置Top图
        Drawable drawable = context.getResources().getDrawable(labelModels[position].drawableTopRid);
        drawable.setBounds(0, DensityUtil.dip2px(context,15), DensityUtil.dip2px(context,30) ,DensityUtil.dip2px(context,45) );
        holder.label.setCompoundDrawables(null, drawable, null, null);

        //怎么XML里的居中不生效（这句必须在代码里写，在XML里不生效，我也不知道为什么）
        holder.label.setPadding(0,0,13,0);
//        if(holder.label.isChecked()){//设置颜色
//            holder.label.setTextColor(Color.parseColor("#fcb815"));
//        }else{
//            holder.label.setTextColor(Color.BLACK);
//        }
        //设置消息数
        int count = labelModels[position].getMsgCount();
        if(count <= 0){//如果新消息数为0，那就不显示脚标
            holder.msgCount.setVisibility(View.INVISIBLE);
        }else if(count > 99){//如果新消息数大于99，则脚标显示99+
            //holder.msgCount.setTextSize(DensityUtil.sp2px(context,10));//因为要显示+号，所以把字体变小
            holder.msgCount.setVisibility(View.VISIBLE);
            holder.msgCount.setText("99+");
        }else{
            //holder.msgCount.setTextSize(DensityUtil.sp2px(context,12));
            holder.msgCount.setVisibility(View.VISIBLE);
            holder.msgCount.setText(count+"");
        }

        return convertView;
    }

    class ViewHolder {
        RadioButton label ;
        TextView msgCount;
    }
}
