package com.urovo.activity.messagecenter.ui;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.messagecenter.model.SaleActivityData;
import com.urovo.activity.messagecenter.presenter.SaleActivityPresenter;
import com.urovo.activity.messagecenter.util.Date2DayUtil;
import com.urovo.wgmf.db.dao.dao.MsgOperate;
import com.urovo.wgmf.db.dao.entitys.MsgDb;
import com.urovo.wgmf.notice.CuXiaoHuoDongActivity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * Created by Sasuke on 2016/8/15.
 */
public class SaleActivityAdapter extends BaseAdapter {
    Context context;
    SaleActivityPresenter mPresenter;
    List<SaleActivityData.Model> dataList;

    public SaleActivityAdapter(Context context, List<SaleActivityData.Model> dataList, SaleActivityPresenter presenter) {
        this.context = context;
        this.dataList = dataList;
        this.mPresenter = presenter;
    }

    @Override
    public int getCount() {
        return dataList.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        if(convertView == null){
            convertView = (LinearLayout) LayoutInflater.from(context).inflate(R.layout.list_item_sale_activity,null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        }else{
            holder = (ViewHolder) convertView.getTag();
        }
        SaleActivityData.Model model = dataList.get(position);
        holder.saleIsNew.setVisibility(model.mIsNew? View.VISIBLE: View.INVISIBLE);
        holder.saleContent.setText(model.mContent);
        holder.saleTime.setText(Date2DayUtil.withDay(model.mDate));
        holder.saleTitle.setText(model.mTitle);
        if(model.mImgState.equals("0")){
            holder.goingMark.setImageResource(R.drawable.mark_news_not_start);
        }else if(model.mImgState.equals("1")){
            holder.goingMark.setImageResource(R.drawable.mark_news_going);
        }else{
            holder.goingMark.setVisibility(View.INVISIBLE);
        }


        convertView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(dataList.get(position).mIsNew){//如果点击的是未读的
                    mPresenter.getData().msgAmountMinus();//未读数自减
                }
                dataList.get(position).mIsNew = false;
                MsgDb mode = (MsgDb) dataList.get(position).mObject;
                MsgOperate.update(mode);
                Intent intent = new Intent(context,CuXiaoHuoDongActivity.class);
                Bundle b = new Bundle();
                b.putBoolean("isnew", dataList.get(position).mIsNew);
                b.putString("cuxiao", dataList.get(position).mContent);
                b.putString("title", dataList.get(position).mTitle);
                b.putString("id", dataList.get(position).mID);
                b.putString("state", dataList.get(position).mImgState);
                b.putString("date", dataList.get(position).mDate);
                b.putString("update", dataList.get(position).mDate);
                intent.putExtra("bundle", b);
                intent.putExtra("storeId", SystemHelper.LoginOrganId);
                ((BaseActivity)context).startActivity(intent);
            }
        });
        return convertView;
    }

    class ViewHolder{
        public ViewHolder(View view) {
            ButterKnife.bind(this,view);
        }

        @BindView(R.id.sale_isNew)
        ImageView saleIsNew;
        @BindView(R.id.text_sale_content)
        TextView saleContent;
        @BindView(R.id.text_sale_title)
        TextView saleTitle;
        @BindView(R.id.text_sale_time)
        TextView saleTime;
        @BindView(R.id.mark_news_going)
        ImageView goingMark;
    }
}
