package com.urovo.activity.messagecenter.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.messagecenter.presenter.SaleNewsPresenter;
import com.urovo.activity.messagecenter.util.Date2DayUtil;
import com.urovo.activity.tabMenu.web.NewSaleDetailResponse;
import com.urovo.wgmf.AsyncTask.BaseAppSalerServerTask;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.system.SystemHelper;

import java.util.HashMap;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * Created by Sasuke on 2016/8/7.
 */
public class SaleNewsAdapter extends BaseAdapter {
    Context context;
    SaleNewsPresenter mPresenter;
    List<NewSaleDetailResponse.SaleMessage> dataList;
    public SaleNewsAdapter(Context context,
                           List<NewSaleDetailResponse.SaleMessage> dataList, SaleNewsPresenter presenter) {
        this.context = context;
        this.dataList = dataList;
        this.mPresenter = presenter;//到时候送花什么的提供网络操作
    }

    @Override
    public int getCount() {
        return dataList.size();
    }
    @Override
    public Object getItem(int position) {
        return null;
    }
    @Override
    public long getItemId(int position) {
        return position;
    }
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final ViewHolder holder;
        if(convertView == null){
            convertView = (LinearLayout) LayoutInflater.from(context).inflate(R.layout.list_item_sale_news,null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        }else{
            holder = (ViewHolder) convertView.getTag();
        }
        holder.markNew.setVisibility(position == 0? View.VISIBLE : View.GONE);
        final NewSaleDetailResponse.SaleMessage item = dataList.get(position);
        /*String time = item.getAddDate().substring(11,16);
        String date = item.getAddDate().substring(0,10);*/
        String time = Date2DayUtil.withDay(item.getAddDate());
        holder.addDate.setText(time);

        String showText = "";
        if(item.getIsFirstOrder() == 1){
            showText = "啦啦啦～～今天的第一单生意，金额"+item.getSaleAmount()+"元。想比我们更早开张？快快来赶超吧～";
        }else{
            showText = "哇咔咔~~成功加粉1个，门槛"+item.getSaleAmount()+"元，等你来挑战~！";
        }
        if(Float.parseFloat(item.getSaleAmount()) >= 1000){
            if(item.getIsFirstOrder() != 1){
                showText = "";
            }else{
                showText += "\n";
            }
            showText += "大吼一声～～超大客单价产生，门槛1000元。除了我们还有谁？！不服来战～";
        }
        holder.showText.setText(showText);

        holder.shopName.setText(item.getShopName());
        //显示鲜花数
        if(Integer.parseInt(item.getFlowerNum()) > 0){
            holder.flowerShow.setVisibility(View.VISIBLE);
            holder.flowerShow.setText(item.getFlowerNum()+"");
        }else{
            holder.flowerShow.setVisibility(View.INVISIBLE);
        }
        //显示金种子数
        if(Integer.parseInt(item.getSeedNum()) > 0){
            holder.seedShow.setVisibility(View.VISIBLE);
            holder.seedShow.setText(item.getSeedNum()+"");
        }else{
            holder.seedShow.setVisibility(View.INVISIBLE);
        }
        //对“送花”的初始显示控制
        if(item.hasGiveFlower() > 0){//大于0表示已送过花
            holder.giveFlower.setChecked(true);
        }else{
            holder.giveFlower.setChecked(false);
        }

        holder.giveFlower.setOnClickListener(new View.OnClickListener() {//CheckBox会先改变状态，再执行这里
            @Override
            public void onClick(View view) {
                if(!((CheckBox)view).isChecked()){//由已check变为未check（二次）
                    ((CheckBox)view).setChecked(true);//多次送花不合法，所以重新设为已check
                    ((BaseActivity)context).showMsg("您已经送过花了哟~~");
                }else{//由未check变为已check（初次）
                    item.FlowerNumPlus();//鲜花数增1
                    holder.flowerShow.setVisibility(View.VISIBLE);
                    holder.flowerShow.setText(item.getFlowerNum());

                    HashMap<String,String> param = new HashMap<String, String>();
                    param.put("type","1");
                    param.put("staffNo", SystemHelper.LoginUserId);
                    param.put("pid",item.getPid()+"");
                    param.put("sum","1");
                    new BaseAppSalerServerTask("donation", BaseOldResponse.class,(BaseActivity)context,"正在献花...",false,
                            "/message/donation",param).execute("");
                }
            }
        });
        return convertView;
    }

    class ViewHolder{
        public ViewHolder(View view) {
            ButterKnife.bind(this,view);
        }
        @BindView(R.id.add_date)
        TextView addDate;//时间
        @BindView(R.id.shop_name)
        TextView shopName;//门店名称
        @BindView(R.id.show_text)
        TextView showText;//显示文本主体
        @BindView(R.id.mark_new)
        ImageView markNew;//第一条显示New
        @BindView(R.id.flower_check_box)
        CheckBox flowerShow;//显示有多少鲜花
        @BindView(R.id.golden_seed_check_box)
        CheckBox seedShow;//显示有多少金种子
        @BindView(R.id.give_flowers)
        CheckBox giveFlower;//送花按钮
    }

};



