package com.urovo.activity.messagecenter.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.messagecenter.net.ArticleModel;
import com.urovo.activity.messagecenter.net.SysMsgModel;
import com.urovo.activity.messagecenter.presenter.SysMsgPresenter;
import com.urovo.activity.messagecenter.view.MsgDetailAct;
import com.urovo.wugumofang.R;

import java.text.SimpleDateFormat;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * Created by Sasuke on 2016/8/23.
 */
public class SysMsgAdapter extends BaseAdapter {
    Context context;
    SysMsgPresenter mPresenter;
    List<SysMsgModel> modelList;
    SimpleDateFormat sdf;
    SimpleDateFormat sdfTime;

    public SysMsgAdapter(Context context, List<SysMsgModel> modelList, SysMsgPresenter mPresenter) {
        this.context = context;
        this.mPresenter = mPresenter;
        this.modelList = modelList;
        sdf = new SimpleDateFormat("yyyy-MM-dd");
        sdfTime = new SimpleDateFormat("yyyy-MM-dd HH:mm");
    }

    @Override
    public int getCount() {
        return modelList.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder holder;
        if (convertView == null) {
            convertView = (LinearLayout) LayoutInflater.from(context).inflate(R.layout.list_item_today_task, null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        final SysMsgModel model = modelList.get(position);
        if (model.getUsed() == 0) {//未读
            holder.noticeIsNew.setVisibility(View.VISIBLE);
        } else {//已读
            holder.noticeIsNew.setVisibility(View.INVISIBLE);
        }
        holder.noticeTitle.setText(model.getDesc());//标题
        holder.noticeTime.setText(model.getTime());//格式化后的时间

        //如果从未收到过推送or收到过但最后一次日期小于今天（由西门在后台控制，今天如果没有那就直接不显示就行了嘛）
       /* String today = sdf.format(new Date());
        if(TextUtils.isEmpty(model.getLastDate()) ||
                model.getLastDate().compareTo(today) < 0){
            holder.contentLayout.setVisibility(View.GONE);//测试时可以改这里为VISIBLE
        }else{
            holder.contentLayout.setVisibility(View.VISIBLE);
        }*/

        if (model.getType() == 6) {//考勤
            holder.noticeContent.setText(model.getCon());//内容

        } else if (model.getType() == 7 || model.getType() == 8) {//文章更新
            String title = "";
            switch (model.getType()) {
                case 7:
                    title = "【养生文库】";
                    break;
                case 8:
                    title = "【学习中心】";
                    break;
            }
            holder.noticeContent.setText(title + ((ArticleModel) model).getTitle());
        } else {//订货、盘点
            holder.noticeContent.setText(model.getCon());//内容
        }

        convertView.setOnClickListener(v -> {
            if (model.getUsed() == 0) {//只有在它是未读状态的时候，才上传已读记录
                if (model.getType() != 7 && model.getType() != 8) {//(文章更新另外计)
                    model.setUsed(1);//同步设置本地已读标记
                    mPresenter.uploadMsgCount(model.getType() + "", model.getType() == 6 ? model.getId() : "");//同步上传已读标记（只有文章和考勤要传id）
                    mPresenter.getData().msgAmountMinus();//同步把侧边标签未读数减1
                    holder.noticeIsNew.setVisibility(View.INVISIBLE);//小圆点去掉
                }
            }

            if (model.getType() != 9) {
                MsgDetailAct.launch(context, model.getType(), model.desc);
            }
        });
        return convertView;
    }

    class ViewHolder {
        public ViewHolder(View view) {
            ButterKnife.bind(this, view);
        }

        @BindView(R.id.content_layout)
        LinearLayout contentLayout;
        @BindView(R.id.task_isNew)
        ImageView noticeIsNew;
        @BindView(R.id.text_task_content)
        TextView noticeContent;
        @BindView(R.id.text_task_title)
        TextView noticeTitle;
        @BindView(R.id.text_task_time)
        TextView noticeTime;
    }
}
