package com.urovo.activity.messagecenter.view;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;

import com.urovo.activity.messagecenter.presenter.MsgCenterContract;
import com.urovo.activity.messagecenter.presenter.MsgDetailPresenter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;


/**
 * Created by Sasuke on 2016/10/8.
 */

public class MsgDetailAct extends BaseActivity implements MsgCenterContract.view {
    private MsgDetailPresenter mPresenter;
    private MsgDetailFra detailFra;
    private int type;//1、新客三响炮回访  2、积分到期提醒  3、优惠券到期提醒  4、订货提醒
    //  5、盘点提醒  6、考勤提醒 文章更新（7：养生文库 8：学习中心）  9:今日任务 10:会员商城提成 11:千店万群销售动态
    private String title;//界面标题
    private String localType;//本地类型（结合type一起来判断，因为在线学习的类型比较多，所以不用type,而是另起一个新本地type来区分。


    public static void launch(Context context, int type, String title, String localType) {
        Intent intent = new Intent(context, MsgDetailAct.class);
        intent.putExtra("type", type);
        intent.putExtra("title", title);
        intent.putExtra("localType", localType);
        context.startActivity(intent);
    }

    public static void launch(Context context, int type, String title) {
        Intent intent = new Intent(context, MsgDetailAct.class);
        intent.putExtra("type", type);
        intent.putExtra("title", title);
        context.startActivity(intent);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ll_msgdetail_act);
        initTitle();

        type = getIntent().getIntExtra("type", -1);
        title = getIntent().getStringExtra("title");
        localType = getIntent().getStringExtra("localType") == null ? "" : getIntent().getStringExtra("localType");

        if (type == -1) {
            showMsg("error:未传type值，请检查代码");
            finish();
        }
        initUi();
        mPresenter.refreshAll();
    }

    @Override
    public void initUi() {
        if (!TextUtils.isEmpty(title)) {
            titleTextView.setText(title);
        }
        switch (type) {
            case 4:
                titleTextView.setText(R.string.msg_order_reminder);
                break;
            case 5:
                titleTextView.setText(R.string.msg_inventory_reminder);
                break;
            case 6:
                titleTextView.setText(R.string.msg_attendance_reminder);
                break;
            case 7:
                titleTextView.setText(R.string.msg_article_update);
                break;
            case 8:
                titleTextView.setText(R.string.msg_article_update);
                break;
            case 10:
                titleTextView.setText(R.string.msg_online_order);
                break;
            case 11:
                titleTextView.setText(R.string.msg_thousands_stores_sales_dynamics);
                break;
//            case 50:
//                titleTextView.setText("在线学习");
//                detailFra.setPullLoadEnabled(false);
            // 禁用上拉加载（接口都不支持上拉加载这边拉个毛线）
//                break;
        }
        if (localType.equals("ELearning")) {//因为不知道在线学习会有哪些类型，所以单独在本地跳转时传入自定义类型
            titleTextView.setText("在线学习");
        }

        detailFra = new MsgDetailFra();
        mPresenter = new MsgDetailPresenter(this, detailFra);
        mPresenter.getData().setActType(type);
        mPresenter.getData().setLocalType(localType);
        getSupportFragmentManager().beginTransaction().replace(R.id.msg_frag_container, detailFra).commit();
    }

    @Override
    public void notifyAdapter() {

    }

//    @Override
//    public void displayResult(String tag, BaseResponse response) {
//        if(response == null){
//            return ;
//        }
//
//        SysMsgDataRes res = (SysMsgDataRes)response;
//        mPresenter.getData().setMsgAmount(Integer.parseInt(res.msgInfo));
//        mPresenter.transData(res.getResultInfo());//里面会自己判断是不是文章
//        mPresenter.notifyAdapter();
//        if(res.getResultInfo() != null){
//            mPresenter.getData().pageNumPlus();//每次刷新成功就要把下次页码自增，便于今后的上拉加载
//        }
//
//        /*if(tag.equals("notArticleMsg")){//如果不是文章（文章和其它的数据模型不一样，得分开解析）
//        }else if(tag.equals("articleMsg")){//如果是文章
//        }*/
//
//
//    }

    @Override
    public void setPresenter(Object presenter) {

    }

}
