package com.urovo.activity.messagecenter.view;

import android.os.Bundle;
import androidx.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;

import com.urovo.activity.messagecenter.presenter.MsgCenterContract;
import com.urovo.activity.messagecenter.presenter.MsgDetailPresenter;
import com.urovo.activity.messagecenter.ui.MsgDetailAdapter;
import com.urovo.wugumofang.R;

/**
 * Created by Sasuke on 2016/10/8.
 */

public class MsgDetailFra extends BaseRefreshFra implements MsgCenterContract.view{
    MsgDetailPresenter mPresenter;
    MsgDetailAdapter adapter;
    MsgCenterContract.view mActivity;
    @Override
    public void initUi() {

    }

    @Override
    public MsgCenterContract.detailPresenter buildPre(MsgCenterContract.view mActivity) {
        if(mPresenter == null){
            mPresenter = new MsgDetailPresenter(mActivity,this);
            this.mActivity = mActivity;
        }
        return mPresenter;
    }

    @Override
    public MsgCenterContract.detailPresenter getPre() {
        return mPresenter;
    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container  = (RelativeLayout)inflater.inflate(R.layout.fra_msg_center,container,false);
        initPullListView(container);
        //有时候pre会报空！！
        if(mPresenter == null){
            mPresenter = new MsgDetailPresenter((MsgCenterContract.view)getActivity(),this);
        }
        adapter = new MsgDetailAdapter(getActivity(),mPresenter.getData().getDataList(),mPresenter);
        mListView.setAdapter(adapter);
        setRefreshListener();//挂双监听
        setPullLoadEnabled(! ("ELearning".equals(mPresenter.getData().getLocalType())));
        return container;
    }

    @Override
    public void notifyAdapter() {
        if(mPresenter.getData().getDataList().size() == 0){//如果数据源为空了
            showNoData();
        }else{//如果有数据了
            hideErrorText();
            adapter.notifyDataSetChanged();
        }
        completeRefresh(true);
    }

    @Override
    public void setPresenter(Object presenter) {
        this.mPresenter = (MsgDetailPresenter)presenter;
    }

    @Override
    public void loadMore() {
        mPresenter.loadMore();
    }

    @Override
    public void refreshAll() {
        this.mPresenter.refreshAll();
    }

    @Override
    public void onResume() {
        super.onResume();
        if(adapter != null){
            adapter.notifyDataSetChanged();
        }
    }

    @Override
    public void showMsg(String msg) {

    }
}
