package com.urovo.activity.messagecenter.view;

import android.os.Bundle;
import androidx.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;

import com.urovo.activity.messagecenter.presenter.MsgCenterContract;
import com.urovo.activity.messagecenter.presenter.SaleActivityPresenter;
import com.urovo.activity.messagecenter.ui.SaleActivityAdapter;
import com.urovo.wugumofang.R;

/**
 * Created by Sasuke on 2016/8/15.
 */
public class SaleActivityFrag extends BaseRefreshFra implements MsgCenterContract.view{
    SaleActivityAdapter adapter;
    SaleActivityPresenter mPresenter;
    MsgCenterContract.view mActivity;
    @Override
    public void initUi() {

    }

    @Override
    public MsgCenterContract.detailPresenter buildPre(MsgCenterContract.view mActivity) {
        if(mPresenter == null){
            mPresenter = new SaleActivityPresenter(mActivity,this);
            this.mActivity = mActivity;
        }
        return mPresenter;
    }

    @Override
    public MsgCenterContract.detailPresenter getPre() {
        return mPresenter;
    }

    @Override
    public void notifyAdapter() {
        if(mPresenter.getData().getDataList().size() == 0){//如果数据源为空了
            showNoData();
        }else{//如果有数据了
            hideErrorText();
            adapter.notifyDataSetChanged();
        }
        completeRefresh(true);
    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container  = (RelativeLayout)inflater.inflate(R.layout.fra_msg_center,null,false);
        initPullListView(container);
        setPullLoadEnabled(false);//重新设置一下使上拉加载不生效（促销活动不需要上拉加载）
        if(mPresenter == null){//有时候pre会报空！！
            mPresenter = new SaleActivityPresenter((MsgCenterContract.view)getActivity(),this);
        }
        adapter = new SaleActivityAdapter(getActivity(),mPresenter.getData().getDataList(),mPresenter);
        mListView.setAdapter(adapter);
        setRefreshListener();//挂双监听
        return container;
    }

    @Override
    public void refreshAll() {
        this.mPresenter.refreshAll();
    }

    @Override
    public void loadMore() {

    }

    @Override
    public void setPresenter(Object presenter) {
        this.mPresenter = (SaleActivityPresenter)presenter;
    }

    @Override
    public void onResume() {
        super.onResume();
        if(adapter != null){
            adapter.notifyDataSetChanged();
        }
    }

    @Override
    public void showMsg(String msg) {
        mActivity.showMsg(msg);
    }

}
