package com.urovo.activity.messagecenter.view;

import android.os.Bundle;
import androidx.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;

import com.urovo.activity.messagecenter.presenter.MsgCenterContract;
import com.urovo.activity.messagecenter.presenter.SysMsgPresenter;
import com.urovo.activity.messagecenter.ui.SysMsgAdapter;
import com.urovo.wugumofang.R;

/**
 * Created by Sasuke on 2016/8/23.
 */
public class SysMsgFra extends BaseRefreshFra implements MsgCenterContract.view {
    SysMsgPresenter mPresenter;
    SysMsgAdapter adapter;
    MsgCenterContract.view mActivity;

    @Override
    public MsgCenterContract.detailPresenter buildPre(MsgCenterContract.view mActivity) {
        if(mPresenter == null){
            mPresenter = new SysMsgPresenter(mActivity,this);
            this.mActivity = mActivity;
        }
        return mPresenter;
    }

    @Override
    public MsgCenterContract.detailPresenter getPre() {
        return mPresenter;
    }

    @Override
    public void initUi() {

    }

    @Override
    public void loadMore() {

    }

    public void refreshAll() {
        mPresenter.refreshAll();
    }
    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container  = (RelativeLayout)inflater.inflate(R.layout.fra_msg_center,null,false);
        initPullListView(container);
        if(mPresenter == null){//有时候pre会报空！！
            mPresenter = new SysMsgPresenter((MsgCenterContract.view)getActivity(),this);
        }
        adapter = new SysMsgAdapter(getActivity(),mPresenter.getData().getModels(),mPresenter);
        mListView.setAdapter(adapter);
        setRefreshListener();
        loading.setVisibility(View.VISIBLE);
        return container;
    }

    @Override
    public void notifyAdapter() {
        if (adapter != null) {
            if(mPresenter.getData().getModels().size() == 0){//如果数据源为空了
                showNoData();
            }else{//如果有数据了
                hideErrorText();
                adapter.notifyDataSetChanged();
            }
        }
        completeRefresh(true);
    }

    @Override
    public void setPresenter(Object presenter) {
        this.mPresenter = (SysMsgPresenter) presenter;
    }


    @Override
    public void onResume() {
        super.onResume();
        mPresenter.notifyAdapter();
    }

    @Override
    public void showMsg(String msg) {
        mActivity.showMsg(msg);
    }


}
