package com.urovo.activity.nativemanager;

import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.ProgressBar;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.activity.tabMenu.view.TabMenuActivity;
import com.urovo.wgmf.AsyncTask.UploadBusinessDataTask;
import com.urovo.wgmf.AsyncTask.UploadFanKuiTask;
import com.urovo.wgmf.adapter.UntreatedOrderAdapter;
import com.urovo.wgmf.constants.UploadParam;
import com.urovo.wgmf.db.dao.bill.DalDingHuoExamine;
import com.urovo.wgmf.db.dao.dao.CxykqDbOperate;
import com.urovo.wgmf.db.dao.dao.Djbh001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djbs001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djcj001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djdb001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djpd001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djsc001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djxs001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djzs001DbOperate;
import com.urovo.wgmf.db.dao.dao.Jfdh001DbOperate;
import com.urovo.wgmf.db.dao.entitys.UntreatedOrderEntity;
import com.urovo.wgmf.db.dao.entitys.ZHXX002Entity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.ToActivity;

import java.util.ArrayList;
import java.util.List;

@Route(path = RouterParams.MoreIndex.UntreatedOrder)
public class UntreatedOrder extends BaseActivity implements UpEndNotify {

    ArrayList<String> urlLists = new ArrayList<String>();
    int tempCount = 0;
    List<ZHXX002Entity> tempEntitys = new ArrayList<>();
    private ListView listview;
    private List<UntreatedOrderEntity> list = new ArrayList<UntreatedOrderEntity>();
    private UntreatedOrder context;
    private List<String> tags = new ArrayList<>();
    private ProgressBar preBar;
    private Button submit;
    private UpEndBroadcast broadcast = new UpEndBroadcast(this);

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.untreated_order);
        init();
        initTitle();
        titleTextView.setText("未处理单据");
        IntentFilter intentFilter = new IntentFilter("com.urovo.wgmf.upend");
        registerReceiver(broadcast, intentFilter);
//        if (!EventBus.getDefault().isRegistered(this)) {
//            EventBus.getDefault().register(this);
//        }
        // initListener();
    }

    private void initListener() {

        listview.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                ToActivity.toActivity(UntreatedOrder.this, UntreatedOrderDetail.class, list.get(position).unUpType);
            }
        });
    }

    private void init() {

        context = this;
        listview = (ListView) findViewById(R.id.listview);
        preBar = (ProgressBar) findViewById(R.id.progressBar1);
        submit = (Button) findViewById(R.id.submit);
        list.clear();
        preBar.setVisibility(View.INVISIBLE);
        submit.setText("一键上传");
        submit.setEnabled(true);
        // 未上传考勤数据总数
        if (CxykqDbOperate.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent = new UntreatedOrderEntity();
            ent.oderType = "未上传考勤单";
            ent.count = CxykqDbOperate.GetUnUploadCount();
            ent.unUpType = UploadParam.KAOQIN;
            list.add(ent);
            tags.add(UploadParam.KAOQIN);
        }
        // 未上传订货数据总数
        if (Djbh001DbOperate.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent2 = new UntreatedOrderEntity();
            ent2.oderType = "未上传订货单";
            ent2.count = Djbh001DbOperate.GetUnUploadCount();
            ent2.unUpType = UploadParam.DINGHUO;
            list.add(ent2);
            tags.add(UploadParam.DINGHUO);
        }
        // 未上传订货审核数据总数
        if (DalDingHuoExamine.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent3 = new UntreatedOrderEntity();
            ent3.oderType = "未上传订货审核";
            ent3.count = DalDingHuoExamine.GetUnUploadCount();
            ent3.unUpType = UploadParam.DINGHUOSHENHE;
            list.add(ent3);
            tags.add(UploadParam.DINGHUOSHENHE);
        }
        // 未上传报损数据总数
        if (Djbs001DbOperate.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent4 = new UntreatedOrderEntity();//
            ent4.oderType = "未上传报损单";
            ent4.count = Djbs001DbOperate.GetUnUploadCount();
            ent4.unUpType = UploadParam.BAOSHUN;
            list.add(ent4);
            tags.add(UploadParam.BAOSHUN);
        }
        // 未上传冲顶数据总数
        if (Djcj001DbOperate.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent5 = new UntreatedOrderEntity();//
            ent5.oderType = "未上传冲顶单";
            ent5.count = Djcj001DbOperate.GetUnUploadCount();
            ent5.unUpType = UploadParam.CHONGDING;
            list.add(ent5);
            tags.add(UploadParam.CHONGDING);
        }
        // 未上传调拨数据总数
        if (Djdb001DbOperate.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent6 = new UntreatedOrderEntity();
            ent6.oderType = "未上传调拨单";
            ent6.count = Djdb001DbOperate.GetUnUploadCount();
            ent6.unUpType = UploadParam.DIAOBO;
            list.add(ent6);
            tags.add(UploadParam.DIAOBO);
        }
        // 未上传盘点数据总数
        if (Djpd001DbOperate.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent7 = new UntreatedOrderEntity();
            ent7.oderType = "未上传盘点单";
            ent7.count = Djpd001DbOperate.GetUnUploadCount();
            ent7.unUpType = UploadParam.PANDIAN;
            list.add(ent7);
            tags.add(UploadParam.PANDIAN);
        }
        // 未上传试吃数据总数
        if (Djsc001DbOperate.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent8 = new UntreatedOrderEntity();
            ent8.oderType = "未上传试吃单";
            ent8.count = Djsc001DbOperate.GetUnUploadCount();
            ent8.unUpType = UploadParam.SHICHI;
            list.add(ent8);
            tags.add(UploadParam.SHICHI);
        }
        // 未上传销售数据总数
        if (Djxs001DbOperate.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent9 = new UntreatedOrderEntity();
            ent9.oderType = "未上传销售单";
            ent9.count = Djxs001DbOperate.GetUnUploadCount();
            ent9.unUpType = UploadParam.XIAOSHOU;
            list.add(ent9);
            tags.add(UploadParam.XIAOSHOU);
        }
        // 未上传赠送数据总数
        if (Djzs001DbOperate.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent10 = new UntreatedOrderEntity();//
            ent10.oderType = "未上传赠送单";
            ent10.count = Djzs001DbOperate.GetUnUploadCount();
            ent10.unUpType = UploadParam.ZENGSONG;
            list.add(ent10);
            tags.add(UploadParam.ZENGSONG);
        }
        // 未上传积分兑换数据总数
        if (Jfdh001DbOperate.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent11 = new UntreatedOrderEntity();//
            ent11.oderType = "未上传积分兑换";
            ent11.count = Jfdh001DbOperate.GetUnUploadCount();
            ent11.unUpType = UploadParam.JIFENDUIHUAN;
            list.add(ent11);
            tags.add(UploadParam.JIFENDUIHUAN);
        }
        // 未上传质量监督数据总数
    /*	if(Zhxx001DbOperate.GetUnUploadCount() > 0) {
            UntreatedOrderEntity ent12 = new UntreatedOrderEntity();
			ent12.oderType = "未上传上报反馈";
			ent12.count = Zhxx001DbOperate.GetUnUploadCount();
//			ent12.unUpType = UploadParam.ZHILIANJIANDU;//现在放在外面处理，改用七牛存储;
			list.add(ent12);
//			tags.add(UploadParam.ZHILIANJIANDU);
		}*/
        listview.setAdapter(new UntreatedOrderAdapter(list, context));
        setListViewHeight(listview);
    }

    public void submit(View view) {
        if (list.size() == 0 && tags.size() == 0) {
            showMsg("没有可上传数据!");
            return;
        }/*else {
            if (Zhxx001DbOperate.GetUnUploadCount() > 0) {//上报反馈的特殊性，拿到这边处理
				new QiNiuTokenTask(this,"正在上传数据",true).execute("");
			}
			new UploadBusinessDataTask(UntreatedOrder.this, "数据上传中", false, tags, true).execute("");
		}*/ else {
            new UploadBusinessDataTask(UntreatedOrder.this, "数据上传中...", true, tags).execute("");
        }

//        preBar.setVisibility(View.VISIBLE);
//        submit.setEnabled(false);

    }

//    @Subscribe(threadMode = ThreadMode.MAIN)
//    public void onUpLoadSignInOrOutEvent(UpLoadSignInOrOutResultEvent event) {
//        if (event.isUpLoad()) {
//            Toast.makeText(this, "eventbus", Toast.LENGTH_SHORT).show();
//            new UploadBusinessDataTask(UntreatedOrder.this, "数据上传中...", true, tags).execute("");
//        }
//    }

    @Override
    protected void onResume() {

        super.onResume();
    }

    private void setListViewHeight(ListView listView) {

        // 获取ListView对应的Adapter

        ListAdapter listAdapter = listView.getAdapter();

        if (listAdapter == null) {
            return;
        }
        int totalHeight = 0;
        for (int i = 0, len = listAdapter.getCount(); i < len; i++) { // listAdapter.getCount()返回数据项的数目
            View listItem = listAdapter.getView(i, null, listView);
            listItem.measure(0, 0); // 计算子项View 的宽高
            totalHeight += listItem.getMeasuredHeight(); // 统计所有子项的总高度
        }

        ViewGroup.LayoutParams params = listView.getLayoutParams();
        params.height = totalHeight + (listView.getDividerHeight() * (listAdapter.getCount() - 1));
        listView.setLayoutParams(params);
    }

    @Override
    public void notifyData() {
        init();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        unregisterReceiver(broadcast);
//        EventBus.getDefault().unregister(this);
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
//        if (QiNiuTokenTask.TAG.equals(tag)) {
//            if ("0".equals(response.ret)) {
//                String tempToken = response.retInfo;
////				if (!TextUtils.isEmpty(tempToken)) {
////					getQiNiuUrl(tempToken);
////				}
//            }
//        } else
        if (UploadFanKuiTask.TAG.equals(tag)) {
            if (response != null) {
                if ("0".equals(((BaseOldResponse) response).msgCode)) {
                    showMsg("上传成功");
//					submit.setEnabled(true);
                }
            } else {
                showMsg("上传失败");
            }
        } else if (UploadBusinessDataTask.TAG.equals(tag)) {
            if (response != null) {
//                finish();
                Intent intent = new Intent(this, TabMenuActivity.class);
                intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                startActivity(intent);
//				if("0".equals(response.msgCode)) {
//					showMsg("上传成功");
//					submit.setEnabled(true);
//				}
            }
        }
    }

//	private void getQiNiuUrl(String token) {
//		ViewUtil.showProgress(this, "正在上传数据", "",false);//因现在就一条数据，可以这样处理
//		tempCount=0;
//		urlLists.clear();
//		List<ZHXX001Entity> list = Zhxx001DbOperate.GetUnUploadALL(null);
//		for (final ZHXX001Entity ent : list) {
//			if (ent != null) {
//				tempEntitys = Zhxx002DbOperate.GetBillDetail(ent.getBillId());
//
//				for (ZHXX002Entity ZHXX002Entity : tempEntitys) {
//					String tempImgUrl = ZHXX002Entity.getTPID();
//					Bitmap bitmap = PhotoUtil.revitionImageSize(Files.photoPath + tempImgUrl);
//
//					String key = PhotoUtil.getFileUrlUUID(SystemHelper.LoginOrganId, SystemHelper.LoginUserId);
//					UploadManager uploadManager = new UploadManager();
//					uploadManager.put(PhotoUtil.Bitmap2Bytes(bitmap), key,
//							token, new UpCompletionHandler() {
//								@Override
//								public void complete(String s, ResponseInfo responseInfo, JSONObject response) {
//									qiNiuComplete(s, responseInfo, response);
//								}
//
//							}, null);
//				}
//			}
//		}
//	}

//	void qiNiuComplete(String s, ResponseInfo responseInfo, JSONObject response) {
//		tempCount++;
//		if(response!=null) {
//			String json = response.toString();
//			BaseOldResponse mTokenBean = PhotoUtil
//					.parseTokenData(json);
//			// 解析出返回的token
//			if (null != mTokenBean && "0".equals(mTokenBean.getRet())) {
//				String url = PhotoUtil.getRealUrl(mTokenBean.getRetInfo());
//				urlLists.add(url);
//			}
//		}
//		if (tempEntitys.size() == tempCount) {
//			ViewUtil.dismissProgress();
//			new UploadFanKuiTask(UntreatedOrder.this, "正在上传数据", true, urlLists).execute("");
//		}
//	}
}
