package com.urovo.activity.newGuideAct.presenter;

import android.content.Intent;

import com.alibaba.android.arouter.launcher.ARouter;
import com.urovo.activity.login.view.PartTimeSalesStaffAct;
import com.urovo.activity.login.view.PartTimeStaffAct;
import com.urovo.activity.newGuideAct.model.GuideData;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.data.PreferHelper;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Created by Sasuke on 2017/2/16.
 * ...
 */

public class NewGuidePresenter implements NewGuideContract.presenter {
    NewGuideContract.view mView;
    GuideData data;

    public NewGuidePresenter(NewGuideContract.view mView) {
        this.mView = mView;
    }

    @Override
    public void start() {
        mView.initUI();
    }

    public GuideData getData() {
        if (data == null) {
            data = new GuideData();
        }
        return data;
    }

    public void showNextPage() {
        //如果后面没有Fragment了，判断是否是兼职人员登录，是就跳兼职人员专用界面，否则就跳主界面。
        if (!mView.showNextPage()) {
            if (mView.isPartTimeStaff()) {
                startActivityByClass(PartTimeStaffAct.class);
            } else if (mView.isPartTimeSalesStaff()) {
//                兼职销售人员
                startActivityByClass(PartTimeSalesStaffAct.class);
            } else {
//                nextPageClass = WxLoginAct.class;
                ARouter.getInstance().build(RouterParams.ORIGIN.TABMENUACTIVITY)
//                        .withFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP)//加了这个会崩
                        .navigation();
            }
        }
    }


    private void startActivityByClass(Class<?> actClass){
        Intent intent = new Intent((BaseActivity) mView, actClass);
        intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
        ((BaseActivity) mView).startActivity(intent);
    }

    /**
     * 保存现在打开了 广告页（职业宣言）的时间
     */
    public void saveAdOpenTime() {
        PreferHelper.getInstance().setString(AppConstants.PreKeys.DECLARATION_PAGE_LAST_OPEN_TIME, new SimpleDateFormat("yyyy-MM-dd").format(new Date()));
    }

    /**
     * 保存现在打开了欢迎页的时间
     */
    public void saveWelcomeLastOpenTime() {
        //记录当前日期
        PreferHelper.getInstance().setString(AppConstants.PreKeys.NEW_GUIDE_LAST_OPEN_TIME, new SimpleDateFormat("yyyy-MM-dd").format(new Date()));
        //记录当前版本号
//        String lastVertion = "";
//        try {
//            PackageInfo info = GlobalApp.getInstance().getPackageManager().getPackageInfo(GlobalApp.getInstance().getPackageName(), 0);
//            lastVertion = info.versionName;
//        } catch (PackageManager.NameNotFoundException e) {
//            lastVertion = "";
//            e.printStackTrace();
//        }
//        PreferHelper.getInstance().setString(AppConstants.PreKeys.NEW_GUIDE_LAST_APP_VERSION,lastVertion);
    }
}
