package com.urovo.activity.newGuideAct.view;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.AnimationUtils;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RelativeLayout;

import com.urovo.activity.login.view.LoginActivity;
import com.urovo.activity.newGuideAct.presenter.NewGuideContract;
import com.urovo.activity.newGuideAct.presenter.NewGuidePresenter;
import com.urovo.activity.newGuideAct.ui.GuideAdapter;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.List;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.viewpager.widget.ViewPager;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;
import me.relex.circleindicator.CircleIndicator;

/**
 * Created by Sasuke on 2017/5/25.
 * 新功能介绍
 */

public class WelcomeFra extends Fragment implements NewGuideContract.view, View.OnClickListener, ViewPager.OnPageChangeListener {
    NewGuidePresenter pre;
    List<View> viewList;//用来填充ViewPager的View们。
    Button useBtn;//缓存该View用于动画。
    @BindView(R.id.new_guide_view_pager)
    ViewPager guidePager;
    @BindView(R.id.new_guide_indicator)
    CircleIndicator indicator;
    Unbinder unbinder;

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        RelativeLayout view = (RelativeLayout) inflater.inflate(R.layout.welcome_fra, container, false);
        unbinder = ButterKnife.bind(this, view);

        viewList = new ArrayList<>();
        int count = pre.getData().imgRes.length;
        int resId;
        for (int i = 0; i < count; i++) {
            resId = pre.getData().imgRes[i];
            RelativeLayout layout = (RelativeLayout) inflater.inflate(R.layout.ll_guide_pager_item, null);
//            Picasso.with(this).load(resId).into(
//                            (ImageView) layout.findViewById(R.id.pager_img));
            //这里不要用框架！不要用框架！不要用框架！(会导致vivo手机部分page显示不出来，直接黑屏了就)
            ((ImageView) layout.findViewById(R.id.pager_img)).setImageResource(resId);
            if (i == count - 1) {//如果是最后一个pager了，那就显示“立即体验”的按钮。
                useBtn = (Button) layout.findViewById(R.id.start_use);
                useBtn.setOnClickListener(this);
                useBtn.setVisibility(View.VISIBLE);
            }
            viewList.add(layout);
        }
        guidePager.setAdapter(new GuideAdapter(viewList));
        guidePager.addOnPageChangeListener(this);
        indicator.setViewPager(guidePager);
        pre.saveWelcomeLastOpenTime();//做个时间标记
        return view;
    }

    @Override
    public void initUI() {

    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.start_use:
                if (pre.getData().fromActivity != LoginActivity.class) {//如果不是从登陆界面跳过来的
                    getActivity().finish();
                } else {
                    pre.showNextPage();//继续往后显示
                }
                break;
            default:
                break;
        }
    }

    @Override
    public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {

    }

    @Override
    public void onPageSelected(int position) {
        if (useBtn == null) {
            return;
        }
        if (pre.getData().imgRes.length == position + 1 && useBtn != null) {//如果到了最后一页
            useBtn.startAnimation(
                    AnimationUtils.loadAnimation(getActivity(), R.anim.overshoot_translate_right));
        }
    }

    @Override
    public void onPageScrollStateChanged(int state) {

    }

    @Override
    public void showMsg(String msg) {

    }

    @Override
    public void setPresenter(NewGuideContract.presenter presenter) {
        this.pre = (NewGuidePresenter) presenter;
    }

    @Override
    public boolean showNextPage() {
        //nothing
        return false;
    }

    @Override
    public boolean isPartTimeStaff() {
        return false;
    }

    @Override
    public boolean isPartTimeSalesStaff() {
        return false;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }
}
