package com.urovo.activity.normalquestionact.presenter

import com.urovo.activity.normalquestionact.net.QuestionRes
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import okhttp3.Request

/**
 * @author Sasuke on 2018/5/3.
 */
class QuestionPre(val mView: QuestionContract.view): QuestionContract.pre {
    init {
        mView.setPresenter(this)
    }

    override fun start() {
        mView.init()
    }

    /**
     * 查询常见问题
     */
    fun queryProblemData(stair: String,id: String){
        mView.showLoad();
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.GET_PROBLEM_DATA,
                mapOf("stair" to stair,"id" to id),
                object : OkHttpDominator.ResultCallback<QuestionRes>(){
                    override fun onError(request: Request?, e: Exception?) {
                        mView.dismissLoadWait()
                        mView.showNetError()
                    }

                    override fun onResponse(res: QuestionRes?) {
                        mView.dismissLoadWait()
                        if(res == null || res.resultInfo == null || res.resultInfo.size == 0){
                            mView.showNoData()//无数据
                            return ;
                        }
                        mView.refreshUI(res.resultInfo)
                    }
                })
    }

    /**
     * 常见问题阅读数量累加
     */
    fun addProblemReadCount(stair: String,id: String){

    }

}