package com.urovo.activity.normalquestionact.presenter

import com.urovo.activity.normalquestionact.net.QuestionRes
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.data.PreferHelper
import com.urovo.wugumofang.net.OkHttpDominator
import okhttp3.Request

/**
 * @author Sasuke on 2018/5/17.
 */
class QuestionSearchPre(var mView: QuestionContract.view?) : QuestionContract.pre {
    var dataList: MutableList<QuestionRes.ResultInfo>? = mutableListOf()
    var currentKey: String = ""//当前正在搜索的key

    fun getHistory(): List<String>?{
        var hisPref = PreferHelper.getInstance().getString(AppConstants.PreKeys.QUESTION_SEARCH_HISTORY)
        if(hisPref.isNullOrEmpty()) return null
        return hisPref.split(",").filterNot { it.isNullOrEmpty() }
    }

    fun addHistory(key: String) {
        var his = PreferHelper.getInstance().getString(AppConstants.PreKeys.QUESTION_SEARCH_HISTORY)
        var historyList = getHistory()
        if(historyList != null && key in historyList) return //如果历史记录里没有，才添加
        PreferHelper.getInstance().setString(
                AppConstants.PreKeys.QUESTION_SEARCH_HISTORY,
                if (his != "") "${key},${his}" else key)
    }

    fun clearHistory(){
        PreferHelper.getInstance().setString(AppConstants.PreKeys.QUESTION_SEARCH_HISTORY,"")
    }


    init {
        mView?.setPresenter(this)
    }

    override fun start() {
        mView?.init()
    }

    /**
     * 搜索常见问题
     */
    fun searchProblemData(key: String) {
        currentKey = key//同步记录一下正在搜索的key，后面会用到
        mView?.showLoad()
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.SEARCH_PROBLEM_DATA,
                mapOf("key" to key),
                object : OkHttpDominator.ResultCallback<QuestionRes>() {
                    override fun onError(request: Request?, e: Exception?) {
                        mView?.apply {
                            dismissLoadWait()
                            showNetError()
                        }
                    }

                    override fun onResponse(res: QuestionRes?) {
                        mView?.dismissLoadWait()
                        if(res == null || res.resultInfo == null || res.resultInfo.isEmpty()){
                            mView?.showNoData()
                            return
                        }
                        mView?.refreshUI(res.resultInfo)
                    }
                })

    }

}