package com.urovo.activity.normalquestionact.view

import android.content.Context
import android.os.Build
import android.os.Bundle
import android.view.View
import android.view.ViewAnimationUtils
import android.widget.AdapterView
import android.widget.ArrayAdapter
import android.widget.TextView
import androidx.recyclerview.widget.LinearLayoutManager
import com.urovo.activity.normalquestionact.net.QuestionRes
import com.urovo.activity.normalquestionact.presenter.QuestionContract
import com.urovo.activity.normalquestionact.presenter.QuestionSearchPre
import com.urovo.activity.normalquestionact.ui.QuestionAdapter
import com.urovo.wgmf.ext.afterTextChanged
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.view.LoadWaitDominator
import com.wgmf.trade.widgets.ExtListView
import kotlinx.android.synthetic.main.ll_question_search_act.*
import kotlinx.android.synthetic.main.question_search_title.*
import org.jetbrains.anko.find


/**
 * @author Sasuke on 2018/5/16.
 * 常见问题搜索
 */
class QuestionSearchAct : BaseActivity(), QuestionContract.view {
    var loadWait: LoadWaitDominator? = null
    var pre: QuestionSearchPre? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.ll_question_search_act)
        QuestionSearchPre(this)
        pre?.start()

    }

//    /**
//     * 历史搜索记录弹窗
//     */
//    val historyPop: CustomPopupWindow by lazy {
//        CustomPopupWindow.Builder(this)
//                .setContentView(R.layout.popup_white_history_list)
//                .setFouse(true)
//                .setOutSideCancel(true)
//                .setAnimationStyle(R.style.dropmenu_anim_style)
//                .setBackgroundDrawable(BitmapDrawable())
//                .setwidth(ViewGroup.LayoutParams.MATCH_PARENT)
//                .setheight(dip(320))
//                .builder()
//    }

    /**
     * 弹出历史记录
     */
//    protected fun popupHistory() {
//        val array = pre?.getHistory()
//        if (array == null || array?.isEmpty()) return
//        historyPop?.let {
//            (historyPop.getItemView(R.id.popupHistoryList) as ListView?)?.apply {
//                adapter = ArrayAdapter(this@QuestionSearchAct, R.layout.text_view_drawable_layout, array)
//                //历史记录点击监听
//                onItemClickListener = AdapterView.OnItemClickListener { parent, view, position, id ->
//                    searchInput.setText(array[position])//把输入框的显示刷新
//                    focus(searchInput)//聚焦到输入框
//                    searchInput.setSelection(searchInput.text.toString().length)//光标移到最后一位
//                    historyPop.dismiss()
//                    pre?.searchProblemData(searchInput.text.toString())
//                }
//                it.getItemView(R.id.clearHistoryTv).setOnClickListener { pre?.clearHistory(); historyPop.dismiss() }
//            }
//        }
//        historyPop?.showAsLocation(searchLayout, Gravity.BOTTOM, 0, 0)
//    }


    /**
     * 显示历史搜索记录
     */
    protected fun popupHistory() {
        val array = pre?.getHistory()
        if (array == null || array?.isEmpty()) return
        historylistLayout.find<ExtListView>(R.id.historyList).apply {
            adapter = ArrayAdapter(this@QuestionSearchAct, R.layout.text_view_drawable_layout, array)
            //历史记录点击监听
            onItemClickListener = AdapterView.OnItemClickListener { parent, view, position, id ->
                searchInput.setText(array[position])//把输入框的显示刷新
                focus(searchInput)//聚焦到输入框
                searchInput.setSelection(searchInput.text.toString().length)//光标移到最后一位
                historylistLayout.visibility = View.GONE
                pre?.searchProblemData(searchInput.text.toString())
            }
        }
        //清除记录点击监听
        historylistLayout.find<TextView>(R.id.clearHistoryTv).setOnClickListener {
            pre?.clearHistory()
            historylistLayout.visibility = View.GONE
            pre?.dataList?.clear()
            resultRv.adapter?.notifyDataSetChanged()
        }
        //显示历史记录
        historylistLayout.visibility = View.VISIBLE
    }

    override fun init() {
        loadWait = LoadWaitDominator(this, container)
        bt_back.setOnClickListener { finish() }
        resultRv.apply {
            layoutManager = LinearLayoutManager(this@QuestionSearchAct)
            adapter = QuestionAdapter(this@QuestionSearchAct, pre?.dataList, this@QuestionSearchAct::jumpToNextPage)
        }
        //输入框初始化
        searchInput.apply {
            hint = "输入关键字进行搜索"
            afterTextChanged {
                if (it.isNullOrEmpty()) {
                    popupHistory()
                } else {
                    historylistLayout.visibility = View.GONE
                    pre?.searchProblemData(it)
                }
            }
        }
        //显示历史搜索记录（延时弹出）
//        Handler().postDelayed( { popupHistory() }, 600)
        popupHistory()
        //初始化输入框（圆形扩散动画）
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            searchLayout.post {
                val cicular_R = if (searchLayout.getHeight() / 2 > searchLayout.getWidth() / 2) searchLayout.getHeight() / 2 else searchLayout.getWidth() / 2
                val animator = ViewAnimationUtils.createCircularReveal(searchLayout, searchLayout.getWidth() as Int / 2, searchLayout.getHeight() as Int / 2, 0f, cicular_R.toFloat())
                animator.duration = 500
                animator.start()
            }
        }

    }

    override fun onResume() {
        super.onResume()
        if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT && searchInput.isAttachedToWindow){
            focus(searchInput)//聚焦到输入框
        }
    }

    /**
     * 通过重用NromalQuestion的方法进行跳转，然后添加一个本搜索页面特有的 记录搜索历史 操作。
     */
    fun jumpToNextPage(context: Context, itemData: QuestionRes.ResultInfo) {
        NormalQuestionAct()::jumpToNextPage.invoke(this,itemData)
        pre?.currentKey?.let { pre?.addHistory(it) }//记录搜索历史到Pref
    }

    override fun refreshUI(dataList: List<QuestionRes.ResultInfo>) {
        //刷新数据源
        pre?.dataList?.apply {
            clear()
            addAll(dataList)
        }
        //写入需要的标记和关键字，并刷新adapter
        (resultRv.adapter as QuestionAdapter).apply {
            isHighLight = true
            key = pre?.currentKey!!
            notifyDataSetChanged()
        }
    }


    override fun showLoad() {
        loadWait?.show(LoadWaitDominator.LOADING)
    }

    override fun showNetError() {
        loadWait?.show(LoadWaitDominator.NET_ERROR)
    }

    override fun showNoData() {
        loadWait?.show(LoadWaitDominator.NO_DATA)
    }

    override fun dismissLoadWait() {
        loadWait?.dismissAll()
    }

    override fun setPresenter(presenter: QuestionContract.pre?) {
        this.pre = presenter as QuestionSearchPre
    }


}