package com.urovo.activity.overduequeryactivity.model

import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.urovo.activity.overduequeryactivity.net.OverDueQueryRes
import com.urovo.wugumofang.utils.MyToast
import com.urovo.wugumofang.view.LoadWaitDominator
import kotlinx.coroutines.launch

/**
 * @author Sasuke on 2019-6-4 0004.
 */
class OverDueQueryModel(val repo: OverDueQueryRepo): ViewModel() {
    //转圈圈的状态，在Activity里观察它
    var loadWaitState = MutableLiveData<Int>()/*.apply { value = LoadWaitDominator.DISMISS }*/

    //返回数据的缓存
    var dataCaches = MutableLiveData<OverDueQueryRes.ResultInfo>()

    //当前选中的品牌标签
    var currCheckedPos = MutableLiveData<Int>().apply { value = 0 }

    /**根据标签位置来设置数据表*/
    fun getCurrList(pos: Int): List<OverDueQueryRes.ResultInfo.StockLq>?{
        return when(pos){
            0 ->dataCaches.value?.wgStockLqList
            else  -> dataCaches.value?.sbjStockLqList
        }
    }

    /**
     * 请求数据
     */
    fun queryData(shopId: String) = viewModelScope.launch {
        loadWaitState.value = LoadWaitDominator.LOADING
        try{
            dataCaches.value = repo.queryStockLq(shopId)
        }catch (e: Exception){
            MyToast.show(e.message)
            if (e.message == "暂无数据"){
                loadWaitState.value = LoadWaitDominator.NO_DATA
                return@launch
            }else{
                loadWaitState.value = LoadWaitDominator.NET_ERROR
                return@launch
            }
        }
        loadWaitState.value = LoadWaitDominator.DISMISS//DIY模式默认是空白字
    }
}