package com.urovo.activity.overduequeryactivity.model

import com.urovo.activity.overduequeryactivity.net.OverDueQueryRes
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import okhttp3.Request
import kotlin.coroutines.resume
import kotlin.coroutines.resumeWithException
import kotlin.coroutines.suspendCoroutine

/**
 * @author Sasuke on 2019-6-4 0004.
 */
class OverDueQueryRepo {

    /**临期查询*/
    suspend fun queryStockLq(shopId: String) =
        suspendCoroutine<OverDueQueryRes.ResultInfo> { conti ->
            OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.QUERY_SHOP_STOCK_LQ,
                mapOf("shopId" to shopId),
                object : OkHttpDominator.ResultCallback<OverDueQueryRes>() {
                    override fun onError(request: Request?, e: Exception) {
                        conti.resumeWithException(e)
                    }

                    override fun onResponse(res: OverDueQueryRes?) {
                        res?.let {
                            if (it.resultInfo.sbjStockLqList.isNullOrEmpty() && it.resultInfo.wgStockLqList.isNullOrEmpty()) {
                                conti.resumeWithException(Exception("暂无数据"))
                                return
                            }
                            conti.resume(it.resultInfo)
                            return
                        }

                    }
                })
        }

}