package com.urovo.activity.overduequeryactivity.ui

import android.view.LayoutInflater
import android.view.ViewGroup
import android.widget.TextView
import androidx.core.content.ContextCompat
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.overduequeryactivity.net.OverDueQueryRes
import com.urovo.wugumofang.R
import com.urovo.wugumofang.data.DateUtil
import com.urovo.wugumofang.databinding.OverdueQueryListItemBinding
import com.urovo.wugumofang.utils.isNotNullOrSize
import com.urovo.wugumofang.utils.notNullAndEmpty
import com.urovo.wugumofang.view.addTag
import com.wgmf.trade.ui.ada.ViewHolderX
import java.lang.Exception
import java.util.*

/**
 * @author Sasuke on 2019-6-5 0005.
 * 临期查询Adapter
 */
class OverDueQueryAdapter(var dataList: MutableList<OverDueQueryRes.ResultInfo.StockLq>?) :
    RecyclerView.Adapter<ViewHolderX>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        return ViewHolderX(
            DataBindingUtil.inflate<OverdueQueryListItemBinding>(
                LayoutInflater.from(parent.context),
                R.layout.overdue_query_list_item,
                parent,
                false
            ).root
        )
    }

    override fun getItemCount(): Int {
        return dataList?.size ?: 0
    }

    override fun onBindViewHolder(holder: ViewHolderX, position: Int) {
        val binding = DataBindingUtil.getBinding<OverdueQueryListItemBinding>(holder.view)
        val data = dataList?.get(position)
        binding?.root?.apply {
            data?.let {
                findViewById<TextView>(R.id.overdue_item_procuct_name_tv).apply {
                    if (it.proIsExpired) {
                        setTextColor(ContextCompat.getColor(context, R.color.color_common_red_one))
                        addTag(
                            it.proName ?: "",
                            "已过期",
                            R.drawable.shape_rect_round_6_stroke_e6383a,
                            R.color.color_common_red_one
                        )
                    } else {
                        setTextColor(ContextCompat.getColor(context, R.color.color_common_gray))
                        text = it.proName
                    }
                }
            }
        }
        binding?.data = data
    }

    /**设置数据表*/
    fun setDatas(list: List<OverDueQueryRes.ResultInfo.StockLq>?) {
        if (list.isNotNullOrSize()) {
            list?.forEach {
                if (it.proEndDate.notNullAndEmpty() && it.proEndDate != "--") {
                    val startDate = DateUtil.String2Date(it.proEndDate, "yyyy-MM-dd")
                    val endDate = DateUtil.String2Date(DateUtil.getDate(Date()), "yyyy-MM-dd")
                    it.proIsExpired = DateUtil.dyasBetween(startDate, endDate) > 0
                } else {
                    it.proIsExpired = false
                }
            }
            dataList = list as MutableList<OverDueQueryRes.ResultInfo.StockLq>
            notifyDataSetChanged()
        }
    }
}