package com.urovo.activity.personalcenter.model

import java.io.Serializable

/**
 * 权益卡查询实体类
 * @author LW
 */
data class VoucherCardQueryBean(
    val purchaseCardRecords: List<PurchaseCardRecordsBean>?,
    val converRecords: List<ConverRecordsBean>?,
    val megerRecords: List<MegerRecordsBean>?
) : Serializable


data class PurchaseCardRecordsBean(
    val expireDate: String?,  //到期时间
    val orderId: String?,  //订单号
    val purchaseDate: String?,  //购卡时间
    val salerName: String?,  //开卡顾问
    val status: String?  //交易状态
)

data class ConverRecordsBean(
    val createDate: String?,  //发券时间
    val isPostPone: Boolean,  //是否可以延期
    val memberId: String?,  //主键券id
    val pone: Int,  //是否可以延期(1:是)
    val salerName: String?,   //核销顾问
    val sendMessageDate: String?,  //发送短信日期
    val sendMessageNum: Int,  // 剩余发送短信次数
    val status: Int,   //券状态，0：未核销，1：已核销，2：未发券,3:已失效 ,
    val useDate: String?,  //核销时间
    val useShopName: String?,  //核销门店
    val validtime: String?,  //过期时间
    val willSendDate: String  //预估发券时间
)

data class MegerRecordsBean(
    val paramMobile: String?, //传入手机号
    val megerDate: String?,  //合并时间
    val oldMobile: String?,  //旧号码
    val newMobile: String?  //新号码
)
