package com.urovo.activity.personalcenter.presenter;

import android.content.Context;
import android.graphics.Bitmap;

import com.urovo.activity.memberGoodsShare.model.MemberGoodsData;
import com.urovo.activity.memberGoodsShare.model.MemberQrEntity;
import com.urovo.activity.memberGoodsShare.presenter.MemberGoodsQrContract;
import com.urovo.wgmf.zxing.ZxingCodeTool;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.zsy.libcore.common.other.DensityUtil;

import okhttp3.Request;

public class QueryTicketPersenter implements MemberGoodsQrContract.presenter {
    MemberGoodsQrContract.view mView;
    MemberGoodsData data;
    Context context;

    public QueryTicketPersenter(Context context, MemberGoodsQrContract.view mView) {
        this.mView = mView;
        this.mView.setPresenter(this);
        data = new MemberGoodsData();
        this.context = context;
    }

    @Override
    public void start() {
        mView.init();
    }

    public MemberGoodsData getData() {
        if (data == null) {
            data = new MemberGoodsData();
        }
        return data;
    }

    public void setEntity(MemberQrEntity entity) {
        getData().setEntity(entity);
        new Thread(new Runnable() {
            @Override
            public void run() {
                getData().setErweima(transUrlTo2DCode(getData().getQrUrl()));
                mView.refreshUI(getData().getErweima());//先下载了分享时的缩略图再更新，确保分享时图片不为空。
            }
        }).start();

        if (!getData().getEntity().hasImage()) {//前面一个页面产品图片没有下载成功时，就再下载一次；如果直接传过来了就直接刷新UI
            downloadUMImage(getData().getImageUrl());
        }
    }


    /**
     * 把Url生成二维码
     */
    public Bitmap transUrlTo2DCode(String url) {
        if (url != null) {
            return ZxingCodeTool.create2DCode(url, DensityUtil.dip2px(context, 350), DensityUtil.dip2px(context, 350));
        }
        return null;
    }

    /**
     * 下载分享时的图片
     */
    public void downloadUMImage(String imageUrl) {//图片大小一定要转小一点，具体多少不知道，反正以前120x120是可以的
        OkHttpDominator.downImageAsyn(imageUrl, new OkHttpDominator.ResultCallback<Bitmap>() {
            @Override
            public void onError(Request request, Exception e) {
                mView.showMsg("产品图片下载失败，将使用默认图片");
            }

            @Override
            public void onResponse(Bitmap response) {
                if (response != null) {
                    getData().getEntity().setImage(response);
                    mView.refreshUI(getData().getErweima());//先下载了分享时的缩略图再更新，确保分享时图片不为空。
                }
            }
        });
    }
}