package com.urovo.activity.personalcenter.presenter.contract

import com.urovo.activity.personalcenter.model.VoucherCardDataBean
import com.urovo.activity.personalcenter.model.VoucherCardQueryBean
import com.urovo.activity.personalcenter.model.VoucherCardUserInfoBean
import com.urovo.wugumofang.base.BasePresenter

import com.urovo.wugumofang.base.mvp.AbsView
import com.zsy.libcore.model.bean.RequestResult
import retrofit2.Call

/**
 * 权益卡查询 Contract
 * @author LW
 */
interface VoucherCardContract {

    interface IView : AbsView {

        fun voucherCardQuery(voucherCardBean: VoucherCardQueryBean?) {}

        fun voucherCardData(voucherCardBean: VoucherCardDataBean?) {}

        fun voucherCardFailureStatus(status: Boolean) {}

        fun voucherCardSendMessageStatus(status: Boolean) {}

        fun dynamicParameterInfo(voucherCardAddress: String?) {}

        fun voucherCardUserInfo(voucherCardUserInfoBean: VoucherCardUserInfoBean?){}
    }


    interface IPresenter : BasePresenter {
        /**
         * 获取客户信息列表的数据
         * @param ymd:String 日期
         * @param staffId:Int 用户Id
         */
        fun requestVoucherCardData(ymd: String?)

        /**
         * 请求获取权益卡信息数据
         * @param mobile:String 手机号
         */
        fun requestVoucherCardInfo(mobile: String?)

        /**
         * 权益卡失效延期
         * @param memberId:String 券Id
         */
        fun requestVoucherCardFailurePostpone(memberId: String?)

        /**
         * 发送权益卡二维码短信到手机
         * @param memberId:String 券Id
         * @param mobile: String 手机号
         */
        fun requestVoucherCardSendMessage(memberId: String?, mobile: String?)

        /**
         * 动态参数配置详情
         */
        fun requestDynamicParameterInfo()

        /**
         * 权益卡兑换码或商城订单编号查询购买者信息
         * @param exchangeCode:String 	权益卡优惠券兑换码
         * @param orderCode: String 	权益卡商城订单编号
         */
        fun requestVoucherCardUserInfo(exchangeCode: String?, orderCode: String?)

    }
}