package com.urovo.activity.personalcenter.service

import com.urovo.activity.personalcenter.model.MergeMemberEntity
import com.urovo.activity.personalcenter.model.MergeMemberRequest
import com.urovo.wugumofang.constants.ApiUrls
import com.zsy.libcore.model.bean.RequestResult
import retrofit2.Call
import retrofit2.http.*

/**
 * 合并会员
 * @author LW
 */
interface MergeMemberApiService {

    /**
     * 旧手机号获取会员信息
     */
    @POST(ApiUrls.SYGJ.MERGE_MEMBER_INFO_OLD_MOBILE)
    fun mergeMemberInfoOldMobile(
        @Query("oldMobile") oldMobile: String,
        @Query("stopId") stopId: String
    ): Call<RequestResult<MergeMemberEntity>>

    /**
     * 新手机号获取会员信息
     */
    @POST(ApiUrls.SYGJ.MERGE_MEMBER_INFO_NEW_MOBILE)
    fun mergeMemberInfoNewMobile(
        @Query("newMobile") newMobile: String
    ): Call<RequestResult<MergeMemberEntity>>

    /**
     * 合并会员信息
     */
    @POST(ApiUrls.SYGJ.MERGE_MEMBER_INFO_EXECUTE)
    fun mergeMemberInfoExecute(
        @Body request: MergeMemberRequest
    ): Call<RequestResult<Any>>

}