package com.urovo.activity.personalcenter.service

import com.urovo.activity.personalcenter.model.*
import com.urovo.wugumofang.constants.ApiUrls
import com.zsy.libcore.model.bean.RequestResult
import retrofit2.Call
import retrofit2.http.Body
import retrofit2.http.GET
import retrofit2.http.POST
import retrofit2.http.Query

/**
 * 权益卡接口
 * @author LW
 */
interface VoucherCardApiService {

    /**
     * 权益卡查询
     */
    @GET(ApiUrls.APP.VOUCHER_CARD_INFO)
    fun getVoucherCardInfo(@Query("mobile") mobile: String): Call<RequestResult<VoucherCardQueryBean>>

    /**
     * 权益卡数据
     */
    @GET(ApiUrls.APPSALER.VOUCHER_CARD_DATA)
    fun getVoucherCardData(
        @Query("ymd") ymd: String,
        @Query("staffId") staffId: String
    ): Call<RequestResult<VoucherCardDataBean>>

    /**
     * 权益卡失效延期
     */
    @POST(ApiUrls.SYGJ.VOUCHERCARD_FAILURE_POSTPONE)
    fun getVoucherCardFailurePostpone(
        @Query("memberId") memberId: String
    ): Call<RequestResult<Any>>

    /**
     * 发送权益卡二维码短信到手机
     */
    @POST(ApiUrls.SYGJ.VOUCHERCARD_SEND_MESSAGE)
    fun getVoucherCardSendMessage(
        @Query("memberId") memberId: String,
        @Query("mobile") mobile: String
    ): Call<RequestResult<Any>>

    /**
     * 动态参数配置详情
     */
    @POST(ApiUrls.CommonApi.DYNAMIC_PARAMETER_INFO)
    fun getDynamicParameterInfo(
        @Query("paramKey") paramKey: String
    ): Call<RequestResult<String>>


    /**
     * 权益卡兑换码或商城订单编号查询购买者信息
     */
    @POST(ApiUrls.SYGJ.VOUCHERCARD_USER_INFO)
    fun getVoucherCardUserInfo(
        @Body request: VoucherCardUserInfoRequest
    ): Call<RequestResult<VoucherCardUserInfoBean>>

}