package com.urovo.activity.qualityBackAct.model;

/**
 * 上报反馈 的各问题类型的枚举。
 * Created by Sasuke on 2017/1/22.
 */

public enum QTYPE {
    PRODUCT("产品质量问题", 1), URGENT_EVENT("紧急突发事件处理", 13),
    ARRIVE_ERROR("到货误差问题", 721),
    CABINET_MATERIAL("柜子/物料问题"),
    OVERDUE("临/过期货报损申请"),
    LOGISTICS("物流紧急问题", 2),
    SHOPPE("专柜陈列图片上传", 21),
    COMPLAIN("我要找督察"), CPLN_WORKFLOW("我要走流程投诉"), CPLN_PHONE("我要打电话投诉"), CPLN_WECHAT("我要发微信投诉"),
    MACHINE("本机问题", 6), URGENT_ISSUE("紧急问题处理"), SUGGESTION("意见与建议"),

    PACKAGE_BOX("包装盒破损（非外箱破损）", 7, PRODUCT), PACKAGE_BAG("包装袋破损（非外箱破损）", 7, PRODUCT), DATE_IDENTIFY("日期标识问题", 8, PRODUCT), SHORTAGE("含量短缺", 9, PRODUCT),
    FOREIGN("异物杂物", 11, PRODUCT), BUG("虫害（产品中有虫类）", 0, PRODUCT), SMELL("异味", 10, PRODUCT), LOOK_BAD("外观\\口感不良", 0, PRODUCT),
    STORE_REASON("门店原因", 0, PRODUCT), NO_PRODUCT("非产品质量问题", 0, PRODUCT),

    UNFRESH("来货不新鲜", 12, PRODUCT), OTHER("其它", 14, PRODUCT),
    CABINET("柜子问题", 0, CABINET_MATERIAL), MATERIAL("物料问题", 0, CABINET_MATERIAL),

    SHISAN("门店柜型", 0), CHINRETSU("多点陈列上报", 0),
    LIGHT("亮灯情况上报", 0),

    PRODUCT_CLASS("产品类", 0),
    COUNTER_MATERIAL_CLASS("柜台/物料类", 1),
    SALARY_BENEFITS_PERFORMANCE_CLASS("薪资福利/绩效类", 2),
    ORDER_INVENTORY_CLASS("订货盘点类", 3),
    MACHINE_REPAIR_CLASS("机修类（柜子/灯箱维修)", 4),
    BARCODE_PROBLEM("条码问题", 5),
    LOGISTIC_ISSUE("物流问题", 6),
    BUSINESS_MARKETING_STEWARD("生意管家/营销管家", 7),
    MEMBER_REPURCHASE_PROGRAM("会员复购项目", 9),
    OTHERS_CLASS("其他类", 8),

    PACKAGING_IDENTIFICATION("包装/标识", 0, PRODUCT_CLASS),
    PRODUCT_DESIGN_TASTE("产品设计/口感", 1, PRODUCT_CLASS),

    PROMOTIONAL_ACTIVITIES("推广活动类", 2, COUNTER_MATERIAL_CLASS),
    COUNTER_MATERIAL("柜台/物料", 3, COUNTER_MATERIAL_CLASS),
    TASTING_STANDARD_SUGGESTION("试吃标准建议", 4, COUNTER_MATERIAL_CLASS),

    MEMBERSHIP_BENEFIT_DAY("会员日/福利日", 5, MEMBER_REPURCHASE_PROGRAM),
    BENEFIT_CARD("权益卡", 6, MEMBER_REPURCHASE_PROGRAM),
    THOUSANDS_OF_SHOPS("千店万群", 7, MEMBER_REPURCHASE_PROGRAM),
    THOUSANDS_OF_PEOPLE("千人千面", 8, MEMBER_REPURCHASE_PROGRAM);

    public String showName;//用来显示在表格上的文字。
    public int subType;//用来提交的类型。
    public QTYPE parentType;//父类型（比如 产品质量问题，父类型用于加载对应填写表格，子类型用于具体上传参数）

    private QTYPE(String showName) {
        this.showName = showName;
        this.parentType = this;
    }

    private QTYPE(String showName, int subType) {
        this.showName = showName;
        this.subType = subType;
        this.parentType = this;
    }

    //新加一个parentType父类型，用于加载对应不同的填写表格。
    private QTYPE(String showName, int subType, QTYPE parentType) {
        this.showName = showName;
        this.subType = subType;
        this.parentType = parentType;
    }
}
