package com.urovo.activity.qualityBackAct.ui

import android.widget.CheckBox
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.urovo.activity.qualityBackAct.model.DispatchProductEntity
import com.urovo.wugumofang.R
import com.wgmf.trade.GlobalApp.context

/**
 * 选择波次单货品适配器
 * @author LW
 */
class DispatchBillProductChooseAdapter(
    data: List<DispatchProductEntity.DispatchProductBean.DispatchDetailBean>
) : BaseQuickAdapter<DispatchProductEntity.DispatchProductBean.DispatchDetailBean, BaseViewHolder>(
    R.layout.item_delivery_bill_product_choose, data
) {

    fun refreshClickStatus(position: Int) {
        val dispatchDetailBean =
            getItem(position) as DispatchProductEntity.DispatchProductBean.DispatchDetailBean
        dispatchDetailBean.chooseStatus = !dispatchDetailBean.chooseStatus
    }

    override fun convert(
        helper: BaseViewHolder?,
        item: DispatchProductEntity.DispatchProductBean.DispatchDetailBean?
    ) {

        helper?.apply {
            item?.let {
                val deliveryBillChoose = getView<CheckBox>(R.id.delivery_bill_choose)
                deliveryBillChoose.isChecked = it.chooseStatus

                setText(
                    R.id.delivery_bill_product_name, it.proName
                )
                setText(
                    R.id.delivery_bill_product_code, it.proCode
                )
                setText(
                    R.id.delivery_bill_product_bill,
                    context.getString(R.string.problem_escalation_bill, it.dispatchBill)
                )
                setText(
                    R.id.delivery_bill_product_price,
                    context.getString(R.string.problem_escalation_selling_price, it.proPrice)
                )

                setText(
                    R.id.delivery_bill_product_num,
                    context.getString(R.string.problem_escalation_number, it.proQty)
                )
                setText(
                    R.id.delivery_bill_product_amount,
                    context.getString(R.string.problem_escalation_total_price, it.proSumAmount)
                )
            }
        }
    }

}
