package com.urovo.activity.qualityBackAct.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.urovo.activity.qualityBackAct.model.MenuItem;
import com.urovo.wugumofang.R;

/**
 * Created by Sasuke on 2016/12/1.
 */

public class QBackExpandableAdapter extends BaseExpandableListAdapter {
    MenuItem [] array;
    Context context;
    public QBackExpandableAdapter(Context context, MenuItem [] array) {
        this.array = array;
        this.context = context;
    }

    @Override
    public int getGroupCount() {
        return array.length;
    }

    @Override
    public int getChildrenCount(int i) {
        return array[i].childrenArray == null ? 0 : array[i].childrenArray.length;
    }

    @Override
    public Object getGroup(int i) {
        return null;
    }

    @Override
    public Object getChild(int i, int i1) {
        return null;
    }

    @Override
    public long getGroupId(int i) {
        return i;
    }

    @Override
    public long getChildId(int i, int i1) {
        return i1;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int i, boolean isExpanded, View view, ViewGroup viewGroup) {
        GroupHolder holder;
        if(view == null){
            holder = new GroupHolder();
            view = LayoutInflater.from(context).inflate(R.layout.ll_qback_exlist_group,null);
            holder.qbackType = (TextView)view.findViewById(R.id.qback_group_type);
            holder.arrow = (ImageView) view.findViewById(R.id.list_group_arrow);
            view.setTag(holder);
        }else{
            holder = (GroupHolder) view.getTag();
        }
        //正文显示。
        holder.qbackType.setText(array[i].qtype.showName);
        //箭头显示。
        if(getChildrenCount(i) > 0){
            holder.arrow.setVisibility(View.VISIBLE);
            if(isExpanded) {
                holder.arrow.setImageResource(R.drawable.list_group_open);
            }else{
                holder.arrow.setImageResource(R.drawable.list_group_close);
            }
        }else{
            holder.arrow.setVisibility(View.INVISIBLE);
        }
        return view;
    }

    @Override
    public View getChildView(int i, int i1, boolean isLastChild, View view, ViewGroup viewGroup) {
        ChildHolder holder;
        if(view == null){
            holder = new ChildHolder();
            view = LayoutInflater.from(context).inflate(R.layout.ll_qback_exlist_child,null);
            holder.productType = (TextView)view.findViewById(R.id.qback_product_problem);
            view.setTag(holder);
        }else{
            holder = (ChildHolder)view.getTag();
        }
        holder.productType.setText(array[i].childrenArray[i1].showName);
        return view;
    }

    @Override
    public boolean isChildSelectable(int i, int i1) {
        return true;
    }

    class GroupHolder{
        TextView qbackType;//反馈问题类型。
        ImageView arrow;//折叠箭头。
    }

    class ChildHolder{
        TextView productType;//产品质量反馈二级目录。
    }
}
