package com.urovo.activity.qualityBackAct.view

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ArrayAdapter
import android.widget.LinearLayout
import android.widget.TextView
import androidx.fragment.app.Fragment
import com.urovo.activity.qualityBackAct.net.BaseEntity
import com.urovo.activity.qualityBackAct.net.ChinretsuEntity
import com.urovo.activity.qualityBackAct.presenter.QBackContract
import com.urovo.activity.qualityBackAct.presenter.QBackInputPresenter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.data.DateUtil
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.ViewUtil
import com.urovo.wugumofang.utils.MyToast
import kotlinx.android.synthetic.main.ll_qback_chinretsu.*

/**
 * @author Sasuke on 2019/5/23.
 * 多点陈列
 */
class ChinretsuFra : Fragment(), QBackContract.view {
    var presenter: QBackInputPresenter? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        var container = container
        container = inflater.inflate(R.layout.ll_qback_chinretsu, null, false) as LinearLayout
//        keyboard = LimitedKeyboard.newInstance(presenter?.productData()?.inputRule)
        return container
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    override fun initUI() {
        userName.setText(SystemHelper.LoginUserName)
        storeNameTv.setText(SystemHelper.LoginOrganName)
        spotType.setAdapter(createArrayAdapter(presenter?.data?.spotType!!))
        //选择日期的处理与监听判断
        arrayOf(startDateTv,endDateTv).forEach {
            it.setOnClickListener {
                DateUtil.pickDialog(activity as BaseActivity,it as TextView,"yyyy-MM-dd",null,null){
                    if (!startDateTv.text.toString().isNullOrBlank() && !endDateTv.text.toString().isNullOrBlank()){
                        val startDate = DateUtil.String2Date(startDateTv.text.toString(),"yyyy-MM-dd");
                        val endDate = DateUtil.String2Date(endDateTv.text.toString(),"yyyy-MM-dd");
                        if (DateUtil.dyasBetween(startDate,endDate) > 30){
                            it.text = ""
                            showMsg("开始时间和结束时间的最大间隔是30天")
                        }
                        if (DateUtil.dyasBetween(startDate,endDate) < 0){
                            it.text = ""
                            showMsg("开始时间应小于结束时间")
                        }
                    }
                }.show()
            }
        }
    }


    fun createArrayAdapter(array: Array<String>): ArrayAdapter<*> {
        return ArrayAdapter(activity!!,
                R.layout.gray_spinner_dropdown_item,
                array)
    }
    override fun showMsg(msg: String?) {
        MyToast.show(msg)
    }

    override fun packData(): BaseEntity? {
        if (startDateTv.text.toString().isNullOrBlank()){
            showMsg("请选择开始时间")
            return null
        }
        if (endDateTv.text.toString().isNullOrBlank()){
            showMsg("请选择结束时间")
            return null
        }
        if (spotType.getSelectedItemPosition() == 0){
            showMsg("请选择陈列类型")
            return null
        }
//        if (spotNumInput.text.toString().isNullOrBlank()){
//            showMsg("请填写陈列数")
//            return null
//        }
        return ChinretsuEntity().apply {
            userNo = SystemHelper.LoginUserId
            storeNo = SystemHelper.LoginOrganId
//            spotNum = spotNumInput.text.toString()?.toInt()
            type = spotType.getSelectedItemPosition()
            startDate = startDateTv.text.toString()
            endDate = endDateTv.text.toString()
            content = report_edit.text.toString()
        }
    }

    override fun showProgressBar(title: String?, msg: String?, cancelable: Boolean) {
    }

    override fun dismissProgressBar() {
        ViewUtil.dismissProgress()
    }

    override fun setPresenter(presenter: QBackContract.presenter?) {
        this.presenter = presenter as QBackInputPresenter
    }
}