package com.urovo.activity.qualityBackAct.view

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ArrayAdapter
import android.widget.LinearLayout
import androidx.fragment.app.Fragment
import com.urovo.activity.qualityBackAct.net.BaseEntity
import com.urovo.activity.qualityBackAct.net.LightQBackEntity
import com.urovo.activity.qualityBackAct.presenter.QBackContract
import com.urovo.activity.qualityBackAct.presenter.QBackInputPresenter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.ViewUtil
import com.urovo.wugumofang.utils.MyToast
import kotlinx.android.synthetic.main.light_state_qback_fra_layout.*
import java.text.SimpleDateFormat
import java.util.*

/**
 * @author Sasuke on 2019-8-7 0007.
 * 亮灯情况上报
 */
class LightStateFra : Fragment(), QBackContract.view {
    companion object {
        const val ALL_LIGHT_ON = 0
        const val SOME_LIGHT_OFF = 1
    }

    var presenter: QBackInputPresenter? = null
    val stateArray = arrayOf("--请选择--", "全部灯都亮", "有灯不亮")

    override fun showMsg(msg: String?) {
        MyToast.show(msg)
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View {
        var view = inflater?.inflate(R.layout.light_state_qback_fra_layout, container, false) as LinearLayout
        return view
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    override fun initUI() {
        personTv.text = SystemHelper.LoginUserName
        storeNameTv.text = SystemHelper.LoginOrganName
        yearMonthTv.text = SimpleDateFormat("yyyy年M月").format(Date())
        lightStateSpinner.setAdapter(createArrayAdapter(stateArray))
    }

    fun createArrayAdapter(array: Array<String>): ArrayAdapter<*> {
        return ArrayAdapter(activity!!,
                R.layout.gray_spinner_dropdown_item,
                array)
    }

    //打包数据
    override fun packData(): BaseEntity? {
        if (lightStateSpinner.selectedItemPosition == 0){
            showMsg("请选择亮灯情况")
            return null
        }

        return LightQBackEntity().apply {
            userNo = SystemHelper.LoginUserId
            storeNo = SystemHelper.LoginOrganId
            storeName = SystemHelper.LoginOrganName
            yearMonth = SimpleDateFormat("yyyy-MM").format(Date())
            lampStatus = when (lightStateSpinner.selectedItemPosition) {
                1 -> ALL_LIGHT_ON//全部灯亮
                2 -> SOME_LIGHT_OFF//有灯不亮
                else ->-1
            }
        }
    }

    override fun showProgressBar(title: String?, msg: String?, cancelable: Boolean) {
    }

    override fun dismissProgressBar() {
        ViewUtil.dismissProgress()
    }

    override fun setPresenter(presenter: QBackContract.presenter?) {
        this.presenter = presenter as QBackInputPresenter
    }
}