package com.urovo.activity.qualityBackAct.view;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;

import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.github.yoojia.inputs.ValueScheme;
import com.urovo.activity.common.OrderGoodsChoseSingleActivity;
import com.urovo.activity.qualityBackAct.model.QBackInput;
import com.urovo.activity.qualityBackAct.model.QTYPE;
import com.urovo.activity.qualityBackAct.net.BaseEntity;
import com.urovo.activity.qualityBackAct.net.ProductEntity;
import com.urovo.activity.qualityBackAct.presenter.QBackContract;
import com.urovo.activity.qualityBackAct.presenter.QBackInputPresenter;
import com.urovo.activity.qualityBackAct.ui.AddItemGroup;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DialogHelper;
import com.urovo.wugumofang.ui.EditTextDecimal;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.view.LimitedKeyboard;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * Created by Sasuke on 2017/2/4.
 * 产品质量问题
 */

public class ProductFra extends Fragment implements QBackContract.view, View.OnClickListener {
    QBackInputPresenter presenter;

    //    @BindView(R.id.report_goods) TextView reportGoods;//选择产品
//    @BindView(R.id.report_count) EditTextDecimal reportCount;//产品数量
//    @BindView(R.id.date) TextView date;//生产日期
    @BindView(R.id.shouhuo_person_show)
    EditText commitPerson;//提交人
    @BindView(R.id.telephone)
    EditText telephone;//联系电话
    @BindView(R.id.report_edit)
    EditText reportEdit;//描述
    @BindView(R.id.aima)
    View aima;//顶部间隔
    @BindView(R.id.head_text)
    TextView headText;//顶部提示语

    final int TAG_KEY_KCUOM = R.id.kcuom;//单位
    final int TAG_KEY_ITEM_ID = R.id.report_goods;//产品编码

    final AndroidNextInputs inputs = new AndroidNextInputs();//校验框架
    //    @BindView(R.id.reportTypell) LinearLayout reportTypell;////破损类型下拉框//破损啥呀破损，现在所有质量问题都要加类型了
//    @BindView(R.id.posunTypeSpinner) Spinner posunTypeSpinner;//破损类型
//    @BindView(R.id.dateTail) TextView dateTailTv;//日期后面加的两位附加码
    @BindView(R.id.goods_items_container)
    public LinearLayout goodsContainer;//添加好多产品

    private TextView selectGoodsView;//缓存跳转到选择产品页面的TextView
    private LimitedKeyboard keyboard;//限制输入内容的自定义键盘
    private QTYPE currentType = null;//记录当前已选类型

    Unbinder unbinder;

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container = (LinearLayout) inflater.inflate(R.layout.ll_layout_qback_goodshow, null, false);
        unbinder = ButterKnife.bind(this, container);
        keyboard = LimitedKeyboard.newInstance(presenter.productData().getInputRule());
        initUI();
        return container;
    }

    @Override
    public void showMsg(String msg) {
        MyToast.show(msg);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.report_goods://选择产品
                presenter.selectorGoods(this);
                selectGoodsView = (TextView) v;
                break;
            case R.id.date://生产日期
                Calendar c = Calendar.getInstance();
                DialogHelper.alertDatePicker((BaseActivity) getActivity(), (TextView) v).getDatePicker().setMaxDate(c.getTimeInMillis());
                break;
            case R.id.dateTail:
                keyboard.show((TextView) v, getFragmentManager(), "");
            default:
        }
    }
    //    @Override
//    @OnClick({R.id.report_goods,R.id.date,R.id.dateTail})
//    public void onClick(View v) {
//        switch(v.getId()){
//            case R.id.report_goods://选择产品
//                presenter.selectorGoods(this);
//                selectGoodsView = (TextView) v;
//                break;
//            case R.id.date://生产日期
//                Calendar c = Calendar.getInstance();
////                c.add(Calendar.DAY_OF_YEAR,-1);
//                DialogHelper.alertDatePicker((BaseActivity)getActivity(), (TextView) v).getDatePicker().setMaxDate(c.getTimeInMillis());
//                break;
//            case R.id.dateTail:
//                keyboard.show((TextView)v,getFragmentManager(),"");
//            default:
//        }
//    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            case QBackInput.SELECT_GOODS://产品质量反馈 的 选择产品
                if (resultCode == OrderGoodsChoseSingleActivity.activityResultCode) {
                    com.urovo.wgmf.db.dao.entitys.ProductEntity entity = (com.urovo.wgmf.db.dao.entitys.ProductEntity) data.getSerializableExtra(OrderGoodsChoseSingleActivity.activityResultData);
                    if (entity != null && selectGoodsView != null) {
                        selectGoodsView.setText(entity.getItemName());//先在之前点击的组件上显示名字。
                        selectGoodsView.setTag(TAG_KEY_ITEM_ID, entity.getItemId());//把产品id存到文本框的tag里
                        selectGoodsView.setTag(TAG_KEY_KCUOM, entity.getKCUom());
                        presenter.productData().setProduct(entity);
                        refreshProInfoShow();//刷新一下单位显示
                    }
                }
                break;
            default:
        }
    }

    /**
     * 根据选择的产品，遍历所有元素，刷新一下产品信息显示
     */
    private void refreshProInfoShow() {
        int childNum = goodsContainer.getChildCount();
        for (int index = 0; index < childNum; index++) {
            ProductHolder child = (ProductHolder) goodsContainer.getChildAt(index).getTag();
            child.kcuom.setText((String) child.reportGoods.getTag(TAG_KEY_KCUOM));
        }
    }


    @Override
    public void initUI() {
        if (goodsContainer.getChildCount() == 0) {
            addChildToLayout(0);
        }
        commitPerson.setText(SystemHelper.LoginUserName);
        telephone.setText(SystemHelper.LoginUserMobile);

    }

    public void addChildToLayout(int pos) {
        AddItemGroup group = new AddItemGroup.Builder(getActivity())
                .attachTo(goodsContainer)
                .addChildAt(pos, R.layout.goods_item_simple)
                .setOnAddListener(new AddItemGroup.OnAddListener() {
                    @Override
                    public void onAdd(int pos) {
                        //自己调自己，因为此方法里要初始化holder
                        //还要setTag，还有设置选择产品的点击监听
                        //因为封装的里面不知道选择产品的组件是谁
                        addChildToLayout(pos);
                    }
                })
                .build();//build（）执行之后，其实就已经把child加载到容器布局里去了。
        ViewGroup child = group.getChild();//child用来在tag里存holder
        View content = group.getContentView();//content用来建holder

        final ProductHolder holder = new ProductHolder();
        holder.kcuom = (TextView) content.findViewById(R.id.kcuom);
        holder.reportGoods = (TextView) content.findViewById(R.id.report_goods);
        holder.reportCount = (EditTextDecimal) content.findViewById(R.id.report_count);
        holder.date = (TextView) content.findViewById(R.id.date);
        holder.dateTailTv = (TextView) content.findViewById(R.id.dateTail);
        holder.reportTypell = (LinearLayout) content.findViewById(R.id.reportTypell);
        holder.posunTypeSpinner = (Spinner) content.findViewById(R.id.posunTypeSpinner);
        holder.posunTypeSpinner.setAdapter(
                createArrayAdapter(presenter.productData().getSpinnerArrayByType(presenter.getData().qtype))
        );

        //其实还有一项，下拉的spinner，inputs不支持，所以留在最后的打包数据里校验。

        /**跳转选择商品点击*/
        holder.reportGoods.setOnClickListener(this);
        /**选择日期点击*/
        holder.date.setOnClickListener(this);
        /**日期后两位点击*/
        holder.dateTailTv.setOnClickListener(this);

        child.setTag(holder);//不要忘了
    }

    /**
     * 生成给Spinner用的Adapter
     */
    public ArrayAdapter createArrayAdapter(String[] array) {
        return new ArrayAdapter(getActivity(),
                R.layout.gray_spinner_dropdown_item,
                array);
    }

    @Override
    public void onResume() {
        super.onResume();
        //只有在子类型改变了才执行onResume的一些重置操作，没变类型就不重置了
        if (currentType != null && currentType == presenter.getData().qtype) {
            return;
        }
        //同步存储一下当前类型
        currentType = presenter.getData().qtype;
        //非外箱破损需要在顶类型下面显示一个备注提示语
        if (aima != null && headText != null) {
            if (presenter.getData().qtype == QTYPE.PACKAGE_BAG
                    || presenter.getData().qtype == QTYPE.PACKAGE_BOX) {//如果是 包装破损 ，就显示顶部提示语
                aima.setVisibility(View.GONE);
                headText.setVisibility(View.VISIBLE);
                headText.setText("备注：外箱破损的请走到货误差");
            } else {
                aima.setVisibility(View.VISIBLE);
                headText.setVisibility(View.GONE);
            }
        }
        //门店问题、非产品质量问题、其它  都不需要显示类型选择
//        reportTypell.setVisibility( (presenter.getData().qtype == QTYPE.STORE_REASON ||
//            presenter.getData().qtype == QTYPE.NO_PRODUCT ||
//            presenter.getData().qtype == QTYPE.OTHER) ? View.GONE : View.VISIBLE);
        //==========根据枚举类型来获取下拉类型列表==========
        //如果在质量反馈页面里面点击的类别选择，则该Fragment不会被刷新，
        // 因为parentType都是质量问题反馈，
        //而不同子类别的spinner类别下拉菜单数据又分别不同，所以需要刷新spinner的数据源
        refreshTypeSpinnerShow();
        //情况说明的hint刷新同上
        reportEdit.setHint(presenter.productData().getReportHintByType(presenter.getData().qtype));
    }

    //如果在质量反馈页面里面点击的类别选择，则该Fragment不会被刷新，
    // 因为parentType都是质量问题反馈，
    //而不同子类别的spinner类别下拉菜单数据又分别不同，所以需要刷新spinner的数据源
    public void refreshTypeSpinnerShow() {
        int childNum = goodsContainer.getChildCount();
        for (int index = 0; index < childNum; index++) {
            ProductHolder child = (ProductHolder) goodsContainer.getChildAt(index).getTag();
//                if(child != null){
            child.posunTypeSpinner.setAdapter(
                    createArrayAdapter(presenter.productData().getSpinnerArrayByType(presenter.getData().qtype))
            );
//                }
        }
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }

    @Override
    public void setPresenter(QBackContract.presenter presenter) {
        this.presenter = (QBackInputPresenter) presenter;
    }

    private void initInputsRules() {
        inputs.clear();
        //        inputs.add(reportGoods, StaticScheme.Required(),ValueScheme.NotEquals("请选择").msgOnFail("未选择产品"));
//        inputs.add(reportCount, StaticScheme.Required());
//        inputs.add(date, StaticScheme.Required(),ValueScheme.NotEquals("请选择").msgOnFail("未选择日期"));
//        inputs.add(dateTailTv,StaticScheme.Required());
        inputs.add(commitPerson, StaticScheme.Required());
        inputs.add(telephone, StaticScheme.Required(), StaticScheme.ChineseMobile());
        inputs.add(reportEdit, StaticScheme.Required());

        int childNum = goodsContainer.getChildCount();
        for (int index = 0; index < childNum; index++) {
            ProductHolder holder = (ProductHolder) goodsContainer.getChildAt(index).getTag();
            inputs.add(holder.reportGoods, StaticScheme.Required(), ValueScheme.NotEquals("请选择").msgOnFail("未选择产品"));
            inputs.add(holder.reportCount, StaticScheme.Required());
            inputs.add(holder.date, StaticScheme.Required(), ValueScheme.NotEquals("请选择").msgOnFail("未选择日期"));
            inputs.add(holder.dateTailTv, StaticScheme.Required());
        }
    }

    @Override
    public BaseEntity packData() {
        initInputsRules();
        if (inputs.test()) {
            int childNum = goodsContainer.getChildCount();
            for (int index = 0; index < childNum; index++) {//循环检查每一个item的生产日期是否等于今天，如果等于今天说明是乱填的，不让他提交。
                if (((ProductHolder) goodsContainer.getChildAt(index).getTag()).date.getText().toString().equals(new SimpleDateFormat("yyyy-MM-dd").format(new Date()))) {
////                if(date.getText().toString().equals(new SimpleDateFormat("yyyy-MM-dd").format(new Date()))){
                    showMsg("生产日期有误差，请核实并重新选择！");
                    return null;
                }
            }
            // 校验通过，开始“读取数据”并“组建请求报文的Json”

            //先把container里的child们组装成list，再塞到总json里去。
            List<ProductEntity.details> details = new ArrayList<>();

            for (int index = 0; index < childNum; index++) {
                ProductHolder child = (ProductHolder) goodsContainer.getChildAt(index).getTag();
                ProductEntity.details info = new ProductEntity.details();
                info.setProductName(child.reportGoods.getText().toString());
                info.setProductCount(child.reportCount.getText().toString() + child.reportGoods.getTag(TAG_KEY_KCUOM));//新需求：数量要拼接上单位。
                info.setProductNo(child.reportGoods.getTag(TAG_KEY_ITEM_ID) + "");
                //如果日期后两位没填，那上传的时候就传个“XX”
                info.setProductionDate(child.date.getText().toString().replace("-", "") + (child.dateTailTv.getText().toString().equals("无") ? "XX" : child.dateTailTv.getText().toString()));

                if (child.reportTypell.getVisibility() == View.VISIBLE) {//如果显示了类型，那就要校验一下
                    if (child.posunTypeSpinner.getSelectedItemPosition() == 0) {
                        showMsg("请选择类别");
                        return null;
                    } else {
                        info.setSubCategory(child.posunTypeSpinner.getSelectedItem().toString());
                    }
                }
                details.add(info);
            }

//            if (reportTypell.getVisibility() == View.VISIBLE) {
//                if (posunTypeSpinner.getSelectedItemPosition() == 0) {
//                    showMsg("请选择类别");
//                    return null;
//                } else {
//                    json.setSubCategory(posunTypeSpinner.getSelectedItem().toString());
//                }
//            }

            ProductEntity json = new ProductEntity();
////            if(reportTypell.getVisibility() == View.GONE){
            json.setThemeName(presenter.getData().qtype.showName);
////           }
////            json.setOrderId(presenter.getData().getOrderId());
//            json.setProductName(reportGoods.getText().toString());
//            json.setProductCount(reportCount.getText().toString());
//            ////如果日期后两位没填，那上传的时候就传个“XX”
//            json.setProductionDate(date.getText().toString().replace("-","") + (dateTailTv.getText().toString().equals("无")? "XX" : dateTailTv.getText().toString()));

            json.setMobile(telephone.getText().toString());
            json.setDescription(reportEdit.getText().toString());
            json.setShopName(SystemHelper.LoginOrganName);
            json.setSubmiter(commitPerson.getText().toString());
            json.setTitle(presenter.getData().getParentType().showName);
            json.addProInfos(details);

            return json;
        } else {
            MyToast.show(getActivity(), "填写有误，请检查", Toast.LENGTH_SHORT);
            return null;
        }
    }

    class ProductHolder {
        TextView reportGoods;//选择产品
        EditTextDecimal reportCount;//产品数量
        TextView date;//生产日期
        Spinner posunTypeSpinner;//破损类型下拉框//破损啥呀破损，现在所有质量问题都要加类型了
        TextView dateTailTv;//日期后面加的两位附加码
        LinearLayout reportTypell;//破损类型下拉框//破损啥呀破损，现在所有质量问题都要加类型了
        TextView kcuom;//单位
    }

    @Override
    public void showProgressBar(String title, String msg, boolean cancelable) {
        ViewUtil.showProgress(getActivity(), title, msg);
    }

    @Override
    public void dismissProgressBar() {
        ViewUtil.dismissProgress();
    }
}
