package com.urovo.activity.qualityBackAct.view;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.activity.qualityBackAct.model.MenuItem;
import com.urovo.activity.qualityBackAct.model.QBackMenu;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 产品质量反馈的过滤中间列表（界面过于简单，故不使用presenter）
 * Created by Sasuke on 2017/1/19.
 */
public class ProductQBackListAct extends BaseActivity{
    @BindView(R.id.qback_product_lv)  ListView lv;
    private MenuItem [] mProductMenu;
    //用来暂存填写反馈的Activity（因为QBackInputAct退出即隐藏，所以需要在本页面关闭时一起关闭QBackInputAct）
    Unbinder unbinder;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.qback_product_list_act);
        unbinder = ButterKnife.bind(this);
        initTitle();
        initUI();
        setListener();
    }

    private void setListener(){
        lv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
                Intent intent = new Intent(ProductQBackListAct.this,QBackInputAct.class);
                intent.putExtra(AppConstants.PreKeys.QBACK_TYPE,mProductMenu[i].qtype);//传的是一个枚举类型。
                intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);//跳转的界面返回时是需要moveToBackground。
//                intent.setFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT);
                startActivity(intent);
                overridePendingTransition(R.anim.right_in,R.anim.left_out);
//                finish();
            }
        });
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText("产品质量问题");
    }

    private void initUI(){
        mProductMenu = new QBackMenu().getProductMenu();

        lv.setAdapter(new BaseAdapter() {
            @Override
            public int getCount() {
                return mProductMenu.length;
            }

            @Override
            public Object getItem(int i) {
                return null;
            }

            @Override
            public long getItemId(int i) {
                return i;
            }

            @Override
            public View getView(int i, View view, ViewGroup viewGroup) {
                Holder holder;
                if(view == null){
                    holder = new Holder();
                    view = LayoutInflater.from(ProductQBackListAct.this).inflate(R.layout.ll_qback_exlist_group,null);
                    holder.qbackType = (TextView)view.findViewById(R.id.qback_group_type);
                    holder.arrow = (ImageView) view.findViewById(R.id.list_group_arrow);
                    view.setTag(holder);
                }else{
                    holder = (Holder) view.getTag();
                }
                //正文显示。
                holder.qbackType.setText(mProductMenu[i].qtype.showName);
                //箭头显示。
                holder.arrow.setVisibility(View.VISIBLE);
                holder.arrow.setImageResource(R.drawable.to_right_nor);
                return view;
            }

            class Holder{
                TextView qbackType;//反馈问题类型。
                ImageView arrow;//向右箭头。
            }
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }

}
