package com.urovo.activity.qualityBackAct.view;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentTransaction;

import com.squareup.picasso.Picasso;
import com.urovo.activity.qualityBackAct.model.QTYPE;
import com.urovo.activity.qualityBackAct.net.ArrErrTextImgRes;
import com.urovo.activity.qualityBackAct.net.BaseEntity;
import com.urovo.activity.qualityBackAct.presenter.QBackContract;
import com.urovo.activity.qualityBackAct.presenter.QBackInputPresenter;
import com.urovo.activity.qualityBackAct.ui.PictureAdapter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DensityUtil;
import com.urovo.wugumofang.ui.PhotoPickDominator;
import com.urovo.wugumofang.ui.PhotoPreviewDominator;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.view.BottomDialog;
import com.urovo.wugumofang.view.webview.FraContainerAct;
import com.wgmf.trade.ui.fra.more.reportfeedback.QualityBackResultFra;
import com.wgmf.trade.ui.fra.more.reportfeedback.QualityBackType;
import com.zsy.libcore.ui.fra.FragmentArgs;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

import static com.urovo.activity.qualityBackAct.model.QBackInput.PHOTO_MAX_NUM;
import static com.urovo.activity.qualityBackAct.model.QBackInput.PHOTO_MAX_NUM_CHINRETSU;
import static com.urovo.activity.qualityBackAct.model.QBackInput.PHOTO_MAX_NUM_LIGHT;

/**
 * 用户填写反馈具体内容（共用）
 * Created by Sasuke on 2017/1/20.
 */

public class QBackInputAct extends BaseActivity
        implements QBackContract.view,
        View.OnClickListener {
    QBackInputPresenter presenter;
    @BindView(R.id.report_type)
    TextView typeTv;
    //    @BindView(R.id.qback_input_frag_container)
//    LinearLayout container;
    @BindView(R.id.qback_type_arrow)
    ImageView typeArrow;
    @BindView(R.id.add_picture)
    ImageView addPicture;//添加照片按钮
    @BindView(R.id.add_picture_hint)
    TextView pictureHint;//照片栏提示文字
    @BindView(R.id.buttonSubmit)
    Button buttonSubmit;//提交按钮
    @BindView(R.id.photoGroup)
    LinearLayout photoGroup;//横向照片显示list

    @BindView(R.id.chartTitleLayout)
    LinearLayout chartTitleLayout;//标题栏

    @BindView(R.id.confirm)
    Button confirm;//右上角按钮

    @BindView(R.id.arrErrText)
    TextView arrErrTextTv;//到货误差时下方文字

    @BindView(R.id.arrErrAlertLayout)
    LinearLayout arrErrAlertLayout;//到货误差情况下方说明图片容器

    @BindView(R.id.bottomLeftImg)
    ImageView bottomLeftImg;//到货误差时下方说明图片左

    @BindView(R.id.bottomRightImg)
    ImageView bottomRightImg;//到货误差时下方说明图片右

    BottomDialog dialog;//点击添加图片出现的底部弹窗
    public PictureAdapter reportPicAdapter;
    PhotoPickDominator picker;


    /**
     * 通过字符串映射QTYPE，用于在更多页面跳转时的传值 。把json里的params转换成QTYPE
     */
    public static QTYPE param2Qtype(String str) {
        for (QTYPE qtype : QTYPE.values()) {
            if (qtype.toString().equals(str)) {
                return qtype;
            }
        }
        return QTYPE.PRODUCT;
//        switch (str) {
//            case "SHISAN":
//                return QTYPE.SHISAN;
//            case "CHINRETSU":
//                return QTYPE.CHINRETSU;
//            case "COMPLAIN":
//                return QTYPE.COMPLAIN;
//            case "SUGGESTION":
//                return QTYPE.SUGGESTION;
//            case "LIGHT"://亮灯情况上报
//                return QTYPE.LIGHT;
//            case "CPLN_WORKFLOW": //走流程投诉
//                return QTYPE.CPLN_WORKFLOW;
//            default:
//                return QTYPE.PRODUCT;
//        }
    }

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        setIntent(intent);
        initUI();
        presenter.makeOrderId();//产品质量问题，在不关闭本页面的前提下，选另一个类型之后，回到这个页面，就要重置一下单号了，毕竟类型换了。
    }

    Unbinder unbinder;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.quality_back);
        unbinder = ButterKnife.bind(this);
        presenter = new QBackInputPresenter(this);
        presenter.start();

    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            //顶栏反馈类型点击，重新选择
            case R.id.report_type:
                Intent intent = new Intent(this, ProductQBackListAct.class);
                startActivity(intent);
                overridePendingTransition(R.anim.left_in, R.anim.right_out);
                break;
            //返回
            case R.id.back:
                exitCheck();
                break;
            //添加照片
            case R.id.add_picture:
                showBottomDialog();
                break;
//            case R.id.camera_pick://相机拍照
//                presenter.cameraPick();
//                dialog.dismiss();
//                break;
//            case R.id.local_pick://本地图库
//                presenter.localPick();
//                dialog.dismiss();
//                break;
            //提交
            case R.id.buttonSubmit:
                presenter.submit();
                break;
            //右上角结果按钮
            case R.id.confirm:
                FragmentArgs fragmentArgs = new FragmentArgs();
                if (presenter.getData().qtype == QTYPE.SUGGESTION) {//意见与建议
                    fragmentArgs.add(AppConstants.ExtraKeys.QBACK_RESULT_TYPE, QualityBackType.Suggestion.getIndex());
                } else if (presenter.getData().qtype == QTYPE.CPLN_WORKFLOW) {//我要找督察
                    fragmentArgs.add(AppConstants.ExtraKeys.QBACK_RESULT_TYPE, QualityBackType.InternalComplaints.getIndex());
                }
                FraContainerAct.launch(this, QualityBackResultFra.class, fragmentArgs, false);
                break;
            default:
                break;
        }
    }

    /**
     * 弹出底部弹窗
     */
    private void showBottomDialog() {
        //如果是多点陈列，只能提交最多3张图片
        if (presenter.getData().qtype == QTYPE.CHINRETSU
                && presenter.getData().getPhotoList().size() >= PHOTO_MAX_NUM_CHINRETSU) {
            showMsg("最多只能上传" + PHOTO_MAX_NUM_CHINRETSU + "张图片!");
            return;
        }
        //如果是亮灯情况上报，只能提交最多3张图片
        if (presenter.getData().qtype == QTYPE.LIGHT
                && presenter.getData().getPhotoList().size() >= PHOTO_MAX_NUM_LIGHT) {
            showMsg("最多只能上传" + PHOTO_MAX_NUM_LIGHT + "张图片!");
            return;
        }
        //其它情况
        if (presenter.getData().getPhotoList().size() >= PHOTO_MAX_NUM) {
            showMsg("最多只能上传" + PHOTO_MAX_NUM + "张图片!");
            return;
        }
        //通过了其它校验，开始初始化并弹出
        if (picker == null) {
            picker = new PhotoPickDominator(this, presenter.getData().getPhotoList());
        }
        picker.showDialog();
    }

//    @OnItemClick(R.id.horizontialListView)
//    public void onItemClick(AdapterView<?> parent, int position) {
////        switch (parent.getId()) {
////            case R.id.horizontialListView:
//        if (presenter.getData().getPhotoList().size() == position) {
//            showBottomDialog();
//        } else {
//            showBigImg(position);
//        }
////                break;
////        }
//    }

//    @OnItemLongClick(R.id.horizontialListView)
//    public boolean onItemLongClick(final int position) {
//        if (position == presenter.getData().getPhotoList().size()) {
//            return false;
//        }
//        DialogHelper.Alert2(QBackInputAct.this, "提示", "是否要删除该张图片？", null, new DialogInterface.OnClickListener() {
//            @Override
//            public void onClick(DialogInterface dialog, int which) {
//                presenter.getData().getPhotoList().remove(position);
//                refreshListView();
//            }
//        });
//        return false;
//    }


    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (picker != null) {
            String photoPath = picker.onPhotoPathResult(this, requestCode, resultCode, data);
            if (!photoPath.isEmpty()) {
//                presenter.getData().addPhotoPathToLists(photoPath);
                //这里的addPhoto2Group()里面包含了presenter.getData().addPhotoPathToLists(photoPath);这样的操作
                //因为picker在初始化的时候，已经传入了presenter.getData()里的List
                picker.addPhoto2Group(photoPath,
                        DensityUtil.dip2px(this, 60f),
                        DensityUtil.dip2px(this, 60f),
                        photoGroup);
//                refreshListView();
            }
        }
//        switch (requestCode) {
//            case QBackInput.PHOTO_REQUEST_TAKEPHOTO:// 当选择拍照时调用
//                if (resultCode == Activity.RESULT_OK) {
//                    presenter.getData().addPhotoPathToLists(photoPath);
//                    refreshListView();
//                }
//                break;
//            case QBackInput.PHOTO_REQUEST_GALLERY:// 当选择从本地获取图片时
//                if (resultCode == Activity.RESULT_OK) {
//                    String imgPath;
//                    Cursor cursor = getContentResolver().query(data.getData(), null, null, null, null);
//                    if(cursor != null && cursor.moveToFirst()){
//                        imgPath = cursor.getString(4);//安卓7.0以上，4才是路径，但低版本安卓，1是路径。
//                        if (!imgPath.contains("/storage/")) {//如果不是路径，就再找找。
//                            for (int i = 0; i < 7; i++) {//找个6次应该就差不多了，7、8.。。。后面一般都是null
//                                if (cursor.getString(i).contains("/storage/")) {
//                                    imgPath = cursor.getString(i);
//                                    break;
//                                }
//                            }
//                        }
//                        cursor.close();
//                    }else{
//                        imgPath = data.getDataString().replace("file://","");;
//                    }
//                    presenter.localPickDragOut(imgPath);//把图片从图库拖到指定位置，并改个名字
//                    presenter.getData().addPicNameToList();
//                    refreshListView();
//                }
//                break;
//        }
    }

    /**
     * 刷新横向照片列表
     */
//    public void refreshListView() {
//        int hintVisibility = presenter.getData().getPhotoList().size() > 0 ? View.GONE : View.VISIBLE;
//        int listVisibility = presenter.getData().getPhotoList().size() > 0 ? View.VISIBLE : View.GONE;
//        addPicture.setVisibility(hintVisibility);
//        pictureHint.setVisibility(hintVisibility);
//        photoGroup.setVisibility(listVisibility);
////        reportPicAdapter.notifyDataSetChanged();
//    }
    @Override
    public void initUI() {
        initTitle();
        picker = new PhotoPickDominator(this, presenter.getData().getPhotoList());
        dialog = BottomDialog.newInstance(R.layout.ll_bottom_dialog);
//        dialog.setItemClickListener(this);
        back.setOnClickListener(this);
        addPicture.setOnClickListener(this);
        buttonSubmit.setOnClickListener(this);
        confirm.setOnClickListener(this);
        //先默认隐藏到货误差说明
        arrErrTextTv.setVisibility(View.GONE);
        arrErrAlertLayout.setVisibility(View.GONE);
        //获取传过来的类型，显示对应的Fragment表格（QBACK_TYPE 或 ACTIVITY_TYPE 只用传一个过来就行了）
        QTYPE qtype = (QTYPE) getIntent().getSerializableExtra(AppConstants.PreKeys.QBACK_TYPE);
        //兼容传字符串形式的跳转
        String activityType = getIntent().getStringExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE);
        if (!TextUtils.isEmpty(activityType)) {
            qtype = param2Qtype(activityType);
        }

        //如果之前存的type和新传进来的type不一样，那才切换Fragment，
        if (presenter.getData().getParentType() != qtype.parentType) {
            showFraByType(qtype.parentType);
        }
        presenter.getData().qtype = qtype;
        //设置首栏反馈类型的显示
        typeTv.setText(qtype.showName);
        //只有产品质量问题的问题类型可点击重新选择。
        if (presenter.getData().qtype.parentType == QTYPE.PRODUCT) {
            typeTv.setOnClickListener(this);
            typeArrow.setVisibility(View.VISIBLE);
        } else {
            typeTv.setOnClickListener(null);
            typeArrow.setVisibility(View.INVISIBLE);
        }
        titleTextView.setText(qtype.parentType.showName);
        //从更多里面进来的不需要显示表格里的顶栏。
        chartTitleLayout.setVisibility((qtype == QTYPE.CHINRETSU || qtype == QTYPE.LIGHT) ? View.GONE : View.VISIBLE);
        //创建底栏的照片列表。
//        reportPicAdapter = new PictureAdapter(presenter.getData().getPhotoList(), this);
//        photoListView.setAdapter(reportPicAdapter);
        //设置特立独行的 柜子质量问题 照片hint文字
        if (presenter.getData().qtype == QTYPE.CABINET) {
            pictureHint.setText("添加破损柜台照片、破损柜子柜门内侧公章照片，最多5张");
        } else if (presenter.getData().qtype == QTYPE.MATERIAL) {
            pictureHint.setText("请添加物料问题图片，最多5张");
        } else if (presenter.getData().qtype == QTYPE.OVERDUE) {
            pictureHint.setText("添加照片,至少3张,最多5张。照片要\n" +
                                           "求如下：\n" +
                                           "第1张是报废前,需拍清楚所报损产品\n" +
                                           "的标签及生产日期 ；\n" +
                                           "第2张是报废后,需看得清垃圾桶内的\n" +
                                           "产品；\n" +
                                           "第3张是拆包后的包装袋,也需要看到\n" +
                                           "生产日期");
        }else if (presenter.getData().qtype == QTYPE.CHINRETSU) {
            pictureHint.setText("请添加图片附件，最多3张");
        } else if (presenter.getData().qtype == QTYPE.LIGHT) {
            pictureHint.setText("对不亮的灯进行拍照上传，最多3张");
        }

        //我要找督察&&意见与建议 右上角按钮要显示结果按钮
        if (presenter.getData().qtype == QTYPE.CPLN_WORKFLOW ||
                presenter.getData().qtype == QTYPE.SUGGESTION) {
            confirm.setVisibility(View.VISIBLE);
            confirm.setText("结果");
        }

        //到货误差要请求并显示底部提示栏
        if (presenter.getData().qtype == QTYPE.ARRIVE_ERROR){
            presenter.queryArrErrTextImg(SystemHelper.LoginOrganId, SystemHelper.LoginUserId);
        }
    }

    /***
     * 刷新到货误差底栏文字
     * @param result
     */
    public void refreshArrErrText(ArrErrTextImgRes.ResultInfo result) {
        if (isFinishing()) return;
        arrErrTextTv.setVisibility(View.VISIBLE);
        arrErrAlertLayout.setVisibility(View.VISIBLE);
        arrErrTextTv.setText(result.getTitle() + "\n" +  result.getContent());
        //左边查看大图
        if (!TextUtils.isEmpty(result.getBoxEgImg())){
            Picasso.with(this).load(result.getBoxEgImg()).into(bottomLeftImg);
            bottomLeftImg.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    new PhotoPreviewDominator(arrErrAlertLayout, result.getBoxEgImg(),null).isShowDelBtn(false).showPreview();
                }
            });
        }
        //右边查看大图
        if (!TextUtils.isEmpty(result.getProcessEgImg())){
            Picasso.with(this).load(result.getProcessEgImg()).into(bottomRightImg);
            bottomRightImg.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    new PhotoPreviewDominator(arrErrAlertLayout, result.getProcessEgImg(),null).isShowDelBtn(false).showPreview();
                }
            });
        }
    }


    @Override
    public void setPresenter(QBackContract.presenter presenter) {
        this.presenter = (QBackInputPresenter) presenter;
    }

    @Override
    public void onBackPressed() {
        exitCheck();//退出前弹窗提示确定是否真的退出。
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        switch (keyCode) {
            case KeyEvent.KEYCODE_BACK:
                exitCheck();
                return true;
            default:
        }
        return super.onKeyDown(keyCode, event);
    }

    /**
     * 根据Type来显示不同的Fra填写表格
     */
    public void showFraByType(QTYPE qtype) {
        FragmentTransaction tran = getSupportFragmentManager().beginTransaction();
        QBackContract.view fra = null;
        switch (qtype) {
            case PRODUCT://产品质量问题
                fra = new ProductFra();
                break;
            case ARRIVE_ERROR://到货误差问题
                fra = new ArriveErrorFra();
                break;
            case CABINET_MATERIAL://柜子质量问题
                fra = new CabinetFra();
                break;
            case OVERDUE://临/过期货报损申请
                fra = new OverdueFra();
                break;
            case SHOPPE://专柜陈列图片上传
                fra = new ShoppeFra();
                break;
            case CPLN_WORKFLOW://我要走流程投诉
                fra = new WorkFlowFra();
                break;
            case MACHINE://本机问题
                fra = new MachineFra();
                break;
            case SUGGESTION://意见与建议
                fra = new SuggestionFra();
                break;
            case CHINRETSU://多点陈列
                fra = new ChinretsuFra();
                break;
//            case SHISAN://固定资产
//                fra = new ShisanFra();
//                break;
            case LIGHT://亮灯情况上报
                fra = new LightStateFra();
                break;
            default:
                break;
        }

        if (fra != null) {
            presenter.setFragment(fra);
            tran.replace(R.id.qback_input_frag_container, (Fragment) fra).commit();
        }
    }


    /**
     * 返回退出时，弹窗确定是否真的要退出
     */
    public void exitCheck() {
        new AlertDialog.Builder(this).setMessage("确定要退出？")
                .setNegativeButton("留在本页", null)
                .setPositiveButton("退出", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        finish();
//                        if(presenter.getData().qtype.parentType == QTYPE.PRODUCT) {//产品质量问题退出时跳转到质量问题选择列表。
//                            startActivity( new Intent(QBackInputAct.this, ProductQBackListAct.class));
//                        }
                        overridePendingTransition(R.anim.left_in, R.anim.right_out);
                    }
                }).create().show();
    }

    /**
     * 在图预览（几乎是从老代码直接移过来的，懒得改了）
     */
//    public void showBigImg(int index) {
//        View v = getLayoutInflater().inflate(R.layout.picture_popupwindow, null);
//        ImageView img = (ImageView) v.findViewById(R.id.list_item_bigImg);
//        Bitmap bitmap;
//        if (reportPicAdapter.imageCache.get(presenter.getData().getPhotoList().get(index)) == null || reportPicAdapter.imageCache.get(presenter.getData().getPhotoList().get(index)).get() == null) {
//            bitmap = ReportPicAdapter.revitionImageSize(Files.photoPath + presenter.getData().getPhotoList().get(index));
//            reportPicAdapter.imageCache.put(presenter.getData().getPhotoList().get(index), new SoftReference<Bitmap>(bitmap));
//        } else {
//            bitmap = reportPicAdapter.imageCache.get(presenter.getData().getPhotoList().get(index)).get();
//        }
//        img.setImageBitmap(bitmap);
//        final PopupWindow pw = new PopupWindow(v, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, true);
//        pw.setFocusable(true);
//        pw.setBackgroundDrawable(new BitmapDrawable());
//        pw.showAtLocation(this.findViewById(R.id.title), Gravity.BOTTOM, 0, 0);
//        img.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//                pw.dismiss();
//            }
//        });
//    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }

    @Override
    public BaseEntity packData() {
        return null;
    }

    @Override
    public void showProgressBar(String title, String msg, boolean cancelable) {
        ViewUtil.showProgress(this, title, msg, cancelable);
    }

    @Override
    public void dismissProgressBar() {
        ViewUtil.dismissProgress();
    }
}
