package com.urovo.activity.qualityBackAct.view;

import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager.LayoutParams;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ExpandableListView;
import android.widget.ListView;

import androidx.drawerlayout.widget.DrawerLayout;

import com.urovo.activity.qualityBackAct.net.BaseEntity;
import com.urovo.activity.qualityBackAct.presenter.QBackContract;
import com.urovo.activity.qualityBackAct.presenter.QBackPresenter;
import com.urovo.activity.qualityBackAct.ui.QBackExpandableAdapter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.view.webview.FraContainerAct;
import com.wgmf.trade.ui.fra.more.reportfeedback.QualityBackResultFra;
import com.wgmf.trade.ui.fra.more.reportfeedback.QualityBackType;
import com.zsy.libcore.ui.fra.FragmentArgs;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 上报反馈Activity
 * <p>
 *
 * @author Sasuke
 * @date 2017/1/18
 */
public class QualityBackActivity extends BaseActivity implements QBackContract.view, OnClickListener, AdapterView.OnItemClickListener {
    QBackPresenter presenter;
    Button confirm;
    QBackExpandableAdapter exAdapter;
    @BindView(R.id.qback_main_menu)
    ExpandableListView exList;
    @BindView(R.id.qback_drawer_layout)
    public DrawerLayout drawerLayout;
    @BindView(R.id.lv_slide)
    ListView slideLv;

    List<String> items;
    Unbinder unbinder;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.quality_back_menu);
        unbinder = ButterKnife.bind(this);
        getWindow().setSoftInputMode(LayoutParams.SOFT_INPUT_ADJUST_RESIZE);

        presenter = new QBackPresenter(this);
        presenter.start();

        //侧边栏部分
        items = QualityBackType.getItems();
        ArrayAdapter<String> arrayAdapter = new ArrayAdapter<String>(this, R.layout.listview_slide_item, R.id.tv_slide_item, items);
        slideLv.setAdapter(arrayAdapter);
        slideLv.setOnItemClickListener(this);
    }

    @Override
    public void onClick(View view) {
        toggleDrawer();
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        toggleDrawer();
        FragmentArgs fragmentArgs = new FragmentArgs();
        fragmentArgs.add(AppConstants.ExtraKeys.QBACK_RESULT_TYPE, QualityBackType.getIndexFromName(items.get(position)));
        FraContainerAct.launch(this, QualityBackResultFra.class, fragmentArgs, false);
    }

    private void toggleDrawer() {
        if (drawerLayout.isDrawerOpen(Gravity.RIGHT)) {// 按钮按下，将抽屉打开
            drawerLayout.closeDrawers();
        } else {
            drawerLayout.openDrawer(Gravity.RIGHT);
        }
    }

    @Override
    public void initUI() {
        initTitle();
        exAdapter = new QBackExpandableAdapter(this, presenter.getData().getMainMenu());
        exList.setGroupIndicator(null);
        exList.setDividerHeight(1);
        exList.setAdapter(exAdapter);
        exList.setOnGroupClickListener(new ExpandableListView.OnGroupClickListener() {
            @Override
            public boolean onGroupClick(ExpandableListView expandableListView, View view, int groupPos, long l) {
                if (presenter.getData().getMainMenu()[groupPos].childrenArray == null) {//如果该大类下没有小分支，就直接跳转；否则展开子列表。
                    presenter.jumpToActivity(groupPos, 0);
                }
                return false;
            }
        });
        exList.setOnChildClickListener(new ExpandableListView.OnChildClickListener() {
            @Override
            public boolean onChildClick(ExpandableListView expandableListView, View view, int groupPos, int childPos, long l) {
                presenter.jumpToActivity(groupPos, childPos);//直接按照具体列表位置来跳转。
                return true;
            }
        });

    }

    @Override
    public void setPresenter(QBackContract.presenter presenter) {
        this.presenter = (QBackPresenter) presenter;
    }

    @Override
    public void initTitle() {
        super.initTitle();
        confirm = (Button) findViewById(R.id.confirm);
        titleTextView.setText("上报反馈");
        confirm.setText("结果");
        confirm.setVisibility(View.VISIBLE);
        confirm.setOnClickListener(this);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }

    @Override
    public BaseEntity packData() {
        return null;
    }

    @Override
    public void showProgressBar(String title, String msg, boolean cancelable) {

    }

    @Override
    public void dismissProgressBar() {
        ViewUtil.dismissProgress();
    }
}
