package com.urovo.activity.ra90listact.presenter

import com.urovo.activity.ra90listact.net.Ra90DetailRes
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.system.SystemHelper
import okhttp3.Request

/**
 * @author SASUKE on 2018/3/25.
 */
class Ra90DetailPre(val mView: Ra90ListCon.view) : Ra90ListCon.pre {
    var resSave: Ra90DetailRes? = null

    init {
        mView.setPresenter(this)
    }


    override fun start() {
        mView.init()
    }

    /**
     * 查询数据 ，类型：已回访，未回访
     */
    fun queryData(labelType: Int,queryType: Int, date: String) {
        mView.showLoading()
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.GET_RA90_DATA_LIST,
                mapOf("shopId" to SystemHelper.LoginOrganId, "ym" to date,"type" to queryType.toString()),
                object: OkHttpDominator.ResultCallback<Ra90DetailRes>(){
                    override fun onError(request: Request?, e: Exception?) {
                        mView.showNetError()
                        e?.printStackTrace()
                    }

                    override fun onResponse(res: Ra90DetailRes?) {
                        if (res == null || res.msgCode != 0) {
                            mView.showNoData()
                            return
                        }
                        mView.run {
                            resSave = res.apply { resultInfo.apply {
                                //根据购买时间逆序排序
                                callList = callList?.sortedByDescending { it.lastBuyTime }
                                notCallList = notCallList?.sortedByDescending { it.lastBuyTime }
                            }}
                            dismissLoadWait()
                            showData(labelType)
                        }
                    }
                })
    }
}