package com.urovo.activity.ra90listact.presenter

import com.urovo.activity.ra90listact.net.Ra90Res
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.data.DateUtil
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.system.SystemHelper
import okhttp3.Request
import java.text.SimpleDateFormat

/**
 * @author SASUKE on 2018/3/17.
 */
class Ra90ListPre(val mView: Ra90ListCon.view) : Ra90ListCon.pre {
    val simpleFormat = SimpleDateFormat("yyyy年MM月")
    val uploadFormat = SimpleDateFormat("yyyy-MM")
    var resSave: Ra90Res? = null

    init {
        mView.setPresenter(this)
    }


    /**
     * 根据月份偏移量来得到显示的日期
     */
    fun getDateTextByOff(monthOff: Int): String {
        return simpleFormat.format(DateUtil.getFirstDayOfMonth(monthOff))
    }

    /**
     * 返回用于传给后台的日期数据
     */
    fun getDateByOff(monthOff: Int): String {
        return uploadFormat.format(DateUtil.getFirstDayOfMonth(monthOff))
    }

    override fun start() {
        mView.init()
    }

    /**
     * 查询数据 ，全部 - 新客 - 老客
     */
    fun queryData(clientType: Int,date: String) {
        mView.showLoading()
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.GET_RA90_DATA,
                mapOf("shopId" to SystemHelper.LoginOrganId, "ym" to date),
                object : OkHttpDominator.ResultCallback<Ra90Res>() {
                    override fun onError(request: Request?, e: Exception?) {
                        mView.showNetError()
                        e?.printStackTrace()
                    }

                    override fun onResponse(res: Ra90Res) {
                        if (res == null || res.msgCode != 0) {
                            mView.showNoData()
                            return
                        }
                        mView.run {
                            dismissLoadWait()
                            resSave = res//先备份一份，界面切换标签的时候，再拿出来过滤显示
                            showData(clientType)
                        }

                    }
                })
    }
}