package com.urovo.activity.ra90listact.ui

import android.content.Context
import android.content.Intent
import android.graphics.Color
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.MemberList.model.MemberListEntity
import com.urovo.activity.MemberProfile.view.MemberProfileAct
import com.urovo.activity.ra90listact.net.Ra90DetailRes
import com.urovo.wugumofang.R
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2018/3/27.
 */
class Ra90DetailAdapter(val context: Context, var dataList: List<Ra90DetailRes.ResultInfo.DetailItem>?) : RecyclerView.Adapter<Ra90Holder>() {

    override fun onBindViewHolder(holder: Ra90Holder, pos: Int) {
        holder.apply {
            dataList?.get(pos)?.let {
                val item = it
                phoneTv.apply { text = item.customerMobile.toString() ;setTextColor(Color.BLACK)}
                levelTv.apply { text = item.cusGrade ; setTextColor(Color.BLACK)}
                lastBuyTime.apply{ text = item.lastBuyTime ; setTextColor(Color.BLACK)}

                rightArrow.visibility = View.VISIBLE
                itemRoot.setOnClickListener {
                    val entity = MemberListEntity().apply {
                        buyDate = item.lastBuyTime
                        customerMobile = item.customerMobile
                        customerName = item.customerName
                        hasCommunication = item.hasCommunication
                        phoneCare = item.phoneCare
                        shareCare = item.shareCare
                        smsCare = item.smsCare
                        type = "1"//默认传1获取全部数据
                        wechatCare = item.wechatCare
                    }
                    context.startActivity(Intent(context, MemberProfileAct::class.java).apply {
                        putExtra("phone", item.customerMobile)
//                        putExtra("mType", 1)//告诉它这条新客记录是从哪个标签来的
                        putExtra("entity", entity)//只用传对应会员的Entity就行了
                        putExtra("careType", "1")//关怀类型 默认1新客三响炮 2积分到期提醒 3砖石会员
                        putExtra("position", pos)
                    })
                }
            }
        }
    }

    override fun getItemCount(): Int {
        return dataList?.size ?: 0
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): Ra90Holder {
        return Ra90Holder(LayoutInflater.from(context).inflate(R.layout.ll_ra90_detail_item, parent, false))
    }
}

class Ra90Holder(view: View) : RecyclerView.ViewHolder(view) {
    var itemRoot: ViewGroup
    var phoneTv: TextView
    var levelTv: TextView
    var lastBuyTime: TextView
    var rightArrow: ImageView

    init {
        itemRoot = view.find<ViewGroup>(R.id.itemRoot)
        phoneTv = view.find<TextView>(R.id.phoneTv)
        levelTv = view.find<TextView>(R.id.levelTv)
        lastBuyTime = view.find<TextView>(R.id.lastBuyTime)
        rightArrow = view.find<ImageView>(R.id.rightArrow)
    }
}