package com.urovo.activity.receiveGoodsTabMenu.ui;

import android.app.AlertDialog;
import android.graphics.Paint;
import android.graphics.drawable.BitmapDrawable;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.entitys.PeiSongBillRes;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.ui.DensityUtil;
import com.urovo.wugumofang.view.CustomPopupWindow;

import java.util.List;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

public class ReceiveGoodsPassiveAda extends BaseAdapter {
    private List<PeiSongBillRes.itemBill.PassiveListBean> list;
    private BaseActivity context;

    private String [] statusArray = {"破损","正常"};
    private CustomPopupWindow statusPop;//选择弹窗
    int clickPos = 0 ;

    public ReceiveGoodsPassiveAda(final List<PeiSongBillRes.itemBill.PassiveListBean> list, BaseActivity context) {
        this.list = list;
        this.context = context;
        this.statusPop = new CustomPopupWindow.Builder(context)
                                                                            .setContentView(R.layout.popup_white_list_ll)
                                                                            .setFouse(true)
                                                                            .setOutSideCancel(true)
                                                                            .setAnimationStyle(R.style.dropmenu_anim_style)
                                                                            .setBackgroundDrawable(new BitmapDrawable())
                                                                            .setwidth(DensityUtil.dip2px(context,100))
                                                                            .builder();
        ListView lv = (ListView) statusPop.getItemView(R.id.popupList);
        lv.setAdapter(new ArrayAdapter(context, R.layout.text_view_black_layout, statusArray));
        lv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int popPosition, long id) {
                String status = "-1";
                if(statusArray[popPosition].equals("破损")){
                    status = "3";
                }else if(statusArray[popPosition].equals("正常")){
                    status = "2";
                }
                list.get(clickPos).setBoxStatus(status);
                notifyDataSetChanged();
                statusPop.dismiss();
            }
        });
    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.size();
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.second_receivegoods2menu_item, null);
            viewHolder = new ViewHolder();
            viewHolder.bill = (TextView) convertView.findViewById(R.id.box_num_num);
            viewHolder.type = (TextView) convertView.findViewById(R.id.box_style);
            viewHolder.status = (TextView) convertView.findViewById(R.id.box_condition);
            viewHolder.arrow = (ImageView) convertView.findViewById(R.id.arrow);
            viewHolder.popClickArea = (LinearLayout)convertView.findViewById(R.id.popClickArea);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        final PeiSongBillRes.itemBill.PassiveListBean ent = list.get(position);
        viewHolder.type.setText(ent.getBoxPack());
        viewHolder.bill.setText(ent.getBoxCode());
        viewHolder.bill.getPaint().setFlags(Paint.UNDERLINE_TEXT_FLAG);//下划线
        viewHolder.arrow.setVisibility(ent.isVerify?View.VISIBLE : View.INVISIBLE);
        String pack = ent.getBoxPack().isEmpty() ? "空白" : ent.getBoxPack();
//		if("Z".equals(pack)) {
//			viewHolder.type.setText("整箱");
//		}
//		else
//			if("S".equals(pack)) {
//				viewHolder.type.setText("散拼");
//			}
//			else
//				if("F".equals(pack)) {
//					viewHolder.type.setText("辅料");
//				}
//				else {
//					viewHolder.type.setText("空白");
//				}

        if (ent.getBoxStatus().equals("-1")) { // 箱子状态,1：未到； 2：正常  3：差异  自定义的-1：未处理
            viewHolder.status.setText("未收");
            viewHolder.status.setTextColor(context.getResources().getColor(R.color.red_text_color));
        } else if (ent.getBoxStatus().equals("1")) { // 箱子状态,1：未收； 2：正常  3：破损
            viewHolder.status.setText("未收");
            viewHolder.status.setTextColor(context.getResources().getColor(R.color.red_text_color));
        } else if (ent.getBoxStatus().equals("2")) {
            viewHolder.status.setText("正常");
            viewHolder.status.setTextColor(context.getResources().getColor(R.color.dull_green));
        } else if (ent.getBoxStatus().equals("3")) {
            viewHolder.status.setText("破损");
            viewHolder.status.setTextColor(context.getResources().getColor(R.color.text_color_gray));

        } else {//只可能是1或者2啊，还可能是其它的吗？那一定是后台的错了。
            context.showMsg("后台返回的状态码有误，请检查后台！");
        }

        //只有在isVerify为true，即扫码过的条目，即有箭头显示的条目，才可以挂载点击监听
        viewHolder.popClickArea.setOnClickListener(!ent.isVerify? null : new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickPos = position;
                statusPop.showAsLocation(v, Gravity.BOTTOM, 0, 0);
            }
        });

        //点击弹出详情
        viewHolder.bill.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                View view = LayoutInflater.from(context).inflate(R.layout.receivegoods_passive_detail,null);
                RecyclerView rV = view.findViewById(R.id.receivegoodsDetailRv);
                rV.setLayoutManager(new LinearLayoutManager(context));
                rV.setAdapter( new ReceivePassiveDialogAdapter(context, ent.getDetailList()));

                new AlertDialog.Builder(context)
                        .setView(view)
                        .setPositiveButton("确定",null)
                        .show();
            }
        });

        return convertView;
    }

    class ViewHolder {
        TextView bill;
        TextView type;
        TextView status;
        ImageView arrow;
        LinearLayout popClickArea;//点击下拉区域
    }

}
