package com.urovo.activity.receiveGoodsTabMenu.view;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.urovo.activity.receiveGoodsTabMenu.ui.ReceiveGoodsActiveAda;
import com.urovo.wgmf.db.dao.entitys.PeiSongBillRes;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseSimpleResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;

import java.util.HashMap;

import okhttp3.Request;

/**
 * 主动配送收货(按单)
 *
 * @author Administrator
 */
public class ReceiveGoodsAtiveAct extends BaseActivity {

    private TextView receivenum;
    private TextView store;
    private ListView receivesn;
    private PeiSongBillRes.itemBill bill = new PeiSongBillRes.itemBill();
    private Button submit;
    private ReceiveGoodsActiveAda adapter;
    public static final int RESULTCODE = 1;
    private boolean isUp = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.recieve_goos_sn);
        initTitle();
        init();
    }

    private void init() {
        titleTextView.setText("配送单详情");
//		receivenum = (TextView) findViewById(R.id.receive_num);
//		store = (TextView) findViewById(R.id.receive_store);
        receivesn = (ListView) findViewById(R.id.receive_sn_listview);
        submit = (Button) findViewById(R.id.submit);
        Intent intent = getIntent();
        bill = (PeiSongBillRes.itemBill) intent.getSerializableExtra("object");
        if (bill != null) {
//			receivenum.setText(bill.getPS_Bill());
//			store.setText(bill.getTStoreName());
            bill.setReceivedUserNo(SystemHelper.LoginUserId);//返回给后台的时候要把收货人改成当前的这位。
            adapter = new ReceiveGoodsActiveAda(bill.getInitiativeList(), ReceiveGoodsAtiveAct.this);
            receivesn.setAdapter(adapter);
            submit.setOnClickListener(new OnClickListener() {

                @Override
                public void onClick(View v) {

                    if (isUp) {
                        return;
                    }
//					new UploadPeiSongShouHuoTask(ReceiveGoodsAtiveAct.this, "正在上传配送收货数据...", true, bill).execute("");
                    submit();

                }
            });
        }
    }

    protected void submit() {
        //新需求干掉离线模式。
//        if (!PSTableDbOperate.insert(bill)) {//Json存到本地
//            showMsg("保存本地失败");
//            return;
//        }
        bill.force2ActiveType();//如果那什么和为0，说明要强转成主动配送（只需要提交的时候改，外面的表显示的不用改）
        HashMap<String, String> param = new HashMap<>();
        param.put("dispatch", new Gson().toJson(bill));
        ViewUtil.showProgress(this, "请稍等", "正在上传配送单...");
        OkHttpDominator.postAsynByType(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.SAVE_DISPATCHBILL,
                OkHttpDominator.JSON,
                param,
                new OkHttpDominator.ResultCallback<BaseSimpleResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        showMsg(e.getMessage());
                    }

                    @Override
                    public void onResponse(BaseSimpleResponse res) {
                        ViewUtil.dismissProgress();
                        if (res == null) {
                            showMsg("后台返回为空");
                            return;
                        }
                        if (!TextUtils.isEmpty(res.msgInfo)) {
                            showMsg(res.msgInfo);
                        }
                        if (res.msgCode == 0) {//上传成功
//                            PSTableDbOperate.UpdateBillState(bill.getDispatchBill());//更改本地配送单的成功标记
                            isUp = true;
                            submit.setBackgroundColor(ReceiveGoodsAtiveAct.this.getResources().getColor(R.color.deep_line));
                            setResult(RESULTCODE);
                            ReceiveGoodsAtiveAct.this.finish();
                        }
                    }
                });
    }

//	@Override
//	public void displayResult(String tag, BaseResponse response) {
//
//		super.displayResult(tag, response);
//		if(UploadPeiSongShouHuoTask.TAG.equals(tag)) {
//			showMsg("上传成功!");
//			isUp = true;
//			setResult(RESULTCODE);
//			ReceiveGoodsAtiveAct.this.finish();
//		}
//	}

}
