package com.urovo.activity.receiveGoodsTabMenu.view;

import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager.LayoutParams;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.RadioGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.urovo.activity.receiveGoodsTabMenu.ui.ReceiveGoodsPassiveAda;
import com.urovo.activity.receiveGoodsTabMenu.ui.ReceiveGoodsPassivePopupAdapter;
import com.urovo.wgmf.PosBaseActivity;
import com.urovo.wgmf.db.dao.entitys.PeiSongBillRes;
import com.urovo.wgmf.zxing.CaptureActivity;
import com.urovo.wgmf.zxing.Preferences;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseSimpleResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DialogHelper;
import com.urovo.wugumofang.ui.InputMethodManagerTool;
import com.urovo.wugumofang.ui.ViewUtil;
import com.valence.safe.keyboard.SafeKeyboard;
import com.valence.safe.keyboard.SafeKeyboardConfig;

import java.util.HashMap;

import okhttp3.Request;

/**
 * 被动配送收货(按箱)（就是从左标签的结果点“收货”进去后的界面）
 *
 * @author Administrator
 */
public class ReceiveGoodsPassiveAct extends PosBaseActivity implements OnClickListener {

    // private TextView store;
    // private TextView receivenum;
    private TextView receivecountnum;
    private TextView receiveconfirmnum;
    private EditText receiveedt;
    private ListView listview;
    private PeiSongBillRes.itemBill bill;
    private ReceiveGoodsPassiveAda adapter;
    private int total = 0;
    private PopupWindow pw;
    private ListView detailListView;
    private int index;
    private Button submit;
    private Button scan;
    public static final int RESULTCODE = 2;
    private boolean isUp = false;
    private boolean isAutoScan = false;//扫描模式下，自动连续扫描
    private SafeKeyboard mSafeKeyboard;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.receivegoods2);
        init();
        initTitle();
        titleTextView.setText("配送单详情");
        initListener();
    }

    private void initListener() {
        if (isPda) {
            scan.setEnabled(false);
        }

        receiveedt.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {

                String trim = receiveedt.getText().toString().trim();
                if (TextUtils.isEmpty(trim)) {
                    scan.setText("扫描");
                    if (isPda) {
                        scan.setEnabled(false);
                    }
                } else {
                    scan.setEnabled(true);
                    scan.setText("确认");
                }
            }
        });
        scan.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {

                String trim = receiveedt.getText().toString().trim();
                if (TextUtils.isEmpty(trim)) {
                    PreferHelper.getInstance().setBoolean(Preferences.FLAG_TRANSLUCENT_STATUS, true);
                    PreferHelper.getInstance().setString(Preferences.SCAN_BOTTOM, "请对准二维码或条形码,扫二维码时距离不能太近！");
                    startActivityForResult(new Intent(ReceiveGoodsPassiveAct.this, CaptureActivity.class), 1);
                } else {
                    isAutoScan = false;//如果切换成手动输入了，那就停止自动扫描
//                    receiveedt.setText("");
                    InputMethodManagerTool.getInstance(ReceiveGoodsPassiveAct.this).hideInputMethod(receiveedt);
                    queryBarCode(trim);
                }
            }
        });

    }

    private void init() {
        receivecountnum = (TextView) findViewById(R.id.receive_count_num);
        receiveconfirmnum = (TextView) findViewById(R.id.receive_confirm_num);
        receiveedt = (EditText) findViewById(R.id.receive_edittext);
        submit = (Button) findViewById(R.id.submit);
        scan = (Button) findViewById(R.id.scan_btn);
        listview = (ListView) findViewById(R.id.listview_receivegoods2);

        RelativeLayout receiveRootRl = findViewById(R.id.receive_root_rl);
        LinearLayout receiveSafeKeyboardLl = findViewById(R.id.receive_safe_keyboard_ll);
        LinearLayout receiveSearchContainerLl = findViewById(R.id.receive_search_container_ll);

        SafeKeyboardConfig config = SafeKeyboardConfig.getDefaultConfig();
        config.keyboardTitle = "配送单键盘";
        mSafeKeyboard = new SafeKeyboard(getApplicationContext(), receiveSafeKeyboardLl, receiveRootRl, receiveSearchContainerLl, config);
        mSafeKeyboard.putEditText2IdCardType(receiveedt);

        Intent intent = getIntent();
        bill = (PeiSongBillRes.itemBill) intent.getSerializableExtra("object");
        bill.setReceivedUserNo(SystemHelper.LoginUserId);//进行操作时要改的字段为 receivedUserNo 和 boxStatus
        if (bill != null) {
            receivecountnum.setText(bill.getPassiveList().size() + "");
            for (PeiSongBillRes.itemBill.PassiveListBean bean : bill.getPassiveList()) {
                bean.setBoxStatus("-1");//这个不是后台返回的状态码，是我自己自定义的，表示“未处理”，要不然一上来就会显示“未到”了
            }
            adapter = new ReceiveGoodsPassiveAda(bill.getPassiveList(), ReceiveGoodsPassiveAct.this);
            listview.setAdapter(adapter);
            // listview.setOnItemClickListener(new OnItemClickListener()
            // {
            //
            // @Override
            // public void onItemClick(AdapterView<?> parent, View view, final
            // int position, long id)
            // {
            //
            // showDetail(position);
            // }
            // });
        }
    }

    private void queryBarCode(String barcode) {
//		boolean exist = false;
        // for(WLCK003MEntity ent : bill.WLCK003MList){
        // if(barcode.equals(ent.BQCODE)){
        // if("WD".equals(ent.SH_STATUS)){
        // total += 1;
        // ent.SH_STATUS = "ZC";
        // exist = true;
        // break;
        // }
        // else{
        // showMsg("条码重复");
        // return;
        // }
        // }
        // }
        // Toast.makeText(this, "扫码结果:"+barcode, 1000).show();
        int billSize = bill.getPassiveList().size();
        for (int i = 0; i < billSize; i++) {
            if (bill.getPassiveList().get(i).getBoxCode().equals(barcode)) {
//                showDetail(i);
                index = i;
                refreshUI(2);//只要匹配了就显示“正常”，如果要改破损让他后面自己手动改
                //如果是扫描模式，并且如果已确认数量不等于总数量，那就继续自动执行扫描操作
                if (isAutoScan && total != bill.getPassiveList().size()) {
                    scan.performClick();
                }
                return;
            }
        }
        showMsg("配送单不存在该箱条码");

//		for (int i = 0; i < bill.WLCK003MList.length; i++) {
//			if(barcode.equals(bill.WLCK003MList[i].BQCODE)) {
//				exist = true;
//				showDetail(i);
//				break;
//			}
//		}
//		if(!exist) {
//			showMsg("配送单不存在该箱条码");
//		}
    }

    private void showDetail(int position) {
        index = position;
        if (pw == null) {
            View v = getLayoutInflater().inflate(R.layout.receivegoods2_detail, null);
            detailListView = (ListView) v.findViewById(R.id.listview_receivegoods2_detail);
            final Button enter = (Button) v.findViewById(R.id.enter_receive);
            enter.setOnClickListener(this);
            ImageButton close = (ImageButton) v.findViewById(R.id.close_detail);
            RadioGroup group = (RadioGroup) v.findViewById(R.id.receive_radio_group);
            group.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
                @Override
                public void onCheckedChanged(RadioGroup radioGroup, int checkedId) {
                    enter.setEnabled(true);
                    enter.setTag(checkedId);
                }
            });
            pw = new PopupWindow(v, LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT, true);
            pw.setFocusable(true);
            pw.setBackgroundDrawable(new BitmapDrawable());
            close.setOnClickListener(this);
//			noArrive.setOnClickListener(this);
//			difference.setOnClickListener(this);
//			normal.setOnClickListener(this);
        }

        if (!pw.isShowing()) {
            pw.showAtLocation(receiveedt, Gravity.NO_GRAVITY, 0, 0);
        }
        PeiSongBillRes.itemBill.PassiveListBean wlck003mEntity = bill.getPassiveList().get(index);
        detailListView.setAdapter(new ReceiveGoodsPassivePopupAdapter(wlck003mEntity.getDetailList(), ReceiveGoodsPassiveAct.this));
    }

    @Override
    public void onClick(View v) {

        switch (v.getId()) {
            case R.id.close_detail:
                if (pw != null && pw.isShowing()) {
                    pw.dismiss();
                    pw = null;
                }
                break;
//			case R.id.no_arrive:
//				if(pw != null && pw.isShowing()) {
//					pw.dismiss();
//				}
//				refreshUI(1);
//				break;
//			case difference:
//				if(pw != null && pw.isShowing()) {
//					pw.dismiss();
//				}
//				refreshUI(3);
//				break;
//			case R.id.normal:
//				if(pw != null && pw.isShowing()) {
//					pw.dismiss();
//				}
//				refreshUI(2);
//				break;
            case R.id.enter_receive:
                refreshUI((int) v.getTag());
                if (pw != null && pw.isShowing()) {
                    pw.dismiss();
                    pw = null;
                }
                //如果是扫描模式，并且如果已确认数量不等于总数量，那就继续自动执行扫描操作
                if (isAutoScan && total != bill.getPassiveList().size()) {
                    scan.performClick();
                }
                break;
            case R.id.submit:
                submit();
            default:
                break;
        }
    }

    private void submit() {
        if (isUp) {
            return;
        }

        int iZC = 0;//正常（这命名也是信了你的邪。。。
        int iPS = 0;//破损
        int iCY = 0;//差异
        int iWD = 0;//未到
        for (PeiSongBillRes.itemBill.PassiveListBean x : bill.getPassiveList()) {
            if ("2".equals(x.getBoxStatus())) {
                iZC++;
            } else if ("1".equals(x.getBoxStatus())) {
                iWD++;
            } else if ("3".equals(x.getBoxStatus())) {
                iPS++;
            } else {
                iCY++;
            }
        }
        String msg = "配送单号:\r\n" + bill.getDispatchBill() + "\r\n--------------------\r\n总箱数:" + bill.getPassiveList().size() + " 箱\r\n";
        if (iZC > 0) {
            msg += "正常:" + iZC + " 箱\r\n";
        }
        if (iPS > 0) {
            msg += "破损:" + iPS + " 箱\r\n";
        }

//        if (iCY > 0) {
//            msg += "差异:" + iCY + " 箱\r\n";
//        }
//        if (iWD > 0) {
//            msg += "未到:" + iWD + " 箱\r\n";
//        }
        msg += "--------------------\r\n确认提交吗？";
        DialogHelper.Alert2(ReceiveGoodsPassiveAct.this, "提示", msg, null, new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {

//				new UploadPeiSongShouHuoTask(ReceiveGoodsPassiveAct.this, "正在上传配送收货数..", true, bill).execute("");
//                if (!PSTableDbOperate.insert(bill)) {//Json存到本地
//                    showMsg("保存本地失败");
//                    return;
//                }
                bill.force2ActiveType();//如果那什么和为0，说明要强转成主动配送（只需要提交的时候改，外面的表显示的不用改）
                HashMap<String, String> param = new HashMap<String, String>();
                param.put("dispatch", new Gson().toJson(bill));
                ViewUtil.showProgress(ReceiveGoodsPassiveAct.this, "请稍等", "正在上传配送收货数...");
                OkHttpDominator.postAsynByType(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.SAVE_DISPATCHBILL,
                        OkHttpDominator.JSON,
                        param,
                        new OkHttpDominator.ResultCallback<BaseSimpleResponse>() {
                            @Override
                            public void onError(Request request, Exception e) {
                                ViewUtil.dismissProgress();
                                showMsg(e.getMessage());
                            }

                            @Override
                            public void onResponse(BaseSimpleResponse res) {
                                ViewUtil.dismissProgress();
                                if (res == null) {
                                    showMsg("后台返回为空");
                                    return;
                                }
                                if (!TextUtils.isEmpty(res.msgInfo)) {
                                    showMsg(res.msgInfo);
                                }
                                if (res.msgCode == 0) {//上传成功
//                                    PSTableDbOperate.UpdateBillState(bill.getDispatchBill());//更改本地配送单的成功标记
                                    isUp = true;
                                    submit.setBackgroundColor(ReceiveGoodsPassiveAct.this.getResources().getColor(R.color.deep_line));
                                    setResult(RESULTCODE);
                                    ReceiveGoodsPassiveAct.this.finish();
                                }
                            }
                        });
            }
        });
    }

    private void refreshUI(int type) {

        if (!bill.getPassiveList().get(index).isVerify) {
            bill.getPassiveList().get(index).isVerify = true;
            total += 1;
            receiveconfirmnum.setText(total + "");
            if (total == bill.getPassiveList().size()) {
                submit.setBackgroundColor(this.getResources().getColor(R.color.title_yellow_bg));
                submit.setOnClickListener(this);
            }
        }

        bill.getPassiveList().get(index).setBoxStatus(String.valueOf(type));
        adapter.notifyDataSetChanged();

        switch (type) {
//            case R.id.no_arrive://未到
//                bill.getPassiveList().get(index).setBoxStatus("1");
//                adapter.notifyDataSetChanged();
//                break;
//            case R.id.normal://正常
//                bill.getPassiveList().get(index).setBoxStatus("2");
//                adapter.notifyDataSetChanged();
//                break;
//            case R.id.difference://差异
//                bill.getPassiveList().get(index).setBoxStatus("3");
//                adapter.notifyDataSetChanged();
//                break;
            default:
                break;
        }
    }

//	@Override
//	public void displayResult(String tag, BaseResponse response) {
//
//		super.displayResult(tag, response);
//		if(UploadPeiSongShouHuoTask.TAG.equals(tag)) {
//			showMsg("上传成功!");
//			isUp = true;
//			submit.setBackgroundColor(this.getResources().getColor(R.color.deep_line));
//			setResult(RESULTCODE);
//			ReceiveGoodsPassiveAct.this.finish();
//
//		}
//	}

    // /**
    // * 回车事件处理
    // *
    // */
    // @Override
    // public boolean dispatchKeyEvent(KeyEvent event)
    // {
    // if (event.getKeyCode() == KeyEvent.KEYCODE_ENTER && event.getAction() ==
    // KeyEvent.ACTION_DOWN)
    // {
    // if (receiveedt.isFocused())
    // {// 条码框回车事件
    // String barcode = receiveedt.getText().toString().trim();
    // if (TextUtils.isEmpty(barcode))
    // {
    // showMsg("请先输入条码!");
    // }
    // else
    // {
    // queryBarCode(barcode);
    // }
    // }
    // return true;
    //
    // }
    // else if (event.getKeyCode() == KeyEvent.KEYCODE_ENTER &&
    // event.getAction() == KeyEvent.ACTION_UP) { return false; }
    //
    // return super.dispatchKeyEvent(event);
    // }

    @Override
    protected void onScaned(String barcode) {

        queryBarCode(barcode);
    }


    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (data != null) {
            String code = data.getStringExtra("code");
            isAutoScan = checkHasCode(code);//如果扫码找到了，就开启自动扫码,否则关闭自动扫码
            queryBarCode(code);
        }
    }

    /**
     * 检查是否存在该code
     *
     * @param code
     * @return
     */
    public boolean checkHasCode(String code) {
        int billSize = bill.getPassiveList().size();
        for (int i = 0; i < billSize; i++) {
            if (bill.getPassiveList().get(i).getBoxCode().equals(code)) {
//                isAutoScan = true;
                return true;
            }
        }
        return false;//否则关闭自动扫码
    }

    @Override
    public void onBackPressed() {
        if (mSafeKeyboard.stillNeedOptManually(false)) {
            mSafeKeyboard.hideKeyboard();
            return;
        }
        super.onBackPressed();
    }


    @Override
    protected void onDestroy() {
        if (mSafeKeyboard != null) {
            mSafeKeyboard.release();
            mSafeKeyboard = null;
        }
        super.onDestroy();
    }
}
