package com.urovo.activity.receiveraddress.presenter

import com.google.gson.Gson
import com.urovo.activity.memorderact.net.ReceiversInfosRes
import com.urovo.activity.receiveraddress.net.AddrSubmitBean
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.response.Base3Response
import com.urovo.wugumofang.utils.AddressPickerDominator
import okhttp3.Request

/**
 * @author Sasuke on 2019-7-23 0023.
 */
class AddrEditPresenter(val mView: AddrEditContract.addrEditView) : AddrEditContract.addrEditPre {
    init {
        mView.setPresenter(this)
        start()
    }

    override fun start() {
        mView.init()

    }
//
//    /**
//     * 提交修改过的老地址
//     */
//    fun submitEditedReceiverAddress(info: ReceiversInfosRes.ResultInfo, addrPicker: AddressPickerDominator) {

//    }

    /**
     * 提交新的收货地址
     */
    fun submitNewReceiverAddress(customerTel: String,receiverName: String,
                                 receiverPhone: String,
                                 addrPicker: AddressPickerDominator,
                                 additional: String,
                                 info: ReceiversInfosRes.ResultInfo?) {
        //先建一个完整的实体
        val addrBean = AddrSubmitBean(receiverName, receiverPhone, additional,
                addrPicker.province!!.id,
                addrPicker.city!!.id,
                addrPicker?.district!!.id,
                info?.id ?: 0,
                info?.addressStatus ?: 0,
                info?.customerId ?: 0,
                info?.openId ?: ""
        )
        var json = ""
        //然后根据是新增还是修改，来生成不同的实体（参数传多了也会失败。）
        if (info?.id == null ){//新增
            json = Gson().toJson(addrBean.createNewAddrBean())
        }else{//修改
            json = Gson().toJson(addrBean)

        }


        OkHttpDominator.postAsynByType(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.SUBMIT_NEW_RECEIVER_ADDRESS+"?mobile=${customerTel}",
                OkHttpDominator.JSON, mapOf("address" to json), object : OkHttpDominator.ResultCallback<Base3Response>() {
            override fun onError(request: Request?, e: Exception?) {
                mView.submitFailed(e.toString())
            }

            override fun onResponse(res: Base3Response?) {
                if (res == null) {
                    mView.submitFailed("返回为空")
                    return
                }
                if (res.msgCode != 0) {
                    mView.submitFailed(res.msgInfo)
                    return
                }
                mView.submitSussces(res.msgInfo, addrBean)
            }
        })
    }
}