package com.urovo.activity.report.presenter

import com.urovo.activity.report.model.LogisticsSpecialistEntity
import com.urovo.wugumofang.base.BasePresenter
import com.urovo.wugumofang.base.mvp.AbsView

/**
 * 物流专员信息
 */
interface LogisticsSpecialistContract {

    interface IView : AbsView {
        /**
         * 物流专员信息返回数据
         */
        fun logisticsSpecialistList(data: List<LogisticsSpecialistEntity>)

    }

    interface IPresenter : BasePresenter {
        /**
         * post /sygj/app/logistics/specialist/info/list
         * 物流专员信息请求对象
         */
        fun requestLogisticsSpecialistList()

    }
}
