package com.urovo.activity.report.service

import com.urovo.activity.report.model.LogisticsSpecialistEntity
import com.urovo.activity.report.model.LogisticsSpecialistReqEntity
import com.urovo.wugumofang.net.RetrofitHelper
import com.zsy.libcore.model.bean.RequestResult
import retrofit2.Call

/**
 * 物流专员信息
 * @author LW
 */
class LogisticsSpecialistDepository {

    private val mApiService by lazy {
        RetrofitHelper.createNewApi(ApiService::class.java)
    }

    /**
     * 物流专员信息请求对象
     * @param shopId String
     */
    fun requestLogisticsSpecialistList(shopId: String?): Call<RequestResult<List<LogisticsSpecialistEntity>>> {
        return mApiService.queryLogisticsSpecialistList(LogisticsSpecialistReqEntity(shopId))
    }
}