package com.urovo.activity.report.view

import android.content.Context
import android.content.Intent
import android.view.ViewGroup
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.report.model.LogisticsSpecialistEntity
import com.urovo.activity.report.presenter.LogisticsSpecialistContract
import com.urovo.activity.report.presenter.LogisticsSpecialistPresenter
import com.urovo.activity.report.view.adapter.LogisticsSpecialistAdapter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.base.BasePresenter
import com.urovo.wugumofang.ui.DensityUtil
import com.urovo.wugumofang.ui.SpacesItemDecoration
import com.zsy.libcore.ui.ada.helper.DividerItemDecoration
import kotlinx.android.synthetic.main.public_list_view.*

/**
 * 物流专员信息
 * @author LW
 */
class LogisticsSpecialistActivity: BaseActivity(), LogisticsSpecialistContract.IView {

    private var mLogisticsSpecialistPresenter: LogisticsSpecialistPresenter? = null

    private var mLogisticsSpecialistAdapter: LogisticsSpecialistAdapter? = null

    override fun addRootLayoutId(): Int = R.layout.public_list_view

    override fun rootViewGroup(): ViewGroup = mPublicContainer

    companion object {
        @JvmStatic
        fun launch(context: Context) {
            context.startActivity(Intent(context, LogisticsSpecialistActivity::class.java))
        }
    }

    override fun initTitle() {
        super.initTitle()
        titleTextView.text = getString(R.string.call_logistics_commissioner_phone)
    }

    override fun initViewNew() {
        initTitle()

        mLogisticsSpecialistAdapter = LogisticsSpecialistAdapter(arrayListOf())
        mPublicListViewLv.apply {
            layoutManager = LinearLayoutManager(mContext, RecyclerView.VERTICAL, false)
            adapter = mLogisticsSpecialistAdapter
            addItemDecoration(
                SpacesItemDecoration(
                    DensityUtil.dip2px(mContext, 15f),
                    adapter!!.itemCount,
                    true
                )
            )
        }
    }

    override fun initDataNew() {
    }

    override fun onResume() {
        super.onResume()
        mLogisticsSpecialistPresenter?.requestLogisticsSpecialistList()
    }

    override fun addPresenter(): BasePresenter {
        mLogisticsSpecialistPresenter = LogisticsSpecialistPresenter(this)
        return mLogisticsSpecialistPresenter!!
    }

    override fun logisticsSpecialistList(data: List<LogisticsSpecialistEntity>) {
        mLogisticsSpecialistAdapter?.setNewData(data)
    }
}