package com.urovo.activity.resetpassword.presenter;

import android.text.TextUtils;

import com.urovo.activity.resetpassword.model.PassData;
import com.urovo.activity.resetpassword.web.CheckCodeResponse;
import com.urovo.wgmf.AsyncTask.BaseAppSalerServerTask;
import com.urovo.wugumofang.base.BaseActivity;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by Sasuke on 2016/6/15.
 */
public class ResetPassPresenter implements ResetPassContract.Presenter{
    ResetPassContract.View mView;
    PassData data;
    public ResetPassPresenter(ResetPassContract.View mView) {
        this.mView = mView;
        this.mView.setPresenter(this);
        data = new PassData();
    }

    public void setData(PassData data) {
        if(data != null){
            this.data = data;
        }
    }

    /**
     * 重置密码
     * @param first 输入一次密码
     * @param second 再输入一次密码
     */
    public void resetPassword(String first,String second){
        if(TextUtils.isEmpty(first) || TextUtils.isEmpty(second)){
            ((BaseActivity)mView).showMsg("密码不能为空");
            return;
        }
        if(!first.equals(second)){
            ((BaseActivity)mView).showMsg("两次密码不一致，请重新输入");
            return;
        }

        if(first.length() < 3){
            ((BaseActivity)mView).showMsg("密码不能低于3位数");
            return;
        }

        Map<String,String> params = new HashMap<>();
        params.put("userId",getData().getUserId());
        params.put("phoneNo",getData().getUserPhone());
        params.put("newPassword",first);
        new BaseAppSalerServerTask("resetPassword", CheckCodeResponse.class,
                (BaseActivity) mView, "正在修改密码...", true, "/information/resetPassword",
                params).execute("");
    }

    @Override
    public PassData getData() {
        return this.data;
    }

    @Override
    public void requestCode(String idInput, String phoneInput) {

    }

    @Override
    public void checkCode(String code, String userId, String phone) {

    }

    @Override
    public void set10minStart(long startTime) {

    }

    @Override
    public void startCountDown() {

    }

    @Override
    public void start() {

    }
}
