package com.urovo.activity.saleDatas.presenter;

import com.urovo.activity.saleDatas.model.SaleData;
import com.urovo.activity.saleDatas.net.SalaryResponse;
import com.urovo.activity.saleDatas.net.SaleDataResponse;
import com.urovo.wgmf.AsyncTask.BaseAppSalerServerTask;
import com.urovo.wgmf.AsyncTask.BaseAppServerTask;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.manager.ThreadManager;
import com.urovo.wugumofang.system.SystemHelper;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by Sasuke on 2016/8/25.
 */
public class SaleDataPresenter implements SaleDataConstract.presenter{
    SaleDataConstract.view mView;
    SaleData data;
    public SaleDataPresenter(SaleDataConstract.view mView) {
        this.mView = mView;
        this.mView.setPresenter(this);
        data = new SaleData();
    }

    public SaleData getData(){
        if(data == null){
            data = new SaleData();
        }
        return data;
    }

    /**
     * 查找工资
     */
    public void searchSalary(){
        Map<String, String> params = new HashMap<String, String>();
        //params.put("month",getData().getSalaryDate());//查找日期格式为yyyyMM
        params.put("month", new SimpleDateFormat("yyyyMM").format(new Date()));
        params.put("userno", SystemHelper.LoginUserId);
        //params.put("userno", "75790223");
        new BaseAppSalerServerTask("requestSalary", SalaryResponse.class,(BaseActivity)mView,
                        "正在查询工资...", false, "/salarydetail/querybyempno", params).execute("");
    }

    /**
     * 查找销售数据
     */
    public void searchSaleData(){
//        SimpleDateFormat sdfStart = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
//        SimpleDateFormat sdfEnd = new SimpleDateFormat("yyyy-MM-dd 23:59:59");
        Map<String, String> params = new HashMap<String, String>();
        params.put("shopId",SystemHelper.LoginOrganId);
//        params.put("storeId",SystemHelper.LoginOrganId);
//        params.put("userId",SystemHelper.LoginUserId);
//        Calendar cal = Calendar.getInstance();
//        cal.set(Calendar.DAY_OF_MONTH,1);
//        params.put("startTimeStr",sdfStart.format(cal.getTime()));//起始值传本月第1天
//        params.put("endTimeStr",sdfEnd.format(new Date()));//终结值传今天
        new BaseAppServerTask("requestSale", SaleDataResponse.class,(BaseActivity)mView,
                "正在查询销售数据...",false,"/datastatistics/getStatisticsSummary",params).execute("");
    }

    public void setSaleData(SaleDataResponse.ResultInfoBean bean){
        getData().setMonthTask(bean.getMonthTask());//月任务.
        getData().setMonthAmount(bean.getMonthAmount());//月累计销售金额
        getData().setFinishRate(bean.getFinishRate());//任务完成率
//        getData().setDataList(bean.getSaleCompare());//销量对比（就是那个折线图）
        ThreadManager.getThreadPool().execute(new ChartDataLoadRunnable(bean));
//        getData().setShortAmount(dataList.get(0).getShortAmount());//差额

//        getData().setMerchCommission(dataList.get(0).getMerchCommission());//会员商品提成
//        getData().setTipAmount(dataList.get(0).getTipAmount());//顾客打赏
//        getData().setFlowerNum(dataList.get(0).getFlowerNum());//鲜花数
//        getData().setGoldenSpeedNum(dataList.get(0).getGoldenSpeedNum());//金种子数
    }


    /**
     * 把折线图的数据处理放在新线程里跑
     */
    class ChartDataLoadRunnable implements Runnable {
        SaleDataResponse.ResultInfoBean resBean;
        public ChartDataLoadRunnable(SaleDataResponse.ResultInfoBean resBean) {
            this.resBean = resBean;
        }

        @Override
        public void run() {
            getData().setDataList(resBean);
            mView.refreshLineChart();
        }
    }

    @Override
    public void start() {
        mView.initUI();
    }
}
