package com.urovo.activity.salesdetailnet.repo

import com.urovo.wgmf.db.dao.entitys.SaleProductsEntity
import com.urovo.wgmf.db.dao.entitys.SalesDetialsNewEntity
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import okhttp3.Request
import kotlin.coroutines.resume
import kotlin.coroutines.resumeWithException
import kotlin.coroutines.suspendCoroutine

/**
 * @author Sasuke on 2019-9-17 0017.
 */
class SalesDetailRepo {
    /**
     * 查询门店销售
     */
    suspend fun queryStoreSaleDetail(type: Int,userId: String, storeId: String, startTimeStr: String, endTimeStr: String) = suspendCoroutine<SalesDetialsNewEntity> { conti ->
        OkHttpDominator.postAsyn(NetParam.NEW_SALEDETAIL,
                mapOf("type" to type.toString(),"userId" to userId, "storeId" to storeId, "startTimeStr" to startTimeStr, "endTimeStr" to endTimeStr), object : OkHttpDominator.ResultCallback<SalesDetialsNewEntity>() {
            override fun onError(request: Request?, e: Exception) {
                conti.resumeWithException(e)
            }

            override fun onResponse(res: SalesDetialsNewEntity?) {
                res?.let { conti.resume(res) }
            }
        })
    }
    /**
     * 获取销售明细列表
     */
    suspend fun querySaleDetailByConsId(consId: String) = suspendCoroutine<SaleProductsEntity> { conti ->
        OkHttpDominator.postAsyn(NetParam.SALEDETAILCONSID,
                mapOf("consId" to consId), object : OkHttpDominator.ResultCallback<SaleProductsEntity>() {
            override fun onError(request: Request?, e: Exception) {
                conti.resumeWithException(e)
            }

            override fun onResponse(res: SaleProductsEntity?) {
                res?.let { conti.resume(res) }
            }
        })
    }
}