package com.urovo.activity.salesmanager;

import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.text.method.DigitsKeyListener;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.adapter.SellAdapter;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.data.StringUtils;

import java.util.List;

public class CountEditListener implements OnClickListener {

    private List<ProductEntity> list;
    private BaseActivity context;
    private int position;

    public CountEditListener(BaseActivity context, List<ProductEntity> list, int position) {
        this.list = list;
        this.context = context;
        this.position = position;
    }

    @Override
    public void onClick(View v) {

        Builder builder = new Builder(context);
        builder.setTitle("请输入修改的数量");
        final EditText editText = new EditText(context);
        editText.setKeyListener(new DigitsKeyListener(false, true));
        editText.setText(list.get(position).getTQTY() + "");
        builder.setView(editText);
        builder.setNegativeButton("取消", null);
        builder.setPositiveButton("确定", new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {

                dialog.dismiss();
                String num = editText.getText().toString();
                if (StringUtils.isEmpty(num)) {
                    list.get(position).setTQTY(Double.parseDouble(num));
                    list.get(position).setAmount(Double.parseDouble(num) * (list.get(position).getPrice()));
                    context.onDialogResult(SellAdapter.EDIT_TAG);
                }
            }

        });
        builder.create().show();
    }
}
