package com.urovo.activity.salesmanager;

import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;

import com.urovo.wgmf.AsyncTask.DownVipTask;
import com.urovo.wgmf.AsyncTask.UploadXiaoShouTask;
import com.urovo.wgmf.db.dao.bill.DalCommon;
import com.urovo.wgmf.db.dao.dao.Djxs001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djxs002DbOperate;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.Vip;
import com.urovo.wgmf.db.dao.entitys.XiaoShouEntity;
import com.urovo.wgmf.entity.response.VipResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;

import java.util.Date;
import java.util.List;

public class storeManagerProduceConfit extends BaseActivity implements OnClickListener {

	private Button confirm;
	private Button confirmation;
	private TextView totalPrice;
	private TextView yhPrice;
	private TextView realPrice;
	private TextView vipName;
	private TextView vipGender;
	private TextView vipJF;
	private TextView vipRank;
	private EditText vipEdit;
	private List<ProductEntity> list;

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.store_manager_produce_confit);
		init();
		initvalue();
		initTitle();
	}

	private void init() {

		totalPrice = (TextView) findViewById(R.id.total_price);
		yhPrice = (TextView) findViewById(R.id.yh_price);
		realPrice = (TextView) findViewById(R.id.real_price);
		vipName = (TextView) findViewById(R.id.vip_name);
		vipGender = (TextView) findViewById(R.id.vip_gender);
		vipJF = (TextView) findViewById(R.id.vip_integral);
		vipRank = (TextView) findViewById(R.id.vip_rank);
		vipEdit = (EditText) findViewById(R.id.vip_edit);
		confirm = (Button) findViewById(R.id.confirm);
		confirmation = (Button) findViewById(R.id.produce_confirmation);
		confirm.setText("提交");
		confirm.setOnClickListener(this);
		confirmation.setOnClickListener(this);
		vipName.setOnClickListener(this);
		vipGender.setOnClickListener(this);
	}

	private void initvalue() {

		Intent intent = getIntent();
		list = (List<ProductEntity>) intent.getSerializableExtra("object");
		double countPrice = 0;
		for (ProductEntity p : list) {
			countPrice += p.getAmount();
		}
		totalPrice.setText(String.valueOf(countPrice));
		realPrice.setText(String.valueOf(countPrice));

	}

	@Override
	public void onClick(View v) {

		switch (v.getId()) {
		case R.id.confirm:
			submitData();
			// DialogHelper.Alert(storeManagerProduceConfit.this, "系统提示",
			// "数据上传成功", null, null);
			break;
		case R.id.produce_confirmation:
			if(StringUtils.isEmpty(vipEdit.getText().toString())) {
				String vip = vipEdit.getText().toString().trim();
				new DownVipTask(this, "正在查询会员信息", true, vip).execute("");
			}
			else {
				showMsg("请输入会员号码！");
			}
			break;
		case R.id.vip_name:
			Builder builder = new Builder(this);
			builder.setTitle("请输入姓名");
			final EditText editText = new EditText(this);
			builder.setView(editText);
			builder.setNegativeButton("取消", null);
			builder.setPositiveButton("确定", new DialogInterface.OnClickListener() {

				@Override
				public void onClick(DialogInterface dialog, int which) {

					dialog.dismiss();
					String name = editText.getText().toString();
					vipName.setText(name);
				}

			});
			builder.create().show();
			break;
		case R.id.vip_gender:
			Builder builder2 = new Builder(this);
			builder2.setTitle("请选择性别");
			final View checkSex = View.inflate(this, R.layout.check_sex, null);
			builder2.setView(checkSex);
			builder2.setNegativeButton("取消", null);
			builder2.setPositiveButton("确定", new DialogInterface.OnClickListener() {

				@Override
				public void onClick(DialogInterface dialog, int which) {

					dialog.dismiss();
					RadioGroup checkRadio = (RadioGroup) checkSex.findViewById(R.id.sex);
					RadioButton button = (RadioButton) checkRadio.findViewById(checkRadio.getCheckedRadioButtonId());
					String sexInfo = button.getText().toString();
					vipGender.setText(sexInfo);
				}

			});
			builder2.create().show();
		default:
			break;
		}
	}

	private void submitData() {

		// canUp = true;
		String custid = "";
		String hyxb = "";
		String hyname = "";

		custid = vipEdit.getText().toString().trim();
		// 会员验证通过
		// if (StringUtils.isEmpty(vipEdit.getText().toString().trim()) &&
		// SystemHelper.VipEntity != null) {
		// hyxb = SystemHelper.VipEntity.getVipSex() == "女" ? "F" : "M";
		// hyname = SystemHelper.VipEntity.getVipName();
		// }
		// //会员验证失败时候也可以销售
		// else if (SystemHelper.VipEntity == null){
		// hyxb = "M";
		// }
		// 上传到后台，并保存到本地
		if(list.size() > 0) { // 有明细时才保存
			double amount = 0;
			for (ProductEntity p : list) {
				amount += p.getAmount();
			}
			// 保存销售数据到本地：销售主表和明细表
			XiaoShouEntity ent = new XiaoShouEntity();
			if(!SystemHelper.IsAdmin) {
				Date date = new Date();
				ent.setBillNo(Djxs001DbOperate.GetTodayXiaoShouNo() + 1);
				ent.setStoreId(SystemHelper.LoginOrganId);
				ent.setBill(SystemHelper.LoginOrganId + DateUtil.format(date, "yyMMddHHmmss"));
				ent.setCUSTID(custid);
				ent.setHYXB(hyxb);
				ent.setMDBC(SystemHelper.LoginBC);
				ent.setSaleDate(DateUtil.getDayBefore2(date));
				ent.setSaleTime(DateUtil.getTime(date));
				ent.setSKTNET(amount);
				ent.setSkyId(SystemHelper.LoginUserId);
				ent.setTLine(list.size());
				ent.setTNET(amount);
				ent.setVipName(hyname);
				ent.setXSTYPE("1"); // “1”销售
				// 固定门店模式下posid 为2
				ent.setPOSID("2");
			}
			else {
				Date date = new Date();
				ent.setBillNo(Djxs001DbOperate.GetTodayXiaoShouNo() + 1);
				ent.setStoreId(SystemHelper.DaiLuStore);
				ent.setBill(SystemHelper.DaiLuStore + DateUtil.format(date, "yyMMddHHmmss"));
				ent.setCUSTID(custid);
				ent.setHYXB(hyxb);
				ent.setMDBC(SystemHelper.DaiLuBanCi);
				ent.setSaleDate(DateUtil.getDayBefore2(date));
				ent.setSaleTime(DateUtil.getTime(date));
				ent.setSKTNET(amount);
				ent.setSkyId(SystemHelper.DaiLuOperate);
				ent.setTLine(list.size());
				ent.setTNET(amount);
				ent.setVipName(hyname);
				ent.setXSTYPE("1"); // “1”销售
				// 督导模式下posid为3
				ent.setPOSID("3");
			}
			// 保存销售数据
			Djxs001DbOperate.SaveXiaoShou(ent);
			Djxs002DbOperate.SaveXiaoShouDetail(ent, list);

			// 上传数据
			new UploadXiaoShouTask(storeManagerProduceConfit.this, "正在上传数据", true).execute("");
		}
	}

	@Override
	public void displayResult(String tag, BaseResponse response) {

		super.displayResult(tag, response);
		if(DownVipTask.TAG.equals(tag)) {
			VipResponse vip = (VipResponse) response;
			Vip vipEntity = vip.getVipEntity();
			if(vipEntity != null) {
				vipName.setText(vipEntity.getVipName());
				vipGender.setText(vipEntity.getVipSex());
				vipJF.setText(vipEntity.getYXJF() + "");
				vipRank.setText(vipEntity.getCUSTDJ());
			}
			else {
				showMsg("查不到会员信息，请点击编辑新会员信息！");
			}
		}
		if(UploadXiaoShouTask.TAG.equals(tag)) {

			// 更新未上传数据总数
			DalCommon.GetUnUploadCount(false);

		}
	}

}
