package com.urovo.activity.sanxiangpao.view;

import android.app.DatePickerDialog;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.ImageButton;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.activity.sanxiangpao.model.SanXiangPaoCountEntity;
import com.urovo.activity.sanxiangpao.model.SanXiangPaoListEntity;
import com.urovo.activity.sanxiangpao.presenter.SanXiangPaoPre;
import com.urovo.activity.slidemenu.BlankFrag;
import com.urovo.activity.slidemenu.NoDataFrag;
import com.urovo.wgmf.CommonController;
import com.urovo.wgmf.net.CommonNet;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.SetFocusUtil;
import com.wgmf.trade.model.bean.CommonEntity;
import com.zsy.libcore.model.bean.RequestResult;

import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * @author chenji
 */
@Route(path = RouterParams.Member.SAN_XIANG_PAO)
public class SanXiangPaoAct extends BaseActivity implements OnClickListener, View.OnFocusChangeListener, CommonController.SanXiangPaoInfoView {
    private TextView mTextViewStore;
    private TextView mTextViewDate;
    @BindView(R.id.three_day_btn)
    Button mThreeDayBtn;//3天冲调关怀标签按钮
    @BindView(R.id.seven_day_btn)
    Button mSevenDayBtn;//7天口感关怀标签按钮
    @BindView(R.id.fifteen_day_btn)
    Button mFifteenDayBtn;//15天食用体验关怀标签按钮
    private RelativeLayout mLinearLayoutDate;//改日期的那个区域
    private int mType;
    private Date mDate;
    SimpleDateFormat sdfShow;//格式为"yyyy年MM月dd日"的显示格式
    private SanXiangPaoPre mSanXiangPaoPre;
    SanXiangPaoListFrag listFra;//显示新客列表的Frag
    NoDataFrag noDataFrag;//无新客信息时显示的带提示的Fragment
    BlankFrag blankFrag;
    Unbinder unbinder;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.sanxiangpao);
        unbinder = ButterKnife.bind(this);
        init();
        requestCount();
    }

    private void init() {
        titleTextView = findViewById(R.id.text_title);
        titleTextView.setText("新客三响炮名单");
        ImageButton goback = findViewById(R.id.goback);
        goback.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        //可以点击切换日期的区域
        mLinearLayoutDate = findViewById(R.id.linearLayoutDate);
        mLinearLayoutDate.setOnClickListener(this);

        mTextViewStore = findViewById(R.id.textViewStore);
        mTextViewStore.setText(SystemHelper.LoginOrganName);
        //获取上方标签按钮组件
        getLabelView();
        setLabelClickListener();
        // 1-->3天 ； 2-->7天； 3-->15天
        mType = 1;
        //日期选择器的默认显示
        mDate = new Date();
        sdfShow = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
        mTextViewDate = findViewById(R.id.textViewDate);
        mTextViewDate.setText(sdfShow.format(mDate));
        //显示“暂无数据”
        noDataFrag = new NoDataFrag();
        blankFrag = new BlankFrag();
        //有新客信息时显示此Frag
        listFra = new SanXiangPaoListFrag();
        mSanXiangPaoPre = new SanXiangPaoPre(this, new CommonNet());
    }

    private void requestCount() {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
        Map<String, String> p = new HashMap<>(2);
        p.put("shopId", SystemHelper.LoginOrganId);
        p.put("ymd", sdf.format(mDate));
        mSanXiangPaoPre.start2requestData(AppConstants.SanXiangPao.QUERY_COUNT, p);
    }

    /**
     * 获取上方标签按钮组件
     */
    public void getLabelView() {
        //首先一来就把焦点设在第一个“3天”标签上
        SetFocusUtil.focus(mThreeDayBtn);
        //再来一波字体染色
        mThreeDayBtn.setTextColor(getResources().getColor(R.color.title_yellow_bg));
    }

    /**
     * 给标签按钮挂监听器（包括点击监听、焦点改变监听
     */
    public void setLabelClickListener() {
        mThreeDayBtn.setOnClickListener(this);
        mSevenDayBtn.setOnClickListener(this);
        mFifteenDayBtn.setOnClickListener(this);
        mThreeDayBtn.setOnFocusChangeListener(this);
        mSevenDayBtn.setOnFocusChangeListener(this);
        mFifteenDayBtn.setOnFocusChangeListener(this);
    }


    /**
     * 监听上端标签的点击
     *
     * @param v 标签按钮
     */
    @Override
    public void onClick(View v) {
        int id = v.getId();
        switch (id) {
            case R.id.three_day_btn:
                SetFocusUtil.focus(mThreeDayBtn);
                break;
            case R.id.seven_day_btn:
                SetFocusUtil.focus(mSevenDayBtn);
                break;
            case R.id.fifteen_day_btn:
                SetFocusUtil.focus(mFifteenDayBtn);
                break;
            //改日期的那个点击区域
            case R.id.linearLayoutDate:
                Calendar c = Calendar.getInstance();
                new DatePickerDialog(SanXiangPaoAct.this,
                        new DatePickerDialog.OnDateSetListener() {
                            @Override
                            public void onDateSet(DatePicker view, int year,
                                                  int monthOfYear, int dayOfMonth) {
                                if (mDate.getYear() != (year - 1900)
                                        || mDate.getMonth() != monthOfYear
                                        || mDate.getDate() != dayOfMonth) {
                                    mDate.setYear(year - 1900);
                                    mDate.setMonth(monthOfYear);
                                    mDate.setDate(dayOfMonth);

                                    mTextViewDate.setText(sdfShow.format(mDate));
                                    SanXiangPaoAct.this.getSupportFragmentManager().beginTransaction().replace(R.id.xinke_list_fra_container, blankFrag).commit();
                                    requestCount();
                                }
                            }
                        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c
                        .get(Calendar.DAY_OF_MONTH)).show();
                break;
            default:
                break;
        }
    }

    /**
     * 监听标签的焦点变化
     *
     * @param v        ...
     * @param hasFocus ...
     */
    @Override
    public void onFocusChange(View v, boolean hasFocus) {
        if (hasFocus) {
            ((Button) v).setTextColor(getResources().getColor(R.color.title_yellow_bg));
            int id = v.getId();
            switch (id) {
                case R.id.three_day_btn:
                    mType = 1;
                    break;
                case R.id.seven_day_btn:
                    mType = 2;
                    break;
                case R.id.fifteen_day_btn:
                    mType = 3;
                    break;
                default:
                    break;
            }

            SanXiangPaoAct.this.getSupportFragmentManager().beginTransaction().replace(R.id.xinke_list_fra_container, blankFrag).commit();
            requestCount();
        } else {
            ((Button) v).setTextColor(getResources().getColor(R.color.statusbar_background));
        }
    }

    /**
     * 获取客户信息列表的数据
     */
    private void requestUserData() {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
        Map<String, String> p = new HashMap<>(3);
        p.put("shopId", SystemHelper.LoginOrganId);
        p.put("ymd", sdf.format(mDate));
        p.put("type", "" + mType);
        mSanXiangPaoPre.start2requestData(AppConstants.SanXiangPao.QUERY_LIST, p);
    }

    private void setText(TextView v, int type, String content) {
        if (v != null) {
            switch (type) {
                case 3:
                    content = MessageFormat.format("3天冲调关怀({0})", content);
                    break;
                case 7:
                    content = MessageFormat.format("7天口感关怀({0})", content);
                    break;
                case 15:
                    content = MessageFormat.format("15天食用体验关怀({0})", content);
                    break;
                default:
                    break;
            }
            v.setText(content);
        }
    }

    @SuppressWarnings("unchecked")
    @Override
    public void onResponseSuccess(String tag, CommonEntity resultInfo) {
        if (AppConstants.SanXiangPao.QUERY_COUNT.equals(tag) && null != resultInfo) {
            SanXiangPaoCountEntity sanXiangPaoCountEntity = resultInfo.mSanXiangPaoCountEntity;
            setText(mThreeDayBtn, 3, sanXiangPaoCountEntity.getFirstCareCustomerNum());
            setText(mSevenDayBtn, 7, sanXiangPaoCountEntity.getSecondCareCustomerNum());
            setText(mFifteenDayBtn, 15, sanXiangPaoCountEntity.getThirdCareCustomerNum());
            requestUserData();//请求获取三响炮关怀列表
        } else if (AppConstants.SanXiangPao.QUERY_LIST.equals(tag) && null != resultInfo) {
            RequestResult<List<SanXiangPaoListEntity>> listRequestResult = resultInfo.mSanXiangPaoListEntity;
            if (null != listRequestResult) {
                Bundle bundle = new Bundle();
                bundle.putSerializable("mList", listRequestResult);
                bundle.putInt("mType", mType);//告诉他是3、7、15哪一档的，后面跳转参考话术要用
                listFra.setArguments(bundle);
                if (listRequestResult.resultInfo != null && !listRequestResult.resultInfo.isEmpty()) {
                    SanXiangPaoAct.this.getSupportFragmentManager().beginTransaction().replace(R.id.xinke_list_fra_container, listFra).commit();
                } else {//暂无数据
                    SanXiangPaoAct.this.getSupportFragmentManager().beginTransaction().replace(R.id.xinke_list_fra_container, noDataFrag).commit();
                }
            }
        }
    }

    @Override
    public void onFailure(String tag, String failInfo) {
        MyToast.show(failInfo);
    }

    @Override
    protected void onDestroy() {
        if (unbinder != null) {
            unbinder.unbind();
        }
        super.onDestroy();
    }
}
