package com.urovo.activity.sanxiangpaoData.presenter;

import android.content.Context;
import android.text.TextUtils;

import com.urovo.activity.sanxiangpaoData.model.SXPQueryData;
import com.urovo.activity.sanxiangpaoData.web.SXPBackListEntity;
import com.urovo.activity.sanxiangpaoData.web.SXPBackListResponse;
import com.urovo.wgmf.AsyncTask.BaseAppServerTask;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.data.DateUtil;

import java.text.SimpleDateFormat;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by Sasuke on 2016/6/7.
 */
public class SXPBackListPresenter implements SanXiangPaoDataContract.Presenter{
    SXPQueryData data;
    SanXiangPaoDataContract.View mView;
    Context mContext;
    private SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

    public SXPBackListPresenter(Context context, SanXiangPaoDataContract.View mView) {
        this.mView = mView;
        this.mView.setPresenter(this);
        this.mContext = context;
        data = new SXPQueryData();
    }

    @Override
    public void start() {
//需求是起始日期为本月第一天，终结日期是当天
        Date dateBegin = new Date();
        dateBegin.setDate(1);
        Date dateEnd = new Date();

        data.setDateBegin(sdf.format(dateBegin));//存入默认的起始日期
        data.setDateEnd(sdf.format(dateEnd));//...
    }

    @Override
    public void search() {
        if(! checkDate()){
            return;
        }
        Map<String, String> p = new HashMap<>();
        p.put("userId", SystemHelper.LoginUserId);
        p.put("storeId", SystemHelper.LoginOrganId);
        p.put("startTimeStr",data.getDateBegin());
        p.put("endTimeStr", data.getDateEnd());
        new BaseAppServerTask("query", SXPBackListResponse.class,
                (BaseActivity) mContext, "正在获取数据列表...", true, "/datastatistics/getNewMemberCareDatas",
                p).execute("");
    }

    /**校验选择的日期是否合法*/
    private boolean checkDate(){
        if(TextUtils.isEmpty(data.getDateBegin()) || TextUtils.isEmpty(data.getDateEnd()) ){
            ((BaseActivity)mContext).showMsg("数据错误");
            return false;
        }

        //日期间隔时间
        int diffDate = DateUtil.diffDate(DateUtil.parseDate(data.getDateEnd()),DateUtil.parseDate(data.getDateBegin()));
        //间隔时间不能大于31天（说是间隔，其实是说可查询天数，如果间隔1天那其实是可查询2天，所以这里需求间隔31天，其实要小于等于30天）
        if(diffDate > 30){
            ((BaseActivity)mContext).showMsg("日期查询间隔不能超过31天");
            return false;
        }
        if(diffDate < 0){
            ((BaseActivity)mContext).showMsg("开始时间不能大于结束时间！");
            return false;
        }
        return true;
    }

    public void setDateBegin(String dateBegin){
        if(data == null){
            data = new SXPQueryData();
        }
        data.setDateBegin(dateBegin);
    }

    public void setDateEnd(String dateEnd){
        if(data == null){
            data = new SXPQueryData();
        }
        data.setDateEnd(dateEnd);
    }

    public SXPQueryData getData(){
        return data;
    }

    /**
     * 按日期进行排序
     */
    public void sortList(){
        Collections.sort(data.getSXPBackList(), new Comparator<SXPBackListEntity>() {
            @Override
            public int compare(SXPBackListEntity lhs, SXPBackListEntity rhs) {
                return lhs.getStatisticsDate().compareTo(rhs.getStatisticsDate());
            }
        });
    }

    /**刷新列表*/
    public void notifyAdapter(){
        mView.notifyAdapter();
    }
}
