package com.urovo.activity.sanxiangpaoData.presenter;

import android.content.Context;
import android.content.Intent;
import android.text.TextUtils;

import com.urovo.activity.sanxiangpaoData.model.SXPQueryData;
import com.urovo.activity.sanxiangpaoData.view.NewGuestRepurchaseRateAct;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.DateUtil;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Created by Sasuke on 2016/6/7.
 */
public class SXPDataQueryPresenter implements SanXiangPaoDataContract.Presenter{
    SanXiangPaoDataContract.View mView;
    SXPQueryData data;
    private SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");


    public SXPDataQueryPresenter(SanXiangPaoDataContract.View mView) {
        data = new SXPQueryData();
        this.mView = mView;
        this.mView.setPresenter(this);
    }

    @Override
    public void start() {
        //需求是起始日期为本月第一天，终结日期是当天
        Date dateBegin = new Date();
        dateBegin.setDate(1);
        Date dateEnd = new Date();

        data.setDateBegin(sdf.format(dateBegin));//存入默认的起始日期
        data.setDateEnd(sdf.format(dateEnd));//...
        mView.initUI();//把中文格式的日期传过去
    }

    public SXPQueryData getData(){
        return data;
    }

    /**
     * 查询
     */
    @Override
    public void search() {
        if(TextUtils.isEmpty(data.getDateBegin()) || TextUtils.isEmpty(data.getDateEnd()) ){
            ((BaseActivity)mView).showMsg("数据错误");
        }

        //日期间隔时间
        int diffDate = DateUtil.diffDate(DateUtil.parseDate(data.getDateEnd()),DateUtil.parseDate(data.getDateBegin()));
        //间隔时间不能大于31天（说是间隔，其实是说可查询天数，如果间隔1天那其实是可查询2天，所以这里需求间隔31天，其实要小于等于30天）
        if(diffDate > 30){
            ((BaseActivity)mView).showMsg("日期查询间隔不能超过31天");
            return ;
        }

        Intent intent = new Intent(((Context)mView), NewGuestRepurchaseRateAct.class);
        intent.putExtra("dateBegin",getData().getDateBegin());
        intent.putExtra("dateEnd",getData().getDateEnd());
        ((Context) mView).startActivity(intent);
    }

    /**
     * 设置起始日期
     * @param dateBegin
     */
    public void setDateBegin(Date dateBegin) {
        try {
            isDateCorrect(dateBegin,null);
            data.setDateBegin(sdf.format(dateBegin));
        } catch (Exception e) {
            ((BaseActivity)mView).showMsg("开始日期不能大于结束日期");
            e.printStackTrace();
        }
    }

    /**
     * 设置结束日期
     * @param dateEnd
     */
    public void setDateEnd(Date dateEnd) {
        try {
            isDateCorrect(null,dateEnd);
            data.setDateEnd(sdf.format(dateEnd));
        } catch (Exception e) {
            ((BaseActivity)mView).showMsg("开始日期不能大于结束日期");
            e.printStackTrace();
        }
    }

    /**
     * 判断开始日期是不是小于结束日期
     * @param begin
     * @param end
     * @throws Exception
     */
    public void isDateCorrect(Date begin,Date end) throws Exception{
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        if(begin == null){
            if(sdf.format(end).compareTo(data.getDateBegin()) < 0){
                Exception dateException = new Exception("Exception:SXPDataQueryPresenter --- endDate < beginDate");
                throw dateException;
            }
        }else if(end == null){
            if(data.getDateEnd().compareTo(sdf.format(begin)) < 0){
                Exception dateException = new Exception("Exception:SXPDataQueryPresenter --- endDate < beginDate");
                throw dateException;
            }
        }
    }
}
