package com.urovo.activity.sanxiangpaoData.presenter;

import android.content.Context;

import com.urovo.activity.sanxiangpaoData.model.SXPRnData;
import com.urovo.activity.sanxiangpaoData.web.SXPRnListResponse;
import com.urovo.wgmf.AsyncTask.BaseAppServerTask;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wgmf.entity.response.HuiYuanXiaoFeiXinXiResponse;
import com.urovo.wgmf.db.dao.entitys.HuiYuanXiaoFeiXinXiEntity;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Sasuke on 2016/6/10.
 */
public class SXPRnListPresenter implements SanXiangPaoDataContract.Presenter{
    SanXiangPaoDataContract.View mView;
    SXPRnData data;
    Context context;

    public SXPRnListPresenter(Context context, SanXiangPaoDataContract.View mView) {
        this.mView = mView;
        this.context = context;
        this.mView.setPresenter(this);
        data = new SXPRnData();
    }

    @Override
    public void start() {

    }

    /**
     * 请求一级列表数据
     */
    @Override
    public void search() {
        Map<String,String> p = new HashMap<>();
        p.put("storeId", SystemHelper.LoginOrganId);
        p.put("statisticsDate",data.getEndToDate());
        new BaseAppServerTask("listDetail", SXPRnListResponse.class,
                (BaseActivity) context, "正在获取数据列表...", true, "/datastatistics/getMemberBack",
                p).execute("");
    }

    /**
     * 请求二级列表数据
     * @param customerPhone 顾客手机号
     * @param endTimeStr 查询销售详情的截止日期
     */
    public void searchSalesDetials(String customerPhone,String endTimeStr,int groupPosition){
        Map<String,String> p = new HashMap<>();
        p.put("storeId", SystemHelper.LoginOrganId);
        p.put("userId",SystemHelper.LoginUserId);
        p.put("customerMobile",customerPhone);
        p.put("endTimeStr",endTimeStr);
        new BaseAppServerTask("saleDetail"+groupPosition, HuiYuanXiaoFeiXinXiResponse.class,
                (BaseActivity) context, "正在获取销售详情...", false, "/customer/getSaleDetailByCustomerId",
                p).execute("");
    }

    public void dealAndSaveList(List<HuiYuanXiaoFeiXinXiEntity.XiaoFeiXinXiEntity> list, int groupPosition){
        getData().setExListChilds(list,groupPosition);
        mView.initUI();
    }

    public SXPRnData getData(){
        if(data == null){
            data = new SXPRnData();
        }
        return data;
    }

}
