package com.urovo.activity.sanxiangpaoData.ui;

import android.content.Context;
import android.content.Intent;
import android.graphics.Paint;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.activity.sanxiangpaoData.presenter.SXPBackListPresenter;
import com.urovo.activity.sanxiangpaoData.view.SanXiangPaoRnListAct;
import com.urovo.activity.sanxiangpaoData.web.SXPBackListEntity;
import com.urovo.wugumofang.R;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * Created by Sasuke on 2016/6/8.
 */
public class SXPBackListAdapter extends BaseAdapter{
    List<SXPBackListEntity> list;
    Context context;
    SXPBackListPresenter mPresenter;
    public SXPBackListAdapter(Context context, List<SXPBackListEntity> list, SXPBackListPresenter mPresenter) {
        this.context = context;
        this.list = list;
        this.mPresenter = mPresenter;
    }

    @Override
    public int getCount() {
        return list.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }


    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        if(convertView == null){
            LayoutInflater inflater = LayoutInflater.from(context);
            convertView = inflater.inflate(R.layout.sxp_back_list_item,null);
            holder = new ViewHolder(convertView);

            /*holder.backNumText = (TextView) convertView.findViewById(R.id.have_back_text);
            holder.dateText = (TextView)convertView.findViewById(R.id.date_text);
            holder.NoBackNumText = (TextView)convertView.findViewById(R.id.not_back_text);
            holder.rn60Text = (TextView) convertView.findViewById(R.id.rn_text);*/
            convertView.setTag(holder);
        }else{
            holder = (ViewHolder) convertView.getTag();
        }

        holder.dateText.setText(list.get(position).getStatisticsDate());
        holder.backNumText.setText(list.get(position).getBackNum());
        holder.backNumText.getPaint().setFlags(Paint.UNDERLINE_TEXT_FLAG);
        holder.NoBackNumText.setText(list.get(position).getNoBackNum());
        holder.rn60Text.setText(list.get(position).getBackRate());

        holder.backNumText.setOnClickListener(v -> {
            Intent intent = new Intent(context, SanXiangPaoRnListAct.class);
            intent.putExtra("statisticsDate",list.get(position).getStatisticsDate());
            intent.putExtra("dateBegin",mPresenter.getData().getDateBegin());
            intent.putExtra("dateEnd",mPresenter.getData().getDateEnd());
            context.startActivity(intent);
        });

        return convertView;
    }

    class ViewHolder{
        public ViewHolder(View view) {
            ButterKnife.bind(this,view);
        }

        @BindView(R.id.have_back_text) TextView backNumText;//已回头人数
        @BindView(R.id.date_text) TextView dateText;//日期
        @BindView(R.id.not_back_text) TextView NoBackNumText;//未回头人数
        @BindView(R.id.rn_text) TextView rn60Text;//回头人数百分比
    }


}
