package com.urovo.activity.sanxiangpaoData.view;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.View;
import android.widget.ImageButton;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.activity.sanxiangpaoData.presenter.SXPBackListPresenter;
import com.urovo.activity.sanxiangpaoData.web.SXPBackListResponse;
import com.urovo.activity.slidemenu.NoDataFrag;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;

import androidx.appcompat.app.AlertDialog;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;

/**
 * 新客三响炮90天回头数据（显示列表）
 *
 * @author Sasuke
 * @date 2016/6/8
 */
@Route(path = RouterParams.Member.NEW_GUEST_REPURCHASE_RATE)
public class NewGuestRepurchaseRateAct extends BaseActivity implements StoreDateSelectorPop.StoreDateSelectorPopListener{
    @BindView(R.id.back)  ImageButton back;
    @BindView(R.id.text_title) TextView title;
    @BindView(R.id.begin_and_end_date) TextView beginAndEndDateText;
    @BindView(R.id.store_name) TextView storeName;
    SXPBackListPresenter mPresenter;
    SanXiangPaoBackListFra listFra;//用来显示数据列表的Fragment
    protected StoreDateSelectorPop mStoreDateSelectorPop;
    Unbinder unbinder;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_sanxiangpao_back_list);
        unbinder = ButterKnife.bind(this);

        listFra = new SanXiangPaoBackListFra();
        mPresenter = new SXPBackListPresenter(this,listFra);//传一个上下文进去，好让Presenter回调displayResult()
        mPresenter.start();

        initUI();

        query();
    }

    @SuppressLint("SetTextI18n")
    public void initUI() {
        super.initTitle();
        title.setText("新客90天复购率");
        beginAndEndDateText.setText(mPresenter.getData().getDateBegin()+"至"+mPresenter.getData().getDateEnd());
        storeName.setText(SystemHelper.LoginOrganName);
        getSupportFragmentManager().beginTransaction().
                replace(R.id.back_list_fra_container,new NoDataFrag()).commit();//先显示“暂无数据”
    }


    private void showPopWindowDateStore() {
        if (null == mStoreDateSelectorPop) {
            mStoreDateSelectorPop = new StoreDateSelectorPop(this, this, false, StoreDateSelectorPop.STORE_DATE_SANXIANGPAO_DATA);
            mStoreDateSelectorPop.setMixBegin(mPresenter.getData().getDateBegin());
            mStoreDateSelectorPop.setMixEnd(mPresenter.getData().getDateEnd());
            mStoreDateSelectorPop.setDefaultInfo();
        }
        if (!mStoreDateSelectorPop.isShowing()) {
            mStoreDateSelectorPop.show(super.titile_bg);
        }
    }

    @Override
    public void onChooseStore() {

    }

    @Override
    public void onChooseDate(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {

    }

    @Override
    public void onStartSearch(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {
        mPresenter.setDateBegin(dateFrom);
        mPresenter.setDateEnd(dateTo);
        mPresenter.search();
        mStoreDateSelectorPop.dismiss();
    }

    @Override
    public void onDismiss() {

    }

    @OnClick({R.id.back,R.id.date_select,R.id.rn_title})
    public void onClick(View v){
        int id = v.getId();
        switch(id){
            case R.id.date_select :
                showPopWindowDateStore();
                break;
            case R.id.rn_title:
                new AlertDialog.Builder(this).setMessage("Rn90：指90天内新客回头率；\n" +
                        "计算方式：已回头人数/(已回头人数+未回头人数)*100%")
                        .setPositiveButton("确定",null)
                        .create()
                        .show();
                break;
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }

    /**
     * 一进来就开始查询
     */
    public void query(){
        mPresenter.search();
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if(response == null){
            showMsg("网络连接超时，请检查您的网络状态，稍后重试！");
            return;
        }
        if ("query".equals(tag)) {
            //请求成功了才改日期
            beginAndEndDateText.setText(mPresenter.getData().getDateBegin()+"至"+mPresenter.getData().getDateEnd());
            SXPBackListResponse res = (SXPBackListResponse) response;
            if (null != res.getList() && res.getList().size() > 0) {
                mPresenter.getData().setSXPBackList(res.getList());
                mPresenter.sortList();//列表按日期排序
                if(listFra.isVisible()){
                    mPresenter.notifyAdapter();
                }else{
                    getSupportFragmentManager().beginTransaction().replace(R.id.back_list_fra_container,listFra).commit();
                }
            }else{//显示暂无数据
                getSupportFragmentManager().beginTransaction().replace(R.id.back_list_fra_container,new NoDataFrag()).commit();
            }
        }
    }
}
