package com.urovo.activity.sanxiangpaoData.view;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ExpandableListView;
import android.widget.LinearLayout;

import com.urovo.activity.sanxiangpaoData.presenter.SXPRnListPresenter;
import com.urovo.activity.sanxiangpaoData.presenter.SanXiangPaoDataContract;
import com.urovo.activity.sanxiangpaoData.ui.SXPRnExpanListAdapter;
import com.urovo.wugumofang.R;

import androidx.fragment.app.Fragment;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * @author Sasuke
 * @date 2016/6/10
 */
public class SanXiangPaoRnListFra extends Fragment implements SanXiangPaoDataContract.View {
    SXPRnListPresenter mPresenter;
    SXPRnExpanListAdapter adapter;
    @BindView(R.id.list_ex_rn)
    ExpandableListView exList;
    Unbinder unbinder;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container = (LinearLayout) inflater.inflate(R.layout.fra_sanxiangpao_rn, container, false);
        unbinder = ButterKnife.bind(this, container);
        initUI();
        return container;
    }

    @Override
    public void notifyAdapter() {
        adapter.notifyDataSetChanged();
    }

    @Override
    public void initUI() {
        if (mPresenter != null && mPresenter.getData() != null) {
            //列表默认箭头是左边的，不要左边箭头，换成自定义的右边！
            exList.setGroupIndicator(null);
            if (adapter == null) {
                adapter = new SXPRnExpanListAdapter(getActivity(), mPresenter.getData().getExList());
                exList.setAdapter(adapter);
            } else {
                adapter.notifyDataSetChanged();
            }
            exList.setOnGroupExpandListener(new ExpandableListView.OnGroupExpandListener() {
                @Override
                public void onGroupExpand(int groupPosition) {
                    //只有在数据源集合没有数据的时候才做网络请求
                    if (mPresenter.getData().getExList().get(groupPosition).list == null
                            || mPresenter.getData().getExList().get(groupPosition).list.size() == 0) {
                        mPresenter.searchSalesDetials(mPresenter.getData().getExList().get(groupPosition).entity.getCustomerMobile(),
                                mPresenter.getData().getEndToDate(), groupPosition);
                    }
                }
            });
        }
    }

    @Override
    public void setPresenter(Object presenter) {
        this.mPresenter = (SXPRnListPresenter) presenter;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        if (unbinder != null) {
            unbinder.unbind();
        }
    }
}
