package com.urovo.activity.sell;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wgmf.db.dao.dao.Item001DbOperate;
import com.urovo.wgmf.db.dao.entitys.HuoDongEntity;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.ZuHePin;
import com.urovo.wgmf.db.dao.entitys.ZuHePin.Code;
import com.urovo.wugumofang.R;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * 选择组合品(选择赠品组合)
 */
public class SelectZuHe extends BaseActivity {
  private ListView lv_zuhe;
  private Button btn_save_zuhe;
  private List<ProductEntity> list;

  @Override protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.select_zuhe);
    TextView tv = findViewById(R.id.text_title);
    tv.setText("选择组合品");
    ImageButton goback = findViewById(R.id.goback);
    goback.setOnClickListener(new OnClickListener() {
      @Override public void onClick(View v) {
        finish();
      }
    });

    lv_zuhe = findViewById(R.id.lv_zuhe);
    btn_save_zuhe = findViewById(R.id.btn_save_zuhe);
    Intent intent = getIntent();
    final HuoDongEntity huoDongEntity = (HuoDongEntity) intent.getSerializableExtra("huodong");
    String storeId = intent.getStringExtra("storeId");
    List<ZuHePin> zuheList = huoDongEntity.getGiftprojson().prozuhe;
    List<ProductEntity> all = Item001DbOperate.GetCanXiaoShouProducts(storeId);
    for (ZuHePin zuhe : zuheList) {
      List<Code> codeList = zuhe.getPro_code();
      for (Code c : codeList) {
        String str = c.getCode();
        ProductEntity pe = Item001DbOperate.GetProductByBarcode(str);
        if (pe != null && all.contains(pe)) {
          pe.setPrice(0);
          pe.setTQTY(0);
          pe.setAmount(0);
          if (list == null) {
            list = new ArrayList<>();
          }
          list.add(pe);
        }
      }
    }

    if (list != null) {
      lv_zuhe.setAdapter(new ZuHeAdapter(list, this));
    }

    btn_save_zuhe.setOnClickListener(new OnClickListener() {
      @Override public void onClick(View v) {
        boolean manzu = false;
        for (ZuHePin zuhe : huoDongEntity.getGiftprojson().prozuhe) {
          if (zuhe.getPro_code() != null && zuhe.getPro_code().size() > 0) {
            int num = zuhe.pro_num;
            int songNum = 0;
            List<Code> codeList = zuhe.getPro_code();
            for (Code cd : codeList) {
              ProductEntity p = new ProductEntity();
              p.setItemId(cd.getCode());
              int index = list.indexOf(p);
              if (index != -1) {
                songNum += list.get(index).getTQTY();
              }
            }
            if (songNum == num) {
              // 满足组合品条件
              manzu = true;
            } else {
              break;
            }
          }
        }

        if (manzu) {
          // AlertDialog.Builder builder = new
          // Builder(SelectZuHe.this);
          //
          // builder.setTitle("保存提示");
          // builder.setMessage("您确定选择该组合品吗？");
          // builder.setPositiveButton("确定", new
          // android.content.DialogInterface.OnClickListener() {
          // @Override
          // public void onClick(DialogInterface dialog, int which) {
          Iterator<ProductEntity> it = list.iterator();
          while (it.hasNext()) {
            ProductEntity pe = (ProductEntity) it.next();
            if (pe.getTQTY() == 0) {
              it.remove();
            }
          }
          Intent data = new Intent();
          data.putExtra("zuhe", (Serializable) list);
          setResult(88, data);
          finish();
          // }
          // }).setNegativeButton("取消", null).create().show();

        } else {
          showMsg("对不起，您所选择的赠品不符合组合规则");
        }
      }
    });
  }

  public class ZuHeAdapter extends MyBaseAdapter<ProductEntity, ListView> {
    public ZuHeAdapter(List<ProductEntity> lists, Context context) {
      super(lists, context);
      this.lists = lists;
    }

    @Override public View getView(final int position, View convertView, ViewGroup parent) {
      View view = View.inflate(context, R.layout.listview_item_zuhe, null);
      TextView tv_proname = view.findViewById(R.id.tv_proname);
      final ImageButton ib_jian = view.findViewById(R.id.ib_jian);
      final EditText et_count = view.findViewById(R.id.et_count);
      final ImageButton ib_jia = view.findViewById(R.id.ib_jia);

      tv_proname.setText(lists.get(position).getItemName());

      et_count.setText((int) lists.get(position).getTQTY() + "");
      et_count.setSelectAllOnFocus(true);
      if (lists.get(position).getTQTY() == lists.get(position).minCount) {
        ib_jian.setEnabled(false);
      }
      et_count.addTextChangedListener(new TextWatcher() {
        @Override public void beforeTextChanged(CharSequence s, int start, int count, int after) {
        }

        @Override public void onTextChanged(CharSequence s, int start, int before, int count) {
        }

        @Override public void afterTextChanged(Editable s) {
          String str = et_count.getText().toString();
          int count = 0;
          int minCount = lists.get(position).minCount;
          if (!TextUtils.isEmpty(str)) {
            count = Integer.parseInt(str);
            // if(count==0){
            // if(str.length()>1){
            // et_count.setText(count+"");
            // }
            // ib_jian.setEnabled(false);
            // ib_jia.setEnabled(true);
            // }else
            if (count == minCount) {
              ib_jian.setEnabled(false);
              ib_jia.setEnabled(true);
            } else if (count < minCount) {
              count = minCount;
              et_count.setText(count + "");
              ib_jian.setEnabled(false);
              ib_jia.setEnabled(true);
            } else if (count > 1000) {
              count = 1000;
              et_count.setText(count + "");
              ib_jian.setEnabled(true);
              ib_jia.setEnabled(false);
            } else if (count == 1000) {
              ib_jian.setEnabled(true);
              ib_jia.setEnabled(false);
            } else {
              ib_jian.setEnabled(true);
              ib_jia.setEnabled(true);
            }
          } else if (TextUtils.isEmpty(str)) {
            count = minCount;
            et_count.setText(minCount + "");
          }

          ProductEntity p = lists.get(position);
          p.setTQTY(count);
          lists.set(position, p);
        }
      });
      ib_jian.setOnClickListener(new OnClickListener() {
        @Override public void onClick(View v) {
          int i = Integer.parseInt(et_count.getText().toString());
          i--;
          et_count.setText(i + "");
        }
      });
      ib_jia.setOnClickListener(new OnClickListener() {
        @Override public void onClick(View v) {
          int i = Integer.parseInt(et_count.getText().toString());
          i++;
          et_count.setText(i + "");
        }
      });
      return view;
    }
  }
}
