package com.urovo.activity.shisanreportact.model

import com.google.gson.annotations.Expose
import com.urovo.wugumofang.response.Base3Response

/**
 * Created by Sasuke on 2019-08-15
 */
data class ShisanReportEntity(var resultInfo: ResultInfo): Base3Response() {
    data class ResultInfo(var type: List<Type>,//类别列表
                          var wrapper: List<Wrapper>) {//产品列表
        data class Type(var itemTypeName: String,//类别名称
                        var itemType: Int)//产品类别

        data class Wrapper(var itemTypeName: String,//类别名称
                           var itemType: Int,//产品类别
                           var details: List<Details>) {//产品明细

            class Details{
                @Expose
                var proCode: String = ""//产品编码
                @Expose
                var proQty: Int = 0//产品数量

                //以下字段不用传
                var proName: String = ""//产品名称
                var picUrl: String = ""//图片地址

                var itemTypeNameCache: String = ""//本地自建缓存字段，提交的时候不需要传这个
                var itemTypeId: Int = -1//本地自建缓存字段，提交的时候不需要传这个
            }

        }
    }
}