package com.urovo.activity.shisanreportact.view

import android.app.AlertDialog
import android.os.Bundle
import com.urovo.activity.shisanreportact.model.ShisanReportEntity
import com.urovo.activity.shisanreportact.presenter.ShisanReportContract
import com.urovo.activity.shisanreportact.presenter.ShisanReportPresenter
import com.urovo.activity.shisanreportact.view.adapter.ShisanReportAdapter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.TabRvSyncDominator
import com.urovo.wugumofang.view.LoadWaitDominator
import kotlinx.android.synthetic.main.shisan_report_act.*

/**
 * @author Sasuke on 2019-8-9 0009.
 * 门店柜型上报
 */
class ShisanReportAct : BaseActivity(), ShisanReportContract.view {
    private var pre: ShisanReportPresenter? = null

    private var loadWait: LoadWaitDominator? = null
    //tab状态变化锁，为true时，相当于锁住tab，避免列表滑动过程中引起中途tab状态变更。
    //这个锁的上锁时期为：按下tab时---到----》列表停止滑动，这段时间之内。
    //点击tab即上锁，列表停滑即解锁。
//    var tabStateLock = false

    private var tabRvDominator :TabRvSyncDominator? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.shisan_report_act)
        initTitle()
        setListeners()
        ShisanReportPresenter(this).start()

        //请求数据
        pre?.queryListData(SystemHelper.LoginOrganId)
    }

    override fun init() {
        tabRvDominator = TabRvSyncDominator(this,tabLayout,dataRv)
        loadWait = LoadWaitDominator(this, containerLayout)
        titleTextView.text = "门店柜型上报"
        storeName.text = SystemHelper.LoginOrganName
//        dataRv.layoutManager = LinearLayoutManagerWithSmoothScroller(this)
//        dataRv.addOnScrollListener(object : RecyclerView.OnScrollListener() {
//            var lastPos = -1
//            override fun onScrolled(rv: RecyclerView, dx: Int, dy: Int) {
//                //滑动Rv联动Tab
//                val currHeadPos = (rv.layoutManager as LinearLayoutManager).findFirstCompletelyVisibleItemPosition()
//                if (currHeadPos != lastPos && !tabStateLock) {//正在滑动 && 没有上锁，才会执行更改tab状态操作
//                    //根据列表当前第一个元素的typeId来找对应的Label序号，再select
//                    pre?.getTabPosByRvHead(currHeadPos)?.takeIf { it != -1 }?.let { tabLayout.getTabAt(it)?.select() }
//                }
//                lastPos = currHeadPos
//            }
//            override fun onScrollStateChanged(recyclerView: RecyclerView, newState: Int) {
//                super.onScrollStateChanged(recyclerView, newState)
//                if (newState == 0) tabStateLock = false//如果停止了滑动，那就把锁解开
//            }
//        })

    }

    fun setListeners() {
        //提交点击监听
        submitBtn.setOnClickListener {
            AlertDialog.Builder(this).setTitle("提示")
                    .setMessage("确定提交吗？")
                    .setNegativeButton("取消",null)
                    .setPositiveButton("确定"){ dialog, which ->
                        pre?.submit(SystemHelper.LoginOrganId)
                    }.show()
        }

//        //标签栏挂监听
//        tabLayout.addOnTabSelectedListener(object : TabLayout.OnTabSelectedListener {
//            override fun onTabReselected(tab: TabLayout.Tab?) {
//
//            }
//
//            override fun onTabUnselected(tab: TabLayout.Tab?) {
//                tab?.customView?.findViewById<TextView>(R.id.tabTv)?.setTextColor(Color.parseColor("#4f4f4f"))
//            }
//
//            override fun onTabSelected(tab: TabLayout.Tab?) {
//                tab?.customView?.findViewById<TextView>(R.id.tabTv)?.setTextColor(Color.parseColor("#ff9800"))
//            }
//        })
        //Rv滑动监听
    }


    override fun refreshRv(labelStrings: List<ShisanReportEntity.ResultInfo.Type>, dataList: List<ShisanReportEntity.ResultInfo.Wrapper.Details>) {
        if (isFinishing) return
        tabRvDominator?.setTabInfoNotify(labelStrings.map { TabRvSyncDominator.TabInfo(it.itemTypeName,it.itemType.toString()) },dataList.map { it.itemTypeId.toString() })
        //初始化标签
//        initTabLayout(labelStrings)
        //初始化数据表
        dataRv.adapter = ShisanReportAdapter(this, dataList)
    }

    /**初始化标签栏*/
    fun initTabLayout(titleList: List<ShisanReportEntity.ResultInfo.Type>) {

//        tabLayout.removeAllTabs()
//        //如果标签数量小于等于4个，那就填充，否则滚动
//        tabLayout.tabMode = if (titleList.size <= 4) TabLayout.MODE_FIXED else TabLayout.MODE_SCROLLABLE
//        //逐个添加tab们
//        titleList.forEach { tabInfo ->
//            tabLayout.addTab(tabLayout.newTab().apply {
//                setCustomView(R.layout.tab_rv_sync_item_layout)
//                customView?.findViewById<TextView>(R.id.tabTv)?.run{ text = tabInfo.itemTypeName ;tag = tabInfo.itemType }
//                //点击穿透，点击tab联动Rv
//                customView?.setOnTouchListener { view, motionEvent ->
//                    var oldPos = -1
//                    if (motionEvent.action == MotionEvent.ACTION_DOWN) {
//                        val posForScroll = pre?.resultCache?.indexOfFirst {
//                            view.findViewById<TextView>(R.id.tabTv)?.tag == it.itemTypeId
//                        } ?: 0
//                        //如果点击的tab不一样了，那就把锁锁上
//                        if (oldPos != posForScroll ){ dataRv.smoothScrollToPosition(posForScroll); tabStateLock = true}
////                        (dataRv.layoutManager as LinearLayoutManager).scrollToPositionWithOffset(posForScroll,0)
//                        oldPos = posForScroll
//                    }
//                    false
//                }
//            })
//        }

    }

    override fun setPresenter(presenter: ShisanReportContract.pre?) {
        this.pre = presenter as ShisanReportPresenter
    }

    override fun showLoadWait(state: Int) {
        if (!isFinishing) loadWait?.show(state)
    }

    override fun dismissLoadWait() {
        if (!isFinishing) loadWait?.dismissAll()
    }

}