package com.urovo.activity.slidemenu;

import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ExpandableListView;
import android.widget.ImageButton;
import android.widget.TextView;

import com.urovo.activity.slidemenu.adapter.GouMaiJiLuAdapter;
import com.urovo.wgmf.AsyncTask.DownloadXiaoShouMingXiTask;
import com.urovo.wgmf.db.dao.entitys.SaleProductList;
import com.urovo.wgmf.db.dao.entitys.SaleProductsEntity;
import com.urovo.wgmf.db.dao.entitys.SalesDetialsEntity;
import com.urovo.wgmf.db.dao.entitys.SalesDetialsEntity.ProductsreturnList;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import okhttp3.Request;

import static com.urovo.activity.salesdetailnet.model.SalesDetailModel.TYPE_STORE_SALE;

public class GouMaiJiLuActivity extends BaseActivity implements GouMaiJiLuAdapter.OnItemViewListener {
    private String mPhone;
    private List<ProductsreturnList> parentslist = new ArrayList<ProductsreturnList>();
    private List<SaleProductList> childrenlist = new ArrayList<>();
    private ExpandableListView mExListView;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.goumaijilu);

        titleTextView = (TextView) findViewById(R.id.text_title);
        titleTextView.setText("购买历史");
        mExListView = (ExpandableListView) findViewById(R.id.expandableListViewContent);
        ImageButton goback = (ImageButton) findViewById(R.id.goback);
        goback.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        mPhone = getIntent().getStringExtra("phone");
        request();
    }

    private void request() {
        if (TextUtils.isEmpty(mPhone)) return;
        Map<String, String> p = new HashMap<String, String>();
        p.put("userId", SystemHelper.LoginUserId);
        p.put("customerMobile", mPhone);
        p.put("type", "1");
        new DownloadXiaoShouMingXiTask(this, "正在查询购买记录...", true, p).execute("");
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if (!((BaseOldResponse) response).msgCode.equals("0")) {
            showMsg(response.msgContent);
            return;
        } else if (null != response) {
            SalesDetialsEntity res = (SalesDetialsEntity) response;
            List<ProductsreturnList> list = res.returnBean.returnList;
            parentslist.clear();
            int listSize = list.size();
            for (int i = listSize - 1; i >= 0; i--) {
                parentslist.add(list.get(i));
            }
            if (!parentslist.isEmpty()) {
                mExListView.setAdapter(new GouMaiJiLuAdapter(TYPE_STORE_SALE, this, parentslist, childrenlist, this, false, false));
                mExListView.expandGroup(0);
                mExListView.setSelectedGroup(0);
                mExListView.setGroupIndicator(null);
                queryDetail(0, parentslist.get(0).consId);
            }
        }
    }

    @Override
    public void onViewListener(int groupPosition, String consId) {
        //查询销售明细
        queryDetail(groupPosition, consId);
    }

    /**
     * 查询销售明细
     */
    private void queryDetail(int groupPosition, String consId) {
        ViewUtil.showProgress(this, "请稍等", "正在查询销售明细...");
        Map<String, String> params = new HashMap<>();
        params.put("consId", consId);
        OkHttpDominator.postAsyn(NetParam.SALEDETAILCONSID, params,
                new OkHttpDominator.ResultCallback<SaleProductsEntity>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        if (isFinishing()) return;
                        ViewUtil.dismissProgress();
                    }

                    @Override
                    public void onResponse(SaleProductsEntity res) {
                        if (isFinishing()) return;
                        ViewUtil.dismissProgress();
                        if (res == null) {
                            return;
                        }
                        childrenlist = res.getResultInfo();
                        mExListView.setAdapter(new GouMaiJiLuAdapter(TYPE_STORE_SALE, GouMaiJiLuActivity.this, parentslist, childrenlist, GouMaiJiLuActivity.this, false, false));
                        mExListView.expandGroup(groupPosition);
                        mExListView.setSelectedGroup(groupPosition);
                        mExListView.setGroupIndicator(null);
                    }
                });
    }
}
