package com.urovo.activity.slidemenu;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.text.Editable;
import android.text.InputType;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.SpannedString;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.text.style.AbsoluteSizeSpan;
import android.text.style.ForegroundColorSpan;
import android.text.style.StyleSpan;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.entity.response.VipResponse;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.data.PrefTool;
import com.urovo.wugumofang.system.Prefs;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.List;

/**
 * 积分兑换
 *
 * @author ...
 */
@Route(path = RouterParams.Member.INTEGRAL_CONVERTIBLE)
public class JifenYanZhengActivity extends BaseActivity {

    private ImageButton goback;
    private ListView lv_history;
    private EditText et_yanzheng;
    private Button btn_yanzheng;
    private VipResponse vipResponse;
    private String[] newArrays;
    private ArrayAdapter<String> arr_adapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.jifen_duihuan);

        titleTextView = (TextView) findViewById(R.id.text_title);
        goback = (ImageButton) findViewById(R.id.goback);
        lv_history = (ListView) findViewById(R.id.lv_yanzheng);
        et_yanzheng = (EditText) findViewById(R.id.et_yanzheng);
        btn_yanzheng = (Button) findViewById(R.id.btn_yanzheng);

        titleTextView.setText("积分兑换");
        goback.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                finish();
            }
        });

        et_yanzheng.setInputType(InputType.TYPE_CLASS_NUMBER);

        // 新建一个可以添加属性的文本对象
        SpannableString ss = new SpannableString("手机号码");

        // 新建一个属性对象,设置文字的大小
        AbsoluteSizeSpan ass = new AbsoluteSizeSpan(14, true);
        ForegroundColorSpan f = new ForegroundColorSpan(Color.rgb(189, 189, 189));
        StyleSpan s = new StyleSpan(android.graphics.Typeface.NORMAL);
        // 附加属性到文本
        ss.setSpan(ass, 0, ss.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
        ss.setSpan(f, 0, ss.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
        ss.setSpan(s, 0, ss.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
        // 设置hint
        et_yanzheng.setHint(new SpannedString(ss)); // 一定要进行转换,否则属性会消失

        String history = PrefTool.getStringPerferences(this, Prefs.SEARCH_JIFEN_HISTORY, "");
        if (history != "") {
            // 用逗号分割内容返回数组
            String[] history_arr = history.split(",");
            newArrays = new String[20];
            // 保留前20条数据
            if (history_arr.length > 20) {
                // 实现数组之间的复制
                System.arraycopy(history_arr, 0, newArrays, 0, 20);
            } else {
                newArrays = history_arr;
            }
        } else {
            newArrays = new String[0];
        }
        updateListView();
        et_yanzheng.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (newArrays != null) {
                    String str = et_yanzheng.getText().toString().trim();
                    List<String> alist = new ArrayList<String>();
                    String[] ne2 = new String[20];
                    ne2 = newArrays;
                    for (int i = 0; i < newArrays.length; i++) {
                        if (newArrays[i].startsWith(str)) {
                            alist.add(newArrays[i]);
                        }
                    }
                    String results[] = new String[alist.size()];
                    newArrays = (String[]) alist.toArray(results);
                    updateListView();
                    newArrays = ne2;
                }
            }
        });

        btn_yanzheng.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                String huiyuan = et_yanzheng.getText().toString().trim();
                if (TextUtils.isEmpty(huiyuan)) {
                    showMsg("请输入会员手机号码");
                } else {

                    if (huiyuan.length() < 6 || huiyuan.length() > 13) {
                        showMsg("请输入有效手机号！");
                        return;
                    }
                    if (!TextUtils.isDigitsOnly(huiyuan)) {
                        showMsg("请输入纯数字的手机号！");
                        return;
                    }
                    if (huiyuan.startsWith("1") && huiyuan.length() != 11) {
                        showMsg("请输入11位的手机号！");
                        return;
                    }
                    if (huiyuan.length() == 13 && !huiyuan.startsWith("00852") && !huiyuan.startsWith("00853")) {
                        showMsg("只能输入13位的香港或澳门的号码！");
                        return;
                    }
                    if (huiyuan.startsWith("00852") && huiyuan.length() != 13) {
                        showMsg("请输入13位的香港号码！");
                        return;
                    }
                    if (huiyuan.startsWith("00853") && huiyuan.length() != 13) {
                        showMsg("请输入13位的澳门号码！");
                        return;
                    }
                    if (huiyuan.startsWith("400")) {
                        showMsg("请输入有效的手机号！");
                        return;
                    }

                    et_yanzheng.clearFocus();
                    InputMethodManager imm = (InputMethodManager) JifenYanZhengActivity.this.getSystemService(Context.INPUT_METHOD_SERVICE);
                    imm.hideSoftInputFromWindow(et_yanzheng.getWindowToken(), 0);

                    if (!TextUtils.isEmpty(huiyuan)) {
                        String old_text = PrefTool.getStringPerferences(JifenYanZhengActivity.this, Prefs.SEARCH_JIFEN_HISTORY, "");

                        String[] history_arr = old_text.split(",");
                        StringBuilder builder = new StringBuilder();
                        builder.append(huiyuan + ",");
                        for (int i = 0; i < 19 && i < history_arr.length; i++) {
                            if (!huiyuan.equals(history_arr[i])) {
                                builder.append(history_arr[i] + ",");
                            }
                        }
                        PrefTool.setStringsave(JifenYanZhengActivity.this, Prefs.SEARCH_JIFEN_HISTORY, builder.toString());
                    }

                    Intent intent = new Intent(JifenYanZhengActivity.this, JifenMingXiActivity.class);
                    intent.putExtra("huiyuan", huiyuan);
                    startActivity(intent);
                    finish();
                }
            }
        });
    }

    private void updateListView() {
        arr_adapter = new ArrayAdapter<String>(this, R.layout.simple_dropdown_item_1line, newArrays);
        // 设置适配器
        lv_history.setAdapter(arr_adapter);

        lv_history.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                TextView tv = (TextView) view.findViewById(R.id.text1);
                String number = tv.getText().toString();
                et_yanzheng.setText(number);
            }
        });
    }
}
