package com.urovo.activity.slidemenu.adapter

import android.content.Context
import android.view.View
import android.widget.TextView
import androidx.core.content.ContextCompat
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.urovo.activity.personalcenter.model.CardCustomerInfo
import com.urovo.activity.slidemenu.model.FreeDeliveryQueryBean
import com.urovo.wugumofang.R
import com.urovo.wugumofang.data.StringUtils

/**
 * 权益卡数据适配器
 * @author LW
 */
class FreeDeliveryQueryAdapter(
    private var context: Context,
    data: MutableList<FreeDeliveryQueryBean>
) : BaseQuickAdapter<FreeDeliveryQueryBean, BaseViewHolder>(
    R.layout.item_free_delivery_query_list,
    data
) {

    override fun convert(helper: BaseViewHolder?, freeDeliveryQueryBean: FreeDeliveryQueryBean?) {
        helper?.let {
            it.getView<TextView>(R.id.tv_item_giveaway).visibility =
                if (freeDeliveryQueryBean?.isGift == 0) View.VISIBLE else View.GONE

            it.setText(R.id.tv_item_product_name, freeDeliveryQueryBean?.proName)
            it.setText(R.id.tv_item_product_count, "x" + (freeDeliveryQueryBean?.exchangeNum ?: 0))
            it.setText(
                R.id.tv_item_product_price,
                StringUtils.formatDouble(freeDeliveryQueryBean?.actualPay ?: 0.0, "0.00")
            )
            it.setText(
                R.id.tv_item_product_order,
                StringUtils.formatString(
                    context.getString(R.string.free_delivery_active_order),
                    freeDeliveryQueryBean?.activityId
                )
            )
            it.setText(
                R.id.tv_item_total_price,
                StringUtils.formatDouble(freeDeliveryQueryBean?.totalAmount ?: 0.0, "0.00")
            )
        }
    }
}