package com.urovo.activity.slidemenu.model;

import java.io.Serializable;
import java.util.List;

/**
 * 会员商城订单列表(物流查询)实体类
 *
 * @author chenji
 * @date 2017/12/20
 */

public class OrderEntity implements Serializable {
    /**
     * status : 0
     * msg : 操作成功
     * data : [{"receiverNameSnapshot":"测试","submitDate":1510036252000,"orderCode":"201711071426422997440","appProductResult":[{"productTemplateName":"红豆薏米杏仁粉套装560g","quantity":2},{"productTemplateName":"十一周年礼盒","quantity":1},{"productTemplateName":"植物益生元八珍粉512g","quantity":1}],"appDeliveryResult":[{"deliveryPartyName":"圆通快递","shipmentCode":"44444444444444"}]},{"receiverNameSnapshot":"测试","submitDate":1510037078000,"orderCode":"201711071440285751148","appProductResult":[{"productTemplateName":"益元八珍粉1020g罐装","quantity":2},{"productTemplateName":"十一周年礼盒","quantity":1},{"productTemplateName":"多谷核桃粉原味罐装600g","quantity":1}],"appDeliveryResult":[]},{"receiverNameSnapshot":"测试","submitDate":1510103252000,"orderCode":"201711071516491327805","appProductResult":[{"productTemplateName":"【定金】奇亚籽谷物燕麦片280g四盒装","quantity":1}],"appDeliveryResult":[]},{"receiverNameSnapshot":"测试","submitDate":1511328249000,"orderCode":"201711221323590655702","appProductResult":[{"productTemplateName":"中宁枸杞初心蜜[250g*2/盒]","quantity":1},{"productTemplateName":"红豆薏米粉600g（专柜同款）","quantity":1},{"productTemplateName":"测试赠品","quantity":1},{"productTemplateName":"谷物面膜（体验套装）","quantity":1}],"appDeliveryResult":[]},{"receiverNameSnapshot":"测试","submitDate":1511328312000,"orderCode":"201711221325051043848","appProductResult":[{"productTemplateName":"谷物面膜（体验套装）","quantity":1},{"productTemplateName":"测试赠品","quantity":2},{"productTemplateName":"初心蜜·青海成熟枸杞花蜂蜜丨480g（12g X 40条）","quantity":1}],"appDeliveryResult":[]},{"receiverNameSnapshot":"测试","submitDate":1512550328000,"orderCode":"201712061652004188371","appProductResult":[{"productTemplateName":"【天然真蜜】初心蜜丨250g*2或250g*6","quantity":1}],"appDeliveryResult":[]},{"receiverNameSnapshot":"测试","submitDate":1512550842000,"orderCode":"201712061700351277020","appProductResult":[{"productTemplateName":"红枣干40g","quantity":2},{"productTemplateName":"枸杞鲜果789","quantity":2}],"appDeliveryResult":[]},{"receiverNameSnapshot":"测试","submitDate":1512551250000,"orderCode":"201712061707221578677","appProductResult":[{"productTemplateName":"枸杞鲜果789","quantity":2},{"productTemplateName":"红枣干40g","quantity":1}],"appDeliveryResult":[{"deliveryPartyName":"圆通快递","shipmentCode":"44444444444444"}]}]
     */

    private int status;
    private String msg;
    private List<DataBean> data;

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public List<DataBean> getData() {
        return data;
    }

    public void setData(List<DataBean> data) {
        this.data = data;
    }

    public static class DataBean {
        /**
         * receiverNameSnapshot : 测试
         * submitDate : 1510036252000 购买时间
         * orderCode : 201711071426422997440 订单编号
         * orderStatus: 交易关闭
         * "staffId": "73105268",订单归属(员工号)
         * appProductResult : [{"productTemplateName":"红豆薏米杏仁粉套装560g","quantity":2},{"productTemplateName":"十一周年礼盒","quantity":1},{"productTemplateName":"植物益生元八珍粉512g","quantity":1}]
         * appDeliveryResult : [{"deliveryPartyName":"圆通快递","shipmentCode":"44444444444444"}]
         */

        private String receiverNameSnapshot;
        private String submitDate;
        private String orderCode;
        private String staffId;
        private String orderStatus;
        private List<AppProductResultBean> appProductResult;
        private List<AppDeliveryResultBean> appDeliveryResult;

        public String getReceiverNameSnapshot() {
            return receiverNameSnapshot;
        }

        public void setReceiverNameSnapshot(String receiverNameSnapshot) {
            this.receiverNameSnapshot = receiverNameSnapshot;
        }

        public String getSubmitDate() {
            return submitDate;
        }

        public void setSubmitDate(String submitDate) {
            this.submitDate = submitDate;
        }

        public String getOrderCode() {
            return orderCode;
        }

        public void setOrderCode(String orderCode) {
            this.orderCode = orderCode;
        }

        public String getStaffId() {
            return staffId;
        }

        public void setStaffId(String staffId) {
            this.staffId = staffId;
        }

        public String getOrderStatus() {
            return orderStatus;
        }

        public void setOrderStatus(String orderStatus) {
            this.orderStatus = orderStatus;
        }

        public List<AppProductResultBean> getAppProductResult() {
            return appProductResult;
        }

        public void setAppProductResult(List<AppProductResultBean> appProductResult) {
            this.appProductResult = appProductResult;
        }

        public List<AppDeliveryResultBean> getAppDeliveryResult() {
            return appDeliveryResult;
        }

        public void setAppDeliveryResult(List<AppDeliveryResultBean> appDeliveryResult) {
            this.appDeliveryResult = appDeliveryResult;
        }

        public static class AppProductResultBean {
            /**
             * productTemplateName : 红豆薏米杏仁粉套装560g 产品名称
             * quantity : 2 产品数量
             */
            private String productTemplateName;
            private int quantity;

            public String getProductTemplateName() {
                return productTemplateName;
            }

            public void setProductTemplateName(String productTemplateName) {
                this.productTemplateName = productTemplateName;
            }

            public int getQuantity() {
                return quantity;
            }

            public void setQuantity(int quantity) {
                this.quantity = quantity;
            }

            @Override
            public String toString() {
                return "AppProductResultBean{" +
                        "productTemplateName='" + productTemplateName + '\'' +
                        ", quantity=" + quantity +
                        '}';
            }
        }

        public static class AppDeliveryResultBean {
            /**
             * deliveryPartyName : 圆通快递 快递公司名
             * shipmentCode : 44444444444444 快递单号
             */
            private String deliveryPartyName;
            private String shipmentCode;

            public String getDeliveryPartyName() {
                return deliveryPartyName;
            }

            public void setDeliveryPartyName(String deliveryPartyName) {
                this.deliveryPartyName = deliveryPartyName;
            }

            public String getShipmentCode() {
                return shipmentCode;
            }

            public void setShipmentCode(String shipmentCode) {

                this.shipmentCode = shipmentCode;
            }

            @Override
            public String toString() {
                return "AppDeliveryResultBean{" +
                        "deliveryPartyName='" + deliveryPartyName + '\'' +
                        ", shipmentCode='" + shipmentCode + '\'' +
                        '}';
            }
        }

        @Override
        public String toString() {
            return "DataBean{" +
                    "receiverNameSnapshot='" + receiverNameSnapshot + '\'' +
                    ", submitDate='" + submitDate + '\'' +
                    ", orderCode='" + orderCode + '\'' +
                    ", orderStatus='" + orderStatus + '\'' +
                    ", appProductResult=" + appProductResult +
                    ", appDeliveryResult=" + appDeliveryResult +
                    '}';
        }
    }
}
