package com.urovo.activity.slidemenu.presenter

import com.urovo.activity.slidemenu.presenter.contract.FreeDeliveryQueryContract
import com.urovo.activity.slidemenu.response.FreeDeliveryQueryResponse
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.base.mvp.AbsPresenter
import com.urovo.wugumofang.view.LoadWaitDominator
import com.wgmf.trade.GlobalApp
import com.zsy.libcore.common.other.NetUtil

/**
 * 免费送直接兑换记录查询 Presenter
 * @author LW
 */
class FreeDeliveryQueryPresenter(
    private val view: FreeDeliveryQueryContract.View
) :AbsPresenter(), FreeDeliveryQueryContract.Presenter {

    private var mFreeDeliveryQueryResponse: FreeDeliveryQueryResponse = FreeDeliveryQueryResponse(view)

    override fun start() {
    }

    override fun requestActivityExchageDetail(mobile: String?) {
        if (NetUtil.hasAvailableNet(GlobalApp.getInstance())) {
            if(mobile.isNullOrEmpty()) {
                view.showState(LoadWaitDominator.NO_DATA)
            }else{
                mFreeDeliveryQueryResponse.requestActivityExchageDetail(mobile)
            }
        }else{
            view.showState(LoadWaitDominator.NET_ERROR)
        }

    }
}