package com.urovo.activity.slidemenu.presenter.contract

import com.urovo.wugumofang.base.mvp.AbsView
import com.urovo.wugumofang.base.BasePresenter

/**
 * 上传购物小票Contract
 * @author LW
 */
interface UploadShoppingReceiptContract {

    interface IView : AbsView {
        /**
         * 上传图片中
         */
        fun submitPhotosLoading()

        /**
         * 上传图片成功
         */
        fun submitPhotosSuccess(photos: String)

        /**
         * 上传图片失败
         */
        fun submitPhotosFailed(error:String)

        /**
         * 提交小票状态
         */
        fun submitionStatus(isSuccess: Boolean)

    }


    interface IPresenter : BasePresenter {

        /**
         * 上传图片到七牛云
         */
        fun requestSubmitPhotosToQinIu(photos: String?)

        /**
         * POST /app/uploadCertificate
         * 上传小票
         */
        fun requestUploadCertificate(mobile: String?)
    }
}