package com.urovo.activity.systemsetting;

import android.app.ActivityManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager.NameNotFoundException;
import android.os.Bundle;
import android.text.Html;
import android.text.TextUtils;
import android.view.View;
import android.widget.TextView;

import androidx.annotation.Nullable;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.taobao.sophix.SophixManager;
import com.urovo.activity.login.view.LoginActivity;
import com.urovo.activity.newGuideAct.view.NewGuideAct;
import com.urovo.activity.systemsetting.shareappqrcode2colleagues.ShareAppQrCode2ColleaguesAct;
import com.urovo.activity.systemsetting.view.BluetoothSettingActivity;
import com.urovo.activity.systemsetting.view.ChoosePrinterTypeActivity;
import com.urovo.wgmf.AsyncTask.GetServerVersionTask;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.BasePackageUtil;
import com.urovo.wugumofang.system.PdaMsgConfig;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DialogHelper;
import com.urovo.wugumofang.view.webview.FraContainerAct;
import com.wgmf.trade.GlobalApp;
import com.wgmf.trade.ui.fra.more.setting.DeveloperModeFra;
import com.wgmf.trade.utils.RestartApp;
import com.xsj.crasheye.Crasheye;
import com.zsy.libcore.ui.act.SYActManager;
import com.zsy.libext.widgets.clipboard.ClipboardUtil;

import java.util.HashMap;
import java.util.Map;

@Route(path = RouterParams.ORIGIN.SETTINGACTIVITY)
public class SttingMenu extends BaseActivity implements View.OnClickListener, View.OnLongClickListener {
    private static final int SWITCH_VERSION_CLK_NUM = 3;
    private Map<String, String> params = new HashMap<>();
    private long mPreClickTime;
    private int mCount;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.setting_menu);
        initTitle();
        titleTextView.setText("系统设置");

        android.telephony.TelephonyManager tm = (android.telephony.TelephonyManager) getSystemService(Context.TELEPHONY_SERVICE);
        String device_id = null;
        try {
            if (tm != null) {
                device_id = tm.getDeviceId();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        android.net.wifi.WifiManager wifi = (android.net.wifi.WifiManager) GlobalApp.getInstance().getApplicationContext().getSystemService(Context.WIFI_SERVICE);
        String mac = wifi.getConnectionInfo().getMacAddress();

        findViewById(R.id.setting_menu_logo).setOnLongClickListener(this);// 长按点击会弹出修复紧急bug的对话框

        TextView textViewReleaseInfo = (TextView) findViewById(R.id.textViewReleaseInfo);
        textViewReleaseInfo.setText("机型/系统:" + android.os.Build.VERSION.RELEASE);

        TextView device = (TextView) findViewById(R.id.textViewDevice);
        device.setText("IMEI:" + device_id + "   MAC:" + mac);

        TextView textViewVersion = (TextView) findViewById(R.id.textViewVersion);
        try {
            PackageInfo info = getPackageManager().getPackageInfo(getPackageName(), 0);
            textViewVersion.setText("当前版本号:" + info.versionName);
        } catch (NameNotFoundException e) {

            textViewVersion.setText("当前版本号:" + "无法获取！");
        }
        textViewVersion.setOnClickListener(this);
        textViewReleaseInfo.setOnClickListener(this);
    }

    public void settin_menu_onclick(View view) {
        switch (view.getId()) {
            case R.id.bluetooth_setting_ll:
                Intent intentBlue = new Intent(this, BluetoothSettingActivity.class);
                startActivity(intentBlue);
                break;
            case R.id.printer_type_ll:
                startActivity(new Intent(this, ChoosePrinterTypeActivity.class));
                break;
            case R.id.app_updata:
                params.put("userNo", SystemHelper.LoginUserId);
                new GetServerVersionTask(SttingMenu.this, "正在检测更新", true, params).execute("");
                break;
            case R.id.password:
                Intent intent = new Intent(SttingMenu.this, SystemSettingPassword.class);
                intent.putExtra("TAG", "SttingMenu");
                startActivity(intent);
                break;
            case R.id.cancel:
                DialogHelper.Alert2(this, "提示", "是否要注销?", null, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        if (PdaMsgConfig.isPDA(SttingMenu.this)) {//pos机情况下，直接注销再登陆时，可能进不了主页，原因未知，直接退出到桌面重新进可解决，所以pos机情况下，注销即退出。
                            //要杀掉第二进程
                            ((ActivityManager) getSystemService(ACTIVITY_SERVICE)).killBackgroundProcesses(BasePackageUtil.getAppPackageName(SttingMenu.this));
                            SYActManager.getInstance().AppExit();
                        } else {
                            Intent logoutIntent = new Intent(SttingMenu.this, LoginActivity.class);
                            logoutIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK);
                            startActivity(logoutIntent);
                        }
                    }
                });
                break;
            case R.id.new_function_show:
                Intent intent1 = new Intent(this, NewGuideAct.class);
                //传内容显示标记（只用显示新功能介绍，不用显示广告）
                HashMap<String, Boolean> signals = new HashMap<>();
                signals.put(NewGuideAct.KEY_AD, false);
                signals.put(NewGuideAct.KEY_WELCOME, true);
                intent1.putExtra(NewGuideAct.INTENT_SIGNALS, signals);
                //传从哪个界面过来的（如果是从设置过来的，那点击按钮后需要finish而不是跳转）
                intent1.putExtra(AppConstants.PreKeys.NEW_GUIDE_FROM, this.getClass());
                startActivity(intent1);
                break;
            case R.id.share_colleagues://分享给同事生意管家App下载二维码
                ShareAppQrCode2ColleaguesAct.launch(this, "生意管家", "生意APP下载地址", "http://app.wgmf.com/mobile/wap.html");
                break;
            case R.id.clear_cache: //清除缓存
                DialogHelper.Alert(this, "提示",
                        "确定清除所有缓存数据?", null, (dialog, which) ->
                                BaseAppManager.getInstance().clearApplicationData(), (dialogInterface, i) -> {
                        });
                break;
            case R.id.crash_log_pick://复制闪退码
                String uid = Crasheye.getCrasheyeUUID();
                if (TextUtils.isEmpty(uid)) {
                    showMsg("复制失败");
                } else {
                    ClipboardUtil.copyText(this, uid/*Base64.encodeBase64String(GZIPUtils.compress(log))*/);// 复制到系统的剪切板
                    showMsg("复制成功");
                    //复制完了设备标识码，可以去http://www.testplus.cn/后台按照该复制的设备码uid来过滤查看对应的崩溃日志
                }
                break;
            default:
                break;
        }

    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        showMsg("已经是最新版本");
    }

    @Override
    public void onClick(View v) {
        long now;
        switch (v.getId()) {
            case R.id.textViewVersion:
                now = System.currentTimeMillis();
                if (now - mPreClickTime < 300) {
                    mCount++;
                } else {
                    mCount = 1;
                }
                mPreClickTime = now;
                break;
            case R.id.textViewReleaseInfo:
                now = System.currentTimeMillis();
                if (mCount >= SWITCH_VERSION_CLK_NUM && now - mPreClickTime < 500) {
                    FraContainerAct.launch(SttingMenu.this, DeveloperModeFra.class, null, false);
                }
                break;
            default:
                break;
        }
    }

    private void showDialog() {
        DialogHelper.Alert(this, Html.fromHtml("提示：<font color='#ff0000'><small>(自动重启后需手动再重启)</small></font>"),
                "请点击重启应用，加载新的补丁包!", null, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
//                android.os.Process.killProcess(android.os.Process.myPid());
                        //确认按钮
                        SophixManager.getInstance().cleanPatches();
                        RestartApp.restart(SttingMenu.this);
                    }
                }, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        //取消按钮
                    }
                });

//        htmlStr = htmlStr.replaceAll(TAG_FONT, TAG_BLUE_FONT);
//        DialogHelper.Alert(this, Html.fromHtml(htmlStr, null, new HtmlTagHandler()), "点击确认重启应用，加载新的补丁包!", null, new DialogInterface.OnClickListener() {
//            @Override
//            public void onClick(DialogInterface dialog, int which) {
////                android.os.Process.killProcess(android.os.Process.myPid());
//                //确认按钮
//                SophixManager.getInstance().cleanPatches();
//                RestartApp.restart(SttingMenu.this);
//            }
//        }, new DialogInterface.OnClickListener() {
//            @Override
//            public void onClick(DialogInterface dialogInterface, int i) {
//                //取消按钮
//            }
//        });
    }

    @Override
    public boolean onLongClick(View v) {
        showDialog();
//        XToolReporter.disableAndzu();
//        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M && !Settings.canDrawOverlays(this)) {
//            Intent intent = new Intent(
//                    Settings.ACTION_MANAGE_OVERLAY_PERMISSION,
//                    Uri.parse("package:$packageName")
//            );
//            startActivityForResult(intent, 1);
//        } else {
//            XToolReporter.initBubbles(GlobalApp.context);
//        }
        return false;
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable @org.jetbrains.annotations.Nullable Intent data) {
//        if (requestCode == 1) {
//            if (resultCode == RESULT_OK) {
//                XToolReporter.initBubbles(GlobalApp.context);
//            }
//        } else {
//            super.onActivityResult(requestCode, resultCode, data);
//        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
//        try {
//            XToolReporter.recycle();
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
    }
}
