package com.urovo.activity.systemsetting;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.EditorInfo;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.activity.tabMenu.view.TabMenuActivity;
import com.urovo.wgmf.AsyncTask.BaseAppManageServerTask;
import com.urovo.wgmf.db.dao.dao.Czyda001DbOperate;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.db.dao.entitys.YuanGongEntity;
import com.urovo.wugumofang.system.DeviceHelper;
import com.urovo.wugumofang.system.PdaMsgConfig;
import com.urovo.wugumofang.R;

import java.util.HashMap;

@Route(path = RouterParams.ORIGIN.SYSTEMSETTINGPASSWORD)
public class SystemSettingPassword extends BaseActivity implements OnClickListener {

    private ImageButton back;
    private Button confirmbtn;
    private EditText passwordold;
    private EditText passwordnew;
    private EditText passwordnewconfirm;
    private boolean isTrue = false;// 是否为设置按钮跳转过来。ture为是,false为否
    private YuanGongEntity yuanGongEntity;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.system_password_setting);
        init();
        initTitle();
        initListener();
        Intent intent = getIntent();
        titleTextView.setText("密码设置");
        confirmbtn.setEnabled(false);
        if (intent != null && TextUtils.equals("SttingMenu", intent.getStringExtra("extras"))) {
            isTrue = true;
        } else {
            // back.setVisibility(View.GONE);
        }
    }

    private void init() {

        back = (ImageButton) findViewById(R.id.back);
        back.setVisibility(View.VISIBLE);
        confirmbtn = (Button) findViewById(R.id.confirm_button);
        confirmbtn.setBackgroundResource(R.drawable.btn_gray);
        confirmbtn.setOnClickListener(this);
        back.setOnClickListener(this);
        passwordold = (EditText) findViewById(R.id.password_old);
        passwordnew = (EditText) findViewById(R.id.password_new);
        passwordnewconfirm = (EditText) findViewById(R.id.password_new_confirm);
        passwordold.setInputType(EditorInfo.TYPE_CLASS_PHONE);
        passwordnew.setInputType(EditorInfo.TYPE_CLASS_PHONE);
        passwordnewconfirm.setInputType(EditorInfo.TYPE_CLASS_PHONE);
    }

    public void initListener() {
        btnlistener(passwordold);
        btnlistener(passwordnew);
        btnlistener(passwordnewconfirm);
    }

    public void btnlistener(EditText edt) {

        edt.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {

                btncolorchange();
            }
        });
    }

    public void btncolorchange() {
        if (!(passwordold.getText().toString().equals("")) && !(passwordold.getText() == null) && !(passwordnew.getText().toString().equals("")) && !(passwordnew.getText() == null) && !(passwordnewconfirm.getText().toString().equals("")) && !(passwordnewconfirm.getText() == null)) {
            confirmbtn.setBackgroundResource(R.drawable.login_button_selector);
            confirmbtn.setEnabled(true);
        } else {
            confirmbtn.setBackgroundResource(R.drawable.btn_gray);

        }
    }

    private boolean check() {
        /*if(!TextUtils.equals(PdaMsgConfig.getPassWord(SystemSettingPassword.this), passwordold.getText().toString().trim())) {
			showMsg("原密码输入不正确");
			return false;
		}*/

        if (TextUtils.equals(passwordold.getText().toString().trim(), passwordnew.getText().toString().trim())) {
            showMsg("新密码不能与老密码相同");
            return false;
        }

        if (TextUtils.equals(SystemHelper.LoginUserId, passwordnew.getText().toString().trim())) {
            showMsg("新密码不能与用户名相同");
            return false;
        }

        if (!TextUtils.equals(passwordnew.getText().toString().trim(), passwordnewconfirm.getText().toString().trim())) {
            showMsg("两次输入密码不一致");
            return false;
        }
        return true;
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {

        if (TextUtils.equals(tag, "setttingPassword")) {
            PasswordRes res = (PasswordRes) response;
            if (res.msgCode.equals("0")) {
                PdaMsgConfig.setPassWord("", this);//修改成功后，清空缓存在本地的密码，使下次进登陆界面时密码为空。
                Czyda001DbOperate.updatePassWord(SystemHelper.LoginUserId, passwordnew.getText().toString().trim());
                showMsg(res.getResultInfo());
                if (!isTrue) {
                    Intent intent = new Intent(this, TabMenuActivity.class);
                    startActivity(intent);
                    SystemSettingPassword.this.finish();
                } else {
                    this.finish();
                }
            }//密码修改失败
            else {
                showMsg(res.msgInfo);
            }
        }

    }

    @Override
    protected void back() {
        finish();
        // if (!isTrue) {
        // Intent intent = new Intent(this, TabMenuActivity.class);
        // startActivity(intent);
        // SystemSettingPassword.this.finish();
        // } else {
        // this.finish();
        // }

    }

    @Override
    public void onClick(View v) {

        switch (v.getId()) {
            case R.id.confirm_button:
                if (!check())
                    return;
			/*yuanGongEntity = new YuanGongEntity();
			yuanGongEntity.OPERATORID = SystemHelper.LoginUserId;
			yuanGongEntity.PASSWORD = passwordnewconfirm.getText().toString().trim();*/
                HashMap<String, String> params = new HashMap<>();
                params.put("newPWD", passwordnew.getText().toString().trim());//新密码传明文
                params.put("oldPWD", DeviceHelper.getMD5Str(passwordold.getText().toString().trim()));//老密码传MD5
                params.put("userNo", SystemHelper.LoginUserId);
                //new UploadYuanGongPasswordUpdateTask(SystemSettingPassword.this, "更改员工密码中！", true, yuanGongEntity).execute("");
                new BaseAppManageServerTask("setttingPassword", PasswordRes.class, this,
                        "正在修改密码...", false, "/information/resetPassword", params).execute("");
                break;
            default:
                break;
        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {

        if (keyCode == KeyEvent.KEYCODE_BACK) {
            back();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

}
