package com.urovo.activity.systemsetting.view

import com.alibaba.android.arouter.facade.annotation.Route
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.constants.RouterParams
import com.urovo.wugumofang.data.PreferHelper
import kotlinx.android.synthetic.main.activity_choose_printer_type.*

/**
 * @author LW
 * 打印机类型选择
 */
@Route(path = RouterParams.ORIGIN.CHOOSEBLUETOOTHTYPEACTIVITY)
class ChoosePrinterTypeActivity : BaseActivity() {

    override fun addRootLayoutId(): Int = R.layout.activity_choose_printer_type

    override fun initTitle() {
        super.initTitle()
        titleTextView.text = getString(R.string.choose_printer_type)
    }

    override fun initViewNew() {
        initTitle()

        val newPrinterType = PreferHelper.getInstance().getBoolean(
            AppConstants.PreKeys.NEW_PRINTER_TYPE, false
        )
        choose_printer_type_rg?.check(if (newPrinterType) R.id.choose_printer_type_new_rb else R.id.choose_printer_type_old_rb)

        choose_printer_type_rg?.setOnCheckedChangeListener { group, checkedId ->
            if (checkedId == R.id.choose_printer_type_new_rb) {  //新打印机
                PreferHelper.getInstance()
                    .setBoolean(AppConstants.PreKeys.NEW_PRINTER_TYPE, true)
            } else if (checkedId == R.id.choose_printer_type_old_rb) {  //老打印机
                PreferHelper.getInstance()
                    .setBoolean(AppConstants.PreKeys.NEW_PRINTER_TYPE, false)
            }
            PreferHelper.getInstance().remove(
                AppConstants.PreKeys.PRINT_ADDRESS
            )
            showToast(R.string.choose_printer_switch_success)
        }
    }
}