package com.urovo.activity.systemsetting.view.adapter

import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.urovo.wugumofang.R
import com.urovo.wugumofang.utils.notNullAndEmpty

/**
 * 蓝牙设置适配器
 * @author LW
 */
class BluetoothSettingAdapter(
    entity: List<BluetoothInfoEntity>
) : BaseQuickAdapter<BluetoothInfoEntity, BaseViewHolder>(
    R.layout.item_bluetooth_setting,
    entity
) {

    override fun convert(helper: BaseViewHolder?, item: BluetoothInfoEntity?) {
        item?.let {
            helper?.apply {
                if (it.name.notNullAndEmpty()) {
                    setText(R.id.bluetooth_setting_name_tv, it.name)
                }
                setGone(R.id.bluetooth_setting_name_tv, it.name.notNullAndEmpty())

                if (it.address.notNullAndEmpty()) {
                    setText(R.id.bluetooth_setting_address_tv, it.address)
                }
                setGone(R.id.bluetooth_setting_address_tv, it.address.notNullAndEmpty())
            }
        }
    }
}