package com.urovo.activity.tabMenu.home

import android.content.Context
import android.util.AttributeSet
import android.view.View
import androidx.coordinatorlayout.widget.CoordinatorLayout
import androidx.core.view.ViewCompat
import androidx.core.widget.NestedScrollView
import com.urovo.wugumofang.ui.DensityUtil



/**
 * @author Sasuke on 2019-02-25 0025.
 * HomeActivity在上方的Title层
 */
class HomeTitleUpBehavior : CoordinatorLayout.Behavior<View> {
    constructor(context: Context?, attrs: AttributeSet?) : super(context, attrs)

    override fun onStartNestedScroll(coordinatorLayout: CoordinatorLayout, child: View, directTargetChild: View, target: View, axes: Int, type: Int): Boolean {
        return axes == ViewCompat.SCROLL_AXIS_VERTICAL
    }


    override fun onNestedScroll(coordinatorLayout: CoordinatorLayout, child: View, target: View, dxConsumed: Int, dyConsumed: Int, dxUnconsumed: Int, dyUnconsumed: Int, type: Int) {
        super.onNestedScroll(coordinatorLayout, child, target, dxConsumed, dyConsumed, dxUnconsumed, dyUnconsumed, type)
        var scrolled = target?.getScrollY()?.toFloat() ?: 0f
        val titleHeight = DensityUtil.dip2px(coordinatorLayout?.getContext(), 60f).toFloat()

        scrolled = if (scrolled > titleHeight) titleHeight else if (scrolled < 0) 0f else scrolled
        child?.run {
//            visibility = /*if (scrolled == 0f) View.GONE else*/ View.VISIBLE

            setAlpha(scrolled / titleHeight)
        }
//        Log.i("SasukeLog","onNestedScroll： scrolled=$scrolled")

//        if (target is NestedScrollView && !target?.canScrollVertically(-1)){
//            child?.alpha = 0f
//        }
    }

    override fun onNestedFling(coordinatorLayout: CoordinatorLayout, child: View, target: View, velocityX: Float, velocityY: Float, consumed: Boolean): Boolean {
        if (child is NestedScrollView) {
            child.fling(velocityY.toInt())
        }
        return super.onNestedFling(coordinatorLayout, child, target, velocityX, velocityY, consumed)
    }

}