package com.urovo.activity.tabMenu.home.ada;


import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.text.TextUtils;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.Toast;

import com.urovo.activity.tabMenu.home.ent.HomeAdEntity;
import com.urovo.activity.tabMenu.home.ent.MultipleItem;
import com.urovo.activity.tabMenu.home.holder.BaseMultiItemHolder;
import com.urovo.activity.tabMenu.home.utils.GlideImageLoader;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.net.CookieDominator;
import com.urovo.wugumofang.system.ToActivity;
import com.urovo.wugumofang.ui.DensityUtil;
import com.urovo.wugumofang.utils.AndroidWorkaround;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra;
import com.wgmf.trade.utils.ImageLoader;
import com.youth.banner.Banner;
import com.youth.banner.listener.OnBannerListener;
import com.zsy.libcore.common.android.log.SYLoger;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * 具备item拖拽 滑动 布局嵌套功能的适配器
 * ps:广告位:http://192.168.5.56:8585/app/swagger-ui.html#!/step-by-front-display-controller/showAdListUsingPOST
 *
 * @author chenji
 */
public class MultipleItemAdapter
        extends BaseMultiItemDraggableAdapter<MultipleItem, BaseMultiItemHolder>
        implements OnBannerListener {
    private Context mContext;
    private OnGetFootEmptyTopListener onGetFootEmptyTopListener;
    private List<String> mPicUrls = new ArrayList<>();
    private List<String> mLinkList = new ArrayList<>();
    private String mLinkType = "";
    /**
     * 首页旋转木马数据ID
     */
    private int[] carouselValueTvId = {
            /*任务 差额 已完成 当前完成客单数 任务客单数*/
            R.id.task_sales_carousel_home,
            R.id.difference_sales_carousel_home,
            R.id.completed_sales_carousel_home,
            R.id.guest_completed_sales_carousel_home,
            R.id.singular_task_guest_carousel_home,

            /*基础薪资 提成部分 考核项目 合计*/
            R.id.base_salary_carousel_home,
            R.id.cut_part_salary_carousel_home,
            R.id.project_check_salary_carousel_home,
            R.id.total_salary_carousel_home,

            /*新会员数 老会员数 新客微会员 目标新客微会员达成 当月新客微会员数目标*/
            R.id.new_members_carousel_home,
            R.id.old_members_carousel_home,
            R.id.new_guest_members_carousel_home,
            R.id.new_target_guest_members_carousel_home,
            R.id.new_guest_micro_members_goals_carousel_home
    };
    private int totalHeight;

    public MultipleItemAdapter(Context context, List<MultipleItem> data) {
        super(data);
        mContext = context;
        //自定义的多布局
        addItemType(MultipleItem.HEAD_EMPTY, R.layout.item_head_empty);
        addItemType(MultipleItem.HEAD_SEARCH, R.layout.toolbar_search2);
//        addItemType(MultipleItem.CAROUSEL, R.layout.view_loop_rotary_switch);
        addItemType(MultipleItem.IMAGE_TEXT, R.layout.item_draggable_view);
        addItemType(MultipleItem.IMAGE_TEXT_CUSTOM, R.layout.item_draggable_view);
        addItemType(MultipleItem.IMG_TEXT_EMPTY, R.layout.item_draggable_view);
        addItemType(MultipleItem.MENU_HORIZONTAL_LINE, R.layout.home_menu_hori_line);
        addItemType(MultipleItem.FOOT_EMPTY, R.layout.item_foot_empty);
        addItemType(MultipleItem.HOME_AD, R.layout.home_item_ad);
        addItemType(MultipleItem.HOME_HORIZONTAL_LINE, R.layout.home_menu_hori_line);
        addItemType(MultipleItem.FOOT_TIPS, R.layout.home_foot_tips);

        int screenH = DensityUtil.getScreenH(context);
        //第一个View的高度
        int headHeight = DensityUtil.dip2px(context, 60);
        // 上层嵌套页面TabMenuActivity布局中底部tab的高度
        int tabRadioGroupHeight = DensityUtil.dip2px(context, 54);
        //recycleView总高度=全屏高度+滑行距离(等于第一个View的高度)-底部tab的高度
//        totalHeight = headHeight + screenH - tabRadioGroupHeight;
        if (AndroidWorkaround.checkDeviceHasNavigationBar(context)) {
            //当设备虚拟有键盘时高度处理
            totalHeight = headHeight + screenH - DensityUtil.dip2px(context, 20);
        } else {
            totalHeight = headHeight + screenH - tabRadioGroupHeight;
        }
    }

    public void setOnGetFootEmptyTopListener(OnGetFootEmptyTopListener onGetFootEmptyTopListener) {
        this.onGetFootEmptyTopListener = onGetFootEmptyTopListener;
    }

    /**
     * 首页数据处理
     *
     * @param helper 视图模型(获取控件)
     * @param item   数据模型(获取数据)
     */
//    private void setCarouselValue(BaseMultiItemHolder helper, MultipleItem item) {
//        final String[] homeCarouselArray = mContext.getResources().getStringArray(R.array.home_carousel_data);
//        final HomeCarouselEntity entity = (HomeCarouselEntity) item.getObject();
//        if (entity != null) {
//            //在线
//            final String[] memArray = getMemArray(entity);
//            for (int i = 0; i < memArray.length; i++) {
//                helper.setText(carouselValueTvId[i], memArray[i]);
//            }
//        } else {
//            //离线
//            for (int j = 0; j < carouselValueTvId.length; j++) {
//                helper.setText(carouselValueTvId[j], homeCarouselArray[j]);
//            }
//        }
//    }

    @SuppressWarnings("all")
    @Override
    protected void convert(BaseMultiItemHolder helper, MultipleItem item) {
        switch (helper.getItemViewType()) {
            case MultipleItem.HEAD_SEARCH:
                helper.addOnClickListener(R.id.our_catalogue_toSearch2).addOnClickListener(R.id.refresh_btn2);
                break;
//            case MultipleItem.CAROUSEL:
//                setCarouselValue(helper, item);
//                break;
            case MultipleItem.IMAGE_TEXT:
                helper.addOnClickListener(R.id.menu_icon);

                final String[] strArray = item.getStrArray();
                if (strArray != null) {
                    final String iconName = strArray[0];
                    final String iconUrl = strArray[1];
                    final ImageView ivIcon = helper.getView(R.id.iv_head);
                    helper.setText(R.id.tv, iconName);
                    ImageLoader.loadCircleImg(mContext, iconUrl, ivIcon, R.mipmap.img_default_face, R.mipmap.img_default_face);
                }
                break;

            //首页菜单--自定义按钮
            case MultipleItem.IMAGE_TEXT_CUSTOM:
                helper.setImageResource(R.id.iv_head, item.getResId());
                helper.setText(R.id.tv, item.getContent());
                break;

            //填补空白区域
            case MultipleItem.IMG_TEXT_EMPTY:
                helper.setVisible(R.id.iv_head, false);
                helper.setVisible(R.id.tv, false);
                break;

            case MultipleItem.MENU_HORIZONTAL_LINE:
                //线条设置颜色为白色
                helper.setBackgroundColor(R.id.item_horizontal_lines, Color.WHITE);
                //高度设置为18dp
                ViewGroup.LayoutParams params = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, DensityUtil.dip2px(mContext, 18));
                helper.getView(R.id.item_horizontal_lines).setLayoutParams(params);
                break;

            case MultipleItem.FOOT_EMPTY:
                View view = helper.getView(R.id.ll_root);
                ViewGroup.LayoutParams layoutParams = view.getLayoutParams();
                int footEmptyTop = 0;
                if (onGetFootEmptyTopListener != null) {
                    footEmptyTop = onGetFootEmptyTopListener.getFootEmptyTop();
                }
                layoutParams.height = totalHeight - footEmptyTop;
                view.setLayoutParams(layoutParams);
                break;
            case MultipleItem.HOME_AD:
//                final String[] picUrls = mContext.getResources().getStringArray(R.array.pic_url);
                //assets
//                String[] picUrls = {
//                        "file:///android_asset/gif/banner_001_faq.gif",
//                        "file:///android_asset/gif/banner_002_declaration.gif"
//                };
                final List<HomeAdEntity> entity = (List<HomeAdEntity>) item.getObject();
                SYLoger.print("wgmf--广告位(MultipleItem.HOME_AD):" + entity);
                mPicUrls.clear();
                mLinkList.clear();
                if (entity != null) {
                    for (HomeAdEntity homeAdEntity : entity) {
                        mLinkType = homeAdEntity.getLinkType();
                        if ("url".equals(mLinkType)) {
//                                BaseCookiesWebFra.launch(mContext, new Intent(), homeAdEntity.getUrl(), null, true);
                            mLinkList.add(CookieDominator.transURL(homeAdEntity.getUrl()));//经过一层转换，替换部分字符，实现H5传参
                        } else {
                            mLinkList.add(homeAdEntity.getAndroidLink());
//                                ToActivity.toActivity(mContext, Class.forName(homeAdEntity.getAndroidLink()));
                        }

                        mPicUrls.add(homeAdEntity.getAndroidImgUrl());
                    }
                }
                Integer[] images = {R.drawable.banner_0_default};
                SYLoger.print("wgmf--广告配置(mPicUrls): " + mPicUrls.toString());
                Banner banner = helper.getView(R.id.home_item_ad);
                banner.setImages(mPicUrls.isEmpty() ? Arrays.asList(images) : mPicUrls)
                        .setDelayTime(5000)
                        .setImageLoader(new GlideImageLoader())
                        .setOnBannerListener(this)
                        .start();

//                //设置banner样式
//                banner.setBannerStyle(BannerConfig.CIRCLE_INDICATOR_TITLE);
//                //设置图片加载器
//                banner.setImageLoader(new GlideImageLoader());
//                //设置图片集合
//                banner.setImages(images);
//                //设置banner动画效果
//                banner.setBannerAnimation(Transformer.DepthPage);
//                //设置标题集合（当banner样式有显示title时）
//                banner.setBannerTitles(titles);
//                //设置自动轮播，默认为true
//                banner.isAutoPlay(true);
//                //设置轮播时间
//                banner.setDelayTime(1500);
//                //设置指示器位置（当banner模式中有指示器时）
//                banner.setIndicatorGravity(BannerConfig.CENTER);
//                //banner设置方法全部调用完毕时最后调用
//                banner.start();
                break;
//            case MultipleItem.HOME_HORIZONTAL_LINE:
            //高度设置为18dp
//                ViewGroup.LayoutParams hhlParams = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, DensityUtil.dip2px(mContext, 16));
//                helper.getView(R.id.item_horizontal_lines).setLayoutParams(hhlParams);
//                break;
            default:
                break;
        }
    }

//    private String[] getMemArray(HomeCarouselEntity entity) {
//        /*
//        public String saleAmountTask = "--";//任务
//        public String remainSaleAmount = "--";//差额
//        public String currentSaleAmount = "--";//已完成
//        public int currentSaleNum;//客单数达成
//        public String saleNumTask = "--";//任务客单数
//
//        public String base = "--";//基础薪资
//        public String commission = "--";//提成部分
//        public String assess = "--";//考核项目
//        public String total = "--";//合计
//
//        public int newMemberNum;//新会员数
//        public int oldMemberNum;//老会员数
//        public int weMemberDaySum;//新客微会员
//        public String weMemberMonthSum = "--";//目标新客微会员达成(左边)
//        public String weMemberTargetSum = "--";//目标新客微会员达成(右边)
//        */
//        return new String[]
//                {
//                        entity.getSaleAmountTask(),
//                        entity.getRemainSaleAmount(),
//                        entity.getCurrentSaleAmount(),
//                        entity.getCurrentSaleNum() + "",
//                        entity.getSaleNumTask(),
//
//                        entity.getBase(),
//                        entity.getCommission(),
//                        entity.getAssess(),
//                        entity.getTotal(),
//
//                        entity.getNewMemberNum() + "",
//                        entity.getOldMemberNum() + "",
//                        entity.getWeMemberDaySum() + "",
//                        entity.getWeMemberMonthSum(),
//                        entity.getWeMemberTargetSum()
//                };
//    }

    @SuppressWarnings("all")
    @Override
    public void OnBannerClick(int position) {
        if (mLinkList.isEmpty() || TextUtils.isEmpty(mLinkList.get(position))) {
            return;
        }
        // h5链接就判断是否包含http请求头
        if (mLinkList.get(position).contains("http")) {
            BaseCookiesWebFra.launch(mContext, new Intent(), mLinkList.get(position), "", true);
        } else {
            try {
                ToActivity.toActivity(mContext, Class.forName(mLinkList.get(position)));
            } catch (ClassNotFoundException e) {
                e.printStackTrace();
                MyToast.show(mContext, "当前广告配置有问题", Toast.LENGTH_SHORT);
            }
        }
//        if (mLinkType != null && mLinkList != null) {
//            if ("url".equals(mLinkType.get(position))) {
////                BaseCookiesWebFra.launch(mContext, mLinkList.get(position), "", true);
//                SYLoger.print("wgmf-->广告配置 : LoginUserId: " + SystemHelper.LoginUserId);
//                BaseCookiesWebFra.launch(mContext, new Intent(), mLinkList.get(position), "", true);
////                BaseCookiesWebFra.launch(mContext, "http://stu.wgmf.com/mobile/html/sso.html", "", true);
////                    WebViewAct.launch(mContext, "",  mLinkList.get(position));
////                WebViewAct.launch(mContext, "",  "http://stu.wgmf.com/mobile/html/sso.html");
//            } else {
//                try {
//                    if (!TextUtils.isEmpty(mLinkList.get(position))) {
//                        ToActivity.toActivity(mContext, Class.forName(mLinkList.get(position)));
//                    }
//                } catch (ClassNotFoundException e) {
//                    e.printStackTrace();
//                    MyToast.show(mContext, "当前广告配置有问题", Toast.LENGTH_SHORT);
//                }
//            }
//        }
    }

    public interface OnGetFootEmptyTopListener {
        /**
         * 获取尾部空布局距离顶部的距离
         *
         * @return ...
         */
        int getFootEmptyTop();
    }
}