/*
 * Copyright (c) 2016 咖枯 <kaku201313@163.com | 3772304@qq.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package com.urovo.activity.tabMenu.home.ent;


import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.urovo.activity.tabMenu.home.utils.ACache;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.system.BaseAppManager;
import com.zsy.libcore.common.android.log.SYLoger;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;


/**
 * 加载item数据的管理类
 *
 * @author chenji
 */
public class MenuTableManager {

//    /**
//     * 更多功能
//     *
//     * @return ...
//     */
//    public static List<MultipleItem> loadNewsChannelsMore() {
//        List<String> channelName = Arrays.asList(BaseAppManager.appContext().getResources().getStringArray(R.array.home_menu_name_more));
//        List<Integer> channelImgRes = new ArrayList<>();
//        channelImgRes.add(R.mipmap.btn_new_sxp);
//        channelImgRes.add(R.mipmap.btn_old_remind);
//        channelImgRes.add(R.mipmap.btn_valid_weixin);
//        channelImgRes.add(R.mipmap.btn_order_center);
//        channelImgRes.add(R.mipmap.btn_stores_order);
//        channelImgRes.add(R.mipmap.btn_inventory);
//        channelImgRes.add(R.mipmap.btn_feedback);
//        channelImgRes.add(R.mipmap.btn_e_learning);
//        channelImgRes.add(R.mipmap.btn_guest_folio);
//        List<MultipleItem> newsChannelTables = new ArrayList<>();
//        for (int i = 0; i < channelName.size(); i++) {
//            final MultipleItem entity = new MultipleItem(MultipleItem.IMAGE_TEXT, channelName.get(i), channelImgRes.get(i));
//            newsChannelTables.add(entity);
//        }
//        return newsChannelTables;
//    }

    /**
     * 更多功能
     *
     * @param spanSize ...
     * @return ...
     */
    public static List<MultipleItem> loadNewsChannelsMore(int spanSize) {
//        List<String> channelName = Arrays.asList(BaseAppManager.appContext().getResources().getStringArray(R.array.home_menu_name_more));
//        List<Integer> channelImgRes = new ArrayList<>();
//        channelImgRes.add(R.mipmap.btn_new_sxp);
//        channelImgRes.add(R.mipmap.btn_old_remind);
//        channelImgRes.add(R.mipmap.btn_valid_weixin);
//        channelImgRes.add(R.mipmap.btn_order_center);
//        channelImgRes.add(R.mipmap.btn_stores_order);
//        channelImgRes.add(R.mipmap.btn_inventory);
//        channelImgRes.add(R.mipmap.btn_feedback);
//        channelImgRes.add(R.mipmap.btn_e_learning);
//        channelImgRes.add(R.mipmap.btn_guest_folio);
        final boolean isSaveData = PreferHelper.getInstance().getBoolean(AppConstants.Home.IS_SAVE_DATA, false);
        final String onlineMore = PreferHelper.getInstance().getString(AppConstants.Home.ONLINE_MORE);
        final List<HomeMenuOnlineBean.ResultInfoBean> onlineMoreList = fromJson(onlineMore);
        SYLoger.print("RR_more-3->" + onlineMoreList);

//        //名称
//        final List<String> moreName = new ArrayList<>();
//        //图片
//        final List<String> morePicUrl = new ArrayList<>();
//        //子菜单的ID,确认原始位置,传给后台更新菜单用
//        final List<Integer> moreTypeId = new ArrayList<>();
        List<MultipleItem> moreTables = new ArrayList<>();
        //遍历集合,把名称和图片地址存到新的集合中
        for (HomeMenuOnlineBean.ResultInfoBean entity : onlineMoreList) {
//            moreName.add(entity.getTypeName());
//            morePicUrl.add(entity.getAndroid().getPic());
//            moreTypeId.add(entity.getTypeId());

            moreTables.add(new MultipleItem(
                    MultipleItem.IMAGE_TEXT,
                    spanSize,
                    entity.getTypeId(),
                    entity.getTypeName(),
                    entity.getAndroid().getPic(),
                    entity.getAndroid().getLinkType(),
                    entity.getAndroid().getLink(),
                    entity.getAndroid().getParam()
            ));
        }

//        List<MultipleItem> moreTables = new ArrayList<>();
//        for (int i = 0; i < onlineMoreList.size(); i++) {
//            final MultipleItem entity = new MultipleItem(MultipleItem.IMAGE_TEXT, spanSize, moreTypeId.get(i), moreName.get(i), morePicUrl.get(i));
//            moreTables.add(entity);
//        }
//        List<MultipleItem> newsChannelTables = new ArrayList<>();
//        for (int i = 0; i < channelName.size(); i++) {
//            final MultipleItem entity = new MultipleItem(MultipleItem.IMAGE_TEXT, spanSize, channelName.get(i), channelImgRes.get(i));
//            newsChannelTables.add(entity);
//        }
        if (isSaveData) {
            ACache.get(BaseAppManager.appContext()).put(AppConstants.Home.CHANNEL_MORE, (Serializable) moreTables);
        }
        return moreTables;
    }

//    /**
//     * 默认菜单项
//     *
//     * @return ...
//     */
//    public static List<MultipleItem> loadNewsChannelsStatic() {
//        List<String> channelName = Arrays.asList(BaseAppManager.appContext().getResources().getStringArray(R.array.home_menu_name_static));
//        List<Integer> channelImgRes = new ArrayList<>();
//        channelImgRes.add(R.mipmap.btn_hysp);
//        channelImgRes.add(R.mipmap.btn_integral_exchange);
//        channelImgRes.add(R.mipmap.btn_develop_new);
//        channelImgRes.add(R.mipmap.btn_logistics);
//        channelImgRes.add(R.mipmap.btn_checking_in);
//        channelImgRes.add(R.mipmap.btn_vip_form);
//        channelImgRes.add(R.mipmap.btn_sales_month);
//        List<MultipleItem> newsChannelTables = new ArrayList<>();
//        for (int i = 0; i < channelName.size(); i++) {
//            final MultipleItem entity = new MultipleItem(MultipleItem.IMAGE_TEXT, channelName.get(i), channelImgRes.get(i));
//            newsChannelTables.add(entity);
//        }
//        return newsChannelTables;
//    }

    /**
     * 默认菜单项
     *
     * @param spanSize ...
     * @return ...
     */
    public static List<MultipleItem> loadNewsChannelsStatic(int spanSize) {
//        List<String> channelName = Arrays.asList(BaseAppManager.appContext().getResources().getStringArray(R.array.home_menu_name_static));
//        List<Integer> channelImgRes = new ArrayList<>();
//        channelImgRes.add(R.mipmap.btn_hysp);
//        channelImgRes.add(R.mipmap.btn_integral_exchange);
//        channelImgRes.add(R.mipmap.btn_develop_new);
//        channelImgRes.add(R.mipmap.btn_logistics);
//        channelImgRes.add(R.mipmap.btn_checking_in);
//        channelImgRes.add(R.mipmap.btn_vip_form);
//        channelImgRes.add(R.mipmap.btn_sales_month);

//        final List<HomeMenuOnlineBean.ResultInfoBean> onlineMineList2 = (List<HomeMenuOnlineBean.ResultInfoBean>) ACache.get(BaseAppManager.appContext()).getAsObject(AppConstants.Home.ONLINE_MINE);
//        final List<HomeMenuOnlineBean.ResultInfoBean> onlineMoreList2 = (List<HomeMenuOnlineBean.ResultInfoBean>) ACache.get(BaseAppManager.appContext()).getAsObject(AppConstants.Home.ONLINE_MORE);
//        SYLoger.print("RR_mine-3->" + onlineMineList2);
//        SYLoger.print("RR_more-3->" + onlineMoreList2);
        final boolean isSaveData = PreferHelper.getInstance().getBoolean(AppConstants.Home.IS_SAVE_DATA, false);
        final String onlineMine = PreferHelper.getInstance().getString(AppConstants.Home.ONLINE_MINE);
        final List<HomeMenuOnlineBean.ResultInfoBean> onlineMineList = fromJson(onlineMine);

//        //名称
//        final List<String> mimeName = new ArrayList<>();
//        //图片
//        final List<String> mimePicUrl = new ArrayList<>();
//        //子菜单的ID,确认原始位置,传给后台更新菜单用
//        final List<Integer> mimeTypeId = new ArrayList<>();
        List<MultipleItem> mimeTables = new ArrayList<>();
        //遍历集合,把名称和图片地址存到新的集合中
        for (HomeMenuOnlineBean.ResultInfoBean entity : onlineMineList) {
//            mimeName.add(entity.getTypeName());
//            mimePicUrl.add(entity.getAndroid().getPic());
//            mimeTypeId.add(entity.getTypeId());

            mimeTables.add(new MultipleItem(
                    MultipleItem.IMAGE_TEXT,
                    spanSize,
                    entity.getTypeId(),
                    entity.getTypeName(),
                    entity.getAndroid().getPic(),
                    entity.getAndroid().getLinkType(),
                    entity.getAndroid().getLink(),
                    entity.getAndroid().getParam()
            ));
        }

//        List<MultipleItem> mimeTables = new ArrayList<>();
//        for (int i = 0; i < onlineMineList.size(); i++) {
//            SYLoger.print("RR_name-->" + mimeName.get(i));
//            SYLoger.print("RR_pic-->" + mimePicUrl.get(i));
//            final MultipleItem entity = new MultipleItem(MultipleItem.IMAGE_TEXT, spanSize, mimeTypeId.get(i), mimeName.get(i), mimePicUrl.get(i));
//            mimeTables.add(entity);
//        }
        if (isSaveData) {
            ACache.get(BaseAppManager.appContext()).put(AppConstants.Home.CHANNEL_MINE, (Serializable) mimeTables);
        }
        return mimeTables;
    }

//    public static List<MultipleItem> loadNewsChannelsStatic(List<List<HomeMenuOnlineBean.ResultInfoBean>> menuEntity, int spanSize) {
//
//        List<String> channelName = Arrays.asList(BaseAppManager.appContext().getResources().getStringArray(R.array.home_menu_name_static));
//        List<Integer> channelImgRes = new ArrayList<>();
//        channelImgRes.add(R.mipmap.btn_hysp);
//        channelImgRes.add(R.mipmap.btn_integral_exchange);
//        channelImgRes.add(R.mipmap.btn_develop_new);
//        channelImgRes.add(R.mipmap.btn_logistics);
//        channelImgRes.add(R.mipmap.btn_checking_in);
//        channelImgRes.add(R.mipmap.btn_vip_form);
//        channelImgRes.add(R.mipmap.btn_sales_month);
//
//        //名称
//        //图片
//        List<MultipleItem> newsChannelTables = new ArrayList<>();
//        for (int i = 0; i < channelName.size(); i++) {
//            final MultipleItem entity = new MultipleItem(MultipleItem.IMAGE_TEXT, spanSize, channelName.get(i), channelImgRes.get(i));
//            newsChannelTables.add(entity);
//        }
//        return newsChannelTables;
//    }

    /**
     * json 转集合
     *
     * @param json ...
     * @return ...
     */
    private static List<HomeMenuOnlineBean.ResultInfoBean> fromJson(String json) {
        return new Gson().fromJson(json, new TypeToken<List<HomeMenuOnlineBean.ResultInfoBean>>() {
        }.getType());
    }
}
