package com.urovo.activity.tabMenu.home.ent;

import com.chad.library.adapter.base.entity.MultiItemEntity;

import java.io.Serializable;

/**
 * @author chenji
 * @date 2018/1/8
 */

public class MultipleItem<T> implements MultiItemEntity, Serializable {
    public static final int HEAD_SEARCH = 1;
    public static final int CAROUSEL = 2;
    public static final int IMAGE_TEXT = 3;
    public static final int HEAD_EMPTY = 4;
    public static final int FOOT_EMPTY = 5;
    public static final int IMAGE_TEXT_CUSTOM = 6;
    public static final int IMG_TEXT_EMPTY = 7;
    public static final int MENU_HORIZONTAL_LINE = 8;
    public static final int HOME_AD = 9;
    public static final int HOME_HORIZONTAL_LINE = 10;
    public static final int FOOT_TIPS = 11;

    public static final int IMG_TEXT_SPAN_SIZE = 1;

    private int itemType;
    private int spanSize;
    private String content;
    private String[] strArray;
    private T t;
    private int resId;
    private int typeId;
    private boolean isShow;
    private boolean isAdd;

    public MultipleItem(int itemType, String content) {
        this.itemType = itemType;
        this.content = content;
    }

    public MultipleItem(int itemType, int spanSize, String content) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.content = content;
    }

    public MultipleItem(int itemType, int spanSize) {
        this.itemType = itemType;
        this.spanSize = spanSize;
    }

    public MultipleItem(int itemType, int spanSize, T t) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.t = t;
    }

    public MultipleItem(int itemType, String content, int resId) {
        this.itemType = itemType;
        this.content = content;
        this.resId = resId;
    }

    public MultipleItem(int itemType, int spanSize, String... strArray) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.strArray = strArray;
    }

    public MultipleItem(int itemType, int spanSize, int typeId, String... strArray) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.typeId = typeId;
        this.strArray = strArray;
    }

    public MultipleItem(int itemType, int spanSize, String content, int resId) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.content = content;
        this.resId = resId;
    }

    public int getSpanSize() {
        return spanSize;
    }

    public void setSpanSize(int spanSize) {
        this.spanSize = spanSize;
    }

    public int getResId() {
        return resId;
    }

    public void setResId(int resId) {
        this.resId = resId;
    }

    public void setContent(String content) {
        this.content = content;
    }


    public String getContent() {
        return content;
    }

    public void setItemType(int itemType) {
        this.itemType = itemType;
    }

    public T getObject() {
        return t;
    }

    public void setObject(T t) {
        this.t = t;
    }

    public String[] getStrArray() {
        return strArray;
    }

    public void setStrArray(String[] strArray) {
        this.strArray = strArray;
    }

    public int getTypeId() {
        return typeId;
    }

    public void setTypeId(int typeId) {
        this.typeId = typeId;
    }

    public boolean isShow() {
        return isShow;
    }

    public void setShow(boolean show) {
        isShow = show;
    }

    public boolean isAdd() {
        return isAdd;
    }

    public void setAdd(boolean add) {
        isAdd = add;
    }

    @Override
    public int getItemType() {
        return itemType;
    }
}
