package com.urovo.activity.tabMenu.home.menu;


import com.urovo.activity.tabMenu.home.act.ShortcutMenuAct;
import com.urovo.activity.tabMenu.home.ent.MultipleItem;
import com.urovo.activity.tabMenu.home.ent.ShortcutMenuBean;
import com.urovo.activity.tabMenu.home.pre.HomeModelImpl;
import com.urovo.activity.tabMenu.home.utils.RxDisposeManager;

import org.greenrobot.eventbus.EventBus;

import java.util.List;

import io.reactivex.Observable;
import io.reactivex.Observer;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.disposables.Disposable;

/**
 * @author lvr
 * @date 2017/2/14
 */

public class ShortcutMenuPreImpl implements ShortcutMenuPre {
    private ShortcutMenuAct mView;
    private HomeChannelModelImpl mModel;
    private HomeModelImpl mNewsModel;

    public ShortcutMenuPreImpl(ShortcutMenuAct activity) {
        this.mView = activity;
        this.mModel = new HomeChannelModelImpl();
        this.mNewsModel = new HomeModelImpl();
    }

    @Override
    public void lodeChannelsRequest(int spanSize) {
        Observable<List<MultipleItem>> observable = mNewsModel.requestHomeChannels(spanSize);
        observable.observeOn(AndroidSchedulers.mainThread())
                .subscribe(new Observer<List<MultipleItem>>() {
                    @Override
                    public void onSubscribe(Disposable d) {
                        RxDisposeManager.get().add("newsMinechannel", d);
                    }

                    @Override
                    public void onNext(List<MultipleItem> tables) {
                        mView.currentFunctionList(tables);
                    }

                    @Override
                    public void onError(Throwable e) {
                    }

                    @Override
                    public void onComplete() {

                    }
                });
        Observable<List<MultipleItem>> moreObservable = mModel.lodeMoreHomeChannels(spanSize);
        moreObservable.subscribe(new Observer<List<MultipleItem>>() {
            @Override
            public void onSubscribe(Disposable d) {
                RxDisposeManager.get().add("newsMorechannel", d);
            }

            @Override
            public void onNext(List<MultipleItem> tables) {
                mView.moreFunctionList(tables);
            }

            @Override
            public void onError(Throwable e) {
            }

            @Override
            public void onComplete() {

            }
        });
    }

    @Override
    public void onItemSwap(final List<MultipleItem> newsChannelTableList) {
        mModel.swapDb(newsChannelTableList).subscribe(new Observer<String>() {
            @Override
            public void onSubscribe(Disposable d) {
                EventBus.getDefault().post(new ShortcutMenuBean(newsChannelTableList));
            }

            @Override
            public void onNext(String s) {

            }

            @Override
            public void onError(Throwable e) {

            }

            @Override
            public void onComplete() {

            }
        });
    }

    @Override
    public void onItemAddOrRemove(final List<MultipleItem> mineChannelTableList, List<MultipleItem> moreChannelTableList) {
        mModel.updateDb(mineChannelTableList, moreChannelTableList).subscribe(new Observer<String>() {
            @Override
            public void onSubscribe(Disposable d) {

            }

            @Override
            public void onNext(String s) {
                //发送消息 通知首页更改快捷菜单信息
                EventBus.getDefault().post(new ShortcutMenuBean(mineChannelTableList));
            }

            @Override
            public void onError(Throwable e) {

            }

            @Override
            public void onComplete() {

            }
        });
    }
}
