package com.urovo.activity.tabMenu.home.net;

import com.urovo.activity.tabMenu.home.ent.HomeAdEntity;
import com.urovo.activity.tabMenu.home.ent.HomeCarouselEntity;
import com.urovo.activity.tabMenu.home.ent.HomeMenuOnlineBean;
import com.urovo.wugumofang.constants.ApiUrls;
import com.zsy.libcore.model.bean.RequestResult;

import java.util.List;
import java.util.Map;

import retrofit2.Call;
import retrofit2.http.POST;
import retrofit2.http.QueryMap;

/**
 * @author chenji
 * @date 18/1/12
 */
public interface IHomeNet {
    /**
     * 首页轮播图接口
     *
     * @param map userNo 员工号; type:状态，0首页 1更多
     * @return ...
     */
    //http://test.wgmf.com/app/information/getStoreTaskInfo
    @POST(ApiUrls.APP.STORE_TASK_INFO)
    Call<RequestResult<HomeCarouselEntity>> getHomeCarouselList(@QueryMap Map<String, String> map);


    /**
     * 首页菜单的各个板块列表
     *
     * @param map userNo 员工号; type:状态，0首页 1更多
     * @return 返回菜单列表
     */
    @POST(ApiUrls.APPSALER.MORE_PAGES)
    Call<HomeMenuOnlineBean> getHomeMenuList(@QueryMap Map<String, String> map);

    /**
     * 快捷菜单
     *
     * @param map ...
     * @return ...
     */
    @POST(ApiUrls.APPSALER.HOME_DRAG_MENU_PAGES)
    Call<RequestResult> getDragMenuList(@QueryMap Map<String, String> map);

    /**
     * 首页广告位
     *
     * @return ...
     */
    @POST(ApiUrls.APP.HOME_AD)
    Call<RequestResult<List<HomeAdEntity>>> getHomeAdList();
}
