package com.urovo.activity.tabMenu.home.pre;


import com.urovo.activity.tabMenu.home.ent.MultipleItem;
import com.urovo.activity.tabMenu.home.utils.RxDisposeManager;

import java.util.List;

import io.reactivex.Observable;
import io.reactivex.Observer;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.disposables.Disposable;

/**
 * @author chenji
 * @date 2017/12/11
 */

public class HomePresenterImpl implements HomePresenter {
    private HomeView mHomeView;
    private HomeModelImpl mHomeModel;

    public HomePresenterImpl(HomeView view) {
        this.mHomeView = view;
        this.mHomeModel = new HomeModelImpl();
    }

    @Override
    public void lodeMineChannelsRequest(int spanSize) {
        Observable<List<MultipleItem>> observable = mHomeModel.requestHomeChannels(spanSize);
        observable.observeOn(AndroidSchedulers.mainThread())
                .subscribe(new Observer<List<MultipleItem>>() {
                    @Override
                    public void onSubscribe(Disposable d) {
                        RxDisposeManager.get().add("Homechannel", d);
                    }

                    @Override
                    public void onNext(List<MultipleItem> tables) {
                        mHomeView.returnCurrentFunctionList(tables);
                    }

                    @Override
                    public void onError(Throwable e) {
                    }

                    @Override
                    public void onComplete() {

                    }
                });
    }

//    @Override
//    public void lodeMineChannelsRequest(List<List<HomeMenuOnlineBean.ResultInfoBean>> menuEntity, int spanSize) {
//        Observable<List<MultipleItem>> observable = mHomeModel.requestHomeChannels(menuEntity, spanSize);
//        observable.observeOn(AndroidSchedulers.mainThread())
//                .subscribe(new Observer<List<MultipleItem>>() {
//                    @Override
//                    public void onSubscribe(Disposable d) {
//                        RxDisposeManager.get().add("Homechannel", d);
//                    }
//
//                    @Override
//                    public void onNext(List<MultipleItem> tables) {
//                        mHomeView.returnCurrentFunctionList(tables);
//                    }
//
//                    @Override
//                    public void onError(Throwable e) {
//                    }
//
//                    @Override
//                    public void onComplete() {
//
//                    }
//                });
//    }

}
