package com.urovo.activity.tabMenu.home.pre;

import android.app.Activity;
import android.os.SystemClock;

import com.urovo.wgmf.db.dao.dao.Djxs001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djxs002DbOperate;
import com.urovo.wgmf.db.dao.entitys.OrderReqBean;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.utils.LoadingDialogUtil;
import com.wgmf.trade.presenter.SaveSuccessPre;
import com.wgmf.trade.view.SaveSuccessCon;
import com.zsy.libcore.common.android.log.SYLoger;

import java.util.List;

/**
 * @author chenji
 * @date 2018/6/26
 */
@SuppressWarnings("all")
public abstract class SubmitOrderPre {
    /**
     * 是否上传了的标志
     */
    private boolean isUpload;
    /**
     * 每次上传订单的数目统计（不论成功还是失败的订单）
     */
    private int uploadNum;
    /**
     * 数据库总的订单数目。
     */
    private int totalUploadNum;
    /**
     * 会员手机号
     */
    private String mobile;
    /**
     * 是否静默上传
     */
    private boolean isSilence = false;

    /**
     * 当前上传订单的活动
     */
    private Activity act;

    //用来给主页Tabmenu发送EventBut消息，通知它静默重新上传。
    public static class SubmitOrderEvent {

    }

    public SubmitOrderPre(Activity act, String mobile) {
        this.act = act;
        this.mobile = mobile;
    }

    public SubmitOrderPre(Activity act, String mobile,boolean isSilence) {
        this.act = act;
        this.mobile = mobile;
        this.isSilence = isSilence;
    }

    /**
     * 查询数据库未提交的订单并请求上传到后台
     */
    public void submitOrder(SaveSuccessCon.View saveView) {
        List<OrderReqBean> orderRequestBeans = Djxs001DbOperate.selectUnUploadOrder();
        SaveSuccessPre saveSuccessPre = new SaveSuccessPre(saveView);
        //商品推荐 如果自动录单和手动录单都需要这个的话，就在这里请求。
//        saveSuccessPre.queryRecomProduct(mobile);
        isUpload = true;
        uploadNum = 0;
        totalUploadNum = orderRequestBeans.size();
        for (OrderReqBean orderRequestBeanTemp : orderRequestBeans) {
            List<OrderReqBean.ProductDetailsBean> productDetailsBeans = Djxs002DbOperate.selectOrderDetail(orderRequestBeanTemp.getBill());
            orderRequestBeanTemp.setProductDetails(productDetailsBeans);
            saveSuccessPre.submitOrder(orderRequestBeanTemp);
        }
        if (!isSilence){//只有不是静默上传，才显示进度弹窗
            LoadingDialogUtil.showProgress(act, "本地保存成功，正在拼命上传中...");
        }
    }

    public void onSubmitFailure(long ms) {
        SYLoger.print("在线提交订单失败。。。");
        if (isUpload) {
            //在线异常的时候才延迟2秒，因为在线报服务器状态异常的情况，跳转太快了。
            if (NetHelper.IsHaveInternet(act)) {
                SystemClock.sleep(ms);
            }
            LoadingDialogUtil.dismiss();
        }
        uploadNum++;
        isUpload = false;
    }

    public void onSubmitFailure() {
        onSubmitFailure(0);
    }

    public void onSubmitSuccess() {
        SYLoger.print("在线提交订单成功。。。");
        uploadNum++;
        if (isUpload && uploadNum == totalUploadNum) {
            //需要统计下所有未提交的订单数目。
            LoadingDialogUtil.dismiss();
            //跳转页面
            skipToOrderResult();
        }
    }

    /**
     * 请求成功后跳转到结果页面
     * 默认是扫描条形码（自动录单）跳转的结果页面，手动录单跳转的结果页面需要重写该方法。
     */
    public abstract void skipToOrderResult();
}
