package com.urovo.activity.tabMenu.home.task;

import android.os.AsyncTask;
import android.view.View;

import java.lang.ref.WeakReference;

/**
 * @author chenji
 * @date 2018/6/20
 */
public class OrderTask extends AsyncTask<Void, Void, Boolean> {
    private WeakReference<View> weakReference;
    private OrderResultListener resultListener;

    public OrderTask(View button, OrderResultListener resultListener) {
        this.weakReference = new WeakReference<>(button);
        this.resultListener = resultListener;
    }

    @Override
    protected void onPreExecute() {
        super.onPreExecute();
        if (null != weakReference.get()) {
            weakReference.get().setEnabled(false);
        }
    }

    @Override
    protected Boolean doInBackground(Void... params) {
        //上传的信息组装订单到模型中
        return resultListener.buildOrderForm();
    }

    @Override
    protected void onPostExecute(Boolean isSuccess) {
        super.onPostExecute(isSuccess);
        if (null != weakReference.get()) {
            weakReference.get().setEnabled(true);
            if (isSuccess) {
//                ToastMsg.showToastMsg(BaseAppManager.appContext(), "当前订单本地保存成功!");
                resultListener.onlineUploadOrders();
            }
        }
    }

    public interface OrderResultListener {
        /**
         * 组装订单
         *
         * @return ...
         */
        boolean buildOrderForm();

        /**
         * 在线上传订单
         */
        void onlineUploadOrders();
    }
}
