package com.urovo.activity.tabMenu.home.view;

import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import androidx.annotation.LayoutRes;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import android.view.ViewGroup;
import android.view.WindowManager;

import com.urovo.wugumofang.R;

/**
 * 自定义全屏dialog
 *
 * @author chenji
 * @date 2018/1/22
 */

public class FullScreenDialog extends Dialog {
    /**
     * 默认支持全屏弹窗样式,支持修改
     */
    public FullScreenDialog(@NonNull Context context) {
        super(context, R.style.full_screen_dialog);
        setOwnerActivity((Activity) context);
        setContentView(R.layout.full_screen_dialog_layout);
    }

    public FullScreenDialog(@NonNull Context context, int themeResId, @LayoutRes int layoutResID) {
        super(context, themeResId);
        setContentView(layoutResID);
    }

    protected FullScreenDialog(@NonNull Context context, boolean cancelable, @Nullable OnCancelListener cancelListener) {
        super(context, cancelable, cancelListener);
    }

    /**
     * 重写show方法,可以定制不同位置显示的dialog
     */
    @Override
    public void show() {
        super.show();
        //设置宽度高度全屏，要设置在show的后面
        if (getWindow() != null) {
            WindowManager.LayoutParams layoutParams = getWindow().getAttributes();
//        layoutParams.gravity = Gravity.BOTTOM;
            layoutParams.width = ViewGroup.LayoutParams.MATCH_PARENT;
            layoutParams.height = ViewGroup.LayoutParams.MATCH_PARENT;
//            getWindow().getDecorView().setPadding(0, 0, 0, 0);
            getWindow().setAttributes(layoutParams);
        }
    }
}
