package com.urovo.activity.tabMenu.util.JPush;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;

import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.urovo.wugumofang.system.BaseAppManager;

import cn.jpush.android.api.JPushInterface;

/**
 * 极光推送的广播处理
 *
 * @author Sasuke
 * @date 2016/6/3
 */
public class JPushReceiver extends BroadcastReceiver {
    public static int number = 0;

    @Override
    public void onReceive(Context context, Intent intent) {
//        MyToast.show(context,"ブロードキャストが届いた", Toast.LENGTH_LONG);
//        new BasicDataDownloader(null,
//                SystemHelper.LoginOrganId,
//                new BasicDataDownloader.DatabaseOperate() {
//                    @Override
//                    public boolean dealBasicDataResult(@NotNull BasicDataRes res) {
//                        return Table_toposDbOperate.dealBasicDataResult(res);
//                    }
//                }).download();
        Bundle bundle = intent.getExtras();
        //据说bundle可能会为空，虽然不知道是什么情况下。
        if(bundle == null){
            return ;
        }
        String json = bundle.getString("cn.jpush.android.EXTRA", "");
        JsonObject jsonObject = new JsonObject();
        if (!TextUtils.isEmpty(json)) {
            jsonObject = new JsonParser().parse(json).getAsJsonObject();
        }

        for (String key : bundle.keySet()) {
            Object value = bundle.get(key);
            assert value != null;
            BaseAppManager.loger().info("[MyReceiver] 遍历bundle : " + String.format("%s --- %s (%s)", key, value.toString(), value.getClass().getName()));
        }
        BaseAppManager.loger().info("[MyReceiver] JSON值为 : " + bundle.getString("cn.jpush.android.EXTRA", ""));

        String msgTitle = bundle.getString("cn.jpush.android.NOTIFICATION_CONTENT_TITLE");
        String msgContent = bundle.getString("cn.jpush.android.ALERT");//后来改了，通知内容位置上的被用作文章标题了
        if (JPushInterface.ACTION_REGISTRATION_ID.equals(intent.getAction())) {
            String regId = bundle.getString(JPushInterface.EXTRA_REGISTRATION_ID);
            BaseAppManager.loger().info("[JPushReceiver] 接收Registration Id : " + regId);
            //send the Registration Id to your server...

        } else if (JPushInterface.ACTION_MESSAGE_RECEIVED.equals(intent.getAction())) {
            BaseAppManager.loger().info("[JPushReceiver] 接收到推送下来的自定义消息: " + bundle.getString(JPushInterface.EXTRA_MESSAGE));
        } else if (JPushInterface.ACTION_NOTIFICATION_RECEIVED.equals(intent.getAction())) {
            BaseAppManager.loger().info("[JPushReceiver] 接收到推送下来的通知");
            int notifactionId = bundle.getInt(JPushInterface.EXTRA_NOTIFICATION_ID);
            BaseAppManager.loger().info("[JPushReceiver] 接收到推送下来的通知的ID: " + notifactionId);

            new JPushCase(context,bundle).onReceived();//执行收到通知后的一系列操作

//            //自定义通知铃声
//            customRingStone(context, bundle);
//            //如果是type==9那就弹个窗提醒打卡
//            remindSignIn(context, jsonObject, msgTitle, msgContent);
            // 极光推送个人信息确认
//            makePersonInfoConfirmIntent(context, json);
        } else if (JPushInterface.ACTION_NOTIFICATION_OPENED.equals(intent.getAction())) {
            BaseAppManager.loger().info("[JPushReceiver] 用户点击打开了通知");
            new JPushCase(context,bundle).onClicked();//响应点击通知后的跳转

//            String json = bundle.getString("cn.jpush.android.EXTRA", "");
//            Intent i = new Intent();
//            makePersonInfoConfirmIntent(context, json);  // 极光推送个人信息确认
        } else if (JPushInterface.ACTION_RICHPUSH_CALLBACK.equals(intent.getAction())) {
            BaseAppManager.loger().info("[JPushReceiver] 用户收到到RICH PUSH CALLBACK: " + bundle.getString(JPushInterface.EXTRA_EXTRA));
            //在这里根据 JPushInterface.EXTRA_EXTRA 的内容处理代码，比如打开新的Activity， 打开一个网页等..

        } else if (JPushInterface.ACTION_CONNECTION_CHANGE.equals(intent.getAction())) {
            boolean connected = intent.getBooleanExtra(JPushInterface.EXTRA_CONNECTION_CHANGE, false);
            BaseAppManager.loger().info("[JPushReceiver]" + intent.getAction() + " connected state change to " + connected);
        } else {
            BaseAppManager.loger().info("[JPushReceiver] Unhandled intent - " + intent.getAction());
        }
    }

}
