package com.urovo.activity.tabMenu.view

import android.app.Activity
import android.app.AlertDialog
import android.content.DialogInterface
import android.os.Bundle
import android.widget.LinearLayout
import com.urovo.activity.tabMenu.home.view.FullScreenDialog
import com.urovo.wugumofang.R
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.data.PreferHelper
import java.io.Serializable

/**
 * @author Sasuke on 2018/1/17.
 * 用于弹全局Dialog
 */

class GlobalDialogBridgeAct : Activity() {
    companion object {
        //       const val INTENT_TYPE: String = "INTENT_TYPE"//传值时的key
        const val INTENT_EXTRA: String = "INTENT_EXTRA"

        const val TYPE_REMIND_SIGNIN = "9"//打卡提醒
    }

    open class EXTRA(var mType: String) : Serializable
    data class RemindExtra(var type: String, var msgTitle: String, var msgContent: String) : EXTRA(type)

    lateinit var extra: EXTRA
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        extra = intent.getSerializableExtra(INTENT_EXTRA) as EXTRA

        showRemindDialog(extra)
    }

    /**
     * 打卡提醒弹窗
     */
    fun showRemindDialog(extra: EXTRA) {
        when (extra.mType) {
            TYPE_REMIND_SIGNIN -> {
                val remind: RemindExtra = extra as RemindExtra
                AlertDialog.Builder(this)
                        .setCancelable(false)
                        .setTitle(remind.msgTitle)
                        .setMessage(remind.msgContent)
                        .setPositiveButton("确定", DialogInterface.OnClickListener { dialog, which -> finish() })
                        .create()
                        .show()
            }

            //全屏dialog
//            AppConstants.Home.FULL_SCREEN_DIALOG -> {
//                tipDialog()
//            }
        }
    }

    /**
     * 全面屏弹窗demo ,有需求的可以在这里直接改,直接顶在window最高层
     */
    private fun tipDialog() {
        val mRunCount = PreferHelper.getInstance().getInt(AppConstants.Home.FULL_SCREEN_DIALOG, 0)
        if (mRunCount == 0) {
            val fullScreenDialog = FullScreenDialog(
                    this,
                    R.style.full_screen_dialog,
                    R.layout.full_screen_dialog_layout
            )
            fullScreenDialog.show()
            val fullScreen = fullScreenDialog.findViewById(R.id.full_screen) as LinearLayout
            fullScreen.setOnClickListener {
                PreferHelper.getInstance().setInt(AppConstants.Home.FULL_SCREEN_DIALOG, 1)
                fullScreenDialog.dismiss()
            }
        }
    }
}
