package com.urovo.activity.tabMenu.web;


import com.urovo.activity.goodsmanager.model.AllotmentNotificationEntity;
import com.urovo.activity.goodsmanager.model.NotificationOrderGoodDiffEntity;
import com.urovo.activity.tabMenu.home.ent.HomePopWindowEntity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.zsy.libcore.model.bean.RequestResult;

import retrofit2.Call;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.Query;

/**
 * @author chenji
 * @date 17/04/23
 * 首页弹窗广告
 */
public interface NationalDayAdDataNet {

    @POST(ApiUrls.APP.NATIONAL_AD_IS_SHOW)
    Call<RequestResult<NationalAdRes>> getNationalDayData(
            @Query("storeId") String storeId, @Query("staffId") String staffId
    );

    /**
     * 广告埋点
     *
     * @param staffId   营养顾问Id
     * @param shopId    门店Id
     * @param themeType 主题类型（0:会员商品转发，1：商城喷雾销售攻略弹窗）
     * @param type      0:分享到朋友圈,1:发送给朋友,2:企业微信,3: 企业微信积分过期提醒埋点,
     *                  4:企业微信新客三响炮，5：企业微信点击发送视频；6：点击弹窗
     */
    @POST(ApiUrls.APPSALER.VIP_BURY_POINT)
    Call<RequestResult<Object>> vipBuryPoint(
            @Query("staffId") String staffId, @Query("shopId") String shopId,
            @Query("themeType") String themeType, @Query("type") int type
    );

    /**
     * 查询是否有未读的已处理意见与建议流程,返回true就弹窗
     *
     * @param staffId 营养顾问Id
     */
    @GET(ApiUrls.APPSALER.HAS_UN_READ_DATA)
    Call<RequestResult<Integer>> getHasUnReadData(@Query("staffId") String staffId);

    /**
     * 标记未读的已处理意见与建议流程数据为已读
     *
     * @param staffId 营养顾问Id
     * @param flag    0:未读，1：已读
     * @param type    0:意见与建议，1：到货误差
     */
    @POST(ApiUrls.APPSALER.UPDATE_UN_READ_DATA)
    Call<RequestResult<Object>> updateUnReadData(@Query("staffId") String staffId, @Query("flag") String flag, @Query("type") String type);

    /**
     * 首页弹窗查询
     *
     * @param staffId 营养顾问Id
     * @param shopId  门店Id
     */
    @GET(ApiUrls.APPSALER.POP_WINDOW_SHOW)
    Call<RequestResult<HomePopWindowEntity>> getPopWindowData(@Query("staffId") String staffId, @Query("shopId") String shopId);

    /**
     * post /storeAllot/notificationStoreAllot 调拨单弹窗
     */
    @POST(ApiUrls.APP.NOTIFICATION_STORE_ALLOT)
    Call<RequestResult<AllotmentNotificationEntity>> notificationStoreAllot(@Query("checkUserNo") String checkUserNo, @Query("storeNo") String storeNo);

    /**
     * post /apply/notificationOrderGoodDiff 门店订货与发货差异弹窗
     */
    @POST(ApiUrls.APP.NOTIFICATION_ORDER_GOOD_DIFF)
    Call<RequestResult<NotificationOrderGoodDiffEntity>> notificationOrderGoodDiff(@Query("storeNo") String storeNo);


}
