package com.urovo.activity.user;

import android.content.Context;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wgmf.entity.response.NianJiaResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.ui.ViewUtil;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 年假查询
 *
 * @author xiep on 2017/3/2 14:48
 */

public class AnnualVacationAct extends BaseActivity implements UserContract.view {
    @BindView(R.id.textViewInfo)
    TextView textViewInfo;
    @BindView(R.id.lv_user_content)
    ListView lvUserContent;

    private List<BaseModel> mBaseModel = new ArrayList<>();
    protected BaseAdapter mMyAdapter;
    Unbinder unbinder;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_user_info);
        unbinder = ButterKnife.bind(this);
        initTitle();
        UserPresenter selfCenterListPresenter = new UserPresenter(this);
        selfCenterListPresenter.start();
        ViewUtil.showProgress(this,"请稍等","正在查询...");
        selfCenterListPresenter.queryVactionDetail();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText("年假查询");
    }

    @Override
    public void init() {
//        super.init();
//        textViewInfo.setText(Calendar.getInstance().get(Calendar.YEAR) + "");
        textViewInfo.setVisibility(View.GONE);
        mMyAdapter = new MyAdapter(mBaseModel, this);
        lvUserContent.setAdapter(mMyAdapter);
//        requestConnectTask();
    }

    @Override
    public void refresh(String tag, BaseResponse response) {
//        super.refresh(tag, response);
        if (null != response) {
            NianJiaResponse res = (NianJiaResponse) response;
            if (res.msgCode == 0) {
                NianJiaResponse.ResultInfo entitys = res.getResultInfo();
                mBaseModel.clear();
                {
                    BaseModel cell = new BaseModel();
                    cell.mName = "年度";
                    cell.mData = entitys.getYear() + "年";
                    mBaseModel.add(cell);
                }
                {
                    BaseModel cell = new BaseModel();
                    cell.mName = "姓名";
                    cell.mData = entitys.getEmpName();
                    mBaseModel.add(cell);
                }
                {
                    BaseModel cell = new BaseModel();
                    cell.mName = "入职日期";
                    cell.mData = entitys.getEntryTime();
                    mBaseModel.add(cell);
                }
                {
                    BaseModel cell = new BaseModel();
                    cell.mName = "应休年假天数";
                    cell.mData = "" + entitys.getTotalVacationDays() + "天";
                    mBaseModel.add(cell);
                }
                {
                    BaseModel cell = new BaseModel();
                    cell.mName = "已休年假天数";
                    cell.mData = "" + entitys.getAlreadyVacationDays() + "天";
                    mBaseModel.add(cell);
                }
                {
                    BaseModel cell = new BaseModel();
                    cell.mName = "未休年假天数";
                    cell.mData = "" + entitys.getLastVacationDays() + "天" + entitys.getVacationRemark();
                    mBaseModel.add(cell);
                }
                {
                    BaseModel cell = new BaseModel();
                    cell.mName = "年假过期时间";
                    cell.mData = "" + entitys.getInvalidDate();
                    mBaseModel.add(cell);
                }
                mMyAdapter.notifyDataSetInvalidated();
            } else if (!TextUtils.isEmpty(res.msgInfo)) {
                showMsg(res.msgInfo);
            }
        }
    }

//    private void requestConnectTask() {
//        Map<String, String> params = new HashMap<>(2);
//        params.put("empno", SystemHelper.LoginUserId);
//        params.put("year", Calendar.getInstance().get(Calendar.YEAR) + "");
//        new BaseAppSalerServerTask("nianjia", NianJiaResponse.class, this, "正在查询...", true, "/vactiondetail/querybyempno" , params).execute("");
//    }

    @Override
    protected void onDestroy() {
        if (unbinder != null) {
            unbinder.unbind();
        }
        super.onDestroy();
    }

    @Override
    public void setPresenter(UserContract.presenter presenter) {

    }

    private class BaseModel {
        String mName;
        String mData;
    }

    private class MyAdapter extends MyBaseAdapter<BaseModel, ListView> {
        public MyAdapter(List<BaseModel> lists, Context context) {
            super(lists, context);
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {

            if (null == convertView) {
                convertView = getLayoutInflater().inflate(R.layout.listview_item_chaxun_kedan, parent, false);
            }
            TextView name = (TextView) convertView.findViewById(R.id.textView1);
            TextView data = (TextView) convertView.findViewById(R.id.textView2);

            BaseModel cell = mBaseModel.get(position);
            name.setText(cell.mName);
            data.setText(cell.mData);
            return convertView;
        }
    }
}
