package com.urovo.activity.user;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.response.BaseResponse;

import androidx.fragment.app.Fragment;

/**
 * 作者：xiep on 2017/3/3 10:04
 * 邮箱：2975837870@qq.com
 */

public abstract class BackHandledFragment extends Fragment implements UserContract.view {
    protected static final String TAG = "BackHandledFragment";

    protected UserPresenter selfCenterListPresenter;

    protected BackHandledInterface mBackHandledInterface;

    protected void showMsg(String msg) {
        ((BaseActivity) getActivity()).showMsg(msg);
    }

    @Override
    public abstract void init();

    @Override
    public abstract void refresh(String tag, BaseResponse response);

    @Override
    public void setPresenter(UserContract.presenter presenter) {
        selfCenterListPresenter = (UserPresenter) presenter;
    }

    /**
     * 所有继承BackHandledFragment的子类都将在这个方法中实现物理Back键按下后的逻辑
     */
    protected abstract boolean onBackPressed();

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (!(getActivity() instanceof BackHandledInterface)) {
            throw new ClassCastException(
                    "Hosting Activity must implement BackHandledInterface");
        } else {
            this.mBackHandledInterface = (BackHandledInterface) getActivity();
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.activity_user, container, false);
        selfCenterListPresenter = new UserPresenter(this);
        selfCenterListPresenter.start();
        view.setClickable(true);// 防止点击穿透，底层的fragment响应上层点击触摸事件
        return view;
    }

    @Override
    public void onStart() {
        super.onStart();
        // 告诉FragmentActivity，当前Fragment在栈顶
        mBackHandledInterface.setSelectedFragment(this);
    }


    @Override
    public void onDestroyView() {
        if (selfCenterListPresenter != null) {
            selfCenterListPresenter.onDestroy();
        }
        super.onDestroyView();
    }
}
