package com.urovo.activity.user;

import android.content.Context;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.squareup.picasso.Picasso;
import com.urovo.wgmf.AsyncTask.QueryWenTiSerchTask;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wgmf.db.dao.entitys.ChangJianWenTiEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.PrefTool;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.Prefs;
import com.wgmf.trade.GlobalApp;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * @author ...
 */
public class SearchWenTiAct extends BaseActivity implements OnClickListener, OnItemClickListener {
    @BindView(R.id.bt_search)
    Button btSearch;
    @BindView(R.id.et_search_number)
    EditText etSearchKey;
    String[] newArrays;
    @BindView(R.id.lv_search_history)
    ListView lvSearchHistory;
    @BindView(R.id.lv_search_result)
    ListView lvSearchResult;
//    @BindView(R.id.bt_back)
    ImageButton btBack;
    private ArrayAdapter<String> arrAdapter;
    private MyAdapter retAdapter;
    //    private BitmapUtils bitmapUtils;
    private List<BaseModel> mBaseModel = new ArrayList<>();
    Unbinder unbinder;

    @Override
    protected String getName() {
        return "请输入关键字";
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_user_search);
        unbinder = ButterKnife.bind(this);
//        etSearchKey = (EditText) findViewById(R.id.et_search_number);
        etSearchKey.setSelection(etSearchKey.getText().length());
//        btSearch = (Button) findViewById(R.id.bt_search);
        btBack = (ImageButton) findViewById(R.id.bt_back);
//        lvSearchHistory = (ListView) findViewById(R.id.lv_search_history);
//        lvSearchResult = (ListView) findViewById(R.id.lv_search_result);
        lvSearchHistory.setVisibility(View.VISIBLE);
        lvSearchResult.setVisibility(View.GONE);
        btSearch.setOnClickListener(this);
        btBack.setOnClickListener(this);

        String history = PrefTool.getStringPerferences(this, Prefs.SEARCH_WENTI_HISTORY, "");
        if (!"".equals(history)) {
            // 用逗号分割内容返回数组
            String[] historyArr = history.split(",");
            newArrays = new String[20];
            // 保留前20条数据
            if (historyArr.length > 20) {
                // 实现数组之间的复制
                System.arraycopy(historyArr, 0, newArrays, 0, 20);
            } else {
                newArrays = historyArr;
            }
        } else {
            newArrays = new String[0];
        }

        View v = View.inflate(this, R.layout.history_foot_view, null);
        lvSearchHistory.addFooterView(v);
        TextView tv = (TextView) v.findViewById(R.id.texthistory);
        if (!"".equals(history)) {
            tv.setText("清除历史记录");
        } else {
            tv.setText("无历史记录");
        }

        arrAdapter = new ArrayAdapter<String>(this, R.layout.simple_dropdown_item_1line, newArrays);
        retAdapter = new MyAdapter(mBaseModel, this);
        // 设置适配器
        lvSearchHistory.setAdapter(arrAdapter);

        v.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                PrefTool.deleteSPByName(SearchWenTiAct.this, Prefs.SEARCH_WENTI_HISTORY);
                TextView tv = (TextView) v.findViewById(R.id.texthistory);
                showMsg("清除成功");
                tv.setText("无历史记录");
                newArrays = new String[0];
                arrAdapter = new ArrayAdapter<>(SearchWenTiAct.this, R.layout.simple_dropdown_item_1line, newArrays);
                // 设置适配器
                lvSearchHistory.setAdapter(arrAdapter);
            }
        });

        historyLvSetData();

        etSearchKey.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (newArrays != null) {
                    String str = etSearchKey.getText().toString().trim();
                    List<String> alist = new ArrayList<String>();
                    String[] ne2 = new String[20];
                    ne2 = newArrays;
                    for (String newArray : newArrays) {
                        if (newArray.startsWith(str)) {
                            alist.add(newArray);
                        }
                    }
                    String results[] = new String[alist.size()];
                    newArrays = alist.toArray(results);
                    updateListView();
                    newArrays = ne2;
                }
            }
        });
    }

    private void historyLvSetData() {
        lvSearchHistory.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                TextView tv = (TextView) view.findViewById(R.id.text1);
                String key;
                try {
                    key = tv.getText().toString();
                    etSearchKey.setText(key);
                    etSearchKey.setSelection(etSearchKey.getText().length());
                    lvSearchResult.setAdapter(retAdapter);
                    lvSearchResult.setOnItemClickListener(SearchWenTiAct.this);
                    searchKey(key);
                } catch (Exception e) {
                    GlobalApp.loger.info(e);
                }
            }
        });
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if (null != response) {
            ChangJianWenTiEntity changJianWenTiEntity = (ChangJianWenTiEntity) response;
            List<ChangJianWenTiEntity.ChangJianWenTiReturnList> entitys = changJianWenTiEntity.resultList;
            mBaseModel.clear();
            if (null != entitys && entitys.size() > 0) {
                lvSearchResult.setVisibility(View.VISIBLE);
                lvSearchHistory.setVisibility(View.GONE);
                for (int j = 0; j < entitys.size(); j++) {
                    BaseModel cell = new BaseModel();
                    cell.questionId = entitys.get(j).id;
                    cell.questionTitle = entitys.get(j).title;
                    cell.questionContent = entitys.get(j).content;
                    cell.questionReleaseTime = entitys.get(j).releaseTime;
                    cell.questionProblemId = entitys.get(j).problemId;
                    cell.questionImagePath = entitys.get(j).imagePath;
                    mBaseModel.add(cell);
                }
            } else {
                showMsg("抱歉，未找到结果");
                return;
            }
        }
        retAdapter.notifyDataSetChanged();
    }

    private class BaseModel {
        String questionId;
        String questionTitle;
        String questionContent;
        String questionReleaseTime;
        String questionProblemId;
        String questionImagePath;
    }

    class ViewHolder {
        TextView tvQuestionTitle;
        TextView tvQuestionContent;
        ImageView ivQuestionImagePath;
        ImageView ivQuestionImagePathGo;
    }

    private class MyAdapter extends MyBaseAdapter<BaseModel, ListView> {
        private int mLastPosition = -1;

        public MyAdapter(List<BaseModel> lists, Context context) {
            super(lists, context);
//            bitmapUtils = new BitmapUtils(context);
            /**
             * 按照问题录入的时间排序，先录的显示在后面
             */
            Collections.sort(lists, new Comparator<BaseModel>() {

                @Override
                public int compare(BaseModel lhs, BaseModel rhs) {

                    if (StringUtils.toLong(lhs.questionReleaseTime) > StringUtils.toLong(rhs.questionReleaseTime)) {
                        return -1;
                    } else if (lhs.questionReleaseTime.equals(rhs.questionReleaseTime)) {
                        return 0;
                    } else {
                        return 1;
                    }
                }
            });
        }

        @Override
        public View getView(final int position, View convertView, ViewGroup parent) {
            final ViewHolder viewHolder;
            if (convertView == null) {
                convertView = LayoutInflater.from(context).inflate(R.layout.listview_user_wenti_item, null);
                viewHolder = new ViewHolder();
                viewHolder.tvQuestionTitle = (TextView) convertView.findViewById(R.id.textViewTitle);
                viewHolder.tvQuestionContent = (TextView) convertView.findViewById(R.id.textViewContent);
                viewHolder.ivQuestionImagePath = (ImageView) convertView.findViewById(R.id.imageViewContent);
                viewHolder.ivQuestionImagePathGo = (ImageView) convertView.findViewById(R.id.imageViewButton);
                convertView.setTag(viewHolder);
            } else {
                viewHolder = (ViewHolder) convertView.getTag();
            }
            final BaseModel cell = mBaseModel.get(position);
            viewHolder.tvQuestionTitle.setText(cell.questionTitle);
            viewHolder.tvQuestionContent.setText(cell.questionContent);
            if (position == mLastPosition) {
                if (null != cell.questionImagePath) {
                    viewHolder.ivQuestionImagePath.setImageResource(R.drawable.wenti_default_img);
                    viewHolder.ivQuestionImagePath.setVisibility(View.VISIBLE);
                    Picasso.with(context).load(cell.questionImagePath).into(viewHolder.ivQuestionImagePath);
//                    bitmapUtils.display(viewHolder.ivQuestionImagePath, cell.questionImagePath);
                } else {
                    viewHolder.tvQuestionContent.setVisibility(View.VISIBLE);
                    viewHolder.ivQuestionImagePath.setVisibility(View.GONE);
                }
                viewHolder.ivQuestionImagePathGo.setImageResource(R.drawable.list_group_close);
            } else {
                viewHolder.ivQuestionImagePathGo.setImageResource(R.drawable.list_group_open);
                viewHolder.tvQuestionContent.setVisibility(View.GONE);
                viewHolder.ivQuestionImagePath.setVisibility(View.GONE);
            }
            return convertView;
        }

        void changeImageVisible(int position) {
            if (position != mLastPosition) {
                mLastPosition = position;
            } else {
                mLastPosition = -1;
            }
            notifyDataSetChanged();
        }
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        retAdapter.changeImageVisible(position);
    }

    private void updateListView() {
        arrAdapter = new ArrayAdapter<String>(this, R.layout.simple_dropdown_item_1line, newArrays);
        // 设置适配器
        lvSearchHistory.setAdapter(arrAdapter);
        lvSearchHistory.setVisibility(View.VISIBLE);
        lvSearchResult.setVisibility(View.GONE);
        historyLvSetData();
    }

    public void searchKey(String text) {
        if (TextUtils.isEmpty(text)) {
            showMsg("请输入关键词！");
            // toSearchQuestion(text);
        } else {
            String oldText = PrefTool.getStringPerferences(this, Prefs.SEARCH_WENTI_HISTORY, "");
            String[] historyArr = oldText.split(",");
            StringBuilder builder = new StringBuilder();
            builder.append(text).append(",");
            for (int i = 0; i < 19 && i < historyArr.length; i++) {
                if (!text.equals(historyArr[i])) {
                    builder.append(historyArr[i]).append(",");
                }
            }
            PrefTool.setStringsave(this, Prefs.SEARCH_WENTI_HISTORY, builder.toString());
            toSearchQuestion(text);
        }
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.bt_search:
                lvSearchResult.setAdapter(retAdapter);
                lvSearchResult.setOnItemClickListener(this);
                String searchtext = etSearchKey.getText().toString().trim();
                searchKey(searchtext);
                break;
            case R.id.bt_back:
                this.finish();
                break;
            default:
                break;
        }
    }

    //    /**
//     * @param 参数说明
//     * @return void 返回类型
//     * @throws
//     * @Title: toSearchQuestion
//     * @Description: 根据关键词搜索常见问题
//     */
    private void toSearchQuestion(String text) {
        etSearchKey.clearFocus();
        InputMethodManager imm = (InputMethodManager) SearchWenTiAct.this.getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.hideSoftInputFromWindow(etSearchKey.getWindowToken(), 0);

        Map<String, String> params = new HashMap<>(1);
        // 关键词
        params.put("key", text);
        new QueryWenTiSerchTask(this, "正在搜索...", true, params).execute("");

    }

    @Override
    protected void onDestroy() {
        if (unbinder != null) {
            unbinder.unbind();
        }
        super.onDestroy();
    }
}
