package com.urovo.activity.user.adapter

import android.graphics.Color
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.user.bean.YearAwardRes
import com.urovo.wugumofang.R
import com.wgmf.trade.GlobalApp.context
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2018/3/4.
 */
class YearAwardAdapter(var dataList: MutableList<YearAwardRes.resultInfoClass.resListData>?) : RecyclerView.Adapter<YearAwardAdapter.YearAwardHolder>() {

    override fun getItemCount(): Int {
        return (dataList?.size ?: 0) + 1//底下还要加一栏“合计”
    }

    override fun onBindViewHolder(holder: YearAwardHolder, pos: Int) {
        holder?.apply {
            decoration.visibility = View.VISIBLE//分隔线
            when (pos) {
                getItemCount() - 1 -> {//如果是最后一行“合计”
                    monthTv.text = ""
                    starLevelTv.apply {
                        text = "合计"
                        setTextColor(Color.BLACK)
                    }
                    bonusTv.apply {
                        text = dataList?.sumByDouble {
                            try {
                                it.bonus?.toDouble() ?: 0.0
                            }catch (e: Exception){
                                0.0
                            }
                        }.toString()
                        setTextColor(Color.RED)
                        paint.isFakeBoldText = true//加粗
                    }
                }
                else -> {//如果是普通数据行
                    arrayOf(monthTv, starLevelTv, bonusTv).forEach {
                        it.setTextColor(Color.BLACK)
                        when (it) {
                            monthTv -> it.text = dataList!![pos].month
                            starLevelTv -> it.text = dataList!![pos].starLevel
                            bonusTv -> it.text = dataList!![pos].bonus
                        }
                    }
                }
            }
        }

    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): YearAwardHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.year_award_item, parent, false)
        return YearAwardHolder(view)
    }

    class YearAwardHolder(view: View) : RecyclerView.ViewHolder(view) {
        var monthTv: TextView
        var starLevelTv: TextView
        var bonusTv: TextView
        var decoration: View

        init {
            decoration = view.find(R.id.year_award_decoration)
            monthTv = view.find(R.id.monthTv)
            starLevelTv = view.find(R.id.starLevelTv)
            bonusTv = view.find(R.id.bonusTv)
        }
    }
}

