package com.urovo.activity.user.presenter;

import android.os.Handler;

import com.urovo.wgmf.CommonController;
import com.urovo.wgmf.net.CommonNet;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.ui.ViewUtil;
import com.wgmf.trade.model.bean.CommonEntity;

import java.util.Map;

/**
 * @author chenji
 * @date 2017/11/6
 */

public class FlowSalesPersonCompletionPre implements CommonController.FlowSalesPersonPre {
    private CommonController.FlowSalesPersonView mFlowSalesPersonView;
    private CommonNet mCommonNet;
    private final Handler mHandler = new Handler();
    /**
     * 全局变量，用于判断是否是第一次执行
     */
    private int runCount = 0;
    private Runnable mRunnable = new Runnable() {
        @Override
        public void run() {
            // 第一次执行则关闭定时执行操作
            if (runCount == 1) {
                // 在此处添加执行的代码
                mHandler.removeCallbacks(this);
            }
            ViewUtil.dismissProgress();
            runCount++;
        }
    };

    public FlowSalesPersonCompletionPre(CommonController.FlowSalesPersonView flowSalesPersonView, CommonNet commonNet) {
        this.mFlowSalesPersonView = flowSalesPersonView;
        this.mCommonNet = commonNet;
    }

    @Override
    public void onStart2requestData(Map<String, String> params) {
        mCommonNet.onStart2requestData(this, params);
    }

    @Override
    public void onResponseSuccess(String tag, CommonEntity resultInfo) {
        mFlowSalesPersonView.onResponseSuccess(tag, resultInfo);
    }

    @Override
    public void onFailure(String failInfo) {
        mFlowSalesPersonView.onFailure(failInfo);
    }

    @Override
    public void postDelayed(long delayTime) {
        mHandler.postDelayed(mRunnable, delayTime);
    }

    /**
     * 只可查询本月和上个月的数据的期限判断
     *
     * @param futureMonth ...将要选择的月份
     * @param referMonth  ... 参照比较的月份
     */
    @Override
    public int timeLimit(String futureMonth, String referMonth) {
        final int result = DateUtil.compareSize(futureMonth, referMonth);
        //超过当前月或者小于上一个月
        if (result == 1) {
            mFlowSalesPersonView.showToast("只可查询本月和上个月的数据！");
        }
        //等于当前月
        else if (result == 0) {
            mFlowSalesPersonView.currentMonthSelected(futureMonth);
        }
        //等于上个月
        else if (result == -1) {
            mFlowSalesPersonView.lastMonthSelected(futureMonth);
        } else {
            mFlowSalesPersonView.showToast("月份未知错误！");
        }
        return result;
    }
}
