package com.urovo.activity.user.presenter

import com.urovo.activity.user.bean.YearAwardRes
import com.urovo.wgmf.CommonController
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import okhttp3.Request

/**
 * @author Sasuke on 2018/3/2.
 * 年终奖查询Pre
 */
class YearAwardPre(val mView: CommonController.YearAwardView) : CommonController.YearAwardPre {
   var dataList: MutableList<YearAwardRes.resultInfoClass.resListData> = mutableListOf()
    var copywriter: String? = ""

    override fun query(year: String?, userNo: String?) {
        mView.showLoading()
        OkHttpDominator.getAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.QUERY_YEAR_BONUS,
                mapOf("year" to year, "userNo" to userNo),
                object : OkHttpDominator.ResultCallback<YearAwardRes>() {
                    override fun onError(request: Request?, e: Exception?) {
                        mView.showMsg(e.toString())
                        mView.showNetError()
                    }

                    override fun onResponse(res: YearAwardRes?) {
                        res?.let {
                            copywriter = it.resultInfo?.copywriter
                            if(it.resultInfo == null || it.resultInfo.list == null || it.resultInfo.list.size == 0){
                                mView.showNoData()
                                return
                            }
                            dataList.apply {
                                clear();addAll(res.resultInfo?.list.sortedBy { it.month?.toInt() ?:-1 })
                            }
                            mView.refreshData()
                            return
                        }
                        mView.showNoData()
                    }
                })
    }

}