package com.urovo.activity.wechatqrcode.pre

import com.urovo.activity.tabMenu.home.ent.UserQrCodeRes
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.response.Base3Response
import okhttp3.Request

/**
 * @author Sasuke on 2020-4-17 0017.
 */
class WeChatQrcodePresenter(val mView: WeChatQrcodeContract.view): WeChatQrcodeContract.presenter {
    init {
        mView.setPresenter(this)
    }

    override fun start() {
        mView.init()

    }

    /**检查是否有上传过二维码*/
    fun queryIfHasUpload(userId: String,shopId: String){
        OkHttpDominator.postAsyn(NetParam.WEIXIN_SERVER + ApiUrls.WeiXinEnterprise.GET_USER_QR_CODE,
                mapOf("userId" to userId, "shopId" to shopId), object : OkHttpDominator.ResultCallback<UserQrCodeRes?>() {
            override fun onError(request: Request?, e: java.lang.Exception?) {
                e?.printStackTrace()
                mView.showAlertMsg("获取二维码失败")
            }

            override fun onResponse(res: UserQrCodeRes?) {
                res?.let {
                    mView.showQrcode( it.data)
                }
            }
        })
    }

    /**上传个人微信二维码url*/
    fun updatePersonalWechatUrl(staffId: String, url: String){
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.UPDATE_PERSONAL_WECHAT_URL,
                mapOf("staffId" to staffId, "url" to url),object : OkHttpDominator.ResultCallback<Base3Response>(){
            override fun onError(request: Request?, e: Exception?) {
                e?.printStackTrace()
                mView.showAlertMsg(e?.message ?: "上传失败")
            }

            override fun onResponse(res: Base3Response?) {
                res?.let {
                    if (it.msgCode == 0){
                        mView.updateSuccessed(url)
                        return
                    }
                    mView.showAlertMsg(it.msgInfo)
                }
            }
        })
    }


}