package com.urovo.activity.wxfriendsres.ui

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import com.urovo.activity.photogallery.view.PhotoGalleryDominator
import com.urovo.wugumofang.R
import com.urovo.wugumofang.view.SquareImageView
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2020-4-24 0024.
 * 配图
 */
class WxFriendsResImgGridAdapter(val context: Context?, val picUrls: List<String>?) : RecyclerView.Adapter<WxFriendsResImgGridAdapter.ImgGridHolder>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ImgGridHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.wx_friends_res_grid_item, parent, false)
        return ImgGridHolder(view)
    }

    override fun getItemCount(): Int {
        return picUrls?.size ?: 0
    }

    override fun onBindViewHolder(holder: ImgGridHolder, position: Int) {
        val item = picUrls?.get(position)
        holder.apply {
            Glide.with(context)
                    .load(item ?: "")
                    .placeholder(R.drawable.pop_hone_qgwsr_default)
                    .into(iv)
            //点击预览大图（画廊模式）
            iv.setOnClickListener { PhotoGalleryDominator.showWithTrans(context, ArrayList(picUrls), iv, position) }
        }
    }

    class ImgGridHolder(view: View) : RecyclerView.ViewHolder(view) {
        val iv = view.find<SquareImageView>(R.id.gridImg)
    }
}