package com.urovo.activity.xunjian;

import android.app.DatePickerDialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.common.StoreSelectorActivity;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wgmf.db.dao.dao.Store001DbOprate;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wugumofang.R;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * @ClassName: XunJianShangBaoActivity
 * @Description: 巡检上报
 */
public class XunJianShangBaoActivity extends BaseActivity implements OnClickListener {
    private LinearLayout mLinearLayoutStore;
    private TextView mTextViewStore;

    private LinearLayout mLinearLayoutDate;
    private TextView mTextViewDate;

    private Button mButtonSubmit;

    private String mStoreId;
    private String mStoreName;
    private String mDate;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_xunjian);
        initTitle();

        mLinearLayoutStore = (LinearLayout) findViewById(R.id.linearLayoutStore);
        mTextViewStore = (TextView) findViewById(R.id.textViewStore);
        mLinearLayoutDate = (LinearLayout) findViewById(R.id.linearLayoutDate);
        mTextViewDate = (TextView) findViewById(R.id.textViewDate);
        mButtonSubmit = (Button) findViewById(R.id.buttonSubmit);

        mLinearLayoutStore.setOnClickListener(this);
        mLinearLayoutDate.setOnClickListener(this);
        mButtonSubmit.setOnClickListener(this);

        List<ShopEntity> listStore = Store001DbOprate.GetShopChoice();
        mStoreName = listStore.get(0).getShopName();
        mStoreId = listStore.get(0).getShopId();
        mTextViewStore.setText(mStoreName);

        SimpleDateFormat sdf = new SimpleDateFormat("MM月dd日");
        Date nowDate = new Date();
        mDate = new SimpleDateFormat("yyyy-MM-dd").format(nowDate);
        mTextViewDate.setText(sdf.format(nowDate));

    }

    @Override
    public void initTitle() {

        super.initTitle();
        titleTextView.setText("巡检上报");

    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);
        switch (resultCode) {
            case StoreSelectorActivity.RESULTCODE:
                ShopEntity shopEntity = (ShopEntity) data.getSerializableExtra(StoreSelectorActivity.STORE_TAG);
                if (shopEntity != null) {
                    mStoreName = shopEntity.getShopName();
                    mStoreId = shopEntity.getShopId();
                    if ("全部".equals(mStoreName)) {
                        List<ShopEntity> listStore = Store001DbOprate.GetShopChoice();
                        mStoreName = listStore.get(0).getShopName();
                        mStoreId = listStore.get(0).getShopId();

                    }
                    mTextViewStore.setText(mStoreName);
                }
                break;

            default:
                break;
        }
    }

    @Override
    public void onClick(View v) {

        if (v == mLinearLayoutStore) {
            Intent intent = new Intent(this, StoreSelectorActivity.class);
            intent.putExtra(StoreSelectorActivity.STORE_TAG, SystemHelper.LoginOrganName);
            startActivityForResult(intent, StoreSelectorActivity.RESULTCODE);
        } else if (v == mLinearLayoutDate) {
            Calendar c = Calendar.getInstance();
            new DatePickerDialog(XunJianShangBaoActivity.this, new DatePickerDialog.OnDateSetListener() {

                @Override
                public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                    mTextViewDate.setText(String.format("%02d月%02d日", monthOfYear + 1, dayOfMonth));
                    mDate = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
                }
            }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show();

        } else if (v == mButtonSubmit) {
            Intent intent = new Intent(this, MenDianGaiKuoActivity.class);
            intent.putExtra("shopName", mStoreName);
            intent.putExtra("shopId", mStoreId);
            intent.putExtra("date", mDate);
            startActivity(intent);
        }
    }
}
