package com.urovo.wgmf.AsyncTask;

import android.os.AsyncTask;
import android.widget.Toast;

import com.google.gson.Gson;
import com.google.gson.JsonParseException;
import com.urovo.activity.tabMenu.view.TabMenuActivity;
import com.urovo.wgmf.BaseFragmentActivity;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.CommonTools;

import java.util.List;


public class BaseActivityTask extends AsyncTask<String, String, String> {

    public BaseActivity context;
    public BaseFragmentActivity fcontext;
    public TabMenuActivity tcontext;
    public String dUrl = NetParam.XINXIBU_SERVER_DATA_IP;
    //public String UrlHuiYuan = NetParam.YINXIAOBU_SERVER + NetParam.YINXIAOBU_SERVER_PATH;
    public String UrlBaseDataService = NetParam.YINXIAOBU_SERVER + NetParam.BASE_DATA_SERVICE_PATH;
    public String UrlBaseMsgService = NetParam.YINXIAOBU_SERVER + NetParam.BASE_MSG_SERVICE_PATH;
    public String UrlBaseAppSalerService = NetParam.YINXIAOBU_SERVER + NetParam.BASE_APP_SALER_SERVICE_PATH;
    public String UrlBaseAppManageService = NetParam.YINXIAOBU_SERVER + NetParam.BASE_APP_MANAGE_SERVICE_PATH;
    public String UrlBaseAppService = NetParam.YINXIAOBU_SERVER + NetParam.BASE_APP_SERVICE_PATH;
    public String Url = NetParam.YINXIAOBU_SERVER + NetParam.XINXIBU_SERVER_PATH;//欧依
    // 销售产品接口
    public String UrlProducts = NetParam.SALEPRODUCTDETAIL;
    //产品月销售查询接口
    public String UrlMonthProduct = NetParam.MONTHSALEPRODUCTDETAIL;
    // 销售明细接口
    public String UrlSaleDetail = NetParam.SALEDETAIL;
    //销售明细接口 - 新版！！！！！
    public String UrlNewSaleDetail = NetParam.NEW_SALEDETAIL;
    // 微会员接口
    public String UrlMyWeiVIP = NetParam.SALEMYWEIVIP;
    // 客单数查询接口
    public String UrlKeDan = NetParam.SALEKEDAN;
    // 会员销售占比
    public String UrlMemberPercent = NetParam.SALEMEMBERPERCENT;
    // 三个月会员消费
    public String UrlMemberBack = NetParam.MEMBERBACK;
    // 会员销售明细接口
    public String UrlMemberSaleDetail = NetParam.MEMBERSALEDETAIL;
    // 月销量查询接口
    public String UrlMonthSales = NetParam.MONTHSALES;
    // App升级版本接口
    public String UrlAppUpdata = NetParam.APPUPDATA;
    //App白名单灰度版本升级接口
    public String UrlAppWhiteListUpdate = NetParam.APPUPDATA_GRAY;
    //App响应码信息
    public String UrlAppRetCodeInfo=NetParam.APP_RET_CODE_INFO;
    // 通知查询接口
    public String UrlMsgQuery = NetParam.MSGQUERY;
    // 通知上传接口
    public String UrlMsgUpLoad = NetParam.MSGUPLOAD;
    // 日任务状态接口地址
    public String UrlDayTaskStatus = NetParam.FINDSTATUS;
    // 日任务详情列表接口地址
    public String UrlDayTaskList = NetParam.LISTSOMEDAY;
    // 日任务修改保存接口地址
    public String UrlDayTaskSave = NetParam.DAYTASKSAVE;
    // 标杆门店查询接口地址
    public String UrlGetMarkStore = NetParam.GETMARKSTORE;
    // 标杆门店修改保存接口地址
    public String UrlSetMarkStore = NetParam.SETMARKSTORE;
    // 常见问题接口地址
    public String UrlFindChangJianWenTi = NetParam.WENTIFIND;
    public String UrlSerchChangJianWenTi = NetParam.WENTISEACH;
    public String UrlSaveChangJianWenTiItem = NetParam.WENTIITEMSAVE;
    public List<String> tags;
    protected String message;
    protected boolean toShowProgressBar;
    /**
     * 网络请求时的错误消息
     */
    protected String errMsg;
    private boolean hasInternet;

    public BaseActivityTask(BaseActivity context, String message, boolean toShowProgressBar) {
        this.context = context;
        this.toShowProgressBar = toShowProgressBar;
        this.message = message;
        this.errMsg = null;
    }

    public BaseActivityTask(BaseFragmentActivity context, String message, boolean toShowProgressBar) {
        this.fcontext = context;
        this.toShowProgressBar = toShowProgressBar;
        this.message = message;
        this.errMsg = null;
    }

    public BaseActivityTask(TabMenuActivity context, String message, boolean toShowProgressBar) {
        this.tcontext = context;
        this.toShowProgressBar = toShowProgressBar;
        this.message = message;
        this.errMsg = null;
    }

    public BaseActivityTask(BaseActivity context, String message, boolean toShowProgressBar, List<String> tags) {
        this.context = context;
        this.toShowProgressBar = toShowProgressBar;
        this.message = message;
        this.tags = tags;
        this.errMsg = null;
    }

    public BaseActivityTask(BaseFragmentActivity context, String message, boolean toShowProgressBar, List<String> tags) {
        this.fcontext = context;
        this.toShowProgressBar = toShowProgressBar;
        this.message = message;
        this.tags = tags;
        this.errMsg = null;
    }

    /**
     * 后台执行任务
     */
    @Override
    protected String doInBackground(String... params) {
        if (context != null) {
            hasInternet = NetHelper.IsHaveInternet(context);
        }
        if (fcontext != null) {
            hasInternet = NetHelper.IsHaveInternet(fcontext);
        }
        if (tcontext != null) {
            hasInternet = NetHelper.IsHaveInternet(tcontext);
        }

        if (hasInternet) {
            try {
                dealTask();
            } catch (Exception e) {
                BaseAppManager.loger().info("请求异常:" + e.toString());
            }
        }
        return null;
    }

    @Override
    protected void onPreExecute() {
        super.onPreExecute();

        if (toShowProgressBar) {
            if (context != null) {
                ViewUtil.showProgress(context, message, "请稍等.....", BaseActivityTask.this);
            }
            if (fcontext != null) {
                ViewUtil.showProgress(fcontext, message, "请稍等.....", BaseActivityTask.this);
            }
            if (tcontext != null) {
                ViewUtil.showProgress(tcontext, message, "请稍等.....", BaseActivityTask.this);
            }
        }
    }

    /**
     * 执行完后，doInBackground返回的结果，作为此方法的参数，在主ui上更新
     */
    @Override
    protected void onPostExecute(String result) {
        super.onPostExecute(result);
        try {
            if (toShowProgressBar) {
                CommonTools.INSTANCE.postDelayed(30000);
                ViewUtil.dismissProgress();//这个不能注释掉，如果请求很快返回了，需要马上把progressbar关掉
            }
            if (hasInternet) {
                afterTask();
            } else {
                showMessage("网络连接超时，请检查您的网络状态，稍后重试！");
                noNetAfter();
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("BaseActivityTask.onPostExecute" + e);
        }
    }

    protected void noNetAfter() {

    }

    public void dealTask() throws Exception {

    }

    public void afterTask() {

    }

    protected <T> T checkResult(String resultStr, Class<T> cls) {
        try {
            //BaseActivity
            if (context != null) {
                if (resultStr == null) {
                    errMsg = context.getString(R.string.ser_access_err);
                    return null;
                }
                Gson gson = new Gson();
                T t = gson.fromJson(resultStr, cls);
                if (t == null) {
                    errMsg = context.getString(R.string.ser_black_err);
                    return null;
                }
                errMsg = null;
                if (resultStr.endsWith("'MESSAGE':'暂时没有待下载的数据'}")) {
                    errMsg = context.getString(R.string.ser_black_err);
                    return null;
                }
                return t;
            }
            //FragmentActivity
            if (fcontext != null) {
                if (resultStr == null) {
                    errMsg = fcontext.getString(R.string.ser_access_err);
                    return null;
                }
                Gson gson = new Gson();
                T t = gson.fromJson(resultStr, cls);
                BaseResponse obj = (BaseResponse) t;
                if (obj == null) {
                    errMsg = fcontext.getString(R.string.ser_black_err);
                    return null;
                }
                errMsg = null;
                return t;
            }
            //TabmenuActivity
            if (tcontext != null) {
                if (resultStr == null) {
                    errMsg = tcontext.getString(R.string.ser_access_err);
                    return null;
                }
                Gson gson = new Gson();
                T t = gson.fromJson(resultStr, cls);
                BaseResponse obj = (BaseResponse) t;
                if (obj == null) {
                    errMsg = tcontext.getString(R.string.ser_black_err);
                    return null;
                }
                errMsg = null;
                return t;
            }
        } catch (JsonParseException e) {
            e.printStackTrace();
            errMsg = "JSON本地解析错误for " + cls.getSimpleName();
            BaseAppManager.loger().info("Exception JSON本地解析错误for " + cls.getSimpleName());
        }
        return null;
    }

    public void showMessage(String message) {

        if (context != null) {
            MyToast.show(context, message, Toast.LENGTH_LONG);
            //Toast.makeText(context, message, Toast.LENGTH_LONG).show();
            context.netError();
        }
        if (fcontext != null) {
            MyToast.show(fcontext, message, Toast.LENGTH_LONG);
            //Toast.makeText(fcontext, message, Toast.LENGTH_LONG).show();
            fcontext.netError();
        }
        if (tcontext != null) {
            MyToast.show(tcontext, message, Toast.LENGTH_LONG);
            //Toast.makeText(fcontext, message, Toast.LENGTH_LONG).show();
            tcontext.netError();
        }
    }
}
