package com.urovo.wgmf.AsyncTask

import com.urovo.wgmf.db.dao.dao.AppRetcodeDbOperate
import com.urovo.wgmf.entity.response.GetRespCodeInfoResponse
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.net.ResultTool
import com.urovo.wugumofang.system.BaseAppManager

/**
 * 获取接口状态信息
 * @author LW
 */
class GetRetCodeInfoTask(
    context: BaseActivity,
    message: String,
    toShowProgressBar: Boolean
) : BaseActivityTask(context, message, toShowProgressBar) {

    private var mResultStr: String = ""
    private var mResponse: GetRespCodeInfoResponse? = null

    override fun dealTask() {
        super.dealTask()
        mResultStr = ResultTool.access(UrlAppRetCodeInfo, mutableMapOf<String, String>())
        mResponse = checkResult(mResultStr, GetRespCodeInfoResponse::class.java)
    }

    override fun afterTask() {
        super.afterTask()
        if (errMsg != null) {
            showMessage(errMsg)
            BaseAppManager.loger().info(GetServerVersionTask.TAG + ":" + errMsg)
        } else {
            val resultInfo = mResponse?.resultInfo
            if (resultInfo != null && resultInfo.isNotEmpty()) {
                AppRetcodeDbOperate.insert(resultInfo)
            }
        }
    }
}