package com.urovo.wgmf.AsyncTask;

import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;

import com.urovo.wgmf.entity.response.GetServerVsionResponse;
import com.urovo.wgmf.tool.UpdateManager;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.JsonDominator;
import com.urovo.wugumofang.net.ResultTool;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.DeviceHelper;
import com.urovo.wugumofang.system.PdaMsgConfig;
import com.urovo.wugumofang.ui.DialogHelper;
import com.zsy.libcore.ui.act.SYActManager;

import java.util.Date;
import java.util.Map;

/**
 * 获取服务器版本号
 *
 * @author Administrator
 */
public class GetServerVersionTask extends BaseActivityTask {
    private String resultStr;
    public static final String TAG = "GetServerVersionTask";
    private GetServerVsionResponse obj;
    private boolean isTerminal = PdaMsgConfig.isTerminal(context);
    private Map<String, String> params;
    private String isUpgrade = "0";// 默认不升级
    private String VersionNo;// 版本信息
    private String VersionURL;// 版本升级地址
    private String VersionInfo;// 版本升级信息
    private String VersionInfoText;// 版本升级信息格式化

//    final private int URL_DEFAULT = 0;//默认的常规升级地址
//    final private int URL_WHITE_LIST = 1;//根据白名单指向的升级地址（灰度环境）

//    private int urlType = URL_DEFAULT;//升级地址类型

    public GetServerVersionTask(BaseActivity context, String message, boolean toShowProgressBar) {
        super(context, message, toShowProgressBar);
    }

    public GetServerVersionTask(BaseActivity context, String message, boolean toShowProgressBar, Map<String, String> params) {
        super(context, message, toShowProgressBar);
        this.params = params;
    }

//    public GetServerVersionTask(BaseActivity context, String message, boolean toShowProgressBar, Map<String, String> params) {
//        super(context, message, toShowProgressBar);
//        this.params = params;
//        this.urlType = urlType;
//    }

    @Override
    public void dealTask() throws Exception {
        super.dealTask();
//        String url = "";
//        url = (!params.isEmpty() && params.containsKey("userNo"))? UrlAppWhiteListUpdate : UrlAppUpdata;
        params.put("versionNo", DeviceHelper.getVersion(context));
        params.put("type", "android");

        resultStr = ResultTool.access(UrlAppWhiteListUpdate, params);
        obj = checkResult(resultStr, GetServerVsionResponse.class);
    }

    @Override
    public void afterTask() {

        super.afterTask();
        if (errMsg != null) {
            showMessage(errMsg);
            BaseAppManager.loger().info(TAG + ":" + errMsg);
        } else {

            GetServerVsionResponse.GetServerVsionReturnBean entity = obj.resultInfo;
            //===========test==========
            GetServerVsionResponse resMock = JsonDominator.loadFromSD("GetServerVsionResponse", GetServerVsionResponse.class);
            if (resMock != null) {
                //......do_anything
                entity = resMock.resultInfo;
            }
            //===========test==========
            if (null != entity) {
//				for (int i = 0; i < entitys.size(); i++) {
                String IsUpgrade = entity.getIsUpgrade() + "";
                VersionNo = entity.getVersionNo();
                VersionURL = entity.getUpgradeUrl();
                VersionInfo = entity.getInformation();

                if (entity.getIsUpgrade() != 1) {// 如果不升级，返回的是空！强行改成非0即1的情况！！
                    isUpgrade = "0";// 0 不升级 1升级
                } else {
                    isUpgrade = "1";
                }
//				}
                //把与服务器时间对比放在这里来做（原来是在获取地理位置后做的）
                //判断resMock== null，说明当不需要利用本地txt文件绕过验证的时候才验证时间
                Date syncDate = DateUtil.String2Date(entity.getSystemTime(), "yyyy-MM-dd HH:mm:ss");
                if (null != syncDate && resMock == null) {
                    Date now = new Date();
                    if (Math.abs(syncDate.getTime() - now.getTime()) > 60 * 60 * 1000) {//系统时间允许误差1小时
                        DialogHelper.AlertNotCanceable(context, "提示",
                                "手机时间设置与北京时间不符，请先重新设置手机时间后再登录！", null,
                                (dialog, which) -> SYActManager.getInstance().AppExit());
                        return;
                    }
                }

                if (isUpgrade.equals("1")) {

                    VersionInfoText = VersionInfo.replace("：", ":" + "\n\n").replace("；", ";" + "\n\n");

                    DialogHelper.Alert2NotCanceable(context, "必须更新为最新版本才能使用,是否更新？", VersionInfoText, null, new OnClickListener() {

                        @Override
                        public void onClick(DialogInterface dialog, int which) {

                            UpdateManager updateManager = new UpdateManager(VersionNo, VersionURL);
                            updateManager.checkAppUpdate(context);
                        }
                    }, new OnClickListener() {

                        @Override
                        public void onClick(DialogInterface dialog, int which) {

                            SYActManager.getInstance().AppExit();
                        }
                    });
                } else {
                    context.displayResult(TAG, obj);
                }
            }
        }
    }
}
