package com.urovo.wgmf.AsyncTask;

import com.urovo.wgmf.BaseFragmentActivity;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wgmf.entity.response.HuoDongResponse;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.net.ResultTool;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.ui.ViewUtil;

import java.util.HashMap;
import java.util.Map;

public class RequestZhuanXiangHuoDongTask extends BaseActivityTask {
	private String resultStr;
	public static final String TAG = "RequestZhuanXiangHuoDongTask";
	private String content;
	private boolean hasInternet;
	private HuoDongResponse response;

	public RequestZhuanXiangHuoDongTask(BaseActivity context, String message, boolean toShowProgressBar, String content) {
		super(context, message, toShowProgressBar);

		this.content = content;
	}

	public RequestZhuanXiangHuoDongTask(BaseFragmentActivity fcontext, String message, boolean toShowProgressBar, String content) {
		super(fcontext, message, toShowProgressBar);

		this.content = content;
	}

	@Override
	public void dealTask() throws Exception {

		super.dealTask();
		Map<String, String> params = new HashMap<String, String>();
		params.put("act_id", content);
		Url = UrlBaseAppService + NetParam.ZhuanXiangHuoDongDetail;
		// Url="http://192.168.5.57:8888/crmserver"+NetParam.ZhuanXiangHuoDongDetail;
		resultStr = ResultTool.access(Url, params);
		response = checkResult(resultStr, HuoDongResponse.class);

	}

	@Override
	public void afterTask() {

		super.afterTask();
		if(errMsg != null) {
			showMessage(errMsg);
			BaseAppManager.loger().info(TAG + ":" + errMsg);
		}
		if(resultStr == null) {
			showMessage("访问服务异常");
		}
		dealResult(resultStr);
	}

	private void dealResult(String result) {
		// if (errMsg != null) {
		// showMessage(errMsg);
		// BaseAppManager.loger().info(TAG+":"+errMsg);
		// } else {
		// context.displayResult(TAG, response);
		// }
		if(errMsg != null) {
			showMessage(errMsg);
			BaseAppManager.loger().info(TAG + ":" + errMsg);
		}

		if(context != null) {
			context.displayResult(TAG, response);
		}
		if(fcontext != null) {
			fcontext.displayResult(TAG, response);
		}
	}

	/**
	 * 后台执行任务
	 */
	@Override
	protected String doInBackground(String... params) {
		if(context != null) {
			hasInternet = NetHelper.IsHaveInternet(context);
		}
		if(fcontext != null) {
			hasInternet = NetHelper.IsHaveInternet(fcontext);
		}
		try {
			dealTask();
		}
		catch (Exception e) {

			BaseAppManager.loger().info("RequestZhuanXiangHuoDongTask.doInBackground" + e);

		}
		return null;
	}

	/**
	 * 执行完后，doInBackground返回的结果，作为此方法的参数，在主ui上跟新
	 */
	@Override
	protected void onPostExecute(String result) {
		try {
			if(toShowProgressBar)
				ViewUtil.dismissProgress();
			// if (hasInternet) {
			// afterTask();
			// } else {
			// showMessage("网络连接超时，请检查您的网络状态，稍后重试！");
			// afterTask();
			// }
			if(!hasInternet) {
				showMessage("网络连接超时，请检查您的网络状态，稍后重试！");
			}
			afterTask();

		}
		catch (Exception e) {

			BaseAppManager.loger().info("BaseActivityTask.onPostExecute" + e);
		}
	}
}
