package com.urovo.wgmf.AsyncTask.uploadcases

import android.text.TextUtils
import com.google.gson.Gson
import com.urovo.wgmf.db.dao.dao.CheckDetailDbOperate
import com.urovo.wgmf.db.dao.dao.Djpd001DbOperate
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.response.BaseSimpleResponse
import org.jetbrains.anko.doAsync
import java.util.HashMap

/**
 * @author Sasuke on 2020-02-14 0014.
 * 盘点数据上传Case
 */

class PandianUploadCase: UploadBaseCase() {
    override fun dowork() {
        doAsync {
            if (Djpd001DbOperate.GetUnUploadCount() > 0) {
                val list = Djpd001DbOperate.GetAllUnUpload()
                for (ent in list) {
                    val productDetails = CheckDetailDbOperate.GetBillDetail(ent.bill)
                    val bill = ent.bill
                    val param = HashMap<String, String>()
                    if (!TextUtils.isEmpty(ent.getRemark())) {
                        param["remark"] = ent.getRemark()
                    }
                    if (!TextUtils.isEmpty(ent.getUrl())) {
                        param["url"] = ent.getUrl()
                    }
                    param["detailList"] = Gson().toJson(productDetails)
                    val res = OkHttpDominator.postSynByType(
                            NetParam.YINXIAOBU_SERVER + ApiUrls.APP.SUBMIT_TRANSFER_CHECK,
                            OkHttpDominator.JSON,
                            BaseSimpleResponse::class.java, param) as BaseSimpleResponse
                    if (res != null && res.msgCode == 0) {
                        Djpd001DbOperate.UpdateBillState(bill)// 如果上传成功，更新单据上传状态字段
//                    resultStr = ""
                    } else {
                        resultStr = Gson().toJson(res)
//                    context.uploadFailed()
                    }
//                context.mUpLoadFlag = true
                }
                enqueDominator?.go()
                return@doAsync
            }
            enqueDominator?.go()
        }
    }
}