package com.urovo.wgmf.AsyncTask.uploadcases

import android.app.Activity
import com.urovo.wugumofang.data.DateUtil
import com.urovo.wugumofang.response.BaseResponse
import com.urovo.wugumofang.system.PdaMsgConfig
import com.urovo.wugumofang.utils.MyToast
import com.urovo.wugumofang.utils.TaskEnqueueDominator
import java.util.*

/**
 * @author HUANGSHI-PC on 2020-02-20 0020.
 * 上传队列跑完之后的操作
 */
class UploadAfterCase(val activity: Activity,
                      val refreshUI: (BaseResponse?)->Unit) : TaskEnqueueDominator.BaseCase() {
    var failCouter = 0//失败计数器

    val backupTaskList = mutableListOf<TaskEnqueueDominator.BaseCase>()

    init {
        //之所以要建一个backupList，因为enqueueDominator内部存的taskList会随着执行doWork逐个被干掉
        //为了在UploadAfterCase里还能调到前面的Case数据，就再建一个表来备份各case的引用
        enqueDominator?.let { backupTaskList.addAll(enqueDominator?.taskList!!) }
    }

    override fun dowork() {
        //提取各Case里的错误信息
        backupTaskList.run {
            forEach {
                if ((it as UploadBaseCase).resultStr.isNotBlank()){
                    activity?.runOnUiThread { MyToast.show(it.resultStr) }
                    failCouter++
                }
            }
        }

        activity.takeIf { !it.isFinishing }?.runOnUiThread {
//            if (backupTaskList.size -1 == 0 && ){
//                MyToast.show("没有需上传的数据")
//                refreshUI.invoke(BaseResponse().apply { sysCode == "-1" })//返回-1，则不取消打勾
//                return@runOnUiThread
//            }
            //存在需要上传的数据
            refreshUI.invoke( null)//返回0，则把打的勾全都消掉。
            //如果没有上传失败的
            if (failCouter == 0) {
                MyToast.show("上传操作完成！")
                val time3 = "上次：" + DateUtil.getDateTime2(Date())
                PdaMsgConfig.setupTime(time3, activity)
                if (!activity.isFinishing) activity.finish()
            }
        }


    }
}