package com.urovo.wgmf;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;

import com.umeng.analytics.MobclickAgent;
import com.urovo.activity.systemsetting.SttingMenu;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.PdaMsgConfig;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DialogHelper.DialogResult;
import com.urovo.wugumofang.ui.ViewUtil;
import com.zsy.libcore.ui.act.SYActManager;

import androidx.fragment.app.FragmentActivity;

public class BaseFragmentActivity extends FragmentActivity implements DialogResult {

    protected ImageButton back;
    protected TextView titleTextView;
    protected ImageButton settinButton;
    protected Button submit;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        SYActManager.getInstance().addActivity(this);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
    }

    public void displayResult(String tag, BaseResponse response) {
    }

    public void initTitle() {
        getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title);
        back = (ImageButton) findViewById(R.id.back);
        titleTextView = (TextView) findViewById(R.id.text_title);
        submit = (Button) findViewById(R.id.confirm);
        back.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                back();
            }
        });
        settinButton = (ImageButton) findViewById(R.id.settinButton);
    }

    public void showSettinVButton() {
        submit.setVisibility(View.GONE);
        settinButton.setVisibility(View.VISIBLE);
        settinButton.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {

                startActivity(new Intent(BaseFragmentActivity.this, SttingMenu.class));
            }
        });

    }

    public void focus(View view) {
        view.setFocusable(true);
        view.setFocusableInTouchMode(true);
        view.requestFocus();
    }

    protected String getName() {
        return "none";
    }

    private String getPageName() {
        if (null != titleTextView)
            return titleTextView.getText().toString();
        else
            return getName();
    }

    @Override
    protected void onResume() {
        super.onResume();
        initPdaConfig();
        MobclickAgent.onPageStart(getPageName());
        MobclickAgent.onResume(this);
    }

    @Override
    protected void onPause() {

        super.onPause();
        MobclickAgent.onPageEnd(getPageName());
        MobclickAgent.onPause(this);
    }

    @Override
    protected void onDestroy() {
        SYActManager.getInstance().finishActivity(this);
        ViewUtil.dismissProgress();
        super.onDestroy();
    }

    private void initPdaConfig() {
        SystemHelper.LoginOrganId = PdaMsgConfig.getLoginOrgID(BaseFragmentActivity.this);
        SystemHelper.IsAdmin = PdaMsgConfig.getIsAdmin(BaseFragmentActivity.this);
        // if (TextUtils.equals(PdaMsgConfig.getIsAdmin(BaseActivity.this),
        // "false")) {
        // SystemHelper.IsAdmin = false;
        //
        // } else {
        // SystemHelper.IsAdmin = true;
        // }
    }

    protected void back() {
        this.finish();
    }

    /**
     * Toast提示
     */
    public void showMsg(String msg) {
//        MyToast.show(BaseFragmentActivity.this, msg, 400);
        Toast.makeText(BaseFragmentActivity.this, msg, Toast.LENGTH_SHORT).show();
    }

    @Override
    public void onDialogResult(int tag) {
    }

    public void netError() {

    }
}
