package com.urovo.wgmf;

import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.google.gson.Gson;
import com.scwang.smartrefresh.layout.SmartRefreshLayout;
import com.scwang.smartrefresh.layout.api.RefreshLayout;
import com.scwang.smartrefresh.layout.listener.OnRefreshListener;
import com.urovo.activity.betasuggestion.view.BetaSuggestionAct;
import com.urovo.activity.nativemanager.UpAndDownDataUp;
import com.urovo.activity.nativemanager.UpEndBroadcast;
import com.urovo.activity.nativemanager.UpEndNotify;
import com.urovo.activity.systemsetting.SttingMenu;
import com.urovo.wgmf.db.dao.bill.DalCommon;
import com.urovo.wgmf.db.dao.dao.PrivilegeDbOperate;
import com.urovo.wgmf.more.ada.MoreItemQuickAdapter;
import com.urovo.wgmf.more.ent.MoreOnlineBean;
import com.urovo.wgmf.more.ent.MultipleItem;
import com.urovo.wgmf.more.pre.MoreIndexPre;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.base.BasePresenter;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.EnvironmentHelper;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.system.ToActivity;
import com.urovo.wugumofang.utils.CommonTools;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra;
import com.wgmf.trade.utils.AssetsUtil;
import com.zsy.libcore.common.android.log.SYLoger;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

import static com.urovo.wugumofang.ui.AnimeUtil.vibrate;


/**
 * 更多功能
 *
 * @author chenji
 * <p>
 * ps: 1.item动态的添加删除,每个item的positon的变化最新的位置如何确定？
 * 通过集合长度+固定副标题的数量等组合算出当前需要插入/删除item的位置
 */
public class MoreIndexAct extends BaseActivity implements UpEndNotify, com.urovo.wugumofang.net.CommonController.BaseView<List<List<MoreOnlineBean.ResultInfoBean>>> {
    @BindView(R.id.more_index_rv)
    RecyclerView moreIndexRv;
    //对beta版的建议反馈入口
    @BindView(R.id.beta_suggestion_entry)
    TextView betaSuggestion;
    @BindView(R.id.more_not_upload_notice)
    TextView moreUnUploadNotice;
//    @BindView(R.id.empty_action_bar)
//    RelativeLayout mEmptyActionBar;

    //下拉刷新
    @BindView(R.id.swipe_refresh)
    SmartRefreshLayout mSwipeRefreshLayout;
    @BindView(R.id.empty_view)
    TextView mEmptyViewTv;
    @BindView(R.id.empty_root)
    LinearLayout mEmptyRoot;

    private MoreItemQuickAdapter moreItemAdapter;

    /**
     * 货品管理的集合
     */
    private List<MoreOnlineBean.ResultInfoBean> mGmiBean;
    /**
     * 个人中心的集合
     */
    private List<MoreOnlineBean.ResultInfoBean> mPciBean;
    /**
     * 货品管理子菜单的固定长度
     */
    private final int mFixedLength = 8;
    /**
     * 列表中插入的数据需要计算长度时,上面的标题栏数量+上自己的总和 ,每次新增一个item(如补空白条)都需要看看是否需要+1
     * <p>
     * 个人中心标题行 + 空白行 + 货品管理标题行
     */
    private final int mSubTitleCount = 3;

    private boolean isSeeMoreFlag;
    /**
     * 页面构成所有的控件的集合
     */
    private List<MultipleItem> mTotalList = new ArrayList<>();

    private MoreIndexPre moreIndexPre;
    private UpEndBroadcast broadcast = new UpEndBroadcast(this);
    /**
     * 未上传数量,主要用于红点数量的显示
     */
    @SuppressWarnings("unused")
    private int unUploadCount;
    private Unbinder unbinder;
    //    public static RefreshStatus mRefreshStatus;
    boolean isRefresh = true;

    @Override
    protected BasePresenter addPresenter() {
        return moreIndexPre = new MoreIndexPre(MoreIndexAct.this);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_more_index);
        unbinder = ButterKnife.bind(this);
//        StatusBarUtils.setViewStatus(mEmptyActionBar);
//        mRefreshStatus = this;
        initTitle();
//      是否是beta版本
        boolean isBetaVersion = EnvironmentHelper.getInstance().isBeta();//NetParam.YINXIAOBU_SERVER.equals(ApiConstants.productionEnvServer);
        // beta版本意见反馈消息提醒
        isShowNotify(isBetaVersion ? View.VISIBLE : View.GONE, betaSuggestion);
        betaSuggestion.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                startActivity(new Intent(MoreIndexAct.this, BetaSuggestionAct.class));
            }
        });

        //未上传数据消息提醒
        unUploadNotifyItem();
        moreUnUploadNotice.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ToActivity.toActivity(MoreIndexAct.this, UpAndDownDataUp.class);
            }
        });

        IntentFilter intentFilter = new IntentFilter("com.urovo.wgmf.upend");
        registerReceiver(broadcast, intentFilter);
        ImageButton back = (ImageButton) findViewById(R.id.back);
        back.setVisibility(View.GONE);

        initRv(mTotalList);
        initRefreshLayout();

        //先加载离线数据
        loadDataFromOffline();
        // 如果有网，就拉取网络数据
        refresh();
        showSettingButton();
        initPrivilege2VisibilityOrGone();
    }

    /**
     * 整个页面没有权限时显示的布局
     */
    private void initPrivilege2VisibilityOrGone() {
        if (!PrivilegeDbOperate.checkUserPrivilege(AppConstants.More.MORE)) {
            mEmptyRoot.setVisibility(View.VISIBLE);
            mEmptyViewTv.setText("暂无使用权限!");
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText("更多");
    }

    /**
     * 未上传数据消息提醒
     */
    private void unUploadNotifyItem() {
        isShowNotify(getUnUploadCount() > 0 ? View.VISIBLE : View.GONE, moreUnUploadNotice, "共有" + getUnUploadCount() + "条本机数据未上传");
    }

    private void isShowNotify(int visibility, TextView textView) {
        textView.setVisibility(visibility);
        //震动动画
        vibrate(textView);
    }

    private void isShowNotify(int visibility, TextView textView, String content) {
        textView.setVisibility(visibility);
        textView.setText(content);
        //震动动画
        vibrate(textView);
    }

    /**
     * 初始化recycleView
     */
    private void initRv(final List<MultipleItem> mTotalList) {
        moreItemAdapter = new MoreItemQuickAdapter(MoreIndexAct.this, mTotalList);

        moreItemAdapter.openLoadAnimation(BaseQuickAdapter.ALPHAIN);
        final GridLayoutManager manager = new GridLayoutManager(this, 4);
        moreIndexRv.setLayoutManager(manager);
        moreItemAdapter.setSpanSizeLookup(new BaseQuickAdapter.SpanSizeLookup() {
            @Override
            public int getSpanSize(GridLayoutManager gridLayoutManager, int position) {
                return mTotalList.get(position).getSpanSize();
            }
        });
//        moreItemAdapter.setLoadMoreView(new CustomLoadMoreView(isBetaVersion ? AppConstants.TabActState.MORE_LOAD_STATE : ""));
        moreIndexRv.setAdapter(moreItemAdapter);
        moreItemAdapter.setOnItemChildClickListener(new BaseQuickAdapter.OnItemChildClickListener() {
            @Override
            public void onItemChildClick(BaseQuickAdapter baseQuickAdapter, View view, int position) {
                final MultipleItem multipleItem = (MultipleItem) baseQuickAdapter.getData().get(position);
                if (multipleItem == null) {
                    return;
                }
                if (multipleItem.getContent() != null && "查看更多".equals(multipleItem.getContent())) {
                    isSeeMoreFlag = toggle();
                    SYLoger.print("mUnUploadItem -2->" + multipleItem.getContent());
                    final LinearLayout moreItem2SeeContainer = (LinearLayout) view;
                    final TextView childAt = (TextView) moreItem2SeeContainer.getChildAt(1);
                    CommonTools.INSTANCE.setShowArrow(MoreIndexAct.this, childAt,
                            CommonTools.ShowArrowDirection.right, isSeeMoreFlag,
                            R.drawable.go_up, R.drawable.go_down);
                    //如果点击查看更多
                    if (isSeeMoreFlag) {
                        //展开
                        addMenuItem2List(mGmiBean, mFixedLength, (mPciBean.size() + mFixedLength + mSubTitleCount));
                    } else {
                        //收缩
                        removeMenuItem2List(mGmiBean, mFixedLength, (mPciBean.size() + mFixedLength + mSubTitleCount));
                    }
                    return;
                }

                if (multipleItem.getT() == null) {
                    return;
                }
                final String param = multipleItem.getParam();
                final MoreOnlineBean.ResultInfoBean.AndroidBean androidBean = (MoreOnlineBean.ResultInfoBean.AndroidBean) multipleItem.getT();
                try {
                    //web网页情况
                    if ("url".equals(androidBean.getLinkType())) {
//                        if (typeId == 15) { // 学习系统 e-learning
                        BaseCookiesWebFra.launch(MoreIndexAct.this, new Intent(), androidBean.getLink(), null, true);
//                        } else {
//                            if (tempLink.contains("staffId")) {
//                                tempLink = tempLink.replace("{staffId}", SystemHelper.LoginUserId);
//                            }
//                            if (tempLink.contains("name")) {
//                                tempLink = tempLink.replace("{name}", SystemHelper.LoginUserName);
//                            }
//                            BaseCookiesWebFra.launch(MoreIndexAct.this, intent,
//                                    NetParam.YINXIAOBU_SERVER.replace("https://", "http://") + "/" + tempLink,
//                                    null, true);
//                        }
                    }
                    //native情况之养生文库;
                    else /*if (Class.forName(androidBean.getLink()) == LearningCenterMenuActivity.class &&"2".equals(param)) {
                        // 养生文库情况得传递参数;
                        ToActivity.toActivity(MoreIndexAct.this, Class.forName(androidBean.getLink()), AppConstants.ExtraKeys.ACTIVITY_TYPE, 2);
                    //上报反馈情况
                    }else if (Class.forName(androidBean.getLink()) == QBackInputAct.class ){
                        Intent intent = new Intent(MoreIndexAct.this,QBackInputAct.class);
                        intent.putExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE, param);//传的虽然是个字符串，但会被转换成枚举类型。
                        startActivity(intent);
                    } else*/ {
                        ////除开养生文库外的native情况（新进程下的打卡SignInAndOut需要传Intent，注意一下）
                        //现在的内部跳转全部统一为传ACTIVITY_TYPE的参数来区分共用页面了。
                        ToActivity.toActivity(MoreIndexAct.this, Class.forName(androidBean.getLink()),
                                SystemHelper.LoginOrganId,
                                SystemHelper.LoginUserName,
                                SystemHelper.LoginUserId,
                                param);
                    }
                } catch (ClassNotFoundException e) {
                    e.printStackTrace();
                    BaseAppManager.loger().error("当前选项配置有问题:" + e);
                    showMsg("当前选项配置有问题");
                }
//                switch (multipleItem.getTypeId()) {
//                    //打卡
//                    case 0:
//                        ToActivity.toActivity(MoreIndexAct.this, SignInAndOutActivity.class);
//                        break;
//                    //请假
//                    case 1:
//                        ToActivity.toActivity(MoreIndexAct.this, AskAbsenceAct.class);
//                        break;
//                    //考勤管理
//                    case 2:
//                        ToActivity.toActivity(MoreIndexAct.this, AttendanceManagerMenu.class);
//                        break;
//                    //薪资查询
//                    case 3:
//                        ToActivity.toActivity(MoreIndexAct.this, UserActivity.class);
//                        break;
//                    //信息确认
//                    case 4:
//                        ToActivity.toActivity(MoreIndexAct.this, PersonalAct.class);
//                        break;
//                    //专属二维码
//                    case 5:
//                        ToActivity.toActivity(MoreIndexAct.this, QrCode.class);
//                        break;
//                    //上报反馈
//                    case 6:
//                        ToActivity.toActivity(MoreIndexAct.this, QualityBackActivity.class);
//                        break;
//                    //门店订货
//                    case 7:
//                        ToActivity.toActivity(MoreIndexAct.this, OrderGoodsTabAct.class);
//                        break;
//                    //配送收货
//                    case 8:
//                        ToActivity.toActivity(MoreIndexAct.this, ReceiveGoodsTabMenu.class);
//                        break;
//                    //存货盘点
//                    case 9:
//                        ToActivity.toActivity(MoreIndexAct.this, CheckGoodsTabMenu.class);
//                        break;
//                    //调拨
//                    case 10:
//                        ToActivity.toActivity(MoreIndexAct.this, AllotGoodsActivityQuire.class);
//                        break;
//                    //库存查询
//                    case 11:
//                        ToActivity.toActivity(MoreIndexAct.this, StockSearchActivity.class);
//                        break;
//                    //产品出入库
//                    case 12:
//                        ToActivity.toActivity(MoreIndexAct.this, GoodsInOutStockAct.class);
//                        break;
//                    //报损
//                    case 13:
//                        ToActivity.toActivity(MoreIndexAct.this, ReimburseGoodsActivity.class);
//                        break;
//                    //赠送
//                    case 14:
//                        ToActivity.toActivity(MoreIndexAct.this, GiftGoodsActivity.class);
//                        break;
//                    //e-learning
//                    case 15:
//                        String tempLink = "http://stu.wgmf.com/mobile/html/sso_mobile.html";
//                        BaseCookiesWebFra.launch(MoreIndexAct.this, new Intent(), tempLink, null, true);
//                        break;
//                    //学习中心
//                    case 16:
//                        ToActivity.toActivity(MoreIndexAct.this, LearningCenterMenuActivity.class);
//                        break;
//                    //养生文库
//                    case 17:
//                        ToActivity.toActivity(MoreIndexAct.this, LearningCenterMenuActivity.class, AppConstants.ExtraKeys.ACTIVITY_TYPE, 2);
//                        break;
//                    //数据下载
//                    case 18:
//                        ToActivity.toActivity(MoreIndexAct.this, UpAndDownDataDown.class);
//                        break;
//                    //数据上传
//                    case 19:
//                        ToActivity.toActivity(MoreIndexAct.this, UpAndDownDataUp.class);
//                        break;
//                    //数据清理
//                    case 20:
//                        ToActivity.toActivity(MoreIndexAct.this, UpAndDownDataClean.class);
//                        break;
//                    //常见问题
//                    case 21:
//                        ToActivity.toActivity(MoreIndexAct.this, NormalQuestionAct.class);
//                        break;
//                    //配置id不在范围内
//                    default:
//                        MyToast.show("配置typeId不在范围内!");
//                        break;
//                }
            }
        });
    }

    /**
     * 切换开关
     */
    boolean flag;

    public boolean toggle() {
        return flag = !flag;
    }

    private String[] moduleTitlePrivilege = {
            AppConstants.More.PERSONAL_CENTER,
            AppConstants.More.GOODS_MANAGEMENT,
            AppConstants.More.QUALITY_BACK_MODEL,
            AppConstants.More.LEARNING_AND_TRAINING,
            AppConstants.More.NATIVE_MANAGEMENT,
    };
    private List<List<MoreOnlineBean.ResultInfoBean>> moduleList = new ArrayList<>();
    private int loadModuleNum = 0;

    /**
     * 子模块:个人中心 货品管理 学习培训和本机管理四部分
     *
     * @param resultInfo ...
     * @return ...
     */
    private List<MultipleItem> getTotalList(List<List<MoreOnlineBean.ResultInfoBean>> resultInfo) {
        //清空上次的缓存数据
        clear(mTotalList, moduleList);

        // 遍历模块(个人中心/货品管理),权限控制模块里的item的显隐(ps:个人中心--打卡/请假/上报反馈...)
        for (int i = 0; i < resultInfo.size(); i++) {
            //遍历每个模块,根据权限处理其中的子元素
            filterData(resultInfo.get(i), moduleList);

            //加载模块（如果不需要哪个模块，可以控制这里不加载）
//            loadModule(i, resultInfo.get(i));
            if (PrivilegeDbOperate.checkUserPrivilege(moduleTitlePrivilege[i])) {
                loadModule(i, moduleList.get(i));
            } else {
                loadModuleNum += 1;
            }
        }
        //权限控制下,少几个模块就补几个灰色块,防止背景是白色的穿帮了哈.
        for (int j = 0; j < loadModuleNum; j++) {
            for (int k = 0; k < loadModuleNum; k++) {
                mTotalList.add(new MultipleItem(MultipleItem.GRAY_HORIZONTAL_LINE, MultipleItem.TEXT_SPAN_SIZE));
            }
        }
        SYLoger.print("loadModuleNum:" + loadModuleNum);
        loadModuleNum = 0;

        //本来自然，何须添加的tips
        mTotalList.add(new MultipleItem(MultipleItem.TEXT_FOOT_TIPS, MultipleItem.TEXT_SPAN_SIZE));
        return mTotalList;
    }

    /**
     * 加载模块
     *
     * @param position        ...
     * @param resultInfoBeans ...
     */

    private void loadModule(final int position, List<MoreOnlineBean.ResultInfoBean> resultInfoBeans) {
        switch (position) {
            //个人中心
            case 0:
                personalCenterItem(resultInfoBeans);
                break;
            //货品管理
            case 1:
                goodsManagementItem(resultInfoBeans);
                break;
            //上报反馈
            case 2:
                qualityBackItem(resultInfoBeans);
                break;
            //学习培训
            case 3:
                learningAndTrainingItem(resultInfoBeans);
                break;
            //本机管理
            case 4:
                nativeManagementItem(resultInfoBeans);
                break;
            //未知
            default:
                MyToast.show("App新增模块菜单未配置异常!");
                break;
        }
    }

    /**
     * 根据权限过滤数据（处理第三级目录）
     * 传入模块的集合,遍历,根据权限筛选数据,重新得到新的模块集合
     *
     * @param oldList    传入的模块集合
     * @param moduleList 存放模块集合的新容器
     */
    private void filterData(List<MoreOnlineBean.ResultInfoBean> oldList, List<List<MoreOnlineBean.ResultInfoBean>> moduleList) {
        // 第一种方式 通过权限判断不符合的元素,删除,注意角标要减一
        for (int i = 0; i < oldList.size(); i++) {
            final String link = oldList.get(i).getAndroid().getLink();
            SYLoger.print("wgmf-->权限:" + link);
            if (TextUtils.isEmpty(link)) {
                return;
            } else if (link.startsWith("com")) {
                SYLoger.print("wgmf-->native权限:" + link.substring(link.lastIndexOf(".") + 1));
                String className = link.substring(link.lastIndexOf(".") + 1);
                if (!oldList.get(i).getAndroid().getParam().equals("0")) {//如果param不为0，那就说明有参数，需要拼接一下，再做比较
                    className = className + "@" + oldList.get(i).getAndroid().getParam();
                }
                boolean isHavePrivilege = PrivilegeDbOperate.checkUserPrivilege(className);
                SYLoger.print("wgmf-->native权限: " + className + " is " + isHavePrivilege);
                if (!isHavePrivilege) {
                    oldList.remove(oldList.get(i));
                    i--;
                }
            } else if ("e-learning".equals(oldList.get(i).getTypeName())) {
                SYLoger.print("wgmf-->权限:e-learning");
                final boolean isHavePrivilege = PrivilegeDbOperate.checkUserPrivilege(oldList.get(i).getTypeName());
                SYLoger.print("wgmf-->权限:e-learning: " + isHavePrivilege);
                if (!isHavePrivilege) {
                    oldList.remove(oldList.get(i));
                    i--;
                }
            } else if (link.startsWith("http")) {
                SYLoger.print("wgmf-->H5权限:" + link);
                final boolean isHavePrivilege = PrivilegeDbOperate.checkUserPrivilege(link);
                SYLoger.print("wgmf-->H5权限:http " + isHavePrivilege);
                if (!isHavePrivilege) {
                    oldList.remove(oldList.get(i));
                    i--;
                }
            } else {
                //配置的link不符合标准,还是会默认显示出图标,并提示
                MyToast.show("\"" + oldList.get(i).getTypeName() + "\"" + "菜单跳转地址配置出错!");
            }
        }
        moduleList.add(oldList);
    }

    private void qualityBackItem(List<MoreOnlineBean.ResultInfoBean> moreOnlineBeans) {
        if (moreOnlineBeans == null) {
            return;
        }
        mTotalList.add(new MultipleItem(MultipleItem.TEXT, MultipleItem.TEXT_SPAN_SIZE, "上报反馈"));
        addMenuItem2List(moreOnlineBeans);
    }

    /**
     * 本机管理
     *
     * @param moreOnlineBeans ...
     */
    private void nativeManagementItem(List<MoreOnlineBean.ResultInfoBean> moreOnlineBeans) {
        if (moreOnlineBeans == null) {
            return;
        }
        mTotalList.add(new MultipleItem(MultipleItem.TEXT, MultipleItem.TEXT_SPAN_SIZE, "本机管理"));
        addMenuItem2List(moreOnlineBeans);
    }

    /**
     * 学习培训
     */
    private void learningAndTrainingItem(List<MoreOnlineBean.ResultInfoBean> moreOnlineBeans) {
        if (moreOnlineBeans == null) {
            return;
        }
        mTotalList.add(new MultipleItem(MultipleItem.TEXT, MultipleItem.TEXT_SPAN_SIZE, "学习培训"));
        addMenuItem2List(moreOnlineBeans);
    }

    /**
     * 货品管理
     *
     * @param moreOnlineBeans ...
     */

    private void goodsManagementItem(List<MoreOnlineBean.ResultInfoBean> moreOnlineBeans) {
        mGmiBean = moreOnlineBeans;
        if (moreOnlineBeans == null) {
            return;
        }

        mTotalList.add(new MultipleItem(MultipleItem.TEXT, MultipleItem.TEXT_SPAN_SIZE, "货品管理"));

        if (moreOnlineBeans.size() <= mFixedLength) {
            //集合长度小于等于固定长度，显示全部的item
            addMenuItem2List(moreOnlineBeans);
        } else {
            //超过固定长度时 默认是显示固定长度数量的item，如果点击查看更多，展开，收缩切换
            addMenuItem2List(moreOnlineBeans, isSeeMoreFlag ? moreOnlineBeans.size() : mFixedLength);
            //查看更多
            mTotalList.add(new MultipleItem<>(MultipleItem.TEXT_IMG, MultipleItem.TEXT_IMG_SPAN_SIZE, "查看更多"));
        }
    }

    /**
     * 个人中心
     *
     * @param moreOnlineBeans ...
     */
    private void personalCenterItem(List<MoreOnlineBean.ResultInfoBean> moreOnlineBeans) {
        mPciBean = moreOnlineBeans;
        if (moreOnlineBeans == null) {
            return;
        }
        mTotalList.add(new MultipleItem(MultipleItem.TEXT, MultipleItem.TEXT_SPAN_SIZE, "个人中心"));
        addMenuItem2List(moreOnlineBeans);
    }

    /**
     * 默认添加数据
     *
     * @param moreOnlineBeans 模块集合
     */
    private void addMenuItem2List(List<MoreOnlineBean.ResultInfoBean> moreOnlineBeans) {
        addMenuItem2List(moreOnlineBeans, moreOnlineBeans.size());
    }

    /**
     * 指定集合长度添加数据
     *
     * @param moreOnlineBeans 模块集合
     * @param listMaxLength   集合的长度
     */
    private void addMenuItem2List(List<MoreOnlineBean.ResultInfoBean> moreOnlineBeans, int listMaxLength) {
        if (mTotalList.isEmpty()) {
            return;
        }
        for (int i = 0; i < listMaxLength; i++) {
            mTotalList.add(new MultipleItem<>(MultipleItem.IMG_TEXT, MultipleItem.IMG_TEXT_SPAN_SIZE,
//                    //每个item的id
//                    moreOnlineBeans.get(i) == null ? -1 : moreOnlineBeans.get(i).getTypeId(),
                    //每个item 的param,传递学习中心和养生文库的参数
                    moreOnlineBeans.get(i) == null ? "0" : moreOnlineBeans.get(i).getAndroid().getParam(),
                    //item的通知提醒的红点
                    moreOnlineBeans.get(i) == null ? 0 : unUploadCount,
                    //每个Item 有关link linkType 的封装对象
                    moreOnlineBeans.get(i) == null ?
                            new MoreOnlineBean.ResultInfoBean.AndroidBean() : moreOnlineBeans.get(i).getAndroid(),
//                    // 菜单图片的url 不用公共的url ,去getAndroid中找
//                    moreOnlineBeans.get(i) == null ? "" : moreOnlineBeans.get(i).getTypePic(),
                    //菜单的名称
                    moreOnlineBeans.get(i) == null ? "" : moreOnlineBeans.get(i).getTypeName()
            ));
        }
        mTotalList.add(new MultipleItem<>(MultipleItem.ITEM_HORIZONTAL_LINE, MultipleItem.HORIZONTAL_LINE_SPAN_SIZE));
    }

    /**
     * 插入数据
     *
     * @param moreOnlineBeans 模块集合
     * @param startIndex      从集合哪个索引开始取数据
     * @param positionIndex   插入数据到mTotalList 总集合的哪个位置(ps:插入数据到整个页面的哪个位置)
     */
    private void addMenuItem2List(List<MoreOnlineBean.ResultInfoBean> moreOnlineBeans, int startIndex, int positionIndex) {
        if (mTotalList.isEmpty()) {
            return;
        }
        for (int i = moreOnlineBeans.size() - 1; i >= startIndex; i--) {
            mTotalList.add(positionIndex, new MultipleItem<>(MultipleItem.IMG_TEXT, MultipleItem.IMG_TEXT_SPAN_SIZE,
//                    //每个item的id
//                    moreOnlineBeans.get(i) == null ? -1 : moreOnlineBeans.get(i).getTypeId(),
                    //每个item 的param,传递学习中心和养生文库的参数
                    moreOnlineBeans.get(i) == null ? "0" : moreOnlineBeans.get(i).getAndroid().getParam(),
                    //item的通知提醒的红点
                    moreOnlineBeans.get(i) == null ? 0 : unUploadCount,
                    //每个Item 有关link linkType 的封装对象
                    moreOnlineBeans.get(i) == null ? new MoreOnlineBean.ResultInfoBean.AndroidBean() : moreOnlineBeans.get(i).getAndroid(),
//                    // 菜单图片的url 不用公共的url ,去getAndroid中找
//                    moreOnlineBeans.get(i) == null ? "" : moreOnlineBeans.get(i).getTypePic(),
                    //菜单的名称
                    moreOnlineBeans.get(i) == null ? "" : moreOnlineBeans.get(i).getTypeName()));
        }
        moreItemAdapter.notifyDataSetChanged();
    }

    /**
     * 删除数据
     *
     * @param moreOnlineBeans 模块集合
     * @param startIndex      从集合哪个索引开始取数据，ps:结合集合长度可以确定删除几个item
     * @param positionIndex   从mTotalList中删除数据， 指定总集合的哪个位置开始删除(ps:插入数据到整个页面的哪个位置)
     */
    private void removeMenuItem2List(List<MoreOnlineBean.ResultInfoBean> moreOnlineBeans, int startIndex, int positionIndex) {
        if (mTotalList.isEmpty()) {
            return;
        }
        for (int i = startIndex; i < moreOnlineBeans.size(); i++) {
            mTotalList.remove(positionIndex);
        }
        moreItemAdapter.notifyDataSetChanged();
    }

    /**
     * 清空集合
     */
    private void clear(List... totalList) {
        if (totalList != null && totalList.length != 0) {
            for (List aTotalList : totalList) {
                if (aTotalList != null && !aTotalList.isEmpty()) {
                    aTotalList.clear();
                }
            }
        }
    }

    /**
     * 刷新头监听器初始化
     */
    private void initRefreshLayout() {
        mSwipeRefreshLayout.setOnRefreshListener(new OnRefreshListener() {
            @Override
            public void onRefresh(final RefreshLayout refreshlayout) {
                refreshlayout.getLayout().postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        refresh();
                        refreshlayout.finishRefresh();
                        refreshlayout.resetNoMoreData();
                        mSwipeRefreshLayout.autoRefresh();
                    }
                }, 2000);
            }
        });
    }

    private void refresh() {
        isRefresh = true;

        //网络请求
        start2RequestTask();

        //刷新权限请求
        refreshPrivilege();
    }

    @Override
    public void afterRefreshPrivilege() {
        initPrivilege2VisibilityOrGone();
    }

    /**
     * 网络请求
     */
    private void start2RequestTask() {
        Map<String, String> params = new HashMap<>(2);
        params.put("userNo", SystemHelper.LoginUserId);
        params.put("type", AppConstants.TabActState.MORE_STATE);
        moreIndexPre.onStart2requestData(params);
    }

    /**
     * 加载离线资源
     */
    private void loadDataFromOffline() {
        String tempJson = AssetsUtil.getFromAssets(this, "more_index.json");
        final MoreOnlineBean moreOfflineBean = new Gson().fromJson(tempJson, MoreOnlineBean.class);
        entity = moreOfflineBean.getResultInfo();
        mTotalList = getTotalList(entity);
        //这里做了刷新
        moreItemAdapter.replaceData(mTotalList);
    }

    @Override
    protected void onResume() {
        super.onResume();
        notifyData();
//        moreIndexPre.queryContractDialog(this);
    }

    /**
     * 更多页面右上角设置
     */
    public void showSettingButton() {
        submit.setVisibility(View.GONE);
        settinButton.setVisibility(View.VISIBLE);
        settinButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                startActivity(new Intent(MoreIndexAct.this, SttingMenu.class));
            }
        });
    }

    /**
     * 这是本机管理红点的刷新
     */
    @Override
    public void notifyData() {
        //更新当前界面的未上传的通知消息
        unUploadNotifyItem();

        //刷新recycleView,更新adapter中设置的红点数量的状态
//        if (moreItemAdapter != null) {
//            unUploadCount = getUnUploadCount();
//            moreItemAdapter.notifyDataSetChanged();
//        }
    }

    private int getUnUploadCount() {
        return DalCommon.GetUnUploadCount(false);
    }

    @Override
    protected void onDestroy() {
        if (unbinder != null) {
            unbinder.unbind();
        }
        if (broadcast != null) {
            unregisterReceiver(broadcast);
        }
        super.onDestroy();
    }

//    @Override
//    public void notifyUpLoadData() {
//        notifyData();
//    }

    private List<List<MoreOnlineBean.ResultInfoBean>> entity;

    @Override
    public void onResponseSuccess(com.urovo.wugumofang.response.CommonEntity<List<List<MoreOnlineBean.ResultInfoBean>>> resultInfo) {
        entity = resultInfo.entity;
        if (entity.isEmpty()) {
            loadDataFromOffline();
        } else {
            mTotalList = getTotalList(entity);
            if (isRefresh && mSwipeRefreshLayout != null) {
                mSwipeRefreshLayout.finishRefresh();
                moreItemAdapter.notifyDataSetChanged();
            }
        }
    }

    @Override
    public void onFailure(String failInfo) {
        if (isRefresh && mSwipeRefreshLayout != null) {
            mSwipeRefreshLayout.finishRefresh();
            moreItemAdapter.notifyDataSetChanged();
        }
        loadDataFromOffline();
        MyToast.show(failInfo);
        BaseAppManager.loger().error("报文:" + this.getClass().getSimpleName() + "-->" + failInfo);
    }
}
