package com.urovo.wgmf;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;

import com.urovo.wgmf.tool.ScannerJNI;
import com.urovo.wugumofang.system.PdaMsgConfig;
import com.urovo.wugumofang.base.BaseActivity;

public abstract class PosBaseActivity extends BaseActivity {

    private Context context;
    public static final int FILE_RESULT_CODE = 1;
    private BroadcastReceiver mReceiver;
    private IntentFilter mFilter;
    ScannerJNI Controll = new ScannerJNI(this);
    protected boolean isPda;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        context = this;
        isPda = PdaMsgConfig.isPDA(this);
        // Controll.open();
        // Controll.enablePlayBeep(true);
        // Controll.enablePlayVibrate(false);//不允许震动
        // Controll.enableAddKeyValue(0);//不换行
        // Controll.setOutputMode(1);//使用广播模式
        // // Controll.enablShowNoticeIcon(false);//屏蔽通知栏图标
        // // Controll.unlockScanKey();//释放系统扫描按键，自己控制
        // Controll.enablShowAPPIcon(false);//

        if (isPda) {
            Controll.open();
            Controll.setOutputMode(1);// 使用广播模式
            mFilter = new IntentFilter("android.intent.action.SCANRESULT");
            mReceiver = new BroadcastReceiver() {
                @Override
                public void onReceive(Context context, Intent intent) {
                    // 此处获取扫描结果信息
                    final String scanResult = intent.getStringExtra("value");
                    onScaned(scanResult);
                }
            };
            IntentFilter intentFilter = new IntentFilter();
            intentFilter.addAction("android.intent.action.SCANRESULT");
            registerReceiver(mReceiver, intentFilter);
        }
    }

    public boolean isPda(){
        isPda = PdaMsgConfig.isPDA(this);
        return isPda;
    }

    /*
     * public boolean onKeyDown(int keyCode, KeyEvent event) { if ((keyCode ==
     * KeyEvent.KEYCODE_F9 || keyCode == KeyEvent.KEYCODE_F10 || keyCode ==
     * KeyEvent.KEYCODE_F11)&&event.getRepeatCount()==0) { if(isPda2)
     * Controll.scan_start(); return true; } return super.onKeyDown(keyCode,
     * event); }
     *
     * public boolean onKeyUp(int keyCode, KeyEvent event) { if (keyCode ==
     * KeyEvent.KEYCODE_F9 || keyCode == KeyEvent.KEYCODE_F10 || keyCode ==
     * KeyEvent.KEYCODE_F11) { if(isPda2) Controll.scan_stop(); return true; }
     * return super.onKeyUp(keyCode, event); }
     *
     * @Override protected void onStart() {
     *
     * super.onStart(); if(isPda2){ Controll.open(); } }
     *
     * @Override protected void onResume() { super.onResume(); if(isPda2){
     * registerReceiver(mReceiver, mFilter); } }
     *
     * @Override protected void onPause() { // 注销获取扫描结果的广播 if(isPda2){
     * this.unregisterReceiver(mReceiver); Controll.close(); } super.onPause();
     * }
     */
    @Override
    protected void onDestroy() {

        if (isPda) {
            this.unregisterReceiver(mReceiver);
        }
        super.onDestroy();
    }

    /**
     * 扫描结束后执行的业务操作
     *
     * @param barcode
     */
    protected abstract void onScaned(String barcode);
}
