package com.urovo.wgmf.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageButton;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.StringUtils;

import java.util.ArrayList;
import java.util.List;

public class AllotGoodsAdapter extends BaseAdapter {
	private List<ProductEntity> list;
	private BaseActivity context;

	public AllotGoodsAdapter(List<ProductEntity> list, BaseActivity context) {
		this.list = list;
		this.context = context;

	}

	public void add(List<ProductEntity> checkList) {
		if(list == null) {
			list = new ArrayList<ProductEntity>();
		}
		for (ProductEntity newData : checkList) {
			boolean isExist = false;
			for (ProductEntity data : list) {
				if(data.getItemId().equals(newData.getItemId())) {
					isExist = true;
					data.setTQTY(Arith.add(data.getTQTY(), newData.getTQTY()));
					data.setAmount(Arith.mul(data.getTQTY(), data.getPrice()));
					break;
				}
			}
			if(!isExist) {
				list.add(newData);
			}
		}
		notifyDataSetChanged();
	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Object getItem(int position) {

		return list == null ? null : list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		final ViewHolder viewHolder;
		if(convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.second_allot_goods_item, null);
			viewHolder = new ViewHolder();
			viewHolder.name = (TextView) convertView.findViewById(R.id.goods_name);
			viewHolder.amount = (TextView) convertView.findViewById(R.id.goods_price);
			viewHolder.subtract = (ImageButton) convertView.findViewById(R.id.goods_decrease);
			viewHolder.add = (ImageButton) convertView.findViewById(R.id.goods_plus);
			viewHolder.count = (TextView) convertView.findViewById(R.id.goods_count);
			viewHolder.kcoum = (TextView) convertView.findViewById(R.id.goods_unit);
			convertView.setTag(viewHolder);
		}
		else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		final ProductEntity ent = list.get(position);
		viewHolder.name.setText(ent.getItemName());
		viewHolder.kcoum.setText("(" + ent.getKCUom() + ")");
		viewHolder.count.setText(StringUtils.formatDouble(ent.getTQTY(), "0.##"));
		viewHolder.amount.setText(StringUtils.formatDouble(ent.getAmount(), "0.00"));
		if(ent.getTQTY() == 0) {
			viewHolder.subtract.setEnabled(false);
		}
		else {
			viewHolder.subtract.setEnabled(true);
		}
		viewHolder.subtract.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

				double newCount = Double.parseDouble(viewHolder.count.getText().toString());
				newCount = Arith.sub(newCount, 1);
				ent.setTQTY(newCount);
				ent.setAmount(Arith.mul(ent.getTQTY(), ent.getPrice()));
				viewHolder.count.setText(StringUtils.formatDouble(newCount, "0.##"));
				viewHolder.amount.setText(StringUtils.formatDouble(ent.getAmount(), "0.00"));
				if(ent.getTQTY() == 0) {
					viewHolder.subtract.setEnabled(false);
				}
			}
		});
		viewHolder.add.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

				double newCount2 = Double.parseDouble(viewHolder.count.getText().toString());
				newCount2 = Arith.add(newCount2, 1);
				ent.setTQTY(newCount2);
				ent.setAmount(Arith.mul(ent.getTQTY(), ent.getPrice()));
				viewHolder.count.setText(StringUtils.formatDouble(newCount2, "0.##"));
				viewHolder.amount.setText(StringUtils.formatDouble(ent.getAmount(), "0.00"));
				if(ent.getTQTY() > 0) {
					viewHolder.subtract.setEnabled(true);
				}

			}
		});
		return convertView;
	}

	class ViewHolder {
		TextView name;
		ImageButton subtract;
		ImageButton add;
		TextView count;
		TextView kcoum;
		TextView amount;

	}

}
