package com.urovo.wgmf.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wgmf.entity.response.DiaoBoQueryRes;
import com.urovo.wgmf.db.dao.entitys.AllotGoodsQueryEntity;
import com.urovo.wugumofang.R;

import java.util.List;

public class AllotGoodsQueryAdapter extends BaseAdapter {
    private List<DiaoBoQueryRes.Bean> list;
    private Context context;
    private List<List<AllotGoodsQueryEntity>> child;
    private int mType = 0;//类型标记：0出库，1收货

    public AllotGoodsQueryAdapter(Context context, List<DiaoBoQueryRes.Bean> list) {
        this.list = list;
        this.context = context;
    }

    public void setType(int type){
        this.mType = type;
    }

    @Override
    public int getCount() {
        return list.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        if(convertView == null){
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.second_allot_goods_query_item,null);
            holder.shopNameTv = (TextView)convertView.findViewById(R.id.shop_name);
            holder.dateTv = (TextView)convertView.findViewById(R.id.date);
            holder.proNameTv = (TextView)convertView.findViewById(R.id.goods_name);
            holder.proNoTv = (TextView)convertView.findViewById(R.id.goods_num);
            holder.personTv = (TextView)convertView.findViewById(R.id.allot_goods_query_people);
            holder.priceTv = (TextView)convertView.findViewById(R.id.goods_price);
            holder.proQtyTv = (TextView)convertView.findViewById(R.id.goods_count);
            holder.billNoTv = (TextView)convertView.findViewById(R.id.allot_goods_query_bill);
            holder.amountTv = (TextView)convertView.findViewById(R.id.goods_amount);
            convertView.setTag(holder);
        }else{
            holder = (ViewHolder)convertView.getTag();
        }

        DiaoBoQueryRes.Bean item = list.get(position);
        holder.shopNameTv.setText(item.getAllotOutStore() +" -> "+ item.getAllotInStore());
        holder.dateTv.setText(item.getAllotDate().substring(0,10));
        holder.proNameTv.setText(item.getProName());
        holder.proNoTv.setText(item.getProCode());
        holder.personTv.setText(item.getAllotUserName());
        holder.billNoTv.setText(item.getAllotmentId());
        holder.proQtyTv.setText(getQty(item)+"");
        holder.amountTv.setText(getAmount(item)+"");
        holder.priceTv.setText(getPrice(item));
        return convertView;
    }

    /**
     * 如果in 和 out有一个是零，那就返回另一个
     * @param item
     * @return
     */
    private double getQty(DiaoBoQueryRes.Bean item){
        return item.getProInQty() == 0? item.getProOutQty() : item.getProInQty() ;
    }

    private String getPrice(DiaoBoQueryRes.Bean item){
        return String.format("%.1f",getQty(item) == 0? 0 : getAmount(item)/getQty(item));
    }

    private double getAmount(DiaoBoQueryRes.Bean item){
        return item.getProInAmount() == 0? item.getProOutAmount() : item.getProInAmount() ;
    }

    class ViewHolder {
        TextView shopNameTv;//门店（A门店 -> B门店）
        TextView dateTv;//日期
        TextView proNameTv;//产品名称
        TextView proNoTv;//产品编码
        TextView personTv;//制单人
        TextView priceTv;//产品价格
        TextView proQtyTv;//产品数量
        TextView billNoTv;//单号
        TextView amountTv;//总价


    }

}
