package com.urovo.wgmf.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.entitys.ZCDA002Entity;
import com.urovo.wugumofang.R;

import java.util.List;

public class AssetQueryAdapter extends BaseAdapter {
    private List<ZCDA002Entity> list;
    private BaseActivity context;

    public AssetQueryAdapter(List<ZCDA002Entity> list, BaseActivity context) {
        this.list = list;
        this.context = context;

    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.second_materialsquire_item, null);
            viewHolder = new ViewHolder();
            viewHolder.text1 = (TextView) convertView.findViewById(R.id.name);
            viewHolder.text2 = (TextView) convertView.findViewById(R.id.count);
            viewHolder.text3 = (TextView) convertView.findViewById(R.id.kcuom);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        viewHolder.text1.setText(list.get(position).ZCNAME);
        viewHolder.text2.setText(list.get(position).KCQTY + "");
        viewHolder.text3.setText(list.get(position).KCUOMName);
        return convertView;
    }

    class ViewHolder {
        TextView text1;
        TextView text2;
        TextView text3;

    }

}
