package com.urovo.wgmf.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wgmf.entity.response.BaoSunQueryResponse;
import com.urovo.wugumofang.R;

import java.util.List;

public class BaoSunQueryAdapter extends BaseAdapter {
    private List<BaoSunQueryResponse.Bean> list;
    private Context context;

    public BaoSunQueryAdapter(Context context, List<BaoSunQueryResponse.Bean> list) {
        this.list = list;
        this.context = context;
    }

    @Override
    public int getCount() {
        return list.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        if(convertView == null){
            holder = new ViewHolder();
            convertView =  LayoutInflater.from(context).inflate(R.layout.baosun_item,parent,false);
            holder.proNameTv = (TextView) convertView.findViewById(R.id.goods_name);
            holder.dateTv = (TextView)convertView.findViewById(R.id.goods_query_date);
            holder.proIdTv = (TextView)convertView.findViewById(R.id.goods_num);
            holder.personTv = (TextView)convertView.findViewById(R.id.goods_query_people);
            holder.priceTv = (TextView)convertView.findViewById(R.id.goods_price);
            holder.proQtyTv = (TextView)convertView.findViewById(R.id.goods_count);
            holder.billNoTv = (TextView)convertView.findViewById(R.id.goods_query_bill);
            holder.amountTv = (TextView)convertView.findViewById(R.id.goods_amount);
            convertView.setTag(holder);
        }else{
            holder = (ViewHolder)convertView.getTag();
        }

        BaoSunQueryResponse.Bean bean = list.get(position);
        holder.proNameTv.setText(bean.getProName());
        holder.dateTv.setText(bean.getLossDate().substring(0,10));
        holder.personTv.setText(bean.getUserName());
        holder.priceTv.setText(bean.getProPrice()+"");
        holder.proQtyTv.setText(bean.getLossQty() + "");
        holder.billNoTv.setText(bean.getLossId() + "");
        holder.amountTv.setText(bean.getLossAmount()+"");
        holder.proIdTv.setText(bean.getProCode());

        return convertView;
    }

    class ViewHolder {
        TextView dateTv;//制单日期
        TextView proNameTv;//产品名称
        TextView proIdTv;//产品编码
        TextView personTv;//制单人
        TextView priceTv;//产品售价
        TextView proQtyTv;//产品数量
        TextView billNoTv;//单号
        TextView amountTv;//总价
    }

}
