package com.urovo.wgmf.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.entity.response.ShiChiQueryResponse;
import com.urovo.wugumofang.R;

import java.util.List;

public class EatQueryAdapter extends BaseAdapter {
    private List<ShiChiQueryResponse.ResultInfoBean> list;
    private BaseActivity context;

    public EatQueryAdapter(List<ShiChiQueryResponse.ResultInfoBean> list, BaseActivity context) {
        this.list = list;
        this.context = context;

    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.eatmanager_listview, null);
            viewHolder = new ViewHolder();
            viewHolder.date = (TextView) convertView.findViewById(R.id.eat_ltv_dttm);
            viewHolder.count = (TextView) convertView.findViewById(R.id.eat_ltv_num);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        final ShiChiQueryResponse.ResultInfoBean ent = list.get(position);
//        Date date = DateUtil.String2Date(ent.getTasteDate(), "yyyy-MM-dd HH:mm:ss");
        viewHolder.date.setText(ent.getTasteDate());
        viewHolder.count.setText(ent.getTasteQty() + "");

        return convertView;
    }

    class ViewHolder {
        TextView date;
        TextView count;
    }

}
