package com.urovo.wgmf.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.ImageButton;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.StringUtils;

import java.util.List;

/**
 * 商品查询
 * 
 * @author Administrator
 * 
 */
public class GoodsChoseNewAdapter extends BaseAdapter {
	private BaseActivity context;
	private List<ProductEntity> list;

	public GoodsChoseNewAdapter(BaseActivity context, List<ProductEntity> list) {
		this.context = context;
		this.list = list;
	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Object getItem(int position) {

		return list == null ? null : list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		final ViewHolder viewHolder;
		if(convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.add_goods_list_item_new, null);
			viewHolder = new ViewHolder();
			viewHolder.check = (CheckBox) convertView.findViewById(R.id.goods_check);
			viewHolder.name = (TextView) convertView.findViewById(R.id.goods_name);
			viewHolder.id = (TextView) convertView.findViewById(R.id.goods_id);
			viewHolder.count = (TextView) convertView.findViewById(R.id.goods_count);
			viewHolder.subtract = (ImageButton) convertView.findViewById(R.id.goods_subtract);
			viewHolder.add = (ImageButton) convertView.findViewById(R.id.goods_add);
			viewHolder.kcuom = (TextView) convertView.findViewById(R.id.goods_kcuom);
			convertView.setTag(viewHolder);
		}
		else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		final ProductEntity ent = list.get(position);
		viewHolder.name.setText(ent.getItemName());
		viewHolder.kcuom.setText("(" + ent.getKCUom() + ")");
		viewHolder.id.setText(ent.getItemId());
		viewHolder.count.setText(StringUtils.formatDouble(ent.getTQTY(), "0.##"));
		viewHolder.check.setChecked(ent.isChecked);
		if(ent.isChecked) {
			viewHolder.subtract.setVisibility(View.VISIBLE);
			viewHolder.add.setVisibility(View.VISIBLE);
			viewHolder.count.setVisibility(View.VISIBLE);
		}
		else {
			viewHolder.subtract.setVisibility(View.GONE);
			viewHolder.add.setVisibility(View.GONE);
			viewHolder.count.setVisibility(View.GONE);
		}
		if(ent.getTQTY() == 0) {
			viewHolder.subtract.setEnabled(false);
		}
		else {
			viewHolder.subtract.setEnabled(true);
		}
		// viewHolder.check.setOnClickListener(new OnClickListener() {
		//
		// @Override
		// public void onClick(View v) {
		//
		// if(!viewHolder.check.isChecked()){
		// viewHolder.subtract.setVisibility(View.INVISIBLE);
		// viewHolder.add.setVisibility(View.INVISIBLE);
		// ent.isChecked = false;
		// }else{
		// viewHolder.subtract.setVisibility(View.VISIBLE);
		// viewHolder.add.setVisibility(View.VISIBLE);
		// ent.isChecked = true;
		// }
		// context.doResult(position);
		// }
		// });
		viewHolder.subtract.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

				double newCount = ent.getTQTY();
				newCount = Arith.sub(newCount, ent.getDHPack());
				ent.setTQTY(newCount);
				ent.setAmount(Arith.mul(newCount, ent.getPrice()));
				viewHolder.count.setText(StringUtils.formatDouble(newCount, "0.##"));
				if(ent.getTQTY() == 0) {
					viewHolder.subtract.setEnabled(false);
				}
			}
		});
		viewHolder.add.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

				double newCount2 = ent.getTQTY();
				newCount2 = Arith.add(newCount2, ent.getDHPack());
				ent.setTQTY(newCount2);
				ent.setAmount(Arith.mul(newCount2, ent.getPrice()));
				viewHolder.count.setText(StringUtils.formatDouble(newCount2, "0.##"));
				if(ent.getTQTY() >= ent.getDHPack()) {
					viewHolder.subtract.setEnabled(true);
				}
			}
		});
		return convertView;
	}

	class ViewHolder {
		TextView name;
		TextView id;
		TextView count;
		CheckBox check;
		ImageButton subtract;
		ImageButton add;
		TextView kcuom;

	}

}