package com.urovo.wgmf.adapter;

import android.content.Context;
import android.graphics.Color;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.ui.TextColorDominator;

import java.util.List;

/**
 * 商品查询
 * 
 * @author Administrator
 * 
 */
public class GoodsChoseSingleAdapter extends BaseAdapter {
	private Context context;
	private List<ProductEntity> list;
	private String keyWord;//用于搜索的时候，关键字高亮显示

	public void setKeyWord(String keyWord){
		this.keyWord = keyWord;
	}

	public GoodsChoseSingleAdapter(Context context, List<ProductEntity> list) {
		this.context = context;
		this.list = list;
	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public ProductEntity getItem(int position) {

		if(position >= list.size())
			return null;
		else
			return list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return 0;
	}

	class ViewHolder {
		TextView name, no;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup arg2) {

		final ViewHolder holder;
		if(convertView == null) {
			holder = new ViewHolder();
			convertView = LayoutInflater.from(context).inflate(R.layout.second_addmenu_item, null);
			holder.name = (TextView) convertView.findViewById(R.id.goods_names);
			holder.no = (TextView) convertView.findViewById(R.id.goods_nums);
			convertView.setTag(holder);
		}
		else {
			holder = (ViewHolder) convertView.getTag();
		}
		ProductEntity data = list.get(position);
		if (!TextUtils.isEmpty(keyWord)){
            holder.name.setText(TextColorDominator.textColorChange( 0,Color.YELLOW, data.getItemName(), keyWord));
            holder.no.setText(TextColorDominator.textColorChange( 0,Color.YELLOW, data.getItemId(), keyWord));
        }else{
            holder.name.setText(data.getItemName());
            holder.no.setText(data.getItemId());
        }
        return convertView;
	}
}
