package com.urovo.wgmf.adapter;

import java.util.List;

import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.dao.Store001DbOprate;
import com.urovo.wgmf.db.dao.entitys.STORERXS001Entity;
import com.urovo.wugumofang.R;

public class SaleAuditAdapter extends BaseAdapter {
	private List<STORERXS001Entity> list;
	private BaseActivity context;

	public SaleAuditAdapter(List<STORERXS001Entity> list, BaseActivity context) {
		this.list = list;
		this.context = context;

	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Object getItem(int position) {

		return list == null ? null : list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		ViewHolder viewHolder;
		if(convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.second_sales_review_item, null);
			viewHolder = new ViewHolder();
			viewHolder.text1 = (TextView) convertView.findViewById(R.id.text1);
			viewHolder.text2 = (TextView) convertView.findViewById(R.id.text2);
			viewHolder.status = (TextView) convertView.findViewById(R.id.audit_status);
			convertView.setTag(viewHolder);
		}
		else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		String storeName = Store001DbOprate.GetStoreName(list.get(position).getSTOREID());
		viewHolder.text1.setText(storeName);
		viewHolder.text2.setText(list.get(position).getXTNET() + "");
		String type = list.get(position).getYN_HD();
		if(TextUtils.equals("1", type))// 已审核
		{
			viewHolder.status.setText("已审核");
			viewHolder.status.setTextColor(context.getResources().getColor(R.color.green_text_color));
			viewHolder.status.setCompoundDrawables(null, null, null, null);
		}
		else
		// 未审核
		{
			viewHolder.status.setText("未审核");
			viewHolder.status.setTextColor(context.getResources().getColor(R.color.text_normal_color));
			viewHolder.status.setCompoundDrawablesWithIntrinsicBounds(null, null, context.getResources().getDrawable(R.drawable.go), null);
		}
		return convertView;
	}

	class ViewHolder {
		TextView text1;
		TextView text2;
		TextView status;

	}

}
