package com.urovo.wgmf.adapter;

import android.content.Context;
import android.graphics.Paint;
import android.os.Build;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.CheckBox;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.squareup.picasso.Picasso;
import com.urovo.activity.salesdetailnet.model.SalesDetailModel;
import com.urovo.wgmf.db.dao.entitys.ProductsreturnList;
import com.urovo.wgmf.db.dao.entitys.SaleProductList;
import com.urovo.wugumofang.R;
import com.zsy.libext.widgets.clipboard.ClipboardUtil;
import com.zsy.libext.widgets.tips.ToastUtil;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;

/*销售明细:https://app.wgmf.com/app/datastatistics/getNewSaleDetail
 *  userId:673 storeId:1510011 startTimeStr:2018-03-02 endTimeStr:2018-03-02
 *  ないわ。。。目に余るわ。。。なんだこの様は！
 *  */
public class SaleDetailAdapter3 extends BaseExpandableListAdapter {
    @SuppressWarnings("all")
    private boolean onlyShow = false;
    @SuppressWarnings("all")
    private boolean nativeUppoad = false;
    private List<ProductsreturnList> parentslist = new ArrayList<>();
    private List<SaleProductList> childrenlist = new ArrayList<>();
    private Context context;
    private int type;//1线下 2会员商品

    private OnItemViewListener listener;

    public interface OnItemViewListener {
        void onViewListener(int groupPosition,String consId);
    }

    public SaleDetailAdapter3(int type, OnItemViewListener listener, List<ProductsreturnList> parentslist,List<SaleProductList> childrenlist, Context cxt, boolean show, boolean nUpload) {
        this.type = type;
        this.listener = listener;
        this.parentslist = parentslist;
        this.childrenlist = childrenlist;
        onlyShow = show;
        nativeUppoad = nUpload;
        context = cxt;
    }

    @Override
    public void notifyDataSetInvalidated() {
        // initList();
        super.notifyDataSetInvalidated();
    }

    @Override
    public void notifyDataSetChanged() {
        // initList();
        super.notifyDataSetChanged();
    }

    @SuppressWarnings("unused")
    public List<SaleProductList> getBackList() {
        return childrenlist;
    }

    @Override
    public int getGroupCount() {
         if (null == parentslist || parentslist.size() == 0) { return 0; }
        return parentslist.size();
    }

    @Override
    public int getChildrenCount(int groupPosition) {
        if (null == childrenlist || childrenlist.size() == 0) { return 0; }
        return childrenlist.size();
    }

    @Override
    public Object getGroup(int groupPosition) {
        return parentslist.get(groupPosition);
    }

    @Override
    public Object getChild(int groupPosition, int childPosition) {
        return childrenlist.get(childPosition);
    }

    @Override
    public long getGroupId(int groupPosition) {
        return groupPosition;
    }

    @Override
    public long getChildId(int groupPosition, int childPosition) {
        return childPosition;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int groupPosition, boolean isExpanded, View convertView, ViewGroup parent) {
        ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.sale_detail_list_item, parent, false);
            viewHolder = new ViewHolder();
            viewHolder.number = (TextView) convertView.findViewById(R.id.vip_number);
            viewHolder.time = (TextView) convertView.findViewById(R.id.sale_time);
            viewHolder.upload = (ImageView) convertView.findViewById(R.id.imageViewUpload);
            viewHolder.amount = (TextView) convertView.findViewById(R.id.amount);
            viewHolder.newIcon = (TextView) convertView.findViewById(R.id.new_icon);
            viewHolder.copyPhoneNum = (TextView) convertView.findViewById(R.id.copy_phone_num);
            viewHolder.storeSaleLayout = (LinearLayout) convertView.findViewById(R.id.storeSaleLayout);
            viewHolder.memberSaleLayout = (LinearLayout) convertView.findViewById(R.id.memberSaleLayout);
            viewHolder.querySalesDetailLl = (LinearLayout) convertView.findViewById(R.id.query_sales_detail_ll);
            viewHolder.headImg = (ImageView) convertView.findViewById(R.id.headImg);
            viewHolder.cusName2 = (TextView) convertView.findViewById(R.id.cusName2);
            viewHolder.cusTel2 = (TextView) convertView.findViewById(R.id.cusTel2);
            viewHolder.amountText = (TextView) convertView.findViewById(R.id.amountText);
            viewHolder.listArrow = (ImageView) convertView.findViewById(R.id.listArrow);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        //设置文本下划线
        setUnderline(viewHolder.copyPhoneNum);
        //线下不需要显示复制按钮，而是直接点击手机号复制
        viewHolder.storeSaleLayout.setVisibility(type == SalesDetailModel.TYPE_STORE_SALE ? View.VISIBLE : View.GONE);
        viewHolder.memberSaleLayout.setVisibility(type == SalesDetailModel.TYPE_STORE_SALE ? View.GONE : View.VISIBLE);

        final ProductsreturnList ent = parentslist.get(groupPosition);

        if (TextUtils.isEmpty(ent.cusMobile) || ent.cusMobile.startsWith("400-")) {
            viewHolder.number.setText("非会员");
            isVisible4View(viewHolder, View.VISIBLE, View.GONE);//if 可见，set 不可见
        } else {
            viewHolder.number.setText(ent.cusMobile);
            isVisible4View(viewHolder, View.GONE, View.VISIBLE);//if 不可见，set 可见
        }

        //会员商城情况
//        if (!TextUtils.isEmpty(ent.HeadImgUrl)) {//头像
        Picasso.with(context).load(ent.headImgUrl).placeholder(R.drawable.head).into(viewHolder.headImg);
//        }
        //名字==========
        if (!TextUtils.isEmpty(ent.name)) {
            viewHolder.cusName2.setText(ent.name);
            setUnderline(viewHolder.cusName2);
            setCopyTextListener(viewHolder.cusName2,ent.name, "昵称已复制！");
        }else{
            viewHolder.cusName2.setText("");
        }
        //电话================
        if (!TextUtils.isEmpty(ent.cusMobile)) {
            viewHolder.cusTel2.setText(ent.cusMobile);
            setUnderline(viewHolder.cusTel2);
            setCopyTextListener(viewHolder.cusTel2,ent.cusMobile, "手机号已复制！");
        }else{
            viewHolder.cusTel2.setText("");
        }

        //日期和时间换行显示
//        viewHolder.time.setText(TextUtils.isEmpty(ent.saleDateStr) ? "" : MessageFormat.format("{0} {1}", ent.saleDateStr.split(" ")[0], ent.saleDateStr.split(" ")[1]));
        //这里陈正说这个日期比较混乱，什么格式都有。。。为避免闪退，直接原样显示。
        viewHolder.time.setText(TextUtils.isEmpty(ent.saleDateStr) ? "" : ent.saleDateStr);
        viewHolder.amount.setText(ent.consAmount);
        if (type == SalesDetailModel.TYPE_STORE_SALE){
            viewHolder.newIcon.setVisibility(ent.isNewMember.equals("1") ?View.VISIBLE : View.INVISIBLE);//'1'是新客单 '0','-'等其它为非新客单
        }else{
            viewHolder.newIcon.setVisibility(ent.isNewMember.equals("1") ?View.VISIBLE : View.GONE);//'1'是新客单 '0','-'等其它为非新客单
        }

        //设置点击复制文本监听
        if (!TextUtils.isEmpty(ent.cusMobile) && !ent.cusMobile.startsWith("400-")) {
            setCopyTextListener(viewHolder.copyPhoneNum,ent.cusMobile, "手机号已复制！");
        }
        //门店销售-获取销售明细列表
        if(type == SalesDetailModel.TYPE_STORE_SALE) {
            viewHolder.querySalesDetailLl.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    listener.onViewListener(groupPosition, ent.consId);
                }
            });
        }else{
            viewHolder.querySalesDetailLl.setOnClickListener(null);
        }
        if (isExpanded) {
            viewHolder.listArrow.setImageResource(R.drawable.list_group_open);
        } else {
            viewHolder.listArrow.setImageResource(R.drawable.list_group_close);
        }
        return convertView;
    }

    /**
     * 判断当前控件的显示状态，如果当前显示就隐藏，隐藏就显示。
     *
     * @param viewHolder   ...
     * @param visibleKey   ...
     * @param visibleValue ...
     */

    private void isVisible4View(ViewHolder viewHolder, int visibleKey, int visibleValue) {
        if (viewHolder.copyPhoneNum.getVisibility() == visibleKey) {
            viewHolder.copyPhoneNum.setVisibility(visibleValue);
        }
    }

    /**
     * 给TextView添加下划线
     */
    private void setUnderline(TextView tv) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN) {
            tv.setBackground(null);
            tv.getPaint().setFlags(Paint.UNDERLINE_TEXT_FLAG); //下划线
            tv.getPaint().setAntiAlias(true);//抗锯齿
        }
    }

    /**
     * 点击复制文本监听
     */
    private void setCopyTextListener(TextView tv,String copyText, String alertMsg) {
        tv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                ClipboardUtil.copyText(context, copyText);// 复制到系统的剪切板
                ToastUtil.TextToast(context, alertMsg, Toast.LENGTH_LONG);
            }
        });
    }

    @Override
    public View getChildView(final int groupPosition, int childPosition, boolean isLastChild, View convertView, ViewGroup parent) {
        final ViewHolder holder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.sale_detail_list_child_item, parent, false);
            holder = new ViewHolder();
            holder.check = (CheckBox) convertView.findViewById(R.id.sale_back_check);
            holder.salereturn = (ImageView) convertView.findViewById(R.id.imageViewReturn);
            holder.name = (TextView) convertView.findViewById(R.id.sale_goods_name);
            holder.count = (TextView) convertView.findViewById(R.id.sale_goods_count_or_weight);
            holder.kcoum = (TextView) convertView.findViewById(R.id.sale_goods_kcuom);
            holder.price = (TextView) convertView.findViewById(R.id.sale_goods_price);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final SaleProductList entsun = childrenlist.get(childPosition);

        if (TextUtils.isEmpty(entsun.productNum)) {
            entsun.productNum = "0.0";
        }
        if (TextUtils.isEmpty(entsun.amount)) {
            entsun.amount = "0.0";
        }

        holder.name.setText(entsun.productName);
        holder.count.setText(entsun.productNum);
        holder.price.setText(entsun.amount);
        holder.kcoum.setText(MessageFormat.format("({0})", entsun.unitName));
        holder.salereturn.setVisibility(View.VISIBLE);
        //下面这些是从GoodsReturnAda.java里复制过来的。。。可以去那边参观
        if (Double.parseDouble(entsun.productNum) > 0 && Double.parseDouble(entsun.amount) <= 0) {//说明是赠品
            holder.salereturn.setImageResource(R.drawable.salegift);
        } else if (Double.parseDouble(entsun.productNum) <= 0) {//个数小于等于0，说明已退
            holder.salereturn.setImageResource(R.drawable.salereturn);
        } else {//如果非赠品，并且没有退货
            holder.salereturn.setVisibility(View.INVISIBLE);
        }
        // convertView.setBackgroundColor(0xFF606060);
        holder.check.setVisibility(View.INVISIBLE);

        return convertView;
    }

    @Override
    public boolean isChildSelectable(int groupPosition, int childPosition) {
        return true;
    }

    class ViewHolder {
        LinearLayout querySalesDetailLl;//会员信息布局
        TextView number;
        TextView time;
        ImageView upload;
        TextView amount;
        TextView name;
        TextView count;
        TextView kcoum;
        TextView price;
        CheckBox check;
        ImageView salereturn;
        ImageButton subtract;
        ImageButton add;
        TextView newIcon;//是否是新客 的标记
        TextView copyPhoneNum;//拷贝手机号
        TextView amountText;//“销售额"文字
        ImageView listArrow;//右端的列表展开收缩箭头
        LinearLayout storeSaleLayout;//线下时显示的小布局
        LinearLayout memberSaleLayout;//会员商城显示的小布局
        ImageView headImg;//头像
        TextView cusName2;//姓名
        TextView cusTel2;//电话
    }
}
