package com.urovo.wgmf.adapter;

import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.entitys.StockGoodsDetailEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.data.MoneyUtils;

import java.text.MessageFormat;
import java.util.List;

/**
 * @author ...
 */
public class StockGoodsAdapter extends BaseAdapter {
    private List<StockGoodsDetailEntity.DetailList> list;
    private BaseActivity context;

    public StockGoodsAdapter(BaseActivity context, List<StockGoodsDetailEntity.DetailList> list) {
        this.list = list;
        this.context = context;

    }

    public void setList(List<StockGoodsDetailEntity.DetailList> list) {
        this.list = list;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {
        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.second_stockgoodsmenu_item, parent, false);
            viewHolder = new ViewHolder();
            viewHolder.goodsNameTv = (TextView) convertView.findViewById(R.id.goods_name_tv);
            viewHolder.goodCodeAndUnitTv = (TextView) convertView.findViewById(R.id.good_code_and_unit_tv);
            viewHolder.lastMonthSalesTv = (TextView) convertView.findViewById(R.id.last_month_sales_tv);
            viewHolder.thisMonthSalesTv = (TextView) convertView.findViewById(R.id.this_month_sales_tv);
            viewHolder.justInTimeInventoryTv = (TextView) convertView.findViewById(R.id.just_in_time_inventory_tv);
            viewHolder.stockDayTv = (TextView) convertView.findViewById(R.id.stock_day_tv);
            viewHolder.jijiangLinqiTv = (TextView) convertView.findViewById(R.id.jijiang_linqi);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        StockGoodsDetailEntity.DetailList ent = list.get(position);
        viewHolder.goodsNameTv.setText(ent.getProductName());
        viewHolder.goodCodeAndUnitTv.setText(MessageFormat.format("{0} \n单位:{1}", ent.getProductNo(), ent.getProductUom()));
        viewHolder.lastMonthSalesTv.setText(TextUtils.equals(ent.getProductUom(), "kg") ? MoneyUtils.dynamicLastDF(ent.getOneMonthQty()) : MoneyUtils.dynamicLastDF(ent.getOneMonthQty()));
        viewHolder.thisMonthSalesTv.setText(TextUtils.equals(ent.getProductUom(), "kg") ? MoneyUtils.dynamicLastDF(ent.getShouHuoQty()) : MoneyUtils.dynamicLastDF(ent.getShouHuoQty()));
        viewHolder.justInTimeInventoryTv.setText(TextUtils.equals(ent.getProductUom(), "kg") ? MoneyUtils.dynamicLastDF(ent.getStockQty()) : MoneyUtils.dynamicLastDF(ent.getStockQty()));
        viewHolder.stockDayTv.setText(TextUtils.equals(ent.getProductUom(), "kg") ? MoneyUtils.dynamicLastDF(ent.getStockDays()) : MoneyUtils.dynamicLastDF(ent.getStockDays()));
        viewHolder.jijiangLinqiTv.setText(MoneyUtils.dynamicLastDF(ent.getProLqQty()));// 即将临期数量
        return convertView;
    }

    class ViewHolder {
        TextView goodsNameTv;
        TextView goodCodeAndUnitTv;
        TextView lastMonthSalesTv;
        TextView thisMonthSalesTv;
        TextView justInTimeInventoryTv;
        TextView stockDayTv;
        TextView jijiangLinqiTv;
    }
}
