package com.urovo.wgmf.more.ada;


import android.content.Context;
import android.graphics.Color;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;

import com.chad.library.adapter.base.BaseMultiItemQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.urovo.wgmf.more.ent.MoreOnlineBean;
import com.urovo.wgmf.more.ent.MultipleItem;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.ui.DensityUtil;
import com.wgmf.trade.utils.ImageLoader;

import org.jetbrains.annotations.NotNull;

import java.util.List;


/**
 * @author chenji
 */
public class MoreItemQuickAdapter extends BaseMultiItemQuickAdapter<MultipleItem, BaseViewHolder> {
    private Context mContext;

    /**
     * 添加type类型和布局(无顺序要求)
     */
    public MoreItemQuickAdapter(Context context, List<MultipleItem> data) {
        super(data);
        mContext = context;
        //副标题
        addItemType(MultipleItem.TEXT, R.layout.more_item_subtitle);
        //查看更多的布局和类型
        addItemType(MultipleItem.TEXT_IMG, R.layout.more_item_to_see);
        //各个菜单模块的布局和类型
        addItemType(MultipleItem.IMG_TEXT, R.layout.more_item_menu);
//      填充白色线条
        addItemType(MultipleItem.ITEM_HORIZONTAL_LINE, R.layout.item_hori_line);
        //body 子元素总数为奇数时填补空白
        addItemType(MultipleItem.IMG_TEXT_EMPTY, R.layout.more_item_menu);
        //未上传数据消息提醒
//        addItemType(MultipleItem.IMG_TEXT_IMG, R.layout.more_item_unupload_notice);
        //尾部--tips
        addItemType(MultipleItem.TEXT_FOOT_TIPS, R.layout.item_tips);
        //灰色线
        addItemType(MultipleItem.GRAY_HORIZONTAL_LINE, R.layout.item_hori_line);
    }


    @Override
    public void onBindViewHolder(@NonNull @NotNull BaseViewHolder holder, int position, @NonNull @NotNull List<Object> payloads) {
        super.onBindViewHolder(holder, position, payloads);
    }



    @Override
    protected void convert(BaseViewHolder helper, final MultipleItem item) {
        switch (helper.getItemViewType()) {
            case MultipleItem.TEXT:
                helper.setText(R.id.more_subtitle, item.getContent());
                break;

            case MultipleItem.IMG_TEXT:
                final MoreOnlineBean.ResultInfoBean.AndroidBean androidBean = (MoreOnlineBean.ResultInfoBean.AndroidBean) item.getT();
                final String iconUrl = androidBean.getPic();
                final String iconName = item.getContent();
                final int redCount = item.getCount();
                final int typeId = item.getTypeId();

                //判断红点在数据上传的位置才显示和隐藏
                if (typeId == 19) {
                    if (redCount > 0) {
                        helper.setVisible(R.id.un_up_count, true);
                        helper.setText(R.id.un_up_count, "" + redCount);
                    } else {
                        helper.setVisible(R.id.un_up_count, false);
                    }
                }

                helper.addOnClickListener(R.id.item_more_index);

                ImageView ivIcon = helper.getView(R.id.type_icon_iv);
                helper.setText(R.id.more_index_tv, iconName);
                ImageLoader.loadCircleImg(mContext, iconUrl, ivIcon,R.mipmap.img_default_face,R.mipmap.img_default_face);
//                Glide.with(mContext)
//                        .load(iconUrl)
//                        .centerCrop()
//                        .dontAnimate()//防止设置placeholder导致第一次不显示网络图片,只显示默认图片的问题
//                        .error(R.mipmap.img_default_face)
//                        .placeholder(R.mipmap.img_default_face)
//                        .into(ivIcon);
                break;

            // 查看更多
            case MultipleItem.TEXT_IMG:
                helper.addOnClickListener(R.id.more_item_to_see);
                break;

//            白色线条
            case MultipleItem.ITEM_HORIZONTAL_LINE:
                //线条设置颜色为白色
                helper.setBackgroundColor(R.id.item_horizontal_lines, Color.WHITE);
                //高度设置为18dp
                ViewGroup.LayoutParams headParams = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, DensityUtil.dip2px(mContext, 18));
                helper.getView(R.id.item_horizontal_lines).setLayoutParams(headParams);
                break;

            //中部item子元素为奇数不能铺满一行的情况下,需要用空白item填补
            case MultipleItem.IMG_TEXT_EMPTY:
                helper.setVisible(R.id.type_icon_iv, false);
                helper.setVisible(R.id.more_index_tv, false);
                break;
            case MultipleItem.GRAY_HORIZONTAL_LINE:
                ViewGroup.LayoutParams height = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, DensityUtil.dip2px(mContext, 48));
                helper.getView(R.id.item_horizontal_lines).setLayoutParams(height);
                break;
            default:
                break;
        }
    }
}
