package com.urovo.wgmf.more.net;

import com.urovo.wgmf.more.ent.MoreContractBean;
import com.urovo.wgmf.more.ent.MoreOnlineBean;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.urovo.wugumofang.response.Base3Response;
import com.zsy.libcore.model.bean.RequestResult;

import java.util.Map;

import io.reactivex.Observable;
import retrofit2.Call;

/**
 * 会员营销页面接口
 *
 * @author chenji last on 2018/1/2 19:51
 */

public class MoreNet {
    private IMoreNet mIMoreNet;

    /**
     * retrofit的配置
     */
    public MoreNet() {
        mIMoreNet = RetrofitHelper.createApi(IMoreNet.class);
    }

    /**
     * 更多页面
     *
     * @param map ...
     * @return ...
     */
    public Observable<MoreOnlineBean> getMoreList(Map<String, String> map) {
        return mIMoreNet.getMoreList(map);
    }

    /**
     * 更多页面合同条款弹窗
     */
    public Call<RequestResult<MoreContractBean>> queryContractDialog(String shopId, String staffId) {
        return mIMoreNet.queryContractDialog(shopId, staffId);
    }

    /**
     * 上传合同已读状态
     */
    public Call<Base3Response> submitContractRead(String staffId) {
        return mIMoreNet.submitContractRead(staffId);
    }
}
