package com.urovo.wgmf.tool;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.ActivityManager;
import android.content.Context;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RelativeLayout;

import com.urovo.wgmf.db.dao.dao.MsgOperate;
import com.urovo.wgmf.db.dao.dao.Table_toposDbOperate;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.libutils.R;
import com.urovo.wugumofang.manager.ThreadManager;
import com.urovo.wugumofang.system.BasePackageUtil;
import com.urovo.wugumofang.system.EnvironmentHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.view.VerticalViewPager;
import com.zsy.libcore.ui.act.SYActManager;

/**
 * Created by Sasuke on 2017/8/1.
 * 垂直ViewPager，专门放在LoginActivity里提供环境切换
 */
public class EnvViewPager extends VerticalViewPager {
    @SuppressWarnings("unused")
    private int mFingerNum = 0;

    public EnvViewPager(Context context) {
        this(context, null);
    }

    public EnvViewPager(Context context, AttributeSet attrs) {
        super(context, attrs);
        init();
    }

    private void init() {
        @SuppressLint("InflateParams") final RelativeLayout view = (RelativeLayout) LayoutInflater.from(context).inflate(R.layout.env_pager_ll, null);
        Button releaseBtn = (Button) view.findViewById(R.id.releaseBtn);
        Button betaBtn = (Button) view.findViewById(R.id.betaBtn);
        Button testBtn = (Button) view.findViewById(R.id.testBtn);
        releaseBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                switchEnvStatus(EnvironmentHelper.ENV_RELEASE);
            }
        });

        betaBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                switchEnvStatus(EnvironmentHelper.ENV_BETA);
            }
        });

        testBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                switchEnvStatus(EnvironmentHelper.ENV_TEST);
            }
        });

        View blankView = new ImageView(context);
        blankView.setAlpha(0);
        viewList.add(view);
        viewList.add(blankView);
        notifyDataSetChanged();
        setOverScrollMode(View.OVER_SCROLL_NEVER);//不需要那种拉到头的光晕效果
        setCurrentItem(1);
    }

    @SuppressLint("ClickableViewAccessibility")
    @Override
    public boolean onTouchEvent(MotionEvent ev) {
        switch (ev.getAction()) {
//            case MotionEvent.ACTION_DOWN:
//                mFingerNum = 1;
//                break;
//            case MotionEvent.ACTION_POINTER_DOWN:
//                mFingerNum +=1;
//                break;
//            case MotionEvent.ACTION_POINTER_UP:
//                mFingerNum -= 1;
//                break;
//            case MotionEvent.ACTION_UP:
//                mFingerNum = 2;
//                break;
            case MotionEvent.ACTION_MOVE:
                return ev.getPointerCount() == 3 && super.onTouchEvent(ev);
        }
       /* if(mFingerNum == 2){
            return super.onTouchEvent(ev);
        }else{
            return false;
        }*/
        return super.onTouchEvent(ev);
    }

    /**
     * 切换环境并清除缓存
     */
    private void switchEnvStatus(int type) {
        if (! PreferHelper.getInstance().setIntCommit(AppConstants.APIEnvironment.APP_ENVIRONMENT, type)){
            return;
        }
//        切换环境时清除基础资料时间戳
        ViewUtil.showProgress(context, "提示", "正在清除基础资料时间戳 和 促销活动 通知公告缓存....");
        ThreadManager.getThreadPool().execute(new Runnable() {
            @Override
            public void run() {
                Table_toposDbOperate.deleteBy(null);
                MsgOperate.deleteBy(null);//切换环境的时候把消息中心的这俩要用数据库的也清一下。
                ((Activity)context).runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        ViewUtil.dismissProgress();
                        //要杀掉第二进程
                        ((ActivityManager) context.getSystemService(Context.ACTIVITY_SERVICE)).killBackgroundProcesses(BasePackageUtil.getAppPackageName(context));
                        SYActManager.getInstance().AppExit();
                    }
                });
            }
        });
//        new Thread(new Runnable() {
//            @Override
//            public void run() {
//                Table_toposDbOperate.deleteBy(null);
//                MsgOperate.deleteBy(null);//切换环境的时候把消息中心的这俩要用数据库的也清一下。
//                new android.os.Handler().post(new Runnable() {
//                    @Override
//                    public void run() {
//                        ViewUtil.dismissProgress();
//                        SYActManager.getInstance().AppExit();
//                    }
//                });
//            }
//        }).start();
    }
}
