package com.urovo.wgmf.tool.netUtil;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.util.Log;

import com.qiniu.android.http.ResponseInfo;
import com.qiniu.android.storage.UpCompletionHandler;
import com.qiniu.android.storage.UploadManager;
import com.urovo.wugumofang.constants.ApiConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.BitmapUtil;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.MyToast;
import com.wgmf.trade.utils.PhotoUtil;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Sasuke on 2017/2/10.
 * 一整套的七牛操作全家桶（相当于曾经的QiNiuTokenTask）
 */

public class QiNiuDominator {
    //    public static String path = Files.photoPath;
    public static String SUCCESS = "SUCCESS";

    public static void uploadImages(List<String> photoList, final CompleteQiniu callback) {
        uploadImages(photoList, callback, null, false);
    }

    /**
     * 重载,添加上传图片失败回调接口
     */
    public static void uploadImages(List<String> photoList, final CompleteQiniu callback, final FailureQiniu callbackFailured, final boolean isCancleDialog) {
        int size = photoList.size();
        final String[] array = photoList.toArray(new String[size]);
        final List<String> ourUrls = new ArrayList<>();//把这些上传成功的七牛地址传一份到咱公司。
        new uploadTask(array.length, ourUrls, callback, callbackFailured, isCancleDialog).execute(array);
    }

    /**
     * 上传任务
     */
    private static class uploadTask extends AsyncTask<String, Integer, String> {
        List<String> ourUrls = new ArrayList<>();
        CompleteQiniu callback;
        FailureQiniu callbackFailured;
        boolean isCancleDialog;
        int successCount;

        public uploadTask(int successCount, List<String> ourUrls, final CompleteQiniu callback, final FailureQiniu callbackFailured, boolean isCancleDialog) {
            this.ourUrls.clear();
            this.ourUrls.addAll(ourUrls);
            this.callback = callback;
            this.callbackFailured = callbackFailured;
            this.isCancleDialog = isCancleDialog;
            this.successCount = successCount;
        }

        @Override
        protected void onPreExecute() {
            ourUrls.clear();
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            boolean isToast = true;//PreferHelper.getInstance().getBoolean(AppConstants.PreKeys.KAOQIN_IS_TOAST_FLAG, true);
            if ("-1".equals(s)) {
                ViewUtil.dismissProgress();
                if (isToast) {
                    MyToast.show("网络连接超时，请检查您的网络状态，稍后重试！");
                }
                if (callbackFailured != null) {
                    callbackFailured.onUpLoadFail("网络连接超时，请检查您的网络状态，稍后重试！");
                }
            } else if ("-2".equals(s)) {
                ViewUtil.dismissProgress();
                if (isToast) {
                    MyToast.show("获取图片Token失败!");
                }
                if (callbackFailured != null) {
                    callbackFailured.onUpLoadFail("获取图片Token失败!");
                }
            } else if ("-3".equals(s) && callbackFailured != null) {
                ViewUtil.dismissProgress();
                callbackFailured.onUpLoadFail("图片有问题，请重新选择");
            }
//            if (isCancleDialog) {
//                ViewUtil.dismissProgress();
//            }
        }

        @Override
        protected String doInBackground(final String... photoArray) {
            String tokenUrl = ApiConstants.releaseEnvServer + NetParam.URL_PRODUCT_TOKEN;
            Map<String, String> params = new HashMap<>();
            params.put("content", "");
//            BaseOldResponse response = (BaseOldResponse) OkHttpDominator.postSyn(tokenUrl, BaseOldResponse.class, params);
            BaseOldResponse response = (BaseOldResponse) OkHttpDominator.postSynTimeout(tokenUrl, params, BaseOldResponse.class, 10);

            if (response == null) {
                return "-1";
            } else if (!"0".equals(response.ret)) {
                return "-2";
            }
//                progressDialog.setTitle("正在上传图片");
            String tempToken = response.retInfo;
            for (String tempImgUrl : photoArray) {
                //以下进行图片压缩
                Bitmap mBitmap = BitmapFactory.decodeFile(tempImgUrl);
                int degree = BitmapUtil.getBitmapDegree(tempImgUrl);
                //说明拍照后被系统旋转了,那我们就要把它转回来
                if (degree != 0) {
                    mBitmap = BitmapUtil.rotateBitmapByDegree(mBitmap, degree);
                }
                if (mBitmap == null) {
                    return "-3";
                }
                byte[] bytes = BitmapUtil.compressBmp2Bytes(mBitmap, tempImgUrl, 100);//压缩到80KB以下（不用保存到本地，直接把bmp压成字节流传给七牛）
                String key = PhotoUtil.getFileUrlUUID(SystemHelper.LoginOrganId, SystemHelper.LoginUserId);
                UploadManager uploadManager = new UploadManager();
                //开始上传图片啦！！！！！！！！！！！！！
                uploadManager.put(bytes, key,
                        tempToken, new UpCompletionHandler() {
                            @Override
                            public void complete(String s, ResponseInfo responseInfo, JSONObject response) {
                                if (responseInfo.statusCode == 200 && response != null) {
                                    successCount--;
                                    cacheQiniuUrl(s, responseInfo, response, ourUrls);
                                    if (successCount == 0 && callback != null) {
//                                        FileUtil.deleteAll(new File(photoArray[0]));//清空图片缓存
                                        callback.uploadInfo(ourUrls);//上传完图片之后继续上传其它东西的操作。
                                    }
                                } else {
                                    if (callbackFailured != null) {
                                        callbackFailured.onUpLoadFail(responseInfo.error);
                                    }
                                }
                            }
                        }, null);
            }
            return "";
        }
    }

    /**
     * 七牛上传图片完成后的回调（这里要把返回的URL传给app.wgmf.com了）
     */
    public static void cacheQiniuUrl(String s, ResponseInfo responseInfo, JSONObject response, List<String> ourUrls) {
        if (response != null) {
            String json = response.toString();
            BaseOldResponse mTokenBean = PhotoUtil.parseTokenData(json);
            // 解析出返回的token
            if (null != mTokenBean && "0".equals(mTokenBean.getRet())) {
                String url = PhotoUtil.getRealUrl(mTokenBean.getRetInfo());
                ourUrls.add(url);//图片上传成功就把图片url再传一份到app.wgmf.com......
                Log.i("Log", "报文 [七牛传图返回]：" + url);
            }
        }
    }

    /**
     * 上传完图片之后调这个上传信息
     */
    public interface CompleteQiniu {
        void uploadInfo(List<String> qiniuUrl);
    }

    /**
     * 七牛上传图片失败
     */
    public interface FailureQiniu {
        void onUpLoadFail(String failInfo);
    }
}
