package com.urovo.wgmf.view;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.DashPathEffect;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.PathEffect;
import android.util.AttributeSet;
import android.widget.TextView;

public class DashedLine extends TextView {
	public DashedLine(Context context, AttributeSet attrs) {
		super(context, attrs);
	}

	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		Paint paint = new Paint();
		paint.setStyle(Paint.Style.STROKE);
		paint.setColor(getTextColors().getDefaultColor());
		Path path = new Path();
		path.moveTo(0, getHeight() / 2);
		path.lineTo(getWidth(), getHeight() / 2);
		PathEffect effects = new DashPathEffect(new float[]{ 3, 2, 3, 2 }, 1);
		// 长线，点距，短线，点距
		paint.setPathEffect(effects);
		canvas.drawPath(path, paint);
	}
}
