package com.urovo.wgmf.view;

import android.content.Context;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ListView;

public class InnerListView extends ListView {

	/**
	 * pull state,pull up or pull down;PULL_UP_STATE or PULL_DOWN_STATE
	 */
	int mLastMotionY;

	public InnerListView(Context context) {
		super(context);
		
	}

	public InnerListView(Context context, AttributeSet attrs) {
		super(context, attrs);
		
	}

	public InnerListView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		
	}

	@Override
	public boolean onInterceptTouchEvent(MotionEvent ev) {

		// 阻止父类拦截事件
		// if(!topFlag){
		// getParent().requestDisallowInterceptTouchEvent(true);
		// }

		return super.onInterceptTouchEvent(ev);
	}

	@Override
	public boolean onTouchEvent(MotionEvent ev) {

		int y = (int) ev.getRawY();
		switch (ev.getAction()) {
		case MotionEvent.ACTION_DOWN:
			// 首先拦截down事件,记录y坐标
			mLastMotionY = y;
			break;
		case MotionEvent.ACTION_MOVE:
			// deltaY > 0 是向下运动,< 0是向上运动
			int deltaY = y - mLastMotionY;
			if(deltaY > 0) {
				View child = getChildAt(0);
				if(child != null) {

					if(getFirstVisiblePosition() == 0 && child.getTop() == 0) {
						getParent().requestDisallowInterceptTouchEvent(false);
					}
					else {
						getParent().requestDisallowInterceptTouchEvent(true);
					}

					int top = child.getTop();
					int padding = getPaddingTop();
					if(getFirstVisiblePosition() == 0 && Math.abs(top - padding) <= 8) {// 这里之前用3可以判断,但现在不行,还没找到原因
						getParent().requestDisallowInterceptTouchEvent(false);

					}
					else {
						getParent().requestDisallowInterceptTouchEvent(true);
					}
				}
			}
			else {
				getParent().requestDisallowInterceptTouchEvent(true);
			}
			break;
		case MotionEvent.ACTION_UP:
		case MotionEvent.ACTION_CANCEL:
			break;
		}

		return super.onTouchEvent(ev);
	}

}
