package com.urovo.wgmf.zxing;

import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.BaseExpandableListAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.activity.data.DataBaseActivity;
import com.urovo.wgmf.AsyncTask.BaseAppServerTask;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.entity.response.SanXiangPaoDataResponse;
import com.urovo.wgmf.db.dao.entitys.SanXiangPaoEntity;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Sasuke on 2016/4/15.
 */
public class QuerySanXiangPaoData extends DataBaseActivity {
    private Map<String, String> params = new HashMap<String, String>();
    private List<SanXiangPaoEntity> mEntitys  = new ArrayList<SanXiangPaoEntity>();
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        search(mStoreId, null, mUserID, null, mDateFrom, mDateTo);
    }



    @Override
    protected boolean isExpandableList() {
        return false;
    }

    @Override
    protected String getTitleText() {
        return "新客三响炮数据";
    }

    @Override
    protected int getPopupWindowMode() {
        return StoreDateSelectorPop.STORE_DATE_SANXIANGPAO_DATA;
    }

    @Override
    protected BaseAdapter newBaseAdapter() {
        return new MyAdapter(mEntitys, this);
    }


    private class MyAdapter extends MyBaseAdapter{
        public MyAdapter(List mEntitys, Context context) {
            super(mEntitys, context);
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
           if(null == convertView) {
                convertView = getLayoutInflater().inflate(R.layout.ll_item_sanxiangpao, null);
            }
            LinearLayout backNumLayout = (LinearLayout)convertView.findViewById(R.id.ll_back_num);//回头人数布局
            LinearLayout backRateLayout = (LinearLayout)convertView.findViewById(R.id.ll_back_rate);//回头率布局
            TextView diffDay = (TextView) convertView.findViewById(R.id.diff_day);//天数
            TextView totalMembers = (TextView) convertView.findViewById(R.id.total_members);//目标回访数
            TextView careMembers = (TextView) convertView.findViewById(R.id.care_members);//已回访数
            TextView careRate = (TextView) convertView.findViewById(R.id.care_rate);//回访率
            TextView backNum = (TextView) convertView.findViewById(R.id.back_num);//回头人数
            TextView backRate =(TextView) convertView.findViewById(R.id.back_rate);//回头率

            SanXiangPaoEntity cell = mEntitys.get(position);
            int day = Integer.parseInt(cell.getDiffDay());
            switch(day){
                case 5:
                    diffDay.setText("5天冲调名单");
                    backNumLayout.setVisibility(View.GONE);
                    backRateLayout.setVisibility(View.GONE);
                    break;
                case 15:
                    diffDay.setText("15天鼓励名单");
                    backNumLayout.setVisibility(View.GONE);
                    backRateLayout.setVisibility(View.GONE);
                    break;
                case 45:
                    diffDay.setText("45天待回头名单");
                    backNum.setVisibility(View.VISIBLE);
                    backRate.setVisibility(View.VISIBLE);
                    break;
            }
            totalMembers.setText(cell.getTotalMembers());
            careMembers.setText(cell.getCareMembers());
            careRate.setText(cell.getCateRate());
            backNum.setText(cell.getBackNum());
            backRate.setText(cell.getBackRate());

            return convertView;
        }

    }

    @Override
    protected BaseExpandableListAdapter newExpandableAdapter() {
        return null;
    }

    @Override
    protected void requestConnectTask() {
        new BaseAppServerTask("query",
                SanXiangPaoDataResponse.class, this, "正在获取回访数据...",
                true, "/datastatistics/getMemberCareDatas", params).execute("");
    }

    @Override
    protected void search(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {
        if(null == dateFrom || null == dateTo)
            return;
        params.clear();
        params.put("storeId", id);
        params.put("userId", user);
        params.put("startTimeStr", dateFrom);
        params.put("endTimeStr", dateTo);
        requestConnectTask();
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if(!((BaseOldResponse)response).msgCode.equals("0")) {
            showMsg(response.msgContent);
            return;
        }else
            if ("query".equals(tag) && null != response) {
                mEntitys.clear();
                SanXiangPaoDataResponse res = (SanXiangPaoDataResponse) response;
                if (null != res.getList() && res.getList().size() > 0) {
                    List<SanXiangPaoEntity> entityList = (List<SanXiangPaoEntity>) res.getList();
                    for(SanXiangPaoEntity entity : entityList){
                        mEntitys.add(entity);
                    }
                }
            }
        mMyAdapter.notifyDataSetInvalidated();
    }
}
