package com.wgmf.trade;

import android.annotation.SuppressLint;
import android.app.Application;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

import com.taobao.sophix.SophixManager;
import com.taobao.sophix.listener.PatchLoadStatusListener;
import com.urovo.wugumofang.constants.AppConstants;
import com.wgmf.trade.utils.Reflect;
import com.wgmf.trade.wx.WXApp;

import org.apache.log4j.Logger;

import java.lang.reflect.Method;

public class GlobalApp extends WXApp {
    public final static int DEFAULT_TIME_OUT = 1000 * 15;
    private static final String TAG = "GlobalApp";//热修复log 过滤的tag
    //	public static MsgDisplayListener msgDisplayListener = null;
//	public static StringBuilder cacheMsg = new StringBuilder();
//	public static int mCode;
    public static Logger loger;
    public static SQLiteDatabase database;
    @SuppressLint("StaticFieldLeak")
    public static Application context;
    //    public Method logerMethod = null;
//    public Method databaseMethod = null;
    public Class cls = null;
    public WgmfAppLogic logic = null;
    public Method method = null;
//    public static boolean isOpen2SophixFlag = false;// 发布默认状态下是打开的，调试的时候调成false,防止打线上的补丁出错

    @Override
    protected void attachBaseContext(Context base) {
        super.attachBaseContext(base);
//        initHotfix();
        context = this;
        cls = Reflect.getClass("com.wgmf.trade.WgmfAppLogic");
        logic = (WgmfAppLogic) Reflect.newInstance(cls);
        method = Reflect.getMethod(cls, "attachBaseContext", Context.class);
        Reflect.invoke(method, logic, base);
    }

    /**
     * mode: 补丁模式, 0:正常请求模式 1:扫码模式 2:本地补丁模式
     * code: 补丁加载状态码, 详情查看PatchStatusCode类说明
     * info: 补丁加载详细说明, 详情查看PatchStatusCode类说明
     * handlePatchVersion: 当前处理的补丁版本号, 0:无 -1:本地补丁 其它:后台补丁
     * <p>
     * <p>
     * code 0: 准备开始拉取最新补丁
     * code: 1 补丁加载成功
     * code: 2 sdk初始化失败 加了setUnsupportedModel
     * code: 6 服务端没有最新可用的补丁
     * code: 8 补丁下载失败
     * code: 9 补丁下载成功
     * code: 11 RSASECRET错误，官网中的密钥是否正确请检查
     * code: 12 当前应用已经存在一个旧补丁, 应用重启尝试加载新补丁
     * code: 13 补丁加载失败, 导致的原因很多种, 比如UnsatisfiedLinkError等异常, 此时应该严格检查logcat异常日志
     * code: 14 找不到任何可加载的补丁文件 一种情况是确实没有，一种情况是需要考虑补丁文件可能放在sdcard等外部存储器中，sdk22以上版本机器需要6.0权限。
     * code: 16 APPSECRET错误，官网中的密钥是否正确请检查
     * code: 18 一键清除补丁
     * code: 19 连续两次queryAndLoadNewPatch()方法调用不能短于3s
     * errorCode:-101 异常
     * <p>
     */
    private void initHotfix() {
        String appVersion;
        try {
            appVersion = this.getPackageManager().getPackageInfo(this.getPackageName(), 0).versionName;
            Log.i(TAG, "appVersion==" + appVersion);
        } catch (Exception e) {
            appVersion = "3.4.0";
        }
        SophixManager.getInstance().setContext(this)
//                已过期，只在sdk2.0.9 使用
//                .setClearPreVerify(LibCoreApp.class)//过滤掉初始化不必要的父类，保证在application下初始化
//                .setClearPreVerify(LibExtApp.class)
//                .setClearPreVerify(WXApp.class)
//                .setClearPreVerify(GlobalApp.class)
                .setAppVersion(appVersion)
//                .setUnsupportedModel("2014501", android.os.Build.VERSION_CODES.KITKAT)//无法支持修复的机型加入黑名单

                //三个Secret分别对应AndroidManifest里面的三个,idSecret, appSecret, rsaSecret
                .setSecretMetaData(
                        AppConstants.Sophix.IDSECRET,
                        AppConstants.Sophix.APPSECRET,
                        AppConstants.Sophix.RSASECRET
                )
//                .setAesKey(null)
//                .setAesKey("2017042020170426")//16位任意数加密
                .setAesKey("wgmfsygj20170804")//16位任意数字字母组合加密
//                .setEnableDebug(true) // 调试的时候可以打开，过滤sophix看日志，绕过密码签名检验。
                .setPatchLoadStatusStub(new PatchLoadStatusListener() {
                    @Override
                    public void onLoad(final int mode, final int code, final String info, final int handlePatchVersion) {
//						String msg = new StringBuilder("").append("Mode:").append(mode)
//								.append(" Code:").append(code)
//								.append(" Info:").append(info)
//								.append(" HandlePatchVersion:").append(handlePatchVersion).toString();
//						if (msgDisplayListener != null) {
//							Log.i(TAG, "handle chenji-- " + code);
//							msgDisplayListener.handle(msg, code);
//						} else {
//							mCode = code;
//							Log.i(TAG, " chenji-- " + code);
//							cacheMsg.append("\n").append(msg);
//						}

//                        // 补丁加载回调通知
//                        if (code == PatchStatus.CODE_LOAD_SUCCESS) {
//                            // 表明补丁加载成功
//                            Log.i(TAG, "表明补丁加载成功");
//                        } else if (code == PatchStatus.CODE_LOAD_RELAUNCH) {
//                            // 表明新补丁生效需要重启. 开发者可提示用户或者强制重启;
//                            Log.i(TAG, "新补丁生效需要重启");
////                            android.os.Process.killProcess(android.os.Process.myPid());14 0 9 12 1
//                            // 建议: 用户可以监听进入后台事件, 然后应用自杀
//                        } else if (code == PatchStatus.CODE_LOAD_FAIL) {
//                            // 内部引擎异常, 推荐此时清空本地补丁, 防止失败补丁重复加载
//                            Log.i(TAG, "内部引擎异常, 推荐此时清空本地补丁, 防止失败补丁重复加载");
//                            // SophixManager.getInstance().cleanPatches();
//                        } else {
//                            Log.i(TAG, "其它错误信息, 查看PatchStatus类说明");
//                            // 其它错误信息, 查看PatchStatus类说明
//                        }

//                      监听代码执行的精确时间（看不到log时，执行adb shell setprop log.tag.GlobalApp VERBOSE）
//                        TimingLogger timingLogger = new TimingLogger(TAG, "Time");
//                        timingLogger.addSplit("\n Mode: " + mode + "\n Code: " + code + "， Info: " + info + "\n HandlePatchVersion: " + handlePatchVersion);
//                        timingLogger.dumpToLog();
                        Log.d(TAG, "\n Mode: " + mode + "\n Code: " + code + "， Info: " + info + "\n HandlePatchVersion: " + handlePatchVersion);
                    }
                }).initialize();
    }

    @Override
    public void onCreate() {
        super.onCreate();
        context = this;
        method = Reflect.getMethod(cls, "onCreate", Application.class);
        Reflect.invoke(method, logic, context);
    }

    @Override
    protected void initLib() {
        super.initLib();
        context = this;
        method = Reflect.getMethod(cls, "initLib", Application.class);
        Reflect.invoke(method, logic, context);
    }

    @Override
    public void onLowMemory() {
        super.onLowMemory();
        System.gc();
    }

//	public interface MsgDisplayListener {
//		void handle(String msg, int code);
//	}
}