package com.wgmf.trade;


import android.annotation.SuppressLint;
import android.app.ActivityManager;
import android.app.Application;
import android.content.Context;
import android.os.StrictMode;

import androidx.multidex.MultiDex;

import android.text.TextUtils;

//import com.huawei.hms.maps.MapsInitializer;
import com.tencent.bugly.crashreport.CrashReport;
import com.umeng.socialize.PlatformConfig;
import com.urovo.wugumofang.BuildConfig;
import com.urovo.wugumofang.constants.AppConfig;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.Files;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.PdaMsgConfig;
import com.zsy.libcore.LibCoreApp;
import com.zsy.libcore.config.LibCoreConfig;
import com.zsy.libcore.model.img.ImageLoaderHelper;
import com.zsy.libext.config.LibExtConfig;

import java.util.List;

import cn.jpush.android.api.JPushInterface;

import static com.wgmf.trade.GlobalApp.context;
import static com.wgmf.trade.GlobalApp.loger;

//import com.tencent.bugly.beta.Beta;

/**
 * Created by chenji on 2017/4/26.
 * 程序入口的logic封装类(反射访问)
 */
@SuppressWarnings("unused")
public class WgmfAppLogic {

//    public static org.apache.log4j.Logger loger;
//    public static SQLiteDatabase database;

    //各个平台的配置，建议放在全局Application或者程序入口
    static {
        PlatformConfig.setWeixin(NetParam.WXAPP_ID, NetParam.WXAPP_SECRET);
        //极光推送放这里会爆炸。
    }

    public String getProcessName(Context cxt, int pid) {
        ActivityManager am = (ActivityManager) cxt.getSystemService(Context.ACTIVITY_SERVICE);
        List<ActivityManager.RunningAppProcessInfo> runningApps = am.getRunningAppProcesses();
        if (runningApps == null) {
            return null;
        }
        for (ActivityManager.RunningAppProcessInfo procInfo : runningApps) {
            if (procInfo.pid == pid) {
                return procInfo.processName;
            }
        }
        return null;
    }

    public String getDeviceInfo(Context context) {
        try {
            org.json.JSONObject json = new org.json.JSONObject();
            android.telephony.TelephonyManager tm = (android.telephony.TelephonyManager) LibCoreApp.getInstance().getApplicationContext().getSystemService(Context.TELEPHONY_SERVICE);

            @SuppressLint("MissingPermission") String device_id = tm.getDeviceId();

            android.net.wifi.WifiManager wifi = (android.net.wifi.WifiManager) LibCoreApp.getInstance().getApplicationContext().getSystemService(Context.WIFI_SERVICE);

            String mac = wifi.getConnectionInfo().getMacAddress();
            json.put("mac", mac);

            if (TextUtils.isEmpty(device_id)) {
                device_id = mac;
            }

            if (TextUtils.isEmpty(device_id)) {
                device_id = android.provider.Settings.Secure.getString(context.getContentResolver(), android.provider.Settings.Secure.ANDROID_ID);
            }

            json.put("device_id", device_id);

            return json.toString();
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
        }
        return null;
    }

    public void onCreate(Application context) {
        try {
            String processName = getProcessName(context, android.os.Process.myPid());
            if (processName != null) {
                boolean defaultProcess = processName.equals(context.getPackageName());
                if (defaultProcess) {
                    init(context);
                }
            } else {
                init(context);
            }
            //极光推送
            JPushInterface.init(context);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * =================Application初始化 的都在这里做=================
     */
    protected void initLib(Application context) {
        BaseAppManager.init(context);//组件化的Applilcation初始化
        GlobalApp.loger = BaseAppManager.loger();
        GlobalApp.database = BaseAppManager.database();
//        Stetho.initializeWithDefaults(context);
        LibCoreConfig.IS_DEBUG_ENABLE = BuildConfig.DEBUG;
        LibExtConfig.IS_DEBUG_ENABLE = BuildConfig.DEBUG;
        LibCoreConfig.API_URL = AppConfig.APP_URL;
        LibCoreConfig.DB_NAME = AppConfig.APP_NAME;
        ImageLoaderHelper.getInstance(context)
                .init(ImageLoaderHelper.getInstance(context)
                        .getImageLoaderConfiguration(AppConstants.Paths.IMAGE_LOADER_CACHE_PATH));

        //禁用Canary系列
//        if (BuildConfig.DEBUG) {
//            if (LeakCanary.isInAnalyzerProcess(context)) {
//                // This process is dedicated to LeakCanary for heap analysis.
//                // You should not init your app in this process.
//                return;
//            }
//            LeakCanary.install(context);
//            BlockCanary.install(context, new AppBlockCanaryContext()).start();
//            //initStrictMode();
//        }
    }

    //	@Override protected void initDBRealmConfig() {
//		//RealmConfiguration config = new RealmConfiguration.Builder(getApplicationContext()).name(AppConstants.DB.REALM_DB_NAME).build();
//		//Realm.setDefaultConfiguration(config);
//	}

    private void initStrictMode() {
        StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder()
                .detectDiskReads()
                .detectDiskWrites()
                .detectNetwork()   // or .detectAll() for all detectable problems
                .penaltyLog()
                .build());
        StrictMode.setVmPolicy(new StrictMode.VmPolicy.Builder()
                .detectLeakedSqlLiteObjects()
                .detectLeakedClosableObjects()
                .penaltyLog()
                .penaltyDeath()
                .build());
    }

    private void init(Application context) {
//		//检测内存溢出配置
//		if (BuildConfig.DEBUG) {
//			refWatcher = LeakCanary.install(this);
//			BlockCanary.install(this, new AppBlockCanaryContext()).start();
//		}

        try {
//            context = getApplicationContext();
            Files.createFile(context);
//            loger = ConfigureLog4J.configure(Files.logfile,"WGMF");

            if (!BuildConfig.DEBUG) {
                //loger.shutdown();//正式版打包时开启，屏蔽Log
            }
            loger.info("五谷磨房程序启动");
            loger.info(getDeviceInfo(context));
            // CrashHandler crashHandler = CrashHandler.getInstance();
            // crashHandler.init(getApplicationContext());

            CrashReport.initCrashReport(context, NetParam.BUGLY_APP_ID, false);

//            database = e;
        } catch (Exception e) {
//            if (null == loger) {
//                Toast.makeText(context, "log is not exist!", Toast.LENGTH_LONG);
//            }
            if (loger != null) {
                loger.info("WgmfAppLogic.onCreate" + e);
            }
        }
        /**
         * 检测是否为POS机
         */
        if ("Android".equals(android.os.Build.MODEL) || "A4".equals(android.os.Build.MODEL) || "A4_PLUS".equals(android.os.Build.MODEL)) {
            PdaMsgConfig.setIsPDA(true, context);
        } else {
            PdaMsgConfig.setIsPDA(false, context);
        }

        /**
         * 检测是否为终端机，需要绑定管理员密码
         */
        if ("S8-701u".equals(android.os.Build.MODEL) || "S8-701w".equals(android.os.Build.MODEL) || "T1-823L".equals(android.os.Build.MODEL) || "Android".equals(android.os.Build.MODEL) || "A4".equals(android.os.Build.MODEL) || "A4_PLUS".equals(android.os.Build.MODEL)) {
            PdaMsgConfig.setIsTerminal(true, context);
        } else {
            PdaMsgConfig.setIsTerminal(false, context);
        }

//        MapsInitializer.setApiKey("DQEDAKNKezbVPpUxXIC8qDUL63i3d14MfTpACeMWnrDi+VfeHhBZ9HtuPnfrAFuRPXZzfvkTQpMZ1UdkFNT7vqZsJbMXT3EW6P4j4A==");
    }

    protected void attachBaseContext(Context base) {
        MultiDex.install(context);
        // 安装tinker,注：Tinker不支持应用加固
//        Beta.installTinker();
    }
}