package com.wgmf.trade.model.bean;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * 会员活动Item(离线、全场),故加入自定义属性；isVip;用于区分
 *
 * @author samy
 * @date 16/9/6
 */
public class MemberAction implements Serializable {

    /**
     *  Retinfo«List«ActivityInfo»» {
     msgCode (integer, optional): 状态码,状态码等于0说明成功 ,
     msgInfo (string, optional): 状态说明 ,
     resultInfo (Array[ActivityInfo], optional): 结果集
     }

     ActivityInfo {
     activityId (integer, optional): 活动ID ,
     checkCodeOrNot (integer, optional): 是否校验验证码(0.不验证 1.验证) ,
     checkRuleOrNot (integer, optional): 是否验证规则(0.不验证 1.验证) ,
     content (string, optional): 活动内容 ,比如常规销售
     endTime (string, optional): 活动结束时间 ,
     giftRule (ActivityRuleGift, optional): 活动规则赠送详情 ,
     name (string, optional): 活动名称 ,
     rule (ActivityRule, optional): 活动规则购买详情 ,
     startTime (string, optional): 活动开始时间
     }

     ActivityRuleGift {
     giftDiscount (number, optional): 活动折扣 ,
     giftMoney (number, optional): 活动赠送金额 ,
     giftPoint (integer, optional): 活动赠送积分 ,
     giftPointMultiple (number, optional): 活动赠送积分倍数 ,
     giftProGroupInfo (Array[ProGroupInfo], optional): 赠送产品组合 ,
     giftProductInfo (Array[ProductInfo], optional): 赠送产品
     }

     ActivityRule {
     money (number, optional): 活动满足金额 ,
     point (integer, optional): 活动所需积分 ,
     proGroupInfo (Array[ProGroupInfo], optional): 所需产品组合 ,
     productInfo (Array[ProductInfo], optional): 所需产品
     }

     ProGroupInfo {
     num (string, optional): 产品数量 ,
     product (Array[ProductBasic], optional): 产品基本信息
     }

     ProductInfo {
     code (string, optional): 产品编码 ,
     name (string, optional): 产品名称 ,
     num (string, optional): 产品数量 ,
     price (number, optional): 产品价格 ,
     specialPrice (number, optional): 特价
     }

     ProductBasic {
     code (string, optional): 产品编码 ,
     name (string, optional): 产品名称 ,
     price (number, optional): 产品价格 ,
     specialPrice (number, optional): 特价
     }
     */

    /**
     * activityId : 0
     * checkCodeOrNot : 0
     * checkRuleOrNot : 0
     * content : string
     * endTime : string
     * giftRule : {"giftDiscount":0,"giftMoney":0,"giftPoint":0,"giftPointMultiple":0,"giftProGroupInfo":[{"num":"string","product":[{"code":"string","name":"string","price":0,"specialPrice":0}]}],"giftProductInfo":[{"code":"string","name":"string","num":"string","price":0,"specialPrice":0}]}
     * name : string
     * rule : {"money":0,"point":0,"proGroupInfo":[{"num":"string","product":[{"code":"string","name":"string","price":0,"specialPrice":0}]}],"productInfo":[{"code":"string","name":"string","num":"string","price":0,"specialPrice":0}]}
     * startTime : string
     */
    /**
     * 全场活动 不参与销售标记、1不参加 0参加，不参加时，不显示“继续添加按钮”
     */
    public int notjoinsale = 0;
    public int activityId;
    public int checkCodeOrNot;
    public int checkRuleOrNot;
    public String content;
    public String endTime;
    public RuleBean rule;
    public GiftRuleBean giftRule;
    public String name;
    public String startTime;
    public int arriveHome;//支持到家业务：1:是，0:不是
    public int stick;//是否置顶（0.不置顶 1.置顶）//后端来做排序，app端什么都不需要做
    /**
     * 是否赠送产品积分（0.送 1.不送）,用于提交订单是用
     */
    public int sentProPointOrNot;

    /**
     * 是否可参加活动；
     * 默认为：0；都可以参加；
     * 1:商品  只要一个itemId对应不上；
     * 2:商品组合 全部itemId对应不上。如果没有的要移除掉；
     * 3:赠品 只要一个itemId对应不上；
     * 4:赠品组合 全部itemId对应不上。如果没有的要移除掉；
     */
    private boolean isCanJoin = true;

    /**
     * 活动类型：0.专享活动 1.全场活动;2:常规活动
     * ps:0.专享活动 1.全场活动;不在使用isVip判断
     */
    public int actType;

    /**
     * 活动类型：activityType (integer, optional):

     活动类型：1.买送活动 2.满赠活动 ……大于14特殊活动 , 9 特价活动
     *
     */
    public int activityType;

    /**
     * 0: 五谷磨房；1：鲜稻研
     */
    public int brandType;

    /**
     * 是否是全场折扣（0.不是，1.是）
     */
    public int allDiscountOrNot;

    /**品牌校验，1：只允许五谷产品，2：只允许散装，3：不限制产品*/
    /**新增多品牌混录活动之后，满减情况，因为第二品牌不能打印，所以要与第一品牌分开。
     * 这样就无法确定应该把减的价格分配到哪个
     * 所以就新增这个字段，避开满减活动&&多品牌混录 同时发生的情况*/
    public int brandCheck;

    public static class RuleBean implements Serializable {
        public float money;
        public float point;
        /**
         * 组合产品（比如十方） 集合模型
         */
        public ArrayList<ProGroupInfoBean> proGroupInfo;
        /**
         * 单品（核桃）集合模型
         */
        public ArrayList<ProductInfoBean> productInfo;
        /**
         * 规则提示
         */
        public String groupTip;

        @Override
        public String toString() {
            return "RuleBean{" +
                    "money=" + money +
                    ", point=" + point +
                    ", proGroupInfo=" + proGroupInfo +
                    ", productInfo=" + productInfo +
                    ", groupTip='" + groupTip + '\'' +
                    '}';
        }
    }

    public static class GiftRuleBean implements Serializable {
        public double giftDiscount;
        public double giftMoney;
        public double giftPoint;
        public double giftPointMultiple;
        public ArrayList<ProGroupInfoBean> giftProGroupInfo;
        /**
         * 赠送产品
         */
        public ArrayList<ProductInfoBean> giftProductInfo;

        @Override
        public String toString() {
            return "GiftRuleBean{" +
                    "giftDiscount=" + giftDiscount +
                    ", giftMoney=" + giftMoney +
                    ", giftPoint=" + giftPoint +
                    ", giftPointMultiple=" + giftPointMultiple +
                    ", giftProGroupInfo=" + giftProGroupInfo +
                    ", giftProductInfo=" + giftProductInfo +
                    '}';
        }
    }

    public boolean isCanJoin() {
        return isCanJoin;
    }

    public void setCanJoin(boolean canJoin) {
        isCanJoin = canJoin;
    }


    /**
     * true表示不为空
     */
    public boolean checkProArrayNull(ArrayList<ProductInfoBean> productInfoBean) {
        return productInfoBean != null && productInfoBean.size() > 0;
    }

    public boolean checkGroupArrayNull(ArrayList<ProGroupInfoBean> proGroupInfoBeen) {
        return proGroupInfoBeen != null && proGroupInfoBeen.size() > 0;
    }

    @Override
    public String toString() {
        return "MemberAction{" +
                "notjoinsale=" + notjoinsale +
                ", activityId=" + activityId +
                ", checkCodeOrNot=" + checkCodeOrNot +
                ", checkRuleOrNot=" + checkRuleOrNot +
                ", content='" + content + '\'' +
                ", endTime='" + endTime + '\'' +
                ", rule=" + rule +
                ", giftRule=" + giftRule +
                ", name='" + name + '\'' +
                ", startTime='" + startTime + '\'' +
                ", sentProPointOrNot=" + sentProPointOrNot +
                ", isCanJoin=" + isCanJoin +
                ", actType=" + actType +
                ", brandType=" + brandType +
                '}';
    }
}
