package com.wgmf.trade.model.data.net.Interceptor;

import com.wgmf.trade.GlobalApp;
import com.zsy.libcore.common.other.NetUtil;
import java.io.IOException;
import okhttp3.CacheControl;
import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;

/**
 * 缓存拦截器
 * Created by samy on 16/11/4.
 */

public class CacheInterceptor implements Interceptor {

  @Override public Response intercept(Chain chain) throws IOException {
    Request request = chain.request();
    if (!NetUtil.hasAvailableNet(GlobalApp.getInstance())) {
      request = request.newBuilder().cacheControl(CacheControl.FORCE_CACHE).build();
    }
    Response response = chain.proceed(request);
    if (NetUtil.hasAvailableNet(GlobalApp.getInstance())) {// 有网络时 设置缓存超时时间0个小时
      int maxAge = 0;
      response.newBuilder()
          .header("Cache-Control", "public, max-age=" + maxAge)
          .removeHeader("my_samy")// 清除头信息，因为服务器如果不支持，会返回一些干扰信息，不清除下面无法生效
          .build();
    } else {// 无网络时，设置超时为4周
      int maxStale = 60 * 60 * 24 * 28;
      response.newBuilder()
          .header("Cache-Control", "public, only-if-cached, max-stale=" + maxStale)
          .removeHeader("nyn")
          .build();
    }
    return response;
  }
}
  //File cacheFile = new File(DemoApplication.getContext().getExternalCacheDir(), "SamyCache");
  //Cache cache = new Cache(cacheFile, 1024 * 1024 * 50);
//builder.cache(cache).addInterceptor(cacheInterceptor);

