package com.wgmf.trade.model.data.net.Interceptor;

import java.io.IOException;
import okhttp3.Headers;
import okhttp3.HttpUrl;
import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;

/**
 * 公共参数拦截器
 * Created by samy on 16/11/4.
 */

public class CommonParamInterceptor implements Interceptor {
  @Override public Response intercept(Chain chain) throws IOException {

    Request originalRequest = chain.request();
    Request request;
    String method = originalRequest.method();
    Headers headers = originalRequest.headers();
    HttpUrl modifiedUrl = originalRequest.url()
        .newBuilder()
        .addQueryParameter("platform", "android")
        .addQueryParameter("version", "1.0.0")
        .build();// Provide your custom parameter here
    request = originalRequest.newBuilder().url(modifiedUrl).build();
    return chain.proceed(request);
  }
}

//公共参数
//builder.addInterceptor(addQueryParameterInterceptor);
