package com.wgmf.trade.model.data.net;

import com.urovo.wugumofang.constants.ApiUrls;
import com.wgmf.trade.model.bean.MemberAction;
import com.zsy.libcore.model.bean.RequestResult;

import java.util.List;

import retrofit2.Call;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.Query;

/**
 *
 *
 * @author samy
 * @date 16/9/7
 */
public interface MemberActionListDataNet {

  /**
   * 全场活动列表(可离线)
   * @param storeId 店id
   * @return 响应数组
   */
  //@Headers("Cache-Control: max-age=60 * 60 * 24 * 7")
  @GET(ApiUrls.PROMOTION.OFFLINE_COMMON_ACTIVITY)
  Call<RequestResult<List<MemberAction>>> offlineCommonActionList(
          @Query("storeId") String storeId, @Query("saledate") String saledate, @Query("brandList") String brandList
  );

  /**
   * 专享活动列表(不可离线)
   * @param storeId 店id
   * @param phone 会员手机号
   * @return 响应数组
   */
  @GET(ApiUrls.PROMOTION.OFFLINE_VIP_ACTIVITY)
  Call<RequestResult<List<MemberAction>>> offlineVipActionList(
          @Query("storeId") String storeId, @Query("phone") String phone, @Query("saledate") String saledate, @Query("brandList") String brandList
  );

  /**
   * 查询会员剩余积分
   * @param phone 会员手机号
   * @return ...
   */
  @GET(ApiUrls.PROMOTION.CUS_REMAINS_POINTS)
  Call<RequestResult<Float>> remainsPoints(@Query("phone") String phone);


  /**
   * 查询是否显示到家销售按钮
   */
  @POST(ApiUrls.APP.CAN_HAVE_2_HOME_BIZ)
  Call<RequestResult<Boolean>> canHave2HomeBiz(@Query("storeNo") String storeNo);

}
