package com.wgmf.trade.model.data.net;

import com.urovo.activity.goodsmanager.model.OrderCommonEntity;
import com.urovo.wgmf.db.dao.entitys.DingHuoOplQtyEntity;
import com.urovo.wgmf.entity.response.DingHuoQueryResponse;
import com.urovo.activity.goodsmanager.model.OrderDeliveryDifferenceQueryEntity;
import com.urovo.activity.goodsmanager.model.OrderGoodsQueryEntity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.wgmf.trade.model.bean.OrderSubmitReqBean;
import com.zsy.libcore.model.bean.RequestResult;

import java.util.List;

import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.Query;

/**
 * Created by samy on 16/12/22.
 */
public interface OrderGoodDataNet {

    @GET(ApiUrls.MINISTRY.EnvPort)
    Call<DingHuoQueryResponse> selectOrderedList(@Query("action") String action, @Query("method") String method, @Query("content") String content);

    @GET(ApiUrls.APP.IS_CAN_ORDERING)
    Call<RequestResult<String>> isCanOrdering(@Query("storeId") String storeId, @Query("userId") String userId);

    @GET(ApiUrls.APP.GET_ORDER_LIST)
    Call<RequestResult<DingHuoOplQtyEntity.ResultInfo>> getOrderList(@Query("storeId") String storeId, @Query("staffId") String staffId, @Query("brands") String brands);

    @POST(ApiUrls.APP.ORDER_SUBMIT)
    Call<RequestResult<String>> orderSubmit(@Body OrderSubmitReqBean orderSubmitReqBean);

    @POST(ApiUrls.APP.GET_ORDER_COMMON_LIST)
    Call<RequestResult<List<OrderCommonEntity>>> getOrderCommonList(@Query("storeId") String storeId);

    @POST(ApiUrls.APP.ORDER_GOODS_DETAIL)
    Call<RequestResult<List<OrderGoodsQueryEntity>>> getOrderGoodsDetail(@Query("storeNo") String storeNo, @Query("beginDate") String beginDate, @Query("endDate") String endDate);

    @POST(ApiUrls.APP.ORDER_GOODS_Diff)
    Call<RequestResult<List<OrderDeliveryDifferenceQueryEntity>>> getOrderGoodsDiff(@Query("storeNo") String storeNo, @Query("beginDate") String beginDate, @Query("endDate") String endDate);

}
