package com.wgmf.trade.model.data.net;

import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.response.BaseSimpleResponse;
import com.wgmf.trade.model.bean.QualityBackResultBean;
import com.zsy.libcore.model.bean.RequestResult;
import java.util.List;
import retrofit2.Call;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.Query;

/**
 * Created by samy on 17/1/19.
 */

public interface QualityBackResultDataNet {
  /**
   * @param staffid 员工id
   * @param shopId 门店id
   * @param type 查询类型0:所有，1：未处理和处理中，2：已处理
   * @param workFlowId 流程类型： 721到货误差，2181柜子，质量问题 2421，内部投诉2441
   * @return
   */
  @GET(ApiUrls.APPSALER.OA_WORKFLOW_GET_WORK_FLOW_INFO)
  Call<RequestResult<List<QualityBackResultBean>>> getTypeList(
          @Query("staffid") String staffid,
          @Query("shopId") String shopId,
          @Query("type") String type,
          @Query("workFlowId") String workFlowId
  );

  @POST(ApiUrls.APPSALER.OA_WORKFLOW_SUBMIT_PJ)
  Call<RequestResult<BaseSimpleResponse>> submitPj(
          @Query("id") String id,
          @Query("problemType") int problemType,
          @Query("pj") int pj,
          @Query("content") String content,
          @Query("staffId") String staffId
  );
}
