package com.wgmf.trade.presenter;

import com.google.gson.Gson;
import com.urovo.activity.customerlabel.model.CustomerLabelEntity;
import com.urovo.activity.customerlabel.model.CustomerLabelReqEntity;
import com.urovo.activity.customerlabel.service.ApiService;
import com.urovo.wgmf.entity.response.WeiXinJiaFenResponse;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.net.ApiException;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.urovo.wugumofang.net.callback.RetrofitCallback;
import com.wgmf.trade.model.bean.MemberInfo;
import com.wgmf.trade.model.data.net.MemberInfoDataNet;
import com.wgmf.trade.view.MemberDetailCon;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.model.bean.RequestResult;
import com.zsy.libcore.model.bean.ResultCallback;
import com.zsy.libcore.presenter.impl.BasePresenterImpl;

import org.jetbrains.annotations.NotNull;

import java.util.HashMap;
import java.util.List;

import okhttp3.Request;
import retrofit2.Call;
import retrofit2.Response;

/**
 * 会员信息
 * Created by samy on 16/9/12.
 */
public class MemberDetailPre extends BasePresenterImpl implements MemberDetailCon.Pre {

    private MemberInfoDataNet memberInfoDataNet;

    private ApiService apiService;

    public MemberDetailPre(MemberDetailCon.View mMvpView) {
        super(mMvpView);
        memberInfoDataNet = RetrofitHelper.createApi(MemberInfoDataNet.class);

        apiService = RetrofitHelper.createNewApi(ApiService.class);
    }

    @Override
    public void getMemberInfo(String userId, String shopId, String customerMobile) {
        Call<RequestResult<MemberInfo>> memberInfo = memberInfoDataNet.getMemberInfo(userId, shopId, customerMobile);
        memberInfo.enqueue(new ResultCallback<MemberInfo>() {
            @Override
            public void onResponse(Call<RequestResult<MemberInfo>> call,
                                   Response<RequestResult<MemberInfo>> response) {
                super.onResponse(call, response);
                RequestResult<MemberInfo> body = response.body();

                if (response.isSuccessful() && body != null) {
                    if (body.msgCode == 0 && getMvpView().isActive()) {
                        ((MemberDetailCon.View) getMvpView()).showMemberInfo(body.resultInfo);
                    }
                    SYLoger.print("wgmf--> onResponse: " + body.resultInfo);
                    SYLoger.print("wgmf--> onResponse: =======" + response.isSuccessful() + "=======" + body.msgCode);
                }
            }
        });
    }

    @Override
    public void getWeiXibJiaFen(String qrcodeticket, String phoneNo, String staffNo, String storeId) {
        HashMap<String, String> param = new HashMap<>();
        param.put("qrcodeticket", qrcodeticket);
        param.put("phoneNo", phoneNo);
        param.put("staffNo", staffNo);
        param.put("storeId", storeId);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.WEIXIN_SAOMA_JIAFEN,
                param, new OkHttpDominator.ResultCallback<WeiXinJiaFenResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {

                    }

                    @Override
                    public void onResponse(WeiXinJiaFenResponse res) {
                        if (res != null && res.msgCode.equals("0") && getMvpView().isActive()
                                && res.returnBean != null) {
                            PreferHelper.getInstance().setString(AppConstants.PreKeys.WE_MEMBER_DETAIL, new Gson().toJson(res.returnBean));
                            ((MemberDetailCon.View) getMvpView()).showIsWeMember(res.returnBean);
                        }
                    }
                });
    }

    @Override
    public void getLabelList(String mobile) {
        apiService.labelList(new CustomerLabelReqEntity(mobile))
                .enqueue(new RetrofitCallback<RequestResult<List<CustomerLabelEntity>>>() {

                    @Override
                    public void onResponse(@NotNull Call<RequestResult<List<CustomerLabelEntity>>> call,
                                           @NotNull Response<RequestResult<List<CustomerLabelEntity>>> response) {
                        RequestResult<List<CustomerLabelEntity>> body = response.body();
                        if (response.isSuccessful() && body != null) {
                            if (body.msgCode == AppConstants.Http.RESPONSE_SUCCESS && getMvpView().isActive()) {
                                ((MemberDetailCon.View) getMvpView()).showLabelList(body.payload);
                            }
                        }
                    }

                    @Override
                    protected void onFailure(@NotNull ApiException exception) {

                    }
                });
    }

    @Override
    public void start() {

    }
}
