package com.wgmf.trade.presenter;

import com.urovo.wugumofang.data.MoneyUtils;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.urovo.wugumofang.response.Base3Response;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.utils.MyToast;
import com.wgmf.trade.GlobalApp;
import com.wgmf.trade.model.bean.EnjoyDiscountRequestBean;
import com.wgmf.trade.model.bean.MemGoodsOrderBean;
import com.wgmf.trade.model.bean.MemberAction;
import com.wgmf.trade.model.bean.ProductInfoBean;
import com.wgmf.trade.model.data.net.MemberSalesDataNet;
import com.wgmf.trade.view.MemberSalesCon;
import com.zsy.libcore.model.bean.RequestResult;
import com.zsy.libcore.model.bean.ResultCallback;
import com.zsy.libcore.presenter.impl.BasePresenterImpl;
import com.zsy.libext.widgets.tips.ToastMsg;

import java.net.SocketTimeoutException;
import java.util.ArrayList;
import java.util.List;

import okhttp3.ResponseBody;
import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * 会员主页>会员销售
 * Created by samy on 16/9/6.
 */
public class MemberSalesPre extends BasePresenterImpl implements MemberSalesCon.Pre {
    private MemberSalesDataNet memberSalesDataNet;


    public MemberSalesPre(MemberSalesCon.View view) {
        super(view);
        memberSalesDataNet = RetrofitHelper.createApi(MemberSalesDataNet.class);
    }

    public static void main(String[] args) {
//        LibCoreConfig.API_URL = ApiConstants.testEnvServer;
//        MemberSalesPre memberActionListPre = new MemberSalesPre(new MemberSalesFra());
//        memberActionListPre.checkVerifyCode("15112608286", "1943", "3838523");
    }

    @Override
    public void start() {

    }

    @Override
    public void validRuleResult(String phoneNum, String activityId, List<ProductInfoBean> productInfoBeans) {
        ArrayList<EnjoyDiscountRequestBean.OrderContextBean.ProListBean> productInfoBaseBeanList = new ArrayList<>();
        for (ProductInfoBean productInfoBean : productInfoBeans) {
            EnjoyDiscountRequestBean.OrderContextBean.ProListBean productInfoBaseBean = new EnjoyDiscountRequestBean.OrderContextBean.ProListBean();
            productInfoBaseBean.num = MoneyUtils.dynamicLastDF(productInfoBean.getProNum());
            productInfoBaseBean.name = productInfoBean.name;
            productInfoBaseBean.price = productInfoBean.getPriceOriginal();
            productInfoBaseBean.specialPrice = productInfoBean.specialPrice;
            productInfoBaseBean.code = productInfoBean.code;
            productInfoBaseBean.subtotal = productInfoBean.getAmount();
            productInfoBaseBean.brandType = SystemHelper.isWgmf(productInfoBean.getBrand())? 0 : 1;//0五谷磨房  1鲜稻研
            productInfoBaseBean.setIsDecimal(productInfoBean.isDecimal());
            productInfoBaseBean.groupId = productInfoBean.getGroupId();
            productInfoBaseBean.proportRelation =  productInfoBean.getProportRelation();
            productInfoBaseBeanList.add(productInfoBaseBean);
        }
        //String listJson = new Gson().toJson(productInfoBaseBeanList);
        //listJson = "{'proList':"+listJson+"}";

        EnjoyDiscountRequestBean requestBean = new EnjoyDiscountRequestBean();
        requestBean.activityId = activityId;
        requestBean.phone = phoneNum;
        EnjoyDiscountRequestBean.OrderContextBean orderContextBean = new EnjoyDiscountRequestBean.OrderContextBean();
        orderContextBean.proList = productInfoBaseBeanList;
        requestBean.orderContext = orderContextBean;
        Call<RequestResult<MemberAction.GiftRuleBean>> call = memberSalesDataNet.validRuleResult(requestBean);
        call.enqueue(new ResultCallback<MemberAction.GiftRuleBean>() {
            @Override
            public void onResponse(Call<RequestResult<MemberAction.GiftRuleBean>> call, Response<RequestResult<MemberAction.GiftRuleBean>> response) {
                super.onResponse(call, response);
                if (response.body() == null){
                    ToastMsg.showToastMsg(GlobalApp.getInstance(), response.raw().message() + ":" + response.raw().code());
                }else if(response.body().resultInfo == null){
                    ToastMsg.showToastMsg(GlobalApp.getInstance(), response.body().msgInfo);
                }else{
                    ((MemberSalesCon.View) getMvpView()).showEnjoyDiscount(response.body().resultInfo);
                }
            }
        });
    }

    /**
     * 验证 活动验证码，核销
     * @param phoneNum     电话号码
     * @param activityId   参加活动Id
     * @param exchangeCode 校验码
     */
    @Override
    public void checkVerifyCode(String phoneNum, String activityId, String exchangeCode) {
        Call<RequestResult<String>> call = memberSalesDataNet.checkVerifyCode(phoneNum, activityId, exchangeCode);
        call.enqueue(new ResultCallback<String>() {
            @Override
            protected void onResponseSuccess(RequestResult<String> responseBody) {
                super.onResponseSuccess(responseBody);
                ToastMsg.showToastMsg(GlobalApp.getInstance(), responseBody.msgInfo);
                ((MemberSalesCon.View) getMvpView()).showCheckCodeState(responseBody.msgCode == 0);
            }

            @Override
            public void onResponse(Call<RequestResult<String>> call, Response<RequestResult<String>> response) {
//           super.onResponse(call, response);
                RequestResult<String> responseBody = response.body();
                ResponseBody errorBody = response.errorBody();

                if (response.code() == 200 && responseBody != null) {
                    int flag = responseBody.msgCode;
                    //请求失败
                    if (flag != 0) {
                        MyToast.show(responseBody.msgInfo);
                    }
                    //请求成功
                    else {
                        this.onResponseSuccess(responseBody);
                    }
                } else {
                    if (errorBody!=null) {
                        this.onFailure(call, new Throwable(response.errorBody().toString()));
                    }
                }
            }

            @Override
            public void onFailure(Call<RequestResult<String>> call, Throwable t) {
                String msgTips = "网络访问异常";
                if (t instanceof SocketTimeoutException) {
                    msgTips = "网络请求超时";
                }
                MyToast.show(msgTips);
            }
        });
    }

    /**
     * UploadXiaoShouTask对应上；
     *
     */
    @Override
    public void submitMemberGoodsOrder(MemGoodsOrderBean bean,List<ProductInfoBean> proList) {
        for (ProductInfoBean productInfoBean : proList) {
            //数量为零的过滤掉了
            if (productInfoBean.getProNum() == 0) {
                continue;
            }
            MemGoodsOrderBean.Details detail = new MemGoodsOrderBean.Details(
                    productInfoBean.code,//prodCode
                    productInfoBean.name,//prodName
                    productInfoBean.getProNum(),//quantity
                    productInfoBean.getAmountActual(),//subamount
                    productInfoBean.getPrice(),//unitPrice
                    productInfoBean.getGroupId(),
                    productInfoBean.getProportRelation()
            );
            bean.getDetails().add(detail);
        }


        Call<Base3Response> call = memberSalesDataNet.submitMemGoodsOrder(bean);
        call.enqueue(new Callback<Base3Response>() {
            @Override
            public void onResponse(Call<Base3Response> call,
                                   Response<Base3Response> res) {
                if (res.isSuccessful()) {
                    if (getMvpView().isActive()) {
                        ToastMsg.showToastMsg(GlobalApp.getInstance(),res.body().msgInfo);
                        //提交成功
                        if (res.body().msgCode == 0){
                            ((MemberSalesCon.View) getMvpView()).memGoodsSumbitSuccess();
                        //提交失败
                        }else{
                            ((MemberSalesCon.View) getMvpView()).memGoodsSumbitFailed(res.body().msgInfo);
                        }
//                        ToastMsg.showToastMsg(GlobalApp.getInstance(), response.body().retInfo);
//                        if ("0".equals(response.body().ret)) {
//                            ((MemberSalesCon.View) getMvpView()).commitOrderState(response.body().resultStr);
//                        } else if ("1036".equals(response.body().ret)) {
//
//                        } else {
//
//                        }
                    }
                } else {
                    onFailure(call, null);
                }
            }

            @Override
            public void onFailure(Call<Base3Response> call, Throwable t) {
                ((MemberSalesCon.View) getMvpView()).memGoodsSumbitFailed("网络异常");
            }
        });
    }
}
