package com.wgmf.trade.presenter;

import android.text.TextUtils;

import androidx.fragment.app.Fragment;

import com.urovo.wugumofang.net.RetrofitHelper;
import com.urovo.wugumofang.response.BaseSimpleResponse;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.MyToast;
import com.wgmf.trade.model.bean.QualityBackResultBean;
import com.wgmf.trade.model.data.net.QualityBackResultDataNet;
import com.wgmf.trade.view.QualityBackResultCon;
import com.zsy.libcore.model.bean.RequestResult;
import com.zsy.libcore.model.bean.ResultCallback;
import com.zsy.libcore.presenter.impl.BasePresenterImpl;

import java.util.ArrayList;
import java.util.List;

import retrofit2.Call;
import retrofit2.Response;

/**
 * Created by samy on 17/1/19.
 */
public class QualityBackResultPre extends BasePresenterImpl implements QualityBackResultCon.Pre {
  QualityBackResultDataNet qualityBackResultDataNet;
  List<QualityBackResultBean> allList;

  public QualityBackResultPre(QualityBackResultCon.View mMvpView) {
    super(mMvpView);
    qualityBackResultDataNet  = RetrofitHelper.createApi(QualityBackResultDataNet.class);
  }

  /**
   * 查询反馈结果
   * @param staffid
   * @param shopId
   * @param type
   * @param workFlowId
   */
  @Override public void getTypeList(String staffid, String shopId,int type,int workFlowId) {
    getMvpView().showLoading("");
    Call<RequestResult<List<QualityBackResultBean>>> call = qualityBackResultDataNet.getTypeList(staffid,shopId,type+"",workFlowId+"");
    call.enqueue(new ResultCallback<List<QualityBackResultBean>>(){
      @Override
      protected void onResponseSuccess(RequestResult<List<QualityBackResultBean>> responseBody) {
        getMvpView().hideLoading();
        super.onResponseSuccess(responseBody);
        List<QualityBackResultBean>  qualityBackResultBeanList= responseBody.resultInfo;
        if (qualityBackResultBeanList!=null){
          if (getMvpView()!=null){//进入页面时请求一次；
             allList = qualityBackResultBeanList;
            ((QualityBackResultCon.View)getMvpView()).showTypeList(qualityBackResultBeanList);
          }
        }else {//qualityBackResultBeanList == null
          MyToast.show(responseBody.msgInfo);
        }
      }

      @Override
      public void onFailure(Call<RequestResult<List<QualityBackResultBean>>> call, Throwable t) {
        getMvpView().hideLoading();
        super.onFailure(call, t);
      }
    });
  }

  /**
   * 提交评级
   * @param id
   * @param problemType
   * @param pj
   * @param content
   * @param staffid
   */
  @Override
  public void submitpj(String id, int problemType, int pj, String content, String staffid) {
//    getMvpView().showLoading("正在提交评价...");
    ViewUtil.showProgress(((Fragment)getMvpView()).getActivity(),"请稍等","正在提交评价...");
    Call<RequestResult<BaseSimpleResponse>> call = qualityBackResultDataNet.submitPj(id, problemType, pj, content, staffid);
    call.enqueue(new ResultCallback<BaseSimpleResponse>(){
      @Override
      public void onResponse(Call<RequestResult<BaseSimpleResponse>> call, Response<RequestResult<BaseSimpleResponse>> response) {
        getMvpView().hideLoading();
        ViewUtil.dismissProgress();
        super.onResponse(call, response);
        if (response.body() == null){//有时候OA报错，返回500，这个会为空。
          ((QualityBackResultCon.View)getMvpView()).refreshShow();//提交成功，重新请求刷新一下界面。
          return;
        }
        if (TextUtils.isEmpty(response.body().msgInfo)){
          MyToast.show(response.body().msgInfo);//管你请求成功失败，都弹个状态返回
        }
        if(response.body().msgCode == 0){
          ((QualityBackResultCon.View)getMvpView()).refreshShow();//提交成功，重新请求刷新一下界面。
        }
      }


      @Override
      public void onFailure(Call<RequestResult<BaseSimpleResponse>> call, Throwable t) {
        getMvpView().hideLoading();
        ViewUtil.dismissProgress();
        super.onFailure(call, t);
      }
    });
  }

  @Override
  public void queryDifTypeList(int type) {
    //想遍历又想删除，你应该倒着来;或者直接用Iterator;
    if (allList==null){
      return;
    }
    List<QualityBackResultBean> qualityBackResultBeanList = new ArrayList<>();
    switch (type){
      case 0://all
        qualityBackResultBeanList = allList;
        break;
      case 1://未处理
      case 2://已处理
        for (QualityBackResultBean qualityBackResultBean:allList){
            if (type==qualityBackResultBean.status){
              qualityBackResultBeanList.add(qualityBackResultBean);
            }
        }
        break;
    }
    if (getMvpView()!=null){
      ((QualityBackResultCon.View)getMvpView()).showTypeList(qualityBackResultBeanList);
    }

    //Iterator<QualityBackResultBean> qualityBackResultBeanIterator = allList.iterator();
    //while (qualityBackResultBeanIterator.hasNext()) {
    //  QualityBackResultBean nextAll = qualityBackResultBeanIterator.next();
    //  switch (type){
    //    case 0://all
    //
    //      break;
    //    case 1://未处理
    //
    //      break;
    //    case 2://已处理
    //
    //      break;
    //  }
    //  if (nextAll.status!=type){
    //    qualityBackResultBeanIterator.remove();
    //  }

  }

  @Override public void start() {

  }
}
