package com.wgmf.trade.ui.ada;


import android.content.Context;
import android.widget.TextView;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.urovo.wugumofang.R;
import com.wgmf.trade.model.bean.MemberDaySubscribeBean;

import java.util.List;
import java.util.Locale;

import androidx.annotation.Nullable;
import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.RecyclerView;


/**
 * @author chenji
 */
public class MemberDaySubscribeAda extends BaseQuickAdapter<MemberDaySubscribeBean.ResultInfoBean, BaseViewHolder> {
    private Context context;
    private int selPosition = 0;
    private int height;//元素高度，用于平铺整个屏幕

    public MemberDaySubscribeAda(Context context,int height, @Nullable List<MemberDaySubscribeBean.ResultInfoBean> data) {
        super(R.layout.item_member_day_subscribe_list, data);
        this.height = height;
        this.context = context;
    }

    @Override
    protected void convert(BaseViewHolder helper, MemberDaySubscribeBean.ResultInfoBean resultInfoBean) {
        /*设置数值*/
        TextView memberSubscribeDate = helper.getView(R.id.member_subscribe_date);
        memberSubscribeDate.setText(resultInfoBean.getDate());
        TextView memberDaySubscribeNum = helper.getView(R.id.member_day_subscribe_num);
        memberDaySubscribeNum.setText(String.format(Locale.CHINA, "(%d人)", resultInfoBean.getNum()));
        helper.getView(R.id.member_subscribe_item).setLayoutParams(new RecyclerView.LayoutParams(RecyclerView.LayoutParams.MATCH_PARENT,height));

        /*点击监听颜色变化*/
        helper.addOnClickListener(R.id.member_subscribe_item);

        /*改变颜色*/
        if (selPosition == helper.getLayoutPosition()) {
            memberSubscribeDate.setTextColor(ContextCompat.getColor(mContext, R.color.title_pop_query_bg));
            memberDaySubscribeNum.setTextColor(ContextCompat.getColor(mContext, R.color.title_pop_query_bg));
        } else {
            memberSubscribeDate.setTextColor(ContextCompat.getColor(context, R.color.black));
            memberDaySubscribeNum.setTextColor(ContextCompat.getColor(context, R.color.black));
        }

    }

    /**
     * 刷新item 为了改变颜色状态
     *
     * @param selPosition item 位置
     */
    public void setItemSel(int selPosition) {
        this.selPosition = selPosition;
        notifyDataSetChanged();
    }
}
