package com.wgmf.trade.ui.ada

import androidx.databinding.ObservableList
import androidx.recyclerview.widget.RecyclerView



/**
 * @author Sasuke on 2019/5/1.
 * 在list上add这个监听器，可以用到databinding的对数据源List变化的监听，来自动刷新UI。。。。随便了，感觉好像也不太好用。
 */

class ObservableListChangeListener<T>(private val adapter: RecyclerView.Adapter<ViewHolderX>) : ObservableList.OnListChangedCallback<ObservableList<T>>() {

    override fun onChanged(sender: ObservableList<T>) {
        adapter.notifyDataSetChanged()
    }

    override fun onItemRangeChanged(sender: ObservableList<T>, positionStart: Int, itemCount: Int) {
        adapter.notifyItemRangeChanged(positionStart, itemCount)
    }

    override fun onItemRangeInserted(sender: ObservableList<T>, positionStart: Int, itemCount: Int) {
        adapter.notifyItemRangeInserted(positionStart, itemCount)
    }

    override fun onItemRangeMoved(sender: ObservableList<T>, fromPosition: Int, toPosition: Int, itemCount: Int) {
        adapter.notifyItemRangeRemoved(fromPosition, itemCount)
        adapter.notifyItemRangeInserted(toPosition, itemCount)
    }

    override fun onItemRangeRemoved(sender: ObservableList<T>, positionStart: Int, itemCount: Int) {
        adapter.notifyItemRangeRemoved(positionStart, itemCount)
    }

}
