package com.wgmf.trade.ui.fra.index;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.wgmf.trade.model.bean.ExchangeUndoBean;
import com.wgmf.trade.presenter.ExchangeUndoPre;
import com.wgmf.trade.view.ExchangeUndoCon;
import com.zsy.libcore.ui.ada.helper.ViewHelper;
import com.zsy.libcore.ui.ada.quickadapter.QuickRecycleViewAdapter;
import com.zsy.libext.ui.fra.BaseFra;
import com.zsy.libext.widgets.AutoLoadRecyclerView;

import java.util.ArrayList;
import java.util.List;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import androidx.swiperefreshlayout.widget.SwipeRefreshLayout;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 兑换撤销
 * Created by samy on 17/2/5.
 */
public class ExchangeUndoFra extends BaseFra<ExchangeUndoCon.Pre>
    implements SwipeRefreshLayout.OnRefreshListener,AutoLoadRecyclerView.OnLoadListener, ExchangeUndoCon.View {
  @BindView(R.id.refresh_srl)
  SwipeRefreshLayout refreshSrl;
  @BindView(R.id.list_rv) AutoLoadRecyclerView listRv;

  List<ExchangeUndoBean> exchangeUndoBeanList;

  ExchangeUndoCon.Pre pre;
  QuickRecycleViewAdapter quickRecycleViewAdapter;
  protected String phoneNum;

  private int pages=1;
  private final int TOP_REFRESH = 1;
  private final int BOTTOM_REFRESH = 2;
  private final static int EXCHANGE_REASON = 3;
  int openTime = 0;//是否第一次打开此页面，第一次时不让它执行onResume()

  @Override protected void getBundleExtras(Bundle extras) {
    super.getBundleExtras(extras);
    phoneNum = extras.getString(AppConstants.ExtraKeys.PHONE_NUM);
  }

  @Override
  public void onDestroy() {
    super.onDestroy();
    unbinder.unbind();
  }

  Unbinder unbinder;
  @Override protected void initWidgetsAndEvents(View view) {
    unbinder = ButterKnife.bind(this,view);
    baseAct.commonToolbar.setTitle("兑换撤销");

    pre = new ExchangeUndoPre(this);

    exchangeUndoBeanList = new ArrayList<>();

    refreshSrl.setColorSchemeResources(android.R.color.holo_green_light, android.R.color.holo_orange_light,
        android.R.color.holo_red_light);


    final LinearLayoutManager layoutManager = new LinearLayoutManager(getActivity());
    layoutManager.setOrientation(RecyclerView.VERTICAL);
    listRv.setLayoutManager(layoutManager);
    quickRecycleViewAdapter =
        new QuickRecycleViewAdapter<ExchangeUndoBean>(R.layout.item_exchange_undo,
            exchangeUndoBeanList) {
          @Override
          protected void onBindData(Context context, int i, final ExchangeUndoBean exchangeUndoBean,
              ViewHelper viewHelper) {
            viewHelper.setText(R.id.exchange_gift_name_tv,
                exchangeUndoBean.productName + "x" + exchangeUndoBean.productNum);
            viewHelper.setText(R.id.exchange_integral_tv, exchangeUndoBean.consumePoint);
            viewHelper.setText(R.id.exchange_datetime_tv, exchangeUndoBean.exchageTime);
            viewHelper.setText(R.id.exchange_shop_name_tv, exchangeUndoBean.shopName);
            //0:已兑换 1:已退换 2:已兑换（已超过30天不允许撤销）
            String exchange_state = "";
            if (exchangeUndoBean.status == 0) exchange_state = "已兑换";
            if (exchangeUndoBean.status == 1) exchange_state = "已退换";
            if (exchangeUndoBean.status == 2) exchange_state = "已兑换（已超过30天不允许撤销）";

            viewHelper.setText(R.id.exchange_state_tv,exchange_state);
            Button undo_exchange_btn = viewHelper.getView(R.id.undo_exchange_btn);
            undo_exchange_btn.setText("撤销兑换");
            undo_exchange_btn.setEnabled(exchangeUndoBean.status ==0 ? true : false);
            undo_exchange_btn.setTextColor(exchangeUndoBean.status ==0 ?getResources().getColor(R.color.title_yellow_bg) : getResources().getColor(R.color.gray_text_color));
            undo_exchange_btn.setOnClickListener(new View.OnClickListener() {
              @Override public void onClick(View v) {
                  Intent intent = new Intent(ExchangeUndoFra.this.getActivity(), ExchangeReasonAct.class);
                  intent.putExtra(ExchangeReasonAct.getINTENT_DATE(),exchangeUndoBean.exchageTime.substring(0,10));
                  intent.putExtra(ExchangeReasonAct.getINTENT_EXCHID(),exchangeUndoBean.exchId);
                  startActivity(intent);

//                final EffectsAlertDialog effectsAlertDialog =
//                    EffectsAlertDialog.getInstance(getActivity());
//                effectsAlertDialog
//                    .withTitle("请输入撤销兑换的原因")
//                    .withInputContent("", 200, 0)
//                    .withInputMargin(5, 0, 0, 0)
//                    .setRightButtonClick(
//                        new View.OnClickListener() {
//                          @Override public void onClick(View v) {
//                            String exChangeReason = effectsAlertDialog.getInputStr();
//                            if (TextUtils.isEmpty(exChangeReason)) {
//                              ToastMsg.showToastMsg(getActivity(), "请输入撤销兑换原因!");
//                              return;
//                            }
//                            pre.pointExchangeCancel(exchangeUndoBean.exchId,
//                                SystemHelper.LoginUserId, exChangeReason);
//                            effectsAlertDialog.dismiss();
//                          }
//                        })
//                    .show();
              }
            });
          }
        };
    refreshSrl.setOnRefreshListener(this);
    listRv.setAdapter(quickRecycleViewAdapter);
    listRv.setHasFixedSize(true);
    listRv.setOnLoadListener(this);
    //listRv.addItemDecoration(new RecycleViewDivider(mContext, LinearLayoutManager.VERTICAL));

    dataOption(TOP_REFRESH);
  }

  @Override
  public void onResume() {
    super.onResume();
    if(openTime > 0){
      dataOption(TOP_REFRESH);
    }
    openTime++;
  }

  @Override protected View getLoadingTargetView() {
    return null;
  }


  @Override protected int getContentViewLayoutID() {
    return R.layout.fra_exchange_undo;
  }

  @Override public void onRefresh() {//下拉刷新；
    dataOption(TOP_REFRESH);
  }


  @Override public void onLoad() {//加载更多
    dataOption(BOTTOM_REFRESH);
  }

  private void dataOption(int option) {
    switch (option) {
      case TOP_REFRESH://下拉刷新
        pages=1;
        exchangeUndoBeanList.clear();
        break;
      case BOTTOM_REFRESH: //上拉加载更多
        pages++;
        break;
    }
    pre.getExchangeUndoList(phoneNum, SystemHelper.LoginOrganId,pages);
  }

  @Override public void showLoading(String s) {
    //super.showLoading(s);
    ViewUtil.showProgress(getActivity(),"请稍等",s);
    refreshSrl.setRefreshing(true);
  }

  @Override public void hideLoading() {
    //super.hideLoading();
    ViewUtil.dismissProgress();
    refreshSrl.setRefreshing(false);
  }

  @Override public void showExchangeUndoList(List<ExchangeUndoBean> exchangeUndoBeanListTemp) {
    exchangeUndoBeanList.addAll(exchangeUndoBeanListTemp);
    quickRecycleViewAdapter.resetItems(exchangeUndoBeanList);
  }

  @Override public void showPointExchangeCancel(boolean isSuccess) {
    if (isSuccess) {
      dataOption(TOP_REFRESH);
    }
  }

  @Override public void setPresenter(@NonNull ExchangeUndoCon.Pre pre) {

  }

}
