package com.wgmf.trade.ui.fra.index;


import androidx.annotation.Nullable;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.urovo.wugumofang.R;
import com.wgmf.trade.model.bean.MemberAction;
import com.zsy.libcore.common.android.log.SYLoger;

import java.util.List;

/**
 * 会员活动列表
 *
 * @author chenji
 * @date 2018/05/03
 */
public class MemberActionAda extends BaseQuickAdapter<MemberAction, BaseViewHolder> {
    private List<MemberAction> data;

    public MemberActionAda(@Nullable List<MemberAction> data) {
        super(R.layout.item_member_action_list, data);
        this.data = data;
    }

    @Override
    protected void convert(BaseViewHolder viewHolder, MemberAction memberAction) {
        viewHolder.addOnClickListener(R.id.action_item);
        viewHolder.setText(R.id.action_type_name_tv, memberAction.name);
        if (memberAction.actType == 0) {
            viewHolder.setText(R.id.action_type_tv, "专享");
            viewHolder.getView(R.id.action_type_tv).setBackgroundResource(R.drawable.btn_red_state);
        } else {
            viewHolder.setText(R.id.action_type_tv, "全场");
            viewHolder.getView(R.id.action_type_tv).setBackgroundResource(R.drawable.btn_orange_state);
            SYLoger.print("wgmf brandType -->" + memberAction.brandType);
        }
        //如果是支持到家业务的，就显示标签
        viewHolder.setVisible(R.id.action_type_2home_tv, memberAction.arriveHome == 1);

        //鲜稻研产品散装标志（）
//        viewHolder.setVisible(R.id.action_type_des_tv, memberAction.brandType == AppConstants.BRAND.XDY);

        //去掉集合最后一个数据的虚线
        if (viewHolder.getLayoutPosition() == this.data.size() - 1) {
            viewHolder.setVisible(R.id.list_line_horizontal, false);
        }
    }
}
