package com.wgmf.trade.ui.fra.index;

import android.app.AlertDialog;
import android.os.Bundle;
import android.text.Html;
import android.text.Spanned;
import android.text.TextUtils;
import android.view.View;
import android.widget.TextView;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.urovo.wgmf.db.dao.dao.Item001DbOperate;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.utils.MyToast;
import com.wgmf.trade.model.bean.MemActionDominator;
import com.wgmf.trade.model.bean.MemberAction;
import com.wgmf.trade.model.bean.ProGroupInfoBean;
import com.wgmf.trade.model.bean.ProductInfoBean;
import com.wgmf.trade.view.MemberActionListCon;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.common.other.NetUtil;
import com.zsy.libext.ui.fra.BaseFra;
import com.zsy.libext.utils.DateTimeUtils;
import com.zsy.libext.widgets.tips.ToastMsg;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 会员活动列表(专享活动和全场活动)
 *
 * @author samy
 * @date 16/9/9
 */
@SuppressWarnings("all")
public class MemberActionListFra extends BaseFra<MemberActionListCon.Pre>
        implements MemberActionListCon.View {
    @BindView(R.id.member_action_list_lv)
    RecyclerView memberActionListRv;
    @BindView(R.id.total_action_list_tv)
    TextView totalActionListTv;
    private List<MemberAction> memberActions = new ArrayList<>();
    private MemberActionAda memberActionAda;
    private MemberActionListCon.Pre pre;
    private boolean isVip;
    private String phoneNum;
    private MemberAction selectedMemberAction;
    /**
     * 是否是销售补录状态
     */
    private boolean isAdditionalRecord;
    String selectTime = "";

    public static MemberActionListFra newInstance(String phoneNum, boolean isVip, boolean isAdditionalRecord, String selectTime) {
        Bundle arguments = new Bundle();
        arguments.putString(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
        arguments.putBoolean("isVip", isVip);
        arguments.putBoolean(AppConstants.ExtraKeys.IS_ADDITIONAL_RECORD, isAdditionalRecord);
        arguments.putString(AppConstants.ExtraKeys.SELECT_TIME, selectTime);
        MemberActionListFra fragment = new MemberActionListFra();
        fragment.setArguments(arguments);
        return fragment;
    }

    @Override
    protected void getBundleExtras(Bundle extras) {
        super.getBundleExtras(extras);
        phoneNum = extras.getString(AppConstants.ExtraKeys.PHONE_NUM);
        isVip = extras.getBoolean("isVip", false);
        selectTime = extras.getString(AppConstants.ExtraKeys.SELECT_TIME);
        isAdditionalRecord = extras.getBoolean(AppConstants.ExtraKeys.IS_ADDITIONAL_RECORD, false);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        unbinder.unbind();
    }

    Unbinder unbinder;

    @Override
    protected void initWidgetsAndEvents(View view) {
        unbinder = ButterKnife.bind(this, view);
        updateShowTips(isVip);
        memberActionAda = new MemberActionAda(memberActions);
        memberActionListRv.setHasFixedSize(true);
        LinearLayoutManager layoutManager = new LinearLayoutManager(getActivity(), LinearLayoutManager.VERTICAL, false);
        memberActionListRv.setLayoutManager(layoutManager);
        //禁止滑动
        memberActionListRv.setNestedScrollingEnabled(false);
        memberActionListRv.setAdapter(memberActionAda);

        //活动网络请求开始
        if (pre != null) {
            pre.getActionList(isVip, SystemHelper.LoginOrganId, phoneNum, selectTime, isAdditionalRecord);
        }

        memberActionAda.setOnItemChildClickListener(new BaseQuickAdapter.OnItemChildClickListener() {
            @Override
            public void onItemChildClick(BaseQuickAdapter adapter, View view, int position) {
                selectedMemberAction = memberActions.get(position);
                SYLoger.print("wgmf-->memberAction: " + selectedMemberAction.toString());
                if (TextUtils.isEmpty(phoneNum)) {
                    ToastMsg.showToastMsg(getActivity(), "需要输入手机号才能参与活动!");
                    return;
                }
                if (selectedMemberAction.checkRuleOrNot == 1 || selectedMemberAction.rule.point > 0) {
                    if (!NetUtil.isNetworkAvailable(getActivity())) {
                        ToastMsg.showToastMsg(getActivity(), "网络良好才能参与此活动!");
                        return;
                    }
                    if (selectedMemberAction.rule.point > 0) {
                        pre.remainsPoints(selectedMemberAction.rule.point, phoneNum);
                        return;
                    }
                }
                //不允许不同isDecimal的商品存在于规则的同一个 组合商品 或 组合赠品 里。
                if (!MemActionDominator.checkActionGroupSameDecimal(selectedMemberAction)) {
                    ToastMsg.showToastMsg(getActivity(), "活动配置有误，无法校验规则，请联系销管部修改！");
                    return;
                }

                jumpToSales();
            }
        });
    }

    /**
     * 跳转之前先过滤掉当前店,没有的itemID;不能参加活动
     */
    private void jumpToSales() {
        /**
         * 是否可参加活动；
         * 默认为：0；都可以参加；
         * 1:商品  只要一个itemId对应不上；
         * 2:商品组合 全部itemId对应不上。如果没有的要移除掉；
         * 3:赠品 只要一个itemId对应不上；
         * 4:赠品组合 全部itemId对应不上。如果没有的要移除掉；
         * 5:只有五谷磨房和鲜稻研品牌才能跳转到产品页面
         * 6:活动类型activityType = 9 特价活动时，各产品之间的关系统一设置为【或】的关系
         */

        //散装组合活动情况下，在点击活动进入时，要校验一下是否后台有配置money和num规则
        //如果没配置规则，要弹窗提示
        String checkDecimalGroupHaveRule = MemActionDominator.checkDecimalHaveRule(selectedMemberAction);
        if (!TextUtils.isEmpty(checkDecimalGroupHaveRule)) {
            MyToast.show(checkDecimalGroupHaveRule);
        }

        boolean isCanJoin = true;

        //校验规则的时候，在数据库里没有找到相应的活动商品，就存在HashSet里，到时候弹Toast提示。
        HashSet<ProductInfoBean> notFoundProSet = new HashSet();
        HashSet<ProductInfoBean> notFoundGiftSet = new HashSet();//专门给giftProGroupInfo来存的，因为赠品组合缺产品不用提示
        //我重新把这块校验逻辑封装了一下，校验是否能找到产品，找不到是不允许参加活动的，赠品组合特殊处理

        HashSet<ProductInfoBean> notFoundProGroupSet = new HashSet();
        HashSet<ProductInfoBean> notFoundGiftGroupSet = new HashSet();

        String notFoundPros = MemActionDominator.checkHasFoundPro(selectedMemberAction, notFoundProSet);
        String notFoundGifts = MemActionDominator.checkHasFoundGift(selectedMemberAction, notFoundGiftSet);

        String notFoundProsGroup = MemActionDominator.checkHasFoundProGroup(selectedMemberAction, notFoundProGroupSet);
        String notFoundGiftsGroup = MemActionDominator.checkHasFoundGiftGroup(selectedMemberAction, notFoundGiftGroupSet);

        PreferHelper.getInstance().setString("notFoundPros", null);//先清空没找到产品记录提示信息

        //判断是否缺少产品：组合产品进入产品选择页再判断，非组合产品活动再此处判断
        //如果选择产品，并且是组合活动产品，将不存在产品的信息存储起来，在产品列表页进行提示
        if (!TextUtils.isEmpty(notFoundPros) || !TextUtils.isEmpty(notFoundGifts)
                || (selectedMemberAction.rule.proGroupInfo != null && !TextUtils.isEmpty(notFoundProsGroup))
                || (selectedMemberAction.giftRule.giftProGroupInfo != null && !TextUtils.isEmpty(notFoundGiftsGroup))
        ) {
            isCanJoin = false;
        }
        if (!isCanJoin) {
            String notFound = notFoundPros + notFoundProsGroup;
            if (!TextUtils.isEmpty(notFound)) {
                PreferHelper.getInstance().setString("notFoundPros", notFound);
            }
            new AlertDialog.Builder(getActivity())
                    .setTitle("以下产品不存在！")
                    .setMessage(notFoundPros + notFoundProsGroup + notFoundGifts + notFoundGiftsGroup + "\n先下载基础资料，还是报错的话请联系主管/文员找销管部对应的货品专员维护产品目录。")
                    .setPositiveButton("我知道了", null)
                    .create().show();
        }

        if (isCanJoin && SystemHelper.hasWgmf()) {
            //利用数据库来初始化一些数据
            filterProItemIdAndPrice(selectedMemberAction.rule.productInfo);
            filterProGroupItemIdAndPrice(selectedMemberAction.rule.proGroupInfo, false);
            if (selectedMemberAction.giftRule != null) {
                filterProItemIdAndPrice(selectedMemberAction.giftRule.giftProductInfo);
                //filterProGroupItemIdAndPrice(selectedMemberAction.giftRule.giftProGroupInfo, true);//赠品组合缺产品不用提示
                filterProGroupItemIdAndPrice(selectedMemberAction.giftRule.giftProGroupInfo, false);//赠品组合缺产品不用提示
            }
            Date nowDate = new Date();
            Date actionTime = DateTimeUtils.getDateFromString(selectedMemberAction.endTime);
            if (!isAdditionalRecord && nowDate.compareTo(actionTime) == 1) {
                ToastMsg.showToastMsg(getActivity(), "本门店该活动已过期!");
                return;
            }
            MemberSalesFra.launch(getActivity(), phoneNum, selectedMemberAction, isAdditionalRecord, selectTime, actionBrand(), String.valueOf(selectedMemberAction.brandType));
        }
    }

    /**
     * 五谷磨房/鲜稻研
     * ps:根据活动的brandType判断正在做哪个品牌的活动,再获取产品表的品牌字段作为品牌区分的标志.
     *
     * @return 活动品牌类型 可能为空
     */
    private String actionBrand() {
        String brandType = "";
        if (selectedMemberAction.brandType == AppConstants.BRAND.WGMF) {
            brandType = SystemHelper.WgmfBrand;
        } else if (selectedMemberAction.brandType == AppConstants.BRAND.XDY) {
            brandType = SystemHelper.XdyBrand;
        }
        return brandType;
    }

    /**
     * 在list显示前。主要是计算服务器活动商品和组合商品的价格
     */
    public static boolean filterProItemIdAndPrice(ArrayList<ProductInfoBean> productInfo) {
        boolean isCanJoin = true;
        if (productInfo != null && productInfo.size() > 0) {
            Iterator<ProductInfoBean> iterator = productInfo.iterator();
            while (iterator.hasNext()) {
                ProductInfoBean productInfoBeanTemp = iterator.next();
                ProductEntity productEntityTemp = Item001DbOperate.GetProductByBarcode(productInfoBeanTemp.code);
                //查找到了设置其基础资料的价格；
                if (productEntityTemp != null) {
                    productInfoBeanTemp.setPrice(productEntityTemp.getPrice());
                    productInfoBeanTemp.setProNum(productInfoBeanTemp.getProNum());
                    productInfoBeanTemp.setItemMode(productEntityTemp.getItemMode());
                    productInfoBeanTemp.setKCUom(productEntityTemp.getKCUom());
                    productInfoBeanTemp.setUnit(productEntityTemp.getUnit());
                    //productInfoBeanTemp.setAmount(productEntityTemp.getAmount());//默认情况下；
                    productInfoBeanTemp.setBarcode(productEntityTemp.getBarcode());
                }
                //查找不到ItemID移除掉；[不是组合不能删除]
                else {
                    isCanJoin = false;
                }
            }
        }
        return isCanJoin;
    }


    public static boolean filterProGroupItemIdAndPrice(ArrayList<ProGroupInfoBean> proGroupInfo, boolean isGiftGroup) {
        boolean isCanJoin = true;
        if (proGroupInfo != null && proGroupInfo.size() > 0) {
            for (ProGroupInfoBean proGroupInfoBeanTemp : proGroupInfo) {
                //filterProItemIdAndPrice(proGroupInfoBeanTemp.product);
                if (proGroupInfoBeanTemp.product != null && proGroupInfoBeanTemp.product.size() > 0) {
                    Iterator<ProductInfoBean> iterator = proGroupInfoBeanTemp.product.iterator();
                    while (iterator.hasNext()) {
                        ProductInfoBean productInfoBeanTemp = iterator.next();
                        ProductEntity productEntityTemp = Item001DbOperate.GetProductByBarcode(productInfoBeanTemp.code);
                        //查找到了设置其基础资料的价格；
                        if (productEntityTemp != null) {
                            productInfoBeanTemp.setPrice(productEntityTemp.getPrice());
                            productInfoBeanTemp.setProNum(productInfoBeanTemp.getProNum());
                            productInfoBeanTemp.setItemMode(productEntityTemp.getItemMode());
                            productInfoBeanTemp.setKCUom(productEntityTemp.getKCUom());
                            productInfoBeanTemp.setUnit(productEntityTemp.getUnit());
                            //productInfoBeanTemp.setAmount(productEntityTemp.getAmount());//默认情况下；
                            productInfoBeanTemp.setBarcode(productEntityTemp.getBarcode());
                        }
                        //查找不到ItemID移除掉；
                        else {
                            if (isGiftGroup) { //如果是校验赠品组合，那就移除
                                iterator.remove();
                            } else {//否则判为校验不通过
                                isCanJoin = false;
                            }
                        }
                    }
                }

                if (isGiftGroup) {//如果是校验赠品组合，那只要有产品，就通过
                    if (proGroupInfoBeanTemp.product.size() > 0) {
                        //selectedMemberAction.setCanJoin(true);
                        isCanJoin = true;
                    } else {
                        //selectedMemberAction.setCanJoin(false);
                        isCanJoin = false;
                    }
                }
            }
        }
        return isCanJoin;
    }


    @Override
    protected View getLoadingTargetView() {
        return null;
    }

    @Override
    protected int getContentViewLayoutID() {
        return R.layout.fra_member_action_list;
    }

    @Override
    public void setPresenter(@NonNull MemberActionListCon.Pre pre) {
        this.pre = pre;
    }

    @Override
    public void showActionList(boolean isVip, List<MemberAction> actions, boolean isAdditionalRecord, String selectTime) {
        this.selectTime = selectTime;
        this.memberActions = MemActionDominator.sort2HomeOrderToBottom(actions);//到家业务活动排到后面（其实前面的MemberActionListPre.java:140已经做了品牌排序）
        this.isAdditionalRecord = isAdditionalRecord;
        memberActionAda.replaceData(memberActions);
        updateShowTips(isVip);
    }

    @Override
    public void showRemainsPoints(float rulePoint, float remainsPoints) {
        if (remainsPoints < rulePoint) {
            ToastMsg.showToastMsg(getActivity(), "积分不足,无法兑换");
            return;
        }
        jumpToSales();
    }

    private void updateShowTips(boolean isVip) {
        Spanned actionTitle = Html.fromHtml
                (
                        "ta可参加的" + (isVip ? "专享" : "全场") + "活动 "
                                + "<font color='#ffa019' >(" + memberActions.size() + ")</font>"
                );
        totalActionListTv.setText(actionTitle);
    }
}