package com.wgmf.trade.ui.fra.index;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.sibyl.addsellactivity.view.AddSellAct;
import com.urovo.activity.slidemenu.HuoDongJiLu;
import com.urovo.activity.slidemenu.XiaoFeiActivity;
import com.urovo.activity.slidemenu.ui.FreeDeliveryQueryActivity;
import com.urovo.activity.slidemenu.ui.LogisticsQueryAct;
import com.urovo.activity.slidemenu.ui.VoucherCardSalesActivity;
import com.urovo.wgmf.db.dao.dao.Item001DbOperate;
import com.urovo.wgmf.db.dao.entitys.ActionFreshBtnBean;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.Show2HomeBean;
import com.urovo.wgmf.entity.response.VoucherCardBean;
import com.urovo.wgmf.entity.response.VoucherCardResponse;
import com.urovo.wugumofang.view.dialog.PublicTipDialog;
import com.urovo.wgmf.view.PublicPictureDialog;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.manager.ThreadManager;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.printermodule.PrinterTool;
import com.urovo.wugumofang.printermodule.StatusDbMap;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DensityUtil;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.view.webview.FraContainerAct;
import com.wgmf.trade.model.bean.MemActionDominator;
import com.wgmf.trade.presenter.AdditionalRecordPre;
import com.wgmf.trade.presenter.MemberActionListPre;
import com.wgmf.trade.presenter.MemberDetailPre;
import com.zsy.libcore.ui.fra.FragmentArgs;
import com.zsy.libext.ui.fra.BaseFra;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;
import org.greenrobot.eventbus.ThreadMode;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

import androidx.annotation.NonNull;
import androidx.drawerlayout.widget.DrawerLayout;
import androidx.fragment.app.FragmentManager;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;
import okhttp3.Request;


/**
 * 会员主页
 *
 * @author samy
 * @date 16/9/7
 */
@SuppressWarnings("all")
@Route(path = RouterParams.ORIGIN.MEMBERHOMEFRA)
public class MemberHomeFra extends BaseFra implements AdditionalRecordFra.SelectTimeCallback {
    /**
     * 五谷磨房常规销售入口
     */
    @BindView(R.id.add_sell_ll_wgmf)
    LinearLayout addSellWgmf;

    /**
     * 五谷磨房常规销售按钮蒙版
     */
    @BindView(R.id.add_sell_ll_wgmf_mengban)
    LinearLayout addSellWgmfMengban;
    /**
     * 五谷磨房标题
     */
    @BindView(R.id.add_sell_wgmf_tv)
    TextView sellWgmfTv;

    /**
     * 会员商品 常规销售入口【原鲜稻研】
     */
    @BindView(R.id.add_sell_ll_memGoods)
    LinearLayout addSellMemGoods;

    /**
     * 到家订单录入
     */
    @BindView(R.id.add_sell_ll_2_home)
    LinearLayout addSell2home;

    /**
     * 到家订单文案提示
     */
    @BindView(R.id.to_home_tip_tv)
    TextView toHomeTipTv;

    /**
     * 会员商品 按钮标题
     */
    @BindView(R.id.add_sell_memGoods)
    TextView addSellMemGoodsTv;

    /**
     * 侧滑菜单部分
     */
    @BindView(R.id.slide_lv)
    ListView slideLv;
    /**
     * DrawerLayout 抽屉布局容器
     */
    @BindView(R.id.root_dl)
    DrawerLayout rootDl;
    /**
     * 全场活动列表容器
     */
    @BindView(R.id.member_common_action_list_container_ll)
    LinearLayout memberCommonActionListContainerLl;
    /**
     * 专享活动列表容器
     */
    @BindView(R.id.member_vip_action_list_container_ll)
    LinearLayout memberVipActionListContainerLl;
    protected String phoneNum;

    private FragmentManager fragmentManager;

    /**
     * 是否是销售补录状态
     */
    private boolean isAdditionalRecord;
    /**
     * 是否显示列表和可点击操作(用于判断销售侧滑选择时间)
     */
    private boolean isHideListAndBtnUnable;
    /**
     * 销售补录选择的时间
     */
    private String selectTime;

    private MemberActionListPre memberActionListPre;
    private MemberActionListPre memberActionListPreVip;
    private MemberDetailFra memberDetailFra;

    /**
     * 打印条码工具
     */
    private PrinterTool mPrinterTool;

    /**
     * 线下权益卡数据
     */
    private List<ProductEntity> mMenefitCardList;
    /**
     * 显示权益卡销售开关
     */
    private boolean mSpecSwitch = false;
    /**
     * 显示权益卡销售文案
     */
    private String mConfirmContent = "";

    Unbinder unbinder;

    @Override
    protected void getBundleExtras(Bundle extras) {
        super.getBundleExtras(extras);
        phoneNum = extras.getString(AppConstants.ExtraKeys.PHONE_NUM);
    }


    @Override
    protected void initWidgetsAndEvents(View view) {
        unbinder = ButterKnife.bind(this, view);
        setHasOptionsMenu(true);
        baseAct.commonToolbar.setTitle("会员主页");
        if (!EventBus.getDefault().isRegistered(this)) {
            EventBus.getDefault().register(this);
        }

        //判断是否权益卡套餐的目标人群（谷谷、银谷会员）
        checkCardTargetCus();

        fragmentManager = baseAct.mFragmentManager;
        //会员主页 头部  会员详情
        changeTopFra(false);

        //全场活动列表
        MemberActionListFra memberActionListFraComm =
                MemberActionListFra.newInstance(phoneNum, false, isAdditionalRecord, selectTime);
        memberActionListPre = new MemberActionListPre(memberActionListFraComm);
        baseAct.changeFragment(R.id.member_common_action_list_container_ll, memberActionListFraComm, false);

        //专享活动列表
        if (!TextUtils.isEmpty(phoneNum)) {
            MemberActionListFra memberActionListFraVip =
                    MemberActionListFra.newInstance(phoneNum, true, isAdditionalRecord, selectTime);
            memberActionListPreVip = new MemberActionListPre(memberActionListFraVip);
            baseAct.changeFragment(R.id.member_vip_action_list_container_ll, memberActionListFraVip, false);
        }
        addSellWgmf.setOnClickListener(this);
        addSellMemGoods.setOnClickListener(this);
        addSell2home.setOnClickListener(this);

        //根据品牌标记来显隐常规销售的按钮
        addSellWgmf.setVisibility(SystemHelper.hasWgmf() ? View.VISIBLE : View.GONE);
        //先默认让蒙版点击穿透
        addSellWgmfMengban.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View view, MotionEvent motionEvent) {
                return false;
            }
        });
        addSellMemGoods.setVisibility(isShowAddSellMemGoods() ? View.VISIBLE : View.GONE);
        //判断到家业务显隐
        memberActionListPre.canHave2HomeBiz(SystemHelper.LoginOrganId);

        slideLv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                toggleDrawer();
                switch (position) {
                    case 0:
                        //销售补录
                        changeTopFra(true);
                        break;
                    case 1:
                        //兑换撤销
                        FragmentArgs fragmentArgs = new FragmentArgs();
                        fragmentArgs.add(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
                        FraContainerAct.launch(getActivity(), ExchangeUndoFra.class, fragmentArgs, false);
                        break;
                    case 2:
                        //购买明细
                        Intent intent2 = new Intent(getActivity(), XiaoFeiActivity.class);
                        intent2.putExtra(XiaoFeiActivity.MEMBER_ID, phoneNum);
                        startActivity(intent2);
                        break;
                    case 3:
                        //活动记录
                        Intent intent3 = new Intent(getActivity(), HuoDongJiLu.class);
                        intent3.putExtra("huiyuan", phoneNum);
                        startActivity(intent3);
                        break;
                    case 4:
                        //物流查询
                        Intent intent4 = new Intent(getActivity(), LogisticsQueryAct.class);
                        intent4.putExtra(LogisticsQueryAct.MEMBER_PHONE_NUM, phoneNum);
                        startActivity(intent4);
                        break;
                    case 5:
                        //免费送查询
                        Intent intent5 = new Intent(getActivity(), FreeDeliveryQueryActivity.class);
                        intent5.putExtra(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
                        startActivity(intent5);
                        break;
                    case 6:
                        //打印权益卡条码
                        //printBenefitCard();
                        //权益卡销售
                        Intent intent6 = new Intent(getActivity(), VoucherCardSalesActivity.class);
                        intent6.putExtra(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
                        intent6.putExtra(AppConstants.ExtraKeys.CONFIRM_CONTENT, mConfirmContent);
                        startActivity(intent6);
                        break;
                    //case 7:
                    //上传购物小票
                    //Intent intent7 = new Intent(getActivity(), UploadShoppingReceiptActivity.class);
                    //intent7.putExtra(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
                    //startActivity(intent7);
                    //break;
                    default:
                        break;
                }
            }
        });
    }

    /**
     * @param specSwitch     权益卡销售开关
     * @param confirmContent
     */
    private void showBenefitCardModule(boolean specSwitch, String confirmContent) {
        this.mSpecSwitch = specSwitch;
        this.mConfirmContent = confirmContent;

        List<String> menuTitles = Arrays.asList(mContext.getResources().getStringArray(R.array.member_home_menu_default_title));
        if (specSwitch) {
            menuTitles = Arrays.asList(mContext.getResources().getStringArray(R.array.member_home_menu_other_title));
            //获取权益卡数据
            //loadBenefitCardData();
            //初始化打印设备
            //initPrinter();
        }

        ArrayAdapter<String> arrayAdapter =
                new ArrayAdapter<>(getActivity(), R.layout.listview_slide_item, R.id.tv_slide_item, menuTitles);

        slideLv.setAdapter(arrayAdapter);
    }

    /**
     * 初始化打印工具
     */
    private void initPrinter() {
        //如果品牌是鲜稻研，那就不显示打印按钮，因为鲜稻研用的是超市自带的秤。
        mPrinterTool = new PrinterTool(getActivity(), new PrinterTool.OnPrinterTool() {
            @Override
            public void onFinish() {
            }

            @Override
            public void onBegin() {
            }
        });
    }

    /**
     * 打印权益卡数据
     */
    private void printBenefitCard() {
        //当前默认产品存在，如果产品为空，就显示编码问题
        if (null == mMenefitCardList || mMenefitCardList.size() <= 0) {
            MyToast.show(StatusDbMap.statusDbMap("PRT102", "条码规则解析出错，找销管部易晨维护！"));
        } else {
            Double[] priceResults = MemActionDominator.calculatePrice(mMenefitCardList);
            /**总价格*/
            Double totalPrice = priceResults[0];
            /**总实际价格*/
            Double actualPrice = priceResults[1];

            mPrinterTool.printMsg(mMenefitCardList, actualPrice, totalPrice);
        }
    }

    /**
     * 读取线下权益卡数据
     */
    private void loadBenefitCardData() {
        ThreadManager.getThreadPool().execute(() -> {
            mMenefitCardList = Item001DbOperate.GetCanXiaoShouProductsByItemId(
                    SystemHelper.LoginOrganId, "2.70224");
        });
    }


    /**
     * 头部由会员信息变成销售补录Fragment
     */
    public void changeTopFra(boolean isAdditionalRecordTemp) {
        isAdditionalRecord = isAdditionalRecordTemp;
        //销售补录
        if (isAdditionalRecord) {
            AdditionalRecordFra additionalRecordFra = AdditionalRecordFra.newInstance();
            fragmentManager.beginTransaction()
                    .replace(R.id.member_detail_container_ll, additionalRecordFra)
                    .commit();
            new AdditionalRecordPre(additionalRecordFra);
            additionalRecordFra.setSelectTimeCallback(this);
        }
        //头部首页
        else {
            memberDetailFra = MemberDetailFra.newInstance(phoneNum, true, true, false);
            fragmentManager.beginTransaction()
                    .replace(R.id.member_detail_container_ll, memberDetailFra)
                    .commit();
            new MemberDetailPre(memberDetailFra);
        }
    }

    @Override
    protected View getLoadingTargetView() {
        return null;
    }

    @Override
    protected int getContentViewLayoutID() {
        return R.layout.fra_member_home;
    }

    @Override
    public void setPresenter(@NonNull Object o) {

    }

    @Override
    public void widgetsClick(View v) {
        super.widgetsClick(v);

        switch (v.getId()) {
            //五谷磨房常规销售
            case R.id.add_sell_ll_wgmf:
                jumpToAddSellAct(SystemHelper.WgmfBrand, false);
                break;
            //会员商品常规销售【原鲜稻研】
            case R.id.add_sell_ll_memGoods:
                jumpToAddSellAct(SystemHelper.MemGoodsBrand, false);
                break;
            //到家销售
            case R.id.add_sell_ll_2_home:
                jumpToAddSellAct(SystemHelper.WgmfBrand, true);
                break;
            default:
                break;
        }
    }

    /**
     * 跳转选择产品页面
     *
     * @param wgmfBrand ...
     */
    private void jumpToAddSellAct(String brand, Boolean is2Home) {
        Intent intent = new Intent(getActivity(), AddSellAct.class);
        intent.putExtra(AppConstants.ExtraKeys.ADD_SELL_BRAND, brand);
        intent.putExtra(AppConstants.ExtraKeys.REGULAR_SALES, true);
        intent.putExtra(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
        intent.putExtra(AppConstants.ExtraKeys.IS_ADDITIONAL_RECORD, isAdditionalRecord);
        intent.putExtra(AppConstants.ExtraKeys.IS_2_HOME, is2Home);
        intent.putExtra(AppConstants.ExtraKeys.SELECT_TIME, selectTime);
        startActivity(intent);
    }

    @Override
    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
        super.onCreateOptionsMenu(menu, inflater);
        inflater.inflate(R.menu.member_home, menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.toggle_slide:
                toggleDrawer();
                break;
            default:
                break;
        }
        return super.onOptionsItemSelected(item);
    }

    /**
     * 按钮按下，将抽屉打开
     */
    private void toggleDrawer() {
        if (rootDl.isDrawerOpen(Gravity.END)) {
            rootDl.closeDrawers();
        } else {
            rootDl.openDrawer(Gravity.END);
        }
    }

    @Override
    public void changeListShowAndBtnAble(String selectTime, boolean isHideListAndBtnUnable) {
        this.selectTime = selectTime;
        addSellWgmf.setEnabled(!isHideListAndBtnUnable);
        addSellMemGoods.setVisibility(View.GONE);//暂时不需要考虑会员商品的补录情况
        memberCommonActionListContainerLl.setVisibility(isHideListAndBtnUnable ? View.INVISIBLE : View.VISIBLE);
        memberVipActionListContainerLl.setVisibility(isHideListAndBtnUnable ? View.INVISIBLE : View.VISIBLE);
        //在显示，并且已经初始化过，更新数据；
        if (!isHideListAndBtnUnable) {
            //全场活动请求数据
            if (memberActionListPre != null) {
                memberActionListPre.getActionList(false, SystemHelper.LoginOrganId, phoneNum, selectTime, isAdditionalRecord);
            }
            //专享活动请求数据
            if (memberActionListPreVip != null) {
                memberActionListPreVip.getActionList(true, SystemHelper.LoginOrganId, phoneNum, selectTime, isAdditionalRecord);
            }
        }
    }

    /**
     * 判断是否显示会员商品按钮
     */
    private boolean isShowAddSellMemGoods() {
        return !TextUtils.isEmpty(phoneNum) && Item001DbOperate.hasMemGoods() && !baseAct.commonToolbar.getTitle().equals("销售补录");
    }

    //专门为到家销售按钮写一个。。。真是服了
    @Subscribe(threadMode = ThreadMode.MAIN)
    public void onShowEvent2(final Show2HomeBean btnBean) {
        Boolean visible = btnBean.isShowBtn();
        addSell2home.setVisibility(visible ? View.VISIBLE : View.GONE);
        toHomeTipTv.setVisibility(visible ? View.VISIBLE : View.GONE);
    }

    @SuppressWarnings("unused")
    @Subscribe(threadMode = ThreadMode.MAIN)
    public void onShowEvent(final ActionFreshBtnBean btnBean) {
        //因为基础资料下载需要时间，所以要刷新一下。
        addSellWgmf.setVisibility(SystemHelper.hasWgmf() ? View.VISIBLE : View.GONE);
        //会员商品先不考虑销售补录的情况
        addSellMemGoods.setVisibility(isShowAddSellMemGoods() ? View.VISIBLE : View.GONE);
        //TabMenuActivity 中请求全场活动完成前，也需要时间，也要刷新下。
        if (btnBean.brandTypeList != null) {
            for (int brandType : btnBean.brandTypeList) {
                if (AppConstants.BRAND.WGMF == brandType) {
                    addSellWgmf.setEnabled(btnBean.isShow);
                }
            }
        }
        addSellWgmfMengban.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View view, MotionEvent motionEvent) {
                if (!btnBean.isShow) {
                    MyToast.show("门店正在做全场折扣，只能通过折扣活动录单！");
                    return true;
                } else {
                    return false;//点击穿透
                }
            }
        });

        //if (mSpecSwitch) {
        //加载线下权益卡数据
        //    loadBenefitCardData();
        //}
    }

    protected void showPublicTipDialog(String title, String content, String url, String confirmBtn, String cancelBtn) {
        if (baseAct == null) return;
        PublicTipDialog.Companion.Builder builder = new PublicTipDialog.Companion.Builder(baseAct);
        builder.setMessage(content);
        builder.setTitle(title);
        builder.setPositiveButton(confirmBtn,
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                        showPublicPictureDialog(url);
                    }
                });
        builder.setNegativeButton(cancelBtn,
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });

        if (baseAct != null && !baseAct.isFinishing()) {
            builder.create().show();
        }
    }

    protected void showPublicPictureDialog(String url) {
        int width = DensityUtil.getScreenW(mContext);
        int height = width / 3 * 4;

        PublicPictureDialog.Builder builder = new PublicPictureDialog.Builder(mContext);
        builder.setUrl(url);
        builder.setCententLayoutId(R.layout.view_picture_three_dialog);
        builder.setWidth(width);
        builder.setHeight(height);
        builder.setPositiveButton(
                (dialog, which) -> dialog.dismiss());
        PublicPictureDialog tipDialog = builder.create();
        tipDialog.setCanceledOnTouchOutside(false);
        if (this != null && !getActivity().isFinishing()) {
            tipDialog.show();
        }
    }

    /**
     * 判断是否权益卡套餐的目标人群（谷谷、银谷会员
     */
    public void checkCardTargetCus() {
        ViewUtil.showProgress(getActivity(), "", "请稍等.....");
        HashMap<String, String> param = new HashMap<>(3);
        param.put("staffId", SystemHelper.LoginUserId);
        param.put("shopId", SystemHelper.LoginOrganId);
        param.put("mobile", phoneNum);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + NetParam.checkCardTargetCus, param,
                new OkHttpDominator.ResultCallback<VoucherCardResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        //刷新侧边栏数据
                        showBenefitCardModule(false, "");
                    }

                    @Override
                    public void onResponse(VoucherCardResponse response) {
                        ViewUtil.dismissProgress();
                        if (response == null) {
                            return;
                        }
                        if (response.msgCode == 0) {
                            if (null != response.getResultInfo()) {
                                VoucherCardBean bean = response.getResultInfo();
                                if (bean.isShowFlag()) {
                                    //弹窗
                                    //showPublicTipDialog(
                                    //        mVoucherCardBean.getTitle(),
                                    //        mVoucherCardBean.getContent(),
                                    //        mVoucherCardBean.getImage(),
                                    //        mVoucherCardBean.getConfirmBtn(),
                                    //        mVoucherCardBean.getCancelBtn());

                                    String imageUrl = bean.getImage();
                                    if (!TextUtils.isEmpty(imageUrl)) {
                                        showPublicPictureDialog(imageUrl);
                                    }
                                }
                                //刷新侧边栏数据
                                showBenefitCardModule(bean.getSpecSwitch(), bean.getConfirmContent());
                            }
                        } else {
                            showBenefitCardModule(false, "");
                        }
                    }
                });
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
        unbinder.unbind();
    }

}