package com.wgmf.trade.ui.fra.index;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.text.Html;
import android.text.TextUtils;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.ScrollView;
import android.widget.TextView;

import com.sibyl.addsellactivity.view.AddSellAct;
import com.urovo.activity.sell.SaveFailureActivity;
import com.urovo.activity.sell.SaveSuccessActivity;
import com.urovo.activity.tabMenu.home.pre.SubmitOrderPre;
import com.urovo.activity.tabMenu.home.task.OrderTask;
import com.urovo.activity.tabMenu.view.TabMenuActivity;
import com.urovo.wgmf.db.dao.dao.Cpbill002DbOperate;
import com.urovo.wgmf.db.dao.dao.Djxs001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djxs002DbOperate;
import com.urovo.wgmf.db.dao.dao.Item001DbOperate;
import com.urovo.wgmf.db.dao.entitys.OrderReqBean;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.ConstantParams;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.ListDominator;
import com.urovo.wugumofang.data.MoneyUtils;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.printermodule.PrinterTool;
import com.urovo.wugumofang.system.PdaMsgConfig;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.utils.CommonTools;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.utils.TaskEnqueueDominator;
import com.urovo.wugumofang.view.webview.FraContainerAct;
import com.wgmf.trade.model.bean.MemActionDominator;
import com.wgmf.trade.model.bean.MemberAction;
import com.wgmf.trade.model.bean.ProGroupInfoBean;
import com.wgmf.trade.model.bean.ProductInfoBean;
import com.wgmf.trade.presenter.MemberDetailPre;
import com.wgmf.trade.presenter.MemberSalesPre;
import com.wgmf.trade.ui.ada.BaseMemberSalesAda;
import com.wgmf.trade.ui.ada.MemberSalesXdyAda;
import com.wgmf.trade.ui.fra.more.cases.EnjoyDiscountCase;
import com.wgmf.trade.ui.fra.more.cases.Input2HomeOrderCase;
import com.wgmf.trade.ui.fra.more.cases.InputActionCodeCase;
import com.wgmf.trade.ui.fra.more.cases.MemGoodsOrderCase;
import com.wgmf.trade.ui.fra.more.cases.OrderSaveCase;
import com.wgmf.trade.utils.ArithUtil;
import com.wgmf.trade.utils.VerifyUtil;
import com.wgmf.trade.view.MemberSalesCon;
import com.wgmf.trade.widgets.ExtListView;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.ui.ada.helper.ViewHelper;
import com.zsy.libcore.ui.ada.quickadapter.QuickAdapter;
import com.zsy.libcore.ui.fra.FragmentArgs;
import com.zsy.libext.ui.fra.BaseFra;
import com.zsy.libext.widgets.dialog.effectsdialog.EffectsAlertDialog;
import com.zsy.libext.widgets.tips.ToastMsg;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AlertDialog;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

import static com.urovo.wugumofang.data.DateUtil.String2Date;

/**
 * 会员主页的第二个界面
 * 会员销售(常规销售，全场销售，专享销售)
 * 由于下面提交原因，也得包含上半部分会员详情数据；
 *
 * @author samy
 * @date 16/9/8
 */
@SuppressWarnings("all")
public class MemberSalesFra extends BaseSubmitOrderFra implements MemberSalesCon.View, OrderTask.OrderResultListener, BaseMemberSalesAda.SaleAdaCallBack {
    protected String phoneNum;
    protected MemberAction memberAction;
    protected BaseMemberSalesAda memberSalesAda;
    protected QuickAdapter<ProductInfoBean> quickAdapter;

    private static String PLZ_SELECT_PRO = "请选择商品";
    private static String PLZ_SELECT_GIFT = "请选择赠品";
    private static String AGAIN_SELECT_PRO = "重新选择商品";
    private static String AGAIN_SELECT_GIFT = "重新选择赠品";
    /**
     * 暂存销售单号
     */
    protected String billCache;
    @BindView(R.id.member_detail_container_ll)
    LinearLayout memberDetailContainerLl;
    @BindView(R.id.action_type_tv)
    TextView actionTypeTv;
    /**
     * 活动详情
     */
    @BindView(R.id.action_type_detail_tv)
    TextView actionTypeDetailTv;
    @BindView(R.id.action_title_rl)
    RelativeLayout actionTitleRl;
    @BindView(R.id.pro_gift_des_tv)
    TextView proGiftDesTv;
    @BindView(R.id.pro_gift_num_tv)
    TextView proGiftNumTv;
    @BindView(R.id.pro_gift_rl)
    RelativeLayout proGiftRl;
    @BindView(R.id.pro_selected_elv)
    ExtListView proSelectedElv;
    @BindView(R.id.pro_extra_content_tv)
    TextView proExtraContentTv;
    @BindView(R.id.pro_extra_content_rl)
    RelativeLayout proExtraContentRl;
    @BindView(R.id.pro_opt_ll)
    LinearLayout proOptLl;
    @BindView(R.id.gift_action_type_opt_tv)
    TextView giftActionTypeOptTv;
    @BindView(R.id.gift_point_tv)
    TextView giftPointTv;
    @BindView(R.id.gift_point_rl)
    RelativeLayout giftPointRl;
    @BindView(R.id.gift_selected_elv)
    ExtListView giftSelectedElv;
    @BindView(R.id.gift_goto_list_tv)
    TextView giftGotoListTv;
    @BindView(R.id.gift_des_and_goto_rl)
    RelativeLayout giftDesAndGotoRl;
    @BindView(R.id.gift_opt_ll)
    LinearLayout giftOptLl;
    @BindView(R.id.reduce_price_des_tv)
    TextView reducePriceDesTv;
    @BindView(R.id.reduce_price_num_tv)
    TextView reducePriceNumTv;
    @BindView(R.id.reduce_price_rl)
    RelativeLayout reducePriceRl;
    @BindView(R.id.actual_price_tv)
    TextView actualPriceTv;
    @BindView(R.id.total_price_tv)
    TextView totalPriceTv;
    @BindView(R.id.total_price_rl)
    RelativeLayout totalPriceRl;
    @BindView(R.id.continue_add_btn)
    Button continueAddBtn;
    @BindView(R.id.barcode_print_btn)
    Button barcodePrintBtn;
    @BindView(R.id.action_opt_container_ll)
    LinearLayout actionOptContainerLl;
    @BindView(R.id.sent_point_no_ll)
    LinearLayout sentPointNoLl;
    @BindView(R.id.sales_sv)
    ScrollView salesSv;
    @BindView(R.id.out_actual_price_tv)
    TextView outActualPriceTv;
    @BindView(R.id.out_total_price_tv)
    TextView outTotalPriceTv;
    @BindView(R.id.save_order_btn)
    Button saveOrderBtn;
    @BindView(R.id.saveOverView)
    View saveOverView;//保存按钮遮罩层
    /**
     * 总价格
     */
    private double totalPrice = 0;
    /**
     * 总实际价格
     */
    private double actualPrice = 0;
    /**
     * 订单任务
     */
    private OrderTask orderTask;
    /**
     * 是否是销售补录状态
     */
    private boolean isAdditionalRecord;
    /**
     * 是否是到家订单
     */
    private boolean is2Home;

    /**
     * 商品数组[主Adapter数组],BaseAda不做共享内存处理
     */
    private ArrayList<ProductInfoBean> productInfoBeans = new ArrayList<>();
    /**
     * 商品组合数组
     */
    private ArrayList<ProGroupInfoBean> productGroupInfoBeans = new ArrayList<>();
    /**
     * 赠品数组[主Adapter数组],QuickAdapter不做共享内存处理,为了一致性,不共享内存处理
     */
    private ArrayList<ProductInfoBean> giftProductInfoBeans = new ArrayList<>();
    /**
     * 赠品组合数组
     */
    private ArrayList<ProGroupInfoBean> giftProductGroupInfoBeans = new ArrayList<>();
    /**
     * 数组
     */
    private ArrayList<ProductInfoBean> productInfoBeansResult = new ArrayList<>();
    private ArrayList<ProductInfoBean> continueProductInfoBeansResult = new ArrayList<>();
    private ArrayList<ProductInfoBean> giftProductInfoBeansResult = new ArrayList<>();
    /**
     * 继续添加的数组,旧数据格式
     */
    private List<ProductEntity> productEntities;
    /**
     * 更新ProductAdapter的总数组（可以公用)
     *///排序为:商品、继续添加的商品、组合商品
    private ArrayList<ProductInfoBean> productInfoBeansAll = new ArrayList<>();
    /**
     * 更新GiftProductAdapter的总数组（可以公用)
     *///排序为:赠品品、组合赠品
    private ArrayList<ProductInfoBean> giftProductInfoBeansAll = new ArrayList<>();
    private MemberSalesCon.Pre memberSalesPre;
    private ArrayList<ProductInfoBean> productForPrintTemp;
    private boolean isPda;
    private BroadcastReceiver mReceiver;
    private IntentFilter mFilter;
    private PrinterTool mPrinterTool;
    /**
     * 新价格比例,默认比例为1
     */
    private double newPricePercentage = 1;
    private String selectTime;
    public String exChangeCode = "";
    public String toHomeOrderCode = "";
    private boolean isAutoCheckCode = false;//标记是否自动连网校验验证码（核销情况是首页扫码然后自动校验，其它情况是需要弹窗手动输入验证码的）
    /**
     * 品牌【默认为“五谷磨房”】（至于为什么要单独设一个变量来存品牌，
     * 是因为如果是从活动进到这里来的，那就应该都默认为五谷磨房品牌，而不是鲜稻研（虽然不知道以后会不会改）
     * 如果是从常规销售关闭后跳转到这里，那那个“继续添加”的按钮，再点进去跳转到常规销售，是跳五谷磨房还是跳鲜稻研？就需要由
     * 之前常规销售跳过来时传的标记来判断，传过来的是什么品牌，再跳回去的就应该还是那个品牌
     */
    private String brand = SystemHelper.WgmfBrand;

    /**
     * 订单上传和回调
     */
    private SubmitOrderPre mSubmitOrderPre;

    private String mFlag = ""; // 标记特价活动是否存在满足条件的产品
    private String mIsDecimal = ""; // 是否散装标记

    public static void launch(Context context, String phoneNum, MemberAction selectedMemberAction, boolean isAdditionalRecord, String selectTime, String brand) {
        launch(context, phoneNum, selectedMemberAction, isAdditionalRecord, selectTime, brand, null);
    }

    public static void launch(Context context, String phoneNum, MemberAction selectedMemberAction, boolean isAdditionalRecord, String selectTime, String brand, String brandType) {
        FragmentArgs fragmentArgs = new FragmentArgs();
        fragmentArgs.add(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
        fragmentArgs.add("MEMBER_ACTION", selectedMemberAction);
        fragmentArgs.add("IS_ADDITIONAL_RECORD", isAdditionalRecord);
        fragmentArgs.add("selectTime", selectTime);
        fragmentArgs.add(AppConstants.ExtraKeys.IS_2_HOME, selectedMemberAction.arriveHome == 1);
        fragmentArgs.add("BRAND", brand);
        FraContainerAct.launch(context, MemberSalesFra.class, fragmentArgs, false);
    }

    /**
     * 首页扫码跳转核销的情况
     * 注：多加了个核销码的传值 checkCode
     */
    public static void launchForExchangeCode(Context context, String phoneNum, MemberAction selectedMemberAction, String selectTime, String exChangeCode, String brand) {
        FragmentArgs fragmentArgs = new FragmentArgs();
        fragmentArgs.add(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
        fragmentArgs.add("MEMBER_ACTION", selectedMemberAction);
        fragmentArgs.add("IS_ADDITIONAL_RECORD", false);
        fragmentArgs.add("selectTime", selectTime);
        fragmentArgs.add("exChangeCode", exChangeCode);
        fragmentArgs.add("BRAND", brand);
        FraContainerAct.launch(context, MemberSalesFra.class, fragmentArgs, false);
    }

    /**
     * 老Model转换成新Model
     */
    public static ArrayList<ProductInfoBean> changeOldToNewModels(List<ProductEntity> productsContinue) {
        ArrayList<ProductInfoBean> productInfoBeansTemp = new ArrayList<>();
        //转换
        for (ProductEntity productEntity : productsContinue) {
            ProductInfoBean productInfoBean = new ProductInfoBean();
            productInfoBean.code = productEntity.getItemId();
            productInfoBean.name = productEntity.getItemName();
            productInfoBean.setPrice(productEntity.getPrice());
            productInfoBean.setProType(2);
            productInfoBean.setProNum(productEntity.getTQTY());
            productInfoBean.setItemMode(productEntity.getItemMode());
            productInfoBean.setKCUom(productEntity.getKCUom());
            productInfoBean.setUnit(productEntity.getUnit());
            //productInfoBeanTemp.setAmount(productEntityTemp.getAmount());//默认情况下；
            productInfoBean.setBarcode(productEntity.getBarcode());
            productInfoBean.setBrand(productEntity.getBrand());
            productInfoBean.setClassid(productEntity.getClassid());
            productInfoBean.setClassidorder(productEntity.getClassidorder());
            productInfoBean.setDecimal(productEntity.isDecimal());
            productInfoBean.setStockQty(productEntity.getStock_Qty());//会员商品新增的库存暂存字段。

            //【以下Amount鲜稻研用到】
            //五谷磨房品牌不需要手动赋Amount，就算赋进来了好像也不会用到，
            // 但鲜稻研需要用到，因为要直传用户输入的总价，而不能经过计算去得到不精准的总价
            productInfoBean.Amount = productEntity.getAmount();

            productInfoBeansTemp.add(productInfoBean);
        }
        return productInfoBeansTemp;
    }

    @Override
    protected void getBundleExtras(Bundle extras) {
        super.getBundleExtras(extras);
        phoneNum = extras.getString(AppConstants.ExtraKeys.PHONE_NUM);
        if (phoneNum == null) phoneNum = "";
        isAdditionalRecord = extras.getBoolean("IS_ADDITIONAL_RECORD");//是否是销售补录状态
        is2Home = extras.getBoolean(AppConstants.ExtraKeys.IS_2_HOME, false);
        memberAction = (MemberAction) extras.getSerializable("MEMBER_ACTION");
        selectTime = extras.getString("selectTime");
        exChangeCode = extras.getString("exChangeCode", "");
        isAutoCheckCode = !TextUtils.isEmpty(exChangeCode);//不为空，则是自动校验，不用弹窗输入
        brand = extras.getString("BRAND");
        memberSalesPre = new MemberSalesPre(this);
        //提交订单入口
        mSubmitOrderPre = new SubmitOrderPre(getActivity(), phoneNum) {
            @Override
            public void skipToOrderResult() {
                MemberSalesFra.this.skipToOrderResult(SaveSuccessActivity.class);
            }
        };
    }

    //保存按钮点击时的任务队列（避免回调地狱）
    TaskEnqueueDominator saverEnque;

    //到家业务输入订单号的弹窗
    EffectsAlertDialog toHomeCodeDialog;

    Unbinder unbinder;

    @Override
    protected void initWidgetsAndEvents(View view) {
        unbinder = ButterKnife.bind(this, view);
        baseAct.commonToolbar.setTitle(isAdditionalRecord ? "销售补录" : "会员主页");
        //让键盘跟随输入框弹起
        getActivity().getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_ADJUST_PAN);
        FragmentManager fragmentManager = getFragmentManager();
        //if (!TextUtils.isEmpty(phoneNum)) {
        //  inputMemberNumFl.setVisibility(View.GONE);
        //头部首页
        MemberDetailFra memberDetailFra = MemberDetailFra.newInstance(phoneNum, false, false, true);
        fragmentManager.beginTransaction()
                .replace(R.id.member_detail_container_ll, memberDetailFra)
                .commit();
        new MemberDetailPre(memberDetailFra);
        //}

        initPosDevice();
        initPrinter();
        //专享
        if (memberAction.actType == 0) {
            actionTypeTv.setBackgroundResource(R.mipmap.vip_activity);
        }
        //全场
        else if (memberAction.actType == 1) {
            actionTypeTv.setBackgroundResource(R.mipmap.common_activity);
        }
        //常规
        else if (memberAction.actType == 2) {
            actionTypeTv.setBackgroundResource(R.mipmap.common_sale);
        }
        actionTypeDetailTv.setText(memberAction.name);
        actionTypeDetailTv.setOnClickListener(this);
        proExtraContentTv.setOnClickListener(this);
        giftGotoListTv.setOnClickListener(this);
        continueAddBtn.setVisibility(memberAction.notjoinsale == 1 ? View.INVISIBLE : View.VISIBLE);
        continueAddBtn.setEnabled(memberAction.notjoinsale == 0);
        continueAddBtn.setOnClickListener(this);
        barcodePrintBtn.setOnClickListener(this);
        saveOrderBtn.setOnClickListener(this);
        //保存按钮遮罩层（利用点击穿透，来提前校验赠品）
        saveOverView.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                if (giftGotoListTv.getVisibility() == View.VISIBLE//如果添加赠品按钮可见，并且显示为“请添加赠品”，那就拦截点击事件
                        && giftGotoListTv.getText().toString().equals(PLZ_SELECT_GIFT)) {
                    ToastMsg.showToastMsg(getActivity(), "请选择赠品，满足活动条件后才能保存！");
                    return true;//拦截点击事件。
                } else {
                    return false;//把点击事件传递给下面的真正的保存按钮
                }
            }
        });
        //长按打印按钮，清除上次保存的蓝牙配对记录，这样再报错 ”设备不具备打印功能“ 的时候，就可以重新配对了。
        barcodePrintBtn.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View view) {
                PreferHelper.getInstance().remove(AppConstants.PreKeys.PRINT_ADDRESS);
                ToastMsg.showToastMsg(getActivity(), "已清除蓝牙配对记录");
                return true;
            }
        });

        showProductInfoLogic();
        //if (memberAction.checkRuleOrNot == 0){
        showGiftLogic();
        //}
        updatePriceShow();
    }

    private void initPosDevice() {
    }

    private void initPrinter() {
        //如果品牌是鲜稻研，那就不显示打印按钮，因为鲜稻研用的是超市自带的秤。
        mPrinterTool = new PrinterTool(getActivity(), new PrinterTool.OnPrinterTool() {
            @Override
            public void onFinish() {
                if (getActivity() != null && !getActivity().isFinishing()) {
                    barcodePrintBtn.setEnabled(MemActionDominator.hasWgmfExist(productInfoBeansAll));
                }
            }

            @Override
            public void onBegin() {
                if (getActivity() != null && !getActivity().isFinishing()) {
                    barcodePrintBtn.setEnabled(false);
                }
            }
        });
    }

    /**
     * 加 积分兑换活动用
     * 活动商品列
     */
    private void showProductInfoLogic() {
        proGiftRl.setVisibility(memberAction.rule.point > 0 ? View.VISIBLE : View.GONE);
        proGiftNumTv.setText(memberAction.rule.point + "积分");
        //新：【活动单品】在初始化其它list之前，先把后台返回的活动产品列表里的isDecimal标记做初始化。
        if (memberAction.rule.productInfo != null) {
            for (ProductInfoBean bean : memberAction.rule.productInfo) {
                bean.setDecimal(Cpbill002DbOperate.isDecimalById(bean.code));
            }
        }
        //新：【活动组合产品】在初始化其它list之前，先把后台返回的活动产品列表里的isDecimal标记做初始化。
        if (memberAction.rule.proGroupInfo != null) {
            for (ProGroupInfoBean group : memberAction.rule.proGroupInfo) {
                if (group.product != null && group.product.size() != 0) {
                    for (ProductInfoBean product : group.product) {
                        product.setDecimal(Cpbill002DbOperate.isDecimalById(product.code));
                    }
                }
            }
        }

        if (memberAction.rule.productInfo != null) {
            //存储起来;
            productInfoBeans.addAll(memberAction.rule.productInfo);
            //初始化用于计算价格;
            productInfoBeansAll.addAll(memberAction.rule.productInfo);
        }

        if (memberAction.rule.proGroupInfo != null) {
            productGroupInfoBeans = memberAction.rule.proGroupInfo;
        }
        //为满足混合录单，不再通过品牌来选择不同的adapter，把所有逻辑都塞到xdyAdapter里。。。
        memberSalesAda = new MemberSalesXdyAda(getActivity(), productInfoBeans, this);
        if (memberSalesAda != null) {
            proSelectedElv.setAdapter(memberSalesAda);
        }

        //初始化两个添加产品和赠品的按钮的文字
        proExtraContentTv.setText(PLZ_SELECT_PRO);
        giftGotoListTv.setText(PLZ_SELECT_GIFT);
        if (memberAction.checkGroupArrayNull(productGroupInfoBeans)) {//所需活动所需积分
            proExtraContentRl.setVisibility(View.VISIBLE);
        } else {
            proExtraContentRl.setVisibility(View.GONE);
            proExtraContentTv.setText("");
        }
        if (memberAction.sentProPointOrNot == 1) {//sentProPointOrNot：0 送积分不显示提示内容，1 不送积分显示。
            sentPointNoLl.setVisibility(View.VISIBLE);
        }
    }

    /**
     * 赠品列表
     * 减免
     */
    private void showGiftLogic() {
        //选择赠品
        giftDesAndGotoRl.setVisibility(View.GONE);
        giftGotoListTv.setText("");
        //赠送
        giftPointRl.setVisibility(View.GONE);
        //减免
        reducePriceRl.setVisibility(View.GONE);
        if (memberAction.giftRule == null) {
            return;
        }

        if (memberAction.giftRule.giftProductInfo != null) {
            //存储起来;
            giftProductInfoBeans.addAll(memberAction.giftRule.giftProductInfo);
            SYLoger.print("wgmf giftProductInfo-->" + memberAction.giftRule.giftProductInfo);
            //初始化用于计算价格;
            giftProductInfoBeansAll.addAll(memberAction.giftRule.giftProductInfo);
        }
        /**
         * 赠品或减免产品列表的适配器
         */
        quickAdapter = new QuickAdapter<ProductInfoBean>(R.layout.item_gift_selected, giftProductInfoBeans) {
            @Override
            protected void onBindData(Context context, int i, ViewHelper viewHelper, int i1,
                                      final ProductInfoBean giftProductInfoBean) {
                if (SystemHelper.isWgmf(giftProductInfoBean.getBrand())) {
                    viewHelper.setText(R.id.gift_name_tv,
                            giftProductInfoBean.name + " x " + MoneyUtils.dynamicLastDF(giftProductInfoBean.getProNum()));
                } else if (!SystemHelper.isWgmf(giftProductInfoBean.getBrand())) {
                    viewHelper.setText(R.id.gift_name_tv, giftProductInfoBean.name + " x " + MoneyUtils.dynamicLastDF(giftProductInfoBean.getProNum()) + " kg");
                } else {
                }
            }
        };
        giftSelectedElv.setAdapter(quickAdapter);

        if (memberAction.giftRule.giftProGroupInfo != null) {
            giftProductGroupInfoBeans = memberAction.giftRule.giftProGroupInfo;
        }
        //所需活动所需积分
        if (memberAction.checkGroupArrayNull(giftProductGroupInfoBeans)) {
            giftDesAndGotoRl.setVisibility(View.VISIBLE);
            giftGotoListTv.setText(PLZ_SELECT_GIFT);
        }

        //赠送
        //giftPointRl.setVisibility(View.GONE);
        if (memberAction.giftRule.giftPoint > 0) {
            giftPointTv.setText(String.format(Locale.CHINA, "%s积分", MoneyUtils.twolastDF(memberAction.giftRule.giftPoint)));
            giftPointRl.setVisibility(View.VISIBLE);
        }
        if (memberAction.giftRule.giftPointMultiple > 0) {
            giftPointTv.setText(String.format(Locale.CHINA, "%s倍积分", MoneyUtils.twolastDF(memberAction.giftRule.giftPointMultiple)));
            giftPointRl.setVisibility(View.VISIBLE);
        }
        //减免
        //reducePriceRl.setVisibility(View.GONE);
        if (memberAction.giftRule.giftMoney > 0) {
            reducePriceNumTv.setText(String.format(Locale.CHINA, "￥%s", MoneyUtils.twolastDF(memberAction.giftRule.giftMoney)));
            reducePriceRl.setVisibility(View.VISIBLE);
        }
        if (memberAction.giftRule.giftDiscount > 0) {
//            reducePriceNumTv.setText(String.format(Locale.CHINA, "%s折", MoneyUtils.twolastDF(memberAction.giftRule.giftDiscount)));
            reducePriceNumTv.setText(MemActionDominator.makeDiscountTextString(memberAction));
            reducePriceRl.setVisibility(View.VISIBLE);
        }

        giftSelectedElv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                //现在通过点击重新选择的按钮了，不需要点击item了
            }
        });

    }

    @Override
    protected View getLoadingTargetView() {
        return null;
    }

    @Override
    protected int getContentViewLayoutID() {
        return R.layout.fra_member_sales;
    }

    private boolean isDocFlag;

    @Override
    public void widgetsClick(View v) {
        super.widgetsClick(v);
        switch (v.getId()) {
            case R.id.pro_extra_content_tv:// 请选择商品按钮
                setProductType(productGroupInfoBeans, 1);
                jumpToProductSelection(productGroupInfoBeans, 300, false,
                        memberAction.activityType, memberAction.activityId, phoneNum, memberAction.rule.groupTip);
                restoreRuleData();// 复位giftRule赠品规则，使选择完产品退回来时，可以重新点击“立享优惠”
                break;   // if(ConstantParams.CONSTANT_PARAMS_14.equals(mActivityType))
            case R.id.gift_goto_list_tv:
                setProductType(giftProductGroupInfoBeans, 1);
                jumpToProductSelection(giftProductGroupInfoBeans, 301, true,
                        memberAction.activityType, memberAction.activityId, phoneNum, "");
                break;
            //表示非第一次继续添加数据;或者常规销售情况；
            case R.id.continue_add_btn:
                //活动actType=0,actType=1;
                if ((productEntities != null && productEntities.size() > 0) && memberAction.checkProArrayNull(continueProductInfoBeansResult)) {
                    changeNewToOldModels(productEntities, continueProductInfoBeansResult);
                } else {
                    //第一次，常规销售情况；只会走一次；如果已经有数据的话就走上面方法；
                    if (memberAction.actType == 2) {
                        productEntities = new ArrayList<>();
                        productEntities.addAll(changeNewToOldModels(memberAction.rule.productInfo, false));
                    }
                }
                restoreRuleData();
                Intent intent = new Intent(getActivity(), AddSellAct.class);
//                intent.putExtra(AppConstants.ExtraKeys.BRAND_NO_SHOW_STATE, memberAction.brandCheck);//brandCheck：【1：只允许五谷产品，2：只允许散装，3：不限制产品】
                intent.putExtra(AppConstants.ExtraKeys.ADD_SELL_BRAND, brand);
                intent.putExtra(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
                intent.putExtra(AppConstants.ExtraKeys.IS_2_HOME, is2Home);
                intent.putExtra("sales", (Serializable) productEntities);
                intent.putExtra("actListIds", (Serializable) getProductAndGroupIds());
//                intent.putExtra("totalPrice", totalPrice);
                startActivityForResult(intent, 302);
                break;
            //仅仅打印
            case R.id.barcode_print_btn:
                if (memberAction.checkProArrayNull(productInfoBeansAll)) {
                    // 仅仅用来打印，跟保存订单页面无关系。
                    dealSpecialPrice(true);
                } else {
                    ToastMsg.showToastMsg(getActivity(), "请选择商品打印!");
                }
                break;
            case R.id.save_order_btn:
                if (!CommonTools.INSTANCE.isOneClick()) return;
                orderTask = new OrderTask(saveOrderBtn, this);
                //开启任务队列（带pause的是带悬停的，不带pause的是不悬停的）
                saverEnque = new TaskEnqueueDominator();
                toHomeCodeDialog = EffectsAlertDialog.getInstance(getActivity());
                //会员商品下单
                saverEnque.addPauseCase(new MemGoodsOrderCase(brand, memberSalesPre, actualPrice, phoneNum, productInfoBeansAll))
                        .addPauseCase(new EnjoyDiscountCase(saveOrderBtn, memberAction, memberSalesPre, phoneNum, productInfoBeansAll))//在线验证的情况下；giftRule一定是null;跟1对应上；//立享优惠
                        .addPauseCase(new InputActionCodeCase(this, memberAction, memberSalesPre, phoneNum, isAutoCheckCode))//验证验证码，或手动输入验证码
                        .addPauseCase(new Input2HomeOrderCase(this, toHomeCodeDialog, is2Home))//到家业务
                        .addCase(new OrderSaveCase(orderTask)).go();//最后保存订单
                break;
            case R.id.action_type_detail_tv:
                String message1 = "活动时间：\n" + memberAction.startTime + "--" + memberAction.endTime + "\n活动内容：\n" + memberAction.content;
                String message2 = "活动内容：" + memberAction.content;
                //消息内容是否居中显示
                boolean message3Flag = TextUtils.isEmpty(memberAction.startTime) || TextUtils.isEmpty(memberAction.endTime);
                //活动时间为空时处理
                String message3 = !message3Flag ? message1 : message2;

                final EffectsAlertDialog effectsAlertDialog = EffectsAlertDialog.getInstance(getActivity());
                effectsAlertDialog
                        .withTitle("活动详情")
                        .withMessage(message3, message3Flag)
                        .withSingleButton().setRightButtonClick(
                        new View.OnClickListener() {
                            @Override
                            public void onClick(View v) {
                                effectsAlertDialog.dismiss();
                            }
                        }).show();
                break;
            default:
        }
    }

    /**
     * 处理特价的逻辑，选择商品的集合中是特价的就按照特价的价格打印
     *
     * @param isJump2Printer 是否需要执行打印（不执行打印的话就是单纯的打印数据处理）
     */
    private void dealSpecialPrice(boolean isJump2Printer) {
        if (productForPrintTemp == null) {
            productForPrintTemp = new ArrayList<>();
        } else {
            // 不清空会影响到下次选择后打印的产品数
            productForPrintTemp.clear();
            SYLoger.print("页面保存：" + "清空集合。");
        }
        //把产品信息先缓存到temp表里，由于这一块涉及到改值，把产品价格改了再后面上传就会上传错误的信息，
        //而这里改值只是为了应付调价打印而已，为了避免改了原始产品数据，就加一个新List做缓存，并拿它来打印，
        //上传还是用原先老的list来上传。
        //深拷贝，避免改价影响到原表
        productForPrintTemp.addAll(ListDominator.clone(productInfoBeansAll));
        for (ProductInfoBean item : productForPrintTemp) {
            if (item.discountedPrice != 0) {//如果有特价，打印是会按照特价打印的，所以打折产品直接把打折后的价格覆盖特价字段就能打印了。
                item.specialPrice = item.discountedPrice;
            }
        }
        /**
         * 注：一定要把这个newPricePercentage的计算放到 mPrinterTool.printMsg(）前面做，
         * 因为这个计算里面包含了对 productForPrintTemp 元素的特价处理，
         * 而mPrinterTool.printMsg(）的第一个参数里，需要用到这个处理后的 productForPrintTemp
         * 把这个处理放到后面做的话，就晚了。。
         *
         * ① 有特价就把原价改成特价
         * ② 转换模型
         * ③ 过滤留下五谷磨房产品
         * ④ 把十方详情通过数据库查出来
         * ⑤ 算特价（把特价赋给price或用比例平摊）
         */
        List<ProductEntity> changedProTemps = changeNewToOldModels(productForPrintTemp, true);

        //打印（如果只是单纯处理生成打印列表，并不需要真正打印；为true时需要真正打印才打印）
        if (isJump2Printer) {
            mPrinterTool.printMsg(changedProTemps, actualPrice, totalPrice);
        }
    }

    /**
     * 点击保存按钮后需要组装的数据(数据库-->OrderReqBean)
     * 组装提交订单的数据
     */
    private boolean saveOrderToDB() {
        boolean isSaveSuccess;
        String storeId = SystemHelper.LoginOrganId;
        String userId = SystemHelper.LoginUserId;
        Date date = new Date();
        double diffPrice = ArithUtil.sub(actualPrice, totalPrice);
        OrderReqBean orderRequestBean = new OrderReqBean();
        orderRequestBean.setSentProPointOrNot(memberAction.sentProPointOrNot);
        if (memberAction.giftRule != null) {
            if (memberAction.giftRule.giftPoint <= 0 && memberAction.giftRule.giftPointMultiple > 0) {
                orderRequestBean.setGiftPoints(Math.floor(ArithUtil.mul(memberAction.giftRule.giftPointMultiple - 1d, actualPrice)));
            } else {
                orderRequestBean.setGiftPoints(memberAction.giftRule.giftPoint);
            }
        }
        orderRequestBean.setGiftMoney(-diffPrice);
        orderRequestBean.setBill(storeId + userId + DateUtil.format(date, "yyMMddHHmmss"));
        //暂存一下单号，要传给下一个成功界面。
        billCache = orderRequestBean.getBill();
        //这个地段不用传服务器，本地查询要用；
        orderRequestBean.setBillNo(Djxs001DbOperate.GetTodayXiaoShouNo() + 1);
        orderRequestBean.setCUSTID(phoneNum);
        // 老带新者号码
        orderRequestBean.setRecommendation("");
        orderRequestBean.setMDBC(SystemHelper.LoginBC);
        // 固定门店模式下posid 为4
        orderRequestBean.setPOSID(PdaMsgConfig.isPDA(getActivity()) ? "2" : "4");
        //如果是补录，时间就不需要时分秒了，只传日期。
        orderRequestBean.setSCDate(DateUtil.getDateTime(date));
        orderRequestBean.setPromid(memberAction.actType == 2 ? "" : memberAction.activityId + "");
        //orderRequestBean.setSaleBill();//原销售单号（退货时存原销售单号）
        if (isAdditionalRecord) {
            date = DateUtil.String2Date(selectTime + " " + DateUtil.getTime2(date), "yyyyMMdd HH:mm:ss");
        }

        Date date2 = String2Date(DateUtil.getDateTime(date), "yyyy-MM-dd HH:mm:ss");
        orderRequestBean.setSaleDate(DateUtil.getDateByFormat(date2, "yyyy-MM-dd HH:mm:ss"));
        orderRequestBean.setSaleTime(DateUtil.getTime(date));
        orderRequestBean.setSkyId(userId);
        orderRequestBean.setStoreId(storeId);
        //orderRequestBean.setStoreName(SystemHelper.LoginOrganName);
        orderRequestBean.setExchangecode(exChangeCode);
        // （销售类型,1：销售；2：退货；3：团购）
        orderRequestBean.setXSTYPE("1");
        orderRequestBean.setTNET(totalPrice);
        orderRequestBean.setSKTNET(actualPrice);
        SYLoger.print("条码打印：保存页面： 原价总金额：" + totalPrice + ", 实付总价：" + actualPrice);
        // 订单类型
        orderRequestBean.setOrdertype(isAdditionalRecord ? 1 : (is2Home ? 3 : 0));
        //到家单号
        orderRequestBean.setOrderBillNo(toHomeOrderCode);
        // 提货类型
        orderRequestBean.setDelivertype(0);
        List<OrderReqBean.ProductDetailsBean> productDetailsBeans = new ArrayList<>();
        //商品
        for (ProductInfoBean productInfoBean : productInfoBeansAll) {
            //数量为零的过滤掉了
            if (productInfoBean.getProNum() == 0) {
                continue;
            }
            OrderReqBean.ProductDetailsBean productDetailsBean = new OrderReqBean.ProductDetailsBean();
            productDetailsBean.setSpecialPrice(productInfoBean.specialPrice);
            //productDetailsBean.setBarcode(productInfoBean.getBarcode());
            productDetailsBean.setBarcode(productInfoBean.code);
            productDetailsBean.setItemId(productInfoBean.code);
            productDetailsBean.setItemMode(productInfoBean.getItemMode());
            productDetailsBean.setItemName(productInfoBean.name);
            productDetailsBean.setKCUom(productInfoBean.getKCUom());
            productDetailsBean.setTQTY(productInfoBean.getProNum());
            productDetailsBean.setPrice(productInfoBean.getPriceOriginal());
            productDetailsBean.setUnit(productInfoBean.getUnit());
            productDetailsBean.setAmount(productInfoBean.getAmount());
            //把产品品牌标记提交订单时传给后台
            productDetailsBean.setBrandType(productInfoBean.getBrand());
            productDetailsBean.setIsDecimal(productInfoBean.isDecimal());
            //梯度折扣groupId和ProportRelation
            productDetailsBean.setGroupId(productInfoBean.getGroupId());
            productDetailsBean.setProportRelation(productInfoBean.getProportRelation());
            productDetailsBeans.add(productDetailsBean);

            SYLoger.print("条码打印 保存页面 产品详细表单：productDetailsBeans -- " + productDetailsBean.toString());
        }
        //赠品
        for (ProductInfoBean productInfoBean : giftProductInfoBeansAll) {
            //有时候不满足该活动时，后台返回了数量为0的赠品，这时不要允许它保存，并提示错误
            if (productInfoBean.getProNum() == 0) {
                getActivity().runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        MyToast.show("错误：赠品为0");
                    }
                });
                return false;
            }
            OrderReqBean.ProductDetailsBean productDetailsBean = new OrderReqBean.ProductDetailsBean();
            productDetailsBean.setSpecialPrice(productInfoBean.specialPrice);
            //productDetailsBean.setBarcode(productInfoBean.getBarcode());
            productDetailsBean.setBarcode(productInfoBean.code);
            productDetailsBean.setItemId(productInfoBean.code);
            productDetailsBean.setItemMode(productInfoBean.getItemMode());
            productDetailsBean.setItemName(productInfoBean.name);
            productDetailsBean.setKCUom(productInfoBean.getKCUom());
            productDetailsBean.setTQTY(productInfoBean.getProNum());
            productDetailsBean.setPrice(0);//赠品为0；
            productDetailsBean.setUnit(productInfoBean.getUnit());
            productDetailsBean.setAmount(0);
            productDetailsBean.setIsDecimal(productInfoBean.isDecimal());
            productDetailsBeans.add(productDetailsBean);
        }
        //特价、打折、满减；//从数据库拿到最后修改设置价格；
        if (diffPrice != 0) {
            ProductEntity productEntity = Item001DbOperate.GetProductByBarcode("9.8888");
            OrderReqBean.ProductDetailsBean productDetailsBean = new OrderReqBean.ProductDetailsBean();
            productDetailsBean.setSpecialPrice(0);
            productDetailsBean.setBarcode("9.8888");
            productDetailsBean.setItemId(productEntity.getItemId());
            productDetailsBean.setItemMode(productEntity.getItemMode());
            productDetailsBean.setItemName(productEntity.getItemName());
            productDetailsBean.setKCUom(productEntity.getKCUom());
            productDetailsBean.setTQTY(1);
            //赠品为0；
            productDetailsBean.setPrice(diffPrice);
            productDetailsBean.setAmount(diffPrice);
            productDetailsBean.setUnit(productEntity.getUnit());
            productDetailsBeans.add(productDetailsBean);
            SYLoger.print("条码打印 保存页面 产品详细表单：productDetailsBeans(diffPrice) -- " + productDetailsBean.toString());
        }

        orderRequestBean.setProductDetails(productDetailsBeans);
        SYLoger.print("wgmf--下单数据: " + orderRequestBean);
        // 保存销售数据
        boolean isSaveOrder = Djxs001DbOperate.saveSaleOrder(orderRequestBean);
        boolean isSaveOrderDetail = Djxs002DbOperate.saveSaleOrderDetail(orderRequestBean.getBill(), productDetailsBeans);
        isSaveSuccess = isSaveOrder && isSaveOrderDetail;

        return isSaveSuccess;
    }

    /**
     * 拿到活动商品和商品组合的ID数组，用于继续添加列表筛选过滤；
     */
    private List<String> getProductAndGroupIds() {
        List<String> tempIds = new ArrayList<>();
        for (ProductInfoBean productInfoBeanTemp : productInfoBeansAll) {
            //之前是继续添加的踢出；
            if (productInfoBeanTemp.getProType() == 2) {
                continue;
            }
            tempIds.add(productInfoBeanTemp.code);
        }
        tempIds.addAll(getCombListIds(memberAction.rule.proGroupInfo));
        return tempIds;
    }

    /**
     * 获取组合(商品和赠品组合id)列表；
     */
    private List<String> getCombListIds(ArrayList<ProGroupInfoBean> groupInfo) {
        List<String> tempIds = new ArrayList<>();
        //也要移除产品组合中的ID产品；tempIds可能会有重复的ids;其实放在这里性能不好；
        if (memberAction.checkGroupArrayNull(groupInfo)) {
            for (ProGroupInfoBean proGroupInfoBeanTemp : groupInfo) {
                if (memberAction.checkProArrayNull(proGroupInfoBeanTemp.product)) {
                    for (ProductInfoBean productInfoBeanTemp : proGroupInfoBeanTemp.product) {
                        tempIds.add(productInfoBeanTemp.code);
                    }
                }
            }
        }
        return tempIds;
    }

    /**
     * 因公用ProductInfoBean问题;得于区分;
     * 因遍历原因。Adapter不同,只做0&1判断;
     * proType类型,
     * 0:商品;(默认)
     * 1:组合商品;
     * 2:继续添加的商品(老数据model);
     * 0:赠品;0
     * 1:组合赠品;1
     */
    @SuppressWarnings("all")
    private void setProductType(ArrayList<ProGroupInfoBean> productGroupInfoBeansTemp, int proType) {
        for (ProGroupInfoBean proGroupInfoBeanTemp : productGroupInfoBeansTemp) {
            for (ProductInfoBean productInfoBean : proGroupInfoBeanTemp.product) {
                productInfoBean.setProType(proType);
            }
        }
    }

    /**
     * 跳转到商品选择
     *
     * @param proGroupInfoBeans
     * @param requestCode
     * @param isGift
     * @param activityType
     */
    private void jumpToProductSelection(ArrayList<ProGroupInfoBean> proGroupInfoBeans, int requestCode, boolean isGift,
                                        int activityType, int activityId, String phoneNum, String groupTip) {
        FragmentArgs fragmentArgs = new FragmentArgs();
        fragmentArgs.add(AppConstants.ExtraKeys.IS_GIFT, isGift);
        //应序列化原因。ArrayList必须设置为这个具体类型;
        fragmentArgs.add(AppConstants.ExtraKeys.PRODUCT_INFO_BEAN, proGroupInfoBeans);
        fragmentArgs.add(AppConstants.ExtraKeys.PRODUCT_TITLE, groupTip);
        fragmentArgs.add(AppConstants.ExtraKeys.ACTIVITY_TYPE, activityType);
        fragmentArgs.add(AppConstants.ExtraKeys.ACTIVITY_ID, activityId);
        fragmentArgs.add(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
        launchForResult(this, ProductSelectionFra.class, fragmentArgs, requestCode);
    }

    /**
     * 重写FraContainerAct中里面回调的方法。
     */
    public void launchForResult(BaseFra from, Class<? extends Fragment> clazz, FragmentArgs args,
                                int requestCode) {
        Intent intent = new Intent(from.getActivity(), FraContainerAct.class);
        intent.putExtra("CLASS_NAME", clazz.getName());
        if (args != null) {
            intent.putExtra("ARGS", args);
        }
        from.startActivityForResult(intent, requestCode);
    }

    @SuppressWarnings("unchecked")
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (data == null) {
            return;
        }
        switch (requestCode) {
            case 200://到家业务 扫码填写订单号
                String orderCode = data.getStringExtra("code");
                if (!TextUtils.isEmpty(orderCode)) {
                    toHomeCodeDialog.setInputStr(orderCode);
                }
                break;
            case 300://添加产品组合的返回
                productInfoBeansAll.clear();
                if (memberAction.rule.productInfo != null) {
                    //商品
                    productInfoBeansAll.addAll(memberAction.rule.productInfo);
                }
                ArrayList<ProGroupInfoBean> tempArr1 = (ArrayList<ProGroupInfoBean>) data.getSerializableExtra(AppConstants.ExtraKeys.PRODUCT_INFO_BEAN);
                memberAction.rule.proGroupInfo.clear();
                memberAction.rule.proGroupInfo.addAll(tempArr1);
                if (memberAction.checkProArrayNull(continueProductInfoBeansResult)) {
                    //继续添加的商品
                    productInfoBeansAll.addAll(continueProductInfoBeansResult);
                }
                updateRepeatList(productInfoBeansResult, proGroupChangeProList(tempArr1), true, memberAction.rule.proGroupInfo);
                //组合商品
                productInfoBeansAll.addAll(productInfoBeansResult);
                memberSalesAda.setList(productInfoBeansAll);
//                proExtraContentRl.setVisibility(View.GONE);
                proExtraContentTv.setText(AGAIN_SELECT_PRO);//显示为“重新选择产品”
                updatePriceData();//处理那几个破list的
                break;
            case 301://添加赠品的返回
                giftProductInfoBeansAll.clear();
                if (memberAction.giftRule.giftProductInfo != null) {
                    //赠品
                    giftProductInfoBeansAll.addAll(memberAction.giftRule.giftProductInfo);
                }
                ArrayList<ProGroupInfoBean> tempArr2 = (ArrayList<ProGroupInfoBean>) data.getSerializableExtra(AppConstants.ExtraKeys.PRODUCT_INFO_BEAN);
                memberAction.giftRule.giftProGroupInfo.clear();
                memberAction.giftRule.giftProGroupInfo.addAll(tempArr2);
                updateRepeatList(giftProductInfoBeansResult, proGroupChangeProList(tempArr2), true, memberAction.giftRule.giftProGroupInfo);
                //组合赠品
                giftProductInfoBeansAll.addAll(giftProductInfoBeansResult);
                quickAdapter.replaceAll(giftProductInfoBeansAll);
                giftGotoListTv.setText(AGAIN_SELECT_GIFT);
                updatePriceShow();
                break;
            //公用内存;
            case 302://继续添加的返回
                productEntities = (List<ProductEntity>) data.getSerializableExtra(AppConstants.ExtraKeys.ADD_SELL_SELECT_LIST);
                //通过setResult回传的品牌brand标记
//                String dataBrand = data.getStringExtra("BRAND");
//                brand = (dataBrand == null || dataBrand.isEmpty()) ? brand : dataBrand;
                //把brand品牌标记更新了一下之后，顺便把打印按钮重新刷新一下，即如果是鲜稻研就把按钮隐藏
                initPrinter();

                productInfoBeansAll.clear();
                //常规销售的添加不用处理；
                if (memberAction.actType == 0 || memberAction.actType == 1) {
                    if (memberAction.rule.productInfo != null) {
                        //商品
                        productInfoBeansAll.addAll(memberAction.rule.productInfo);
                    }
                }
                updateRepeatList(continueProductInfoBeansResult, changeOldToNewModels(productEntities), false, memberAction.rule.proGroupInfo);
                //组合商品
                productInfoBeansAll.addAll(continueProductInfoBeansResult);
                if (memberAction.checkProArrayNull(productInfoBeansResult)) {
                    //继续添加的商品
                    productInfoBeansAll.addAll(productInfoBeansResult);
                }
                memberSalesAda.setList(productInfoBeansAll);
                updatePriceData();
                break;
            default:
        }
    }

    //特殊原因；不用这个方法处理pre
    @Override
    public void setPresenter(@NonNull MemberSalesCon.Pre pre) {
        //memberSalesPre = pre;
    }

    /**
     * 老Model转换成新Model,
     * 借用之前返回的继续添加的数据;
     * 只修改添加数量即可;
     */
    private void changeNewToOldModels(List<ProductEntity> productEntities, ArrayList<ProductInfoBean> productInfoBeans) {
        for (ProductInfoBean productInfoBeanTemp : productInfoBeans) {
            for (ProductEntity productEntityTemp : productEntities) {
                if (productInfoBeanTemp.code.equals(productEntityTemp.getItemId())) {
                    productEntityTemp.setTQTY(productInfoBeanTemp.getProNum());
                    //以上这几个字段用于打印用；
                    productEntityTemp.setBrand(productInfoBeanTemp.getBrand());
                    productEntityTemp.setItemId(productInfoBeanTemp.code);
                    productEntityTemp.setClassid(productInfoBeanTemp.classid);
                    //用于选择产品列表里的标签分类
                    productEntityTemp.setClassidorder(productInfoBeanTemp.classidorder);
                    productEntityTemp.setDecimal(productInfoBeanTemp.isDecimal());
                    if (!SystemHelper.isWgmf(productInfoBeanTemp.getBrand())) {
                        //2017-12-15：以前这里竟然写的是.getPrice()，当时我就吃惊了。
                        productEntityTemp.setAmount(productInfoBeanTemp.getAmount());
                    } else {
                        productEntityTemp.setAmount(productInfoBeanTemp.getPrice());
                    }
                    productEntityTemp.setStock_Qty(productInfoBeanTemp.getStockQty());
                    productEntityTemp.setItemName(productInfoBeanTemp.name);
                    //  其他字段不做修改；
                }
            }
        }
        //再把数量为0的都过滤掉（怂个毛，反正后面保存的时候不也要执行这一步吗）line: 713
        Iterator it = productInfoBeans.iterator();
        while (it.hasNext()) {
            if (((ProductInfoBean) it.next()).getProNum() == 0.0) {
                it.remove();//把数量为0的都干掉
            }
        }
    }

    /**
     * 构造一个新数组，(包含装换数据)
     * 用于打印条码用,保存到下一页界面；
     */
    private List<ProductEntity> changeNewToOldModels(@NonNull ArrayList<ProductInfoBean> productInfoBeans, boolean isSpecialPrice) {
        List<ProductEntity> productEntitiesTemp = new ArrayList<>();
        for (ProductInfoBean productInfoBeanTemp : productInfoBeans) {
            if (productInfoBeanTemp.getProNum() == 0) {
                continue;
            }
            ProductEntity productEntityTemp = new ProductEntity();
            productEntityTemp.setTQTY(productInfoBeanTemp.getProNum());
            productEntityTemp.setItemId(productInfoBeanTemp.code);
            productEntityTemp.setItemName(productInfoBeanTemp.name);
            productEntityTemp.setSpecialPrice(productInfoBeanTemp.specialPrice);
            //新增brand字段
            productEntityTemp.setBrand(productInfoBeanTemp.getBrand());
            //新增brand字段
            productEntityTemp.setBOMSPEC(productInfoBeanTemp.getBOMSPEC());
            //用于选择产品列表里的标签分类
            productEntityTemp.setClassid(productInfoBeanTemp.classid);
            //用于选择产品列表里的标签分类
            productEntityTemp.setClassidorder(productInfoBeanTemp.classidorder);
            //是否支持小数位
            productEntityTemp.setDecimal(productInfoBeanTemp.isDecimal());
            //库存
            productEntityTemp.setStock_Qty(productInfoBeanTemp.getStockQty());

            //start下面的数据主要用于下单提交用，在界面显示没有意义；
            productEntityTemp.setBarcode(productInfoBeanTemp.code);
            productEntityTemp.setKCUom(productInfoBeanTemp.getKCUom());
            productEntityTemp.setItemMode(productInfoBeanTemp.getItemMode());
            productEntityTemp.setBarcode(productInfoBeanTemp.code);
            //如果是要按特价来算均摊价，那就需要拷原价过去，这样才能有差值才能算啊，要不怎么算？如果不是按特价均摊，那就走老逻辑，=getPrice()，有特价拷特价，没特价拷原价。
            productEntityTemp.setPrice(isSpecialPrice ? productInfoBeanTemp.getPriceOriginal() : productInfoBeanTemp.getPrice());
            //如果要按特价来算总价，那就需要用特价把原价覆盖掉，因为后面计算 Amount 是用OriginalPrice来算的。
            if (isSpecialPrice && productInfoBeanTemp.specialPrice != 0) {
                productInfoBeanTemp.setPrice(productInfoBeanTemp.specialPrice);
            }
            //如果是鲜稻研，那就直接获取Amount字段，因为getAmount()是通过计算得到的总价，而不是完全按照手动输入的值，所以重新计算可能会产生偏差
            productEntityTemp.setAmount(productInfoBeanTemp.getAmount());
            productEntityTemp.setUnit(productInfoBeanTemp.getUnit());
            //end
            productEntitiesTemp.add(productEntityTemp);
        }
        return productEntitiesTemp;
    }

    /**
     * 更新设置数据；
     *
     * @param productInfoBeansTemp       ...
     * @param productInfoBeansResultTemp ...
     * @param isComb                     是否是组合商品,这种情况下，有可能id重复的情况；
     *                                   for (int i = n - 1; i >= 0; i--){
     *                                   if (list.get(i).equals("one"))
     *                                   {
     *                                   list.remove(i);
     *                                   }
     *                                   }
     */
    private void updateRepeatList(ArrayList<ProductInfoBean> productInfoBeansTemp,//目标list
                                  ArrayList<ProductInfoBean> productInfoBeansResultTemp, boolean isComb,//选择产品后返回的列表
                                  ArrayList<ProGroupInfoBean> groupInfo) {//提取id用来排除重复
        Iterator<ProductInfoBean> iterator = productInfoBeansResultTemp.iterator();
        //把原来的移除掉，再重新添加；
        if (isComb) {
            List<String> tempIds = getCombListIds(groupInfo);
            for (String tempId : tempIds) {
                Iterator<ProductInfoBean> productInfoBeansTempIterator = productInfoBeansTemp.iterator();
                while (productInfoBeansTempIterator.hasNext()) {
                    ProductInfoBean nextAll = productInfoBeansTempIterator.next();
                    if (nextAll.code.equals(tempId)) {
                        productInfoBeansTempIterator.remove();
                    }
                }
            }
        }

        //把返回回来的数据清掉数量为0的，并更新老表
        while (iterator.hasNext()) {
            ProductInfoBean next = iterator.next();
            if (next.getProNum() == 0) {
                iterator.remove();
                continue;
            }
            if (productInfoBeansTemp.contains(next)) {//有相同的话更新
                int index = productInfoBeansTemp.indexOf(next);
                productInfoBeansTemp.set(index, next);
            } else {//没的话直接添加进入;
                productInfoBeansTemp.add(next);
            }
        }

        //修复 常规销售第二次 继续添加 返回时，如果选择产品有做删减操作，返回后产品未删减的问题。
        //isComb为false，则是常规销售返回回来的。
        if (!isComb) {
            //遍历返回的，如果 原有的item 在 返回的 里找不到，就删除 原有的item
            List<ProductInfoBean> deleteTemp = new ArrayList<>();
            for (ProductInfoBean goalBean : productInfoBeansTemp) {
                if (!productInfoBeansResultTemp.contains(goalBean)) {//如果返回的里匹配不到原有的，说明原有的是多的，删掉！
                    deleteTemp.add(goalBean);//缓存起来，后面再删掉。
                }
            }
            //遍历完把需要删的元素都加到deleteTemp里了，再一次性删除（不能在一次迭代里做多次add remove，否则会报ConcurrentModificationException
            for (ProductInfoBean delItem : deleteTemp) {
                productInfoBeansTemp.remove(delItem);
            }
        }
    }

    /**
     * 把数组Group转换成Prolist
     *
     * @return ...
     */
    private ArrayList<ProductInfoBean> proGroupChangeProList(ArrayList<ProGroupInfoBean> proGroupInfoBeans) {
        ArrayList<ProductInfoBean> productInfoBeans = new ArrayList<>();
        if (memberAction.checkGroupArrayNull(proGroupInfoBeans)) {
            for (ProGroupInfoBean proGroupInfoBean : proGroupInfoBeans) {
                productInfoBeans.addAll(proGroupInfoBean.product);
            }
        }
        return productInfoBeans;
    }

    @Override
    public void itemClick(ProductInfoBean productInfoBean) {
        if (productInfoBean.getProType() == 1) {
            jumpToProductSelection(productGroupInfoBeans, 300, false,
                    memberAction.activityType, memberAction.activityId, phoneNum, memberAction.rule.groupTip);
        }
    }

    @Override
    public void updatePriceData() {
        if (memberAction.checkRuleOrNot == 1) {
            restoreRuleData();
            if (giftProductInfoBeans != null && quickAdapter != null) {
                giftProductInfoBeans.clear();
                quickAdapter.replaceAll(giftProductInfoBeans);
                giftProductInfoBeansAll.clear();//修BUG
            }
            showGiftLogic();
        }
        updatePriceShow();
    }

    /**
     * 主要用于，在线验证是；
     * 在操作继续添加和操作加减时，设置还原；
     */
    private void restoreRuleData() {
        if (memberAction.checkRuleOrNot == 1) {
            memberAction.giftRule = null;
            reducePriceRl.setVisibility(View.GONE);
        }
    }

    /**
     * 更新价格显示
     */
    public void updatePriceShow() {
        Double[] priceResults = MemActionDominator.calculatePrice(productInfoBeansAll, memberAction);
        /**总价格*/
        totalPrice = priceResults[0];
        /**总实际价格*/
        actualPrice = priceResults[1];

        double specialActualPrice = priceResults[2];

        double verifyNotRulesNum = priceResults[3];
        // 如果品牌是五谷磨房，则显示金额要保留两位小数；如果是鲜稻研，则保存1位小数
        totalPriceTv.setText(String.format("总金额：¥%s", MoneyUtils.twolastDF(totalPrice)));
        actualPriceTv.setText(Html.fromHtml("实付：" + "<font color='#ffa019'>¥" + MoneyUtils.twolastDF(actualPrice) + "</font>"));
        outActualPriceTv.setText(Html.fromHtml("实销金额：" + "<font color='#ffa019'>¥" + MoneyUtils.twolastDF(actualPrice) + "</font>"));
        outTotalPriceTv.setText(String.format("总金额：¥%s", MoneyUtils.twolastDF(totalPrice)));
        changeBtnState(specialActualPrice, verifyNotRulesNum);
    }

    /**
     * 通过价格和类型，处理现实btn的显示；
     * 建议放在价格变更之后；
     */
    private void changeBtnState(double specialActualPrice, double verifyNotRulesNum) {
        if (memberAction.giftRule == null) {
            //在线验证的情况下；giftRule一定是null;跟1对应上；
            if (memberAction.checkRuleOrNot == 1) {
                saveOrderBtn.setText("立享优惠");
            }
        } else {//memberAction.giftRule != null
            saveOrderBtn.setText("保存");
        }
        //如果没配置规则，要弹窗提示
        String checkDecimalGroupHaveRule = MemActionDominator.checkDecimalHaveRule(memberAction);
        if (!TextUtils.isEmpty(checkDecimalGroupHaveRule)) {
            MyToast.show(checkDecimalGroupHaveRule);
            saveOrderBtn.setEnabled(false);
            return;
        }
        //表示没有了继续添加按钮；(新：现在判断条件变为是否显示文字为”重新选择产品“，是则说明已添加产品)
        //文字为”“的情况，设定为该按钮没显示。
        if ((proExtraContentTv.getText().toString().equals(AGAIN_SELECT_PRO) || proExtraContentTv.getText().toString().equals(""))
                && (giftGotoListTv.getText().toString().equals(AGAIN_SELECT_GIFT) || giftGotoListTv.getText().toString().equals(""))) {
//        if (giftDesAndGotoRl.getVisibility() == View.GONE) {//表示没有了继续添加按钮；
            //特价情况
            if (specialActualPrice > 0) {
                if (verifyNotRulesNum <= 0.0 && specialActualPrice >= MemActionDominator.formatPrice(memberAction.rule.money)) {
                    saveOrderBtn.setEnabled(true);
//                    barcodePrintBtn.setEnabled(true);
                    //还没有点击立享优惠的时候，让打印按钮先置灰
                    barcodePrintBtn.setEnabled(MemActionDominator.hasWgmfExist(productInfoBeansAll) && !saveOrderBtn.getText().toString().equals("立享优惠"));
                } else {
                    saveOrderBtn.setEnabled(false);
                    barcodePrintBtn.setEnabled(false);
                }
            } else {//specialActualPrice <= 0
                if (verifyNotRulesNum <= 0.0 && totalPrice >= MemActionDominator.formatPrice(memberAction.rule.money)) {
                    //如果总价(totalPrice)为0,那么保存按钮应该不可点击(作废)
                    saveOrderBtn.setEnabled(true);
                    barcodePrintBtn.setEnabled(MemActionDominator.hasWgmfExist(productInfoBeansAll) && !saveOrderBtn.getText().toString().equals("立享优惠"));
                } else {//totalPrice<0
                    saveOrderBtn.setEnabled(false);
                    barcodePrintBtn.setEnabled(false);
                }
            }
        } else {//如果有显示继续添加按钮；
            saveOrderBtn.setEnabled(false);
            barcodePrintBtn.setEnabled(false);
        }

        //如果一进来产品列表和赠品列表都为空，那就把保存按钮置灰
        if (productInfoBeansAll.size() == 0 && giftProductInfoBeansAll.size() == 0) {
            saveOrderBtn.setEnabled(false);
            barcodePrintBtn.setEnabled(false);
        }

        //只有在不合法的时候拦截一下，把按钮状态置置灰，其它逻辑还是按原来的走，保险。
        boolean isCorrect = checkProGroupNumMoney(memberAction.rule.proGroupInfo);
        if (!isCorrect) {
            saveOrderBtn.setEnabled(false);
            barcodePrintBtn.setEnabled(false);
        }
    }

    /**
     * 判断组合产品里的各个规则是否满足，来改变按钮的enable状态（其实就是从ProductSelectionFra.java那里无耻地拷过来的）
     *
     * @param groupBeans ...
     * @return ...
     */
    public boolean checkProGroupNumMoney(ArrayList<ProGroupInfoBean> groupBeans) {
        if (groupBeans != null && groupBeans.size() > 0) {
            double mainMultiple = -1;  //梯度折扣中主比例
            for (ProGroupInfoBean proGroupInfoBean : groupBeans) {
                String num = proGroupInfoBean.num;
                int proportRelation = proGroupInfoBean.proportRelation;
                double proNum = 0;
                double proMoney = 0.0;
                for (ProductInfoBean productInfoBean : proGroupInfoBean.product) {
                    proNum = Arith.add(proNum, productInfoBean.getProNum());
                    //跟ProSelectedAda里的总价显示保持一致的算法
                    if (productInfoBean.isDecimal()) {
                        mIsDecimal += "T";
                        proMoney += ArithUtil.add(proMoney, productInfoBean.getAmount());
                    } else {
                        mIsDecimal += "F";
                        proMoney += ArithUtil.add(proMoney, productInfoBean.getAmountActual());//跟ProSelectedAda里的总价显示保持一致的算法
                    }
                }
                //散装校验金额，非散装校验数量
                if (mIsDecimal.contains("T")) {
                    //如果金额规则和数量规则都为空，这是非法的，说明后台配错了！报个提示就行。
                    if (TextUtils.isEmpty(proGroupInfoBean.money)) {
                        return false;
                    }
                    if (!VerifyUtil.compareMoney(proGroupInfoBean.money, proMoney)) {
                        return false;
                    }
                } else {
                    if (TextUtils.isEmpty(num)) {
                        return false;
                    }
                    if (ConstantParams.CONSTANT_STARTS_9 == memberAction.activityType) {// 如果特价活动，只要有一个满足数量规则即可
                        if (VerifyUtil.compareLogicNum(num, proNum)) {
                            mFlag += "T";
                        } else {
                            mFlag += "F";
                        }
                    } else if (ConstantParams.CONSTANT_STARTS_14 == memberAction.activityType) { //梯度折扣，必须满足倍数关系
                        double multiple;
                        if (!TextUtils.isEmpty(num)) {
                            multiple = ArithUtil.div(proNum, Double.parseDouble(num));
                            proGroupInfoBean.multipleRelation = multiple; //倍数关系
                            if (proNum > 0) {
                                if (proportRelation == ConstantParams.CONSTANT_STARTS_1) {
                                    mainMultiple = multiple;
                                    if (proNum % Double.parseDouble(num) >= 0) {
                                        mFlag += "T";
                                    } else {
                                        mFlag += "F";
                                    }
                                } else {
                                    if (proNum % Double.parseDouble(num) == 0) {
                                        mFlag += "T";
                                    } else {
                                        mFlag += "F";
                                    }
                                }
                            } else {
                                mFlag += "F";
                            }
                        } else {
                            mFlag += "T";
                        }

                    } else if (ConstantParams.CONSTANT_STARTS_26 == memberAction.activityType) {
                        if (!TextUtils.isEmpty(num)) {
                            if (proNum % Double.parseDouble(num) == 0) {
                                proGroupInfoBean.multipleRelation = ArithUtil.div(proNum, Double.parseDouble(num)); //倍数关系
                                mFlag += "T";
                            } else {
                                mFlag += "F";
                            }
                        } else {
                            mFlag += "T";
                        }
                    } else {
                        if (!VerifyUtil.compareNum(num, proNum)) {
                            return false;
                        }
                    }
                }
            }
            if (mainMultiple >= 0 && ConstantParams.CONSTANT_STARTS_14 == memberAction.activityType) {
                for (ProGroupInfoBean proGroupInfoBean : groupBeans) {
                    if (proGroupInfoBean.proportRelation != ConstantParams.CONSTANT_STARTS_1 &&
                            proGroupInfoBean.multipleRelation > mainMultiple) {
                        mFlag += "F";
                    }
                }
            }
            if (!mIsDecimal.contains("T")) {
                if (ConstantParams.CONSTANT_STARTS_9 == memberAction.activityType) {// 如果特价活动，只要有一个满足数量规则即可
                    if (!mFlag.contains("T")) {// 非散装才校验数量
                        mFlag = "";
                        return false;
                    }
                } else if (ConstantParams.CONSTANT_STARTS_14 == memberAction.activityType || ConstantParams.CONSTANT_STARTS_26 == memberAction.activityType) {
                    if (mFlag.contains("F")) {
                        mFlag = "";
                        return false;
                    }
                }
            }
        }
        return true;
    }

    @Override
    public void showEnjoyDiscount(MemberAction.GiftRuleBean giftRuleBean) {
        //防止两次点击导致两次请求，使赠品多添加了一次。
        saveOrderBtn.setEnabled(true);
        boolean isCanGift = MemberActionListFra.filterProItemIdAndPrice(giftRuleBean.giftProductInfo);
        boolean isCanGiftGroup = MemberActionListFra.filterProGroupItemIdAndPrice(giftRuleBean.giftProGroupInfo, true);
        if (isCanGift && isCanGiftGroup) {
            //先过滤数据再次加入到现有数据中；(能执行这个showEnjoyDiscount()方法，说明memberAction.giftRule肯定是null的)
            memberAction.giftRule = giftRuleBean;
            showGiftLogic();
            updatePriceShow();
        } else {
            ToastMsg.showToastMsg(getActivity(), "本门店无此赠品，无法参与活动！");
        }
    }


    @Override
    public void showCheckCodeState(boolean isSuccess) {
        if (isSuccess && /*CommonTools.INSTANCE.isOneClick() &&*/ saverEnque.isNotEmpty()) {
            saverEnque.go();//如果保存任务队列不为空，就直接执行队列。
            return;
        }
    }


    @Override
    public void onSubmitFailure() {
        mSubmitOrderPre.onSubmitFailure();
        // 失败的时候也需要把成功页面需要的参数带过去，为了重新保存
        skipToOrderResult(SaveFailureActivity.class);
    }

    @Override
    public void onSubmitSuccess() {
        mSubmitOrderPre.onSubmitSuccess();
    }

    /**
     * 跳转到订单保存界面;
     */
    private void skipToOrderResult(Class<?> clz) {
        //处理特价,跳转到订单保存页面（成功销售单上传，也是销售单保存到数据库后），才执行打印
        dealSpecialPrice(false);
        Intent intent = new Intent(getActivity(), clz);
        SYLoger.print("条码打印 保存页面：实付：" + actualPrice);
        //传到SaveSuccessAct界面用这个标记来判断是否显示打印按钮，鲜稻研不需要打印按钮的！
//        intent.putExtra("brand", brand);
        intent.putExtra("actualPrice", actualPrice);
        intent.putExtra("totalPrice", totalPrice);
        // 结果页面处理特价条码打印
//        intent.putExtra(SaveSuccessActivity.NEW_PRICE_PERCENTAGE, MemActionDominator.specialPrice2Price2(productInfoBeansAll, actualPrice, totalPrice));
        intent.putExtra("bill", (Serializable) changeNewToOldModels(productInfoBeansAll, true));
        intent.putExtra("bill4Printer", (Serializable) changeNewToOldModels(productForPrintTemp, true));//把专门用来打印的列表也传过去
        intent.putExtra("huodong", false);
        intent.putExtra("huiyuan", phoneNum);
        //只有常规销售才传这个billCode，用来区分销售补录。
        intent.putExtra("billCode", billCache);
        //intent.putExtra(SaveSuccessActivity.WX_PAY_NO,wxPayNo);
        //失败页面需要的参数，反正谁需要谁获取
        intent.putExtra("isScanPage", false);
        getActivity().startActivity(intent);
        getActivity().finish();
    }


    @Override
    public void onDestroy() {
        unbinder.unbind();
        if (null != orderTask) {
            orderTask.cancel(false);
        }
        mPrinterTool = null;
        productInfoBeans.clear();
        productInfoBeans = null;
        productGroupInfoBeans.clear();
        productGroupInfoBeans = null;
        giftProductInfoBeans.clear();
        giftProductInfoBeans = null;
        giftProductGroupInfoBeans.clear();
        giftProductGroupInfoBeans = null;
        productInfoBeansResult.clear();
        productInfoBeansResult = null;
        continueProductInfoBeansResult.clear();
        continueProductInfoBeansResult = null;
        giftProductInfoBeansResult.clear();
        giftProductInfoBeansResult = null;
        if (productEntities != null) {
            productEntities.clear();
            productEntities = null;
        }
        productInfoBeansAll.clear();
        productInfoBeansAll = null;
        giftProductInfoBeansAll.clear();
        giftProductInfoBeansAll = null;
        super.onDestroy();
    }

    /**
     * 组装订单
     *
     * @return ...
     */
    @Override
    public boolean buildOrderForm() {
        return saveOrderToDB();
    }

    @Override
    public void onlineUploadOrders() {
        mSubmitOrderPre.submitOrder(MemberSalesFra.this);
    }

    /**
     * 会员商品提交成功
     */
    @Override
    public void memGoodsSumbitSuccess() {
        new AlertDialog.Builder(getActivity()).setTitle("待付款订单保存成功")
                .setMessage("待顾客买单后，前往首页-会员商品未完成订单，继续完成录入和提交")
                .setCancelable(false)
                .setPositiveButton("好的", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        Intent intent = new Intent(getActivity(), TabMenuActivity.class);
                        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
//                        intent.putExtra(TabMenuActivity.IS_REFRESH_MEMGOODS_ORDER,true);
                        getActivity().startActivity(intent);
                    }
                }).show();
    }

    /**
     * 会员商品提交失败
     */
    @Override
    public void memGoodsSumbitFailed(String msgInfo) {
        new AlertDialog.Builder(getActivity()).setTitle("待付款订单保存失败")
                .setMessage(msgInfo)
                .setCancelable(false)
                .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        //啥都不用做。
                    }
                }).show();
    }
}