package com.wgmf.trade.ui.fra.index;

import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;

import androidx.annotation.NonNull;

import com.urovo.wugumofang.R;
import com.urovo.wugumofang.view.webview.FraContainerAct;
import com.wgmf.trade.presenter.WXQRCodePayPre;
import com.wgmf.trade.presenter.impl.WXQRCodePayPreImpl;
import com.wgmf.trade.view.WXBarcodePayView;
import com.zsy.libcore.ui.fra.FragmentArgs;
import com.zsy.libext.ui.fra.BaseFra;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;

/**
 * 微信二维码支付
 * Created by samy on 16/4/12.
 */
public class WXQRCodePayFra extends BaseFra<WXQRCodePayPre> implements WXBarcodePayView {
    @BindView(R.id.wx_pay_ll)
    LinearLayout wxPayLl;
    @BindView(R.id.barcode_iv)
    ImageView barcodeIv;
    @BindView(R.id.check_pay_status_btn)
    Button checkPayStatusBtn;

    private WXQRCodePayPre wxqrCodePayPre;
    private  String orderNo;


    public static void launch(Context context, String orderNo) {
        FragmentArgs args = new FragmentArgs();
        args.add("orderNo", orderNo);
        FraContainerAct.launch(context, WXQRCodePayFra.class, args, false);
        //new WXQRCodePayPreImpl(GlobalApp.getInstance(), new WXQRCodePayFra());
    }


    @Override
    protected void getBundleExtras(Bundle extras) {
        super.getBundleExtras(extras);
        orderNo = extras.getString("orderNo");
        wxqrCodePayPre = new WXQRCodePayPreImpl(getActivity(),this);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        unbinder.unbind();
    }

    Unbinder unbinder;
    @Override
    protected void initWidgetsAndEvents(View view) {
        unbinder = ButterKnife.bind(this,view);
        baseAct.commonToolbar.setTitle("微信支付");
        wxqrCodePayPre.getQRCode(orderNo,barcodeIv);
    }

    @Override
    protected View getLoadingTargetView() {
        return rootView.findViewById(R.id.wx_pay_ll);
//        return wxPayLl;
    }

    @Override
    protected int getContentViewLayoutID() {
        return R.layout.index_fra_wx_barcode_pay;
    }

    /*
    @Override
    public void initPresenter() {
        wxqrCodePayPre = new WXQRCodePayPreImpl(mContext);
        wxqrCodePayPre.attachView(this);
    }
    */


    @Override
    @OnClick({R.id.barcode_iv, R.id.check_pay_status_btn})
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.barcode_iv:
//                wxqrCodePayPre.getPayStatus(orderNo);
                break;
            case R.id.check_pay_status_btn:
                wxqrCodePayPre.getPayStatus(orderNo);
                break;
        }
    }
  //
  @Override public void setPresenter(@NonNull WXQRCodePayPre wxqrCodePayPre) {
    //this.wxqrCodePayPre = wxqrCodePayPre;
  }

  //
//    @Override
//    public void showQRCode(String imgUrl) {
//        ImageLoaderHelper.getInstance(getActivity()).displayImage(imgUrl,barcodeIv);
//    }
}
