package com.wgmf.trade.ui.fra.more.cases

import android.text.TextUtils
import android.view.View
import com.urovo.wugumofang.utils.TaskEnqueueDominator
import com.wgmf.trade.model.bean.MemberAction
import com.wgmf.trade.ui.fra.index.MemberSalesFra
import com.wgmf.trade.view.MemberSalesCon
import com.zsy.libext.widgets.dialog.effectsdialog.EffectsAlertDialog
import com.zsy.libext.widgets.tips.ToastMsg

/**
 * @author Sasuke on 2019/12/3.
 * 输入活动校验码情况
 */
class InputActionCodeCase(val frag: MemberSalesFra,//这里需要传MemberSalesFra，因为exChangeCode会改变，并且后面组装订单要用
                          val memberAction: MemberAction,
                          val memberSalesPre: MemberSalesCon.Pre,
                          val phoneNum: String?,
                          val isAutoCheckCode: Boolean): TaskEnqueueDominator.BaseCase() {

    override fun dowork() {
        if (memberAction.checkCodeOrNot == 1) {
            //扫码跳转核销情况，不需要弹窗手动输入，直接执行自动网络校验
            if (isAutoCheckCode && memberSalesPre != null) {
                memberSalesPre.checkVerifyCode(phoneNum ?:"", memberAction.activityId.toString(), frag.exChangeCode)
                return
            }
            //需要手动输入验证码
            val effectsAlertDialog = EffectsAlertDialog.getInstance(frag.activity)
            effectsAlertDialog.withTitle("请输入活动验证码").withInputContent("验证码", 0, 0).withInputMargin(5, 0, 0, 0).setRightButtonClick(
                    View.OnClickListener {
                        frag.exChangeCode = effectsAlertDialog.inputStr
                        if (TextUtils.isEmpty(frag.exChangeCode)) {
                            ToastMsg.showToastMsg(frag.activity, "请输入验证码!")
                            return@OnClickListener
                        }
                        if (memberSalesPre != null) {
                            memberSalesPre.checkVerifyCode(phoneNum ?:"", memberAction.activityId.toString(), frag.exChangeCode)
                        }
                        effectsAlertDialog.dismiss()
                    }).show()
            return
        }else{// isAutoCheckCode == false 或 memberSalesPre == null
            enqueDominator?.go()//继续执行队列
        }
    }
}