package com.wgmf.trade.ui.fra.more.reportfeedback

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseAdapter
import android.widget.ImageView
import android.widget.TextView
import com.urovo.wugumofang.R
import com.wgmf.trade.model.bean.QualityBackResultBean
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2019-6-19 0019.
 * 反馈结果 里面的固定长度的流程列表
 */
class QBackResultStreamAdapter(var context: Context, var dataList: List<QualityBackResultBean.OaHandler>) : BaseAdapter() {
    override fun getView(pos: Int, convertView: View?, parent: ViewGroup?): View {
        var view = LayoutInflater.from(context).inflate(R.layout.qback_result_stream_list_item, parent, false)
        var circleView = view.find<ImageView>(R.id.streamCircle)

        //初始化前面的状态小圆点
        circleView.setBackgroundResource(when (pos) {
            0 -> if (count == 1) R.drawable.stream_list_single else R.drawable.stream_list_head
            count -1 -> R.drawable.stream_list_foot
            else -> R.drawable.stream_list_center
        })

        //初始化数据显示
        view.find<TextView>(R.id.streamContent).text = dataList[pos].reply
        view.find<TextView>(R.id.streamTime).text = "${dataList[pos].handler} ${dataList[pos].handlerDate}"
        return view
    }

    override fun getItem(pos: Int): Any? {
        return null
    }

    override fun getItemId(pos: Int): Long {
        return pos.toLong()
    }

    override fun getCount(): Int {
        return dataList.size
    }

}