package com.wgmf.trade.ui.fra.more.reportfeedback;

import android.content.Context;
import android.graphics.Color;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.View;
import android.view.WindowManager;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RatingBar;

import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.utils.MyToast;
import com.wgmf.trade.model.bean.QualityBackResultBean;
import com.wgmf.trade.presenter.QualityBackResultPre;
import com.wgmf.trade.view.QualityBackResultCon;
import com.wgmf.trade.widgets.ExtListView;
import com.zsy.libcore.ui.ada.helper.ViewHelper;
import com.zsy.libcore.ui.ada.quickadapter.QuickAdapter;
import com.zsy.libext.ui.fra.BaseFra;

import java.util.ArrayList;
import java.util.List;

import androidx.annotation.NonNull;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 上报反馈结果界面
 * Created by samy on 17/1/19.
 */
public class QualityBackResultFra extends BaseFra<QualityBackResultCon.Pre> implements QualityBackResultCon.View {
    @BindView(R.id.root_ll)
    LinearLayout rootRl;
    @BindView(R.id.back_result_tap_rg)
    RadioGroup backResultTapRg;
    @BindView(R.id.back_result_all_rb)
    RadioButton backResultAllRb;
    @BindView(R.id.back_result_untreated_rb)
    RadioButton backResultUntreatedRb;
    @BindView(R.id.back_result_treated_rb)
    RadioButton backResultTreatedRb;
    @BindView(R.id.data_lv)
    ListView dataLv;

    QualityBackResultCon.Pre pre;
    QuickAdapter quickAdapter;
    List<QualityBackResultBean> qualityBackResultBeanList = new ArrayList<>();
    int qualityBackType;
    /**
     * 查询类型0:所有，1：未处理和处理中，2：已处理
     */
    int queryType = 0;

    @Override
    protected void getBundleExtras(Bundle extras) {
        super.getBundleExtras(extras);
        qualityBackType = extras.getInt(AppConstants.ExtraKeys.QBACK_RESULT_TYPE);
        this.pre = new QualityBackResultPre(this);
    }

    private CharSequence checkDataIsNull(CharSequence text) {
        return text != null ? text : "";
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        unbinder.unbind();
    }

    Unbinder unbinder;

    @Override
    protected void initWidgetsAndEvents(View view) {
        unbinder = ButterKnife.bind(this, view);
        getActivity().getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_ADJUST_PAN);
        baseAct.commonToolbar.setTitle("反馈结果");
        quickAdapter = new QuickAdapter<QualityBackResultBean>(R.layout.item_quality_back_result, qualityBackResultBeanList) {
            @Override
            protected void onBindData(Context context, final int pos, final ViewHelper viewHelper, int i1, final QualityBackResultBean qualityBackResultBean) {
                viewHelper.setText(R.id.problem_type_tv, checkDataIsNull(qualityBackResultBean.problemName));

                if (qualityBackResultBean.problemType == QualityBackType.ArrivalError.getIndex()) {
                    viewHelper.setText(R.id.problem_detail_tv, "配送波次号:" + checkDataIsNull(qualityBackResultBean.peisbch));
                } else if (qualityBackResultBean.problemType == QualityBackType.OverDue.getIndex()) {
                    viewHelper.setText(R.id.problem_detail_tv, "报损金额:" + checkDataIsNull(qualityBackResultBean.amount));
                } else {
                    viewHelper.setText(R.id.problem_detail_tv, checkDataIsNull(qualityBackResultBean.content));
                }
                viewHelper.setVisibility(R.id.serial_number_tv, qualityBackResultBean.problemType == QualityBackType.MachineProblem.getIndex() ? View.GONE : View.VISIBLE).setText(R.id.serial_number_tv, "流水号：" + checkDataIsNull(qualityBackResultBean.serialNumber));
                viewHelper.setVisibility(R.id.submit_time_tv, qualityBackResultBean.problemType == QualityBackType.MachineProblem.getIndex() ? View.VISIBLE : View.GONE);
                viewHelper.setText(R.id.submit_time_tv, qualityBackResultBean.problemType == QualityBackType.MachineProblem.getIndex() ? checkDataIsNull(qualityBackResultBean.submitTime) : "");
                viewHelper.setImageResource(R.id.status_iv, qualityBackResultBean.status == 2 ? R.drawable.yichuli : R.drawable.chulizhong);

                //过程流列表（Adapter用 QBackResultStreamAdapter.kt）
                ((ExtListView) viewHelper.getView(R.id.streamLv)).setAdapter(
                        new QBackResultStreamAdapter(getActivity(), qualityBackResultBeanList.get(pos).getReplys()));

                //==============评价建议栏================
                boolean hasRated = qualityBackResultBean.hasComment;//是否已评价
                int ratingNum = qualityBackResultBean.getPj();//网络返回的已评级数，默认为4
                String suggestText = qualityBackResultBean.getPjContent();//建议

                //最后初始化
                if (!qualityBackResultBean.isCanComment()
                        || qualityBackResultBean.status != 2 //只有已处理才给显示评价
                        || (qualityBackResultBean.problemType != QualityBackType.ProductionProblem.getIndex()
                        && qualityBackResultBean.problemType != QualityBackType.ArrivalError.getIndex()
                        && qualityBackResultBean.problemType != QualityBackType.CabinetProblem.getIndex()
                        && qualityBackResultBean.problemType != QualityBackType.Suggestion.getIndex()
                        && qualityBackResultBean.problemType != QualityBackType.OverDue.getIndex())) {
                    viewHelper.setVisibility(R.id.ratingToggle, View.GONE);
                    viewHelper.setVisibility(R.id.ratingLayout, View.GONE);
                    return;//只有上面四种类型才显示评价，如果不是，那就隐藏，并且下面的都不用做了。
                } else {
                    viewHelper.setVisibility(R.id.ratingToggle, View.VISIBLE);
                    viewHelper.setVisibility(R.id.ratingLayout, qualityBackResultBean.isRateExpand);
                }

                viewHelper.setOnCheckedChangeListener(R.id.ratingToggle, new CompoundButton.OnCheckedChangeListener() {
                    @Override
                    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                        viewHelper.setVisibility(R.id.ratingLayout, isChecked);
                        qualityBackResultBean.isRateExpand = isChecked;
                        //遍历把其它已展开的评价都关上
                        if (isChecked) {
                            for (QualityBackResultBean bean : qualityBackResultBeanList) {
                                if (bean != qualityBackResultBean) {
                                    bean.isRateExpand = false;
                                }
                            }
                            notifyDataSetChanged();
                        }
                    }
                });
                viewHelper.setChecked(R.id.ratingToggle, qualityBackResultBean.isRateExpand);//本地展开标记

                if (!qualityBackResultBean.isRateExpand) {
                    //如果是折叠的，就要记得把焦点给清除掉，这样在切换建议输入框的时候，别的输入框才能获得新的焦点，才能输入
                    ((EditText) viewHelper.getView(R.id.ratingSuggest)).clearFocus();
                } else {
                    //如果是展开的，就要在滚动的时候，重新让它获得焦点
                    ((EditText) viewHelper.getView(R.id.ratingSuggest)).requestFocusFromTouch();
                    ((EditText) viewHelper.getView(R.id.ratingSuggest)).setSelection(
                            ((EditText) viewHelper.getView(R.id.ratingSuggest)).getText().toString().length()
                    );
                }
                viewHelper.setText(R.id.ratingToggle, hasRated ? "已评价" : "我要评价");
                viewHelper.setRatingIndicator(R.id.ratingBar, hasRated);//已评价就不能再修改星级栏了，indicator属性应为true了
                viewHelper.setFocusable(R.id.ratingSuggest, !hasRated);//若已评价，就把焦点false掉，禁止输入
                viewHelper.setText(R.id.ratingSuggest, suggestText);//显示建议内容
                viewHelper.setBackgroundColor(R.id.ratingSuggest, hasRated ? Color.TRANSPARENT : Color.WHITE);//更改输入框背景颜色
                viewHelper.setVisibility(R.id.ratingSuggest, hasRated && TextUtils.isEmpty(suggestText) ? View.GONE : View.VISIBLE);
                viewHelper.setVisibility(R.id.ratingSubmit, hasRated ? View.GONE : View.VISIBLE);
                viewHelper.setHintText(R.id.ratingSuggest, getInputHint(//显示EditText输入框默认提示文字（不同星级，文字不同
                        (int) ((RatingBar) viewHelper.getView(R.id.ratingBar)).getRating()));

                viewHelper.setText(R.id.ratingText, getGradeByRating(ratingNum));//满意度文字
                viewHelper.setRating(R.id.ratingBar, ratingNum);//星级

                //提交按钮点击监听
                viewHelper.setOnClickListener(R.id.ratingSubmit, new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        //提交
                        int rating = (int) ((RatingBar) viewHelper.getView(R.id.ratingBar)).getRating();
                        String suggestText = ((EditText) viewHelper.getView(R.id.ratingSuggest)).getText().toString().trim();
                        if (rating <= 2.0f && TextUtils.isEmpty(suggestText)) {//如果是2星或以下，必须填写建议
                            MyToast.show("请填写建议后提交");
                            return;
                        }
                        pre.submitpj(qualityBackResultBean.id, qualityBackResultBean.problemType, rating, suggestText, SystemHelper.LoginUserId);

                    }
                });
                //建议文字输入监听
                ((EditText) viewHelper.getView(R.id.ratingSuggest)).addTextChangedListener(new TextWatcher() {
                    @Override
                    public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {


                    }

                    @Override
                    public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {

                    }

                    @Override
                    public void afterTextChanged(Editable s) {
                        if (((EditText) viewHelper.getView(R.id.ratingSuggest)).isFocused()) {//这里必须用isFocused()，不要用hasWindowFocus()，要使它仅在输入时写入到List，排除滚动时。
                            qualityBackResultBeanList.get(pos).setPjContent(((EditText) viewHelper.getView(R.id.ratingSuggest)).getText().toString());
                        }
                    }
                });

                //评星级变化监听
                viewHelper.setOnRatingBarChangeListener(R.id.ratingBar, new RatingBar.OnRatingBarChangeListener() {
                    @Override
                    public void onRatingChanged(RatingBar ratingBar, float rating, boolean fromUser) {
                        if (rating < 1.0f) {//强制使最低为1星，不允许为0星
                            ratingBar.setRating(1.0f);
                        }
                        if (((RatingBar) viewHelper.getView(R.id.ratingBar)).hasWindowFocus()) {//只有在点击的时候才写入到数据源表里（这里必须用hasWindowFocus()，其它不行）
                            qualityBackResultBeanList.get(pos).setPj(rating);
                            //根据星级同步改变满意度文字
                            viewHelper.setText(R.id.ratingText, getGradeByRating((int) rating));
                            viewHelper.setHintText(R.id.ratingSuggest, getInputHint((int) rating));//显示EditText输入框默认提示文字（不同星级，文字不同
                        }
                    }
                });

            }
        };

        dataLv.setAdapter(quickAdapter);
        pre.getTypeList(SystemHelper.LoginUserId, SystemHelper.LoginOrganId, queryType, qualityBackType);

        backResultTapRg.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                switch (checkedId) {
                    case R.id.back_result_all_rb:
                        queryType = 0;
                        break;
                    case R.id.back_result_untreated_rb:
                        queryType = 1;
                        break;
                    case R.id.back_result_treated_rb:
                        queryType = 2;
                        break;
                    default:
                }
                pre.queryDifTypeList(queryType);
            }
        });
    }

    /**
     * 通过星级来返回输入框的提示文字
     *
     * @return
     */
    private String getInputHint(int ratingNum) {
        String inputHint = "";
        switch (ratingNum) {
            case 0:
            case 1:
            case 2:
                inputHint = "提出你的意见，我们会努力改进";
                break;
            case 3:
            case 4:
                inputHint = "有更好的建议，也可以提交给我们";
                break;
            default:
        }
        return inputHint;
    }

    /**
     * 通过星级来返回满意度文字
     *
     * @param rating
     * @return
     */
    private String getGradeByRating(float rating) {
        String rateText = "";
        int ratingInt = (int) rating;
        switch (ratingInt) {
            case 0:
            case 1:
                rateText = "不满意";
                break;
            case 2:
                rateText = "一般";
                break;
            case 3:
                rateText = "满意";
                break;
            case 4:
                rateText = "非常满意";
                break;
            default:
        }
        return rateText;
    }

    @Override
    protected View getLoadingTargetView() {
        return rootView.findViewById(R.id.root_ll);
    }

    @Override
    protected int getContentViewLayoutID() {
        return R.layout.fra_quality_back_result;
    }

    @Override
    public void showTypeList(List<QualityBackResultBean> qualityBackResultBeanList) {
        this.qualityBackResultBeanList = qualityBackResultBeanList;
        quickAdapter.replaceAll(qualityBackResultBeanList);
    }

    @Override
    public void refreshShow() {
        pre.getTypeList(SystemHelper.LoginUserId, SystemHelper.LoginOrganId, queryType, qualityBackType);
    }

    @Override
    public void setPresenter(@NonNull QualityBackResultCon.Pre pre) {
        //this.pre = pre;
    }
}