package com.wgmf.trade.ui.fra.more.reportfeedback;

import java.util.ArrayList;
import java.util.List;

/**
 * 反馈的类型；
 * Created by samy on 17/1/20.
 */
public enum QualityBackType {
  ProductionProblem(2421, "产品问题反馈"), ArrivalError(721, "到货误差反馈"), CabinetProblem(2181,"柜子/物料问题反馈"),OverDue(5623,"临/过期货报损申请"),
  InternalComplaints(2441, "内部投诉反馈"), MachineProblem(6, "本机问题反馈"),Suggestion(3721,"意见与建议反馈");
  // 成员变量
  private int index;
  private String name;

  // 构造方法
  private QualityBackType(int index, String name) {
    this.index = index;
    this.name = name;
  }

  // 普通方法

  /**
   * 通过index找到name;
   * @param index
   * @return
   */
  public static String getName(int index) {
    for (QualityBackType c : QualityBackType.values()) {
      if (c.getIndex() == index) {
        return c.name;
      }
    }
    return "";
  }

  /**
   * 通过name找到index;
   * @param name
   * @return
   */
  public static int getIndexFromName(String name) {
    for (QualityBackType c : QualityBackType.values()) {
      if (c.name.equals(name)){
        return c.index;
      }
    }
    return 0;
  }

  /**
   * 字符串
   * @return
   */
  public static List<String> getItems(){
    List<String> items = new ArrayList<>();
    for (QualityBackType c : QualityBackType.values()) {
      if (!items.contains(c.getName())//侧滑菜单不需要显示“内部投诉反馈”和“意见与建议反馈”
              && c != QualityBackType.InternalComplaints
              && c != QualityBackType.Suggestion){
        items.add(c.getName());
      }
    }
    return items;
  }

  // get set 方法
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public int getIndex() {
    return index;
  }

  public void setIndex(int index) {
    this.index = index;
  }
}
