package com.wgmf.trade.ui.fra.more.setting;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import com.urovo.wugumofang.constants.Files;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.utils.MyToast;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import androidx.annotation.Nullable;
import androidx.fragment.app.DialogFragment;

/**
 * Created by samy on 16/4/29.
 */
public class CopyDataToSDCard extends DialogFragment {

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return super.onCreateView(inflater, container, savedInstanceState);
    }


    private void copyData(){
        MyToast.show(getActivity(), "正在复制应用数据到SD卡", Toast.LENGTH_SHORT);
        //Toast.makeText(getActivity(), "正在复制应用数据到SD卡", Toast.LENGTH_SHORT).show();
        try {
            copyFiles(Files.apkDataPath, Files.apkBakPath);
            MyToast.show(getActivity(), "复制文件完毕！", Toast.LENGTH_SHORT);
            //Toast.makeText(getActivity(), "复制文件完毕！", Toast.LENGTH_SHORT).show();
            return;
        }
        catch (Exception e) {

            BaseAppManager.loger().info(e);
            MyToast.show(getActivity(), "复制失败,再试一次！" + e.toString(), Toast.LENGTH_SHORT);
            //Toast.makeText(getActivity(), "复制失败,再试一次！" + e.toString(), Toast.LENGTH_SHORT).show();
        }

        try {
            copyFiles(Files.apkDataPath, Files.apkBakPath2);
            MyToast.show(getActivity(), "复制数据完毕！", Toast.LENGTH_SHORT);
            //Toast.makeText(getActivity(), "复制数据完毕！", Toast.LENGTH_SHORT).show();
        }
        catch (Exception e) {
            BaseAppManager.loger().info(e);
            MyToast.show(getActivity(), "复制失败！" + e.toString(), Toast.LENGTH_SHORT);
            //Toast.makeText(getActivity(), "复制失败！" + e.toString(), Toast.LENGTH_SHORT).show();
        }

    }

    /**
     * 拷贝整个文件夹的方法
     * @param path1
     * @param path2
     * @throws Exception
     */
    public void copyFiles(String path1, String path2) throws Exception {
        File file = new File(path1);
        if(file.isDirectory()) {
            File f = new File(path2);
            if(!f.exists())
                f.mkdir();
            File[] files = file.listFiles();
            for (File file2 : files) {
                copyFiles(file2.toString(), path2 + "/" + file2.getName());
            }

        }
        else {
            copy(path1, path2);
        }
    }

    /**
     * 拷贝单个文件的方法
     * @param path1
     * @param path2
     * @throws IOException
     */
    public void copy(String path1, String path2) throws IOException {
        DataInputStream in = new DataInputStream(new BufferedInputStream(new FileInputStream(path1)));
        byte[] date = new byte[in.available()];
        in.read(date);
        DataOutputStream out = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(path2)));
        out.write(date);
        in.close();
        out.close();

    }
}
