package com.wgmf.trade.ui.fra.more.setting;

import android.app.ActivityManager;
import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.dao.MsgOperate;
import com.urovo.wgmf.db.dao.dao.Table_toposDbOperate;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.system.BasePackageUtil;
import com.urovo.wugumofang.system.EnvironmentHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.wgmf.trade.presenter.EnvironmentSwitchPre;
import com.wgmf.trade.presenter.impl.EnvironmentSwitchPreImpl;
import com.wgmf.trade.view.EnvironmentSwitchView;
import com.zsy.libcore.ui.act.SYActManager;

import androidx.annotation.Nullable;
import androidx.fragment.app.DialogFragment;

import java.util.Arrays;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;

/**
 * 环境切换
 * Created by samy on 16/4/8.
 */
public class EnvironmentSwitchFra extends DialogFragment implements EnvironmentSwitchView {
    @BindView(R.id.current_env_tv)
    TextView currentEnvTv;
    @BindView(R.id.will_change_env_tv)
    TextView WillChangeEnvTv;
    @BindView(R.id.release_env_rb)
    RadioButton releaseEnvRb;
    @BindView(R.id.production_env_rb)
    RadioButton productionEnvRb;
    @BindView(R.id.test_env_rb)
    RadioButton testEnvRb;
    @BindView(R.id.change_env_rg)
    RadioGroup changeEnvRg;
    @BindView(R.id.server_address_tv)
    TextView serverAddressTv;
    @BindView(R.id.server_port_tv)
    TextView serverPortTv;
    @BindView(R.id.ok_btn)
    Button okBtn;
    @BindView(R.id.cancel_btn)
    Button cancelBtn;

    protected EnvironmentSwitchPre environmentSwitchPre;
    Unbinder unbinder;
    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.more_setting_fra_env_switch, container, false);
        unbinder = ButterKnife.bind(this, view);
        getDialog().setTitle("环境切换");

        environmentSwitchPre = new EnvironmentSwitchPreImpl(this);
        environmentSwitchPre.getEnvStatusAndName();

        changeEnvRg.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                switch (checkedId) {
                    case R.id.release_env_rb://正式环境
                        environmentSwitchPre.getServerAddressAndPort(EnvironmentHelper.ENV_RELEASE);
                        break;
                    case R.id.production_env_rb://生产环境
                        environmentSwitchPre.getServerAddressAndPort(EnvironmentHelper.ENV_BETA);
                        break;
                    case R.id.test_env_rb://测试环境
                        environmentSwitchPre.getServerAddressAndPort(EnvironmentHelper.ENV_TEST);
                        break;
                }
            }
        });

        return view;
    }


    /**
     * 显示测试版本，发布版本的开关
     */
    @OnClick(R.id.ok_btn)
    public void ok_btn() {
        if (releaseEnvRb.isChecked()) {
            environmentSwitchPre.setEnvStatus(EnvironmentHelper.ENV_RELEASE);
        } else if (productionEnvRb.isChecked()) {
            environmentSwitchPre.setEnvStatus(EnvironmentHelper.ENV_BETA);
        } else if (testEnvRb.isChecked()) {
            environmentSwitchPre.setEnvStatus(EnvironmentHelper.ENV_TEST);
        }

        /**切换环境时清除基础资料时间戳*/
        ViewUtil.showProgress(getActivity(),"提示","正在清除基础资料时间戳 和 促销活动 通知公告缓存....");
        new Thread(() -> {
            Table_toposDbOperate.deleteBy(null);
            MsgOperate.deleteBy(null);//切换环境的时候把消息中心的这俩要用数据库的也清一下。
            try {
                Thread.sleep(2000);//休眠3秒
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            getActivity().runOnUiThread(() -> {
                ViewUtil.dismissProgress();
                //要杀掉第二进程
                ((ActivityManager) getActivity().getSystemService(Context.ACTIVITY_SERVICE)).killBackgroundProcesses(BasePackageUtil.getAppPackageName(getActivity()));
                SYActManager.getInstance().AppExit();
            });
        }).start();


//        new AsyncTask<String,Integer,String>(){
//            ProgressDialog progressDialog = new ProgressDialog(EnvironmentSwitchFra.this.getActivity());
//            @Override
//            protected void onPostExecute(String str) {
//                super.onPostExecute(str);
//                progressDialog.dismiss();
//                SYActManager.getInstance().AppExit();
//            }
//
//            @Override
//            protected void onPreExecute() {
//                super.onPreExecute();
//                progressDialog.setTitle("提示");
//                progressDialog.setMessage("正在清除基础资料时间戳 和 促销活动 通知公告缓存....");
//                progressDialog.setCancelable(false);
//                progressDialog.show();
//            }
//
//            @Override
//            protected String doInBackground(String... strings) {
//                Table_toposDbOperate.deleteBy(null);
//                MsgOperate.deleteBy(null);//切换环境的时候把消息中心的这俩要用数据库的也清一下。
//                return null;
//            }
//        }.execute("");
    }

    @OnClick(R.id.cancel_btn)
    public void cancel_btn() {
        getDialog().dismiss();
    }

    @Override
    public void getEnvStatusAndName(int envStatus, String envName) {
        switch (envStatus) {
            case EnvironmentHelper.ENV_DEFAULT:
            case EnvironmentHelper.ENV_RELEASE:
                releaseEnvRb.setChecked(true);
                break;
            case EnvironmentHelper.ENV_BETA:
                productionEnvRb.setChecked(true);
                break;
            case EnvironmentHelper.ENV_TEST:
                testEnvRb.setChecked(true);
                break;
        }
        currentEnvTv.setText(envName);

        environmentSwitchPre.getServerAddressAndPort(envStatus);
    }

    @Override
    public void getServerAddressAndPort(String[] envServer, String envPort, String envNameChange) {
        serverAddressTv.setText(Arrays.toString(envServer));
        serverPortTv.setText(envPort);
        WillChangeEnvTv.setText(envNameChange);
    }

    public void onDestroyView() {
        super.onDestroyView();
        unbinder.unbind();
    }

}
