package com.wgmf.trade.utils;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.Typeface;

import com.google.gson.Gson;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.system.BaseAppManager;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Random;

public class PhotoUtil {
    /**
     * @param @param  path
     * @param @return 参数说明
     * @return Bitmap 返回类型
     * @throws
     * @Title: revitionImageSize
     * @Description: 修改图片尺寸
     */
    public static Bitmap revitionImageSize(String path) {
        Bitmap bitmap = null;
        try {
            BufferedInputStream in = new BufferedInputStream(
                    new FileInputStream(new File(path)));
            BitmapFactory.Options options = new BitmapFactory.Options();
            options.inJustDecodeBounds = true;
            BitmapFactory.decodeStream(in, null, options);
            in.close();
            int i = 0;
            bitmap = null;
            while (true) {
                if ((options.outWidth >> i <= 1000)
                        && (options.outHeight >> i <= 1000)) {
                    in = new BufferedInputStream(new FileInputStream(new File(
                            path)));
                    options.inSampleSize = (int) Math.pow(2.0D, i);
                    options.inJustDecodeBounds = false;
                    bitmap = BitmapFactory.decodeStream(in, null, options);
                    break;
                }
                i += 1;
            }
            in.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return bitmap;
    }

    /**
     * @param @param  bmp
     * @param @return 参数说明
     * @return Bitmap 返回类型
     * @throws
     * @Title: setDateBitmap
     * @Description: 添加水印
     */
    public static Bitmap setDateBitmap(Bitmap bmp) {
        Bitmap temp = null;
        try {
            temp = Bitmap.createBitmap(bmp.getWidth(), bmp.getHeight(),
                    Bitmap.Config.ARGB_8888);
            Canvas canvas = new Canvas(temp);
            Paint paint = new Paint(); // 建立画笔
            paint.setDither(true);
            paint.setFilterBitmap(true);
            Rect src = new Rect(0, 0, bmp.getWidth(), bmp.getHeight());
            Rect dst = new Rect(0, 0, bmp.getWidth(), bmp.getHeight());
            canvas.drawBitmap(bmp, src, dst, paint);

            Paint textPaint = new Paint(Paint.ANTI_ALIAS_FLAG
                    | Paint.DEV_KERN_TEXT_FLAG);
            textPaint.setTextSize(20.0f);
            textPaint.setTypeface(Typeface.DEFAULT_BOLD); // 采用默认的宽度
            textPaint.setColor(Color.RED);

            Date now = new Date();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd-HH:mm:ss");
            String str = sdf.format(now);
            String d = str.split("-")[0];
            String t = str.split("-")[1];
            Rect m = new Rect();
            Rect c = new Rect();
            textPaint.getTextBounds(d, 0, d.length() - 1, m);
            textPaint.getTextBounds(t, 0, t.length() - 1, c);
            canvas.drawText(d, bmp.getWidth() - m.width() - 20,
                    bmp.getHeight() - 5, textPaint);
            canvas.drawText(t, bmp.getWidth() - c.width() - 20,
                    bmp.getHeight() - 23, textPaint);
            canvas.save();
            canvas.restore();
        } catch (Exception e) {
            temp = null;
            BaseAppManager.loger().info(e);
        }
        return temp;
    }


    public static String getFileUrlUUID(String shopId, String userId) {
        String filePath = "sygj_android_" + shopId + "_" + userId + "_"
                + DateUtil.getDateTime1(new Date()) + "_"
                + (new Random().nextInt(10000));
        return filePath;
    }

    public static String getRealUrl(String fileUrlUUID) {
        String filePath = NetParam.QINIU_BASE + fileUrlUUID;
        return filePath;
    }

    public static byte[] Bitmap2Bytes(Bitmap bm) {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        bm.compress(Bitmap.CompressFormat.JPEG, 100, baos);
        return baos.toByteArray();
    }


    public static BaseOldResponse parseTokenData(String json) {
        Gson gson = new Gson();
        return gson.fromJson(json, BaseOldResponse.class);
    }

}
