package com.wgmf.trade.view;

import com.urovo.activity.goodsmanager.model.OrderCommonEntity;
import com.urovo.wgmf.db.dao.entitys.DingHuoOplQtyEntity;
import com.urovo.activity.goodsmanager.model.OrderDeliveryDifferenceQueryEntity;
import com.urovo.activity.goodsmanager.model.OrderGoodsQueryEntity;
import com.wgmf.trade.model.bean.OrderSubmitReqBean;

import java.util.List;

/**
 * 订货
 * Created by samy on 16/12/22.
 */

public interface OrderGoodCon {

    interface Pre {
        /**
         * 查询门店订货列表
         */
        void getOrderGoodsDetail(String storeNo, String beginDate, String endDate);

        /**
         * 获取订货公共物料列表
         */
        void getOrderCommonList(String storeId);

        /**
         * 门店订货与发货差异列表
         */
        void getOrderGoodsDiff(String storeNo, String beginDate, String endDate);

        /**
         * 获取订货提交列表
         */
        void getOrderList(String storeId, String staffId, String brands);

        /**
         * 查看门店是否可以订货
         */
        void isCanOrdering(String storeId, String userId, boolean isSubmitOrder);

        /**
         * 订货提交
         */
        void orderSubmit(OrderSubmitReqBean orderSubmitReqBean);
    }

    interface View {
        void showOrderGoodsDetail(List<OrderGoodsQueryEntity> list);

        void showOrderCommon(List<OrderCommonEntity> list);

        void showOrderGoodsDiff(List<OrderDeliveryDifferenceQueryEntity> list);

        void showCanOrdering(int msgCode, String msgInfo, boolean isSubmitOrder);

        //void showOrderList(List<OrderGoodBean> orderGoodBeanList);
        void showOrderList(DingHuoOplQtyEntity.ResultInfo dingHuoOplQtyEntityList);

        void submitSuccess(String msg);

        void submitFailed(String msg);

        void showIsLoading();

        void showError(String errorMsg);

        void showState(int loadWaitState);//见LoadWaitDominator Companion object

        void showDismissAll();
    }

}
