package com.wgmf.trade.view;

import com.urovo.wgmf.db.dao.entitys.OrderReqBean;
import com.wgmf.trade.model.bean.FirstShopGiftBean;

import java.util.Map;

/**
 * Created by samy on 16/11/4.
 */
public interface SaveSuccessCon {

    interface Pre {

        /**
         * 直接在线订单（最开始）
         *
         * @param content 下单的json信息
         */
        void submitOrder(String content);

        /**
         * 查询首购礼
         *
         * @param params Map
         */
        void queryFirstShopGift(Map<String, String> params);

        void sendTicket(Map<String, String> params);


        /**
         * 离线下单情况
         */
        void submitOrder(OrderReqBean orderRequestBean);
    }

    interface View {
        /**
         * 订单提交状态
         *
         * @param wxPayNo 微信二维码支付订单号
         */
        void commitOrderState(String wxPayNo);

        void showRecomProduct(String product);

        /**
         * 收购礼状态
         *
         * @param firstShopGiftBean FirstShopGiftBean
         */
        default void firstShopGift(FirstShopGiftBean firstShopGiftBean){}

        /**
         * 展示
         */
        void onShowProgress();

        /**
         * 订单提交成功状态
         */
        void onResponseSuccess();

        /**
         * 订单提交失败状态
         */
        void onFailure();
    }
}
