package com.wgmf.trade.wx.act;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Rect;
import android.net.Uri;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.taobao.weex.IWXRenderListener;
import com.taobao.weex.WXRenderErrorCode;
import com.taobao.weex.WXSDKEngine;
import com.taobao.weex.WXSDKInstance;
import com.taobao.weex.common.WXRenderStrategy;
import com.taobao.weex.utils.WXFileUtils;
import com.taobao.weex.utils.WXSoInstallMgrSdk;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseOldActivity;
import com.wgmf.trade.utils.AssertUtil;
import com.wgmf.trade.wx.WXApp;

import java.util.HashMap;
import java.util.Map;

import androidx.localbroadcastmanager.content.LocalBroadcastManager;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * Created by samy on 16/8/11.
 * 兼容目前项目中老的处理方式；(不推荐用)
 */
public abstract class WXContainerOldAct extends BaseOldActivity implements IWXRenderListener {

    private static final String DEFAULT_IP = "your_current_IP";
    //private static String CURRENT_IP = "192.168.0.2"; // your_current_IP
    protected String CURRENT_IP = "http://192.168.0.2:8888/dist/";
    @BindView(R.id.js_container_fl)
    FrameLayout jsContainerFl;
    @BindView(R.id.render_loading_pb)
    ProgressBar renderLoadingPb;
    @BindView(R.id.not_support_render_tv)
    TextView notSupportRenderTv;
    private ViewGroup mContainer;
    private WXSDKInstance mInstance;
    //protected String WEEX_INDEX_URL = CURRENT_IP + "" +setJSUrl();
    private BroadcastReceiver mReloadReceiver;

    /**
     * 是否加载离线资源,用于调试或者热更新配置
     */
    protected abstract boolean isOnLineMode();

    protected abstract String setSelfTitle();

    protected abstract String setJSUrl();
    Unbinder unbinder;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_wx_container_old);
        unbinder = ButterKnife.bind(this);
        initTitle();
        if (!TextUtils.isEmpty(setSelfTitle())) {
            titleTextView.setText(setSelfTitle());
        } else {
            titile_bg.setVisibility(View.GONE);
        }
        createWeexInstance();
        mInstance.onActivityCreate();
        loadRenderView();
    }

    protected final ViewGroup getContainer() {
        return mContainer;
    }

    protected final void setContainer(ViewGroup container) {
        mContainer = container;
    }

    protected void destoryWeexInstance() {
        if (mInstance != null) {
            mInstance.registerRenderListener(null);
            mInstance.destroy();
            mInstance = null;
        }
    }

    protected void createWeexInstance() {
        destoryWeexInstance();

        Rect outRect = new Rect();
        getWindow().getDecorView().getWindowVisibleDisplayFrame(outRect);

        mInstance = new WXSDKInstance(this);
        mInstance.registerRenderListener(this);
    }

    protected void renderPage(String template, String source) {
        renderPage(template, source, null);
    }

    protected void renderPage(String template, String source, String jsonInitData) {
        AssertUtil.throwIfNull(mContainer,
                new RuntimeException("Can't render page, container is null"));
        Map<String, Object> options = new HashMap<>();
        options.put(WXSDKInstance.BUNDLE_URL, source);
        mInstance.render(getPageName(), template, options, jsonInitData,
                //ScreenUtil.getDisplayWidth(this),
                //ScreenUtil.getDisplayHeight(this),
                WXApp.SCREEN_WIDTH, WXApp.SCREEN_HEIGHT, WXRenderStrategy.APPEND_ASYNC);
    }

    protected void renderPageByURL(String url) {
        renderPageByURL(url, null);
    }

    protected void renderPageByURL(String url, String jsonInitData) {
        AssertUtil.throwIfNull(mContainer,
                new RuntimeException("Can't render page, container is null"));
        Map<String, Object> options = new HashMap<>();
        options.put(WXSDKInstance.BUNDLE_URL, url);
        mInstance.renderByUrl(getPageName(), url, options, jsonInitData,
                WXApp.SCREEN_WIDTH, WXApp.SCREEN_HEIGHT, WXRenderStrategy.APPEND_ASYNC);
    }

    protected String getPageName() {
        return WXContainerOldAct.class.getSimpleName();
    }

    @Override
    public void onStart() {
        super.onStart();
        if (mInstance != null) {
            mInstance.onActivityStart();
        }
    }

    @Override
    public void onResume() {
        super.onResume();
        if (mInstance != null) {
            mInstance.onActivityResume();
        }
    }

    @Override
    public void onPause() {
        super.onPause();
        if (mInstance != null) {
            mInstance.onActivityPause();
        }
    }

    @Override
    public void onStop() {
        super.onStop();
        if (mInstance != null) {
            mInstance.onActivityStop();
        }
    }

    @Override
    public void onDestroy() {
//        ButterKnife.unbind(this);
        unbinder.unbind();
        LocalBroadcastManager.getInstance(this).unregisterReceiver(mReloadReceiver);
        if (mInstance != null) {
            mInstance.onActivityDestroy();
        }
        super.onDestroy();
    }

    @Override
    public void onViewCreated(WXSDKInstance wxsdkInstance, View view) {
        if (mContainer != null) {
            mContainer.addView(view);
        }
    }

    @Override
    public void onRefreshSuccess(WXSDKInstance instance, int width, int height) {

    }


    protected void loadRenderView() {
        setContainer(jsContainerFl);

        renderLoadingPb.setVisibility(View.VISIBLE);
        notSupportRenderTv.setVisibility(View.VISIBLE);

        if (!WXSoInstallMgrSdk.isCPUSupport()) {
            renderLoadingPb.setVisibility(View.INVISIBLE);
            notSupportRenderTv.setText(R.string.cpu_not_support_tip);
            return;
        }

        if (isOnLineMode()) {
            renderPageByURL(setJSUrl());
        } else {
            Uri url = Uri.parse(setJSUrl());
            String path = url.getScheme().equals("file") ? assembleFilePath(url) : url.toString();
            renderPage(WXFileUtils.loadAsset(path, this), url.toString());
        }

        mReloadReceiver = new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                createWeexInstance();
                if (isOnLineMode()) {
                    //renderPageByURL(WEEX_INDEX_URL);
                } else {
                    //renderPage(WXFileUtils.loadAsset(setJSUrl(), WXContainerOldAct.this),WEEX_INDEX_URL);
                }
                renderLoadingPb.setVisibility(View.VISIBLE);
            }
        };

        LocalBroadcastManager.getInstance(this)
                .registerReceiver(mReloadReceiver, new IntentFilter(WXSDKEngine.JS_FRAMEWORK_RELOAD));
    }

    protected String assembleFilePath(Uri uri) {
        if (uri != null && uri.getPath() != null) {
            return uri.getPath().replaceFirst("/", "");
        }
        return "";
    }

    @Override
    public void onRenderSuccess(WXSDKInstance wxsdkInstance, int i, int i1) {
        renderLoadingPb.setVisibility(View.GONE);
        notSupportRenderTv.setVisibility(View.GONE);
    }

    @Override
    public void onException(WXSDKInstance wxsdkInstance, String s, String s1) {
        renderLoadingPb.setVisibility(View.GONE);
        notSupportRenderTv.setVisibility(View.VISIBLE);
        if (TextUtils.equals(s, WXRenderErrorCode.WX_NETWORK_ERROR)) {
            notSupportRenderTv.setText(R.string.index_tip);
        } else {
            notSupportRenderTv.setText("render error:" + s1);
        }
    }


}
