package com.wgmf.trade.wx.module;

import com.taobao.weex.bridge.WXBridgeManager;
import com.taobao.weex.common.WXModule;
import com.taobao.weex.common.WXModuleAnno;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.constants.AppConfig;
import com.zsy.libcore.common.android.log.SYLoger;
import org.json.JSONException;
import org.json.JSONObject;

/**
 * 封装基本的桥接工具类
 * Created by samy on 16/10/11.
 */

public class CommonModule extends WXModule {
  /**
   * 登录用户的基本信息
   * @param callbackId
   */
  @WXModuleAnno(runOnUIThread = false) public void getNativeUserInfo(String callbackId) {
    String tempJson = createJsonString();
    //ToastMsg.showToastMsg(mWXSDKInstance.getContext(),"UserInfoModule:" + tempJson);
    SYLoger.print("UserInfoModule:"+tempJson);
    WXBridgeManager.getInstance()
        .callback(mWXSDKInstance.getInstanceId(), callbackId,tempJson);
  }

  public String createJsonString(){
    JSONObject jsonObject = new JSONObject();
    try {
      jsonObject.put("storeId", SystemHelper.LoginOrganId);
      jsonObject.put("storeName", SystemHelper.LoginOrganName);
      jsonObject.put("accountNo", SystemHelper.LoginUserId);
      jsonObject.put("accountName", SystemHelper.LoginUserName);
    } catch (JSONException e) {
      e.printStackTrace();
    }
    return jsonObject.toString();
  }


  /**
   * 是否正式环境接口地址；
   * @param callbackId
   */
  @WXModuleAnno(runOnUIThread = false) public void getNativeEnvServer(String callbackId) {
    WXBridgeManager.getInstance()
        .callback(mWXSDKInstance.getInstanceId(),callbackId, AppConfig.APP_URL);
  }
}
