package com.wgmf.trade.wx.module;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import com.taobao.weex.bridge.WXBridgeManager;
import com.taobao.weex.common.WXModule;
import com.taobao.weex.common.WXModuleAnno;
import com.taobao.weex.utils.WXLogUtils;
import com.urovo.activity.tabMenu.view.TabMenuActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.wgmf.trade.ui.fra.index.MemberHomeFra;
import com.wgmf.trade.utils.IntentUtil;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.ui.fra.FragmentArgs;
import com.urovo.wugumofang.view.webview.FraContainerAct;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by samy on 16/8/10.
 * JS跳转到原生交互
 */
public class IntentModule extends WXModule {

  /**
   * 跳转到下一个界面。没办法传递bean对象，传递八大类型和list
   *
   * @param param {
   * animate: boolean
   * url: dest + title
   * translateData:{
   * Integer: 1
   * Boolean: true
   * }
   * }
   * @param callbackId 回调ID
   */
  @WXModuleAnno public void push(String param, final String callbackId) {

  }

  /**
   * 从JS页面跳转到原生activity   同时也可以从JS传递相关数据到原生
   * params很多的请求下，可以做成一个json串
   */
  @WXModuleAnno public void startActivityFromJS(String name, String extras, boolean isFinish) {
    try {
      Context context = mWXSDKInstance.getContext();
      if (null != context) {
        Class toActivity = Class.forName(name);//目前还是用FraContainerAct去装；目前之处理Activity.获取处理Fragment;
        Intent intent = new Intent(context, toActivity);
        //toIntent.setClass(baseAct, Class.forName(toWhereClass));
        //toIntent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
        intent.putExtra(AppConstants.PreKeys.JS_EXTRAS, extras);
        context.startActivity(intent);
        if (isFinish) {
          ((Activity) context).finish();
        }
        SYLoger.print(extras);
      }
    } catch (Exception e) {
      e.printStackTrace();
      WXLogUtils.e("不能打开Activity:" + e.getMessage());
    }
  }


  /**
   * 从JS页面跳转到Activity界面，并且等待从Activity返回的数据给JS
   */
  @WXModuleAnno public void startActivityFromJSGetResult(String className, String callbackId) {
    //callback to javascript
    Map<String, Object> result = new HashMap<String, Object>();
    result.put("ts", System.currentTimeMillis());
    WXBridgeManager.getInstance().callback(mWXSDKInstance.getInstanceId(), callbackId, result);
  }

  /**
   * 获取JS里面的数据，传递给下一个界面，再传递给当前界面的js;
   */
  @WXModuleAnno(runOnUIThread = false) public void getJsExrasDataToJs(String callbackId) {
    String JS_EXTRAS = ((Activity) mWXSDKInstance.getContext()).getIntent().getStringExtra(AppConstants.PreKeys.JS_EXTRAS);
    SYLoger.print(JS_EXTRAS);
    WXBridgeManager.getInstance().callback(mWXSDKInstance.getInstanceId(), callbackId, JS_EXTRAS);
  }

  /**
   * 获取JS里面的数据，传递给下一个界面，再传递给当前界面的js;
   */
  @WXModuleAnno(runOnUIThread = true) public void goHomeTab(String callbackId) {
    Context context = mWXSDKInstance.getContext();
    Intent intent = new Intent(context, TabMenuActivity.class);
    //极光推送点击监听器传来的Intent（序列化），用于在未登陆时点击推送，使其经过登陆验证才打开页面
    Intent jPushIntent = (Intent)((Activity)context).getIntent().getParcelableExtra(AppConstants.ExtraKeys.JPUSH_INTENT);
    if(jPushIntent != null){
      intent.putExtra(AppConstants.ExtraKeys.JPUSH_INTENT,jPushIntent);
    }
    context.startActivity(intent);
  }

  /**
   * 拨打电话功能
   */
  @WXModuleAnno(runOnUIThread = true) public void callPhone(String phoneNum,String callbackId) {
    IntentUtil.callPhone(phoneNum,mWXSDKInstance.getContext());
  }



  /**
   * 跳转到Fragment，临时跳转Fragment处理
   */
  @WXModuleAnno(runOnUIThread = true) public void goMemberHome(String phoneNum,String callbackId) {
    FragmentArgs fragmentArgs = new FragmentArgs();
    fragmentArgs.add(AppConstants.ExtraKeys.PHONE_NUM,phoneNum);
    FraContainerAct.launchWithFinish(mWXSDKInstance.getContext(), MemberHomeFra.class,fragmentArgs,false);
  }

}
