package com.zsy.libcore.common.android.log;

import android.util.Log;

import com.zsy.libcore.config.LibCoreConfig;

/**
 * 应用程序的Log管理
 */
public final class SYLoger {

	private static boolean IS_DEBUG = LibCoreConfig.IS_DEBUG_ENABLE;
	private static boolean SHOW_ACTIVITY_STATE = LibCoreConfig.IS_DEBUG_ENABLE;

	/**
	 * @description 控制是否显示Log信息显示;现在在KJConfig配置显示；
	 * @author samy
	 * @date 2014年11月11日 上午10:36:13
	 */
	public static final void openDebutLog(boolean enable) {
		IS_DEBUG = enable;
	}

	/**
	 * @description 控制是否显示Activity和Fragment的生命周期调试
	 * @author samy
	 * @date 2014年11月11日 上午10:37:10
	 */
	public static final void openActivityState(boolean enable) {
		SHOW_ACTIVITY_STATE = enable;
	}

	public static void print(String paramString) {
		if (LibCoreConfig.IS_DEBUG_ENABLE) {
			StackTraceElement stack = (new Throwable()).getStackTrace()[1];
			StringBuilder builder = new StringBuilder();
			builder.append("文件:" + stack.getFileName());
			builder.append("<->行号:" + stack.getLineNumber());
			builder.append("<->方法:" + stack.getMethodName());
			builder.append("<->信息:" + paramString);
			Log.i(LibCoreConfig.DEBUG_TAG, builder.toString());
		}
	}

	public static final void debug(String msg, Object... format) {
		debug(String.format(msg, format));
	}

	public static final void debug(String packName, String msg) {
		if (IS_DEBUG) {
			Log.d(packName, msg);
		}
	}

	public static final void state(String packName, String state) {
		if (SHOW_ACTIVITY_STATE) {
			Log.d("activity_state", packName + state);
		}
	}
}
